/*
 Navicat Premium Data Transfer

 Source Server         : lhc-dev
 Source Server Type    : MySQL
 Source Server Version : 50640
 Source Host           : 127.0.0.1:3306
 Source Schema         : contact-center

 Target Server Type    : MySQL
 Target Server Version : 50640
 File Encoding         : 65001

 Date: 10/08/2018 17:33:13
*/

SET NAMES utf8mb4;
SET FOREIGN_KEY_CHECKS = 0;

-- ----------------------------
-- Create Database
-- ----------------------------
CREATE DATABASE IF NOT EXISTS `cosinee` CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci;
USE `cosinee`;

-- ----------------------------
-- Table structure for cs_callout_log_dialplan
-- ----------------------------
DROP TABLE IF EXISTS `cs_callout_log_dialplan`;
CREATE TABLE `cs_callout_log_dialplan` (
  `id` varchar(32) NOT NULL COMMENT '主键ID',
  `operator` varchar(32) DEFAULT NULL COMMENT '操作员ID',
  `module` varchar(128) DEFAULT NULL COMMENT '模块',
  `subitem` varchar(32) DEFAULT NULL COMMENT '子项',
  `operation` varchar(32) DEFAULT NULL COMMENT '操作内容',
  `status` tinyint(4) DEFAULT NULL COMMENT '操作状态',
  `detail` varchar(128) DEFAULT NULL COMMENT '细节',
  `ipaddr` varchar(255) DEFAULT NULL COMMENT '客户ip地址',
  `port` varchar(32) DEFAULT NULL COMMENT '客户ip端口',
  `url` longtext COMMENT 'url',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='拨号计划记录';


-- ----------------------------
-- Table structure for uk_act_batch
-- ----------------------------
DROP TABLE IF EXISTS `uk_act_batch`;
CREATE TABLE `uk_act_batch` (
  `ID` varchar(32) NOT NULL COMMENT '主键',
  `NAME` varchar(50) DEFAULT NULL COMMENT '批次名称',
  `CODE` varchar(50) DEFAULT NULL COMMENT '批次代码',
  `CREATETIME` datetime DEFAULT NULL COMMENT '创建时间',
  `CREATER` varchar(32) DEFAULT NULL COMMENT '创建人',
  `UPDATETIME` datetime DEFAULT NULL COMMENT '更新时间',
  `ORGI` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `USERNAME` varchar(50) DEFAULT NULL COMMENT '创建人',
  `STATUS` varchar(50) DEFAULT NULL COMMENT '批次状态',
  `PARENTID` varchar(32) DEFAULT NULL COMMENT '上级ID',
  `ACTID` varchar(32) DEFAULT NULL COMMENT '活动ID',
  `INX` int(11) DEFAULT '0' COMMENT '分类排序序号',
  `NAMENUM` int(11) DEFAULT '0' COMMENT '批次包含的名单总数',
  `VALIDNUM` int(11) DEFAULT '0' COMMENT '批次包含的有效名单总数',
  `INVALIDNUM` int(11) DEFAULT '0' COMMENT '批次包含的无效名单总数',
  `ASSIGNED` int(11) DEFAULT '0' COMMENT '已分配名单总数',
  `NOTASSIGNED` int(11) DEFAULT '0' COMMENT '未分配名单总数',
  `ENABLE` tinyint(4) DEFAULT '0' COMMENT '分类状态',
  `DATASTATUS` tinyint(4) DEFAULT '0' COMMENT '数据状态',
  `AREA` text COMMENT '分类描述',
  `imptype` varchar(50) DEFAULT NULL COMMENT '任务导入类型',
  `batchtype` varchar(32) DEFAULT NULL COMMENT '批次类型',
  `ORGAN` varchar(32) DEFAULT NULL COMMENT '部门',
  `impurl` text COMMENT '导入的文件链接',
  `filetype` varchar(50) DEFAULT NULL COMMENT '文件类型',
  `dbtype` varchar(50) DEFAULT NULL COMMENT '数据库类型',
  `jdbcurl` text COMMENT '数据库连接地址',
  `driverclazz` varchar(255) DEFAULT NULL COMMENT '数据库驱动',
  `password` varchar(255) DEFAULT NULL COMMENT '密码',
  `DESCRIPTION` text COMMENT '数据描述',
  `execnum` int(11) DEFAULT '0' COMMENT '导入次数',
  `SOURCE` varchar(255) DEFAULT NULL COMMENT '来源',
  `CLAZZ` varchar(255) DEFAULT NULL COMMENT '驱动名称',
  `TASKFIRETIME` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '任务启动时间',
  `CRAWLTASKID` varchar(255) DEFAULT NULL COMMENT '任务ID',
  `EMAIL` varchar(255) DEFAULT NULL COMMENT '邮箱地址',
  `NICKNAME` varchar(255) DEFAULT NULL COMMENT '昵称',
  `USERID` varchar(255) DEFAULT NULL COMMENT '用户ID',
  `TASKTYPE` varchar(255) DEFAULT NULL COMMENT '任务类型',
  `TASKID` varchar(255) DEFAULT NULL COMMENT '任务ID',
  `FETCHER` smallint(6) NOT NULL DEFAULT '0' COMMENT '采集状态',
  `PAUSE` smallint(6) NOT NULL DEFAULT '0' COMMENT '是否暂停',
  `PLANTASK` smallint(6) NOT NULL DEFAULT '0' COMMENT '是否计划任务',
  `SECURE_ID` varchar(32) DEFAULT NULL COMMENT '安全级别',
  `CONFIGURE_ID` varchar(32) DEFAULT NULL COMMENT '配置ID',
  `TAKSPLAN_ID` varchar(32) DEFAULT NULL COMMENT '计划任务ID',
  `CRAWLTASK` varchar(32) DEFAULT NULL COMMENT '采集任务状态',
  `TARGETTASK` varchar(32) DEFAULT NULL COMMENT '目标任务',
  `STARTINDEX` int(11) DEFAULT NULL COMMENT '排序位置',
  `LASTDATE` timestamp NULL DEFAULT NULL COMMENT '最近一次更新时间',
  `CREATETABLE` tinyint(4) DEFAULT NULL COMMENT '自动创建数据表',
  `MEMO` text COMMENT '备注',
  `NEXTFIRETIME` timestamp NULL DEFAULT NULL COMMENT '下次启动时间',
  `CRONEXP` varchar(255) DEFAULT NULL COMMENT '表达式',
  `TASKSTATUS` varchar(32) DEFAULT NULL COMMENT '任务状态',
  `usearea` varchar(255) DEFAULT '' COMMENT '用户区域',
  `areafield` varchar(255) DEFAULT NULL COMMENT '区域字段',
  `areafieldtype` varchar(32) DEFAULT NULL COMMENT '区域字段类型',
  `arearule` varchar(255) DEFAULT NULL COMMENT '区域规则',
  `minareavalue` varchar(255) DEFAULT NULL COMMENT '范围最小值',
  `maxareavalue` varchar(255) DEFAULT NULL COMMENT '范围最大值',
  `formatstr` varchar(255) DEFAULT NULL COMMENT '格式化字符串',
  `DATAID` varchar(1000) DEFAULT NULL COMMENT '报表id字符串',
  `DICID` varchar(1000) DEFAULT NULL COMMENT '目录id字符串',
  `taskinfo` longtext COMMENT 'taskinfo信息',
  PRIMARY KEY (`ID`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='电销活动';

-- ----------------------------
-- Table structure for uk_act_callagent
-- ----------------------------
DROP TABLE IF EXISTS `uk_act_callagent`;
CREATE TABLE `uk_act_callagent` (
  `ID` varchar(32) NOT NULL COMMENT '主键ID',
  `NAME` varchar(50) DEFAULT NULL COMMENT '坐席名称',
  `CODE` varchar(50) DEFAULT NULL COMMENT '坐席代码',
  `CREATETIME` datetime DEFAULT NULL COMMENT '创建时间',
  `CREATER` varchar(32) DEFAULT NULL COMMENT '创建人',
  `UPDATETIME` datetime DEFAULT NULL COMMENT '更新时间',
  `ORGI` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `USERNAME` varchar(50) DEFAULT NULL COMMENT '用户名',
  `STATUS` varchar(50) DEFAULT NULL COMMENT '坐席状态',
  `PARENTID` varchar(32) DEFAULT NULL COMMENT '上级ID',
  `FILTERTYPE` varchar(32) DEFAULT NULL COMMENT '筛选类型（批次筛选/元数据筛选）',
  `BATID` varchar(32) DEFAULT NULL COMMENT '筛选表单使用的批次ID',
  `TABLEID` varchar(32) DEFAULT NULL COMMENT '筛选表单使用元数据ID',
  `DATASTATUS` tinyint(4) DEFAULT '0' COMMENT '数据状态',
  `INX` int(11) DEFAULT '0' COMMENT '分类排序序号',
  `ORGAN` varchar(32) DEFAULT NULL COMMENT '部门',
  `DESCRIPTION` text COMMENT '描述信息',
  `distype` varchar(32) DEFAULT NULL COMMENT '分配类型',
  `distarget` varchar(32) DEFAULT NULL COMMENT '分配对象',
  `disnum` varchar(32) DEFAULT NULL COMMENT '分配数据',
  `ACTID` varchar(32) DEFAULT NULL COMMENT '活动ID',
  PRIMARY KEY (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='电销活动名单分配表';

-- ----------------------------
-- Table structure for uk_act_callnames
-- ----------------------------
DROP TABLE IF EXISTS `uk_act_callnames`;
CREATE TABLE `uk_act_callnames` (
  `ID` varchar(32) NOT NULL COMMENT '主键ID',
  `NAME` varchar(50) DEFAULT NULL COMMENT '名单名称',
  `CODE` varchar(50) DEFAULT NULL COMMENT '名单代码',
  `CREATETIME` datetime DEFAULT NULL COMMENT '创建时间',
  `CREATER` varchar(32) DEFAULT NULL COMMENT '创建人',
  `UPDATETIME` datetime DEFAULT NULL COMMENT '更新时间',
  `ORGI` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `USERNAME` varchar(50) DEFAULT NULL COMMENT '用户名',
  `STATUS` varchar(50) DEFAULT NULL COMMENT '名单状态',
  `PARENTID` varchar(32) DEFAULT NULL COMMENT '上级ID',
  `ACTID` varchar(32) DEFAULT NULL COMMENT '活动ID',
  `BATID` varchar(32) DEFAULT NULL COMMENT '活动ID',
  `DATASTATUS` varchar(32) DEFAULT NULL COMMENT '数据状态',
  `CALLS` int(11) DEFAULT '0' COMMENT '拨打次数',
  `FAILDCALLS` int(11) DEFAULT '0' COMMENT '拨打失败次数',
  `invalid` tinyint(4) DEFAULT '0' COMMENT '数据状态',
  `failed` tinyint(4) DEFAULT '0' COMMENT '数据状态',
  `WORKSTATUS` varchar(32) DEFAULT NULL COMMENT '名单业务状态',
  `OPTIME` datetime DEFAULT NULL COMMENT '分配时间',
  `ORGAN` varchar(32) DEFAULT NULL COMMENT '部门',
  `BATNAME` varchar(100) DEFAULT NULL COMMENT '批次名称',
  `TASKNAME` varchar(100) DEFAULT NULL COMMENT '任务名称',
  `owneruser` varchar(100) DEFAULT NULL COMMENT '所属用户',
  `ownerdept` varchar(100) DEFAULT NULL COMMENT '所属部门',
  `dataid` varchar(100) DEFAULT NULL COMMENT '数据ID',
  `taskid` varchar(100) DEFAULT NULL COMMENT '任务ID',
  `filterid` varchar(100) DEFAULT NULL COMMENT '筛选表单ID',
  `phonenumber` varchar(100) DEFAULT NULL COMMENT '电话号码',
  `leavenum` int(11) DEFAULT '0' COMMENT '剩余名单数量',
  `metaname` varchar(100) DEFAULT NULL COMMENT '元数据名称',
  `distype` varchar(100) DEFAULT NULL COMMENT '分配类型',
  `previewtime` int(11) DEFAULT '0' COMMENT '预览时长',
  `previewtimes` int(11) DEFAULT '0' COMMENT '预览次数',
  `servicetype` text COMMENT '服务类型',
  `reservation` tinyint(4) DEFAULT '0' COMMENT '是否预约',
  `memo` text COMMENT '预约备注',
  `firstcalltime` datetime DEFAULT NULL COMMENT '首次拨打时间',
  `firstcallstatus` varchar(20) DEFAULT NULL COMMENT '首次拨打状态',
  PRIMARY KEY (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='电销名单表';

-- ----------------------------
-- Table structure for uk_act_config
-- ----------------------------
DROP TABLE IF EXISTS `uk_act_config`;
CREATE TABLE `uk_act_config` (
  `id` varchar(32) NOT NULL COMMENT '主键ID',
  `orgi` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `creater` varchar(32) DEFAULT NULL COMMENT '创建人',
  `username` varchar(32) DEFAULT NULL COMMENT '创建人用户名',
  `name` varchar(32) DEFAULT NULL COMMENT '名称',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `enablecallout` tinyint(4) DEFAULT '0' COMMENT '启用自动外呼功能',
  `countdown` int(11) DEFAULT '0' COMMENT '倒计时时长',
  `enabletagentthreads` tinyint(4) DEFAULT '0' COMMENT '启用坐席外呼并发控制',
  `agentthreads` int(11) DEFAULT '0' COMMENT '坐席外呼并发数量',
  `enabletaithreads` tinyint(4) DEFAULT '0' COMMENT '启用机器人外呼并发控制',
  `aithreads` int(11) DEFAULT '0' COMMENT '机器人并发数量',
  `defaultvalue` varchar(100) DEFAULT NULL COMMENT '默认值',
  `strategy` varchar(100) DEFAULT NULL COMMENT '策略',
  `type` varchar(100) DEFAULT NULL COMMENT '类型',
  `updatetime` datetime DEFAULT NULL COMMENT '更新时间',
  `dataid` varchar(32) DEFAULT NULL COMMENT '数据ID',
  `previewautocallout` tinyint(4) DEFAULT '0' COMMENT '启用预览倒计时',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='电销配置表';

-- ----------------------------
-- Table structure for uk_act_filter_his
-- ----------------------------
DROP TABLE IF EXISTS `uk_act_filter_his`;
CREATE TABLE `uk_act_filter_his` (
  `ID` varchar(32) NOT NULL COMMENT '主键ID',
  `NAME` varchar(50) DEFAULT NULL COMMENT '筛选名称',
  `CODE` varchar(50) DEFAULT NULL COMMENT '筛选代码',
  `CREATETIME` datetime DEFAULT NULL COMMENT '创建时间',
  `CREATER` varchar(32) DEFAULT NULL COMMENT '创建人',
  `UPDATETIME` datetime DEFAULT NULL COMMENT '更新时间',
  `ORGI` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `USERNAME` varchar(50) DEFAULT NULL COMMENT '用户名',
  `STATUS` varchar(50) DEFAULT NULL COMMENT '状态',
  `PARENTID` varchar(32) DEFAULT NULL COMMENT '上级ID',
  `ACTID` varchar(32) DEFAULT NULL COMMENT '活动ID',
  `INX` int(11) DEFAULT '0' COMMENT '分类排序序号',
  `NAMENUM` int(11) DEFAULT '0' COMMENT '批次包含的名单总数',
  `VALIDNUM` int(11) DEFAULT '0' COMMENT '批次包含的有效名单总数',
  `INVALIDNUM` int(11) DEFAULT '0' COMMENT '批次包含的无效名单总数',
  `ASSIGNED` int(11) DEFAULT '0' COMMENT '已分配名单总数',
  `NOTASSIGNED` int(11) DEFAULT '0' COMMENT '未分配名单总数',
  `ENABLE` tinyint(4) DEFAULT '0' COMMENT '分类状态',
  `DATASTATUS` tinyint(4) DEFAULT '0' COMMENT '数据状态',
  `ORGAN` varchar(32) DEFAULT NULL COMMENT '部门',
  `DESCRIPTION` text COMMENT '备注',
  `execnum` int(11) DEFAULT '0' COMMENT '导入次数',
  `SOURCE` varchar(255) DEFAULT NULL COMMENT '来源',
  `BATID` varchar(32) DEFAULT NULL COMMENT '批次ID',
  `FILTERID` varchar(32) DEFAULT NULL COMMENT '筛选表单ID',
  `ASSIGNEDORGAN` int(11) DEFAULT '0' COMMENT '分配部门',
  `exectype` varchar(32) DEFAULT NULL COMMENT '执行类型',
  `renum` int(11) DEFAULT '0' COMMENT '分配数量',
  `reorgannum` int(11) DEFAULT '0' COMMENT '部门分配数量',
  `assignedai` int(11) DEFAULT '0' COMMENT '分配到AI的名单数量',
  PRIMARY KEY (`ID`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='筛选记录表';

-- ----------------------------
-- Table structure for uk_act_formfilter
-- ----------------------------
DROP TABLE IF EXISTS `uk_act_formfilter`;
CREATE TABLE `uk_act_formfilter` (
  `ID` varchar(32) NOT NULL COMMENT '主键ID',
  `NAME` varchar(50) DEFAULT NULL COMMENT '筛选表单名称',
  `CODE` varchar(50) DEFAULT NULL COMMENT '筛选表单代码',
  `CREATETIME` datetime DEFAULT NULL COMMENT '创建时间',
  `CREATER` varchar(32) DEFAULT NULL COMMENT '创建人',
  `UPDATETIME` datetime DEFAULT NULL COMMENT '更新时间',
  `ORGI` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `USERNAME` varchar(50) DEFAULT NULL COMMENT '创建人名称',
  `STATUS` varchar(50) DEFAULT NULL COMMENT '状态',
  `PARENTID` varchar(32) DEFAULT NULL COMMENT '上级ID',
  `FILTERTYPE` varchar(32) DEFAULT NULL COMMENT '筛选类型（批次筛选/元数据筛选）',
  `BATID` varchar(32) DEFAULT NULL COMMENT '筛选表单使用的批次ID',
  `TABLEID` varchar(32) DEFAULT NULL COMMENT '筛选表单使用元数据ID',
  `DATASTATUS` tinyint(4) DEFAULT '0' COMMENT '数据状态',
  `INX` int(11) DEFAULT '0' COMMENT '分类排序序号',
  `ORGAN` varchar(32) DEFAULT NULL COMMENT '部门',
  `DESCRIPTION` text COMMENT '备注信息',
  `execnum` int(11) DEFAULT '0' COMMENT '导入次数',
  `filternum` int(11) DEFAULT '0' COMMENT '筛选次数',
  `conditional` int(11) DEFAULT '0' COMMENT '条件个数',
  PRIMARY KEY (`ID`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='筛选表单';

-- ----------------------------
-- Table structure for uk_act_formfilter_item
-- ----------------------------
DROP TABLE IF EXISTS `uk_act_formfilter_item`;
CREATE TABLE `uk_act_formfilter_item` (
  `id` varchar(32) NOT NULL COMMENT '主键ID',
  `orgi` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `creater` varchar(32) DEFAULT NULL COMMENT '创建人',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `updatetime` datetime DEFAULT NULL COMMENT '更新时间',
  `formfilterid` varchar(32) DEFAULT NULL COMMENT '筛选器ID',
  `field` varchar(32) DEFAULT NULL COMMENT '字段',
  `cond` varchar(32) DEFAULT NULL COMMENT '条件',
  `value` varchar(32) DEFAULT NULL COMMENT '取值',
  `contype` varchar(32) DEFAULT NULL COMMENT '条件类型',
  `itemtype` varchar(32) DEFAULT NULL COMMENT '类型',
  `comp` varchar(50) DEFAULT NULL COMMENT '逻辑条件',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='筛选项';

-- ----------------------------
-- Table structure for uk_act_role
-- ----------------------------
DROP TABLE IF EXISTS `uk_act_role`;
CREATE TABLE `uk_act_role` (
  `id` varchar(32) NOT NULL COMMENT '主键ID',
  `rolename` varchar(50) DEFAULT NULL COMMENT '角色名称',
  `roleid` varchar(50) DEFAULT NULL COMMENT '角色id',
  `bustype` varchar(50) DEFAULT NULL COMMENT '业务类型',
  `organid` text COMMENT '授权部门id',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `creater` varchar(32) DEFAULT NULL COMMENT '创建人',
  `updatetime` datetime DEFAULT NULL COMMENT '更新时间',
  `orgi` varchar(32) DEFAULT NULL COMMENT '租户ID',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='电销角色授权表';

-- ----------------------------
-- Table structure for uk_act_schedule
-- ----------------------------
DROP TABLE IF EXISTS `uk_act_schedule`;
CREATE TABLE `uk_act_schedule` (
  `ID` varchar(32) NOT NULL COMMENT '主键ID',
  `NAME` varchar(50) DEFAULT NULL COMMENT '名称',
  `CODE` varchar(50) DEFAULT NULL COMMENT '代码',
  `CREATETIME` datetime DEFAULT NULL COMMENT '创建时间',
  `CREATER` varchar(32) DEFAULT NULL COMMENT '创建人',
  `UPDATETIME` datetime DEFAULT NULL COMMENT '更新时间',
  `ORGI` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `USERNAME` varchar(50) DEFAULT NULL COMMENT '创建人名称',
  `STATUS` varchar(50) DEFAULT NULL COMMENT '状态',
  `PARENTID` varchar(32) DEFAULT NULL COMMENT '上级ID',
  `FILTERTYPE` varchar(32) DEFAULT NULL COMMENT '筛选类型（批次筛选/元数据筛选）',
  `ACTID` varchar(32) DEFAULT NULL COMMENT '筛选表单使用的批次ID',
  `TABLEID` varchar(32) DEFAULT NULL COMMENT '筛选表单使用元数据ID',
  `DATASTATUS` tinyint(4) DEFAULT '0' COMMENT '数据状态',
  `INX` int(11) DEFAULT '0' COMMENT '分类排序序号',
  `ORGAN` varchar(32) DEFAULT NULL COMMENT '部门',
  `DESCRIPTION` text COMMENT '描述信息',
  `daytype` varchar(32) DEFAULT NULL COMMENT '日期类型',
  `begintime` varchar(32) DEFAULT NULL COMMENT '开始时间',
  `endtime` varchar(32) DEFAULT NULL COMMENT '结束时间',
  `policy` varchar(32) DEFAULT NULL COMMENT '策略',
  `callvalues` text COMMENT '备注内容信息',
  PRIMARY KEY (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='电销日程表';

-- ----------------------------
-- Table structure for uk_act_task
-- ----------------------------
DROP TABLE IF EXISTS `uk_act_task`;
CREATE TABLE `uk_act_task` (
  `ID` varchar(32) NOT NULL COMMENT '主键ID',
  `NAME` varchar(50) DEFAULT NULL COMMENT '任务名称',
  `CODE` varchar(50) DEFAULT NULL COMMENT '任务代码',
  `CREATETIME` datetime DEFAULT NULL COMMENT '创建时间',
  `CREATER` varchar(32) DEFAULT NULL COMMENT '创建人',
  `UPDATETIME` datetime DEFAULT NULL COMMENT '更新时间',
  `ORGI` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `USERNAME` varchar(50) DEFAULT NULL COMMENT '创建人名称',
  `STATUS` varchar(50) DEFAULT NULL COMMENT '状态',
  `PARENTID` varchar(32) DEFAULT NULL COMMENT '上级ID',
  `ACTID` varchar(32) DEFAULT NULL COMMENT '活动ID',
  `INX` int(11) DEFAULT '0' COMMENT '分类排序序号',
  `NAMENUM` int(11) DEFAULT '0' COMMENT '批次包含的名单总数',
  `VALIDNUM` int(11) DEFAULT '0' COMMENT '批次包含的有效名单总数',
  `INVALIDNUM` int(11) DEFAULT '0' COMMENT '批次包含的无效名单总数',
  `ASSIGNED` int(11) DEFAULT '0' COMMENT '已分配名单总数',
  `NOTASSIGNED` int(11) DEFAULT '0' COMMENT '未分配名单总数',
  `ENABLE` tinyint(4) DEFAULT '0' COMMENT '分类状态',
  `DATASTATUS` tinyint(4) DEFAULT '0' COMMENT '数据状态',
  `ORGAN` varchar(32) DEFAULT NULL COMMENT '部门',
  `DESCRIPTION` text COMMENT '备注信息',
  `execnum` int(11) DEFAULT '0' COMMENT '导入次数',
  `SOURCE` varchar(255) DEFAULT NULL COMMENT '来源信息',
  `BATID` varchar(32) DEFAULT NULL COMMENT '批次ID',
  `FILTERID` varchar(32) DEFAULT NULL COMMENT '筛选ID',
  `ASSIGNEDORGAN` int(11) DEFAULT '0' COMMENT '分配给部门',
  `exectype` varchar(32) DEFAULT NULL COMMENT '执行类型',
  `renum` int(11) DEFAULT '0' COMMENT '分配数量',
  `reorgannum` int(11) DEFAULT '0' COMMENT '分配到部门数量',
  `assignedai` int(11) DEFAULT '0' COMMENT '分配到AI的名单数量',
  PRIMARY KEY (`ID`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='电销任务表';

-- ----------------------------
-- Table structure for cs_callout_dialplan
-- ----------------------------
DROP TABLE IF EXISTS `cs_callout_dialplan`;
CREATE TABLE `cs_callout_dialplan` (
  `id` varchar(32) NOT NULL COMMENT '主键',
  `name` varchar(50) NOT NULL COMMENT '计划名称',
  `voicechannel` varchar(32) NOT NULL COMMENT '语音渠道ID',
  `organ` varchar(32) NOT NULL COMMENT '技能组部门ID',
  `isrecord` bit(1) NOT NULL DEFAULT b'1' COMMENT '是否录音',
  `createtime` datetime NOT NULL ON UPDATE CURRENT_TIMESTAMP COMMENT '创建日期',
  `updatetime` datetime NOT NULL ON UPDATE CURRENT_TIMESTAMP COMMENT '更新日期',
  `orgi` varchar(32) NOT NULL COMMENT '租户ID',
  `isarchive` bit(1) NOT NULL DEFAULT b'0' COMMENT '是否已删除',
  `executed` int(11) NOT NULL DEFAULT '0' COMMENT '执行次数',
  `targetnum` int(11) NOT NULL DEFAULT '0' COMMENT '目标客户总数',
  `status` varchar(20) NOT NULL DEFAULT 'stopped' COMMENT '状态',
  `executefirsttime` datetime DEFAULT NULL COMMENT '首次执行时间',
  `executelasttime` datetime DEFAULT NULL COMMENT '最近一次执行时间',
  `creater` varchar(32) NOT NULL COMMENT '创建人ID',
  `maxconcurrence` int(11) NOT NULL COMMENT '最大并发数',
  `curconcurrence` int(11) NOT NULL COMMENT '当前并发数',
  `concurrenceratio` float(10,5) NOT NULL COMMENT '坐席并发比',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='外呼计划表';


-- ----------------------------
-- Table structure for cs_callout_targets
-- ----------------------------
DROP TABLE IF EXISTS `cs_callout_targets`;
CREATE TABLE `cs_callout_targets` (
  `id` varchar(32) NOT NULL COMMENT '主键',
  `orgi` varchar(32) NOT NULL COMMENT '租户ID',
  `organid` varchar(32) NOT NULL COMMENT '部门ID',
  `calls` int(11) NOT NULL DEFAULT '0' COMMENT '拨打次数',
  `failed` int(11) NOT NULL DEFAULT '0' COMMENT '拨打失败次数',
  `invalid` bit(1) NOT NULL DEFAULT b'0' COMMENT '是否有效',
  `phone` varchar(20) NOT NULL COMMENT '电话号码',
  `country` varchar(20) DEFAULT '中国' COMMENT '国家',
  `province` varchar(20) DEFAULT NULL COMMENT '省份',
  `city` varchar(20) DEFAULT NULL COMMENT '城市',
  `dialplan` varchar(32) NOT NULL COMMENT '关联呼叫计划',
  `contactsid` varchar(32) DEFAULT NULL COMMENT '关联联系人ID',
  `createtime` datetime NOT NULL ON UPDATE CURRENT_TIMESTAMP COMMENT '创建时间',
  `updatetime` datetime NOT NULL ON UPDATE CURRENT_TIMESTAMP COMMENT '更新时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='外呼计划目标客户';

-- ----------------------------
-- Table structure for cs_stream_file
-- ----------------------------
DROP TABLE IF EXISTS `cs_stream_file`;
CREATE TABLE `cs_stream_file` (
  `id` varchar(32)  NOT NULL COMMENT '文件ID',
  `name` varchar(300)  NOT NULL COMMENT '文件名称',
  `fileurl` varchar(500)  DEFAULT NULL COMMENT '文件访问URL路径',
  `data` mediumblob NOT NULL COMMENT '原始文件',
  `thumbnail` mediumblob COMMENT '缩略图',
  `mime` varchar(200) DEFAULT NULL COMMENT '文件类型 Content Type',
  `cooperation` mediumblob COMMENT '协作文件',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT '文件';

-- ----------------------------
-- Table structure for uk_ad_position
-- ----------------------------
DROP TABLE IF EXISTS `uk_ad_position`;
CREATE TABLE `uk_ad_position` (
  `ID` varchar(32) NOT NULL COMMENT '主键ID',
  `NAME` varchar(50) DEFAULT NULL COMMENT '名称',
  `CODE` varchar(50) DEFAULT NULL COMMENT '代码',
  `CREATETIME` datetime DEFAULT NULL COMMENT '创建时间',
  `CREATER` varchar(32) DEFAULT NULL COMMENT '创建人',
  `UPDATETIME` datetime DEFAULT NULL COMMENT '更新时间',
  `ORGI` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `USERNAME` varchar(50) DEFAULT NULL COMMENT '创建人名称',
  `PARENTID` varchar(32) DEFAULT NULL COMMENT '知识库分类上级ID',
  `INX` int(11) DEFAULT NULL COMMENT '分类排序序号',
  `ENABLE` tinyint(4) DEFAULT NULL COMMENT '分类状态',
  `AREA` text COMMENT '分类描述',
  `IMGURL` varchar(255) DEFAULT NULL COMMENT '图片URL',
  `TIPTEXT` varchar(100) DEFAULT NULL COMMENT '提示文本',
  `URL` text DEFAULT NULL COMMENT '路径',
  `CONTENT` text COMMENT '内容',
  `WEIGHT` int(11) DEFAULT NULL COMMENT '权重',
  `ADTYPE` varchar(50) DEFAULT NULL COMMENT '广告类型',
  `STATUS` varchar(32) DEFAULT NULL COMMENT '广告状态',
  `ADPOS` varchar(32) DEFAULT NULL COMMENT '广告位置',
  `skill` varchar(32) DEFAULT NULL COMMENT '组织机构ID',
  PRIMARY KEY (`ID`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='客服客户端广告位表';

-- ----------------------------
-- Table structure for uk_agentservice
-- ----------------------------
DROP TABLE IF EXISTS `uk_agentservice`;
CREATE TABLE `uk_agentservice` (
  `id` varchar(32) NOT NULL DEFAULT '' COMMENT '主键ID',
  `username` varchar(100) DEFAULT '' COMMENT '创建人用户名',
  `agentno` varchar(100) DEFAULT '' COMMENT '坐席ID',
  `userid` varchar(100) DEFAULT '' COMMENT '用户ID',
  `channel` varchar(100) DEFAULT '' COMMENT '渠道',
  `logindate` datetime DEFAULT NULL COMMENT '登录时间',
  `source` varchar(100) DEFAULT '' COMMENT '来源',
  `endtime` datetime DEFAULT NULL COMMENT '结束时间',
  `nickname` varchar(100) DEFAULT '' COMMENT '昵称',
  `city` varchar(100) DEFAULT '' COMMENT '城市',
  `province` varchar(100) DEFAULT '' COMMENT '省份',
  `country` varchar(100) DEFAULT '' COMMENT '国家',
  `headImgUrl` varchar(255) DEFAULT '' COMMENT '头像URL',
  `waittingtime` int(11) DEFAULT '0' COMMENT '等待时间',
  `tokenum` int(11) DEFAULT '0' COMMENT '未回复消息数量',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `updatetime` datetime DEFAULT NULL COMMENT '更新时间',
  `status` varchar(100) DEFAULT '' COMMENT '状态',
  `appid` varchar(100) DEFAULT '' COMMENT 'SNSID',
  `sessiontype` varchar(100) DEFAULT '' COMMENT '会话类型',
  `contextid` varchar(100) DEFAULT '' COMMENT '会话ID',
  `agentserviceid` varchar(100) DEFAULT '' COMMENT '服务记录ID',
  `orgi` varchar(100) DEFAULT '' COMMENT '租户ID',
  `snsuser` varchar(100) DEFAULT '' COMMENT '用户ID（微信）',
  `lastmessage` datetime DEFAULT NULL COMMENT '最后一条消息时间',
  `waittingtimestart` datetime DEFAULT NULL COMMENT '进入排队时间',
  `lastgetmessage` datetime DEFAULT NULL COMMENT '坐席最后一条消息时间',
  `lastmsg` text COMMENT '最后一条消息内容',
  `agentskill` varchar(100) DEFAULT '' COMMENT '技能组',
  `create_time` datetime DEFAULT NULL COMMENT '创建时间',
  `creater` varchar(255) DEFAULT NULL COMMENT '创建人',
  `update_time` datetime DEFAULT NULL COMMENT '修改时间',
  `update_user` varchar(255) DEFAULT NULL COMMENT '修改人',
  `assignedto` varchar(255) DEFAULT NULL COMMENT '分配目标用户',
  `wfstatus` varchar(255) DEFAULT NULL COMMENT '流程状态',
  `shares` varchar(255) DEFAULT NULL COMMENT '分享给',
  `owner` varchar(255) DEFAULT NULL COMMENT '所属人',
  `datadept` varchar(255) DEFAULT NULL COMMENT '创建人部门',
  `intime` int(32) DEFAULT NULL COMMENT '接入时间',
  `batid` varchar(32) DEFAULT NULL COMMENT '批次ID',
  `ipaddr` varchar(50) DEFAULT NULL COMMENT 'IP地址',
  `osname` varchar(100) DEFAULT NULL COMMENT '操作系统名称',
  `browser` varchar(100) DEFAULT NULL COMMENT '浏览器',
  `sessiontimes` bigint(64) DEFAULT NULL COMMENT '会话时长',
  `servicetime` datetime DEFAULT NULL COMMENT '服务时长',
  `region` varchar(255) DEFAULT NULL COMMENT '区域',
  `agentusername` varchar(50) DEFAULT NULL COMMENT '坐席用户名',
  `times` int(10) DEFAULT NULL COMMENT '消息数量',
  `dataid` varchar(32) DEFAULT NULL COMMENT '数据ID',
  `contactsid` varchar(32) DEFAULT NULL COMMENT '联系人ID',
  `createdate` varchar(32) DEFAULT NULL COMMENT '消息到达时间',
  `name` varchar(100) DEFAULT NULL COMMENT '访客填写的姓名',
  `email` varchar(100) DEFAULT NULL COMMENT '访客填写的邮件地址',
  `phone` varchar(100) DEFAULT NULL COMMENT '访客填写的电话号码',
  `resion` varchar(255) DEFAULT NULL COMMENT '访客填写的来访原因',
  `satisfaction` tinyint(4) DEFAULT NULL COMMENT '满意度调查评级',
  `satistime` datetime DEFAULT NULL COMMENT '满意度调查时间',
  `satislevel` varchar(50) DEFAULT NULL COMMENT '满意度评分',
  `satiscomment` varchar(255) DEFAULT NULL COMMENT '满意度备注',
  `trans` tinyint(4) DEFAULT NULL COMMENT '是否转接',
  `transtime` datetime DEFAULT NULL COMMENT '转接时间',
  `transmemo` text COMMENT '转接备注',
  `agentreplyinterval` int(11) DEFAULT NULL COMMENT '坐席评级回复间隔',
  `agentreplytime` int(11) DEFAULT NULL COMMENT '坐席评级回复时间',
  `avgreplyinterval` int(11) DEFAULT NULL COMMENT '访客平均回复间隔',
  `avgreplytime` int(11) DEFAULT NULL COMMENT '访客回复总时长',
  `agentreplys` int(11) DEFAULT NULL COMMENT '坐席回复消息数量',
  `userasks` int(11) DEFAULT NULL COMMENT '访客发送消息数量',
  `agentuserid` varchar(32) DEFAULT NULL COMMENT '访客ID',
  `sessionid` varchar(32) DEFAULT NULL COMMENT '会话ID',
  `qualitystatus` varchar(20) DEFAULT NULL COMMENT '质检状态',
  `qualitydisorgan` varchar(32) DEFAULT NULL COMMENT '质检分配部门',
  `qualitydisuser` varchar(32) DEFAULT NULL COMMENT '质检分配用户',
  `qualityorgan` varchar(32) DEFAULT NULL COMMENT '质检部门',
  `qualityuser` varchar(32) DEFAULT NULL COMMENT '质检用户',
  `qualitytime` datetime DEFAULT NULL COMMENT '质检时间',
  `qualitytype` varchar(20) DEFAULT NULL COMMENT '质检方式',
  `qualityscore` int(11) DEFAULT '0' COMMENT '质检打分',
  `solvestatus` varchar(20) DEFAULT NULL COMMENT '问题解决状态',
  `leavemsg` tinyint(4) DEFAULT '0' COMMENT '是否留言',
  `initiator` varchar(32) DEFAULT NULL COMMENT '对话发起方',
  `agenttimeout` int(11) DEFAULT '0' COMMENT '坐席超时时长',
  `agenttimeouttimes` int(11) DEFAULT '0' COMMENT '坐席超时次数',
  `servicetimeout` tinyint(4) DEFAULT '0',
  `agentservicetimeout` int(11) DEFAULT '0' COMMENT '服务超时',
  `agentfrewords` int(11) DEFAULT '0' COMMENT '坐席触发敏感词',
  `servicefrewords` int(11) DEFAULT '0' COMMENT '访客触发敏感词',
  `leavemsgstatus` varchar(20) DEFAULT 'notprocess' COMMENT '留言处理状态',
  `agent` varchar(32) DEFAULT NULL COMMENT '坐席',
  `skill` varchar(32) DEFAULT NULL COMMENT '技能组',
  `endby` varchar(20) DEFAULT NULL COMMENT '终止方',
  `aiid` varchar(32) DEFAULT NULL COMMENT 'AIID',
  `aiservice` tinyint(4) DEFAULT '0' COMMENT '是否AI服务',
  `foragent` tinyint(4) DEFAULT '0' COMMENT '直接转人工',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='在线客服服务记录表';


-- ----------------------------
-- Table structure for uk_agentstatus
-- ----------------------------
DROP TABLE IF EXISTS `uk_agentstatus`;
CREATE TABLE `uk_agentstatus` (
  `id` varchar(32) NOT NULL DEFAULT '' COMMENT '主键ID',
  `agentno` varchar(100) DEFAULT '' COMMENT '坐席ID',
  `logindate` datetime DEFAULT NULL COMMENT '登录时间',
  `status` varchar(100) DEFAULT '' COMMENT '状态',
  `orgi` varchar(100) DEFAULT '' COMMENT '租户ID',
  `agentserviceid` varchar(100) DEFAULT '' COMMENT '服务ID',
  `serusernum` int(11) DEFAULT '0' COMMENT '服务用户数',
  `users` int(11) DEFAULT '0' COMMENT '接入用户数',
  `maxusers` int(11) DEFAULT '0' COMMENT '最大接入用户数',
  `username` varchar(100) DEFAULT '' COMMENT '用户名',
  `name` varchar(100) DEFAULT '' COMMENT '名称',
  `updatetime` datetime DEFAULT NULL COMMENT '更新时间',
  `userid` varchar(100) DEFAULT '' COMMENT '用户ID',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `creater` varchar(255) DEFAULT NULL COMMENT '创建人',
  `update_time` datetime DEFAULT NULL COMMENT '修改时间',
  `update_user` varchar(255) DEFAULT NULL COMMENT '修改人',
  `assignedto` varchar(255) DEFAULT NULL COMMENT '分配目标用户',
  `wfstatus` varchar(255) DEFAULT NULL COMMENT '流程状态',
  `shares` varchar(255) DEFAULT NULL COMMENT '分享给',
  `owner` varchar(255) DEFAULT NULL COMMENT '所属人',
  `datadept` varchar(255) DEFAULT NULL COMMENT '创建人部门',
  `batid` varchar(32) DEFAULT NULL COMMENT '批次ID',
  `pulluser` tinyint(4) DEFAULT NULL COMMENT '是否允许拉取用户',
  `busy` tinyint(4) DEFAULT '0' COMMENT '示忙',
  `workstatus` varchar(50) DEFAULT NULL COMMENT '工作状态',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='在线客服坐席状态表';

-- ----------------------------
-- Table structure for uk_agentuser
-- ----------------------------
DROP TABLE IF EXISTS `uk_agentuser`;
CREATE TABLE `uk_agentuser` (
  `id` varchar(32) NOT NULL DEFAULT '' COMMENT '主键ID',
  `username` varchar(100) DEFAULT '' COMMENT '用户名',
  `userid` varchar(100) DEFAULT '' COMMENT '用户ID',
  `channel` varchar(100) DEFAULT '' COMMENT '渠道',
  `logindate` datetime DEFAULT NULL COMMENT '登录时间',
  `source` varchar(100) DEFAULT '' COMMENT '来源',
  `endtime` datetime DEFAULT NULL COMMENT '结束时间',
  `nickname` varchar(100) DEFAULT '' COMMENT '昵称',
  `city` varchar(100) DEFAULT '' COMMENT '城市',
  `province` varchar(100) DEFAULT '' COMMENT '省份',
  `country` varchar(100) DEFAULT '' COMMENT '国家',
  `headImgUrl` varchar(255) DEFAULT '' COMMENT '头像URL',
  `waittingtime` int(11) DEFAULT '0' COMMENT '等待时长',
  `tokenum` int(11) DEFAULT '0' COMMENT '接入次数',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `updatetime` datetime DEFAULT NULL COMMENT '更新时间',
  `status` varchar(100) DEFAULT '' COMMENT '状态',
  `appid` varchar(100) DEFAULT '' COMMENT 'SNSID',
  `sessiontype` varchar(100) DEFAULT '' COMMENT '会话类型',
  `contextid` varchar(100) DEFAULT '' COMMENT '会话ID',
  `agentserviceid` varchar(100) DEFAULT '' COMMENT '服务记录ID',
  `orgi` varchar(100) DEFAULT '' COMMENT '租户ID',
  `snsuser` varchar(100) DEFAULT '' COMMENT 'SNS用户ID',
  `lastmessage` datetime DEFAULT NULL COMMENT '最后一条消息时间',
  `waittingtimestart` datetime DEFAULT NULL COMMENT '进入队列时间',
  `lastgetmessage` datetime DEFAULT NULL COMMENT '最后一条消息时间',
  `lastmsg` text COMMENT '最后一条消息',
  `agentskill` varchar(100) DEFAULT '' COMMENT '技能组',
  `create_time` datetime DEFAULT NULL COMMENT '创建时间',
  `creater` varchar(255) DEFAULT NULL COMMENT '创建人',
  `update_time` datetime DEFAULT NULL COMMENT '修改时间',
  `update_user` varchar(255) DEFAULT NULL COMMENT '修改人',
  `assignedto` varchar(255) DEFAULT NULL COMMENT '分配目标用户',
  `wfstatus` varchar(255) DEFAULT NULL COMMENT '流程状态',
  `shares` varchar(255) DEFAULT NULL COMMENT '分享给',
  `owner` varchar(255) DEFAULT NULL COMMENT '所属人',
  `datadept` varchar(255) DEFAULT NULL COMMENT '创建人部门',
  `intime` int(32) DEFAULT NULL COMMENT '接入时间',
  `batid` varchar(32) DEFAULT NULL COMMENT '批次ID',
  `opttype` varchar(32) DEFAULT NULL COMMENT '服务处理类型',
  `ipaddr` varchar(50) DEFAULT NULL COMMENT 'IP地址',
  `osname` varchar(100) DEFAULT NULL COMMENT '操作系统名称',
  `browser` varchar(100) DEFAULT NULL COMMENT '浏览器',
  `sessiontimes` bigint(64) DEFAULT NULL COMMENT '会话时长',
  `servicetime` datetime DEFAULT NULL COMMENT '服务次数',
  `region` varchar(255) DEFAULT NULL COMMENT '地区',
  `agentservice` varchar(32) DEFAULT NULL COMMENT '服务ID',
  `warnings` varchar(11) DEFAULT NULL COMMENT '提醒次数',
  `warningtime` datetime DEFAULT NULL COMMENT '提醒时间',
  `reptime` datetime DEFAULT NULL COMMENT '坐席最后一次回复时间',
  `reptimes` varchar(10) DEFAULT NULL COMMENT '坐席回复次数',
  `agentno` varchar(100) DEFAULT '' COMMENT '坐席ID',
  `agentname` varchar(100) DEFAULT NULL COMMENT '坐席名字',
  `skill` varchar(32) DEFAULT NULL COMMENT '技能组',
  `name` varchar(100) DEFAULT NULL COMMENT '用户录入的姓名',
  `phone` varchar(100) DEFAULT NULL COMMENT '访客录入的电话',
  `email` varchar(100) DEFAULT NULL COMMENT '访客录入的邮件',
  `resion` varchar(255) DEFAULT NULL COMMENT '访客录入的来访原因',
  `agentreplyinterval` int(11) DEFAULT '0' COMMENT '坐席回复总间隔',
  `agentreplytime` int(11) DEFAULT '0' COMMENT '坐席回复时长',
  `agentreplys` int(11) DEFAULT '0' COMMENT '坐席回复次数',
  `userasks` int(11) DEFAULT '0' COMMENT '访客提问次数',
  `avgreplyinterval` int(11) DEFAULT '0' COMMENT '平均回复间隔',
  `avgreplytime` int(11) DEFAULT '0' COMMENT '平均回复时长',
  `sessionid` varchar(32) DEFAULT NULL COMMENT '会话ID',
  `title` varchar(255) DEFAULT NULL COMMENT '标题',
  `url` text DEFAULT NULL COMMENT 'URL',
  `traceid` varchar(32) DEFAULT NULL COMMENT '跟踪ID',
  `agenttimeout` int(11) DEFAULT '0' COMMENT '坐席超时时长',
  `agenttimeouttimes` int(11) DEFAULT '0' COMMENT '坐席超时次数',
  `servicetimeout` tinyint(4) DEFAULT '0' COMMENT '服务超时时长',
  `agentservicetimeout` int(11) DEFAULT '0' COMMENT '服务超时次数',
  `agentfrewords` int(11) DEFAULT '0' COMMENT '坐席触发敏感词',
  `servicefrewords` int(11) DEFAULT '0' COMMENT '访客触发敏感词',
  `topflag` tinyint(4) DEFAULT NULL COMMENT '是否置顶',
  `toptimes` int(20) DEFAULT NULL COMMENT '置顶时长',
  `toptime` datetime DEFAULT NULL COMMENT '置顶时间',
  `firstreplytime` int(20) DEFAULT '0' COMMENT '首次响应时间',
  `agentusername` varchar(32) DEFAULT NULL COMMENT '坐席姓名',
  `alarm` int(10) DEFAULT '0' COMMENT '是否触发预警',
  `initiator` varchar(32) DEFAULT NULL COMMENT '会话发起方',
  `chatbotops` tinyint(1) DEFAULT '0' COMMENT '是否是机器人客服',
  `chatbotlogicerror` int(11) DEFAULT '0' COMMENT '机器人客服不符合逻辑返回累计',
  `chatbotround` int(11) DEFAULT '0' COMMENT '机器人客服对话轮次',
  PRIMARY KEY (`id`) USING BTREE,
  KEY `agentuser_userid` (`userid`) USING BTREE,
  KEY `agentuser_orgi` (`orgi`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='在线客服访客咨询表';


-- ----------------------------
-- Table structure for uk_agentuser_contacts
-- ----------------------------
DROP TABLE IF EXISTS `uk_agentuser_contacts`;
CREATE TABLE `uk_agentuser_contacts` (
  `id` varchar(32) NOT NULL COMMENT '主键ID',
  `orgi` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `appid` varchar(32) DEFAULT NULL COMMENT 'SNSID',
  `channel` varchar(32) DEFAULT NULL COMMENT '渠道',
  `userid` varchar(32) DEFAULT NULL COMMENT '用户ID',
  `contactsid` varchar(32) DEFAULT NULL COMMENT '联系人ID',
  `username` varchar(100) DEFAULT NULL COMMENT '创建人用户名',
  `creater` varchar(32) DEFAULT NULL COMMENT '创建人ID',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='访客联系人关联表';


-- ----------------------------
-- Table structure for uk_ai
-- ----------------------------
DROP TABLE IF EXISTS `uk_ai`;
CREATE TABLE `uk_ai` (
  `id` varchar(32) NOT NULL COMMENT '主键ID',
  `name` varchar(255) DEFAULT NULL COMMENT 'AI名称',
  `createtime` timestamp NULL DEFAULT NULL ON UPDATE CURRENT_TIMESTAMP COMMENT '创建时间',
  `creater` varchar(32) DEFAULT NULL COMMENT '创建人',
  `orgi` varchar(32) DEFAULT NULL COMMENT '租户id',
  `inx` int(11) DEFAULT NULL COMMENT '分类排序序号',
  `updatetime` datetime DEFAULT NULL COMMENT '更新时间',
  `description` varchar(255) DEFAULT NULL COMMENT '分类描述',
  `code` varchar(32) DEFAULT NULL COMMENT '代码',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='AI机器人表';

-- ----------------------------
-- Table structure for uk_ai_snsaccount
-- ----------------------------
DROP TABLE IF EXISTS `uk_ai_snsaccount`;
CREATE TABLE `uk_ai_snsaccount` (
  `id` varchar(32) NOT NULL COMMENT '主键ID',
  `aiid` varchar(32) DEFAULT NULL COMMENT '用户ID',
  `snsid` varchar(32) DEFAULT NULL COMMENT '角色ID',
  `creater` varchar(32) DEFAULT NULL COMMENT '创建人',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `orgi` varchar(32) DEFAULT NULL COMMENT '租户ID',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='AI列表';

DROP TABLE IF EXISTS `cs_fb_messenger`;
CREATE TABLE `cs_fb_messenger` (
  `id` varchar(32) NOT NULL,
  `page_id` varchar(100) NOT NULL,
  `token` varchar(300) NOT NULL,
  `verify_token` varchar(100) NOT NULL,
  `name` varchar(100) NOT NULL,
  `status` varchar(100) NOT NULL,
  `organ` varchar(32) NOT NULL,
  `aiid` varchar(32) DEFAULT NULL,
  `ai` tinyint(4) DEFAULT '0' COMMENT '启用AI',
  `aisuggest` tinyint(4) DEFAULT '0' COMMENT '启用智能建议',
  `config` VARCHAR(1000) NULL DEFAULT NULL COMMENT '文案配置',
  `createtime` datetime NOT NULL,
  `updatetime` datetime NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='FB渠道';

DROP TABLE IF EXISTS `cs_fb_otn`;
CREATE TABLE `cs_fb_otn` (
	`id` VARCHAR(32) NOT NULL,
	`name` VARCHAR(100) NOT NULL,
	`page_id` VARCHAR(100) NOT NULL,
	`pre_sub_message` VARCHAR(500) NULL DEFAULT NULL,
	`sub_message` VARCHAR(500) NOT NULL,
	`success_message` VARCHAR(500) NULL DEFAULT NULL,
	`otn_message` VARCHAR(1000) NOT NULL,
	`status` VARCHAR(50) NOT NULL,
	`createtime` DATETIME NOT NULL,
	`updatetime` DATETIME NOT NULL,
	`sendtime` DATETIME NULL DEFAULT NULL,
  `sub_num` INT(11) NOT NULL,
  `melink_num` INT(11) NOT NULL,
	PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='FB OTN';

DROP TABLE IF EXISTS `cs_fb_otn_follow`;
CREATE TABLE `cs_fb_otn_follow` (
	`id` VARCHAR(32) NOT NULL,
	`page_id` VARCHAR(32) NOT NULL,
	`otn_id` VARCHAR(32) NOT NULL,
	`user_id` VARCHAR(300) NOT NULL,
	`otn_token` VARCHAR(300) NOT NULL,
	`createtime` DATETIME NOT NULL,
	`updatetime` DATETIME NOT NULL,
	`sendtime` DATETIME NULL DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='FB OTN 订阅';

-- ----------------------------
-- Table structure for uk_area_type
-- ----------------------------
DROP TABLE IF EXISTS `uk_area_type`;
CREATE TABLE `uk_area_type` (
  `ID` varchar(32) NOT NULL COMMENT '主键ID',
  `NAME` varchar(50) DEFAULT NULL COMMENT '名称',
  `CODE` varchar(50) DEFAULT NULL COMMENT '代码',
  `CREATETIME` datetime DEFAULT NULL COMMENT '创建时间',
  `CREATER` varchar(32) DEFAULT NULL COMMENT '创建人',
  `UPDATETIME` datetime DEFAULT NULL COMMENT '更新时间',
  `ORGI` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `USERNAME` varchar(50) DEFAULT NULL COMMENT '用户名',
  `PARENTID` varchar(32) DEFAULT NULL COMMENT '知识库分类上级ID',
  `INX` int(11) DEFAULT NULL COMMENT '分类排序序号',
  `ENABLE` tinyint(4) DEFAULT NULL COMMENT '分类状态',
  `AREA` text COMMENT '分类描述',
  PRIMARY KEY (`ID`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='区域类型';

-- ----------------------------
-- Table structure for uk_attachment_file
-- ----------------------------
DROP TABLE IF EXISTS `uk_attachment_file`;
CREATE TABLE `uk_attachment_file` (
  `id` varchar(32) NOT NULL COMMENT '主键ID',
  `orgi` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `creater` varchar(32) DEFAULT NULL COMMENT '创建人ID',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `organ` varchar(32) DEFAULT NULL COMMENT '组织机构ID',
  `datastatus` tinyint(4) DEFAULT NULL COMMENT '数据状态（逻辑删除）',
  `title` varchar(255) DEFAULT NULL COMMENT '标题',
  `url` text CHARACTER SET utf32 DEFAULT NULL COMMENT '地址',
  `updatetime` datetime DEFAULT NULL COMMENT '更新时间',
  `filelength` int(11) DEFAULT NULL COMMENT '文件长度',
  `filetype` varchar(255) DEFAULT NULL COMMENT '文件类型',
  `image` tinyint(4) DEFAULT NULL COMMENT '是否图片',
  `dataid` varchar(32) DEFAULT NULL COMMENT '数据ID',
  `model` varchar(32) DEFAULT NULL COMMENT '所属功能模块',
  `fileid` varchar(32) DEFAULT NULL COMMENT '文件ID',
  `modelid` varchar(32) DEFAULT NULL COMMENT '所属模块数据ID',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='附件表';

-- ----------------------------
-- Table structure for uk_blacklist
-- ----------------------------
DROP TABLE IF EXISTS `uk_blacklist`;
CREATE TABLE `uk_blacklist` (
  `id` varchar(32) NOT NULL COMMENT '主键ID',
  `orgi` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `userid` varchar(32) DEFAULT NULL COMMENT '用户ID',
  `contactid` varchar(32) DEFAULT NULL COMMENT '联系人ID',
  `sessionid` varchar(32) DEFAULT NULL COMMENT '会话ID',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `channel` varchar(20) DEFAULT NULL COMMENT '渠道',
  `creater` varchar(32) DEFAULT NULL COMMENT '创家人',
  `agentid` varchar(32) DEFAULT NULL COMMENT '坐席ID',
  `phone` varchar(20) DEFAULT NULL COMMENT '电话号码',
  `openid` varchar(100) DEFAULT NULL COMMENT '微信号',
  `description` text COMMENT '描述',
  `agentserviceid` varchar(32) DEFAULT NULL COMMENT '坐席服务ID',
  `times` int(11) DEFAULT NULL COMMENT '次数',
  `chattime` int(11) DEFAULT NULL COMMENT '对话次数',
  `controltime` int(11) DEFAULT '1' COMMENT '开始时间',
  `endtime` datetime DEFAULT NULL COMMENT '结束时间',
  `agentuser` varchar(255) DEFAULT NULL COMMENT '访客',
  `skill` varchar(32) DEFAULT NULL COMMENT '组织机构ID',
  `agentusername` varchar(50) DEFAULT NULL COMMENT '客服',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='黑名单表';

-- ----------------------------
-- Table structure for uk_bpm_process
-- ----------------------------
DROP TABLE IF EXISTS `uk_bpm_process`;
CREATE TABLE `uk_bpm_process` (
  `ID` varchar(32) NOT NULL COMMENT '主键ID',
  `NAME` varchar(50) DEFAULT NULL COMMENT '名称',
  `CODE` varchar(50) DEFAULT NULL COMMENT '代码',
  `CREATETIME` datetime DEFAULT NULL COMMENT '创建时间',
  `CREATER` varchar(32) DEFAULT NULL COMMENT '创建人',
  `UPDATETIME` datetime DEFAULT NULL COMMENT '更新时间',
  `ORGI` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `USERNAME` varchar(50) DEFAULT NULL COMMENT '用户名',
  `CONTENT` text COMMENT '流程文本内容',
  `STATUS` varchar(20) DEFAULT NULL COMMENT '流程状态',
  `TITLE` varchar(50) DEFAULT NULL COMMENT '流程标题',
  `PUBLISHED` tinyint(4) DEFAULT NULL COMMENT '流程发布状态',
  `PROCESSID` varchar(50) DEFAULT NULL COMMENT '流程ID',
  `PROCESSTYPE` varchar(50) DEFAULT NULL COMMENT '流程类型',
  PRIMARY KEY (`ID`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='业务流程表';

-- ----------------------------
-- Table structure for uk_call_monitor
-- ----------------------------
DROP TABLE IF EXISTS `uk_call_monitor`;
CREATE TABLE `uk_call_monitor` (
  `ID` varchar(50) NOT NULL COMMENT 'ID',
  `USERID` varchar(50) DEFAULT NULL COMMENT '登录人ID',
  `AGENT` varchar(50) DEFAULT NULL COMMENT '坐席工号',
  `USERNAME` varchar(50) DEFAULT NULL COMMENT '坐席用户名（登录名）',
  `AGENTNO` varchar(50) DEFAULT NULL COMMENT '分机号（坐席登录的分机号码）',
  `NAME` varchar(50) DEFAULT NULL COMMENT '坐席姓名',
  `CODE` varchar(50) DEFAULT NULL COMMENT '坐席状态code（对应字典表里的CODE）',
  `STATUS` varchar(50) DEFAULT NULL COMMENT '坐席当前状态（坐席当前状态（坐席监控首页显示，判断根本依据，每次状态改变，数据记录会被更新））',
  `ORGI` varchar(50) DEFAULT NULL COMMENT '租户ID',
  `AGENTSERVICEID` varchar(50) DEFAULT NULL COMMENT '会话ID',
  `SKILL` varchar(50) DEFAULT NULL COMMENT '接入的技能组ID',
  `SKILLNAME` varchar(50) DEFAULT NULL COMMENT '接入的技能组名称',
  `BUSY` varchar(50) DEFAULT NULL COMMENT '是否忙',
  `CREATETIME` datetime DEFAULT NULL COMMENT '记录创建时间（每个坐席的第一条记录为，点击登录之后，登录成功之后的时间，则会插入一条记录。以后每次状态改变，记录会被更新，时间都会跟着改变，变为状态改变后的时间。）',
  `ANI` varchar(50) DEFAULT NULL COMMENT '主叫号码',
  `CALLED` varchar(50) DEFAULT NULL COMMENT '被叫号码',
  `DIRECTION` varchar(50) DEFAULT NULL COMMENT '呼叫方向',
  `CALLSTARTTIME` datetime DEFAULT NULL COMMENT '通话开始时间',
  `CALLENDTIME` datetime DEFAULT NULL COMMENT '通话结束时间',
  `RINGDURATION` int(11) DEFAULT NULL COMMENT '振铃时长',
  `DURATION` int(11) DEFAULT NULL COMMENT '通话时长',
  `MISSCALL` tinyint(4) DEFAULT NULL COMMENT '是否漏话',
  `RECORD` tinyint(4) DEFAULT NULL COMMENT '是否录音',
  `RECORDTIME` int(11) DEFAULT NULL COMMENT '录音时长',
  `STARTRECORD` datetime DEFAULT NULL COMMENT '开始录音时间',
  `ENDRECORD` datetime DEFAULT NULL COMMENT '结束录音时间',
  `RECORDFILENAME` varchar(100) DEFAULT NULL COMMENT '录音文件名（单纯录音文件名）',
  `RECORDFILE` varchar(255) DEFAULT NULL COMMENT '录音文件全路径名（存放位置+文件名）',
  `SOURCE` varchar(50) DEFAULT NULL COMMENT '来源',
  `ANSWERTIME` datetime DEFAULT NULL COMMENT '应答时间',
  `CURRENT` tinyint(4) DEFAULT NULL COMMENT '当前通话',
  `INIT` tinyint(4) DEFAULT NULL COMMENT '初始通话',
  `ACTION` varchar(50) DEFAULT NULL COMMENT '事件动作',
  `HOST` varchar(50) DEFAULT NULL COMMENT '时间主机（FreeWitch主机帐户名）',
  `IPADDR` varchar(50) DEFAULT NULL COMMENT '主机IP（FreeWitch主机IP）',
  `SERVICESUMMARY` tinyint(4) DEFAULT NULL COMMENT '是否记录服务小结',
  `SERVICEID` varchar(32) DEFAULT NULL COMMENT '服务记录ID',
  `SERVICESTATUS` varchar(50) DEFAULT NULL COMMENT '当前呼叫状态',
  `CHANNELSTATUS` varchar(50) DEFAULT NULL COMMENT '事件中的呼叫状态',
  `COUNTRY` varchar(50) DEFAULT NULL COMMENT '来电国家',
  `PROVINCE` varchar(50) DEFAULT NULL COMMENT '来电号码归属省份',
  `CITY` varchar(50) DEFAULT NULL COMMENT '来电号码归属城市',
  `ISP` varchar(50) DEFAULT NULL COMMENT '来电号码运营商',
  `CONTACTSID` varchar(50) DEFAULT NULL COMMENT '联系人ID',
  `EXTENTION` varchar(50) DEFAULT NULL COMMENT '分机ID',
  `HOSTID` varchar(50) DEFAULT NULL COMMENT 'PBX服务器ID',
  `CALLTYPE` varchar(50) DEFAULT NULL COMMENT '呼叫方向类型 | 计费类型',
  `CALLDIR` varchar(50) DEFAULT NULL COMMENT '我方呼叫方向',
  `OTHERDIR` varchar(50) DEFAULT NULL COMMENT '对方呼叫方向',
  `BRIDGEID` varchar(50) DEFAULT NULL COMMENT '桥接ID',
  `BRIDRE` tinyint(4) DEFAULT NULL COMMENT '是否有桥接',
  `DISCALLER` varchar(50) DEFAULT NULL COMMENT '主叫分机号',
  `DISCALLED` varchar(50) DEFAULT NULL COMMENT '被叫分机号',
  `ORGAN` varchar(50) DEFAULT NULL COMMENT '所属组织机构ID',
  `EVENTID` varchar(50) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='坐席监控表';

-- ----------------------------
-- Table structure for uk_call_performance
-- ----------------------------
DROP TABLE IF EXISTS `uk_call_performance`;
CREATE TABLE `uk_call_performance` (
  `ID` varchar(50) NOT NULL COMMENT '坐席ID',
  `USERID` varchar(50) DEFAULT NULL COMMENT '登录人ID',
  `AGENT` varchar(50) DEFAULT NULL COMMENT '坐席工号',
  `USERNAME` varchar(50) DEFAULT NULL COMMENT '坐席用户名（登录名）',
  `AGENTNO` varchar(50) DEFAULT NULL COMMENT '分机号（坐席登录的分机号码）',
  `NAME` varchar(50) DEFAULT NULL COMMENT '坐席姓名',
  `STARTSTATUS` varchar(50) DEFAULT NULL COMMENT '上一个状态',
  `CODE` varchar(50) DEFAULT NULL COMMENT '坐席状态code（对应字典管理中的CODE）',
  `STATUS` varchar(50) DEFAULT NULL COMMENT '坐席历史状态（插入该表时的状态（复制自坐席监控表的状态））',
  `ORGI` varchar(50) DEFAULT NULL COMMENT '租户ID',
  `AGENTSERVICEID` varchar(50) DEFAULT NULL COMMENT '会话ID',
  `SKILL` varchar(50) DEFAULT NULL COMMENT '接入的技能组ID',
  `SKILLNAME` varchar(50) DEFAULT NULL COMMENT '接入的技能组名称',
  `BUSY` varchar(50) DEFAULT NULL COMMENT '是否忙',
  `CREATETIME` datetime DEFAULT NULL COMMENT '状态开始时间（取值（坐席监控表的记录创建时间））',
  `ENDTIME` datetime DEFAULT NULL COMMENT '记录创建时间（取值（纪录插入表时的时间））',
  `INTERVALTIME` varchar(50) DEFAULT NULL COMMENT '状态持续时间（秒）（endtime - createtime = intervaltime）',
  `ANI` varchar(50) DEFAULT NULL COMMENT '主叫号码',
  `CALLED` varchar(50) DEFAULT NULL COMMENT '被叫号码',
  `DIRECTION` varchar(50) DEFAULT NULL COMMENT '呼叫方向',
  `CALLSTARTTIME` datetime DEFAULT NULL COMMENT '通话开始时间',
  `CALLENDTIME` datetime DEFAULT NULL COMMENT '通话结束时间',
  `RINGDURATION` int(11) DEFAULT NULL COMMENT '振铃时长',
  `DURATION` int(11) DEFAULT NULL COMMENT '通话时长',
  `MISSCALL` tinyint(4) DEFAULT NULL COMMENT '是否漏话',
  `RECORD` tinyint(4) DEFAULT NULL COMMENT '是否录音',
  `RECORDTIME` int(11) DEFAULT NULL COMMENT '录音时长',
  `STARTRECORD` datetime DEFAULT NULL COMMENT '开始录音时间',
  `ENDRECORD` datetime DEFAULT NULL COMMENT '结束录音时间',
  `RECORDFILENAME` varchar(100) DEFAULT NULL COMMENT '录音文件名（单纯录音文件名）',
  `RECORDFILE` varchar(255) DEFAULT NULL COMMENT '录音文件全路径名（存放位置+文件名）',
  `SOURCE` varchar(50) DEFAULT NULL COMMENT '来源',
  `ANSWERTIME` datetime DEFAULT NULL COMMENT '应答时间',
  `CURRENT` tinyint(4) DEFAULT NULL COMMENT '当前通话',
  `INIT` tinyint(4) DEFAULT NULL COMMENT '初始通话',
  `ACTION` varchar(50) DEFAULT NULL COMMENT '事件动作',
  `HOST` varchar(50) DEFAULT NULL COMMENT '时间主机（FreeWitch主机帐户名）',
  `IPADDR` varchar(50) DEFAULT NULL COMMENT '主机IP（FreeWitch主机IP）',
  `SERVICESUMMARY` tinyint(4) DEFAULT NULL COMMENT '是否记录服务小结',
  `SERVICEID` varchar(32) DEFAULT NULL COMMENT '服务记录ID',
  `SERVICESTATUS` varchar(50) DEFAULT NULL COMMENT '当前呼叫状态',
  `CHANNELSTATUS` varchar(50) DEFAULT NULL COMMENT '事件中的呼叫状态',
  `COUNTRY` varchar(50) DEFAULT NULL COMMENT '来电国家',
  `PROVINCE` varchar(50) DEFAULT NULL COMMENT '来电号码归属省份',
  `CITY` varchar(50) DEFAULT NULL COMMENT '来电号码归属城市',
  `ISP` varchar(50) DEFAULT NULL COMMENT '来电号码运营商',
  `CONTACTSID` varchar(50) DEFAULT NULL COMMENT '联系人ID',
  `EXTENTION` varchar(50) DEFAULT NULL COMMENT '分机ID',
  `HOSTID` varchar(50) DEFAULT NULL COMMENT 'PBX服务器ID',
  `CALLTYPE` varchar(50) DEFAULT NULL COMMENT '呼叫方向类型 | 计费类型',
  `CALLDIR` varchar(50) DEFAULT NULL COMMENT '我方呼叫方向',
  `OTHERDIR` varchar(50) DEFAULT NULL COMMENT '对方呼叫方向',
  `BRIDGEID` varchar(50) DEFAULT NULL COMMENT '桥接ID',
  `BRIDRE` tinyint(4) DEFAULT NULL COMMENT '是否有桥接',
  `DISCALLER` varchar(50) DEFAULT NULL COMMENT '主叫分机号',
  `DISCALLED` varchar(50) DEFAULT NULL COMMENT '被叫分机号',
  `SATISF` tinyint(4) DEFAULT NULL COMMENT '是否进行满意度调查',
  `SATISFACTION` varchar(50) DEFAULT NULL COMMENT '服务小结',
  `SATISFDATE` datetime DEFAULT NULL COMMENT '满意度调查提交时间',
  `ORGAN` varchar(50) DEFAULT NULL COMMENT '所属组织机构ID'
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='坐席绩效表';

-- ----------------------------
-- Table structure for uk_callcenter_acl
-- ----------------------------
DROP TABLE IF EXISTS `uk_callcenter_acl`;
CREATE TABLE `uk_callcenter_acl` (
  `id` varchar(32) NOT NULL COMMENT '主键ID',
  `creater` varchar(32) DEFAULT NULL COMMENT '创建人',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `updatetime` datetime DEFAULT NULL COMMENT '更新时间',
  `name` varchar(100) DEFAULT NULL COMMENT '名称',
  `orgi` varchar(100) DEFAULT NULL COMMENT '租户ID',
  `hostid` varchar(32) DEFAULT NULL COMMENT 'PBX服务器ID',
  `type` varchar(32) DEFAULT NULL COMMENT '类型',
  `strategy` text COMMENT '策略内容',
  `defaultvalue` varchar(50) DEFAULT NULL COMMENT '默认值',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='呼叫中心ACL表';

-- ----------------------------
-- Table structure for uk_callcenter_event
-- ----------------------------
DROP TABLE IF EXISTS `uk_callcenter_event`;
CREATE TABLE `uk_callcenter_event` (
  `ID` varchar(100) NOT NULL COMMENT '主键ID',
  `NAME` varchar(50) DEFAULT NULL COMMENT '名称',
  `CODE` varchar(50) DEFAULT NULL COMMENT '代码',
  `CREATETIME` datetime DEFAULT NULL COMMENT '创建时间',
  `CREATER` varchar(32) DEFAULT NULL COMMENT '创建人',
  `UPDATETIME` datetime DEFAULT NULL COMMENT '更新时间',
  `ORGI` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `organ` varchar(50) DEFAULT NULL COMMENT '部门',
  `organid` varchar(32) DEFAULT NULL COMMENT '部门ID',
  `USERNAME` varchar(50) DEFAULT NULL COMMENT '用户名',
  `SOURCE` varchar(50) DEFAULT NULL COMMENT '来源',
  `ANSWER` varchar(50) DEFAULT NULL COMMENT '应答时间',
  `scurrent` tinyint(4) DEFAULT NULL COMMENT '是否当前通话',
  `INIT` tinyint(4) DEFAULT NULL COMMENT '初始通话',
  `CALLER` varchar(50) DEFAULT NULL COMMENT '呼叫发起号码',
  `CALLING` varchar(50) DEFAULT NULL COMMENT '呼叫对象',
  `CALLED` varchar(50) DEFAULT NULL COMMENT '被叫号码',
  `AGENTYPE` varchar(50) DEFAULT NULL COMMENT '坐席类型',
  `QUENE` varchar(50) DEFAULT NULL COMMENT '队列名称',
  `ANI` varchar(50) DEFAULT NULL COMMENT '主叫号码',
  `TOUSER` varchar(50) DEFAULT NULL COMMENT '目标用户',
  `DIRECTION` varchar(50) DEFAULT NULL COMMENT '呼叫方向',
  `STATE` varchar(50) DEFAULT NULL COMMENT '状态',
  `AGENT` varchar(50) DEFAULT NULL COMMENT '坐席工号',
  `agentname` varchar(255) DEFAULT NULL COMMENT '坐席名字',
  `ACTION` varchar(50) DEFAULT NULL COMMENT '事件动作',
  `HOST` varchar(50) DEFAULT NULL COMMENT '时间主机',
  `IPADDR` varchar(50) DEFAULT NULL COMMENT '主机IP',
  `LOCALDATETIME` varchar(50) DEFAULT NULL COMMENT '时间发起时间',
  `STATUS` varchar(50) DEFAULT NULL COMMENT '状态代码',
  `TIME` decimal(20,0) DEFAULT NULL COMMENT '时间秒值',
  `STARTTIME` datetime DEFAULT NULL COMMENT '通话开始时间',
  `ENDTIME` datetime DEFAULT NULL COMMENT '通话结束时间',
  `DURATION` int(11) DEFAULT NULL COMMENT '通话时长',
  `INSIDE` tinyint(4) DEFAULT NULL COMMENT '内线',
  `MISSCALL` tinyint(4) DEFAULT NULL COMMENT '是否漏话',
  `srecord` tinyint(4) DEFAULT NULL COMMENT '是否录音',
  `RECORDTIME` int(11) DEFAULT NULL COMMENT '录音时长',
  `STARTRECORD` datetime DEFAULT NULL COMMENT '开始录音时间',
  `ENDRECORD` datetime DEFAULT NULL COMMENT '结束录音时间',
  `ANSWERTIME` datetime DEFAULT NULL COMMENT '应答时间',
  `RINGDURATION` int(11) DEFAULT NULL COMMENT '振铃时长',
  `SERVICESUMMARY` tinyint(4) DEFAULT NULL COMMENT '是否记录服务小结',
  `SERVICEID` varchar(32) DEFAULT NULL COMMENT '服务记录ID',
  `RECORDFILE` varchar(255) DEFAULT NULL COMMENT '录音文件名',
  `CALLBACK` tinyint(4) DEFAULT NULL COMMENT '回呼',
  `CCQUENE` varchar(50) DEFAULT NULL COMMENT '转接队列',
  `SERVICESTATUS` varchar(20) DEFAULT NULL COMMENT '当前呼叫状态',
  `CHANNELSTATUS` varchar(50) DEFAULT NULL COMMENT '事件中的呼叫状态',
  `COUNTRY` varchar(50) DEFAULT NULL COMMENT '来电国家',
  `PROVINCE` varchar(50) DEFAULT NULL COMMENT '来电号码归属省份',
  `CITY` varchar(50) DEFAULT NULL COMMENT '来电归属号码城市',
  `ISP` varchar(50) DEFAULT NULL COMMENT '来电号码运营商',
  `VOICECALLED` varchar(50) DEFAULT NULL COMMENT '语音呼叫',
  `CONTACTSID` varchar(32) DEFAULT NULL COMMENT '联系人ID',
  `EXTENTION` varchar(32) DEFAULT NULL COMMENT '分机ID',
  `HOSTID` varchar(32) DEFAULT NULL COMMENT 'PBX服务器ID',
  `CALLTYPE` varchar(20) DEFAULT NULL COMMENT '呼叫方向类型|计费类型',
  `CALLDIR` varchar(30) DEFAULT NULL COMMENT '呼叫方向',
  `OTHERDIR` varchar(30) DEFAULT NULL COMMENT '对边呼叫方向',
  `OTHERLEGDEST` varchar(50) DEFAULT NULL COMMENT '呼叫另一方号码',
  `BRIDGEID` varchar(100) DEFAULT NULL COMMENT '桥接ID',
  `BRIDGE` tinyint(4) DEFAULT NULL COMMENT '是否有桥接',
  `RECORDFILENAME` varchar(100) DEFAULT NULL COMMENT '录音文件名',
  `DISCALLER` varchar(50) DEFAULT NULL COMMENT '显示主叫',
  `DISCALLED` varchar(50) DEFAULT NULL COMMENT '显示被叫',
  `SATISF` tinyint(4) DEFAULT '0' COMMENT '满意度',
  `SATISFACTION` varchar(32) DEFAULT NULL COMMENT '满意度结果',
  `SATISFDATE` datetime DEFAULT NULL COMMENT '满意度时间',
  `datestr` varchar(32) DEFAULT '0' COMMENT '坐席通话日期（yyyy-MM-dd）用于每小时通话数量折线图',
  `hourstr` varchar(32) DEFAULT '0' COMMENT '坐席通话时间小时（HH）用于每小时通话数量折线图',
  `taskid` varchar(32) DEFAULT NULL COMMENT '任务ID',
  `actid` varchar(32) DEFAULT NULL COMMENT '活动ID',
  `batid` varchar(32) DEFAULT NULL COMMENT '批次ID',
  `dataid` varchar(32) DEFAULT NULL COMMENT '数据ID',
  `statustype` varchar(32) DEFAULT NULL COMMENT '号码隐藏状态',
  `disphonenum` varchar(32) DEFAULT NULL COMMENT '号码',
  `distype` varchar(32) DEFAULT NULL COMMENT '显示类型',
  `nameid` varchar(50) DEFAULT NULL COMMENT '名单ID',
  `siptrunk` varchar(32) DEFAULT NULL COMMENT '拨打的网关',
  `prefix` tinyint(4) DEFAULT '0' COMMENT '是否在号码前加拨0',
  `dialplan` varchar(32) DEFAULT NULL COMMENT '呼叫计划ID',
  `callid` varchar(100) DEFAULT NULL COMMENT 'FreeSwitch通话ID',
  `voicechannel` varchar(255) DEFAULT NULL COMMENT '语音渠道标识',
  `recordingfile` varchar(150) DEFAULT NULL COMMENT '录音文件标识',
  PRIMARY KEY (`ID`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='通话记录表';

-- ----------------------------
-- Table structure for uk_callcenter_extention
-- ----------------------------
DROP TABLE IF EXISTS `uk_callcenter_extention`;
CREATE TABLE `uk_callcenter_extention` (
  `id` varchar(32) NOT NULL COMMENT '主键ID',
  `creater` varchar(32) DEFAULT NULL COMMENT '创建人',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `updatetime` datetime DEFAULT NULL COMMENT '更新时间',
  `extention` varchar(100) DEFAULT NULL COMMENT '分机号',
  `orgi` varchar(100) DEFAULT NULL COMMENT '租户ID',
  `hostid` varchar(100) DEFAULT NULL COMMENT 'PBX服务ID',
  `agentno` varchar(50) DEFAULT NULL COMMENT '坐席工号',
  `password` varchar(100) DEFAULT NULL COMMENT '密码',
  `callout` tinyint(4) DEFAULT NULL COMMENT '允许呼出',
  `playnum` tinyint(4) DEFAULT NULL COMMENT '播报工号',
  `srecord` tinyint(4) DEFAULT NULL,
  `extype` varchar(50) DEFAULT NULL COMMENT '分机类型',
  `description` varchar(255) DEFAULT NULL COMMENT '描述',
  `subtype` varchar(50) DEFAULT NULL COMMENT '分机类型',
  `mediapath` varchar(255) DEFAULT NULL COMMENT '播报工号语音文件',
  `afterprocess` tinyint(4) DEFAULT '0' COMMENT '坐席通话后启用后处理功能',
  `siptrunk` varchar(50) DEFAULT NULL,
  `enableai` tinyint(4) DEFAULT '0' COMMENT '启用AI机器人',
  `aiid` varchar(32) DEFAULT NULL COMMENT 'AI机器人',
  `sceneid` varchar(32) DEFAULT NULL COMMENT '启用场景配置',
  `welcomemsg` text COMMENT '机器人欢迎语',
  `waitmsg` text COMMENT '机器人等待提示语',
  `tipmessage` text COMMENT '机器人提示客户说话',
  `asrrecordpath` varchar(255) DEFAULT NULL COMMENT 'ASR结果路径',
  `ttsrecordpath` varchar(255) DEFAULT NULL COMMENT 'ASR结果路径',
  `errormessage` varchar(255) DEFAULT NULL COMMENT '异常提示消息',
  `enablewebrtc` tinyint(4) DEFAULT '0' COMMENT '启用WebRTC',
  `bustype` varchar(32) DEFAULT NULL COMMENT '业务类型（电销sale/问卷quesurvey）',
  `proid` varchar(32) DEFAULT NULL COMMENT '（产品ID）',
  `queid` varchar(32) DEFAULT NULL COMMENT '（问卷ID）',
  `aitype` varchar(32) DEFAULT NULL COMMENT '机器人类型（smartai/quesurvey）',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='分机信息表';

-- ----------------------------
-- Table structure for uk_callcenter_ivr
-- ----------------------------
DROP TABLE IF EXISTS `uk_callcenter_ivr`;
CREATE TABLE `uk_callcenter_ivr` (
  `id` varchar(32) NOT NULL COMMENT '主键ID',
  `creater` varchar(32) DEFAULT NULL COMMENT '创建人ID',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `updatetime` datetime DEFAULT NULL COMMENT '更新时间',
  `name` varchar(100) DEFAULT NULL COMMENT '名称',
  `orgi` varchar(100) DEFAULT NULL COMMENT '租户ID',
  `hostid` varchar(32) DEFAULT NULL COMMENT 'PBX服务器ID',
  `type` varchar(32) DEFAULT NULL COMMENT '类型',
  `greetlong` varchar(100) DEFAULT NULL COMMENT '欢迎提示语音',
  `greetshort` varchar(100) DEFAULT NULL COMMENT '欢迎提示短语音',
  `invalidsound` varchar(100) DEFAULT NULL COMMENT '无效输入提示语音',
  `exitsound` varchar(100) DEFAULT NULL COMMENT '离开语音',
  `confirmmacro` varchar(50) DEFAULT NULL COMMENT '确认宏指令',
  `confirmkey` varchar(50) DEFAULT NULL COMMENT '确认按键',
  `ttsengine` varchar(20) DEFAULT NULL COMMENT 'TTS引擎',
  `ttsvoice` varchar(50) DEFAULT NULL COMMENT 'TTS语音',
  `confirmattempts` varchar(50) DEFAULT NULL COMMENT '确认提示消息',
  `timeout` int(11) DEFAULT NULL COMMENT '超时时间',
  `interdigittimeout` int(11) DEFAULT NULL COMMENT '呼叫等待超时',
  `maxfailures` int(11) DEFAULT NULL COMMENT '最大失败次数',
  `maxtimeouts` int(11) DEFAULT NULL COMMENT '最大外呼次数',
  `digitlen` int(11) DEFAULT NULL COMMENT '数字长度',
  `menucontent` text COMMENT 'IVR菜单内容',
  `action` varchar(50) DEFAULT NULL COMMENT '指令',
  `digits` varchar(50) DEFAULT NULL COMMENT '拨号键',
  `param` varchar(255) DEFAULT NULL COMMENT '参数',
  `parentid` varchar(32) DEFAULT NULL COMMENT '上级ID',
  `extentionid` varchar(32) DEFAULT NULL COMMENT '分机ID',
  `enableai` tinyint(4) DEFAULT '0' COMMENT '启用AI机器人',
  `aiid` varchar(32) DEFAULT NULL COMMENT 'AI机器人',
  `sceneid` varchar(32) DEFAULT NULL COMMENT '启用场景配置',
  `welcomemsg` text COMMENT '机器人欢迎语',
  `waitmsg` text COMMENT '机器人等待提示语',
  `tipmessage` text COMMENT '机器人提示客户说话',
  `asrrecordpath` varchar(255) DEFAULT NULL COMMENT 'ASR结果路径',
  `ttsrecordpath` varchar(255) DEFAULT NULL COMMENT 'ASR结果路径',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='IVR菜单表';

-- ----------------------------
-- Table structure for uk_callcenter_media
-- ----------------------------
DROP TABLE IF EXISTS `uk_callcenter_media`;
CREATE TABLE `uk_callcenter_media` (
  `id` varchar(32) NOT NULL COMMENT '主键ID',
  `creater` varchar(32) DEFAULT NULL COMMENT '创建人ID',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `updatetime` datetime DEFAULT NULL COMMENT '更新时间',
  `name` varchar(100) DEFAULT NULL COMMENT '名称',
  `orgi` varchar(100) DEFAULT NULL COMMENT '租户ID',
  `hostid` varchar(32) DEFAULT NULL COMMENT 'PBX服务ID',
  `type` varchar(32) DEFAULT NULL COMMENT '类型',
  `filename` varchar(255) DEFAULT NULL COMMENT '文件名',
  `content` varchar(50) DEFAULT NULL COMMENT '文件类型',
  `filelength` int(11) DEFAULT NULL COMMENT '语音文件长度',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='媒体资源表';

-- ----------------------------
-- Table structure for uk_callcenter_pbxhost
-- ----------------------------
DROP TABLE IF EXISTS `uk_callcenter_pbxhost`;
CREATE TABLE `uk_callcenter_pbxhost` (
  `id` varchar(32) NOT NULL COMMENT '主键ID',
  `creater` varchar(32) DEFAULT NULL COMMENT '创建人',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `updatetime` datetime DEFAULT NULL COMMENT '更新时间',
  `name` varchar(100) NOT NULL COMMENT '名称',
  `orgi` varchar(100) NOT NULL COMMENT '租户ID',
  `organ` varchar(32) NOT NULL COMMENT '所属组织机构',
  `hostname` varchar(100) NOT NULL COMMENT '主机名',
  `port` int(11) NOT NULL COMMENT 'FreeSWITCH ESL端口',
  `apiport` int(11) NOT NULL COMMENT 'Chatopera Switch API端口',
  `password` varchar(100) DEFAULT NULL COMMENT '密码',
  `ipaddr` varchar(32) DEFAULT NULL COMMENT 'IP地址',
  `callbacknumber` varchar(50) DEFAULT NULL COMMENT '回呼号码',
  `autoanswer` tinyint(4) DEFAULT NULL COMMENT '启用自动接听',
  `callcenter` tinyint(4) DEFAULT NULL COMMENT '启用呼叫中心功能',
  `recordpath` varchar(100) DEFAULT NULL COMMENT '录音文件位置',
  `ivrpath` varchar(100) DEFAULT NULL COMMENT 'IVR文件位置',
  `fspath` varchar(100) DEFAULT NULL COMMENT 'FS安装路径',
  `device` varchar(50) DEFAULT NULL COMMENT '语音设备类型',
  `callbacktype` varchar(32) DEFAULT NULL COMMENT '回呼送号号码',
  `sipautoanswer` tinyint(4) DEFAULT NULL COMMENT 'SIP自动应答',
  `abscodec` varchar(50) DEFAULT NULL COMMENT '通信编码',
  `enableai` tinyint(4) DEFAULT NULL COMMENT '启用机器人',
  `aiid` varchar(32) DEFAULT NULL COMMENT '机器人ID',
  `sceneid` varchar(32) DEFAULT NULL COMMENT '场景ID',
  `welcomemsg` text COMMENT '机器人欢迎语',
  `waitmsg` text COMMENT '机器人等待提示语',
  `tipmessage` text COMMENT '机器人提示客户说话',
  `asrrecordpath` varchar(255) DEFAULT NULL COMMENT 'ASR结果路径',
  `ttsrecordpath` varchar(255) DEFAULT NULL COMMENT 'ASR结果路径',
  `afterprocess` tinyint(4) DEFAULT '0' COMMENT '坐席通话后启用后处理功能',
  `enablewebrtc` tinyint(4) DEFAULT '0' COMMENT '启用WebRTC',
  `webrtcaddress` varchar(100) DEFAULT NULL COMMENT 'WebRTC地址',
  `webrtcport` int(11) NOT NULL COMMENT 'WebRTC端口',
  `webrtcssl` tinyint(4) DEFAULT '0' COMMENT 'WebRTC启用SSL',
  `dissipphone` tinyint(4) DEFAULT '0' COMMENT '外呼隐藏话机上的号码',
  `syncstatus` varchar(32) DEFAULT NULL COMMENT '同步执行状态',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='FS服务器信息';

-- ----------------------------
-- Table structure for uk_callcenter_router
-- ----------------------------
DROP TABLE IF EXISTS `uk_callcenter_router`;
CREATE TABLE `uk_callcenter_router` (
  `id` varchar(32) NOT NULL COMMENT '主键ID',
  `creater` varchar(32) DEFAULT NULL COMMENT '创建人',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `updatetime` datetime DEFAULT NULL COMMENT '更新时间',
  `name` varchar(100) DEFAULT NULL COMMENT '名称',
  `orgi` varchar(100) DEFAULT NULL COMMENT '租户ID',
  `hostid` varchar(32) DEFAULT NULL COMMENT 'PBX服务器ID',
  `type` varchar(32) DEFAULT NULL COMMENT '类型',
  `regex` varchar(255) DEFAULT NULL COMMENT '匹配正则',
  `allow` tinyint(4) DEFAULT NULL COMMENT '允许',
  `falsebreak` tinyint(4) DEFAULT NULL COMMENT '异常终止',
  `routerinx` int(11) DEFAULT NULL COMMENT '编号',
  `routercontent` text COMMENT '路由规则',
  `field` varchar(50) DEFAULT NULL COMMENT '字段名称',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='拨号计划表';

-- ----------------------------
-- Table structure for uk_callcenter_siptrunk
-- ----------------------------
DROP TABLE IF EXISTS `uk_callcenter_siptrunk`;
CREATE TABLE `uk_callcenter_siptrunk` (
  `id` varchar(32) NOT NULL COMMENT '组件ID',
  `creater` varchar(32) DEFAULT NULL COMMENT '创建人',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `updatetime` datetime DEFAULT NULL COMMENT '更新时间',
  `name` varchar(100) DEFAULT NULL COMMENT 'SIP中继名称',
  `orgi` varchar(100) DEFAULT NULL COMMENT '租户ID',
  `hostid` varchar(32) DEFAULT NULL COMMENT 'PBX服务器ID',
  `type` varchar(32) DEFAULT NULL COMMENT '类型',
  `sipcontent` text COMMENT 'SIP配置内容',
  `sipserver` varchar(50) DEFAULT NULL COMMENT '服务器地址',
  `extention` varchar(50) DEFAULT NULL COMMENT '转分机号',
  `outnumber` varchar(50) DEFAULT NULL COMMENT '出局号码',
  `prefix` varchar(50) DEFAULT NULL COMMENT '前缀',
  `port` int(11) DEFAULT NULL COMMENT '端口',
  `exptime` int(11) DEFAULT NULL COMMENT '超时时长',
  `retry` int(11) DEFAULT NULL COMMENT '重试次数',
  `register` tinyint(4) DEFAULT NULL COMMENT '是否注册',
  `fromuser` tinyint(4) DEFAULT NULL COMMENT '是否添加FROM',
  `transprotocol` tinyint(4) DEFAULT NULL COMMENT '协议',
  `username` varchar(50) DEFAULT NULL COMMENT '用户名',
  `authuser` varchar(50) DEFAULT NULL COMMENT '认证用户名',
  `password` varchar(50) DEFAULT NULL COMMENT '密码',
  `protocol` varchar(50) DEFAULT NULL COMMENT '协议',
  `heartbeat` int(11) DEFAULT NULL COMMENT '心跳时长',
  `dtmf` varchar(20) DEFAULT NULL COMMENT 'DTMF协议',
  `province` varchar(50) DEFAULT NULL COMMENT '省份',
  `city` varchar(50) DEFAULT NULL COMMENT '城市',
  `defaultsip` tinyint(4) DEFAULT '0' COMMENT '默认网关',
  `title` varchar(50) DEFAULT NULL COMMENT '标题',
  `busyext` varchar(50) DEFAULT NULL COMMENT '坐席忙的时候转到号码',
  `notready` varchar(50) DEFAULT NULL COMMENT '坐席不在线的时候转到号码',
  `noname` varchar(50) DEFAULT NULL COMMENT '未找到名单或未分配的时候转到号码',
  `enablecallagent` tinyint(4) DEFAULT '0' COMMENT '坐席不在线转手机',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='SIP网关信息表';

-- ----------------------------
-- Table structure for uk_callcenter_skill
-- ----------------------------
DROP TABLE IF EXISTS `uk_callcenter_skill`;
CREATE TABLE `uk_callcenter_skill` (
  `id` varchar(32) NOT NULL COMMENT '主键ID',
  `creater` varchar(32) DEFAULT NULL COMMENT '创建人ID',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `updatetime` datetime DEFAULT NULL COMMENT '更新时间',
  `orgi` varchar(100) DEFAULT NULL COMMENT '租户ID',
  `name` varchar(100) DEFAULT NULL COMMENT '名称',
  `skill` varchar(50) DEFAULT NULL COMMENT '技能组名称',
  `password` varchar(100) DEFAULT NULL COMMENT '密码',
  `quene` varchar(100) DEFAULT NULL COMMENT '队列名称',
  `hostid` varchar(32) DEFAULT NULL COMMENT 'PBX服务器ID',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='电话技能组表';

-- ----------------------------
-- Table structure for uk_callcenter_skillext
-- ----------------------------
DROP TABLE IF EXISTS `uk_callcenter_skillext`;
CREATE TABLE `uk_callcenter_skillext` (
  `id` varchar(32) NOT NULL DEFAULT '主键ID' COMMENT '主键ID',
  `creater` varchar(32) DEFAULT NULL COMMENT '创建人',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `updatetime` datetime DEFAULT NULL COMMENT '更新时间',
  `name` varchar(100) DEFAULT NULL COMMENT '名称',
  `orgi` varchar(100) DEFAULT NULL COMMENT '租户ID',
  `skillid` varchar(32) DEFAULT NULL COMMENT '技能组ID',
  `extention` varchar(32) DEFAULT NULL COMMENT '分机',
  `hostid` varchar(32) DEFAULT NULL COMMENT 'PBX服务器ID',
  `type` varchar(32) DEFAULT NULL COMMENT '类型',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='技能组对应表';

-- ----------------------------
-- Table structure for uk_chat_message
-- ----------------------------
DROP TABLE IF EXISTS `uk_chat_message`;
CREATE TABLE `uk_chat_message` (
  `type` varchar(100) DEFAULT '' COMMENT '类型',
  `id` varchar(32) NOT NULL DEFAULT '' COMMENT '主键ID',
  `calltype` varchar(32) DEFAULT NULL COMMENT '对话方向',
  `contextid` varchar(50) DEFAULT NULL COMMENT '会话ID',
  `usession` varchar(100) DEFAULT NULL COMMENT '会话ID',
  `touser` varchar(50) DEFAULT NULL COMMENT '目标用户',
  `channel` varchar(32) DEFAULT NULL COMMENT '渠道',
  `appid` varchar(50) DEFAULT NULL COMMENT 'SNSID',
  `userid` varchar(100) DEFAULT '' COMMENT '用户名',
  `message` text COMMENT '消息内容',
  `msgtype` varchar(100) DEFAULT '' COMMENT '消息类型',
  `orgi` varchar(100) DEFAULT '' COMMENT '租户ID',
  `msgid` varchar(100) DEFAULT '' COMMENT '消息ID（微信）',
  `expmsg` text COMMENT '原始消息',
  `name` varchar(255) DEFAULT NULL COMMENT '名称',
  `createtime` varchar(50) DEFAULT NULL COMMENT '创建时间',
  `creater` varchar(255) DEFAULT NULL COMMENT '创建人',
  `updatetime` decimal(20,0) DEFAULT NULL COMMENT '修改时间',
  `update_user` varchar(255) DEFAULT NULL COMMENT '修改人',
  `username` varchar(255) DEFAULT NULL COMMENT '用户名',
  `assignedto` varchar(255) DEFAULT NULL COMMENT '分配目标用户',
  `wfstatus` varchar(255) DEFAULT NULL COMMENT '流程状态',
  `shares` varchar(255) DEFAULT NULL COMMENT '分享给',
  `owner` varchar(255) DEFAULT NULL COMMENT '所属人',
  `datadept` varchar(255) DEFAULT NULL COMMENT '创建人部门',
  `batid` varchar(32) DEFAULT NULL COMMENT '批次ID',
  `model` varchar(32) DEFAULT '' COMMENT '消息所属组件',
  `chatype` varchar(32) DEFAULT NULL COMMENT '对话类型',
  `agentserviceid` varchar(32) DEFAULT NULL COMMENT '坐席服务ID',
  `mediaid` varchar(255) DEFAULT NULL COMMENT '媒体文件ID（微信）',
  `locx` varchar(20) DEFAULT NULL COMMENT '地理位置',
  `locy` varchar(20) DEFAULT NULL COMMENT '地理位置',
  `duration` varchar(30) DEFAULT NULL COMMENT '会话时长',
  `scale` varchar(10) DEFAULT NULL COMMENT '地图级别',
  `filename` varchar(255) DEFAULT NULL COMMENT '文件名',
  `filesize` int(11) DEFAULT NULL COMMENT '文件尺寸',
  `attachmentid` varchar(32) DEFAULT NULL COMMENT '附件ID',
  `lastagentmsgtime` datetime DEFAULT NULL COMMENT '最近一次坐席发送消息时间',
  `agentreplytime` int(11) DEFAULT NULL COMMENT '坐席回复消息时间',
  `lastmsgtime` datetime DEFAULT NULL COMMENT '访客最近一次发送消息时间',
  `agentreplyinterval` int(11) DEFAULT NULL COMMENT '坐席回复消息时间',
  `sessionid` varchar(50) DEFAULT NULL COMMENT '会话ID',
  `cooperation` tinyint(4) DEFAULT NULL COMMENT '合并消息',
  `datastatus` tinyint(4) DEFAULT '0' COMMENT '数据状态（已删除/未删除）',
  `intervented` tinyint(4) DEFAULT '0' COMMENT '是否是会话监控发出的干预消息',
  `supervisorname` varchar(100) DEFAULT NULL COMMENT '会话监控人员的名字',
  `aiid` varchar(32) DEFAULT '0' COMMENT '机器人ID',
  `topic` tinyint(4) DEFAULT '0' COMMENT '是否命中知识库',
  `topicid` varchar(32) DEFAULT NULL COMMENT '命中知识库ID',
  `topicatid` varchar(32) DEFAULT NULL COMMENT '命中知识库分类ID',
  `aichat` tinyint(4) DEFAULT '0' COMMENT '是否在和AI对话',
  `suggestmsg` text COMMENT '推荐的提示信息',
  `islabel` BIT(1) NOT NULL DEFAULT b'0' COMMENT '是否添加标记',
  PRIMARY KEY (`id`) USING BTREE,
  KEY `sessionid` (`usession`) USING BTREE,
  KEY `orgi` (`orgi`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='坐席对话表';

-- ----------------------------
-- Table structure for uk_columnproperties
-- ----------------------------
DROP TABLE IF EXISTS `uk_columnproperties`;
CREATE TABLE `uk_columnproperties` (
  `id` varchar(32) NOT NULL COMMENT '主键ID',
  `format` varchar(255) DEFAULT NULL COMMENT '格式化',
  `prefix` varchar(255) DEFAULT NULL COMMENT '前缀',
  `width` varchar(255) DEFAULT NULL COMMENT '组件宽度',
  `suffix` varchar(255) DEFAULT NULL COMMENT '组件后缀',
  `font` varchar(255) DEFAULT NULL COMMENT '字体',
  `colname` varchar(255) DEFAULT NULL COMMENT '字段名称',
  `border` varchar(255) DEFAULT NULL COMMENT '组件宽度',
  `decimalCount` varchar(255) DEFAULT NULL COMMENT '数字格式化',
  `sepsymbol` varchar(255) DEFAULT NULL COMMENT '组件标签',
  `alignment` varchar(255) DEFAULT NULL COMMENT '对齐方式',
  `fontStyle` varchar(255) DEFAULT NULL COMMENT '字体样式',
  `fontColor` varchar(255) DEFAULT NULL COMMENT '字体颜色',
  `paramName` varchar(255) DEFAULT NULL COMMENT '参数名称',
  `orgi` varchar(255) DEFAULT NULL COMMENT '租户ID',
  `dataid` varchar(255) DEFAULT NULL COMMENT '数据ID',
  `modelid` varchar(255) DEFAULT NULL COMMENT '组件ID',
  `dataname` varchar(255) DEFAULT NULL COMMENT '名称',
  `cur` varchar(255) DEFAULT NULL COMMENT '位置',
  `hyp` varchar(255) DEFAULT NULL COMMENT '超链',
  `timeFormat` varchar(255) DEFAULT NULL COMMENT '时间格式化',
  `title` varchar(255) DEFAULT NULL COMMENT '标题',
  `SORTINDEX` int(11) DEFAULT NULL COMMENT '排序位置',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='报表字段映射表';

-- ----------------------------
-- Table structure for uk_consult_invite
-- ----------------------------
DROP TABLE IF EXISTS `uk_consult_invite`;
CREATE TABLE `uk_consult_invite` (
  `id` varchar(32) NOT NULL COMMENT '主键ID',
  `impid` varchar(32) DEFAULT NULL COMMENT '批次ID',
  `orgi` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `owner` varchar(32) DEFAULT NULL COMMENT '数据拥有人',
  `processid` varchar(32) DEFAULT NULL COMMENT '流程ID',
  `shares` varchar(32) DEFAULT NULL COMMENT '分享给',
  `update_time` datetime DEFAULT NULL COMMENT '更新时间',
  `update_user` varchar(32) DEFAULT NULL COMMENT '修改人',
  `username` varchar(32) DEFAULT NULL COMMENT '用户名',
  `wfstatus` varchar(32) DEFAULT NULL COMMENT '流程状态',
  `consult_invite_model` varchar(32) DEFAULT NULL COMMENT '邀请模式',
  `consult_invite_content` varchar(255) DEFAULT NULL COMMENT '邀请框文本',
  `consult_invite_position` varchar(32) DEFAULT NULL COMMENT '邀请框位置',
  `consult_invite_color` varchar(32) DEFAULT NULL COMMENT '邀请框颜色',
  `consult_invite_right` int(11) DEFAULT NULL COMMENT '邀请框距右边位置',
  `consult_invite_left` int(11) DEFAULT NULL COMMENT '邀请框距左侧',
  `consult_invite_bottom` int(11) DEFAULT NULL COMMENT '邀请框距下边位置',
  `consult_invite_top` int(11) DEFAULT NULL COMMENT '邀请框距顶部位置',
  `create_time` datetime DEFAULT NULL COMMENT '创建时间',
  `name` varchar(50) DEFAULT NULL COMMENT '名称',
  `consult_invite_width` int(32) DEFAULT NULL COMMENT '邀请框宽度',
  `consult_invite_poptype` varchar(32) DEFAULT NULL COMMENT '邀请框悬浮位置',
  `consult_invite_fontsize` int(32) DEFAULT NULL COMMENT '邀请框文本字体',
  `consult_invite_fontstyle` varchar(32) DEFAULT NULL COMMENT '邀请框文本样式',
  `consult_invite_fontcolor` varchar(32) DEFAULT NULL COMMENT '邀请框文本颜色',
  `consult_invite_interval` int(32) DEFAULT NULL COMMENT '邀请框弹出频率',
  `consult_invite_repeat` varchar(32) DEFAULT NULL COMMENT '邀请框背景平铺',
  `consult_invite_hight` int(32) DEFAULT NULL COMMENT '邀请框高度',
  `snsaccountid` varchar(56) DEFAULT NULL COMMENT 'SNSID',
  `consult_vsitorbtn_position` varchar(32) DEFAULT NULL COMMENT '悬浮图标位置',
  `consult_vsitorbtn_content` varchar(32) DEFAULT NULL COMMENT '悬浮框文本',
  `consult_vsitorbtn_right` varchar(32) DEFAULT NULL COMMENT '悬浮框距右侧位置',
  `consult_vsitorbtn_left` varchar(32) DEFAULT NULL COMMENT '悬浮框距左侧位置',
  `consult_vsitorbtn_top` varchar(32) DEFAULT NULL COMMENT '悬浮框距顶部',
  `consult_vsitorbtn_color` varchar(32) DEFAULT NULL COMMENT '悬浮框颜色',
  `consult_vsitorbtn_model` varchar(32) DEFAULT NULL COMMENT '悬浮框模式',
  `consult_vsitorbtn_bottom` varchar(32) DEFAULT NULL COMMENT '悬浮框距底部',
  `consult_invite_backimg` varchar(32) DEFAULT NULL COMMENT '悬浮框背景图片',
  `datadept` varchar(32) DEFAULT NULL COMMENT '数据部门',
  `agent_online` varchar(32) DEFAULT NULL COMMENT '坐席在线',
  `consult_dialog_color` varchar(32) DEFAULT NULL COMMENT '对话框颜色',
  `consult_dialog_logo` varchar(100) DEFAULT NULL COMMENT '对话框LOGO',
  `consult_dialog_headimg` varchar(100) DEFAULT NULL COMMENT '对话框头像',
  `consult_vsitorbtn_display` int(11) DEFAULT NULL COMMENT '显示按钮',
  `dialog_name` varchar(100) DEFAULT NULL COMMENT '对话显示名称',
  `dialog_address` varchar(100) DEFAULT NULL COMMENT '对话框地址',
  `dialog_phone` varchar(32) DEFAULT NULL COMMENT '对话框电话号码',
  `dialog_mail` varchar(100) DEFAULT NULL COMMENT '对话框邮件',
  `dialog_introduction` text COMMENT '对话框介绍',
  `dialog_message` text COMMENT '对话框欢迎信息',
  `dialog_ad` varchar(100) DEFAULT NULL COMMENT '对话框广告',
  `consult_invite_enable` tinyint(4) DEFAULT NULL COMMENT '启用邀请框',
  `consult_invite_accept` varchar(50) DEFAULT NULL COMMENT '邀请框统一按钮文本',
  `consult_invite_later` varchar(50) DEFAULT NULL COMMENT '延迟弹出邀请框',
  `consult_invite_delay` int(11) DEFAULT NULL COMMENT '邀请框延迟时间',
  `consult_invite_bg` varchar(100) DEFAULT NULL COMMENT '邀请框背景图片',
  `leavemessage` tinyint(4) DEFAULT NULL COMMENT '留言提示文本',
  `lvmname` tinyint(4) DEFAULT NULL COMMENT '留言框显示名称字段',
  `lvmphone` tinyint(4) DEFAULT NULL COMMENT '留言卡电话号码字段',
  `lvmemail` tinyint(4) DEFAULT NULL COMMENT '留言卡Email字段',
  `lvmaddress` tinyint(4) DEFAULT NULL COMMENT '留言卡地址字段',
  `lvmqq` tinyint(4) DEFAULT '0' COMMENT '留言框QQ',
  `lvmcontent` tinyint(4) DEFAULT NULL COMMENT '留言卡留言内容字段',
  `workinghours` text COMMENT '工作时间段',
  `lvmopentype` varchar(32) DEFAULT NULL COMMENT '留言卡弹出模式',
  `skill` tinyint(4) DEFAULT '0' COMMENT '技能组',
  `notinwhmsg` text COMMENT '非工作时间段提示文本',
  `consult_skill_fixed` tinyint(4) DEFAULT '0' COMMENT '是否绑定单一技能组',
  `consult_skill_fixed_id` varchar(32) DEFAULT NULL COMMENT '绑定的单一技能组ID',
  `consult_skill_logo` varchar(100) DEFAULT NULL COMMENT '技能组图标',
  `consult_skill_title` varchar(50) DEFAULT NULL COMMENT '技能组提示标题',
  `consult_skill_img` varchar(100) DEFAULT NULL COMMENT '技能组显示背景图片',
  `consult_skill_msg` text COMMENT '技能组提示文本内容',
  `consult_skill_numbers` int(11) DEFAULT NULL COMMENT '显示技能组成员数量',
  `consult_skill_maxagent` int(11) DEFAULT NULL COMMENT '显示技能组下最大用户数',
  `consult_skill_bottomtitle` varchar(50) DEFAULT NULL COMMENT '技能组底部标题',
  `consult_skill_agent` tinyint(4) DEFAULT NULL COMMENT '是否显示技能组下的坐席',
  `ai` tinyint(4) DEFAULT '0' COMMENT '启用AI',
  `aifirst` tinyint(4) DEFAULT '0' COMMENT 'AI优先显示',
  `aisearch` tinyint(4) DEFAULT '0' COMMENT 'AI搜索文本',
  `aimsg` text COMMENT 'AI欢迎信息',
  `aisuccesstip` varchar(100) DEFAULT NULL COMMENT 'AI成功命中提示消息',
  `ainame` varchar(50) DEFAULT NULL COMMENT '机器人名称',
  `consult_info` tinyint(4) DEFAULT NULL COMMENT '启用咨询信息收集功能',
  `consult_info_name` tinyint(4) DEFAULT NULL COMMENT '填写姓名',
  `consult_info_email` tinyint(4) DEFAULT NULL COMMENT '填写 邮件地址',
  `consult_info_phone` tinyint(4) DEFAULT NULL COMMENT '填写 电话号码',
  `consult_info_resion` tinyint(4) DEFAULT NULL COMMENT '填写咨询问题',
  `consult_info_message` text COMMENT '咨询窗口显示的欢迎语',
  `consult_info_cookies` tinyint(4) DEFAULT NULL COMMENT '在Cookies中存储用户信息',
  `recordhis` tinyint(4) DEFAULT NULL COMMENT '是否记录访问轨迹',
  `traceuser` tinyint(4) DEFAULT NULL COMMENT '是否跟踪访客',
  `onlyareaskill` tinyint(4) DEFAULT '0' COMMENT '区域技能组',
  `uk_consult_invite` text COMMENT '提示消息',
  `areaskilltipmsg` text COMMENT '区域技能组提示消息',
  `aiid` varchar(32) DEFAULT NULL COMMENT '默认的AI',
  `maxwordsnum` int(11) DEFAULT '300' COMMENT '访客端允许输入的最大字数',
  `agentshortcutkey` varchar(32) DEFAULT NULL COMMENT '坐席默认回复消息快捷键',
  `usershortcutkey` varchar(32) DEFAULT NULL COMMENT '访客默认回复消息快捷键',
  `agentctrlenter` tinyint(4) DEFAULT '0' COMMENT '启用坐席端CTRL+Enter发送消息',
  `ctrlenter` tinyint(4) DEFAULT '0' COMMENT '启用访客端CTRL+Enter发送消息',
  `whitelist_mode` tinyint(4) DEFAULT '0' COMMENT '启用白名单',
  `aisuggest` tinyint(4) DEFAULT '0' COMMENT '启用智能建议',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='访客网站配置表';

-- ----------------------------
-- Table structure for uk_contacts
-- ----------------------------
DROP TABLE IF EXISTS `uk_contacts`;
CREATE TABLE `uk_contacts` (
  `id` varchar(32) NOT NULL COMMENT '联系人ID',
  `gender` varchar(60) DEFAULT NULL COMMENT '联系人性别',
  `cusbirthday` varchar(50) DEFAULT NULL COMMENT '出生日期',
  `ctype` varchar(60) DEFAULT NULL COMMENT '联系人类型',
  `ckind` varchar(60) DEFAULT NULL COMMENT '联系人类别',
  `clevel` varchar(60) DEFAULT NULL COMMENT '联系人级别',
  `ccode` varchar(60) DEFAULT NULL COMMENT '联系人代码',
  `nickname` varchar(64) DEFAULT NULL COMMENT '联系人昵称',
  `sarea` varchar(60) DEFAULT NULL COMMENT '发货地址区县',
  `csource` varchar(64) DEFAULT NULL COMMENT '联系人来源',
  `language` varchar(40) DEFAULT NULL COMMENT '语言',
  `marriage` varchar(60) DEFAULT NULL COMMENT '婚姻状况',
  `education` varchar(60) DEFAULT NULL COMMENT '学历',
  `identifytype` varchar(60) DEFAULT NULL COMMENT '证件类型',
  `identifynumber` varchar(40) DEFAULT NULL COMMENT '证件号码',
  `website` varchar(255) DEFAULT NULL COMMENT '网址',
  `email` varchar(128) DEFAULT NULL COMMENT '电子邮件',
  `emailalt` varchar(128) DEFAULT NULL COMMENT '备用电子邮件',
  `mobileno` varchar(40) DEFAULT NULL COMMENT '手机号码',
  `mobilealt` varchar(40) DEFAULT NULL COMMENT '备用手机号码',
  `phone` varchar(40) DEFAULT NULL COMMENT '办公电话',
  `extension` varchar(40) DEFAULT NULL COMMENT '办公分机',
  `phonealt` varchar(40) DEFAULT NULL COMMENT '备用办公电话',
  `extensionalt` varchar(40) DEFAULT NULL COMMENT '备用办公分机',
  `familyphone` varchar(40) DEFAULT NULL COMMENT '住宅电话',
  `familyphonealt` varchar(40) DEFAULT NULL COMMENT '备用住宅电话',
  `fax` varchar(40) DEFAULT NULL COMMENT '传真号码',
  `faxalt` varchar(40) DEFAULT NULL COMMENT '备用传真号码',
  `country` varchar(60) DEFAULT NULL COMMENT '国家',
  `province` varchar(60) DEFAULT NULL COMMENT '省',
  `city` varchar(60) DEFAULT NULL COMMENT '市(区)县',
  `address` text COMMENT '地址',
  `postcode` varchar(40) DEFAULT NULL COMMENT '邮政编码',
  `enterpriseid` varchar(60) DEFAULT NULL COMMENT '企(事)业单位',
  `company` text COMMENT '公司',
  `department` varchar(40) DEFAULT NULL COMMENT '部门',
  `duty` varchar(40) DEFAULT NULL COMMENT '职务',
  `deptpr` varchar(40) DEFAULT NULL COMMENT '直接上级领导',
  `validstatus` varchar(50) DEFAULT NULL COMMENT '效力状态',
  `weixin` varchar(60) DEFAULT NULL COMMENT '微信号',
  `weixinname` varchar(60) DEFAULT NULL COMMENT '微信昵称',
  `weixinid` varchar(255) DEFAULT NULL COMMENT '微信ID',
  `weibo` varchar(255) DEFAULT NULL COMMENT '微博昵称',
  `weiboid` varchar(255) DEFAULT NULL COMMENT '微博ID',
  `qqcode` varchar(32) DEFAULT NULL COMMENT 'QQ账号',
  `touchtime` datetime DEFAULT NULL COMMENT '最后联系时间',
  `datastatus` tinyint(10) DEFAULT NULL COMMENT '数据状态',
  `processid` varchar(60) DEFAULT NULL COMMENT '流程ID',
  `creater` varchar(60) DEFAULT NULL COMMENT '创建人ID',
  `username` varchar(60) DEFAULT NULL COMMENT '创建人姓名',
  `updateuser` varchar(60) DEFAULT NULL COMMENT '修改人ID',
  `memo` varchar(255) DEFAULT NULL COMMENT '联系人备注',
  `updateusername` varchar(60) DEFAULT NULL COMMENT '修改人姓名',
  `updatetime` datetime DEFAULT NULL COMMENT '修改时间',
  `orgi` varchar(60) DEFAULT NULL COMMENT '租户标识',
  `compper` varchar(255) DEFAULT NULL,
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `name` varchar(255) DEFAULT NULL COMMENT '名称',
  `assignedto` varchar(255) DEFAULT NULL COMMENT '分配目标用户',
  `wfstatus` varchar(255) DEFAULT NULL COMMENT '流程状态',
  `shares` varchar(255) DEFAULT NULL COMMENT '分享给',
  `owner` varchar(255) DEFAULT NULL COMMENT '所属人',
  `datadept` varchar(255) DEFAULT NULL COMMENT '创建人部门',
  `entcusid` varchar(32) DEFAULT NULL COMMENT '客户ID',
  `pinyin` varchar(10) DEFAULT NULL COMMENT '拼音',
  `organ` varchar(32) DEFAULT NULL COMMENT '部门',
  `skypeid` varchar(100) DEFAULT NULL COMMENT 'skypeid',
  `wluid` varchar(100) DEFAULT NULL COMMENT '人员id',
  `wlusername` varchar(255) DEFAULT NULL COMMENT '人员名称',
  `wlcid` varchar(100) DEFAULT NULL COMMENT '公司id',
  `wlcompany_name` varchar(255) DEFAULT NULL COMMENT '公司名称',
  `wlsid` varchar(100) DEFAULT NULL COMMENT '子系统id',
  `wlsystem_name` varchar(255) DEFAULT NULL COMMENT '子系统名称',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='联系人信息表';


-- ----------------------------
-- Table structure for cs_contact_notes
-- ----------------------------
DROP TABLE IF EXISTS `cs_contact_notes`;
CREATE TABLE `cs_contact_notes` (
  `id` varchar(32) NOT NULL COMMENT 'ID',
  `contactid` varchar(32) NOT NULL COMMENT '联系人ID',
  `createtime` datetime NOT NULL COMMENT '创建时间',
  `updatetime` datetime NOT NULL COMMENT '更新时间',
  `category` varchar(200) DEFAULT NULL COMMENT '内容类型',
  `content` text COMMENT '内容',
  `creater` varchar(32) DEFAULT NULL COMMENT '创建人',
  `datastatus` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否已删除',
  `agentuser` varchar(32) DEFAULT NULL COMMENT '在线访客记录ID',
  `onlineuser` varchar(32) DEFAULT NULL COMMENT '在线访客信息ID',
  `orgi` varchar(60) DEFAULT NULL COMMENT '租客标识',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='联系人笔记表';


-- ----------------------------
-- Table structure for uk_cube
-- ----------------------------
DROP TABLE IF EXISTS `uk_cube`;
CREATE TABLE `uk_cube` (
  `ID` varchar(32) NOT NULL COMMENT '主键ID',
  `NAME` varchar(255) DEFAULT NULL COMMENT '名称',
  `CREATETIME` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' ON UPDATE CURRENT_TIMESTAMP COMMENT '创建时间',
  `DB` varchar(32) DEFAULT NULL COMMENT '数据库',
  `ORGI` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `MPOSLEFT` varchar(32) DEFAULT NULL COMMENT '位置',
  `MPOSTOP` varchar(32) DEFAULT NULL COMMENT '距顶位置',
  `TYPEID` varchar(32) DEFAULT NULL COMMENT '类型ID',
  `CODE` varchar(32) DEFAULT NULL COMMENT '代码',
  `DSTYPE` varchar(255) DEFAULT NULL COMMENT '类型',
  `MODELTYPE` varchar(32) DEFAULT NULL COMMENT '组件类型',
  `createdata` varchar(32) DEFAULT NULL COMMENT '创建状态',
  `startindex` int(11) DEFAULT NULL COMMENT '开始位置',
  `startdate` datetime DEFAULT NULL COMMENT '开始时间',
  `dataid` varchar(32) DEFAULT NULL COMMENT '数据ID',
  `dataflag` varchar(255) DEFAULT NULL COMMENT '数据状态',
  `CREATER` varchar(32) DEFAULT NULL COMMENT '创建人',
  `UPDATETIME` timestamp NULL DEFAULT NULL COMMENT '更新时间',
  `CUBEFILE` longtext COMMENT '模型文件',
  PRIMARY KEY (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='立方体表';

-- ----------------------------
-- Table structure for uk_cube_type
-- ----------------------------
DROP TABLE IF EXISTS `uk_cube_type`;
CREATE TABLE `uk_cube_type` (
  `id` varchar(32) NOT NULL COMMENT '主键ID',
  `name` varchar(255) DEFAULT NULL COMMENT '维度名称',
  `createtime` timestamp NULL DEFAULT NULL ON UPDATE CURRENT_TIMESTAMP COMMENT '创建时间',
  `creater` varchar(32) DEFAULT NULL COMMENT '创建人',
  `orgi` varchar(32) DEFAULT NULL COMMENT '租户id',
  `parentid` varchar(32) DEFAULT NULL COMMENT '模型分类上级ID',
  `inx` int(11) DEFAULT NULL COMMENT '分类排序序号',
  `updatetime` datetime DEFAULT NULL COMMENT '更新时间',
  `description` varchar(255) DEFAULT NULL COMMENT '分类描述'
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='立方体分类表';

-- ----------------------------
-- Table structure for uk_cubelevel
-- ----------------------------
DROP TABLE IF EXISTS `uk_cubelevel`;
CREATE TABLE `uk_cubelevel` (
  `ID` varchar(32) NOT NULL COMMENT '主键ID',
  `NAME` varchar(255) DEFAULT NULL COMMENT '层级名称',
  `CODE` varchar(32) DEFAULT NULL COMMENT '层级代码',
  `CREATETIME` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' ON UPDATE CURRENT_TIMESTAMP COMMENT '创建时间',
  `COLUMNAME` varchar(255) DEFAULT NULL COMMENT '字段名称',
  `UNIQUEMEMBERS` smallint(6) DEFAULT NULL COMMENT '唯一约束',
  `TYPE` varchar(32) DEFAULT NULL COMMENT '类型',
  `LEVELTYPE` varchar(32) DEFAULT NULL COMMENT '层级类型',
  `TABLENAME` varchar(255) DEFAULT NULL COMMENT '数据表名',
  `CUBEID` varchar(32) DEFAULT NULL COMMENT '立方体ID',
  `ORGI` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `SORTINDEX` int(11) DEFAULT NULL COMMENT '排序序号',
  `PARAMETERS` longtext COMMENT '参数',
  `ATTRIBUE` longtext COMMENT '扩展参数',
  `DIMID` varchar(32) DEFAULT NULL COMMENT '唯独ID',
  `PERMISSIONS` smallint(6) DEFAULT NULL COMMENT '权限',
  `TABLEPROPERTY` varchar(32) DEFAULT NULL COMMENT '数据表字段',
  `FORMATSTR` varchar(255) DEFAULT NULL COMMENT '格式化字符串',
  `description` text COMMENT '描述信息',
  `creater` varchar(32) DEFAULT NULL COMMENT '创建人信息',
  PRIMARY KEY (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='维度成员表';

-- ----------------------------
-- Table structure for uk_cubemeasure
-- ----------------------------
DROP TABLE IF EXISTS `uk_cubemeasure`;
CREATE TABLE `uk_cubemeasure` (
  `ID` varchar(32) NOT NULL COMMENT '主键ID',
  `NAME` varchar(255) DEFAULT NULL COMMENT '指标名称',
  `CODE` varchar(32) DEFAULT NULL COMMENT '指标代码',
  `CREATETIME` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' ON UPDATE CURRENT_TIMESTAMP COMMENT '创建时间',
  `COLUMNAME` varchar(255) DEFAULT NULL COMMENT '字段名称',
  `UNIQUEMEMBERS` smallint(6) DEFAULT NULL COMMENT '索引约束',
  `TYPE` varchar(32) DEFAULT NULL COMMENT '字段类型',
  `LEVELTYPE` varchar(32) DEFAULT NULL COMMENT '指标类型',
  `TABLENAME` varchar(255) DEFAULT NULL COMMENT '数据表名称',
  `CUBEID` varchar(32) DEFAULT NULL COMMENT '立方体ID',
  `ORGI` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `SORTINDEX` int(11) DEFAULT NULL COMMENT '排序序号',
  `PARAMETERS` longtext COMMENT '参数',
  `ATTRIBUE` longtext COMMENT '扩展属性',
  `MID` varchar(32) DEFAULT NULL COMMENT '指标ID',
  `AGGREGATOR` varchar(32) DEFAULT NULL COMMENT '授权给用户',
  `FORMATSTRING` varchar(255) DEFAULT NULL COMMENT '格式化字符串',
  `CALCULATEDMEMBER` smallint(6) DEFAULT NULL COMMENT '计算指标计算方式',
  `MODELTYPE` varchar(32) DEFAULT NULL COMMENT '模型类型',
  `MEASURE` varchar(32) DEFAULT NULL COMMENT '指标',
  `description` text COMMENT '指标描述',
  `creater` varchar(32) DEFAULT NULL COMMENT '创建人',
  PRIMARY KEY (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='维度指标表';

-- ----------------------------
-- Table structure for uk_cubemetadata
-- ----------------------------
DROP TABLE IF EXISTS `uk_cubemetadata`;
CREATE TABLE `uk_cubemetadata` (
  `ID` varchar(32) NOT NULL COMMENT '主键ID',
  `TITLE` varchar(255) DEFAULT NULL COMMENT '标题',
  `NAME` varchar(255) DEFAULT NULL COMMENT '名称',
  `CODE` varchar(255) DEFAULT NULL COMMENT '代码',
  `CREATETIME` datetime NOT NULL COMMENT '创建时间',
  `TB` varchar(32) DEFAULT NULL COMMENT '数据表',
  `ORGI` varchar(255) DEFAULT NULL COMMENT '租户ID',
  `CUBEID` varchar(32) DEFAULT NULL COMMENT '模型ID',
  `POSTOP` varchar(32) DEFAULT NULL COMMENT '距顶部位置',
  `POSLEFT` varchar(32) DEFAULT NULL COMMENT '距左侧位置',
  `MTYPE` varchar(5) DEFAULT NULL COMMENT '模型类型',
  `NAMEALIAS` varchar(255) DEFAULT NULL COMMENT '别称',
  `PARAMETERS` varchar(255) DEFAULT NULL COMMENT '参数',
  `ATTRIBUE` longtext COMMENT '扩展属性',
  `creater` varchar(32) DEFAULT NULL COMMENT '创建人',
  PRIMARY KEY (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='模型元数据表';

-- ----------------------------
-- Table structure for uk_datadic
-- ----------------------------
DROP TABLE IF EXISTS `uk_datadic`;
CREATE TABLE `uk_datadic` (
  `ID` varchar(32) NOT NULL COMMENT '主键ID',
  `NAME` varchar(32) DEFAULT NULL COMMENT '名称',
  `TITLE` varchar(32) DEFAULT NULL COMMENT '标题',
  `CODE` varchar(32) DEFAULT NULL COMMENT '代码',
  `PARENTID` varchar(32) DEFAULT NULL COMMENT '上级目录ID',
  `TYPE` varchar(32) DEFAULT NULL COMMENT '目录类型',
  `MEMO` varchar(255) DEFAULT NULL COMMENT '备注',
  `ORGI` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `STATUS` varchar(32) DEFAULT NULL COMMENT '状态',
  `CREATETIME` datetime DEFAULT NULL COMMENT '创建时间',
  `UPDATETIME` datetime DEFAULT NULL COMMENT '更新时间',
  `CREATER` varchar(255) DEFAULT NULL COMMENT '创建人',
  `PUBLISHEDTYPE` varchar(32) DEFAULT NULL COMMENT '发布状态',
  `DESCRIPTION` varchar(255) DEFAULT NULL COMMENT '描述',
  `TABTYPE` varchar(32) DEFAULT NULL COMMENT '数据表类型',
  `DSTYPE` varchar(32) DEFAULT NULL COMMENT '数据源类型',
  `DSTEMPLET` varchar(255) DEFAULT NULL COMMENT '数据源模板',
  `SORTINDEX` int(11) DEFAULT NULL COMMENT '排序序号',
  `DICTYPE` varchar(32) DEFAULT NULL COMMENT '目录类型',
  `ICONCLASS` varchar(100) DEFAULT NULL COMMENT '样式CLASS',
  `CSSSTYLE` varchar(255) DEFAULT NULL COMMENT '样式STYLE',
  `AUTHCODE` varchar(100) DEFAULT NULL COMMENT '认证代码',
  `DEFAULTMENU` tinyint(4) DEFAULT NULL COMMENT '默认菜单',
  `DATAID` varchar(32) DEFAULT NULL COMMENT '数据ID',
  `DICICON` varchar(32) DEFAULT NULL COMMENT '图标',
  `CURICON` varchar(32) DEFAULT NULL COMMENT '当前选中图标',
  `BGCOLOR` varchar(32) DEFAULT NULL COMMENT '背景颜色',
  `CURBGCOLOR` varchar(32) DEFAULT NULL COMMENT '当前选中颜色',
  `MENUPOS` varchar(32) DEFAULT NULL COMMENT '菜单位置',
  `DISTITLE` varchar(100) DEFAULT NULL COMMENT '显示标题',
  `NAVMENU` tinyint(4) DEFAULT '0' COMMENT '导航菜单',
  `QUICKMENU` tinyint(4) DEFAULT '0' COMMENT '快捷方式的菜单',
  `PROJECTID` varchar(32) DEFAULT NULL COMMENT '项目ID',
  `SPSEARCH` tinyint(4) DEFAULT NULL COMMENT '搜索关键词',
  PRIMARY KEY (`ID`),
  UNIQUE KEY `SQL121227155530400` (`ID`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='报表目录表';

-- ----------------------------
-- Table structure for uk_dataevent
-- ----------------------------
DROP TABLE IF EXISTS `uk_dataevent`;
CREATE TABLE `uk_dataevent` (
  `id` varchar(32) NOT NULL COMMENT '主键ID',
  `name` varchar(50) DEFAULT NULL COMMENT '名称',
  `tpid` varchar(32) DEFAULT NULL COMMENT '字段ID',
  `propertity` varchar(50) DEFAULT NULL COMMENT '属性名称',
  `field` varchar(50) DEFAULT NULL COMMENT '字段名称',
  `newvalue` varchar(255) DEFAULT NULL COMMENT '变更后的值',
  `oldvalue` varchar(255) DEFAULT NULL COMMENT '变更前的值',
  `orgi` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `modifyid` varchar(32) DEFAULT NULL COMMENT '变更ID',
  `creater` varchar(32) DEFAULT NULL COMMENT '创建人',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `dataid` varchar(32) DEFAULT NULL COMMENT '数据ID',
  `eventtype` varchar(32) DEFAULT NULL COMMENT '事件类型',
  `content` varchar(255) DEFAULT NULL COMMENT '变更内容',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='工单数据变更记录';

-- ----------------------------
-- Table structure for uk_dimension
-- ----------------------------
DROP TABLE IF EXISTS `uk_dimension`;
CREATE TABLE `uk_dimension` (
  `ID` varchar(32) NOT NULL COMMENT '数据ID',
  `NAME` varchar(255) DEFAULT NULL COMMENT '维度名称',
  `CODE` varchar(255) DEFAULT NULL COMMENT '维度代码',
  `CREATETIME` datetime DEFAULT NULL COMMENT '创建时间',
  `CUBEID` varchar(32) DEFAULT NULL COMMENT '立方体ID',
  `ORGI` varchar(255) DEFAULT NULL COMMENT '租户ID',
  `TYPE` varchar(32) DEFAULT NULL COMMENT '维度类型',
  `SORTINDEX` int(11) DEFAULT NULL COMMENT '排序序号',
  `PARAMETERS` longtext COMMENT '参数',
  `ATTRIBUE` longtext COMMENT '扩展属性',
  `POSLEFT` varchar(32) DEFAULT NULL COMMENT '位置',
  `POSTOP` varchar(32) DEFAULT NULL COMMENT '位置距顶',
  `FORMATSTR` varchar(32) DEFAULT NULL COMMENT '格式化字符串',
  `MODELTYPE` varchar(32) DEFAULT NULL COMMENT '模型类型',
  `DIM` varchar(32) DEFAULT NULL COMMENT '维度',
  `ALLMEMBERNAME` varchar(32) DEFAULT NULL COMMENT '小计名称',
  `FKFIELD` varchar(255) DEFAULT NULL COMMENT '外键字段',
  `FKTABLE` varchar(255) DEFAULT NULL COMMENT '外键表',
  `FKTABLEID` varchar(255) DEFAULT NULL COMMENT '外键表ID',
  `CREATER` varchar(32) DEFAULT NULL COMMENT '创建人',
  PRIMARY KEY (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='维度表';

-- ----------------------------
-- Table structure for uk_drilldown
-- ----------------------------
DROP TABLE IF EXISTS `uk_drilldown`;
CREATE TABLE `uk_drilldown` (
  `id` varchar(32) NOT NULL COMMENT '主键ID',
  `name` varchar(255) DEFAULT NULL COMMENT '名称',
  `memo` varchar(255) DEFAULT NULL COMMENT '备注',
  `orgi` varchar(255) DEFAULT NULL COMMENT '租户ID',
  `code` varchar(255) DEFAULT NULL COMMENT '代码',
  `dataid` varchar(255) DEFAULT NULL COMMENT '数据ID',
  `dataname` varchar(255) DEFAULT NULL COMMENT '数据名称',
  `tdstyle` varchar(255) DEFAULT NULL COMMENT 'TD样式',
  `reportid` varchar(255) DEFAULT NULL COMMENT '报表ID',
  `modelid` varchar(255) DEFAULT NULL COMMENT '模型ID',
  `paramname` varchar(255) DEFAULT NULL COMMENT '参数名称',
  `paramtype` varchar(255) DEFAULT NULL COMMENT '参数类型',
  `paramurl` varchar(255) DEFAULT NULL COMMENT '参数URL',
  `paramtarget` varchar(255) DEFAULT NULL COMMENT '目标对象',
  `paramreport` varchar(255) DEFAULT NULL COMMENT '目标报表',
  `paramvalue` varchar(255) DEFAULT NULL COMMENT '参数值',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='钻取表';

-- ----------------------------
-- Table structure for uk_entcustomer
-- ----------------------------
DROP TABLE IF EXISTS `uk_entcustomer`;
CREATE TABLE `uk_entcustomer` (
  `id` varchar(32) NOT NULL COMMENT '单位ID',
  `name` varchar(255) DEFAULT NULL COMMENT '企(事)业单位名称',
  `etype` varchar(60) DEFAULT NULL COMMENT '单位性质',
  `ekind` varchar(60) DEFAULT NULL COMMENT '客户类别',
  `elevel` varchar(60) DEFAULT NULL COMMENT '客户级别',
  `ecode` varchar(60) DEFAULT NULL COMMENT '单位代码',
  `nickname` varchar(64) DEFAULT NULL COMMENT '单位简称',
  `esource` varchar(64) DEFAULT NULL COMMENT '来源',
  `origincode` varchar(60) DEFAULT NULL COMMENT '组织机构代码',
  `corporation` varchar(60) DEFAULT NULL COMMENT '法人',
  `leadername` varchar(40) DEFAULT NULL COMMENT '联系人姓名',
  `leadermobile` varchar(40) DEFAULT NULL COMMENT '联系人手机',
  `leadermobile2` varchar(40) DEFAULT NULL COMMENT '联系人手机2',
  `leaderphone` varchar(40) DEFAULT NULL COMMENT '联系人座机',
  `leaderemail` varchar(60) DEFAULT NULL COMMENT '联系人电子邮件',
  `website` varchar(255) DEFAULT NULL COMMENT '网址',
  `email` varchar(128) DEFAULT NULL COMMENT '电子邮件',
  `emailalt` varchar(128) DEFAULT NULL COMMENT '备用电子邮件',
  `phone` varchar(40) DEFAULT NULL COMMENT '办公电话',
  `phonealt` varchar(40) DEFAULT NULL COMMENT '备用办公电话',
  `fax` varchar(40) DEFAULT NULL COMMENT '传真号码',
  `faxalt` varchar(40) DEFAULT NULL COMMENT '备用传真号码',
  `country` varchar(60) DEFAULT NULL COMMENT '国家',
  `province` varchar(60) DEFAULT NULL COMMENT '省',
  `city` varchar(60) DEFAULT NULL COMMENT '市区县',
  `sarea` varchar(60) DEFAULT NULL COMMENT '区县',
  `address` varchar(255) DEFAULT NULL COMMENT '地址',
  `postcode` varchar(40) DEFAULT NULL COMMENT '邮政编码',
  `businessscope` text COMMENT '经营范围',
  `capital` varchar(40) DEFAULT NULL COMMENT '注册资本',
  `stockcode` varchar(40) DEFAULT NULL COMMENT '股票代码',
  `bankaccount` varchar(40) DEFAULT NULL COMMENT '对公银行账号',
  `registeredaddress` text COMMENT '注册地址',
  `esize` varchar(60) DEFAULT NULL COMMENT '单位规模',
  `industry` varchar(60) DEFAULT NULL COMMENT '所属行业',
  `validstatus` varchar(50) DEFAULT NULL COMMENT '效力状态',
  `weixin` varchar(60) DEFAULT NULL COMMENT '微信公众号',
  `weibo` varchar(255) DEFAULT NULL COMMENT '微博号',
  `touchtime` datetime DEFAULT NULL COMMENT '最后联系时间',
  `dzip` varchar(32) DEFAULT NULL COMMENT '发货地址邮编',
  `daddress` varchar(255) DEFAULT NULL COMMENT '发货地址',
  `darea` varchar(60) DEFAULT NULL COMMENT '发货地址-区县',
  `dcity` varchar(60) DEFAULT NULL COMMENT '发货地址-城市',
  `dprovince` varchar(60) DEFAULT NULL COMMENT '发货地址-省份',
  `datastatus` varchar(2) DEFAULT NULL COMMENT '数据状态',
  `processid` varchar(60) DEFAULT NULL COMMENT '流程ID',
  `description` text COMMENT '描述',
  `creater` varchar(60) DEFAULT NULL COMMENT '创建人ID',
  `username` varbinary(60) DEFAULT NULL COMMENT '创建人姓名',
  `updateuser` varchar(60) DEFAULT NULL COMMENT '修改人ID',
  `updateusername` varchar(60) DEFAULT NULL COMMENT '修改人姓名',
  `updatetime` datetime DEFAULT NULL COMMENT '修改时间',
  `orgi` varchar(60) DEFAULT NULL COMMENT '租户标识',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `assignedto` varchar(255) DEFAULT NULL COMMENT '分配目标用户',
  `wfstatus` varchar(255) DEFAULT NULL COMMENT '流程状态',
  `shares` varchar(255) DEFAULT NULL COMMENT '分享给',
  `owner` varchar(255) DEFAULT NULL COMMENT '所属人',
  `datadept` varchar(255) DEFAULT NULL COMMENT '创建人部门',
  `batid` varchar(32) DEFAULT NULL COMMENT '批次ID',
  `maturity` varchar(32) DEFAULT NULL COMMENT '规模',
  `entcusid` varchar(32) DEFAULT NULL COMMENT '客户ID',
  `pinyin` varchar(10) DEFAULT NULL COMMENT '首字母缩写拼音',
  `organ` varchar(32) DEFAULT NULL COMMENT '部门',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='企(事)业单位信息表';

-- ----------------------------
-- Table structure for uk_fans
-- ----------------------------
DROP TABLE IF EXISTS `uk_fans`;
CREATE TABLE `uk_fans` (
  `id` varchar(32) NOT NULL COMMENT '主键ID',
  `creater` varchar(32) DEFAULT NULL COMMENT '创建人',
  `createtime` date DEFAULT NULL COMMENT '创建时间',
  `updatetime` date DEFAULT NULL COMMENT '更新时间',
  `suser` varchar(32) DEFAULT NULL COMMENT '用户ID',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='粉丝表';

-- ----------------------------
-- Table structure for uk_favorites
-- ----------------------------
DROP TABLE IF EXISTS `uk_favorites`;
CREATE TABLE `uk_favorites` (
  `ID` varchar(32) NOT NULL COMMENT '主键ID',
  `NAME` varchar(50) DEFAULT NULL COMMENT '名称',
  `CODE` varchar(50) DEFAULT NULL COMMENT '编码',
  `CREATETIME` datetime DEFAULT NULL COMMENT '创建时间',
  `CREATER` varchar(32) DEFAULT NULL COMMENT '创建人',
  `UPDATETIME` datetime DEFAULT NULL COMMENT '更新时间',
  `ORGI` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `USERNAME` varchar(50) DEFAULT NULL COMMENT '用户名',
  `ORDERID` varchar(32) DEFAULT NULL COMMENT '数据ID',
  `TITLE` varchar(255) DEFAULT NULL COMMENT '标题',
  `MODEL` varchar(50) DEFAULT NULL COMMENT '所属组件',
  PRIMARY KEY (`ID`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='收藏信息表';

-- ----------------------------
-- Table structure for uk_fs_event_socket
-- ----------------------------
DROP TABLE IF EXISTS `uk_fs_event_socket`;
CREATE TABLE `uk_fs_event_socket` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '主键',
  `hostname` varchar(50) NOT NULL COMMENT 'fs服务名称',
  `nat_map` varchar(20) DEFAULT 'false' COMMENT 'nat_map',
  `listen_ip` varchar(50) DEFAULT '0.0.0.0' COMMENT 'listen_ip',
  `listen_port` int(11) DEFAULT '8021' COMMENT 'listen_port',
  `password` varchar(50) DEFAULT 'ClueCon' COMMENT '密码',
  `apply_inbound_acl` varchar(50) DEFAULT 'lan' COMMENT '呼入ACL',
  `stop_on_bind_error` varchar(50) DEFAULT 'true' COMMENT '错误消息',
  `addtime` varchar(20) DEFAULT NULL COMMENT '创建时间',
  `updatetime` varchar(20) DEFAULT NULL COMMENT '修改时间',
  `connected` int(11) DEFAULT NULL COMMENT 'connected 0-未连接 1-已连接 2 已停止',
  `connected_result` varchar(50) DEFAULT NULL COMMENT '连接结果',
  `show_calls` int(11) DEFAULT NULL COMMENT '容许通话数',
  `enable` int(11) DEFAULT '1' COMMENT '是否启用',
  PRIMARY KEY (`id`) USING BTREE,
  UNIQUE KEY `AK_Key_2` (`hostname`) USING BTREE,
  UNIQUE KEY `UK_hu886eh9fs7qysallkl0ub6t7` (`hostname`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='fs服务器监听端口';

-- ----------------------------
-- Table structure for uk_generation
-- ----------------------------
DROP TABLE IF EXISTS `uk_generation`;
CREATE TABLE `uk_generation` (
  `id` varchar(32) NOT NULL COMMENT '主键ID',
  `model` varchar(32) DEFAULT NULL COMMENT '所属组件',
  `startinx` int(11) DEFAULT NULL COMMENT '开始位置',
  `orgi` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `creater` varchar(32) DEFAULT NULL COMMENT '创建人',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='全局ID生成器';

-- ----------------------------
-- Table structure for uk_historyreport
-- ----------------------------
DROP TABLE IF EXISTS `uk_historyreport`;
CREATE TABLE `uk_historyreport` (
  `ID` varchar(32) NOT NULL COMMENT '主键ID',
  `BYTES` int(11) NOT NULL COMMENT '传输数据量',
  `THREADS` int(11) NOT NULL COMMENT '线程数量',
  `TYPE` varchar(255) DEFAULT NULL COMMENT '类型',
  `STATUS` varchar(255) DEFAULT NULL COMMENT '状态',
  `ERRORMSG` varchar(255) DEFAULT NULL COMMENT '错误提示',
  `CREATETIME` datetime DEFAULT NULL COMMENT '创建时间',
  `STARTTIME` datetime DEFAULT NULL COMMENT '开始时间',
  `ENDTIME` datetime DEFAULT NULL COMMENT '结束时间',
  `AMOUNT` varchar(255) DEFAULT NULL COMMENT '提醒',
  `PAGES` int(11) NOT NULL COMMENT '记录数量',
  `ERRORS` int(11) NOT NULL COMMENT '错误数',
  `ORGI` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `TABLEDIRID` varchar(32) DEFAULT NULL COMMENT '数据表目录ID',
  `TABLEID` varchar(32) DEFAULT NULL COMMENT '数据表ID',
  `TOTAL` int(11) DEFAULT NULL COMMENT '总数',
  `USERID` varchar(32) DEFAULT NULL COMMENT '用户ID',
  `USERNAME` varchar(50) DEFAULT '' COMMENT '用户名',
  `dataid` varchar(32) DEFAULT NULL COMMENT '批次ID',
  `title` varchar(100) DEFAULT NULL COMMENT '标题',
  `organ` varchar(50) DEFAULT NULL COMMENT '组织机构',
  PRIMARY KEY (`ID`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='数据采集历史表';

-- ----------------------------
-- Table structure for uk_imgroup
-- ----------------------------
DROP TABLE IF EXISTS `uk_imgroup`;
CREATE TABLE `uk_imgroup` (
  `id` varchar(32) NOT NULL COMMENT '主键ID',
  `creater` varchar(32) DEFAULT NULL COMMENT '创建人',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `updatetime` datetime DEFAULT NULL COMMENT '更新时间',
  `tipmessage` text COMMENT '提示消息',
  `descript` text COMMENT '描述',
  `name` varchar(100) DEFAULT NULL COMMENT '分组名称',
  `orgi` varchar(100) DEFAULT NULL COMMENT '租户ID',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='企业聊天分组表';

-- ----------------------------
-- Table structure for uk_imgroup_user
-- ----------------------------
DROP TABLE IF EXISTS `uk_imgroup_user`;
CREATE TABLE `uk_imgroup_user` (
  `id` varchar(32) NOT NULL COMMENT '主键ID',
  `creater` varchar(32) DEFAULT NULL COMMENT '创建人ID',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `updatetime` datetime DEFAULT NULL COMMENT '更新时间',
  `name` varchar(100) DEFAULT NULL COMMENT '名称',
  `orgi` varchar(100) DEFAULT NULL COMMENT '租户ID',
  `user_id` varchar(32) DEFAULT NULL COMMENT '用户ID',
  `imgroup_id` varchar(32) DEFAULT NULL COMMENT '分组ID',
  `admin` tinyint(4) DEFAULT NULL COMMENT '是否管理员',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='企业聊天分组用户';

-- ----------------------------
-- Table structure for uk_instruction
-- ----------------------------
DROP TABLE IF EXISTS `uk_instruction`;
CREATE TABLE `uk_instruction` (
  `id` varchar(96) NOT NULL COMMENT '主键ID',
  `name` varchar(96) DEFAULT NULL COMMENT '名称',
  `code` varchar(96) DEFAULT NULL COMMENT '编码',
  `plugin` varchar(96) DEFAULT NULL COMMENT '插件',
  `memo` text COMMENT '备注',
  `status` varchar(96) DEFAULT NULL COMMENT '状态',
  `orgi` varchar(96) DEFAULT NULL COMMENT '租户ID',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `userid` varchar(96) DEFAULT NULL COMMENT '用户ID',
  `type` varchar(96) DEFAULT NULL COMMENT '类型',
  `parent` varchar(96) DEFAULT NULL COMMENT '上级指令',
  `username` varchar(96) DEFAULT NULL COMMENT '用户名',
  `scope` varchar(15) DEFAULT NULL COMMENT '作用域',
  `tipdefault` smallint(6) DEFAULT NULL COMMENT '默认提示',
  `matcherule` varchar(96) DEFAULT NULL COMMENT '匹配规则',
  `userbind` smallint(6) DEFAULT NULL COMMENT '用户绑定',
  `interfacetype` varchar(96) DEFAULT NULL COMMENT '接口类型',
  `adapter` varchar(96) DEFAULT NULL COMMENT '适配程序',
  `interfaceurl` text COMMENT '接口URL',
  `interfaceparam` text COMMENT '接口参数',
  `messagetype` varchar(96) DEFAULT NULL COMMENT '消息类型',
  `keyword` varchar(100) DEFAULT NULL COMMENT '关键词',
  `eventype` varchar(32) DEFAULT NULL COMMENT '菜单事件类型',
  `snsid` varchar(32) DEFAULT NULL COMMENT 'SNSID',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='微信指令表';

-- ----------------------------
-- Table structure for uk_inviterecord
-- ----------------------------
DROP TABLE IF EXISTS `uk_inviterecord`;
CREATE TABLE `uk_inviterecord` (
  `id` varchar(32) NOT NULL COMMENT '主键ID',
  `orgi` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `userid` varchar(32) DEFAULT NULL COMMENT '用户ID',
  `agentno` varchar(32) DEFAULT NULL COMMENT '坐席ID',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `updatetime` datetime DEFAULT NULL COMMENT '更新时间',
  `result` varchar(10) DEFAULT NULL COMMENT '记录',
  `responsetime` int(11) DEFAULT NULL COMMENT '响应时间',
  `appid` varchar(32) DEFAULT NULL COMMENT 'SNSID',
  `title` varchar(255) DEFAULT NULL COMMENT '标题',
  `url` text DEFAULT NULL COMMENT '地址',
  `traceid` varchar(32) DEFAULT NULL COMMENT '跟踪ID',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='邀请记录表';

-- ----------------------------
-- Table structure for uk_jobdetail
-- ----------------------------
DROP TABLE IF EXISTS `uk_jobdetail`;
CREATE TABLE `uk_jobdetail` (
  `ID` varchar(32) NOT NULL COMMENT '主键ID',
  `NAME` varchar(50) DEFAULT NULL COMMENT '名称',
  `CODE` varchar(50) DEFAULT NULL COMMENT '代码',
  `CREATETIME` datetime DEFAULT NULL COMMENT '创建时间',
  `CREATER` varchar(32) DEFAULT NULL COMMENT '创建人',
  `UPDATETIME` datetime DEFAULT NULL COMMENT '更新时间',
  `ORGI` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `USERNAME` varchar(50) DEFAULT NULL COMMENT '创建人',
  `STATUS` varchar(50) DEFAULT NULL COMMENT '任务状态',
  `PARENTID` varchar(32) DEFAULT NULL COMMENT '上级ID',
  `ACTID` varchar(32) DEFAULT NULL COMMENT '活动ID',
  `INX` int(11) DEFAULT '0' COMMENT '分类排序序号',
  `NAMENUM` int(11) DEFAULT '0' COMMENT '批次包含的名单总数',
  `VALIDNUM` int(11) DEFAULT '0' COMMENT '批次包含的有效名单总数',
  `INVALIDNUM` int(11) DEFAULT '0' COMMENT '批次包含的无效名单总数',
  `ASSIGNED` int(11) DEFAULT '0' COMMENT '已分配名单总数',
  `NOTASSIGNED` int(11) DEFAULT '0' COMMENT '未分配名单总数',
  `ENABLE` tinyint(4) NOT NULL DEFAULT '0' COMMENT '分类状态',
  `DATASTATUS` tinyint(4) DEFAULT '0' COMMENT '数据状态',
  `AREA` text COMMENT '分类描述',
  `imptype` varchar(50) DEFAULT NULL COMMENT '导入类型',
  `batchtype` varchar(32) DEFAULT NULL COMMENT '批次类型',
  `ORGAN` varchar(32) DEFAULT NULL COMMENT '部门',
  `impurl` text COMMENT '导入URL',
  `filetype` varchar(50) DEFAULT NULL COMMENT '文件类型',
  `dbtype` varchar(50) DEFAULT NULL COMMENT '数据库类型',
  `jdbcurl` text COMMENT '数据库URL',
  `driverclazz` varchar(255) DEFAULT NULL COMMENT '数据库驱动',
  `password` varchar(255) DEFAULT NULL COMMENT '密码',
  `DESCRIPTION` text COMMENT '描述信息',
  `execnum` int(11) DEFAULT '0' COMMENT '导入次数',
  `SOURCE` varchar(255) DEFAULT NULL COMMENT '来源',
  `CLAZZ` varchar(255) DEFAULT NULL COMMENT '执行的Resource类',
  `TASKFIRETIME` datetime DEFAULT NULL COMMENT '启动时间',
  `CRAWLTASKID` varchar(255) DEFAULT NULL COMMENT '任务ID',
  `EMAIL` varchar(255) DEFAULT NULL COMMENT '邮件地址',
  `NICKNAME` varchar(255) DEFAULT NULL COMMENT '昵称',
  `USERID` varchar(255) DEFAULT NULL COMMENT '用户ID',
  `TASKTYPE` varchar(255) DEFAULT NULL COMMENT '任务类型',
  `TASKID` varchar(255) DEFAULT NULL COMMENT '任务ID',
  `FETCHER` smallint(6) NOT NULL COMMENT '当前状态',
  `PAUSE` smallint(6) NOT NULL COMMENT '暂停',
  `PLANTASK` smallint(6) NOT NULL COMMENT '计划任务',
  `SECURE_ID` varchar(32) DEFAULT NULL COMMENT '安全规则ID',
  `CONFIGURE_ID` varchar(32) DEFAULT NULL COMMENT '配置项ID',
  `TAKSPLAN_ID` varchar(32) DEFAULT NULL COMMENT '计划任务ID',
  `CRAWLTASK` varchar(32) DEFAULT NULL COMMENT '当前任务状态',
  `TARGETTASK` varchar(32) DEFAULT NULL COMMENT '目标任务',
  `STARTINDEX` int(11) DEFAULT NULL COMMENT '开始位置',
  `LASTDATE` datetime DEFAULT NULL COMMENT '最后更新时间',
  `CREATETABLE` tinyint(4) DEFAULT NULL COMMENT '是否创建数据表',
  `MEMO` text COMMENT '备注',
  `NEXTFIRETIME` datetime DEFAULT NULL COMMENT '下次启动时间',
  `CRONEXP` varchar(255) DEFAULT NULL COMMENT 'CRON表达式',
  `TASKSTATUS` varchar(32) DEFAULT NULL COMMENT '任务执行状态',
  `usearea` varchar(255) DEFAULT NULL COMMENT '用户数据',
  `areafield` varchar(255) DEFAULT NULL COMMENT '用户字段',
  `areafieldtype` varchar(32) DEFAULT NULL COMMENT '用户数据类型',
  `arearule` varchar(255) DEFAULT NULL COMMENT '用户数据值',
  `minareavalue` varchar(255) DEFAULT NULL COMMENT '最小值',
  `maxareavalue` varchar(255) DEFAULT NULL COMMENT '最大值',
  `formatstr` varchar(255) DEFAULT NULL COMMENT '格式化字符串',
  `DATAID` varchar(1000) DEFAULT NULL COMMENT '报表id字符串',
  `DICID` varchar(1000) DEFAULT NULL COMMENT '目录id字符串',
  `taskinfo` longtext COMMENT 'taskinfo信息',
  `FILTERID` varchar(32) DEFAULT NULL COMMENT '筛选表单ID',
  `FETCH_SIZE` int(11) DEFAULT NULL COMMENT '采集数据窗口大小',
  `LASTINDEX` int(11) DEFAULT NULL COMMENT '结束位置',
  `PAGES` int(11) DEFAULT NULL COMMENT '页面数量',
  `plantaskreadtorun` tinyint(4) DEFAULT NULL COMMENT '计划任务',
  `priority` int(11) DEFAULT NULL COMMENT '策略',
  `runserver` varchar(100) DEFAULT NULL COMMENT '运行服务器',
  `actype` varchar(50) DEFAULT NULL COMMENT '活动类型',
  `distype` varchar(32) DEFAULT NULL COMMENT '分配类型',
  `distpolicy` varchar(50) DEFAULT NULL COMMENT '分配策略',
  `policynum` int(11) DEFAULT NULL COMMENT '分配数量',
  `busstype` varchar(32) DEFAULT NULL COMMENT '业务类型',
  `disnum` varchar(32) DEFAULT NULL COMMENT '默认分配数量',
  `execmd` varchar(32) DEFAULT NULL COMMENT '执行次数',
  `exectarget` varchar(50) DEFAULT NULL COMMENT '执行分配目标',
  `exectype` varchar(32) DEFAULT NULL COMMENT '执行类型',
  `execto` varchar(32) DEFAULT NULL COMMENT '回收数据位置',
  `threads` int(11) DEFAULT '0' COMMENT '启动任务的线程数量',
  `siptrunk` varchar(32) DEFAULT NULL COMMENT '线路信息',
  `province` varchar(32) DEFAULT NULL COMMENT '线路所在省份',
  `city` varchar(32) DEFAULT NULL COMMENT '线路所在城市',
  `prefix` tinyint(4) DEFAULT '0' COMMENT '线路资源拨号前缀',
  `reportid` varchar(32) DEFAULT NULL COMMENT '数据表ID',
  `mapping` tinyint(4) DEFAULT '0' COMMENT '默认映射结构',
  PRIMARY KEY (`ID`,`ENABLE`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='作业调度任务/活动/批次表';

-- ----------------------------
-- Table structure for uk_jobdetailproduct
-- ----------------------------
DROP TABLE IF EXISTS `uk_jobdetailproduct`;
CREATE TABLE `uk_jobdetailproduct` (
  `id` varchar(32) NOT NULL COMMENT '主键ID',
  `actid` varchar(32) DEFAULT NULL COMMENT '活动ID',
  `product_id` varchar(32) DEFAULT NULL COMMENT '产品ID',
  `creater` varchar(32) DEFAULT NULL COMMENT '创建人',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `orgi` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `quota` int(11) DEFAULT '0' COMMENT '配额',
  `price` int(11) DEFAULT '0' COMMENT '价格',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='活动产品表';


-- ----------------------------
-- Table structure for uk_leavemsg
-- ----------------------------
DROP TABLE IF EXISTS `uk_leavemsg`;
CREATE TABLE `uk_leavemsg` (
  `id` varchar(32) NOT NULL COMMENT '主键ID',
  `name` varchar(50) DEFAULT NULL COMMENT '姓名',
  `mobile` varchar(32) DEFAULT NULL COMMENT '手机',
  `email` varchar(100) DEFAULT NULL COMMENT '邮件',
  `address` varchar(255) DEFAULT NULL COMMENT '地址',
  `qq` varchar(30) DEFAULT NULL COMMENT 'QQ',
  `content` varchar(255) DEFAULT NULL COMMENT '留言内容',
  `orgi` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `creater` varchar(32) DEFAULT NULL COMMENT '创建人',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `msgstatus` varchar(20) DEFAULT NULL COMMENT '消息状态',
  `contactsid` varchar(32) DEFAULT NULL COMMENT '匹配联系人ID',
  `userid` varchar(32) DEFAULT NULL COMMENT '用户ID',
  `skill` varchar(32) DEFAULT NULL COMMENT '技能组',
  `snsid` varchar(32) DEFAULT NULL COMMENT '渠道snsid',
   PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='留言信息表';

-- ----------------------------
-- Records of uk_leavemsg
-- ----------------------------


-- ----------------------------
-- Table structure for uk_log
-- ----------------------------
DROP TABLE IF EXISTS `uk_log`;
CREATE TABLE `uk_log` (
  `id` varchar(32) NOT NULL COMMENT '主键ID',
  `orgi` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `flowid` varchar(32) DEFAULT NULL COMMENT '页面ID',
  `logtype` varchar(32) DEFAULT NULL COMMENT '日志类型',
  `createdate` datetime DEFAULT NULL COMMENT '创建时间',
  `msg` longtext COMMENT '日志消息',
  `LEVELS` varchar(32) DEFAULT NULL COMMENT '日志级别',
  `thread` varchar(255) DEFAULT NULL COMMENT '线程',
  `clazz` varchar(255) DEFAULT NULL COMMENT 'JAVA类',
  `FILES` varchar(255) DEFAULT NULL COMMENT '文件位置',
  `linenumber` varchar(32) DEFAULT NULL COMMENT '行号',
  `method` varchar(255) DEFAULT NULL COMMENT '方法名称',
  `startid` varchar(32) DEFAULT NULL COMMENT '启动ID',
  `errorinfo` text COMMENT '错误消息',
  `triggerwarning` varchar(32) DEFAULT NULL COMMENT '触发警告',
  `triggertime` varchar(32) DEFAULT NULL COMMENT '警告时间',
  `triggertimes` int(11) DEFAULT NULL COMMENT '警告次数',
  `name` varchar(32) DEFAULT NULL COMMENT '日志名称',
  `code` varchar(32) DEFAULT NULL COMMENT '日志代码',
  `memo` varchar(255) DEFAULT NULL COMMENT '备注信息',
  `userid` varchar(32) DEFAULT NULL COMMENT '用户ID',
  `username` varchar(32) DEFAULT NULL COMMENT '日志触发名',
  `logtime` varchar(32) DEFAULT NULL COMMENT '日志时间',
  `ipaddr` varchar(255) DEFAULT NULL COMMENT '服务器地址',
  `port` varchar(32) DEFAULT NULL COMMENT '服务器端口',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='日志表';


-- ----------------------------
-- Table structure for uk_log_request
-- ----------------------------
DROP TABLE IF EXISTS `uk_log_request`;
CREATE TABLE `uk_log_request` (
  `id` varchar(32) NOT NULL DEFAULT '主键ID',
  `type` varchar(255) DEFAULT NULL COMMENT '类型',
  `parameters` longtext COMMENT '参数',
  `throwable` varchar(255) DEFAULT NULL COMMENT '异常消息',
  `username` varchar(255) DEFAULT NULL COMMENT '用户名',
  `usermail` varchar(255) DEFAULT NULL COMMENT '用户信息',
  `filename` varchar(255) DEFAULT NULL COMMENT '文件名',
  `orgi` varchar(255) DEFAULT NULL COMMENT '租户ID',
  `error` text COMMENT '错误信息',
  `classname` varchar(255) DEFAULT NULL COMMENT '类名',
  `starttime` datetime DEFAULT NULL COMMENT '执行的开始时间',
  `endtime` datetime DEFAULT NULL COMMENT '执行的结束时间',
  `detailtype` varchar(255) DEFAULT NULL COMMENT '详情类型',
  `url` text COMMENT '访问URL',
  `reportdic` varchar(255) DEFAULT NULL COMMENT '报表目录',
  `reportname` varchar(255) DEFAULT NULL COMMENT '报表名称',
  `ip` varchar(255) DEFAULT NULL COMMENT 'IP地址',
  `hostname` varchar(255) DEFAULT NULL COMMENT '主机名称',
  `statues` varchar(255) DEFAULT NULL COMMENT '状态',
  `methodname` text COMMENT '方法名称',
  `linenumber` varchar(255) DEFAULT NULL COMMENT '行号',
  `querytime` int(255) DEFAULT NULL COMMENT '执行时间',
  `optext` varchar(255) DEFAULT NULL COMMENT '操作代码',
  `field6` varchar(255) DEFAULT NULL COMMENT '备用字段',
  `field7` varchar(255) DEFAULT NULL COMMENT '备用字段',
  `field8` varchar(255) DEFAULT NULL COMMENT '备用字段',
  `flowid` varchar(32) DEFAULT NULL COMMENT '页面ID',
  `userid` varchar(255) DEFAULT NULL COMMENT '用户ID',
  `name` varchar(32) DEFAULT NULL COMMENT '名称',
  `funtype` varchar(32) DEFAULT NULL COMMENT '方法类型',
  `fundesc` varchar(255) DEFAULT NULL COMMENT '方法描述',
  `triggerwarning` varchar(32) DEFAULT NULL COMMENT '触发警告',
  `triggertime` varchar(32) DEFAULT NULL COMMENT '触发时间',
  `createdate` datetime DEFAULT NULL COMMENT '创建时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='请求记录表';

-- ----------------------------
-- Records of uk_log_request
-- ----------------------------

-- ----------------------------
-- Table structure for uk_message
-- ----------------------------
DROP TABLE IF EXISTS `uk_message`;
CREATE TABLE `uk_message` (
  `id` varchar(32) NOT NULL COMMENT '主键ID',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `creater` varchar(32) DEFAULT NULL COMMENT '创建人',
  `updatetime` datetime DEFAULT NULL COMMENT '更新时间',
  `userid` varchar(32) DEFAULT NULL COMMENT '用户ID',
  `content` text COMMENT '消息内容',
  `status` varchar(10) DEFAULT NULL COMMENT '状态',
  `fromuser` varchar(32) DEFAULT NULL COMMENT '来源用户',
  `touser` varchar(32) DEFAULT NULL COMMENT '目标用户',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='个人消息表';

-- ----------------------------
-- Table structure for uk_onlineuser
-- ----------------------------
DROP TABLE IF EXISTS `uk_onlineuser`;
CREATE TABLE `uk_onlineuser` (
  `assignedto` varchar(255) NOT NULL DEFAULT '' COMMENT '分配给目标',
  `creater` varchar(255) DEFAULT NULL COMMENT '创建人',
  `datastatus` varchar(255) DEFAULT NULL COMMENT '时间状态',
  `id` varchar(32) NOT NULL COMMENT '主键ID',
  `impid` varchar(255) DEFAULT NULL COMMENT '批次ID',
  `ipcode` varchar(255) DEFAULT NULL COMMENT 'IP编码',
  `orgi` varchar(191) DEFAULT NULL COMMENT '租户ID',
  `owner` varchar(255) DEFAULT NULL COMMENT '所属用户',
  `processid` varchar(255) DEFAULT NULL COMMENT '流程ID',
  `shares` varchar(255) DEFAULT NULL COMMENT '分享给',
  `updatetime` datetime DEFAULT NULL COMMENT '更新时间',
  `updateuser` varchar(255) DEFAULT NULL COMMENT '更新用户',
  `username` varchar(255) DEFAULT NULL COMMENT '用户名',
  `wfstatus` varchar(255) DEFAULT NULL COMMENT '流程状态',
  `resolution` varchar(255) DEFAULT NULL COMMENT '分辨率',
  `opersystem` varchar(100) DEFAULT NULL COMMENT '操作系统',
  `ip` varchar(50) DEFAULT NULL COMMENT 'IP',
  `hostname` varchar(32) DEFAULT NULL COMMENT '主机名称',
  `browser` varchar(32) DEFAULT NULL COMMENT '浏览器',
  `status` varchar(11) DEFAULT NULL COMMENT '状态',
  `userid` varchar(52) DEFAULT NULL COMMENT '用户ID',
  `logintime` datetime DEFAULT NULL COMMENT '访问时间',
  `sessionid` varchar(100) DEFAULT NULL COMMENT '会话ID',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `usertype` varchar(52) DEFAULT NULL COMMENT '访客类型',
  `optype` varchar(52) DEFAULT NULL COMMENT '操作类型',
  `mobile` varchar(10) DEFAULT NULL COMMENT '移动端',
  `phone` varchar(20) DEFAULT NULL COMMENT '电话号',
  `olduser` varchar(10) DEFAULT NULL COMMENT '老用户',
  `country` varchar(50) DEFAULT NULL COMMENT '访客国家',
  `region` varchar(200) DEFAULT NULL COMMENT '访客区域',
  `city` varchar(50) DEFAULT NULL COMMENT '城市',
  `isp` varchar(100) DEFAULT NULL COMMENT '接入运营商',
  `province` varchar(50) DEFAULT NULL COMMENT '省份',
  `betweentime` int(11) DEFAULT NULL COMMENT '停留时间',
  `datestr` varchar(20) DEFAULT NULL COMMENT '时间',
  `keyword` varchar(100) DEFAULT NULL COMMENT '搜索引擎关键词',
  `source` varchar(50) DEFAULT NULL COMMENT '来源',
  `title` varchar(255) DEFAULT NULL COMMENT '标题',
  `url` text DEFAULT NULL COMMENT '来源URL',
  `useragent` text COMMENT 'UA',
  `invitetimes` int(11) DEFAULT NULL COMMENT '要求次数',
  `invitestatus` varchar(10) DEFAULT NULL COMMENT '邀请状态',
  `refusetimes` int(11) DEFAULT NULL COMMENT '拒绝次数',
  `channel` varchar(32) DEFAULT NULL COMMENT '渠道',
  `appid` varchar(32) DEFAULT NULL COMMENT 'SNSID',
  `contactsid` varchar(32) DEFAULT NULL COMMENT '联系人ID',
  `headimgurl` varchar(300) DEFAULT NULL COMMENT '访客头像',
  PRIMARY KEY (`id`) USING BTREE,
  KEY `onlineuser_userid` (`userid`) USING BTREE,
  KEY `onlineuser_orgi` (`orgi`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='在线访客信息表';

-- ----------------------------
-- Records of uk_onlineuser
-- ----------------------------

-- ----------------------------
-- Table structure for uk_onlineuser_his
-- ----------------------------
DROP TABLE IF EXISTS `uk_onlineuser_his`;
CREATE TABLE `uk_onlineuser_his` (
  `assignedto` varchar(255) NOT NULL DEFAULT '' COMMENT '分配给目标',
  `creater` varchar(255) DEFAULT NULL COMMENT '创建人',
  `datastatus` varchar(255) DEFAULT NULL COMMENT '时间状态',
  `id` varchar(32) NOT NULL COMMENT '主键ID',
  `impid` varchar(255) DEFAULT NULL COMMENT '批次ID',
  `ipcode` varchar(255) DEFAULT NULL COMMENT 'IP编码',
  `orgi` varchar(255) DEFAULT NULL COMMENT '租户ID',
  `owner` varchar(255) DEFAULT NULL COMMENT '所属用户',
  `processid` varchar(255) DEFAULT NULL COMMENT '流程ID',
  `shares` varchar(255) DEFAULT NULL COMMENT '分享给',
  `updatetime` datetime DEFAULT NULL COMMENT '更新时间',
  `updateuser` varchar(255) DEFAULT NULL COMMENT '更新用户',
  `username` varchar(255) DEFAULT NULL COMMENT '用户名',
  `wfstatus` varchar(255) DEFAULT NULL COMMENT '流程状态',
  `resolution` varchar(255) DEFAULT NULL COMMENT '分辨率',
  `opersystem` varchar(100) DEFAULT NULL COMMENT '操作系统',
  `ip` varchar(50) DEFAULT NULL COMMENT 'IP',
  `hostname` varchar(32) DEFAULT NULL COMMENT '主机名称',
  `browser` varchar(32) DEFAULT NULL COMMENT '浏览器',
  `status` varchar(11) DEFAULT NULL COMMENT '状态',
  `userid` varchar(52) DEFAULT NULL COMMENT '用户ID',
  `logintime` datetime DEFAULT NULL COMMENT '访问时间',
  `sessionid` varchar(100) DEFAULT NULL COMMENT '会话ID',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `usertype` varchar(52) DEFAULT NULL COMMENT '访客类型',
  `optype` varchar(52) DEFAULT NULL COMMENT '操作类型',
  `mobile` varchar(10) DEFAULT NULL COMMENT '移动端',
  `olduser` varchar(10) DEFAULT NULL COMMENT '老用户',
  `country` varchar(50) DEFAULT NULL COMMENT '访客国家',
  `region` varchar(200) DEFAULT NULL COMMENT '访客区域',
  `city` varchar(50) DEFAULT NULL COMMENT '城市',
  `isp` varchar(100) DEFAULT NULL COMMENT '接入运营商',
  `province` varchar(50) DEFAULT NULL COMMENT '省份',
  `betweentime` int(11) DEFAULT NULL COMMENT '停留时间',
  `datestr` varchar(20) DEFAULT NULL COMMENT '时间',
  `keyword` varchar(100) DEFAULT NULL COMMENT '搜索引擎关键词',
  `source` varchar(50) DEFAULT NULL COMMENT '来源',
  `title` varchar(255) DEFAULT NULL COMMENT '标题',
  `url` text DEFAULT NULL COMMENT '来源URL',
  `useragent` text COMMENT 'UA',
  `invitetimes` int(11) DEFAULT NULL COMMENT '要求次数',
  `invitestatus` varchar(10) DEFAULT NULL COMMENT '邀请状态',
  `refusetimes` int(11) DEFAULT NULL COMMENT '拒绝次数',
  `channel` varchar(32) DEFAULT NULL COMMENT '渠道',
  `appid` varchar(32) DEFAULT NULL COMMENT 'SNSID',
  `contactsid` varchar(32) DEFAULT NULL COMMENT '联系人ID',
  `dataid` varchar(32) DEFAULT NULL COMMENT '关联的OnlineUser数据ID',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='在线访客访问历史表';

-- ----------------------------
-- Records of uk_onlineuser_his
-- ----------------------------

-- ----------------------------
-- Table structure for uk_orderscomment
-- ----------------------------
DROP TABLE IF EXISTS `uk_orderscomment`;
CREATE TABLE `uk_orderscomment` (
  `ID` varchar(32) NOT NULL COMMENT '主键ID',
  `USERNAME` varchar(50) DEFAULT NULL COMMENT '用户名',
  `CREATER` varchar(32) DEFAULT NULL COMMENT '创建人ID',
  `CREATETIME` datetime DEFAULT NULL COMMENT '创建时间',
  `DATAID` varchar(32) DEFAULT NULL COMMENT '数据记录ID',
  `CONTENT` text COMMENT '回复内容',
  `UPDATETIME` datetime DEFAULT NULL COMMENT '更新时间',
  `OPTIMAL` tinyint(4) DEFAULT NULL COMMENT '操作次数',
  `PRIREP` tinyint(4) DEFAULT NULL COMMENT '是否私有回复',
  `UP` int(11) DEFAULT NULL COMMENT '点赞',
  `COMMENTS` int(11) DEFAULT NULL COMMENT '回复数量',
  `ADMIN` tinyint(4) DEFAULT NULL COMMENT '是否管理员',
  `DATASTATUS` tinyint(4) DEFAULT NULL COMMENT '数据状态',
  `ORGI` varchar(50) DEFAULT NULL COMMENT '租户ID',
  `CATE` varchar(32) DEFAULT NULL COMMENT '分类',
  `OPTYPE` varchar(32) DEFAULT NULL COMMENT '操作类型',
  `IPCODE` varchar(100) DEFAULT NULL COMMENT 'IP编码',
  `COUNTRY` varchar(100) DEFAULT NULL COMMENT '国家',
  `PROVINCE` varchar(100) DEFAULT NULL COMMENT '省份',
  `CITY` varchar(100) DEFAULT NULL COMMENT '城市',
  `ISP` varchar(100) DEFAULT NULL COMMENT '运营商',
  `REGION` varchar(100) DEFAULT NULL COMMENT '地区',
  `ROWCOUNT` int(11) DEFAULT NULL COMMENT '编号',
  `KEY` varchar(100) DEFAULT NULL COMMENT '关键词',
  `APPROVAL` varchar(20) DEFAULT NULL COMMENT '审批',
  `RETBACK` varchar(20) DEFAULT NULL COMMENT '退回',
  `ACCDEPT` varchar(32) DEFAULT NULL COMMENT '转办部门',
  `ACCUSER` varchar(32) DEFAULT NULL COMMENT '转办用户',
  PRIMARY KEY (`ID`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='工单评论/回复表';

-- ----------------------------
-- Table structure for uk_organ
-- ----------------------------
DROP TABLE IF EXISTS `uk_organ`;
CREATE TABLE `uk_organ` (
  `ID` varchar(32) NOT NULL COMMENT '主键ID',
  `NAME` varchar(50) DEFAULT NULL COMMENT '名称',
  `CODE` varchar(50) DEFAULT NULL COMMENT '代码',
  `CREATETIME` datetime DEFAULT NULL COMMENT '创建时间',
  `CREATER` varchar(32) DEFAULT NULL COMMENT '创建人',
  `UPDATETIME` datetime DEFAULT NULL COMMENT '更新时间',
  `ORGI` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `ORGID` varchar(32) DEFAULT NULL COMMENT '企业ID',
  `USERNAME` varchar(50) DEFAULT NULL COMMENT '用户名',
  `PARENT` varchar(32) DEFAULT NULL COMMENT '父级ID',
  `SKILL` tinyint(4) DEFAULT '0' COMMENT '启用技能组',
  `area` text,
  PRIMARY KEY (`ID`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='部门表';

-- ----------------------------
-- Records of uk_organ
-- ----------------------------
BEGIN;
INSERT INTO `uk_organ` VALUES ('4028a0866f9403f1016f9405a05d000e', '我的企业', NULL, NULL, NULL, NULL, 'cskefu', 'cskefu', NULL, '0', 0, '');
COMMIT;

-- ----------------------------
-- Table structure for cs_organ_user
-- ----------------------------
DROP TABLE IF EXISTS `cs_organ_user`;
CREATE TABLE `cs_organ_user` (
  `userid` varchar(32) NOT NULL COMMENT '用户ID',
  `organ` varchar(32) NOT NULL COMMENT '组织机构ID',
  `createtime` datetime DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
  `creator` varchar(32) DEFAULT NULL COMMENT '创建人',
  `updatetime` datetime DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '更新时间',
  `orgi` varchar(32) DEFAULT NULL COMMENT '租户ID'
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='部门人员表';

alter table cs_organ_user add primary key (userid, organ);

-- ----------------------------
-- Records of cs_organ_user
-- ----------------------------
BEGIN;
INSERT INTO `cs_organ_user` VALUES ('4028cac3614cd2f901614cf8be1f0324', '4028a0866f9403f1016f9405a05d000e', NULL, '4028cac3614cd2f901614cf8be1f0324', NULL, NULL);
COMMIT;

-- ----------------------------
-- Table structure for uk_organization
-- ----------------------------
DROP TABLE IF EXISTS `uk_organization`;
CREATE TABLE `uk_organization` (
  `id` varchar(32) NOT NULL DEFAULT '' COMMENT '机构ID',
  `name` varchar(255) DEFAULT NULL COMMENT '名称',
  `orgtype` varchar(255) DEFAULT NULL COMMENT '类型',
  `orgscale` varchar(255) DEFAULT NULL COMMENT '规模',
  `orgindustry` varchar(255) DEFAULT NULL COMMENT '行业',
  `code` varchar(255) DEFAULT NULL COMMENT '代码',
  `memo` varchar(200) DEFAULT NULL COMMENT '备注',
  `logo` varchar(200) DEFAULT NULL COMMENT 'LOGO URL',
  `createtime` timestamp NULL DEFAULT NULL ON UPDATE CURRENT_TIMESTAMP COMMENT '创建时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='企业信息表';

-- ----------------------------
-- Table structure for uk_organrole
-- ----------------------------
DROP TABLE IF EXISTS `uk_organrole`;
CREATE TABLE `uk_organrole` (
  `id` varchar(32) NOT NULL COMMENT '主键ID',
  `organ_id` varchar(32) DEFAULT NULL COMMENT '机构ID',
  `role_id` varchar(32) DEFAULT NULL COMMENT '角色ID',
  `creater` varchar(32) DEFAULT NULL COMMENT '创建人',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `orgi` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `dicid` varchar(32) DEFAULT NULL COMMENT '目录ID',
  `dicvalue` varchar(50) DEFAULT NULL COMMENT '目录名称',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='部门授权表';

-- ----------------------------
-- Table structure for uk_orgi_skill_rel
-- ----------------------------
DROP TABLE IF EXISTS `uk_orgi_skill_rel`;
CREATE TABLE `uk_orgi_skill_rel` (
  `ID` varchar(32) NOT NULL COMMENT '主键ID',
  `SKILLID` varchar(50) DEFAULT NULL COMMENT '技能组',
  `CREATETIME` datetime DEFAULT NULL COMMENT '创建时间',
  `CREATER` varchar(32) DEFAULT NULL COMMENT '创建人',
  `UPDATETIME` datetime DEFAULT NULL COMMENT '更新时间',
  `ORGI` varchar(32) DEFAULT NULL COMMENT '租户ID',
  PRIMARY KEY (`ID`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='租户角色映射表';

-- ----------------------------
-- Table structure for uk_propertiesevent
-- ----------------------------
DROP TABLE IF EXISTS `uk_propertiesevent`;
CREATE TABLE `uk_propertiesevent` (
  `id` varchar(32) NOT NULL COMMENT '主键ID',
  `name` varchar(50) DEFAULT NULL COMMENT '名称',
  `tpid` varchar(32) DEFAULT NULL COMMENT '字段ID',
  `propertity` varchar(50) DEFAULT NULL COMMENT '字段',
  `field` varchar(50) DEFAULT NULL COMMENT '阻断名称',
  `newvalue` varchar(255) DEFAULT NULL COMMENT '变更后的值',
  `oldvalue` varchar(255) DEFAULT NULL COMMENT '变更前的值',
  `orgi` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `modifyid` varchar(32) DEFAULT NULL COMMENT '修改ID',
  `creater` varchar(32) DEFAULT NULL COMMENT '创建人',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `dataid` varchar(32) DEFAULT NULL COMMENT '数据记录ID',
  `textvalue` varchar(255) DEFAULT NULL COMMENT '文本值',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='字段变更记录';

-- ----------------------------
-- Table structure for uk_publishedcube
-- ----------------------------
DROP TABLE IF EXISTS `uk_publishedcube`;
CREATE TABLE `uk_publishedcube` (
  `ID` varchar(32) NOT NULL COMMENT '主键ID',
  `NAME` varchar(255) DEFAULT NULL COMMENT '名称',
  `CREATETIME` datetime DEFAULT NULL COMMENT '创建时间',
  `DB` varchar(32) DEFAULT NULL COMMENT '数据ID',
  `ORGI` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `MPOSLEFT` varchar(32) DEFAULT NULL COMMENT '位置',
  `MPOSTOP` varchar(32) DEFAULT NULL COMMENT '距顶位置',
  `TYPEID` varchar(32) DEFAULT NULL COMMENT '分类ID',
  `CODE` varchar(32) DEFAULT NULL COMMENT '代码',
  `DSTYPE` varchar(255) DEFAULT NULL COMMENT '数据源类型',
  `MODELTYPE` varchar(32) DEFAULT NULL COMMENT '模型类型',
  `createdata` varchar(32) DEFAULT NULL COMMENT '创建数据',
  `startindex` int(11) DEFAULT NULL COMMENT '开始位置',
  `startdate` datetime DEFAULT NULL COMMENT '开始时间',
  `dataid` varchar(32) DEFAULT NULL COMMENT '数据ID',
  `dataflag` varchar(255) DEFAULT NULL COMMENT '数据标识',
  `DATAVERSION` int(11) DEFAULT NULL COMMENT '版本',
  `CREATER` varchar(255) DEFAULT NULL COMMENT '创建人',
  `USERID` varchar(32) DEFAULT NULL COMMENT '用户ID',
  `USERNAME` varchar(255) DEFAULT NULL COMMENT '用户名',
  `CUBECONTENT` longtext COMMENT '序列化的模型数据',
  `DBID` varchar(32) DEFAULT NULL COMMENT '数据ID',
  `DICLOCATION` varchar(255) DEFAULT NULL COMMENT '目录位置',
  `USEREMAIL` varchar(255) DEFAULT NULL COMMENT '用户邮件',
  PRIMARY KEY (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='已发布模型';

-- ----------------------------
-- Table structure for uk_publishedreport
-- ----------------------------
DROP TABLE IF EXISTS `uk_publishedreport`;
CREATE TABLE `uk_publishedreport` (
  `ID` varchar(32) NOT NULL COMMENT '组件ID',
  `NAME` varchar(255) DEFAULT NULL COMMENT '名称',
  `CREATETIME` datetime DEFAULT NULL COMMENT '创建时间',
  `ORGI` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `DICID` varchar(32) DEFAULT NULL COMMENT '目录ID',
  `CODE` varchar(32) DEFAULT NULL COMMENT '代码',
  `reporttype` varchar(255) DEFAULT NULL COMMENT '报表类型',
  `startindex` int(11) DEFAULT NULL COMMENT '开始位置',
  `startdate` datetime DEFAULT NULL COMMENT '开始时间',
  `dataid` varchar(32) DEFAULT NULL COMMENT '数据ID',
  `dataflag` varchar(255) DEFAULT NULL COMMENT '数据标识',
  `DATAVERSION` int(11) DEFAULT NULL COMMENT '数据版本',
  `CREATER` varchar(255) DEFAULT NULL COMMENT '创建人',
  `REPORTCONTENT` longtext COMMENT '报表内容',
  PRIMARY KEY (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='已发布报表';

-- ----------------------------
-- Table structure for uk_quality
-- ----------------------------
DROP TABLE IF EXISTS `uk_quality`;
CREATE TABLE `uk_quality` (
  `ID` varchar(32) NOT NULL COMMENT '主键ID',
  `NAME` varchar(50) DEFAULT NULL COMMENT '质检名称',
  `CODE` varchar(50) DEFAULT NULL COMMENT '代码',
  `CREATETIME` datetime DEFAULT NULL COMMENT '创建时间',
  `CREATER` varchar(32) DEFAULT NULL COMMENT '创建人',
  `UPDATETIME` datetime DEFAULT NULL COMMENT '更新时间',
  `ORGI` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `USERNAME` varchar(50) DEFAULT NULL COMMENT '用户名',
  `PARENTID` varchar(32) DEFAULT NULL COMMENT '知识库分类上级ID',
  `STARTDATE` datetime DEFAULT NULL COMMENT '有效期开始时间',
  `ENDDATE` datetime DEFAULT NULL COMMENT '有效期结束时间',
  `ENABLE` tinyint(4) DEFAULT NULL COMMENT '分类状态',
  `SCORE` int(11) DEFAULT '0' COMMENT '分值',
  `DESCRIPTION` varchar(255) DEFAULT NULL COMMENT '分类描述',
  `QUALITYTYPE` varchar(50) DEFAULT NULL COMMENT '质检方式',
  PRIMARY KEY (`ID`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='质检表';

-- ----------------------------
-- Table structure for uk_que_survey_answer
-- ----------------------------
DROP TABLE IF EXISTS `uk_que_survey_answer`;
CREATE TABLE `uk_que_survey_answer` (
  `id` varchar(32) NOT NULL,
  `questionid` varchar(32) DEFAULT NULL COMMENT '问题ID',
  `questionname` varchar(255) DEFAULT NULL COMMENT '问题名称',
  `answer` text COMMENT '问题答案',
  `queid` varchar(32) DEFAULT NULL COMMENT '跳转问题ID',
  `answerscore` int(11) DEFAULT '0' COMMENT '答案评分',
  `orgi` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `creater` varchar(32) DEFAULT NULL COMMENT '创建人',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `updatetime` datetime DEFAULT NULL COMMENT '更新时间',
  `processid` varchar(32) DEFAULT NULL COMMENT '问卷ID',
  `correct` varchar(32) DEFAULT NULL COMMENT '是否是正确答案（0正确1不正确）',
  `hanguptype` varchar(32) DEFAULT NULL COMMENT '挂断提示语类型',
  `hangupmsg` varchar(255) DEFAULT NULL COMMENT '挂断提示语文字',
  `hangupvoice` varchar(32) DEFAULT NULL COMMENT '挂断提示语语音',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='问卷调查-问题答案表';

-- ----------------------------
-- Table structure for uk_que_survey_process
-- ----------------------------
DROP TABLE IF EXISTS `uk_que_survey_process`;
CREATE TABLE `uk_que_survey_process` (
  `id` varchar(32) NOT NULL,
  `name` varchar(32) DEFAULT NULL COMMENT '问卷名称',
  `scene` varchar(32) DEFAULT NULL COMMENT '问卷适用场景（机器人呼出/坐席手动）',
  `welword` varchar(255) DEFAULT NULL COMMENT '问卷欢迎语（文字）',
  `welvoice` varchar(255) DEFAULT NULL COMMENT '问卷欢迎语ID（语音）',
  `weltype` varchar(32) DEFAULT NULL COMMENT '问卷欢迎语类型',
  `endword` varchar(255) DEFAULT NULL COMMENT '问卷结束语（文字）',
  `endvoice` varchar(255) DEFAULT NULL COMMENT '问卷结束语ID（语音）',
  `endtype` varchar(32) DEFAULT NULL COMMENT '问卷结束语类型',
  `totalscore` varchar(32) DEFAULT NULL COMMENT '参考评分值',
  `score` varchar(32) DEFAULT '0' COMMENT '是否评分（0否1是）',
  `memo` text COMMENT '备注',
  `orgi` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `creater` varchar(32) DEFAULT NULL COMMENT '创建人',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `updater` varchar(32) DEFAULT NULL COMMENT '更新人',
  `updatetime` datetime DEFAULT NULL COMMENT '更新时间',
  `prostatus` varchar(32) DEFAULT '0' COMMENT '问卷状态（0未发布1发布）',
  `sumscore` varchar(32) DEFAULT NULL COMMENT '总评分值',
  `description` text COMMENT '描述',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='问卷调查表';

-- ----------------------------
-- Table structure for uk_que_survey_question
-- ----------------------------
DROP TABLE IF EXISTS `uk_que_survey_question`;
CREATE TABLE `uk_que_survey_question` (
  `id` varchar(32) NOT NULL,
  `name` varchar(255) DEFAULT NULL COMMENT '问题名称',
  `sortindex` int(11) DEFAULT '0' COMMENT '问题序号',
  `quetype` int(11) DEFAULT '0' COMMENT '问题类型（0选择题1问答题）',
  `orgi` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `creater` varchar(32) DEFAULT NULL COMMENT '创建人',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `updatetime` datetime DEFAULT NULL COMMENT '更新时间',
  `description` text COMMENT '描述',
  `memo` text COMMENT '备注',
  `score` int(11) DEFAULT NULL COMMENT '问题分值',
  `processid` varchar(32) DEFAULT NULL COMMENT '问卷ID',
  `wvtype` varchar(32) DEFAULT NULL COMMENT '类型（文字/语音）',
  `quevoice` varchar(32) DEFAULT NULL COMMENT '语音ID',
  `confirmtype` varchar(32) DEFAULT NULL COMMENT '答案确认语类型',
  `confirmword` varchar(255) DEFAULT NULL COMMENT '答案确认语文字',
  `confirmvoice` varchar(255) DEFAULT NULL COMMENT '答案确认语语音',
  `overtimetype` varchar(255) DEFAULT NULL COMMENT '回答超时语',
  `overtimeword` varchar(255) DEFAULT NULL COMMENT '回答超时语文字',
  `overtimevoice` varchar(255) DEFAULT NULL COMMENT '回答超时语语音',
  `errortype` varchar(255) DEFAULT NULL COMMENT '回答错误语',
  `errorword` varchar(255) DEFAULT NULL COMMENT '回答错误语文字',
  `errorvoice` varchar(255) DEFAULT NULL COMMENT '回答错误语语音',
  `replykeyword` varchar(255) DEFAULT NULL COMMENT '关键词重复',
  `replytype` varchar(255) DEFAULT NULL COMMENT '重复提示类型',
  `replyword` varchar(255) DEFAULT NULL COMMENT '重复提示语文字',
  `replyvoice` varchar(255) DEFAULT NULL COMMENT '重复提示语语音',
  `replyrepeat` varchar(32) DEFAULT NULL COMMENT '重复确认语-最大重复次数',
  `replyoperate` varchar(32) DEFAULT NULL COMMENT '重复确认语-到达最大次数的操作（转接trans/挂断/handup）',
  `replytrans` varchar(32) DEFAULT NULL COMMENT '重复确认语-转接号码',
  `replytypeup` varchar(32) DEFAULT NULL COMMENT '重复确认语-转接号码',
  `replywordup` varchar(255) DEFAULT NULL COMMENT '重复确认语-挂断提示语（文字）',
  `replyvoiceup` varchar(32) DEFAULT NULL COMMENT '重复确认语-挂断提示语（语音ID）',
  `overtimerepeat` varchar(32) DEFAULT NULL COMMENT '回答超时语-最大重复次数',
  `overtimeoperate` varchar(32) DEFAULT NULL COMMENT '回答超时语-到达最大次数的操作（转接trans/挂断/handup）',
  `overtimetrans` varchar(32) DEFAULT NULL COMMENT '回答超时语-转接号码',
  `overtimetypeup` varchar(32) DEFAULT NULL COMMENT '回答超时语-挂断提示语类型',
  `overtimewordup` varchar(255) DEFAULT NULL COMMENT '回答超时语-挂断提示语（文字）',
  `overtimevoiceup` varchar(32) DEFAULT NULL COMMENT '回答超时语-挂断提示语（语音ID）',
  `errorepeat` varchar(32) DEFAULT NULL COMMENT '回答错误语-最大重复次数',
  `erroroperate` varchar(32) DEFAULT NULL COMMENT '回答错误语-到达最大次数的操作（转接trans/挂断/handup）',
  `errortrans` varchar(32) DEFAULT NULL COMMENT '回答错误语-转接号码',
  `errortypeup` varchar(32) DEFAULT NULL COMMENT '回答错误语-挂断提示语类型',
  `errorwordup` varchar(255) DEFAULT NULL COMMENT '回答错误语-挂断提示语（文字）',
  `errorvoiceup` varchar(32) DEFAULT NULL COMMENT '回答错误语-挂断提示语（语音ID）',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='问卷调查-问题表';

-- ----------------------------
-- Table structure for uk_recentuser
-- ----------------------------
DROP TABLE IF EXISTS `uk_recentuser`;
CREATE TABLE `uk_recentuser` (
  `id` varchar(32) NOT NULL COMMENT '主键ID',
  `creater` varchar(32) DEFAULT NULL COMMENT '创建人ID',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `updatetime` datetime DEFAULT NULL COMMENT '更新时间',
  `name` varchar(100) DEFAULT NULL COMMENT '名称',
  `orgi` varchar(100) DEFAULT NULL COMMENT '租户ID',
  `user_id` varchar(32) DEFAULT NULL COMMENT '用户ID',
  `lastmsg` text COMMENT '最后一条消息',
  `newmsg` int(11) DEFAULT NULL COMMENT '未读消息数量',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='公共已读消息';

-- ----------------------------
-- Table structure for uk_report
-- ----------------------------
DROP TABLE IF EXISTS `uk_report`;
CREATE TABLE `uk_report` (
  `ID` varchar(32) NOT NULL COMMENT '主键ID',
  `NAME` varchar(255) DEFAULT NULL COMMENT '报表名称',
  `REPORTTYPE` varchar(32) DEFAULT NULL COMMENT '报表类型',
  `TITLE` varchar(255) DEFAULT NULL COMMENT '主题',
  `ORGI` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `OBJECTCOUNT` int(11) DEFAULT NULL COMMENT '模板内容',
  `DICID` varchar(32) DEFAULT NULL COMMENT '目录ID',
  `CREATETIME` datetime DEFAULT NULL COMMENT '创建时间',
  `DESCRIPTION` longtext COMMENT '描述内容',
  `HTML` longtext COMMENT '代码',
  `REPORTPACKAGE` varchar(255) DEFAULT NULL COMMENT '路径',
  `USEACL` varchar(32) DEFAULT NULL COMMENT '访问授权',
  `status` varchar(32) DEFAULT NULL COMMENT '状态',
  `rolename` text COMMENT '角色名称',
  `userid` text COMMENT '用户ID',
  `blacklist` text COMMENT '黑名单列表',
  `REPORTCONTENT` longtext COMMENT '报表序列化代码',
  `reportmodel` varchar(32) DEFAULT NULL COMMENT '报表模型',
  `updatetime` datetime DEFAULT NULL COMMENT '更新时间',
  `creater` varchar(255) DEFAULT NULL COMMENT '创建人',
  `reportversion` int(11) DEFAULT NULL COMMENT '版本',
  `publishedtype` varchar(32) DEFAULT NULL COMMENT '发布状态',
  `tabtype` varchar(32) DEFAULT NULL COMMENT '切换方式',
  `USERNAME` varchar(32) DEFAULT NULL COMMENT '用户名',
  `USEREMAIL` varchar(255) DEFAULT NULL COMMENT '用户信息',
  `CACHE` smallint(6) DEFAULT NULL COMMENT '是否启用缓存',
  `EXTPARAM` varchar(255) DEFAULT NULL COMMENT '导出参数',
  `TARGETREPORT` varchar(32) DEFAULT NULL COMMENT '目标报表',
  `DATASTATUS` tinyint(4) DEFAULT NULL COMMENT '报表状态',
  `CODE` varchar(100) DEFAULT NULL COMMENT '代码',
  `SOURCE` varchar(50) DEFAULT NULL COMMENT '数据源',
  `VIEWTYPE` varchar(32) DEFAULT NULL COMMENT '视图类型',
  PRIMARY KEY (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='报表数据表';

-- ----------------------------
-- Table structure for uk_reportfilter
-- ----------------------------
DROP TABLE IF EXISTS `uk_reportfilter`;
CREATE TABLE `uk_reportfilter` (
  `id` varchar(32) NOT NULL DEFAULT '' COMMENT '主键ID',
  `dataid` varchar(32) DEFAULT NULL COMMENT '数据ID',
  `dataname` varchar(255) DEFAULT NULL COMMENT '数据名称',
  `modelid` varchar(32) DEFAULT NULL COMMENT '组件ID',
  `reportid` varchar(32) DEFAULT NULL COMMENT '报表ID',
  `contype` varchar(32) DEFAULT NULL COMMENT '链接类型',
  `filtertype` varchar(32) DEFAULT NULL COMMENT '筛选器类型',
  `formatstr` varchar(255) DEFAULT NULL COMMENT '格式化字符串',
  `convalue` varchar(255) DEFAULT NULL COMMENT '数据值',
  `userdefvalue` text COMMENT '默认数据',
  `valuefiltertype` varchar(255) DEFAULT NULL COMMENT '筛选器值类型',
  `name` varchar(255) DEFAULT NULL COMMENT '名称',
  `code` varchar(32) DEFAULT NULL COMMENT '代码',
  `orgi` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `content` text COMMENT '内容',
  `valuestr` varchar(255) DEFAULT NULL COMMENT '数据值字符串',
  `filterprefix` varchar(255) DEFAULT NULL COMMENT '过滤器前缀',
  `filtersuffix` varchar(255) DEFAULT NULL COMMENT '过滤器后缀',
  `modeltype` varchar(32) DEFAULT NULL COMMENT '元素类型',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `funtype` varchar(32) DEFAULT NULL COMMENT '业务类型',
  `measureid` varchar(32) DEFAULT NULL COMMENT '指标ID',
  `valuecompare` varchar(32) DEFAULT NULL COMMENT '值',
  `defaultvalue` text COMMENT '默认值',
  `comparetype` varchar(32) DEFAULT NULL COMMENT '筛选比较类型',
  `title` varchar(255) DEFAULT NULL COMMENT '标题',
  `cubeid` varchar(32) DEFAULT NULL COMMENT '模型ID',
  `mustvalue` varchar(32) DEFAULT NULL COMMENT '必选值',
  `groupids` text COMMENT '分组ID',
  `defaultvaluerule` text COMMENT '默认值',
  `dimid` varchar(32) DEFAULT NULL COMMENT '维度ID',
  `endvalue` text COMMENT '范围值',
  `filtertemplet` varchar(255) DEFAULT NULL COMMENT '筛选器模板',
  `noformatvalue` text COMMENT '未格式化值',
  `startvalue` varchar(255) DEFAULT NULL COMMENT '筛选范围值',
  `sortindex` int(11) DEFAULT NULL COMMENT '排序位置',
  `cascadeid` varchar(32) DEFAULT NULL COMMENT '引用ID',
  `tableproperty` varchar(32) DEFAULT NULL COMMENT '数据字段ID',
  `tableid` varchar(32) DEFAULT NULL COMMENT '数据表ID',
  `fieldid` varchar(32) DEFAULT NULL COMMENT '字段ID',
  `fktableid` varchar(32) DEFAULT NULL COMMENT '外键表ID',
  `filterfieldid` varchar(32) DEFAULT NULL COMMENT '外键字段ID',
  `isdic` tinyint(4) DEFAULT NULL COMMENT '是否目录',
  `diccode` varchar(255) DEFAULT NULL COMMENT '显示值',
  `keyfield` varchar(32) DEFAULT NULL COMMENT '主键字段',
  `valuefield` varchar(32) DEFAULT NULL COMMENT '取值字段',
  `fkfieldid` varchar(32) DEFAULT NULL COMMENT '外键字段ID',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='报表筛选器';

-- ----------------------------
-- Table structure for uk_reportmodel
-- ----------------------------
DROP TABLE IF EXISTS `uk_reportmodel`;
CREATE TABLE `uk_reportmodel` (
  `id` varchar(50) NOT NULL COMMENT '主键ID',
  `posx` varchar(50) DEFAULT NULL COMMENT '位置',
  `posy` varchar(50) DEFAULT NULL COMMENT '位置',
  `poswidth` varchar(50) DEFAULT NULL COMMENT '宽度',
  `posheight` varchar(50) DEFAULT NULL COMMENT '高度',
  `name` varchar(50) DEFAULT NULL COMMENT '名称',
  `code` varchar(50) DEFAULT NULL COMMENT '代码',
  `reportid` varchar(50) DEFAULT NULL COMMENT '报表ID',
  `modeltype` varchar(50) DEFAULT NULL COMMENT '元素类型',
  `sortindex` int(11) DEFAULT NULL COMMENT '排序位置',
  `stylestr` varchar(50) DEFAULT NULL COMMENT '样式',
  `labeltext` varchar(50) DEFAULT NULL COMMENT '标签',
  `cssclassname` varchar(50) DEFAULT NULL COMMENT '样式名称',
  `mposleft` varchar(50) DEFAULT NULL COMMENT '原生位置',
  `mpostop` varchar(50) DEFAULT NULL COMMENT '元素位置',
  `title` varchar(50) DEFAULT NULL COMMENT '标题',
  `exchangerw` tinyint(4) DEFAULT '0' COMMENT '行列交换',
  `publishedcubeid` varchar(50) DEFAULT NULL COMMENT '模型ID',
  `rowdimension` text COMMENT '行维度',
  `coldimension` text COMMENT '列维度',
  `measure` varchar(50) DEFAULT NULL COMMENT '指标',
  `dstype` varchar(50) DEFAULT NULL COMMENT '数据源类型',
  `dbtype` varchar(50) DEFAULT NULL COMMENT '数据类型',
  `orgi` varchar(50) DEFAULT NULL COMMENT '租户ID',
  `objectid` varchar(50) DEFAULT NULL COMMENT '对象ID',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `filterstr` varchar(50) DEFAULT NULL COMMENT '过滤器字符串',
  `sortstr` varchar(50) DEFAULT NULL COMMENT '排序字符串',
  `viewtype` varchar(50) DEFAULT NULL COMMENT '视图类型',
  `chartemplet` varchar(50) DEFAULT NULL COMMENT '图表模板',
  `chartype` varchar(50) DEFAULT NULL COMMENT '图表类型',
  `chartdatatype` varchar(50) DEFAULT NULL COMMENT '图表数据类型',
  `chart3d` varchar(50) DEFAULT NULL COMMENT '是否3D显示图表',
  `xtitle` varchar(50) DEFAULT NULL COMMENT '列标题',
  `ytitle` varchar(50) DEFAULT NULL COMMENT '行标题',
  `charttitle` varchar(50) DEFAULT NULL COMMENT '图表标题',
  `displayborder` varchar(50) DEFAULT NULL COMMENT '显示边框',
  `bordercolor` varchar(50) DEFAULT NULL COMMENT '边框颜色',
  `displaydesc` varchar(50) DEFAULT NULL COMMENT '倒序显示',
  `formdisplay` varchar(50) DEFAULT NULL COMMENT '显示表单',
  `labelstyle` varchar(50) DEFAULT NULL COMMENT '标签',
  `formname` varchar(50) DEFAULT NULL COMMENT '表单名称',
  `defaultvalue` varchar(50) DEFAULT NULL COMMENT '默认值',
  `querytext` varchar(50) DEFAULT NULL COMMENT '查询语句',
  `tempquey` varchar(50) DEFAULT NULL COMMENT '查询语句',
  `displaytitle` tinyint(4) DEFAULT '0' COMMENT '显示标题',
  `clearzero` tinyint(4) DEFAULT '0' COMMENT '除零',
  `titlestr` varchar(50) DEFAULT NULL COMMENT '标题字符串',
  `width` varchar(50) DEFAULT NULL COMMENT '宽度',
  `height` varchar(50) DEFAULT NULL COMMENT '高度',
  `widthunit` varchar(50) DEFAULT NULL COMMENT '宽度单位',
  `heightunit` varchar(50) DEFAULT NULL COMMENT '高度单位',
  `defheight` varchar(50) DEFAULT NULL COMMENT '定义高度',
  `defwidth` varchar(50) DEFAULT NULL COMMENT '定义宽度',
  `neckwidth` varchar(50) DEFAULT NULL COMMENT '吸附宽度',
  `neckheight` varchar(50) DEFAULT NULL COMMENT '吸附高度',
  `extparam` varchar(50) DEFAULT NULL COMMENT '扩展参数',
  `marginright` varchar(50) DEFAULT NULL COMMENT '距离右侧空白',
  `colorstr` varchar(50) DEFAULT NULL COMMENT '颜色样式',
  `sstart` varchar(50) DEFAULT NULL COMMENT '开始',
  `send` varchar(50) DEFAULT NULL COMMENT '结束',
  `rowformatstr` varchar(50) DEFAULT NULL COMMENT '行格式化字符串',
  `colformatstr` varchar(50) DEFAULT NULL COMMENT '列格式化字符串',
  `publishtype` varchar(50) DEFAULT NULL COMMENT '发布状态',
  `editview` varchar(50) DEFAULT NULL COMMENT '编辑状态',
  `expandbtm` tinyint(4) DEFAULT '0' COMMENT '收缩位置',
  `expandrgt` tinyint(4) DEFAULT '0' COMMENT '收缩方式',
  `curtab` varchar(50) DEFAULT NULL COMMENT '当前页签',
  `hiddencolstr` varchar(50) DEFAULT NULL COMMENT '隐藏样式',
  `eventstr` varchar(50) DEFAULT NULL COMMENT '事件触发样式',
  `dsmodel` varchar(50) DEFAULT NULL COMMENT '数据源模型',
  `html` text COMMENT '代码',
  `sqldialect` varchar(255) DEFAULT NULL COMMENT '方言',
  `pagesize` int(11) DEFAULT NULL COMMENT '分页尺寸',
  `isloadfulldata` varchar(50) DEFAULT NULL COMMENT '全量数据',
  `isexport` tinyint(4) DEFAULT '0' COMMENT '导出',
  `selectdata` tinyint(4) DEFAULT '0' COMMENT '选中数据',
  `exporttitle` varchar(50) DEFAULT NULL COMMENT '导出标题',
  `colsize` int(11) DEFAULT NULL COMMENT '列尺寸',
  `sorttype` varchar(50) DEFAULT NULL COMMENT '排序类型',
  `sortname` varchar(50) DEFAULT NULL COMMENT '排序名称',
  `mid` varchar(32) DEFAULT NULL COMMENT '模型ID',
  `parentid` varchar(32) DEFAULT NULL COMMENT '父级ID',
  `templetid` varchar(32) DEFAULT NULL COMMENT '模板ID',
  `colspan` int(11) DEFAULT NULL COMMENT '合并列',
  `colindex` int(11) DEFAULT NULL COMMENT '列位置',
  `chartcontent` longtext COMMENT '图标代码',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='报表布局项';

-- ----------------------------
-- Table structure for uk_role
-- ----------------------------
DROP TABLE IF EXISTS `uk_role`;
CREATE TABLE `uk_role` (
  `ID` varchar(32) NOT NULL COMMENT '主键ID',
  `NAME` varchar(50) DEFAULT NULL COMMENT '名称',
  `CODE` varchar(50) DEFAULT NULL COMMENT '代码',
  `CREATETIME` datetime DEFAULT NULL COMMENT '创建时间',
  `CREATER` varchar(32) DEFAULT NULL COMMENT '创建人',
  `UPDATETIME` datetime DEFAULT NULL COMMENT '更新时间',
  `ORGI` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `ORGID` varchar(32) DEFAULT NULL COMMENT '企业ID',
  `USERNAME` varchar(50) DEFAULT NULL COMMENT '用户名',
  `ORGAN` varchar(32) DEFAULT NULL COMMENT '部门',
  PRIMARY KEY (`ID`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='角色表';

-- ----------------------------
-- Table structure for uk_role_auth
-- ----------------------------
DROP TABLE IF EXISTS `uk_role_auth`;
CREATE TABLE `uk_role_auth` (
  `ID` varchar(32) NOT NULL COMMENT '主键ID',
  `NAME` varchar(50) DEFAULT NULL COMMENT '名称',
  `CODE` varchar(50) DEFAULT NULL COMMENT '代码',
  `CREATETIME` datetime DEFAULT NULL COMMENT '创建时间',
  `CREATER` varchar(32) DEFAULT NULL COMMENT '创建人',
  `UPDATETIME` datetime DEFAULT NULL COMMENT '更新时间',
  `ORGI` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `USERNAME` varchar(50) DEFAULT NULL COMMENT '用户名',
  `ROLEID` varchar(32) DEFAULT NULL COMMENT '角色ID',
  `DICID` varchar(32) DEFAULT NULL COMMENT '权限ID',
  `DICVALUE` varchar(30) DEFAULT NULL COMMENT '权限代码',
  PRIMARY KEY (`ID`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='角色授权';

-- ----------------------------
-- Table structure for uk_sales_product
-- ----------------------------
DROP TABLE IF EXISTS `uk_sales_product`;
CREATE TABLE `uk_sales_product` (
  `id` varchar(32) NOT NULL COMMENT '数据ID',
  `title` varchar(255) DEFAULT NULL COMMENT '标题',
  `content` text COMMENT '内容',
  `keyword` varchar(100) DEFAULT NULL COMMENT '关键词',
  `summary` varchar(255) DEFAULT NULL COMMENT '摘要',
  `status` varchar(32) DEFAULT NULL COMMENT '状态',
  `tptype` varchar(32) DEFAULT NULL COMMENT '类型',
  `cate` varchar(32) DEFAULT NULL COMMENT '产品分类',
  `username` varchar(32) DEFAULT NULL COMMENT '创建人姓名',
  `orgi` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `creater` varchar(32) DEFAULT NULL COMMENT '创建人',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `updatetime` datetime DEFAULT NULL COMMENT '更新时间',
  `memo` varchar(32) DEFAULT NULL COMMENT '备注',
  `price` int(11) DEFAULT NULL COMMENT '价格',
  `organ` varchar(32) DEFAULT NULL COMMENT '部门',
  `termtype` varchar(32) DEFAULT '0' COMMENT '有效期类型（1永久有效，0有效期）',
  `begintime` datetime DEFAULT NULL COMMENT '有效期开始时间',
  `endtime` datetime DEFAULT NULL COMMENT '有效期结束时间',
  `parentid` varchar(32) DEFAULT NULL COMMENT '上级ID',
  `quota` int(11) DEFAULT '0' COMMENT '配额',
  `provoice` varchar(255) DEFAULT NULL COMMENT '语音介绍',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='电销产品';

-- ----------------------------
-- Table structure for uk_sales_product_type
-- ----------------------------
DROP TABLE IF EXISTS `uk_sales_product_type`;
CREATE TABLE `uk_sales_product_type` (
  `ID` varchar(32) NOT NULL COMMENT '数据ID',
  `NAME` varchar(50) DEFAULT NULL COMMENT '名称',
  `CODE` varchar(50) DEFAULT NULL COMMENT '代码',
  `CREATETIME` datetime DEFAULT NULL COMMENT '创建时间',
  `CREATER` varchar(32) DEFAULT NULL COMMENT '创建人',
  `UPDATETIME` datetime DEFAULT NULL COMMENT '更新时间',
  `ORGI` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `USERNAME` varchar(50) DEFAULT NULL COMMENT '用户名',
  `parentid` varchar(32) DEFAULT NULL COMMENT '上级产品分类',
  PRIMARY KEY (`ID`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='电销产品类型';

-- ----------------------------
-- Table structure for uk_sales_status
-- ----------------------------
DROP TABLE IF EXISTS `uk_sales_status`;
CREATE TABLE `uk_sales_status` (
  `id` varchar(32) NOT NULL COMMENT '数据ID',
  `name` varchar(255) DEFAULT NULL COMMENT '状态名',
  `code` varchar(255) DEFAULT NULL COMMENT '状态代码',
  `cate` varchar(32) DEFAULT NULL COMMENT '状态分类ID',
  `orgi` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `creater` varchar(32) DEFAULT NULL COMMENT '创建人',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `updatetime` datetime DEFAULT NULL COMMENT '更新时间',
  `memo` varchar(32) DEFAULT NULL COMMENT '备注',
  `activityid` varchar(32) DEFAULT NULL COMMENT '活动ID',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='电销状态';

-- ----------------------------
-- Table structure for uk_sales_status_type
-- ----------------------------
DROP TABLE IF EXISTS `uk_sales_status_type`;
CREATE TABLE `uk_sales_status_type` (
  `id` varchar(32) NOT NULL COMMENT '数据ID',
  `name` varchar(255) DEFAULT NULL COMMENT '状态分类名',
  `parentid` varchar(32) DEFAULT NULL COMMENT '父级ID',
  `orgi` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `creater` varchar(32) DEFAULT NULL COMMENT '创建人',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `updatetime` datetime DEFAULT NULL COMMENT '更新时间',
  `activityid` varchar(32) DEFAULT NULL COMMENT '活动ID',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='电销状态类型';

-- ----------------------------
-- Table structure for uk_secret
-- ----------------------------
DROP TABLE IF EXISTS `uk_secret`;
CREATE TABLE `uk_secret` (
  `id` varchar(32) NOT NULL COMMENT '主键ID',
  `creater` varchar(32) DEFAULT NULL COMMENT '创建人',
  `createtime` varchar(32) DEFAULT NULL COMMENT '创建时间',
  `password` varchar(100) DEFAULT NULL COMMENT '二次密码',
  `orgi` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `model` varchar(32) DEFAULT NULL COMMENT '所属组件',
  `enable` tinyint(4) DEFAULT NULL COMMENT '是否启用',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='二次验证信息表';

-- ----------------------------
-- Table structure for uk_servicesummary
-- ----------------------------
DROP TABLE IF EXISTS `uk_servicesummary`;
CREATE TABLE `uk_servicesummary` (
  `id` varchar(32) NOT NULL COMMENT '主键ID',
  `agentusername` varchar(100) DEFAULT NULL COMMENT '坐席用户名',
  `agentno` varchar(32) DEFAULT NULL COMMENT '坐席ID',
  `status` varchar(32) DEFAULT NULL COMMENT '状态',
  `times` int(11) DEFAULT NULL COMMENT '服务次数',
  `servicetime` datetime DEFAULT NULL COMMENT '服务时间',
  `orgi` varchar(50) DEFAULT NULL COMMENT '租户ID',
  `username` varchar(100) DEFAULT NULL COMMENT '用户名',
  `userid` varchar(32) DEFAULT NULL COMMENT '用户ID',
  `channel` varchar(32) DEFAULT NULL COMMENT '渠道',
  `logindate` datetime DEFAULT NULL COMMENT '登录时间',
  `servicetype` text COMMENT '服务类型',
  `reservation` tinyint(4) DEFAULT NULL COMMENT '是否预约',
  `reservtype` varchar(32) DEFAULT NULL COMMENT '预约方式',
  `reservtime` datetime DEFAULT NULL,
  `email` varchar(100) DEFAULT NULL COMMENT '电子邮件',
  `phonenumber` varchar(32) DEFAULT NULL COMMENT '电话号码',
  `summary` text COMMENT '服务记录',
  `agentserviceid` varchar(32) DEFAULT NULL COMMENT '服务ID',
  `creater` varchar(32) DEFAULT NULL COMMENT '创建人',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `statuseventid` varchar(50) DEFAULT NULL COMMENT '电话记录ID',
  `contactsid` varchar(50) DEFAULT NULL COMMENT '联系人ID',
  `ani` varchar(50) DEFAULT NULL COMMENT '主叫',
  `caller` varchar(50) DEFAULT NULL COMMENT '呼叫发起号码',
  `called` varchar(50) DEFAULT NULL COMMENT '被叫',
  `agent` varchar(50) DEFAULT NULL COMMENT '分机号',
  `process` tinyint(4) DEFAULT NULL,
  `updateuser` varchar(32) DEFAULT NULL,
  `updatetime` datetime DEFAULT NULL,
  `processmemo` text,
  `skill` varchar(32) DEFAULT NULL COMMENT '技能组',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='服务小结';

-- ----------------------------
-- Table structure for uk_sessionconfig
-- ----------------------------
DROP TABLE IF EXISTS `uk_sessionconfig`;
CREATE TABLE `uk_sessionconfig` (
  `id` varchar(32) NOT NULL DEFAULT '' COMMENT '主键ID',
  `orgi` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `creater` varchar(32) DEFAULT NULL COMMENT '创建人',
  `username` varchar(32) DEFAULT NULL COMMENT '用户名',
  `name` varchar(32) DEFAULT NULL COMMENT '名称',
  `sessionmsg` varchar(255) DEFAULT NULL COMMENT '会话消息',
  `distribution` varchar(32) DEFAULT NULL COMMENT '坐席分配策略',
  `timeoutmsg` varchar(255) DEFAULT NULL COMMENT '超时提醒消息',
  `retimeoutmsg` varchar(255) DEFAULT NULL COMMENT '再次超时提醒消息',
  `satisfaction` tinyint(4) DEFAULT NULL COMMENT '启用满意度调查',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `lastagent` tinyint(4) DEFAULT NULL COMMENT '最后服务坐席优先分配',
  `sessiontimeout` tinyint(4) DEFAULT NULL COMMENT '会话超时时间',
  `resessiontimeout` tinyint(4) DEFAULT NULL COMMENT '再次超时时间',
  `timeout` int(11) DEFAULT NULL COMMENT '超时时长',
  `retimeout` int(11) DEFAULT NULL COMMENT '再次超时时长',
  `agenttimeout` int(11) DEFAULT NULL COMMENT '坐席回复超时时长',
  `agentreplaytimeout` tinyint(4) DEFAULT NULL COMMENT '坐席回复超时时长',
  `agenttimeoutmsg` varchar(255) DEFAULT NULL COMMENT '超时回复消息',
  `maxuser` int(11) DEFAULT NULL COMMENT '最大用户数',
  `initmaxuser` int(11) DEFAULT NULL COMMENT '首次就绪分配用户数',
  `workinghours` text COMMENT '工作时间段',
  `notinwhmsg` text COMMENT '非工作时间提醒消息',
  `hourcheck` tinyint(4) DEFAULT NULL COMMENT '启用工作时间',
  `noagentmsg` varchar(255) DEFAULT NULL COMMENT '无坐席消息提醒',
  `agentbusymsg` varchar(255) DEFAULT NULL COMMENT '坐席忙提醒',
  `successmsg` varchar(255) DEFAULT NULL COMMENT '分配成功提醒',
  `finessmsg` varchar(255) DEFAULT NULL COMMENT '结束会话提示消息',
  `quality` tinyint(4) DEFAULT '0' COMMENT '质检',
  `qualityscore` varchar(20) DEFAULT NULL COMMENT '质检评分',
  `servicetimeoutlimit` tinyint(4) DEFAULT '0' COMMENT '服务超时提醒',
  `servicetimeout` int(11) DEFAULT '0' COMMENT '服务超时提醒消息',
  `servicetimeoutmsg` varchar(50) DEFAULT '0' COMMENT '服务超时时间',
  `quenetimeout` int(11) DEFAULT '600' COMMENT '允许访客排队的最大时长',
  `quenetimeoutmsg` varchar(255) DEFAULT NULL COMMENT '访客排队超市提示消息',
  `quene` tinyint(4) DEFAULT '0' COMMENT '坐席姓名',
  `servicename` varchar(50) DEFAULT NULL COMMENT '无坐席的时候回复昵称',
  `agentautoleave` tinyint(4) DEFAULT '0' COMMENT '关闭浏览器自动离线',
  `otherquickplay` tinyint(4) DEFAULT '0' COMMENT '启用外部快捷回复功能',
  `oqrsearchurl` varchar(255) DEFAULT NULL COMMENT '外部快捷回复搜索地址',
  `oqrsearchinput` varchar(32) DEFAULT NULL COMMENT '外部快捷回复搜索输入参数',
  `oqrsearchoutput` varchar(32) DEFAULT NULL COMMENT '外部快捷回复搜索输出参数',
  `oqrdetailurl` varchar(255) DEFAULT NULL COMMENT '外部快捷回复内容URL',
  `oqrdetailinput` varchar(32) DEFAULT NULL COMMENT '外部快捷回复详情输入参数',
  `oqrdetailoutput` varchar(32) DEFAULT NULL COMMENT '外部快捷回复详情输出参数',
  `agentctrlenter` tinyint(4) DEFAULT '0' COMMENT '启用坐席端CTRL+Enter发送消息',
  `ctrlenter` tinyint(4) DEFAULT '0' COMMENT '启用访客端CTRL+Enter发送消息',
  `enablequick` tinyint(32) DEFAULT '0' COMMENT '启用快捷回复功能',
  `otherssl` tinyint(4) DEFAULT '0' COMMENT '外部知识库启用SSL',
  `skill` varchar(32) DEFAULT NULL COMMENT '组织机构ID',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='会话设置';

-- ----------------------------
-- Table structure for uk_skill
-- ----------------------------
DROP TABLE IF EXISTS `uk_skill`;
CREATE TABLE `uk_skill` (
  `ID` varchar(32) NOT NULL COMMENT '主键ID',
  `NAME` varchar(50) DEFAULT NULL COMMENT '技能组名称',
  `CODE` varchar(50) DEFAULT NULL COMMENT '代码',
  `CREATETIME` datetime DEFAULT NULL COMMENT '创建时间',
  `CREATER` varchar(32) DEFAULT NULL COMMENT '创建人',
  `UPDATETIME` datetime DEFAULT NULL COMMENT '更新时间',
  `ORGI` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `USERNAME` varchar(50) DEFAULT NULL COMMENT '用户名',
  PRIMARY KEY (`ID`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='技能组表';


-- ----------------------------
-- Table structure for cs_chatbot
-- ----------------------------
DROP TABLE IF EXISTS `cs_chatbot`;
CREATE TABLE `cs_chatbot` (
  `ID` varchar(32) NOT NULL COMMENT '主键ID',
  `base_url` varchar(255) NOT NULL COMMENT '基础URL',
  `client_id` varchar(32) NOT NULL COMMENT 'Client Id',
  `secret` varchar(32) NOT NULL COMMENT 'Client Secret',
  `creater` varchar(32) NOT NULL COMMENT '创建人',
  `orgi` varchar(32) NOT NULL COMMENT '租户ID',
  `createtime` datetime NOT NULL COMMENT '创建时间',
  `updatetime` datetime NOT NULL COMMENT '更新时间',
  `name` varchar(255) NOT NULL COMMENT '聊天机器人名字',
  `description` varchar(255) NOT NULL COMMENT '描述',
  `primary_language` varchar(20) NOT NULL COMMENT '首选语言',
  `fallback` varchar(255) DEFAULT NULL COMMENT '兜底回复',
  `welcome` varchar(255) DEFAULT NULL COMMENT '欢迎语',
  `channel` varchar(32) NOT NULL COMMENT '渠道类型',
  `sns_account_identifier` varchar(100) NOT NULL COMMENT '渠道标识',
  `enabled` tinyint(1) DEFAULT '0' COMMENT '是否开启',
  `workmode` varchar(32) NOT NULL COMMENT '工作模式',
  `aisuggest` tinyint(1) DEFAULT '0' COMMENT '启用智能建议',
  PRIMARY KEY (`ID`) USING BTREE,
  UNIQUE KEY `snsid` (`sns_account_identifier`,`orgi`) USING BTREE COMMENT '按照渠道标识唯一'
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='机器人客服表';


-- ----------------------------
-- Table structure for uk_snsaccount
-- ----------------------------
DROP TABLE IF EXISTS `uk_snsaccount`;
CREATE TABLE `uk_snsaccount` (
  `authorizeURL` varchar(255) DEFAULT NULL COMMENT '认证URL',
  `accessTokenURL` varchar(255) DEFAULT NULL COMMENT '微博TokenURL',
  `baseURL` varchar(255) DEFAULT NULL COMMENT '基础URL',
  `redirectURI` varchar(255) DEFAULT NULL COMMENT '重定向URL',
  `clientSERCRET` varchar(192) DEFAULT NULL COMMENT '安全码',
  `clientID` varchar(96) DEFAULT NULL COMMENT '客户端ID',
  `ID` varchar(96) NOT NULL COMMENT '主键ID',
  `states` varchar(32) DEFAULT NULL COMMENT '状态',
  `region` varchar(32) DEFAULT NULL COMMENT '区域',
  `NAME` varchar(255) DEFAULT NULL COMMENT '账号名称',
  `CODE` varchar(255) DEFAULT NULL COMMENT '编码',
  `USERNAME` varchar(255) DEFAULT NULL COMMENT '用户名',
  `APIPOINT` varchar(255) DEFAULT NULL COMMENT 'API接入点',
  `PASSWORD` varchar(255) DEFAULT NULL COMMENT '密码',
  `SNSTYPE` varchar(255) DEFAULT NULL COMMENT '账号类型（微博/微信）',
  `CREATETIME` datetime DEFAULT NULL COMMENT '创建时间',
  `ACCOUNT` varchar(255) DEFAULT NULL COMMENT '账号',
  `ALLOWREMOTE` varchar(255) DEFAULT NULL COMMENT '允许远程访问',
  `EMAIL` varchar(255) DEFAULT NULL COMMENT '邮件',
  `USERNO` varchar(255) DEFAULT NULL COMMENT '用户名',
  `TOKEN` varchar(255) DEFAULT NULL COMMENT '微信Token',
  `APPKEY` varchar(255) DEFAULT NULL COMMENT '微信AppKey',
  `SECRET` varchar(255) DEFAULT NULL COMMENT '微信Secret',
  `AESKEY` varchar(255) DEFAULT NULL COMMENT '微信AesKey',
  `APPTOKEN` varchar(255) DEFAULT NULL COMMENT '微信AppToken',
  `SESSIONKEY` varchar(255) DEFAULT NULL COMMENT '会话Key',
  `MOREPARAM` varchar(255) DEFAULT NULL COMMENT '更多参数',
  `ORGI` varchar(255) DEFAULT NULL COMMENT '租户ID',
  `ORGAN` varchar(32) DEFAULT NULL COMMENT '组织机构ID',
  `DEFAULTACCOUNT` smallint(6) DEFAULT NULL COMMENT '默认账号',
  `lastatupdate` varchar(96) DEFAULT NULL COMMENT '最后更新时间',
  `lastprimsgupdate` varchar(96) DEFAULT NULL,
  `ACCTYPE` varchar(32) DEFAULT NULL COMMENT '账号类型',
  `UPDATETIME` datetime DEFAULT NULL COMMENT '更新时间',
  `creater` varchar(32) DEFAULT NULL COMMENT '创建人',
  `create_time` datetime DEFAULT NULL COMMENT '创建时间',
  `update_username` varchar(255) DEFAULT NULL COMMENT '更新用户',
  `update_time` datetime DEFAULT NULL COMMENT '修改时间',
  `update_user` varchar(255) DEFAULT NULL COMMENT '修改人',
  `shares` varchar(255) DEFAULT NULL COMMENT '分享给',
  `owner` varchar(255) DEFAULT NULL COMMENT '所属人',
  `assignedto` varchar(255) DEFAULT NULL COMMENT '分配目标用户',
  `wfstatus` varchar(255) DEFAULT NULL COMMENT '流程状态',
  `datadept` varchar(255) DEFAULT NULL COMMENT '创建人部门',
  `batid` varchar(32) DEFAULT NULL COMMENT '批次ID',
  `alias` varchar(50) DEFAULT NULL COMMENT '别称',
  `authaccesstoken` varchar(255) DEFAULT NULL COMMENT '认证token（微信第三方平台）',
  `expirestime` int(11) DEFAULT NULL COMMENT '过期时间（微信第三方平台）',
  `headimg` varchar(255) DEFAULT NULL COMMENT '账号头像（微信第三方平台）',
  `oepnscan` varchar(100) DEFAULT NULL COMMENT '极光推送信息',
  `opencard` varchar(100) DEFAULT NULL COMMENT '极光推送信息',
  `openstore` varchar(100) DEFAULT NULL COMMENT '极光推送信息',
  `openpay` varchar(100) DEFAULT NULL COMMENT '极光推送信息',
  `openshake` varchar(100) DEFAULT NULL COMMENT '极光推送信息',
  `qrcode` varchar(100) DEFAULT NULL COMMENT '二维码',
  `refreshtoken` varchar(255) DEFAULT NULL COMMENT '刷新token',
  `verify` varchar(255) DEFAULT NULL COMMENT '验证代码',
  `snsid` varchar(32) NOT NULL COMMENT 'SNSID',
  `agent` tinyint(4) DEFAULT NULL COMMENT '坐席',
  PRIMARY KEY (`ID`) USING BTREE,
  UNIQUE KEY `SQL121227155530370` (`ID`) USING BTREE,
  UNIQUE KEY (`snsid`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='渠道配置表';

-- ----------------------------
-- Table structure for uk_sysdic
-- ----------------------------
DROP TABLE IF EXISTS `uk_sysdic`;
CREATE TABLE `uk_sysdic` (
  `ID` varchar(32) NOT NULL COMMENT '主键ID',
  `NAME` varchar(100) DEFAULT NULL COMMENT '字典名称',
  `TITLE` varchar(100) DEFAULT NULL COMMENT '标题',
  `CODE` varchar(100) DEFAULT NULL COMMENT '代码',
  `ORGI` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `CTYPE` varchar(32) DEFAULT NULL COMMENT '类型',
  `PARENTID` varchar(32) DEFAULT NULL COMMENT '父级ID',
  `DESCRIPTION` varchar(255) DEFAULT NULL COMMENT '描述',
  `MEMO` varchar(32) DEFAULT NULL COMMENT '备注',
  `ICONSTR` varchar(255) DEFAULT NULL COMMENT '图标',
  `ICONSKIN` varchar(255) DEFAULT NULL COMMENT '自定义样式',
  `CATETYPE` varchar(32) DEFAULT NULL COMMENT '类型',
  `CREATER` varchar(32) DEFAULT NULL COMMENT '创建人',
  `CREATETIME` datetime DEFAULT NULL COMMENT '创建时间',
  `UPDATETIME` datetime DEFAULT NULL COMMENT '更新时间',
  `HASCHILD` tinyint(4) DEFAULT NULL COMMENT '是否有下级',
  `SORTINDEX` int(11) DEFAULT NULL COMMENT '排序',
  `DICID` varchar(32) DEFAULT NULL COMMENT '目录ID',
  `DEFAULTVALUE` tinyint(4) DEFAULT NULL COMMENT '默认值',
  `DISCODE` tinyint(4) DEFAULT NULL COMMENT '编码',
  `URL` text DEFAULT NULL COMMENT '系统权限资源的URL',
  `MODULE` varchar(32) DEFAULT NULL COMMENT '权限资源所属模块',
  `MLEVEL` varchar(32) DEFAULT NULL COMMENT '菜单级别（一级/二级）',
  `RULES` varchar(100) DEFAULT NULL,
  `MENUTYPE` varchar(32) DEFAULT NULL COMMENT '菜单类型（顶部菜单/左侧菜单）',
  PRIMARY KEY (`ID`) USING BTREE,
  UNIQUE KEY `SQL121227155532210` (`ID`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='字典表';

-- ----------------------------
-- Records of uk_sysdic
-- ----------------------------
BEGIN;
INSERT INTO `uk_sysdic` VALUES ('297e1e874f5ae37e014f5af969e30120', '性别', 'pub', 'com.dic.contacts.sex', 'cskefu', 'data', '0', '', NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-23 22:32:19', '2015-08-23 22:32:19', 1, 0, NULL, 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f5ae37e014f5af9ceba0126', '男', 'pub', '1', 'cskefu', 'layui-icon', '297e1e874f5ae37e014f5af969e30120', '', NULL, '', '', NULL, '297e8c7b455798280145579c73e501c1', '2015-08-23 22:32:44', '2016-10-13 16:37:40', 0, 1, '297e1e874f5ae37e014f5af969e30120', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f5ae37e014f5af9cecf0127', '女', 'pub', '0', 'cskefu', 'layui-icon', '297e1e874f5ae37e014f5af969e30120', '', NULL, '', '', NULL, '297e8c7b455798280145579c73e501c1', '2015-08-23 22:32:45', '2015-08-27 17:20:25', 0, 2, '297e1e874f5ae37e014f5af969e30120', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f832090e200b8', '国家、省市区县', 'pub', 'com.dic.address.area', 'cskefu', 'data', '0', '', NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:39:53', '2015-08-31 17:39:53', 1, 0, NULL, 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f832154c800c3', '北京市', 'pub', '110000', 'cskefu', NULL, '297e1e874f83129d014f832090e200b8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:43', '2015-08-31 17:40:43', 0, 1, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f832154d900c4', '天津市', 'pub', '120000', 'cskefu', NULL, '297e1e874f83129d014f832090e200b8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:43', '2015-08-31 17:40:43', 0, 2, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f832154e800c5', '河北省', 'pub', '130000', 'cskefu', 'data', '297e1e874f83129d014f832090e200b8', '', NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:43', '2015-08-31 17:40:43', 0, 3, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f832154fa00c6', '山西省', 'pub', '140000', 'cskefu', 'data', '297e1e874f83129d014f832090e200b8', '', NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:43', '2015-08-31 17:40:43', 0, 4, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8321550a00c7', '内蒙古自治区', 'pub', '150000', 'cskefu', 'data', '297e1e874f83129d014f832090e200b8', '', NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:43', '2015-08-31 17:40:43', 0, 5, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8321551a00c8', '辽宁省', 'pub', '210000', 'cskefu', NULL, '297e1e874f83129d014f832090e200b8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:43', '2015-08-31 17:40:43', 0, 6, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8321552c00c9', '吉林省', 'pub', '220000', 'cskefu', NULL, '297e1e874f83129d014f832090e200b8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:43', '2015-08-31 17:40:43', 0, 7, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8321553b00ca', '黑龙江省', 'pub', '230000', 'cskefu', NULL, '297e1e874f83129d014f832090e200b8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:43', '2015-08-31 17:40:43', 0, 8, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8321554a00cb', '上海市', 'pub', '310000', 'cskefu', NULL, '297e1e874f83129d014f832090e200b8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:43', '2015-08-31 17:40:43', 0, 9, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8321555900cc', '江苏省', 'pub', '320000', 'cskefu', NULL, '297e1e874f83129d014f832090e200b8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:43', '2015-08-31 17:40:43', 0, 10, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8321556b00cd', '浙江省', 'pub', '330000', 'cskefu', NULL, '297e1e874f83129d014f832090e200b8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:44', '2015-08-31 17:40:44', 0, 11, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8321557d00ce', '安徽省', 'pub', '340000', 'cskefu', NULL, '297e1e874f83129d014f832090e200b8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:44', '2015-08-31 17:40:44', 0, 12, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8321558a00cf', '福建省', 'pub', '350000', 'cskefu', NULL, '297e1e874f83129d014f832090e200b8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:44', '2015-08-31 17:40:44', 0, 13, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8321559900d0', '江西省', 'pub', '360000', 'cskefu', NULL, '297e1e874f83129d014f832090e200b8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:44', '2015-08-31 17:40:44', 0, 14, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f832155a500d1', '山东省', 'pub', '370000', 'cskefu', 'data', '297e1e874f83129d014f832090e200b8', '', NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:44', '2015-08-31 17:40:44', 0, 15, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f832155b200d2', '河南省', 'pub', '410000', 'cskefu', NULL, '297e1e874f83129d014f832090e200b8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:44', '2015-08-31 17:40:44', 0, 16, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f832155bf00d3', '湖北省', 'pub', '420000', 'cskefu', NULL, '297e1e874f83129d014f832090e200b8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:44', '2015-08-31 17:40:44', 0, 17, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f832155cb00d4', '湖南省', 'pub', '430000', 'cskefu', NULL, '297e1e874f83129d014f832090e200b8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:44', '2015-08-31 17:40:44', 0, 18, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f832155d800d5', '广东省', 'pub', '440000', 'cskefu', NULL, '297e1e874f83129d014f832090e200b8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:44', '2015-08-31 17:40:44', 0, 19, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f832155e400d6', '广西壮族自治区', 'pub', '450000', 'cskefu', NULL, '297e1e874f83129d014f832090e200b8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:44', '2015-08-31 17:40:44', 0, 20, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f832155f300d7', '海南省', 'pub', '460000', 'cskefu', NULL, '297e1e874f83129d014f832090e200b8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:44', '2015-08-31 17:40:44', 0, 21, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f832155ff00d8', '重庆市', 'pub', '500000', 'cskefu', NULL, '297e1e874f83129d014f832090e200b8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:44', '2015-08-31 17:40:44', 0, 22, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8321560b00d9', '四川省', 'pub', '510000', 'cskefu', NULL, '297e1e874f83129d014f832090e200b8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:44', '2015-08-31 17:40:44', 0, 23, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8321561800da', '贵州省', 'pub', '520000', 'cskefu', NULL, '297e1e874f83129d014f832090e200b8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:44', '2015-08-31 17:40:44', 0, 24, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8321562400db', '云南省', 'pub', '530000', 'cskefu', NULL, '297e1e874f83129d014f832090e200b8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:44', '2015-08-31 17:40:44', 0, 25, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8321563300dc', '西藏自治区', 'pub', '540000', 'cskefu', NULL, '297e1e874f83129d014f832090e200b8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:44', '2015-08-31 17:40:44', 0, 26, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8321564100dd', '陕西省', 'pub', '610000', 'cskefu', NULL, '297e1e874f83129d014f832090e200b8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:44', '2015-08-31 17:40:44', 0, 27, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8321564f00de', '甘肃省', 'pub', '620000', 'cskefu', NULL, '297e1e874f83129d014f832090e200b8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:44', '2015-08-31 17:40:44', 0, 28, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8321565d00df', '青海省', 'pub', '630000', 'cskefu', NULL, '297e1e874f83129d014f832090e200b8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:44', '2015-08-31 17:40:44', 0, 29, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8321566d00e0', '宁夏回族自治区', 'pub', '640000', 'cskefu', NULL, '297e1e874f83129d014f832090e200b8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:44', '2015-08-31 17:40:44', 0, 30, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8321567900e1', '新疆维吾尔自治区', 'pub', '650000', 'cskefu', NULL, '297e1e874f83129d014f832090e200b8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:44', '2015-08-31 17:40:44', 0, 31, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8321568900e2', '台湾省', 'pub', '710000', 'cskefu', NULL, '297e1e874f83129d014f832090e200b8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:44', '2015-08-31 17:40:44', 0, 32, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8321569700e3', '香港特别行政区', 'pub', '810000', 'cskefu', NULL, '297e1e874f83129d014f832090e200b8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:44', '2015-08-31 17:40:44', 0, 33, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f832156a900e4', '澳门特别行政区', 'pub', '820000', 'cskefu', NULL, '297e1e874f83129d014f832090e200b8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 17:40:44', '2015-08-31 17:40:44', 0, 34, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e3430242', '市辖区', 'pub', '110100', 'cskefu', NULL, '297e1e874f83129d014f832154c800c3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:05', '2015-08-31 18:02:05', 0, 35, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e3550243', '县', 'pub', '110200', 'cskefu', NULL, '297e1e874f83129d014f832154c800c3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:05', '2015-08-31 18:02:05', 0, 36, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e3860244', '市辖区', 'pub', '120100', 'cskefu', NULL, '297e1e874f83129d014f832154d900c4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:05', '2015-08-31 18:02:05', 0, 37, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e3960245', '县', 'pub', '120200', 'cskefu', NULL, '297e1e874f83129d014f832154d900c4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:05', '2015-08-31 18:02:05', 0, 38, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e3c00246', '石家庄市', 'pub', '130100', 'cskefu', NULL, '297e1e874f83129d014f832154e800c5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:05', '2015-08-31 18:02:05', 0, 39, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e3cc0247', '唐山市', 'pub', '130200', 'cskefu', NULL, '297e1e874f83129d014f832154e800c5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:05', '2015-08-31 18:02:05', 0, 40, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e3d80248', '秦皇岛市', 'pub', '130300', 'cskefu', NULL, '297e1e874f83129d014f832154e800c5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:05', '2015-08-31 18:02:05', 0, 41, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e3e50249', '邯郸市', 'pub', '130400', 'cskefu', NULL, '297e1e874f83129d014f832154e800c5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:05', '2015-08-31 18:02:05', 0, 42, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e3f1024a', '邢台市', 'pub', '130500', 'cskefu', NULL, '297e1e874f83129d014f832154e800c5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:05', '2015-08-31 18:02:05', 0, 43, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e3fd024b', '保定市', 'pub', '130600', 'cskefu', NULL, '297e1e874f83129d014f832154e800c5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:05', '2015-08-31 18:02:05', 0, 44, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e409024c', '张家口市', 'pub', '130700', 'cskefu', NULL, '297e1e874f83129d014f832154e800c5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:05', '2015-08-31 18:02:05', 0, 45, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e418024d', '承德市', 'pub', '130800', 'cskefu', NULL, '297e1e874f83129d014f832154e800c5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:05', '2015-08-31 18:02:05', 0, 46, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e424024e', '沧州市', 'pub', '130900', 'cskefu', NULL, '297e1e874f83129d014f832154e800c5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:05', '2015-08-31 18:02:05', 0, 47, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e430024f', '廊坊市', 'pub', '131000', 'cskefu', NULL, '297e1e874f83129d014f832154e800c5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:05', '2015-08-31 18:02:05', 0, 48, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e43e0250', '衡水市', 'pub', '131100', 'cskefu', NULL, '297e1e874f83129d014f832154e800c5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:05', '2015-08-31 18:02:05', 0, 49, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e6310251', '太原市', 'pub', '140100', 'cskefu', NULL, '297e1e874f83129d014f832154fa00c6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', 0, 50, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e6420252', '大同市', 'pub', '140200', 'cskefu', NULL, '297e1e874f83129d014f832154fa00c6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', 0, 51, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e64e0253', '阳泉市', 'pub', '140300', 'cskefu', NULL, '297e1e874f83129d014f832154fa00c6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', 0, 52, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e65a0254', '长治市', 'pub', '140400', 'cskefu', NULL, '297e1e874f83129d014f832154fa00c6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', 0, 53, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e6650255', '晋城市', 'pub', '140500', 'cskefu', NULL, '297e1e874f83129d014f832154fa00c6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', 0, 54, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e6730256', '朔州市', 'pub', '140600', 'cskefu', NULL, '297e1e874f83129d014f832154fa00c6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', 0, 55, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e67f0257', '晋中市', 'pub', '140700', 'cskefu', NULL, '297e1e874f83129d014f832154fa00c6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', 0, 56, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e68e0258', '运城市', 'pub', '140800', 'cskefu', NULL, '297e1e874f83129d014f832154fa00c6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', 0, 57, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e69e0259', '忻州市', 'pub', '140900', 'cskefu', NULL, '297e1e874f83129d014f832154fa00c6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', 0, 58, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e6ae025a', '临汾市', 'pub', '141000', 'cskefu', NULL, '297e1e874f83129d014f832154fa00c6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', 0, 59, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e6bb025b', '吕梁市', 'pub', '141100', 'cskefu', NULL, '297e1e874f83129d014f832154fa00c6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', 0, 60, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e6e0025c', '呼和浩特市', 'pub', '150100', 'cskefu', NULL, '297e1e874f83129d014f8321550a00c7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', 0, 61, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e6f5025d', '包头市', 'pub', '150200', 'cskefu', NULL, '297e1e874f83129d014f8321550a00c7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', 0, 62, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e702025e', '乌海市', 'pub', '150300', 'cskefu', NULL, '297e1e874f83129d014f8321550a00c7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', 0, 63, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e70e025f', '赤峰市', 'pub', '150400', 'cskefu', NULL, '297e1e874f83129d014f8321550a00c7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', 0, 64, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e71a0260', '通辽市', 'pub', '150500', 'cskefu', NULL, '297e1e874f83129d014f8321550a00c7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', 0, 65, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e7270261', '鄂尔多斯市', 'pub', '150600', 'cskefu', NULL, '297e1e874f83129d014f8321550a00c7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', 0, 66, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e7360262', '呼伦贝尔市', 'pub', '150700', 'cskefu', NULL, '297e1e874f83129d014f8321550a00c7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', 0, 67, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e7430263', '巴彦淖尔市', 'pub', '150800', 'cskefu', NULL, '297e1e874f83129d014f8321550a00c7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', 0, 68, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e74e0264', '乌兰察布市', 'pub', '150900', 'cskefu', NULL, '297e1e874f83129d014f8321550a00c7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', 0, 69, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e75b0265', '兴安盟', 'pub', '152200', 'cskefu', NULL, '297e1e874f83129d014f8321550a00c7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', 0, 70, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e7680266', '锡林郭勒盟', 'pub', '152500', 'cskefu', NULL, '297e1e874f83129d014f8321550a00c7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', 0, 71, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e7740267', '阿拉善盟', 'pub', '152900', 'cskefu', NULL, '297e1e874f83129d014f8321550a00c7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', 0, 72, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e7960268', '沈阳市', 'pub', '210100', 'cskefu', NULL, '297e1e874f83129d014f8321551a00c8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', 0, 73, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e7a40269', '大连市', 'pub', '210200', 'cskefu', NULL, '297e1e874f83129d014f8321551a00c8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', 0, 74, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e7b2026a', '鞍山市', 'pub', '210300', 'cskefu', NULL, '297e1e874f83129d014f8321551a00c8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', 0, 75, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e7c2026b', '抚顺市', 'pub', '210400', 'cskefu', NULL, '297e1e874f83129d014f8321551a00c8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', 0, 76, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e7ce026c', '本溪市', 'pub', '210500', 'cskefu', NULL, '297e1e874f83129d014f8321551a00c8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', 0, 77, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e7da026d', '丹东市', 'pub', '210600', 'cskefu', NULL, '297e1e874f83129d014f8321551a00c8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', 0, 78, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e7e6026e', '锦州市', 'pub', '210700', 'cskefu', NULL, '297e1e874f83129d014f8321551a00c8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', 0, 79, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e7f3026f', '营口市', 'pub', '210800', 'cskefu', NULL, '297e1e874f83129d014f8321551a00c8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', 0, 80, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e8010270', '阜新市', 'pub', '210900', 'cskefu', NULL, '297e1e874f83129d014f8321551a00c8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', 0, 81, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e80f0272', '辽阳市', 'pub', '211000', 'cskefu', NULL, '297e1e874f83129d014f8321551a00c8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', 0, 82, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e81e0273', '盘锦市', 'pub', '211100', 'cskefu', NULL, '297e1e874f83129d014f8321551a00c8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', 0, 83, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e82c0274', '铁岭市', 'pub', '211200', 'cskefu', NULL, '297e1e874f83129d014f8321551a00c8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', 0, 84, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e8410275', '朝阳市', 'pub', '211300', 'cskefu', NULL, '297e1e874f83129d014f8321551a00c8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', 0, 85, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e84e0276', '葫芦岛市', 'pub', '211400', 'cskefu', NULL, '297e1e874f83129d014f8321551a00c8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', 0, 86, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e8730277', '长春市', 'pub', '220100', 'cskefu', NULL, '297e1e874f83129d014f8321552c00c9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', 0, 87, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e8800278', '吉林市', 'pub', '220200', 'cskefu', NULL, '297e1e874f83129d014f8321552c00c9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', 0, 88, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e88f0279', '四平市', 'pub', '220300', 'cskefu', NULL, '297e1e874f83129d014f8321552c00c9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', 0, 89, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e89c027a', '辽源市', 'pub', '220400', 'cskefu', NULL, '297e1e874f83129d014f8321552c00c9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', 0, 90, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e8a8027b', '通化市', 'pub', '220500', 'cskefu', NULL, '297e1e874f83129d014f8321552c00c9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', 0, 91, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e8b9027c', '白山市', 'pub', '220600', 'cskefu', NULL, '297e1e874f83129d014f8321552c00c9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', 0, 92, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e8c6027d', '松原市', 'pub', '220700', 'cskefu', NULL, '297e1e874f83129d014f8321552c00c9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', 0, 93, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e8d4027e', '白城市', 'pub', '220800', 'cskefu', NULL, '297e1e874f83129d014f8321552c00c9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', 0, 94, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e8e1027f', '延边朝鲜族自治州', 'pub', '222400', 'cskefu', NULL, '297e1e874f83129d014f8321552c00c9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', 0, 95, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e91d0280', '哈尔滨市', 'pub', '230100', 'cskefu', NULL, '297e1e874f83129d014f8321553b00ca', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:06', '2015-08-31 18:02:06', 0, 96, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e9290281', '齐齐哈尔市', 'pub', '230200', 'cskefu', NULL, '297e1e874f83129d014f8321553b00ca', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', 0, 97, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e9390282', '鸡西市', 'pub', '230300', 'cskefu', NULL, '297e1e874f83129d014f8321553b00ca', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', 0, 98, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e9470283', '鹤岗市', 'pub', '230400', 'cskefu', NULL, '297e1e874f83129d014f8321553b00ca', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', 0, 99, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e9570284', '双鸭山市', 'pub', '230500', 'cskefu', NULL, '297e1e874f83129d014f8321553b00ca', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', 0, 100, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e9630285', '大庆市', 'pub', '230600', 'cskefu', NULL, '297e1e874f83129d014f8321553b00ca', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', 0, 101, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e9710286', '伊春市', 'pub', '230700', 'cskefu', NULL, '297e1e874f83129d014f8321553b00ca', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', 0, 102, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e97d0287', '佳木斯市', 'pub', '230800', 'cskefu', NULL, '297e1e874f83129d014f8321553b00ca', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', 0, 103, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e98e0288', '七台河市', 'pub', '230900', 'cskefu', NULL, '297e1e874f83129d014f8321553b00ca', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', 0, 104, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e99a0289', '牡丹江市', 'pub', '231000', 'cskefu', NULL, '297e1e874f83129d014f8321553b00ca', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', 0, 105, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e9a8028a', '黑河市', 'pub', '231100', 'cskefu', NULL, '297e1e874f83129d014f8321553b00ca', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', 0, 106, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e9b5028b', '绥化市', 'pub', '231200', 'cskefu', NULL, '297e1e874f83129d014f8321553b00ca', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', 0, 107, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e9c4028c', '大兴安岭地区', 'pub', '232700', 'cskefu', NULL, '297e1e874f83129d014f8321553b00ca', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', 0, 108, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e9e5028d', '市辖区', 'pub', '310100', 'cskefu', NULL, '297e1e874f83129d014f8321554a00cb', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', 0, 109, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334e9f3028e', '县', 'pub', '310200', 'cskefu', NULL, '297e1e874f83129d014f8321554a00cb', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', 0, 110, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334ea23028f', '南京市', 'pub', '320100', 'cskefu', NULL, '297e1e874f83129d014f8321555900cc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', 0, 111, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334ea320290', '无锡市', 'pub', '320200', 'cskefu', NULL, '297e1e874f83129d014f8321555900cc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', 0, 112, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334ea430291', '徐州市', 'pub', '320300', 'cskefu', NULL, '297e1e874f83129d014f8321555900cc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', 0, 113, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334ea510292', '常州市', 'pub', '320400', 'cskefu', NULL, '297e1e874f83129d014f8321555900cc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', 0, 114, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334ea5e0293', '苏州市', 'pub', '320500', 'cskefu', NULL, '297e1e874f83129d014f8321555900cc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', 0, 115, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334ea6d0294', '南通市', 'pub', '320600', 'cskefu', NULL, '297e1e874f83129d014f8321555900cc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', 0, 116, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334ea790295', '连云港市', 'pub', '320700', 'cskefu', NULL, '297e1e874f83129d014f8321555900cc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', 0, 117, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334ea850296', '淮安市', 'pub', '320800', 'cskefu', NULL, '297e1e874f83129d014f8321555900cc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', 0, 118, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334ea940297', '盐城市', 'pub', '320900', 'cskefu', NULL, '297e1e874f83129d014f8321555900cc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', 0, 119, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334eab00298', '扬州市', 'pub', '321000', 'cskefu', NULL, '297e1e874f83129d014f8321555900cc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', 0, 120, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334eaca0299', '镇江市', 'pub', '321100', 'cskefu', NULL, '297e1e874f83129d014f8321555900cc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', 0, 121, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334eaed029a', '泰州市', 'pub', '321200', 'cskefu', NULL, '297e1e874f83129d014f8321555900cc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', 0, 122, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334eb01029b', '宿迁市', 'pub', '321300', 'cskefu', NULL, '297e1e874f83129d014f8321555900cc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', 0, 123, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334eb38029c', '杭州市', 'pub', '330100', 'cskefu', NULL, '297e1e874f83129d014f8321556b00cd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', 0, 124, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334eb45029d', '宁波市', 'pub', '330200', 'cskefu', NULL, '297e1e874f83129d014f8321556b00cd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', 0, 125, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334eb53029e', '温州市', 'pub', '330300', 'cskefu', NULL, '297e1e874f83129d014f8321556b00cd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', 0, 126, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334eb60029f', '嘉兴市', 'pub', '330400', 'cskefu', NULL, '297e1e874f83129d014f8321556b00cd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', 0, 127, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334eb6e02a0', '湖州市', 'pub', '330500', 'cskefu', NULL, '297e1e874f83129d014f8321556b00cd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', 0, 128, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334eb7d02a1', '绍兴市', 'pub', '330600', 'cskefu', NULL, '297e1e874f83129d014f8321556b00cd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', 0, 129, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334eb8902a2', '金华市', 'pub', '330700', 'cskefu', NULL, '297e1e874f83129d014f8321556b00cd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', 0, 130, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334eb9902a3', '衢州市', 'pub', '330800', 'cskefu', NULL, '297e1e874f83129d014f8321556b00cd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', 0, 131, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334eba502a4', '舟山市', 'pub', '330900', 'cskefu', NULL, '297e1e874f83129d014f8321556b00cd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', 0, 132, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334ebb202a5', '台州市', 'pub', '331000', 'cskefu', NULL, '297e1e874f83129d014f8321556b00cd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', 0, 133, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334ebbe02a6', '丽水市', 'pub', '331100', 'cskefu', NULL, '297e1e874f83129d014f8321556b00cd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', 0, 134, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334ebe802a7', '合肥市', 'pub', '340100', 'cskefu', NULL, '297e1e874f83129d014f8321557d00ce', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', 0, 135, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334ebf602a8', '芜湖市', 'pub', '340200', 'cskefu', NULL, '297e1e874f83129d014f8321557d00ce', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:07', '2015-08-31 18:02:07', 0, 136, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334ed2f02a9', '蚌埠市', 'pub', '340300', 'cskefu', NULL, '297e1e874f83129d014f8321557d00ce', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:08', '2015-08-31 18:02:08', 0, 137, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334ed4302aa', '淮南市', 'pub', '340400', 'cskefu', NULL, '297e1e874f83129d014f8321557d00ce', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:08', '2015-08-31 18:02:08', 0, 138, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334ed5202ab', '马鞍山市', 'pub', '340500', 'cskefu', NULL, '297e1e874f83129d014f8321557d00ce', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:08', '2015-08-31 18:02:08', 0, 139, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334ed6202ac', '淮北市', 'pub', '340600', 'cskefu', NULL, '297e1e874f83129d014f8321557d00ce', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:08', '2015-08-31 18:02:08', 0, 140, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334ed6e02ad', '铜陵市', 'pub', '340700', 'cskefu', NULL, '297e1e874f83129d014f8321557d00ce', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:08', '2015-08-31 18:02:08', 0, 141, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334ed7b02ae', '安庆市', 'pub', '340800', 'cskefu', NULL, '297e1e874f83129d014f8321557d00ce', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:08', '2015-08-31 18:02:08', 0, 142, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334ed8802af', '黄山市', 'pub', '341000', 'cskefu', NULL, '297e1e874f83129d014f8321557d00ce', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:08', '2015-08-31 18:02:08', 0, 143, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334ed9602b0', '滁州市', 'pub', '341100', 'cskefu', NULL, '297e1e874f83129d014f8321557d00ce', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:08', '2015-08-31 18:02:08', 0, 144, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334eda302b1', '阜阳市', 'pub', '341200', 'cskefu', NULL, '297e1e874f83129d014f8321557d00ce', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:08', '2015-08-31 18:02:08', 0, 145, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334edb402b2', '宿州市', 'pub', '341300', 'cskefu', NULL, '297e1e874f83129d014f8321557d00ce', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:08', '2015-08-31 18:02:08', 0, 146, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334edc002b3', '巢湖市', 'pub', '341400', 'cskefu', NULL, '297e1e874f83129d014f8321557d00ce', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:08', '2015-08-31 18:02:08', 0, 147, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334edcf02b4', '六安市', 'pub', '341500', 'cskefu', NULL, '297e1e874f83129d014f8321557d00ce', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:08', '2015-08-31 18:02:08', 0, 148, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334eddb02b5', '亳州市', 'pub', '341600', 'cskefu', NULL, '297e1e874f83129d014f8321557d00ce', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:08', '2015-08-31 18:02:08', 0, 149, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334edee02b6', '池州市', 'pub', '341700', 'cskefu', NULL, '297e1e874f83129d014f8321557d00ce', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:08', '2015-08-31 18:02:08', 0, 150, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334edfb02b7', '宣城市', 'pub', '341800', 'cskefu', NULL, '297e1e874f83129d014f8321557d00ce', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:08', '2015-08-31 18:02:08', 0, 151, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334ef4d02b8', '福州市', 'pub', '350100', 'cskefu', NULL, '297e1e874f83129d014f8321558a00cf', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:08', '2015-08-31 18:02:08', 0, 152, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334ef5e02b9', '厦门市', 'pub', '350200', 'cskefu', NULL, '297e1e874f83129d014f8321558a00cf', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:08', '2015-08-31 18:02:08', 0, 153, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334ef6902ba', '莆田市', 'pub', '350300', 'cskefu', NULL, '297e1e874f83129d014f8321558a00cf', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:08', '2015-08-31 18:02:08', 0, 154, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334ef7602bb', '三明市', 'pub', '350400', 'cskefu', NULL, '297e1e874f83129d014f8321558a00cf', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:08', '2015-08-31 18:02:08', 0, 155, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334ef8202bc', '泉州市', 'pub', '350500', 'cskefu', NULL, '297e1e874f83129d014f8321558a00cf', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:08', '2015-08-31 18:02:08', 0, 156, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334ef9002bd', '漳州市', 'pub', '350600', 'cskefu', NULL, '297e1e874f83129d014f8321558a00cf', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:08', '2015-08-31 18:02:08', 0, 157, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334ef9d02be', '南平市', 'pub', '350700', 'cskefu', NULL, '297e1e874f83129d014f8321558a00cf', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:08', '2015-08-31 18:02:08', 0, 158, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334efa902bf', '龙岩市', 'pub', '350800', 'cskefu', NULL, '297e1e874f83129d014f8321558a00cf', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:08', '2015-08-31 18:02:08', 0, 159, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334efb702c0', '宁德市', 'pub', '350900', 'cskefu', NULL, '297e1e874f83129d014f8321558a00cf', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:08', '2015-08-31 18:02:08', 0, 160, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334efde02c1', '南昌市', 'pub', '360100', 'cskefu', NULL, '297e1e874f83129d014f8321559900d0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:08', '2015-08-31 18:02:08', 0, 161, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f11902c2', '景德镇市', 'pub', '360200', 'cskefu', NULL, '297e1e874f83129d014f8321559900d0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:09', '2015-08-31 18:02:09', 0, 162, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f12702c3', '萍乡市', 'pub', '360300', 'cskefu', NULL, '297e1e874f83129d014f8321559900d0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:09', '2015-08-31 18:02:09', 0, 163, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f13602c4', '九江市', 'pub', '360400', 'cskefu', NULL, '297e1e874f83129d014f8321559900d0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:09', '2015-08-31 18:02:09', 0, 164, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f14c02c5', '新余市', 'pub', '360500', 'cskefu', NULL, '297e1e874f83129d014f8321559900d0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:09', '2015-08-31 18:02:09', 0, 165, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f15b02c6', '鹰潭市', 'pub', '360600', 'cskefu', NULL, '297e1e874f83129d014f8321559900d0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:09', '2015-08-31 18:02:09', 0, 166, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f16c02c7', '赣州市', 'pub', '360700', 'cskefu', NULL, '297e1e874f83129d014f8321559900d0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:09', '2015-08-31 18:02:09', 0, 167, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f18502c8', '吉安市', 'pub', '360800', 'cskefu', NULL, '297e1e874f83129d014f8321559900d0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:09', '2015-08-31 18:02:09', 0, 168, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f19402c9', '宜春市', 'pub', '360900', 'cskefu', NULL, '297e1e874f83129d014f8321559900d0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:09', '2015-08-31 18:02:09', 0, 169, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f1a302ca', '抚州市', 'pub', '361000', 'cskefu', NULL, '297e1e874f83129d014f8321559900d0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:09', '2015-08-31 18:02:09', 0, 170, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f1b202cb', '上饶市', 'pub', '361100', 'cskefu', NULL, '297e1e874f83129d014f8321559900d0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:09', '2015-08-31 18:02:09', 0, 171, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f1da02cc', '济南市', 'pub', '370100', 'cskefu', NULL, '297e1e874f83129d014f832155a500d1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:09', '2015-08-31 18:02:09', 0, 172, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f1e902cd', '青岛市', 'pub', '370200', 'cskefu', NULL, '297e1e874f83129d014f832155a500d1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:09', '2015-08-31 18:02:09', 0, 173, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f20c02ce', '淄博市', 'pub', '370300', 'cskefu', NULL, '297e1e874f83129d014f832155a500d1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:09', '2015-08-31 18:02:09', 0, 174, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f21e02cf', '枣庄市', 'pub', '370400', 'cskefu', NULL, '297e1e874f83129d014f832155a500d1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:09', '2015-08-31 18:02:09', 0, 175, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f22d02d0', '东营市', 'pub', '370500', 'cskefu', NULL, '297e1e874f83129d014f832155a500d1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:09', '2015-08-31 18:02:09', 0, 176, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f23d02d1', '烟台市', 'pub', '370600', 'cskefu', NULL, '297e1e874f83129d014f832155a500d1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:09', '2015-08-31 18:02:09', 0, 177, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f37702d2', '潍坊市', 'pub', '370700', 'cskefu', NULL, '297e1e874f83129d014f832155a500d1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:09', '2015-08-31 18:02:09', 0, 178, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f38a02d3', '济宁市', 'pub', '370800', 'cskefu', NULL, '297e1e874f83129d014f832155a500d1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:09', '2015-08-31 18:02:09', 0, 179, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f39602d4', '泰安市', 'pub', '370900', 'cskefu', NULL, '297e1e874f83129d014f832155a500d1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:09', '2015-08-31 18:02:09', 0, 180, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f3a202d5', '威海市', 'pub', '371000', 'cskefu', NULL, '297e1e874f83129d014f832155a500d1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:09', '2015-08-31 18:02:09', 0, 181, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f3b002d6', '日照市', 'pub', '371100', 'cskefu', NULL, '297e1e874f83129d014f832155a500d1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:09', '2015-08-31 18:02:09', 0, 182, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f3c302d7', '莱芜市', 'pub', '371200', 'cskefu', NULL, '297e1e874f83129d014f832155a500d1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:09', '2015-08-31 18:02:09', 0, 183, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f3d202d8', '临沂市', 'pub', '371300', 'cskefu', NULL, '297e1e874f83129d014f832155a500d1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:09', '2015-08-31 18:02:09', 0, 184, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f3dd02d9', '德州市', 'pub', '371400', 'cskefu', NULL, '297e1e874f83129d014f832155a500d1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:09', '2015-08-31 18:02:09', 0, 185, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f3ec02da', '聊城市', 'pub', '371500', 'cskefu', NULL, '297e1e874f83129d014f832155a500d1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:09', '2015-08-31 18:02:09', 0, 186, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f3fb02db', '滨州市', 'pub', '371600', 'cskefu', NULL, '297e1e874f83129d014f832155a500d1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:09', '2015-08-31 18:02:09', 0, 187, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f40802dc', '荷泽市', 'pub', '371700', 'cskefu', NULL, '297e1e874f83129d014f832155a500d1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:09', '2015-08-31 18:02:09', 0, 188, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f43002dd', '郑州市', 'pub', '410100', 'cskefu', NULL, '297e1e874f83129d014f832155b200d2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:09', '2015-08-31 18:02:09', 0, 189, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f56b02de', '开封市', 'pub', '410200', 'cskefu', NULL, '297e1e874f83129d014f832155b200d2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', 0, 190, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f57a02df', '洛阳市', 'pub', '410300', 'cskefu', NULL, '297e1e874f83129d014f832155b200d2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', 0, 191, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f59902e0', '平顶山市', 'pub', '410400', 'cskefu', NULL, '297e1e874f83129d014f832155b200d2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', 0, 192, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f5a902e1', '安阳市', 'pub', '410500', 'cskefu', NULL, '297e1e874f83129d014f832155b200d2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', 0, 193, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f5b602e2', '鹤壁市', 'pub', '410600', 'cskefu', NULL, '297e1e874f83129d014f832155b200d2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', 0, 194, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f5c602e3', '新乡市', 'pub', '410700', 'cskefu', NULL, '297e1e874f83129d014f832155b200d2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', 0, 195, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f5d202e4', '焦作市', 'pub', '410800', 'cskefu', NULL, '297e1e874f83129d014f832155b200d2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', 0, 196, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f5e202e5', '濮阳市', 'pub', '410900', 'cskefu', NULL, '297e1e874f83129d014f832155b200d2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', 0, 197, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f5ef02e6', '许昌市', 'pub', '411000', 'cskefu', NULL, '297e1e874f83129d014f832155b200d2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', 0, 198, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f5fb02e7', '漯河市', 'pub', '411100', 'cskefu', NULL, '297e1e874f83129d014f832155b200d2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', 0, 199, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f60902e8', '三门峡市', 'pub', '411200', 'cskefu', NULL, '297e1e874f83129d014f832155b200d2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', 0, 200, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f61802e9', '南阳市', 'pub', '411300', 'cskefu', NULL, '297e1e874f83129d014f832155b200d2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', 0, 201, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f62802ea', '商丘市', 'pub', '411400', 'cskefu', NULL, '297e1e874f83129d014f832155b200d2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', 0, 202, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f63402eb', '信阳市', 'pub', '411500', 'cskefu', NULL, '297e1e874f83129d014f832155b200d2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', 0, 203, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f64202ec', '周口市', 'pub', '411600', 'cskefu', NULL, '297e1e874f83129d014f832155b200d2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', 0, 204, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f65102ed', '驻马店市', 'pub', '411700', 'cskefu', NULL, '297e1e874f83129d014f832155b200d2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', 0, 205, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f7a802ee', '武汉市', 'pub', '420100', 'cskefu', NULL, '297e1e874f83129d014f832155bf00d3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', 0, 206, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f7c902ef', '黄石市', 'pub', '420200', 'cskefu', NULL, '297e1e874f83129d014f832155bf00d3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', 0, 207, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f7ee02f0', '十堰市', 'pub', '420300', 'cskefu', NULL, '297e1e874f83129d014f832155bf00d3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', 0, 208, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f7fd02f1', '宜昌市', 'pub', '420500', 'cskefu', NULL, '297e1e874f83129d014f832155bf00d3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', 0, 209, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f80b02f2', '襄樊市', 'pub', '420600', 'cskefu', NULL, '297e1e874f83129d014f832155bf00d3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', 0, 210, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f81a02f3', '鄂州市', 'pub', '420700', 'cskefu', NULL, '297e1e874f83129d014f832155bf00d3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', 0, 211, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f82702f4', '荆门市', 'pub', '420800', 'cskefu', NULL, '297e1e874f83129d014f832155bf00d3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', 0, 212, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f83502f5', '孝感市', 'pub', '420900', 'cskefu', NULL, '297e1e874f83129d014f832155bf00d3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', 0, 213, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f84302f6', '荆州市', 'pub', '421000', 'cskefu', NULL, '297e1e874f83129d014f832155bf00d3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', 0, 214, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f85b02f7', '黄冈市', 'pub', '421100', 'cskefu', NULL, '297e1e874f83129d014f832155bf00d3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', 0, 215, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f87102f8', '咸宁市', 'pub', '421200', 'cskefu', NULL, '297e1e874f83129d014f832155bf00d3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', 0, 216, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f88002f9', '随州市', 'pub', '421300', 'cskefu', NULL, '297e1e874f83129d014f832155bf00d3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', 0, 217, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f89202fa', '恩施土家族苗族自治州', 'pub', '422800', 'cskefu', NULL, '297e1e874f83129d014f832155bf00d3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', 0, 218, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f89f02fb', '省直辖行政单位', 'pub', '429000', 'cskefu', NULL, '297e1e874f83129d014f832155bf00d3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:10', '2015-08-31 18:02:10', 0, 219, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f8d802fc', '长沙市', 'pub', '430100', 'cskefu', NULL, '297e1e874f83129d014f832155cb00d4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:11', '2015-08-31 18:02:11', 0, 220, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334f8f902fd', '株洲市', 'pub', '430200', 'cskefu', NULL, '297e1e874f83129d014f832155cb00d4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:11', '2015-08-31 18:02:11', 0, 221, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334fa3e02fe', '湘潭市', 'pub', '430300', 'cskefu', NULL, '297e1e874f83129d014f832155cb00d4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:11', '2015-08-31 18:02:11', 0, 222, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334fa5b02ff', '衡阳市', 'pub', '430400', 'cskefu', NULL, '297e1e874f83129d014f832155cb00d4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:11', '2015-08-31 18:02:11', 0, 223, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334fa6c0300', '邵阳市', 'pub', '430500', 'cskefu', NULL, '297e1e874f83129d014f832155cb00d4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:11', '2015-08-31 18:02:11', 0, 224, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334fa840301', '岳阳市', 'pub', '430600', 'cskefu', NULL, '297e1e874f83129d014f832155cb00d4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:11', '2015-08-31 18:02:11', 0, 225, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334fa950302', '常德市', 'pub', '430700', 'cskefu', NULL, '297e1e874f83129d014f832155cb00d4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:11', '2015-08-31 18:02:11', 0, 226, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334fac00303', '张家界市', 'pub', '430800', 'cskefu', NULL, '297e1e874f83129d014f832155cb00d4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:11', '2015-08-31 18:02:11', 0, 227, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334fafb0304', '益阳市', 'pub', '430900', 'cskefu', NULL, '297e1e874f83129d014f832155cb00d4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:11', '2015-08-31 18:02:11', 0, 228, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334fb1b0305', '郴州市', 'pub', '431000', 'cskefu', NULL, '297e1e874f83129d014f832155cb00d4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:11', '2015-08-31 18:02:11', 0, 229, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334fb3d0306', '永州市', 'pub', '431100', 'cskefu', NULL, '297e1e874f83129d014f832155cb00d4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:11', '2015-08-31 18:02:11', 0, 230, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334fb5d0307', '怀化市', 'pub', '431200', 'cskefu', NULL, '297e1e874f83129d014f832155cb00d4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:11', '2015-08-31 18:02:11', 0, 231, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334fb800308', '娄底市', 'pub', '431300', 'cskefu', NULL, '297e1e874f83129d014f832155cb00d4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:11', '2015-08-31 18:02:11', 0, 232, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334fb9f030a', '湘西土家族苗族自治州', 'pub', '433100', 'cskefu', NULL, '297e1e874f83129d014f832155cb00d4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:11', '2015-08-31 18:02:11', 0, 233, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334fbf4030b', '广州市', 'pub', '440100', 'cskefu', NULL, '297e1e874f83129d014f832155d800d5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:11', '2015-08-31 18:02:11', 0, 234, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334fc0d030c', '韶关市', 'pub', '440200', 'cskefu', NULL, '297e1e874f83129d014f832155d800d5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:11', '2015-08-31 18:02:11', 0, 235, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334fc35030d', '深圳市', 'pub', '440300', 'cskefu', NULL, '297e1e874f83129d014f832155d800d5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:11', '2015-08-31 18:02:11', 0, 236, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334fc4d030e', '珠海市', 'pub', '440400', 'cskefu', NULL, '297e1e874f83129d014f832155d800d5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:11', '2015-08-31 18:02:11', 0, 237, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334fc64030f', '汕头市', 'pub', '440500', 'cskefu', NULL, '297e1e874f83129d014f832155d800d5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:11', '2015-08-31 18:02:11', 0, 238, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334fc830310', '佛山市', 'pub', '440600', 'cskefu', NULL, '297e1e874f83129d014f832155d800d5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:11', '2015-08-31 18:02:11', 0, 239, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334fca40311', '江门市', 'pub', '440700', 'cskefu', NULL, '297e1e874f83129d014f832155d800d5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:12', '2015-08-31 18:02:12', 0, 240, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334fcc10312', '湛江市', 'pub', '440800', 'cskefu', NULL, '297e1e874f83129d014f832155d800d5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:12', '2015-08-31 18:02:12', 0, 241, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334fcdb0313', '茂名市', 'pub', '440900', 'cskefu', NULL, '297e1e874f83129d014f832155d800d5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:12', '2015-08-31 18:02:12', 0, 242, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334fceb0314', '肇庆市', 'pub', '441200', 'cskefu', NULL, '297e1e874f83129d014f832155d800d5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:12', '2015-08-31 18:02:12', 0, 243, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334fd140315', '惠州市', 'pub', '441300', 'cskefu', NULL, '297e1e874f83129d014f832155d800d5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:12', '2015-08-31 18:02:12', 0, 244, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334fd2f0316', '梅州市', 'pub', '441400', 'cskefu', NULL, '297e1e874f83129d014f832155d800d5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:12', '2015-08-31 18:02:12', 0, 245, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334fd4d0317', '汕尾市', 'pub', '441500', 'cskefu', NULL, '297e1e874f83129d014f832155d800d5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:12', '2015-08-31 18:02:12', 0, 246, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334fd650318', '河源市', 'pub', '441600', 'cskefu', NULL, '297e1e874f83129d014f832155d800d5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:12', '2015-08-31 18:02:12', 0, 247, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334fd7b0319', '阳江市', 'pub', '441700', 'cskefu', NULL, '297e1e874f83129d014f832155d800d5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:12', '2015-08-31 18:02:12', 0, 248, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334fda2031a', '清远市', 'pub', '441800', 'cskefu', NULL, '297e1e874f83129d014f832155d800d5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:12', '2015-08-31 18:02:12', 0, 249, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334fdbd031b', '东莞市', 'pub', '441900', 'cskefu', NULL, '297e1e874f83129d014f832155d800d5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:12', '2015-08-31 18:02:12', 0, 250, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334fdd3031c', '中山市', 'pub', '442000', 'cskefu', NULL, '297e1e874f83129d014f832155d800d5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:12', '2015-08-31 18:02:12', 0, 251, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334fde1031d', '潮州市', 'pub', '445100', 'cskefu', NULL, '297e1e874f83129d014f832155d800d5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:12', '2015-08-31 18:02:12', 0, 252, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334fdf3031e', '揭阳市', 'pub', '445200', 'cskefu', NULL, '297e1e874f83129d014f832155d800d5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:12', '2015-08-31 18:02:12', 0, 253, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334fe01031f', '云浮市', 'pub', '445300', 'cskefu', NULL, '297e1e874f83129d014f832155d800d5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:12', '2015-08-31 18:02:12', 0, 254, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334ff530320', '南宁市', 'pub', '450100', 'cskefu', NULL, '297e1e874f83129d014f832155e400d6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:12', '2015-08-31 18:02:12', 0, 255, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334ff630321', '柳州市', 'pub', '450200', 'cskefu', NULL, '297e1e874f83129d014f832155e400d6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:12', '2015-08-31 18:02:12', 0, 256, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334ff6f0322', '桂林市', 'pub', '450300', 'cskefu', NULL, '297e1e874f83129d014f832155e400d6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:12', '2015-08-31 18:02:12', 0, 257, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334ff7c0323', '梧州市', 'pub', '450400', 'cskefu', NULL, '297e1e874f83129d014f832155e400d6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:12', '2015-08-31 18:02:12', 0, 258, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334ff890324', '北海市', 'pub', '450500', 'cskefu', NULL, '297e1e874f83129d014f832155e400d6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:12', '2015-08-31 18:02:12', 0, 259, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334ff970325', '防城港市', 'pub', '450600', 'cskefu', NULL, '297e1e874f83129d014f832155e400d6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:12', '2015-08-31 18:02:12', 0, 260, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334ffa50326', '钦州市', 'pub', '450700', 'cskefu', NULL, '297e1e874f83129d014f832155e400d6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:12', '2015-08-31 18:02:12', 0, 261, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334ffb30327', '贵港市', 'pub', '450800', 'cskefu', NULL, '297e1e874f83129d014f832155e400d6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:12', '2015-08-31 18:02:12', 0, 262, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334ffbf0328', '玉林市', 'pub', '450900', 'cskefu', NULL, '297e1e874f83129d014f832155e400d6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:12', '2015-08-31 18:02:12', 0, 263, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334ffce0329', '百色市', 'pub', '451000', 'cskefu', NULL, '297e1e874f83129d014f832155e400d6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:12', '2015-08-31 18:02:12', 0, 264, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334ffda032a', '贺州市', 'pub', '451100', 'cskefu', NULL, '297e1e874f83129d014f832155e400d6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:12', '2015-08-31 18:02:12', 0, 265, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334ffe8032b', '河池市', 'pub', '451200', 'cskefu', NULL, '297e1e874f83129d014f832155e400d6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:12', '2015-08-31 18:02:12', 0, 266, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8334fff6032c', '来宾市', 'pub', '451300', 'cskefu', NULL, '297e1e874f83129d014f832155e400d6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:12', '2015-08-31 18:02:12', 0, 267, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83350136032d', '崇左市', 'pub', '451400', 'cskefu', NULL, '297e1e874f83129d014f832155e400d6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:13', '2015-08-31 18:02:13', 0, 268, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8335015b032e', '海口市', 'pub', '460100', 'cskefu', NULL, '297e1e874f83129d014f832155f300d7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:13', '2015-08-31 18:02:13', 0, 269, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83350167032f', '三亚市', 'pub', '460200', 'cskefu', NULL, '297e1e874f83129d014f832155f300d7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:13', '2015-08-31 18:02:13', 0, 270, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833501740330', '省直辖县级行政单位', 'pub', '469000', 'cskefu', NULL, '297e1e874f83129d014f832155f300d7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:13', '2015-08-31 18:02:13', 0, 271, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833501a30331', '市辖区', 'pub', '500100', 'cskefu', NULL, '297e1e874f83129d014f832155ff00d8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:13', '2015-08-31 18:02:13', 0, 272, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833501b20332', '县', 'pub', '500200', 'cskefu', NULL, '297e1e874f83129d014f832155ff00d8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:13', '2015-08-31 18:02:13', 0, 273, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833501c00333', '市', 'pub', '500300', 'cskefu', NULL, '297e1e874f83129d014f832155ff00d8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:13', '2015-08-31 18:02:13', 0, 274, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833503160334', '成都市', 'pub', '510100', 'cskefu', NULL, '297e1e874f83129d014f8321560b00d9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:13', '2015-08-31 18:02:13', 0, 275, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8335032b0335', '自贡市', 'pub', '510300', 'cskefu', NULL, '297e1e874f83129d014f8321560b00d9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:13', '2015-08-31 18:02:13', 0, 276, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8335033a0336', '攀枝花市', 'pub', '510400', 'cskefu', NULL, '297e1e874f83129d014f8321560b00d9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:13', '2015-08-31 18:02:13', 0, 277, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833503490337', '泸州市', 'pub', '510500', 'cskefu', NULL, '297e1e874f83129d014f8321560b00d9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:13', '2015-08-31 18:02:13', 0, 278, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833503570338', '德阳市', 'pub', '510600', 'cskefu', NULL, '297e1e874f83129d014f8321560b00d9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:13', '2015-08-31 18:02:13', 0, 279, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833503650339', '绵阳市', 'pub', '510700', 'cskefu', NULL, '297e1e874f83129d014f8321560b00d9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:13', '2015-08-31 18:02:13', 0, 280, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83350373033a', '广元市', 'pub', '510800', 'cskefu', NULL, '297e1e874f83129d014f8321560b00d9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:13', '2015-08-31 18:02:13', 0, 281, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8335037f033b', '遂宁市', 'pub', '510900', 'cskefu', NULL, '297e1e874f83129d014f8321560b00d9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:13', '2015-08-31 18:02:13', 0, 282, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83350393033c', '内江市', 'pub', '511000', 'cskefu', NULL, '297e1e874f83129d014f8321560b00d9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:13', '2015-08-31 18:02:13', 0, 283, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833503b0033d', '乐山市', 'pub', '511100', 'cskefu', NULL, '297e1e874f83129d014f8321560b00d9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:13', '2015-08-31 18:02:13', 0, 284, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833503bf033e', '南充市', 'pub', '511300', 'cskefu', NULL, '297e1e874f83129d014f8321560b00d9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:13', '2015-08-31 18:02:13', 0, 285, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833503cf033f', '眉山市', 'pub', '511400', 'cskefu', NULL, '297e1e874f83129d014f8321560b00d9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:13', '2015-08-31 18:02:13', 0, 286, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833503df0340', '宜宾市', 'pub', '511500', 'cskefu', NULL, '297e1e874f83129d014f8321560b00d9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:13', '2015-08-31 18:02:13', 0, 287, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833503f10341', '广安市', 'pub', '511600', 'cskefu', NULL, '297e1e874f83129d014f8321560b00d9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:13', '2015-08-31 18:02:13', 0, 288, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833504010342', '达州市', 'pub', '511700', 'cskefu', NULL, '297e1e874f83129d014f8321560b00d9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:13', '2015-08-31 18:02:13', 0, 289, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833504100343', '雅安市', 'pub', '511800', 'cskefu', NULL, '297e1e874f83129d014f8321560b00d9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:13', '2015-08-31 18:02:13', 0, 290, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833504230344', '巴中市', 'pub', '511900', 'cskefu', NULL, '297e1e874f83129d014f8321560b00d9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:13', '2015-08-31 18:02:13', 0, 291, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833505600345', '资阳市', 'pub', '512000', 'cskefu', NULL, '297e1e874f83129d014f8321560b00d9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:14', '2015-08-31 18:02:14', 0, 292, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833505730346', '阿坝藏族羌族自治州', 'pub', '513200', 'cskefu', NULL, '297e1e874f83129d014f8321560b00d9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:14', '2015-08-31 18:02:14', 0, 293, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833505830347', '甘孜藏族自治州', 'pub', '513300', 'cskefu', NULL, '297e1e874f83129d014f8321560b00d9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:14', '2015-08-31 18:02:14', 0, 294, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833505940348', '凉山彝族自治州', 'pub', '513400', 'cskefu', NULL, '297e1e874f83129d014f8321560b00d9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:14', '2015-08-31 18:02:14', 0, 295, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833505ca0349', '贵阳市', 'pub', '520100', 'cskefu', NULL, '297e1e874f83129d014f8321561800da', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:14', '2015-08-31 18:02:14', 0, 296, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833505d9034a', '六盘水市', 'pub', '520200', 'cskefu', NULL, '297e1e874f83129d014f8321561800da', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:14', '2015-08-31 18:02:14', 0, 297, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833505ea034b', '遵义市', 'pub', '520300', 'cskefu', NULL, '297e1e874f83129d014f8321561800da', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:14', '2015-08-31 18:02:14', 0, 298, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833505fb034c', '安顺市', 'pub', '520400', 'cskefu', NULL, '297e1e874f83129d014f8321561800da', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:14', '2015-08-31 18:02:14', 0, 299, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8335060c034d', '铜仁地区', 'pub', '522200', 'cskefu', NULL, '297e1e874f83129d014f8321561800da', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:14', '2015-08-31 18:02:14', 0, 300, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8335061f034e', '黔西南布依族苗族自治州', 'pub', '522300', 'cskefu', NULL, '297e1e874f83129d014f8321561800da', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:14', '2015-08-31 18:02:14', 0, 301, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8335062e034f', '毕节地区', 'pub', '522400', 'cskefu', NULL, '297e1e874f83129d014f8321561800da', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:14', '2015-08-31 18:02:14', 0, 302, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833506400350', '黔东南苗族侗族自治州', 'pub', '522600', 'cskefu', NULL, '297e1e874f83129d014f8321561800da', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:14', '2015-08-31 18:02:14', 0, 303, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833506500351', '黔南布依族苗族自治州', 'pub', '522700', 'cskefu', NULL, '297e1e874f83129d014f8321561800da', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:14', '2015-08-31 18:02:14', 0, 304, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833506810352', '昆明市', 'pub', '530100', 'cskefu', NULL, '297e1e874f83129d014f8321562400db', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:14', '2015-08-31 18:02:14', 0, 305, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833507bf0353', '曲靖市', 'pub', '530300', 'cskefu', NULL, '297e1e874f83129d014f8321562400db', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:14', '2015-08-31 18:02:14', 0, 306, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833507cd0354', '玉溪市', 'pub', '530400', 'cskefu', NULL, '297e1e874f83129d014f8321562400db', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:14', '2015-08-31 18:02:14', 0, 307, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833507e00355', '保山市', 'pub', '530500', 'cskefu', NULL, '297e1e874f83129d014f8321562400db', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:14', '2015-08-31 18:02:14', 0, 308, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833507f60356', '昭通市', 'pub', '530600', 'cskefu', NULL, '297e1e874f83129d014f8321562400db', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:14', '2015-08-31 18:02:14', 0, 309, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833508050357', '丽江市', 'pub', '530700', 'cskefu', NULL, '297e1e874f83129d014f8321562400db', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:14', '2015-08-31 18:02:14', 0, 310, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833508180358', '思茅市', 'pub', '530800', 'cskefu', NULL, '297e1e874f83129d014f8321562400db', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:14', '2015-08-31 18:02:14', 0, 311, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833508270359', '临沧市', 'pub', '530900', 'cskefu', NULL, '297e1e874f83129d014f8321562400db', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:14', '2015-08-31 18:02:14', 0, 312, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8335083b035a', '楚雄彝族自治州', 'pub', '532300', 'cskefu', NULL, '297e1e874f83129d014f8321562400db', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:14', '2015-08-31 18:02:14', 0, 313, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8335084a035b', '红河哈尼族彝族自治州', 'pub', '532500', 'cskefu', NULL, '297e1e874f83129d014f8321562400db', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:14', '2015-08-31 18:02:14', 0, 314, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8335085b035c', '文山壮族苗族自治州', 'pub', '532600', 'cskefu', NULL, '297e1e874f83129d014f8321562400db', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:15', '2015-08-31 18:02:15', 0, 315, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8335086c035d', '西双版纳傣族自治州', 'pub', '532800', 'cskefu', NULL, '297e1e874f83129d014f8321562400db', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:15', '2015-08-31 18:02:15', 0, 316, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8335087a035e', '大理白族自治州', 'pub', '532900', 'cskefu', NULL, '297e1e874f83129d014f8321562400db', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:15', '2015-08-31 18:02:15', 0, 317, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8335088a035f', '德宏傣族景颇族自治州', 'pub', '533100', 'cskefu', NULL, '297e1e874f83129d014f8321562400db', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:15', '2015-08-31 18:02:15', 0, 318, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8335089b0360', '怒江傈僳族自治州', 'pub', '533300', 'cskefu', NULL, '297e1e874f83129d014f8321562400db', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:15', '2015-08-31 18:02:15', 0, 319, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833508b20361', '迪庆藏族自治州', 'pub', '533400', 'cskefu', NULL, '297e1e874f83129d014f8321562400db', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:15', '2015-08-31 18:02:15', 0, 320, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833508e00362', '拉萨市', 'pub', '540100', 'cskefu', NULL, '297e1e874f83129d014f8321563300dc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:15', '2015-08-31 18:02:15', 0, 321, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83350a1c0363', '昌都地区', 'pub', '542100', 'cskefu', NULL, '297e1e874f83129d014f8321563300dc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:15', '2015-08-31 18:02:15', 0, 322, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83350a2b0364', '山南地区', 'pub', '542200', 'cskefu', NULL, '297e1e874f83129d014f8321563300dc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:15', '2015-08-31 18:02:15', 0, 323, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83350a3a0365', '日喀则地区', 'pub', '542300', 'cskefu', NULL, '297e1e874f83129d014f8321563300dc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:15', '2015-08-31 18:02:15', 0, 324, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83350a480366', '那曲地区', 'pub', '542400', 'cskefu', NULL, '297e1e874f83129d014f8321563300dc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:15', '2015-08-31 18:02:15', 0, 325, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83350a560367', '阿里地区', 'pub', '542500', 'cskefu', NULL, '297e1e874f83129d014f8321563300dc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:15', '2015-08-31 18:02:15', 0, 326, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83350a650368', '林芝地区', 'pub', '542600', 'cskefu', NULL, '297e1e874f83129d014f8321563300dc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:15', '2015-08-31 18:02:15', 0, 327, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83350a8e0369', '西安市', 'pub', '610100', 'cskefu', NULL, '297e1e874f83129d014f8321564100dd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:15', '2015-08-31 18:02:15', 0, 328, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83350aa1036a', '铜川市', 'pub', '610200', 'cskefu', NULL, '297e1e874f83129d014f8321564100dd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:15', '2015-08-31 18:02:15', 0, 329, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83350ab6036b', '宝鸡市', 'pub', '610300', 'cskefu', NULL, '297e1e874f83129d014f8321564100dd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:15', '2015-08-31 18:02:15', 0, 330, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83350ad3036c', '咸阳市', 'pub', '610400', 'cskefu', NULL, '297e1e874f83129d014f8321564100dd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:15', '2015-08-31 18:02:15', 0, 331, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83350ae2036d', '渭南市', 'pub', '610500', 'cskefu', NULL, '297e1e874f83129d014f8321564100dd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:15', '2015-08-31 18:02:15', 0, 332, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83350af0036e', '延安市', 'pub', '610600', 'cskefu', NULL, '297e1e874f83129d014f8321564100dd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:15', '2015-08-31 18:02:15', 0, 333, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83350afe036f', '汉中市', 'pub', '610700', 'cskefu', NULL, '297e1e874f83129d014f8321564100dd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:15', '2015-08-31 18:02:15', 0, 334, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83350b0b0370', '榆林市', 'pub', '610800', 'cskefu', NULL, '297e1e874f83129d014f8321564100dd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:15', '2015-08-31 18:02:15', 0, 335, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83350b170371', '安康市', 'pub', '610900', 'cskefu', NULL, '297e1e874f83129d014f8321564100dd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:15', '2015-08-31 18:02:15', 0, 336, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83350c540372', '商洛市', 'pub', '611000', 'cskefu', NULL, '297e1e874f83129d014f8321564100dd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:16', '2015-08-31 18:02:16', 0, 337, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83350c7b0373', '兰州市', 'pub', '620100', 'cskefu', NULL, '297e1e874f83129d014f8321564f00de', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:16', '2015-08-31 18:02:16', 0, 338, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83350c890374', '嘉峪关市', 'pub', '620200', 'cskefu', NULL, '297e1e874f83129d014f8321564f00de', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:16', '2015-08-31 18:02:16', 0, 339, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83350c960375', '金昌市', 'pub', '620300', 'cskefu', NULL, '297e1e874f83129d014f8321564f00de', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:16', '2015-08-31 18:02:16', 0, 340, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83350ca40376', '白银市', 'pub', '620400', 'cskefu', NULL, '297e1e874f83129d014f8321564f00de', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:16', '2015-08-31 18:02:16', 0, 341, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83350cb10377', '天水市', 'pub', '620500', 'cskefu', NULL, '297e1e874f83129d014f8321564f00de', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:16', '2015-08-31 18:02:16', 0, 342, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83350cc20378', '武威市', 'pub', '620600', 'cskefu', NULL, '297e1e874f83129d014f8321564f00de', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:16', '2015-08-31 18:02:16', 0, 343, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83350cd10379', '张掖市', 'pub', '620700', 'cskefu', NULL, '297e1e874f83129d014f8321564f00de', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:16', '2015-08-31 18:02:16', 0, 344, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83350cde037a', '平凉市', 'pub', '620800', 'cskefu', NULL, '297e1e874f83129d014f8321564f00de', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:16', '2015-08-31 18:02:16', 0, 345, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83350cec037b', '酒泉市', 'pub', '620900', 'cskefu', NULL, '297e1e874f83129d014f8321564f00de', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:16', '2015-08-31 18:02:16', 0, 346, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83350cf9037c', '庆阳市', 'pub', '621000', 'cskefu', NULL, '297e1e874f83129d014f8321564f00de', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:16', '2015-08-31 18:02:16', 0, 347, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83350d09037d', '定西市', 'pub', '621100', 'cskefu', NULL, '297e1e874f83129d014f8321564f00de', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:16', '2015-08-31 18:02:16', 0, 348, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83350d19037e', '陇南市', 'pub', '621200', 'cskefu', NULL, '297e1e874f83129d014f8321564f00de', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:16', '2015-08-31 18:02:16', 0, 349, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83350e53037f', '临夏回族自治州', 'pub', '622900', 'cskefu', NULL, '297e1e874f83129d014f8321564f00de', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:16', '2015-08-31 18:02:16', 0, 350, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83350e600380', '甘南藏族自治州', 'pub', '623000', 'cskefu', NULL, '297e1e874f83129d014f8321564f00de', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:16', '2015-08-31 18:02:16', 0, 351, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83350e890381', '西宁市', 'pub', '630100', 'cskefu', NULL, '297e1e874f83129d014f8321565d00df', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:16', '2015-08-31 18:02:16', 0, 352, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83350e990382', '海东地区', 'pub', '632100', 'cskefu', NULL, '297e1e874f83129d014f8321565d00df', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:16', '2015-08-31 18:02:16', 0, 353, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83350ea80383', '海北藏族自治州', 'pub', '632200', 'cskefu', NULL, '297e1e874f83129d014f8321565d00df', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:16', '2015-08-31 18:02:16', 0, 354, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83350eb90384', '黄南藏族自治州', 'pub', '632300', 'cskefu', NULL, '297e1e874f83129d014f8321565d00df', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:16', '2015-08-31 18:02:16', 0, 355, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83350ec60385', '海南藏族自治州', 'pub', '632500', 'cskefu', NULL, '297e1e874f83129d014f8321565d00df', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:16', '2015-08-31 18:02:16', 0, 356, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83350ed80386', '果洛藏族自治州', 'pub', '632600', 'cskefu', NULL, '297e1e874f83129d014f8321565d00df', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:16', '2015-08-31 18:02:16', 0, 357, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83350ee90387', '玉树藏族自治州', 'pub', '632700', 'cskefu', NULL, '297e1e874f83129d014f8321565d00df', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:16', '2015-08-31 18:02:16', 0, 358, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83350efd0388', '海西蒙古族藏族自治州', 'pub', '632800', 'cskefu', NULL, '297e1e874f83129d014f8321565d00df', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:16', '2015-08-31 18:02:16', 0, 359, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83350f24038a', '银川市', 'pub', '640100', 'cskefu', NULL, '297e1e874f83129d014f8321566d00e0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:16', '2015-08-31 18:02:16', 0, 360, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8335105f038b', '石嘴山市', 'pub', '640200', 'cskefu', NULL, '297e1e874f83129d014f8321566d00e0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:17', '2015-08-31 18:02:17', 0, 361, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8335106f038c', '吴忠市', 'pub', '640300', 'cskefu', NULL, '297e1e874f83129d014f8321566d00e0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:17', '2015-08-31 18:02:17', 0, 362, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83351081038d', '固原市', 'pub', '640400', 'cskefu', NULL, '297e1e874f83129d014f8321566d00e0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:17', '2015-08-31 18:02:17', 0, 363, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83351091038e', '中卫市', 'pub', '640500', 'cskefu', NULL, '297e1e874f83129d014f8321566d00e0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:17', '2015-08-31 18:02:17', 0, 364, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833510c5038f', '乌鲁木齐市', 'pub', '650100', 'cskefu', NULL, '297e1e874f83129d014f8321567900e1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:17', '2015-08-31 18:02:17', 0, 365, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833510d30390', '克拉玛依市', 'pub', '650200', 'cskefu', NULL, '297e1e874f83129d014f8321567900e1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:17', '2015-08-31 18:02:17', 0, 366, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833510e90391', '吐鲁番地区', 'pub', '652100', 'cskefu', NULL, '297e1e874f83129d014f8321567900e1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:17', '2015-08-31 18:02:17', 0, 367, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833510fa0392', '哈密地区', 'pub', '652200', 'cskefu', NULL, '297e1e874f83129d014f8321567900e1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:17', '2015-08-31 18:02:17', 0, 368, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833511050393', '昌吉回族自治州', 'pub', '652300', 'cskefu', NULL, '297e1e874f83129d014f8321567900e1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:17', '2015-08-31 18:02:17', 0, 369, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8335111a0394', '博尔塔拉蒙古自治州', 'pub', '652700', 'cskefu', NULL, '297e1e874f83129d014f8321567900e1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:17', '2015-08-31 18:02:17', 0, 370, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833511280395', '巴音郭楞蒙古自治州', 'pub', '652800', 'cskefu', NULL, '297e1e874f83129d014f8321567900e1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:17', '2015-08-31 18:02:17', 0, 371, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833512b80396', '阿克苏地区', 'pub', '652900', 'cskefu', NULL, '297e1e874f83129d014f8321567900e1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:17', '2015-08-31 18:02:17', 0, 372, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833512c90397', '克孜勒苏柯尔克孜自治州', 'pub', '653000', 'cskefu', NULL, '297e1e874f83129d014f8321567900e1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:17', '2015-08-31 18:02:17', 0, 373, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833512e50398', '喀什地区', 'pub', '653100', 'cskefu', NULL, '297e1e874f83129d014f8321567900e1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:17', '2015-08-31 18:02:17', 0, 374, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833512f60399', '和田地区', 'pub', '653200', 'cskefu', NULL, '297e1e874f83129d014f8321567900e1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:17', '2015-08-31 18:02:17', 0, 375, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8335130a039a', '伊犁哈萨克自治州', 'pub', '654000', 'cskefu', NULL, '297e1e874f83129d014f8321567900e1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:17', '2015-08-31 18:02:17', 0, 376, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8335131d039b', '塔城地区', 'pub', '654200', 'cskefu', NULL, '297e1e874f83129d014f8321567900e1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:17', '2015-08-31 18:02:17', 0, 377, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83351330039c', '阿勒泰地区', 'pub', '654300', 'cskefu', NULL, '297e1e874f83129d014f8321567900e1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:17', '2015-08-31 18:02:17', 0, 378, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83351347039d', '省直辖行政单位', 'pub', '659000', 'cskefu', NULL, '297e1e874f83129d014f8321567900e1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:02:17', '2015-08-31 18:02:17', 0, 379, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337713e03bd', '东城区', 'pub', '110101', 'cskefu', NULL, '297e1e874f83129d014f8334e3430242', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:52', '2015-08-31 18:04:52', 0, 35, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337715003be', '西城区', 'pub', '110102', 'cskefu', NULL, '297e1e874f83129d014f8334e3430242', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:52', '2015-08-31 18:04:52', 0, 36, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337716903bf', '崇文区', 'pub', '110103', 'cskefu', NULL, '297e1e874f83129d014f8334e3430242', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:52', '2015-08-31 18:04:52', 0, 37, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337718003c0', '宣武区', 'pub', '110104', 'cskefu', NULL, '297e1e874f83129d014f8334e3430242', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:52', '2015-08-31 18:04:52', 0, 38, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337719403c1', '朝阳区', 'pub', '110105', 'cskefu', NULL, '297e1e874f83129d014f8334e3430242', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', 0, 39, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833771a603c2', '丰台区', 'pub', '110106', 'cskefu', NULL, '297e1e874f83129d014f8334e3430242', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', 0, 40, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833771b803c3', '石景山区', 'pub', '110107', 'cskefu', NULL, '297e1e874f83129d014f8334e3430242', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', 0, 41, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833771cb03c4', '海淀区', 'pub', '110108', 'cskefu', NULL, '297e1e874f83129d014f8334e3430242', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', 0, 42, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833771df03c5', '门头沟区', 'pub', '110109', 'cskefu', NULL, '297e1e874f83129d014f8334e3430242', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', 0, 43, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833771f403c6', '房山区', 'pub', '110111', 'cskefu', NULL, '297e1e874f83129d014f8334e3430242', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', 0, 44, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337720303c7', '通州区', 'pub', '110112', 'cskefu', NULL, '297e1e874f83129d014f8334e3430242', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', 0, 45, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337721c03c8', '顺义区', 'pub', '110113', 'cskefu', NULL, '297e1e874f83129d014f8334e3430242', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', 0, 46, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337722b03c9', '昌平区', 'pub', '110114', 'cskefu', NULL, '297e1e874f83129d014f8334e3430242', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', 0, 47, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337724203ca', '大兴区', 'pub', '110115', 'cskefu', NULL, '297e1e874f83129d014f8334e3430242', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', 0, 48, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337725203cb', '怀柔区', 'pub', '110116', 'cskefu', NULL, '297e1e874f83129d014f8334e3430242', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', 0, 49, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337726203cc', '平谷区', 'pub', '110117', 'cskefu', NULL, '297e1e874f83129d014f8334e3430242', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', 0, 50, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337729303cd', '密云县', 'pub', '110228', 'cskefu', NULL, '297e1e874f83129d014f8334e3550243', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', 0, 51, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833772a503ce', '延庆县', 'pub', '110229', 'cskefu', NULL, '297e1e874f83129d014f8334e3550243', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', 0, 52, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833772e803cf', '和平区', 'pub', '120101', 'cskefu', NULL, '297e1e874f83129d014f8334e3860244', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', 0, 53, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337731503d0', '河东区', 'pub', '120102', 'cskefu', NULL, '297e1e874f83129d014f8334e3860244', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', 0, 54, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337732a03d1', '河西区', 'pub', '120103', 'cskefu', NULL, '297e1e874f83129d014f8334e3860244', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', 0, 55, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337733b03d2', '南开区', 'pub', '120104', 'cskefu', NULL, '297e1e874f83129d014f8334e3860244', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', 0, 56, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337735003d3', '河北区', 'pub', '120105', 'cskefu', NULL, '297e1e874f83129d014f8334e3860244', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', 0, 57, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337736103d4', '红桥区', 'pub', '120106', 'cskefu', NULL, '297e1e874f83129d014f8334e3860244', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', 0, 58, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337737103d5', '塘沽区', 'pub', '120107', 'cskefu', NULL, '297e1e874f83129d014f8334e3860244', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', 0, 59, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337738303d6', '汉沽区', 'pub', '120108', 'cskefu', NULL, '297e1e874f83129d014f8334e3860244', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', 0, 60, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337739203d7', '大港区', 'pub', '120109', 'cskefu', NULL, '297e1e874f83129d014f8334e3860244', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', 0, 61, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833773a503d8', '东丽区', 'pub', '120110', 'cskefu', NULL, '297e1e874f83129d014f8334e3860244', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', 0, 62, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833773b703d9', '西青区', 'pub', '120111', 'cskefu', NULL, '297e1e874f83129d014f8334e3860244', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', 0, 63, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833773c503da', '津南区', 'pub', '120112', 'cskefu', NULL, '297e1e874f83129d014f8334e3860244', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', 0, 64, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833773d603db', '北辰区', 'pub', '120113', 'cskefu', NULL, '297e1e874f83129d014f8334e3860244', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', 0, 65, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833773e703dc', '武清区', 'pub', '120114', 'cskefu', NULL, '297e1e874f83129d014f8334e3860244', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', 0, 66, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833773f903dd', '宝坻区', 'pub', '120115', 'cskefu', NULL, '297e1e874f83129d014f8334e3860244', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', 0, 67, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337742703de', '宁河县', 'pub', '120221', 'cskefu', NULL, '297e1e874f83129d014f8334e3960245', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', 0, 68, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337743e03df', '静海县', 'pub', '120223', 'cskefu', NULL, '297e1e874f83129d014f8334e3960245', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', 0, 69, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337745203e0', '蓟　县', 'pub', '120225', 'cskefu', NULL, '297e1e874f83129d014f8334e3960245', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', 0, 70, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337748003e1', '市辖区', 'pub', '130101', 'cskefu', NULL, '297e1e874f83129d014f8334e3c00246', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', 0, 71, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337748e03e2', '长安区', 'pub', '130102', 'cskefu', NULL, '297e1e874f83129d014f8334e3c00246', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', 0, 72, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337749e03e3', '桥东区', 'pub', '130103', 'cskefu', NULL, '297e1e874f83129d014f8334e3c00246', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', 0, 73, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833774ad03e4', '桥西区', 'pub', '130104', 'cskefu', NULL, '297e1e874f83129d014f8334e3c00246', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', 0, 74, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833774bb03e5', '新华区', 'pub', '130105', 'cskefu', NULL, '297e1e874f83129d014f8334e3c00246', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', 0, 75, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833774c903e6', '井陉矿区', 'pub', '130107', 'cskefu', NULL, '297e1e874f83129d014f8334e3c00246', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', 0, 76, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833774da03e7', '裕华区', 'pub', '130108', 'cskefu', NULL, '297e1e874f83129d014f8334e3c00246', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', 0, 77, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833774e903e8', '井陉县', 'pub', '130121', 'cskefu', NULL, '297e1e874f83129d014f8334e3c00246', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', 0, 78, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833774fb03e9', '正定县', 'pub', '130123', 'cskefu', NULL, '297e1e874f83129d014f8334e3c00246', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', 0, 79, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337750b03ea', '栾城县', 'pub', '130124', 'cskefu', NULL, '297e1e874f83129d014f8334e3c00246', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', 0, 80, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337751e03eb', '行唐县', 'pub', '130125', 'cskefu', NULL, '297e1e874f83129d014f8334e3c00246', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', 0, 81, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337753403ec', '灵寿县', 'pub', '130126', 'cskefu', NULL, '297e1e874f83129d014f8334e3c00246', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', 0, 82, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337754303ed', '高邑县', 'pub', '130127', 'cskefu', NULL, '297e1e874f83129d014f8334e3c00246', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', 0, 83, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337755403ee', '深泽县', 'pub', '130128', 'cskefu', NULL, '297e1e874f83129d014f8334e3c00246', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', 0, 84, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337756603ef', '赞皇县', 'pub', '130129', 'cskefu', NULL, '297e1e874f83129d014f8334e3c00246', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:53', '2015-08-31 18:04:53', 0, 85, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337757f03f0', '无极县', 'pub', '130130', 'cskefu', NULL, '297e1e874f83129d014f8334e3c00246', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', 0, 86, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337759303f1', '平山县', 'pub', '130131', 'cskefu', NULL, '297e1e874f83129d014f8334e3c00246', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', 0, 87, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833775a203f2', '元氏县', 'pub', '130132', 'cskefu', NULL, '297e1e874f83129d014f8334e3c00246', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', 0, 88, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833775b803f3', '赵　县', 'pub', '130133', 'cskefu', NULL, '297e1e874f83129d014f8334e3c00246', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', 0, 89, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833775ca03f4', '辛集市', 'pub', '130181', 'cskefu', NULL, '297e1e874f83129d014f8334e3c00246', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', 0, 90, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833775d903f5', '藁城市', 'pub', '130182', 'cskefu', NULL, '297e1e874f83129d014f8334e3c00246', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', 0, 91, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833775e603f6', '晋州市', 'pub', '130183', 'cskefu', NULL, '297e1e874f83129d014f8334e3c00246', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', 0, 92, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833775f503f7', '新乐市', 'pub', '130184', 'cskefu', NULL, '297e1e874f83129d014f8334e3c00246', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', 0, 93, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337760203f8', '鹿泉市', 'pub', '130185', 'cskefu', NULL, '297e1e874f83129d014f8334e3c00246', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', 0, 94, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337762f03f9', '市辖区', 'pub', '130201', 'cskefu', NULL, '297e1e874f83129d014f8334e3cc0247', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', 0, 95, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337763e03fa', '路南区', 'pub', '130202', 'cskefu', NULL, '297e1e874f83129d014f8334e3cc0247', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', 0, 96, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337764d03fb', '路北区', 'pub', '130203', 'cskefu', NULL, '297e1e874f83129d014f8334e3cc0247', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', 0, 97, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337765d03fc', '古冶区', 'pub', '130204', 'cskefu', NULL, '297e1e874f83129d014f8334e3cc0247', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', 0, 98, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337766e03fd', '开平区', 'pub', '130205', 'cskefu', NULL, '297e1e874f83129d014f8334e3cc0247', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', 0, 99, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337768003fe', '丰南区', 'pub', '130207', 'cskefu', NULL, '297e1e874f83129d014f8334e3cc0247', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', 0, 100, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337768f03ff', '丰润区', 'pub', '130208', 'cskefu', NULL, '297e1e874f83129d014f8334e3cc0247', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', 0, 101, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337769f0400', '滦　县', 'pub', '130223', 'cskefu', NULL, '297e1e874f83129d014f8334e3cc0247', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', 0, 102, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833776af0401', '滦南县', 'pub', '130224', 'cskefu', NULL, '297e1e874f83129d014f8334e3cc0247', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', 0, 103, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833776c10402', '乐亭县', 'pub', '130225', 'cskefu', NULL, '297e1e874f83129d014f8334e3cc0247', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', 0, 104, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833776d00403', '迁西县', 'pub', '130227', 'cskefu', NULL, '297e1e874f83129d014f8334e3cc0247', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', 0, 105, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833776e00404', '玉田县', 'pub', '130229', 'cskefu', NULL, '297e1e874f83129d014f8334e3cc0247', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', 0, 106, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833776f20405', '唐海县', 'pub', '130230', 'cskefu', NULL, '297e1e874f83129d014f8334e3cc0247', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', 0, 107, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833777020406', '遵化市', 'pub', '130281', 'cskefu', NULL, '297e1e874f83129d014f8334e3cc0247', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', 0, 108, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833777140407', '迁安市', 'pub', '130283', 'cskefu', NULL, '297e1e874f83129d014f8334e3cc0247', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', 0, 109, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833777430408', '市辖区', 'pub', '130301', 'cskefu', NULL, '297e1e874f83129d014f8334e3d80248', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', 0, 110, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833777530409', '海港区', 'pub', '130302', 'cskefu', NULL, '297e1e874f83129d014f8334e3d80248', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', 0, 111, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83377765040a', '山海关区', 'pub', '130303', 'cskefu', NULL, '297e1e874f83129d014f8334e3d80248', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', 0, 112, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83377773040b', '北戴河区', 'pub', '130304', 'cskefu', NULL, '297e1e874f83129d014f8334e3d80248', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', 0, 113, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83377783040c', '青龙满族自治县', 'pub', '130321', 'cskefu', NULL, '297e1e874f83129d014f8334e3d80248', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', 0, 114, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83377793040d', '昌黎县', 'pub', '130322', 'cskefu', NULL, '297e1e874f83129d014f8334e3d80248', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', 0, 115, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833777a4040e', '抚宁县', 'pub', '130323', 'cskefu', NULL, '297e1e874f83129d014f8334e3d80248', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', 0, 116, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833777b4040f', '卢龙县', 'pub', '130324', 'cskefu', NULL, '297e1e874f83129d014f8334e3d80248', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', 0, 117, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833777de0410', '市辖区', 'pub', '130401', 'cskefu', NULL, '297e1e874f83129d014f8334e3e50249', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', 0, 118, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833777eb0411', '邯山区', 'pub', '130402', 'cskefu', NULL, '297e1e874f83129d014f8334e3e50249', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', 0, 119, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833777f90412', '丛台区', 'pub', '130403', 'cskefu', NULL, '297e1e874f83129d014f8334e3e50249', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', 0, 120, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337780a0413', '复兴区', 'pub', '130404', 'cskefu', NULL, '297e1e874f83129d014f8334e3e50249', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', 0, 121, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337781b0414', '峰峰矿区', 'pub', '130406', 'cskefu', NULL, '297e1e874f83129d014f8334e3e50249', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', 0, 122, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833778290415', '邯郸县', 'pub', '130421', 'cskefu', NULL, '297e1e874f83129d014f8334e3e50249', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', 0, 123, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833778380416', '临漳县', 'pub', '130423', 'cskefu', NULL, '297e1e874f83129d014f8334e3e50249', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', 0, 124, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833778470417', '成安县', 'pub', '130424', 'cskefu', NULL, '297e1e874f83129d014f8334e3e50249', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', 0, 125, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833778570418', '大名县', 'pub', '130425', 'cskefu', NULL, '297e1e874f83129d014f8334e3e50249', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', 0, 126, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833778650419', '涉　县', 'pub', '130426', 'cskefu', NULL, '297e1e874f83129d014f8334e3e50249', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', 0, 127, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83377873041a', '磁　县', 'pub', '130427', 'cskefu', NULL, '297e1e874f83129d014f8334e3e50249', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', 0, 128, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83377884041b', '肥乡县', 'pub', '130428', 'cskefu', NULL, '297e1e874f83129d014f8334e3e50249', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', 0, 129, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83377895041c', '永年县', 'pub', '130429', 'cskefu', NULL, '297e1e874f83129d014f8334e3e50249', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', 0, 130, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833778a5041d', '邱　县', 'pub', '130430', 'cskefu', NULL, '297e1e874f83129d014f8334e3e50249', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', 0, 131, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833778b4041e', '鸡泽县', 'pub', '130431', 'cskefu', NULL, '297e1e874f83129d014f8334e3e50249', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', 0, 132, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833778c3041f', '广平县', 'pub', '130432', 'cskefu', NULL, '297e1e874f83129d014f8334e3e50249', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', 0, 133, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833778d10420', '馆陶县', 'pub', '130433', 'cskefu', NULL, '297e1e874f83129d014f8334e3e50249', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', 0, 134, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833778e10421', '魏　县', 'pub', '130434', 'cskefu', NULL, '297e1e874f83129d014f8334e3e50249', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', 0, 135, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833778f20422', '曲周县', 'pub', '130435', 'cskefu', NULL, '297e1e874f83129d014f8334e3e50249', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', 0, 136, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833779010423', '武安市', 'pub', '130481', 'cskefu', NULL, '297e1e874f83129d014f8334e3e50249', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', 0, 137, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337792c0424', '市辖区', 'pub', '130501', 'cskefu', NULL, '297e1e874f83129d014f8334e3f1024a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:54', '2015-08-31 18:04:54', 0, 138, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83377a700425', '桥东区', 'pub', '130502', 'cskefu', NULL, '297e1e874f83129d014f8334e3f1024a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:55', '2015-08-31 18:04:55', 0, 139, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83377a820426', '桥西区', 'pub', '130503', 'cskefu', NULL, '297e1e874f83129d014f8334e3f1024a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:55', '2015-08-31 18:04:55', 0, 140, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83377aa70427', '邢台县', 'pub', '130521', 'cskefu', NULL, '297e1e874f83129d014f8334e3f1024a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:55', '2015-08-31 18:04:55', 0, 141, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83377abe0428', '临城县', 'pub', '130522', 'cskefu', NULL, '297e1e874f83129d014f8334e3f1024a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:55', '2015-08-31 18:04:55', 0, 142, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83377ace0429', '内丘县', 'pub', '130523', 'cskefu', NULL, '297e1e874f83129d014f8334e3f1024a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:55', '2015-08-31 18:04:55', 0, 143, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83377adc042a', '柏乡县', 'pub', '130524', 'cskefu', NULL, '297e1e874f83129d014f8334e3f1024a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:55', '2015-08-31 18:04:55', 0, 144, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83377ae9042b', '隆尧县', 'pub', '130525', 'cskefu', NULL, '297e1e874f83129d014f8334e3f1024a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:55', '2015-08-31 18:04:55', 0, 145, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83377bfa042c', '任　县', 'pub', '130526', 'cskefu', NULL, '297e1e874f83129d014f8334e3f1024a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:55', '2015-08-31 18:04:55', 0, 146, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83377c09042d', '南和县', 'pub', '130527', 'cskefu', NULL, '297e1e874f83129d014f8334e3f1024a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:55', '2015-08-31 18:04:55', 0, 147, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83377c1a042e', '宁晋县', 'pub', '130528', 'cskefu', NULL, '297e1e874f83129d014f8334e3f1024a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:55', '2015-08-31 18:04:55', 0, 148, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83377d05042f', '巨鹿县', 'pub', '130529', 'cskefu', NULL, '297e1e874f83129d014f8334e3f1024a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:55', '2015-08-31 18:04:55', 0, 149, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83377d2b0430', '新河县', 'pub', '130530', 'cskefu', NULL, '297e1e874f83129d014f8334e3f1024a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:55', '2015-08-31 18:04:55', 0, 150, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83377d570431', '广宗县', 'pub', '130531', 'cskefu', NULL, '297e1e874f83129d014f8334e3f1024a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:56', '2015-08-31 18:04:56', 0, 151, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83377e800432', '平乡县', 'pub', '130532', 'cskefu', NULL, '297e1e874f83129d014f8334e3f1024a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:56', '2015-08-31 18:04:56', 0, 152, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83377fa40433', '威　县', 'pub', '130533', 'cskefu', NULL, '297e1e874f83129d014f8334e3f1024a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:56', '2015-08-31 18:04:56', 0, 153, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83377fba0434', '清河县', 'pub', '130534', 'cskefu', NULL, '297e1e874f83129d014f8334e3f1024a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:56', '2015-08-31 18:04:56', 0, 154, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833780d30436', '临西县', 'pub', '130535', 'cskefu', NULL, '297e1e874f83129d014f8334e3f1024a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:56', '2015-08-31 18:04:56', 0, 155, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833780e30437', '南宫市', 'pub', '130581', 'cskefu', NULL, '297e1e874f83129d014f8334e3f1024a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:56', '2015-08-31 18:04:56', 0, 156, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833780f40438', '沙河市', 'pub', '130582', 'cskefu', NULL, '297e1e874f83129d014f8334e3f1024a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:56', '2015-08-31 18:04:56', 0, 157, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833781d40439', '市辖区', 'pub', '130601', 'cskefu', NULL, '297e1e874f83129d014f8334e3fd024b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:57', '2015-08-31 18:04:57', 0, 158, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833781e2043a', '新市区', 'pub', '130602', 'cskefu', NULL, '297e1e874f83129d014f8334e3fd024b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:57', '2015-08-31 18:04:57', 0, 159, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833781f4043b', '北市区', 'pub', '130603', 'cskefu', NULL, '297e1e874f83129d014f8334e3fd024b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:57', '2015-08-31 18:04:57', 0, 160, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337820f043c', '南市区', 'pub', '130604', 'cskefu', NULL, '297e1e874f83129d014f8334e3fd024b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:57', '2015-08-31 18:04:57', 0, 161, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378221043d', '满城县', 'pub', '130621', 'cskefu', NULL, '297e1e874f83129d014f8334e3fd024b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:57', '2015-08-31 18:04:57', 0, 162, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378339043e', '清苑县', 'pub', '130622', 'cskefu', NULL, '297e1e874f83129d014f8334e3fd024b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:57', '2015-08-31 18:04:57', 0, 163, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337834d043f', '涞水县', 'pub', '130623', 'cskefu', NULL, '297e1e874f83129d014f8334e3fd024b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:57', '2015-08-31 18:04:57', 0, 164, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337846b0440', '阜平县', 'pub', '130624', 'cskefu', NULL, '297e1e874f83129d014f8334e3fd024b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:57', '2015-08-31 18:04:57', 0, 165, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833784820441', '徐水县', 'pub', '130625', 'cskefu', NULL, '297e1e874f83129d014f8334e3fd024b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:57', '2015-08-31 18:04:57', 0, 166, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833785420442', '定兴县', 'pub', '130626', 'cskefu', NULL, '297e1e874f83129d014f8334e3fd024b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:58', '2015-08-31 18:04:58', 0, 167, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833785540443', '唐　县', 'pub', '130627', 'cskefu', NULL, '297e1e874f83129d014f8334e3fd024b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:58', '2015-08-31 18:04:58', 0, 168, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833785630444', '高阳县', 'pub', '130628', 'cskefu', NULL, '297e1e874f83129d014f8334e3fd024b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:58', '2015-08-31 18:04:58', 0, 169, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833785730445', '容城县', 'pub', '130629', 'cskefu', NULL, '297e1e874f83129d014f8334e3fd024b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:58', '2015-08-31 18:04:58', 0, 170, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833785820446', '涞源县', 'pub', '130630', 'cskefu', NULL, '297e1e874f83129d014f8334e3fd024b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:58', '2015-08-31 18:04:58', 0, 171, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833785950447', '望都县', 'pub', '130631', 'cskefu', NULL, '297e1e874f83129d014f8334e3fd024b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:58', '2015-08-31 18:04:58', 0, 172, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833785af0448', '安新县', 'pub', '130632', 'cskefu', NULL, '297e1e874f83129d014f8334e3fd024b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:58', '2015-08-31 18:04:58', 0, 173, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833786d00449', '易　县', 'pub', '130633', 'cskefu', NULL, '297e1e874f83129d014f8334e3fd024b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:58', '2015-08-31 18:04:58', 0, 174, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833786e1044a', '曲阳县', 'pub', '130634', 'cskefu', NULL, '297e1e874f83129d014f8334e3fd024b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:58', '2015-08-31 18:04:58', 0, 175, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833787a8044b', '蠡　县', 'pub', '130635', 'cskefu', NULL, '297e1e874f83129d014f8334e3fd024b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:58', '2015-08-31 18:04:58', 0, 176, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833787bb044c', '顺平县', 'pub', '130636', 'cskefu', NULL, '297e1e874f83129d014f8334e3fd024b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:58', '2015-08-31 18:04:58', 0, 177, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833787ce044d', '博野县', 'pub', '130637', 'cskefu', NULL, '297e1e874f83129d014f8334e3fd024b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:58', '2015-08-31 18:04:58', 0, 178, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833787df044e', '雄　县', 'pub', '130638', 'cskefu', NULL, '297e1e874f83129d014f8334e3fd024b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:58', '2015-08-31 18:04:58', 0, 179, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833787f4044f', '涿州市', 'pub', '130681', 'cskefu', NULL, '297e1e874f83129d014f8334e3fd024b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:58', '2015-08-31 18:04:58', 0, 180, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833788030450', '定州市', 'pub', '130682', 'cskefu', NULL, '297e1e874f83129d014f8334e3fd024b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:58', '2015-08-31 18:04:58', 0, 181, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833788130451', '安国市', 'pub', '130683', 'cskefu', NULL, '297e1e874f83129d014f8334e3fd024b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:58', '2015-08-31 18:04:58', 0, 182, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833788220452', '高碑店市', 'pub', '130684', 'cskefu', NULL, '297e1e874f83129d014f8334e3fd024b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:58', '2015-08-31 18:04:58', 0, 183, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337884d0453', '市辖区', 'pub', '130701', 'cskefu', NULL, '297e1e874f83129d014f8334e409024c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:58', '2015-08-31 18:04:58', 0, 184, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337885e0454', '桥东区', 'pub', '130702', 'cskefu', NULL, '297e1e874f83129d014f8334e409024c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:58', '2015-08-31 18:04:58', 0, 185, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337886d0455', '桥西区', 'pub', '130703', 'cskefu', NULL, '297e1e874f83129d014f8334e409024c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:58', '2015-08-31 18:04:58', 0, 186, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833788820456', '宣化区', 'pub', '130705', 'cskefu', NULL, '297e1e874f83129d014f8334e409024c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:58', '2015-08-31 18:04:58', 0, 187, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833788980457', '下花园区', 'pub', '130706', 'cskefu', NULL, '297e1e874f83129d014f8334e409024c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:58', '2015-08-31 18:04:58', 0, 188, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833788a70458', '宣化县', 'pub', '130721', 'cskefu', NULL, '297e1e874f83129d014f8334e409024c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:58', '2015-08-31 18:04:58', 0, 189, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833788ba0459', '张北县', 'pub', '130722', 'cskefu', NULL, '297e1e874f83129d014f8334e409024c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:58', '2015-08-31 18:04:58', 0, 190, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833788cc045a', '康保县', 'pub', '130723', 'cskefu', NULL, '297e1e874f83129d014f8334e409024c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:58', '2015-08-31 18:04:58', 0, 191, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833788da045b', '沽源县', 'pub', '130724', 'cskefu', NULL, '297e1e874f83129d014f8334e409024c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:58', '2015-08-31 18:04:58', 0, 192, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833788ef045c', '尚义县', 'pub', '130725', 'cskefu', NULL, '297e1e874f83129d014f8334e409024c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:58', '2015-08-31 18:04:58', 0, 193, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833788ff045d', '蔚　县', 'pub', '130726', 'cskefu', NULL, '297e1e874f83129d014f8334e409024c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', 0, 194, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378913045e', '阳原县', 'pub', '130727', 'cskefu', NULL, '297e1e874f83129d014f8334e409024c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', 0, 195, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378928045f', '怀安县', 'pub', '130728', 'cskefu', NULL, '297e1e874f83129d014f8334e409024c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', 0, 196, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833789360460', '万全县', 'pub', '130729', 'cskefu', NULL, '297e1e874f83129d014f8334e409024c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', 0, 197, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337894d0461', '怀来县', 'pub', '130730', 'cskefu', NULL, '297e1e874f83129d014f8334e409024c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', 0, 198, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337895e0462', '涿鹿县', 'pub', '130731', 'cskefu', NULL, '297e1e874f83129d014f8334e409024c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', 0, 199, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337896d0463', '赤城县', 'pub', '130732', 'cskefu', NULL, '297e1e874f83129d014f8334e409024c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', 0, 200, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337897e0464', '崇礼县', 'pub', '130733', 'cskefu', NULL, '297e1e874f83129d014f8334e409024c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', 0, 201, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833789ab0465', '市辖区', 'pub', '130801', 'cskefu', NULL, '297e1e874f83129d014f8334e418024d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', 0, 202, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833789ba0466', '双桥区', 'pub', '130802', 'cskefu', NULL, '297e1e874f83129d014f8334e418024d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', 0, 203, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833789c90467', '双滦区', 'pub', '130803', 'cskefu', NULL, '297e1e874f83129d014f8334e418024d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', 0, 204, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833789d90468', '鹰手营子矿区', 'pub', '130804', 'cskefu', NULL, '297e1e874f83129d014f8334e418024d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', 0, 205, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833789ec0469', '承德县', 'pub', '130821', 'cskefu', NULL, '297e1e874f83129d014f8334e418024d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', 0, 206, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378a07046a', '兴隆县', 'pub', '130822', 'cskefu', NULL, '297e1e874f83129d014f8334e418024d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', 0, 207, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378a1a046b', '平泉县', 'pub', '130823', 'cskefu', NULL, '297e1e874f83129d014f8334e418024d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', 0, 208, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378a2e046c', '滦平县', 'pub', '130824', 'cskefu', NULL, '297e1e874f83129d014f8334e418024d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', 0, 209, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378a3f046d', '隆化县', 'pub', '130825', 'cskefu', NULL, '297e1e874f83129d014f8334e418024d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', 0, 210, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378a51046e', '丰宁满族自治县', 'pub', '130826', 'cskefu', NULL, '297e1e874f83129d014f8334e418024d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', 0, 211, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378a72046f', '宽城满族自治县', 'pub', '130827', 'cskefu', NULL, '297e1e874f83129d014f8334e418024d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', 0, 212, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378a860470', '围场满族蒙古族自治县', 'pub', '130828', 'cskefu', NULL, '297e1e874f83129d014f8334e418024d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', 0, 213, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378aaf0471', '市辖区', 'pub', '130901', 'cskefu', NULL, '297e1e874f83129d014f8334e424024e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', 0, 214, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378abf0472', '新华区', 'pub', '130902', 'cskefu', NULL, '297e1e874f83129d014f8334e424024e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', 0, 215, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378ad10473', '运河区', 'pub', '130903', 'cskefu', NULL, '297e1e874f83129d014f8334e424024e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', 0, 216, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378ae60474', '沧　县', 'pub', '130921', 'cskefu', NULL, '297e1e874f83129d014f8334e424024e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', 0, 217, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378af70475', '青　县', 'pub', '130922', 'cskefu', NULL, '297e1e874f83129d014f8334e424024e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', 0, 218, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378b070476', '东光县', 'pub', '130923', 'cskefu', NULL, '297e1e874f83129d014f8334e424024e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', 0, 219, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378b190477', '海兴县', 'pub', '130924', 'cskefu', NULL, '297e1e874f83129d014f8334e424024e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', 0, 220, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378b2a0478', '盐山县', 'pub', '130925', 'cskefu', NULL, '297e1e874f83129d014f8334e424024e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', 0, 221, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378b3c0479', '肃宁县', 'pub', '130926', 'cskefu', NULL, '297e1e874f83129d014f8334e424024e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', 0, 222, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378b4d047a', '南皮县', 'pub', '130927', 'cskefu', NULL, '297e1e874f83129d014f8334e424024e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', 0, 223, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378b5c047b', '吴桥县', 'pub', '130928', 'cskefu', NULL, '297e1e874f83129d014f8334e424024e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', 0, 224, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378b6a047c', '献　县', 'pub', '130929', 'cskefu', NULL, '297e1e874f83129d014f8334e424024e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', 0, 225, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378b7a047d', '孟村回族自治县', 'pub', '130930', 'cskefu', NULL, '297e1e874f83129d014f8334e424024e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', 0, 226, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378b96047e', '泊头市', 'pub', '130981', 'cskefu', NULL, '297e1e874f83129d014f8334e424024e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', 0, 227, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378bab047f', '任丘市', 'pub', '130982', 'cskefu', NULL, '297e1e874f83129d014f8334e424024e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', 0, 228, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378bc00480', '黄骅市', 'pub', '130983', 'cskefu', NULL, '297e1e874f83129d014f8334e424024e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', 0, 229, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378bcf0481', '河间市', 'pub', '130984', 'cskefu', NULL, '297e1e874f83129d014f8334e424024e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', 0, 230, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378bfe0482', '市辖区', 'pub', '131001', 'cskefu', NULL, '297e1e874f83129d014f8334e430024f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', 0, 231, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378c0f0483', '安次区', 'pub', '131002', 'cskefu', NULL, '297e1e874f83129d014f8334e430024f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', 0, 232, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378c230484', '广阳区', 'pub', '131003', 'cskefu', NULL, '297e1e874f83129d014f8334e430024f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', 0, 233, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378c3a0485', '固安县', 'pub', '131022', 'cskefu', NULL, '297e1e874f83129d014f8334e430024f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', 0, 234, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378c4c0486', '永清县', 'pub', '131023', 'cskefu', NULL, '297e1e874f83129d014f8334e430024f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', 0, 235, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378c5b0487', '香河县', 'pub', '131024', 'cskefu', NULL, '297e1e874f83129d014f8334e430024f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', 0, 236, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378c6b0488', '大城县', 'pub', '131025', 'cskefu', NULL, '297e1e874f83129d014f8334e430024f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', 0, 237, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378c800489', '文安县', 'pub', '131026', 'cskefu', NULL, '297e1e874f83129d014f8334e430024f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', 0, 238, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378c99048a', '大厂回族自治县', 'pub', '131028', 'cskefu', NULL, '297e1e874f83129d014f8334e430024f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', 0, 239, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378ca9048b', '霸州市', 'pub', '131081', 'cskefu', NULL, '297e1e874f83129d014f8334e430024f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', 0, 240, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378cbc048c', '三河市', 'pub', '131082', 'cskefu', NULL, '297e1e874f83129d014f8334e430024f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:04:59', '2015-08-31 18:04:59', 0, 241, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378ce8048d', '市辖区', 'pub', '131101', 'cskefu', NULL, '297e1e874f83129d014f8334e43e0250', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', 0, 242, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378cf7048e', '桃城区', 'pub', '131102', 'cskefu', NULL, '297e1e874f83129d014f8334e43e0250', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', 0, 243, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378d06048f', '枣强县', 'pub', '131121', 'cskefu', NULL, '297e1e874f83129d014f8334e43e0250', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', 0, 244, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378d190490', '武邑县', 'pub', '131122', 'cskefu', NULL, '297e1e874f83129d014f8334e43e0250', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', 0, 245, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378d2d0491', '武强县', 'pub', '131123', 'cskefu', NULL, '297e1e874f83129d014f8334e43e0250', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', 0, 246, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378d440492', '饶阳县', 'pub', '131124', 'cskefu', NULL, '297e1e874f83129d014f8334e43e0250', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', 0, 247, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378d520493', '安平县', 'pub', '131125', 'cskefu', NULL, '297e1e874f83129d014f8334e43e0250', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', 0, 248, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378d650494', '故城县', 'pub', '131126', 'cskefu', NULL, '297e1e874f83129d014f8334e43e0250', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', 0, 249, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378d770495', '景　县', 'pub', '131127', 'cskefu', NULL, '297e1e874f83129d014f8334e43e0250', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', 0, 250, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378d870496', '阜城县', 'pub', '131128', 'cskefu', NULL, '297e1e874f83129d014f8334e43e0250', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', 0, 251, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378d960497', '冀州市', 'pub', '131181', 'cskefu', NULL, '297e1e874f83129d014f8334e43e0250', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', 0, 252, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378dab0498', '深州市', 'pub', '131182', 'cskefu', NULL, '297e1e874f83129d014f8334e43e0250', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', 0, 253, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378de00499', '市辖区', 'pub', '140101', 'cskefu', NULL, '297e1e874f83129d014f8334e6310251', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', 0, 254, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378def049a', '小店区', 'pub', '140105', 'cskefu', NULL, '297e1e874f83129d014f8334e6310251', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', 0, 255, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378e01049b', '迎泽区', 'pub', '140106', 'cskefu', NULL, '297e1e874f83129d014f8334e6310251', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', 0, 256, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378e12049c', '杏花岭区', 'pub', '140107', 'cskefu', NULL, '297e1e874f83129d014f8334e6310251', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', 0, 257, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378e27049d', '尖草坪区', 'pub', '140108', 'cskefu', NULL, '297e1e874f83129d014f8334e6310251', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', 0, 258, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378e38049e', '万柏林区', 'pub', '140109', 'cskefu', NULL, '297e1e874f83129d014f8334e6310251', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', 0, 259, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378e46049f', '晋源区', 'pub', '140110', 'cskefu', NULL, '297e1e874f83129d014f8334e6310251', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', 0, 260, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378e5f04a0', '清徐县', 'pub', '140121', 'cskefu', NULL, '297e1e874f83129d014f8334e6310251', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', 0, 261, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378e6f04a1', '阳曲县', 'pub', '140122', 'cskefu', NULL, '297e1e874f83129d014f8334e6310251', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', 0, 262, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378e8104a2', '娄烦县', 'pub', '140123', 'cskefu', NULL, '297e1e874f83129d014f8334e6310251', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', 0, 263, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378e9504a3', '古交市', 'pub', '140181', 'cskefu', NULL, '297e1e874f83129d014f8334e6310251', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', 0, 264, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378ebe04a4', '市辖区', 'pub', '140201', 'cskefu', NULL, '297e1e874f83129d014f8334e6420252', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', 0, 265, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378ed204a5', '城　区', 'pub', '140202', 'cskefu', NULL, '297e1e874f83129d014f8334e6420252', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', 0, 266, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378ee704a6', '矿　区', 'pub', '140203', 'cskefu', NULL, '297e1e874f83129d014f8334e6420252', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', 0, 267, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378efa04a7', '南郊区', 'pub', '140211', 'cskefu', NULL, '297e1e874f83129d014f8334e6420252', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', 0, 268, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378f0a04a8', '新荣区', 'pub', '140212', 'cskefu', NULL, '297e1e874f83129d014f8334e6420252', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', 0, 269, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378f1b04a9', '阳高县', 'pub', '140221', 'cskefu', NULL, '297e1e874f83129d014f8334e6420252', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', 0, 270, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378f3304aa', '天镇县', 'pub', '140222', 'cskefu', NULL, '297e1e874f83129d014f8334e6420252', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', 0, 271, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378f4804ab', '广灵县', 'pub', '140223', 'cskefu', NULL, '297e1e874f83129d014f8334e6420252', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', 0, 272, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378f5b04ac', '灵丘县', 'pub', '140224', 'cskefu', NULL, '297e1e874f83129d014f8334e6420252', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', 0, 273, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378f6f04ad', '浑源县', 'pub', '140225', 'cskefu', NULL, '297e1e874f83129d014f8334e6420252', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', 0, 274, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378f8d04ae', '左云县', 'pub', '140226', 'cskefu', NULL, '297e1e874f83129d014f8334e6420252', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', 0, 275, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378fa304af', '大同县', 'pub', '140227', 'cskefu', NULL, '297e1e874f83129d014f8334e6420252', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', 0, 276, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83378ff204b0', '市辖区', 'pub', '140301', 'cskefu', NULL, '297e1e874f83129d014f8334e64e0253', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', 0, 277, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337900504b1', '城　区', 'pub', '140302', 'cskefu', NULL, '297e1e874f83129d014f8334e64e0253', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', 0, 278, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337901a04b2', '矿　区', 'pub', '140303', 'cskefu', NULL, '297e1e874f83129d014f8334e64e0253', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', 0, 279, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337903204b3', '郊　区', 'pub', '140311', 'cskefu', NULL, '297e1e874f83129d014f8334e64e0253', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', 0, 280, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337904d04b4', '平定县', 'pub', '140321', 'cskefu', NULL, '297e1e874f83129d014f8334e64e0253', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', 0, 281, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337906504b5', '盂　县', 'pub', '140322', 'cskefu', NULL, '297e1e874f83129d014f8334e64e0253', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', 0, 282, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833790a204b6', '市辖区', 'pub', '140401', 'cskefu', NULL, '297e1e874f83129d014f8334e65a0254', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', 0, 283, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833790b304b7', '城　区', 'pub', '140402', 'cskefu', NULL, '297e1e874f83129d014f8334e65a0254', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', 0, 284, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833790c404b8', '郊　区', 'pub', '140411', 'cskefu', NULL, '297e1e874f83129d014f8334e65a0254', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:00', '2015-08-31 18:05:00', 0, 285, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833790d504b9', '长治县', 'pub', '140421', 'cskefu', NULL, '297e1e874f83129d014f8334e65a0254', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:01', '2015-08-31 18:05:01', 0, 286, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833790ea04ba', '襄垣县', 'pub', '140423', 'cskefu', NULL, '297e1e874f83129d014f8334e65a0254', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:01', '2015-08-31 18:05:01', 0, 287, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337922a04bb', '屯留县', 'pub', '140424', 'cskefu', NULL, '297e1e874f83129d014f8334e65a0254', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:01', '2015-08-31 18:05:01', 0, 288, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337923f04bc', '平顺县', 'pub', '140425', 'cskefu', NULL, '297e1e874f83129d014f8334e65a0254', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:01', '2015-08-31 18:05:01', 0, 289, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337925704bd', '黎城县', 'pub', '140426', 'cskefu', NULL, '297e1e874f83129d014f8334e65a0254', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:01', '2015-08-31 18:05:01', 0, 290, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337926e04be', '壶关县', 'pub', '140427', 'cskefu', NULL, '297e1e874f83129d014f8334e65a0254', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:01', '2015-08-31 18:05:01', 0, 291, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337928104bf', '长子县', 'pub', '140428', 'cskefu', NULL, '297e1e874f83129d014f8334e65a0254', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:01', '2015-08-31 18:05:01', 0, 292, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337929404c0', '武乡县', 'pub', '140429', 'cskefu', NULL, '297e1e874f83129d014f8334e65a0254', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:01', '2015-08-31 18:05:01', 0, 293, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833792a404c1', '沁　县', 'pub', '140430', 'cskefu', NULL, '297e1e874f83129d014f8334e65a0254', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:01', '2015-08-31 18:05:01', 0, 294, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833792b304c2', '沁源县', 'pub', '140431', 'cskefu', NULL, '297e1e874f83129d014f8334e65a0254', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:01', '2015-08-31 18:05:01', 0, 295, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833792c804c3', '潞城市', 'pub', '140481', 'cskefu', NULL, '297e1e874f83129d014f8334e65a0254', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:01', '2015-08-31 18:05:01', 0, 296, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833792fe04c4', '市辖区', 'pub', '140501', 'cskefu', NULL, '297e1e874f83129d014f8334e6650255', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:01', '2015-08-31 18:05:01', 0, 297, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337930f04c5', '城　区', 'pub', '140502', 'cskefu', NULL, '297e1e874f83129d014f8334e6650255', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:01', '2015-08-31 18:05:01', 0, 298, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337932404c6', '沁水县', 'pub', '140521', 'cskefu', NULL, '297e1e874f83129d014f8334e6650255', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:01', '2015-08-31 18:05:01', 0, 299, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337933604c7', '阳城县', 'pub', '140522', 'cskefu', NULL, '297e1e874f83129d014f8334e6650255', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:01', '2015-08-31 18:05:01', 0, 300, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337934d04c8', '陵川县', 'pub', '140524', 'cskefu', NULL, '297e1e874f83129d014f8334e6650255', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:01', '2015-08-31 18:05:01', 0, 301, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337935e04c9', '泽州县', 'pub', '140525', 'cskefu', NULL, '297e1e874f83129d014f8334e6650255', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:01', '2015-08-31 18:05:01', 0, 302, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337936d04ca', '高平市', 'pub', '140581', 'cskefu', NULL, '297e1e874f83129d014f8334e6650255', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:01', '2015-08-31 18:05:01', 0, 303, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337939804cb', '市辖区', 'pub', '140601', 'cskefu', NULL, '297e1e874f83129d014f8334e6730256', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:01', '2015-08-31 18:05:01', 0, 304, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833794d304cd', '朔城区', 'pub', '140602', 'cskefu', NULL, '297e1e874f83129d014f8334e6730256', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', 0, 305, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833794e604ce', '平鲁区', 'pub', '140603', 'cskefu', NULL, '297e1e874f83129d014f8334e6730256', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', 0, 306, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833794f704cf', '山阴县', 'pub', '140621', 'cskefu', NULL, '297e1e874f83129d014f8334e6730256', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', 0, 307, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337951004d0', '应　县', 'pub', '140622', 'cskefu', NULL, '297e1e874f83129d014f8334e6730256', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', 0, 308, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337952304d1', '右玉县', 'pub', '140623', 'cskefu', NULL, '297e1e874f83129d014f8334e6730256', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', 0, 309, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337953604d2', '怀仁县', 'pub', '140624', 'cskefu', NULL, '297e1e874f83129d014f8334e6730256', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', 0, 310, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337956804d3', '市辖区', 'pub', '140701', 'cskefu', NULL, '297e1e874f83129d014f8334e67f0257', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', 0, 311, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337957804d4', '榆次区', 'pub', '140702', 'cskefu', NULL, '297e1e874f83129d014f8334e67f0257', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', 0, 312, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337958904d5', '榆社县', 'pub', '140721', 'cskefu', NULL, '297e1e874f83129d014f8334e67f0257', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', 0, 313, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833795a204d6', '左权县', 'pub', '140722', 'cskefu', NULL, '297e1e874f83129d014f8334e67f0257', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', 0, 314, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833795b904d7', '和顺县', 'pub', '140723', 'cskefu', NULL, '297e1e874f83129d014f8334e67f0257', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', 0, 315, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833796fd04d8', '昔阳县', 'pub', '140724', 'cskefu', NULL, '297e1e874f83129d014f8334e67f0257', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', 0, 316, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337970e04d9', '寿阳县', 'pub', '140725', 'cskefu', NULL, '297e1e874f83129d014f8334e67f0257', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', 0, 317, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337971f04da', '太谷县', 'pub', '140726', 'cskefu', NULL, '297e1e874f83129d014f8334e67f0257', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', 0, 318, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337973104db', '祁　县', 'pub', '140727', 'cskefu', NULL, '297e1e874f83129d014f8334e67f0257', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', 0, 319, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337973f04dc', '平遥县', 'pub', '140728', 'cskefu', NULL, '297e1e874f83129d014f8334e67f0257', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', 0, 320, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337974f04dd', '灵石县', 'pub', '140729', 'cskefu', NULL, '297e1e874f83129d014f8334e67f0257', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', 0, 321, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337975e04de', '介休市', 'pub', '140781', 'cskefu', NULL, '297e1e874f83129d014f8334e67f0257', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', 0, 322, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337978c04df', '市辖区', 'pub', '140801', 'cskefu', NULL, '297e1e874f83129d014f8334e68e0258', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', 0, 323, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833797a004e0', '盐湖区', 'pub', '140802', 'cskefu', NULL, '297e1e874f83129d014f8334e68e0258', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', 0, 324, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833797c604e1', '临猗县', 'pub', '140821', 'cskefu', NULL, '297e1e874f83129d014f8334e68e0258', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', 0, 325, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833797e504e2', '万荣县', 'pub', '140822', 'cskefu', NULL, '297e1e874f83129d014f8334e68e0258', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', 0, 326, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833797fa04e3', '闻喜县', 'pub', '140823', 'cskefu', NULL, '297e1e874f83129d014f8334e68e0258', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', 0, 327, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337980a04e4', '稷山县', 'pub', '140824', 'cskefu', NULL, '297e1e874f83129d014f8334e68e0258', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', 0, 328, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337981f04e5', '新绛县', 'pub', '140825', 'cskefu', NULL, '297e1e874f83129d014f8334e68e0258', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', 0, 329, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337982f04e6', '绛　县', 'pub', '140826', 'cskefu', NULL, '297e1e874f83129d014f8334e68e0258', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', 0, 330, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337984104e7', '垣曲县', 'pub', '140827', 'cskefu', NULL, '297e1e874f83129d014f8334e68e0258', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', 0, 331, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337985304e8', '夏　县', 'pub', '140828', 'cskefu', NULL, '297e1e874f83129d014f8334e68e0258', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', 0, 332, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337986304e9', '平陆县', 'pub', '140829', 'cskefu', NULL, '297e1e874f83129d014f8334e68e0258', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', 0, 333, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337987a04ea', '芮城县', 'pub', '140830', 'cskefu', NULL, '297e1e874f83129d014f8334e68e0258', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', 0, 334, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337988a04eb', '永济市', 'pub', '140881', 'cskefu', NULL, '297e1e874f83129d014f8334e68e0258', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:02', '2015-08-31 18:05:02', 0, 335, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337989904ec', '河津市', 'pub', '140882', 'cskefu', NULL, '297e1e874f83129d014f8334e68e0258', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:03', '2015-08-31 18:05:03', 0, 336, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833799f404ed', '市辖区', 'pub', '140901', 'cskefu', NULL, '297e1e874f83129d014f8334e69e0259', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:03', '2015-08-31 18:05:03', 0, 337, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83379a0204ee', '忻府区', 'pub', '140902', 'cskefu', NULL, '297e1e874f83129d014f8334e69e0259', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:03', '2015-08-31 18:05:03', 0, 338, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83379a1304ef', '定襄县', 'pub', '140921', 'cskefu', NULL, '297e1e874f83129d014f8334e69e0259', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:03', '2015-08-31 18:05:03', 0, 339, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83379a2504f0', '五台县', 'pub', '140922', 'cskefu', NULL, '297e1e874f83129d014f8334e69e0259', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:03', '2015-08-31 18:05:03', 0, 340, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83379a3504f1', '代　县', 'pub', '140923', 'cskefu', NULL, '297e1e874f83129d014f8334e69e0259', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:03', '2015-08-31 18:05:03', 0, 341, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83379a4a04f2', '繁峙县', 'pub', '140924', 'cskefu', NULL, '297e1e874f83129d014f8334e69e0259', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:03', '2015-08-31 18:05:03', 0, 342, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83379a5a04f3', '宁武县', 'pub', '140925', 'cskefu', NULL, '297e1e874f83129d014f8334e69e0259', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:03', '2015-08-31 18:05:03', 0, 343, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83379a6904f4', '静乐县', 'pub', '140926', 'cskefu', NULL, '297e1e874f83129d014f8334e69e0259', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:03', '2015-08-31 18:05:03', 0, 344, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83379a8204f5', '神池县', 'pub', '140927', 'cskefu', NULL, '297e1e874f83129d014f8334e69e0259', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:03', '2015-08-31 18:05:03', 0, 345, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83379a9704f6', '五寨县', 'pub', '140928', 'cskefu', NULL, '297e1e874f83129d014f8334e69e0259', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:03', '2015-08-31 18:05:03', 0, 346, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83379aa604f7', '岢岚县', 'pub', '140929', 'cskefu', NULL, '297e1e874f83129d014f8334e69e0259', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:03', '2015-08-31 18:05:03', 0, 347, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83379abd04f8', '河曲县', 'pub', '140930', 'cskefu', NULL, '297e1e874f83129d014f8334e69e0259', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:03', '2015-08-31 18:05:03', 0, 348, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83379acb04f9', '保德县', 'pub', '140931', 'cskefu', NULL, '297e1e874f83129d014f8334e69e0259', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:03', '2015-08-31 18:05:03', 0, 349, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83379c0604fa', '偏关县', 'pub', '140932', 'cskefu', NULL, '297e1e874f83129d014f8334e69e0259', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:03', '2015-08-31 18:05:03', 0, 350, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83379c1d04fb', '原平市', 'pub', '140981', 'cskefu', NULL, '297e1e874f83129d014f8334e69e0259', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:03', '2015-08-31 18:05:03', 0, 351, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83379c4904fc', '市辖区', 'pub', '141001', 'cskefu', NULL, '297e1e874f83129d014f8334e6ae025a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:03', '2015-08-31 18:05:03', 0, 352, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83379c5704fd', '尧都区', 'pub', '141002', 'cskefu', NULL, '297e1e874f83129d014f8334e6ae025a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:03', '2015-08-31 18:05:03', 0, 353, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83379c6804fe', '曲沃县', 'pub', '141021', 'cskefu', NULL, '297e1e874f83129d014f8334e6ae025a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:03', '2015-08-31 18:05:03', 0, 354, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83379c7704ff', '翼城县', 'pub', '141022', 'cskefu', NULL, '297e1e874f83129d014f8334e6ae025a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:03', '2015-08-31 18:05:03', 0, 355, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83379c850500', '襄汾县', 'pub', '141023', 'cskefu', NULL, '297e1e874f83129d014f8334e6ae025a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:04', '2015-08-31 18:05:04', 0, 356, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83379c930501', '洪洞县', 'pub', '141024', 'cskefu', NULL, '297e1e874f83129d014f8334e6ae025a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:04', '2015-08-31 18:05:04', 0, 357, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83379ca20502', '古　县', 'pub', '141025', 'cskefu', NULL, '297e1e874f83129d014f8334e6ae025a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:04', '2015-08-31 18:05:04', 0, 358, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83379cb00503', '安泽县', 'pub', '141026', 'cskefu', NULL, '297e1e874f83129d014f8334e6ae025a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:04', '2015-08-31 18:05:04', 0, 359, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83379cbf0504', '浮山县', 'pub', '141027', 'cskefu', NULL, '297e1e874f83129d014f8334e6ae025a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:04', '2015-08-31 18:05:04', 0, 360, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83379cce0505', '吉　县', 'pub', '141028', 'cskefu', NULL, '297e1e874f83129d014f8334e6ae025a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:04', '2015-08-31 18:05:04', 0, 361, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83379cdd0506', '乡宁县', 'pub', '141029', 'cskefu', NULL, '297e1e874f83129d014f8334e6ae025a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:04', '2015-08-31 18:05:04', 0, 362, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83379cee0507', '大宁县', 'pub', '141030', 'cskefu', NULL, '297e1e874f83129d014f8334e6ae025a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:04', '2015-08-31 18:05:04', 0, 363, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83379cff0508', '隰　县', 'pub', '141031', 'cskefu', NULL, '297e1e874f83129d014f8334e6ae025a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:04', '2015-08-31 18:05:04', 0, 364, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83379d120509', '永和县', 'pub', '141032', 'cskefu', NULL, '297e1e874f83129d014f8334e6ae025a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:04', '2015-08-31 18:05:04', 0, 365, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83379e4d050a', '蒲　县', 'pub', '141033', 'cskefu', NULL, '297e1e874f83129d014f8334e6ae025a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:04', '2015-08-31 18:05:04', 0, 366, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83379e5b050b', '汾西县', 'pub', '141034', 'cskefu', NULL, '297e1e874f83129d014f8334e6ae025a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:04', '2015-08-31 18:05:04', 0, 367, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83379e68050c', '侯马市', 'pub', '141081', 'cskefu', NULL, '297e1e874f83129d014f8334e6ae025a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:04', '2015-08-31 18:05:04', 0, 368, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83379e77050d', '霍州市', 'pub', '141082', 'cskefu', NULL, '297e1e874f83129d014f8334e6ae025a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:04', '2015-08-31 18:05:04', 0, 369, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83379ea4050e', '市辖区', 'pub', '141101', 'cskefu', NULL, '297e1e874f83129d014f8334e6bb025b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:04', '2015-08-31 18:05:04', 0, 370, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83379eb2050f', '离石区', 'pub', '141102', 'cskefu', NULL, '297e1e874f83129d014f8334e6bb025b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:04', '2015-08-31 18:05:04', 0, 371, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83379ec10510', '文水县', 'pub', '141121', 'cskefu', NULL, '297e1e874f83129d014f8334e6bb025b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:04', '2015-08-31 18:05:04', 0, 372, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83379ed10511', '交城县', 'pub', '141122', 'cskefu', NULL, '297e1e874f83129d014f8334e6bb025b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:04', '2015-08-31 18:05:04', 0, 373, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83379ee00512', '兴　县', 'pub', '141123', 'cskefu', NULL, '297e1e874f83129d014f8334e6bb025b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:04', '2015-08-31 18:05:04', 0, 374, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83379ef20513', '临　县', 'pub', '141124', 'cskefu', NULL, '297e1e874f83129d014f8334e6bb025b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:04', '2015-08-31 18:05:04', 0, 375, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83379f030514', '柳林县', 'pub', '141125', 'cskefu', NULL, '297e1e874f83129d014f8334e6bb025b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:04', '2015-08-31 18:05:04', 0, 376, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83379f120515', '石楼县', 'pub', '141126', 'cskefu', NULL, '297e1e874f83129d014f8334e6bb025b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:04', '2015-08-31 18:05:04', 0, 377, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83379f210516', '岚　县', 'pub', '141127', 'cskefu', NULL, '297e1e874f83129d014f8334e6bb025b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:04', '2015-08-31 18:05:04', 0, 378, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83379f300517', '方山县', 'pub', '141128', 'cskefu', NULL, '297e1e874f83129d014f8334e6bb025b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:04', '2015-08-31 18:05:04', 0, 379, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83379f420518', '中阳县', 'pub', '141129', 'cskefu', NULL, '297e1e874f83129d014f8334e6bb025b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:04', '2015-08-31 18:05:04', 0, 380, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83379f4f0519', '交口县', 'pub', '141130', 'cskefu', NULL, '297e1e874f83129d014f8334e6bb025b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:04', '2015-08-31 18:05:04', 0, 381, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a08c051a', '孝义市', 'pub', '141181', 'cskefu', NULL, '297e1e874f83129d014f8334e6bb025b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:05', '2015-08-31 18:05:05', 0, 382, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a09a051b', '汾阳市', 'pub', '141182', 'cskefu', NULL, '297e1e874f83129d014f8334e6bb025b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:05', '2015-08-31 18:05:05', 0, 383, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a0c2051c', '市辖区', 'pub', '150101', 'cskefu', NULL, '297e1e874f83129d014f8334e6e0025c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:05', '2015-08-31 18:05:05', 0, 384, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a0d1051d', '新城区', 'pub', '150102', 'cskefu', NULL, '297e1e874f83129d014f8334e6e0025c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:05', '2015-08-31 18:05:05', 0, 385, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a0df051e', '回民区', 'pub', '150103', 'cskefu', NULL, '297e1e874f83129d014f8334e6e0025c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:05', '2015-08-31 18:05:05', 0, 386, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a0ee051f', '玉泉区', 'pub', '150104', 'cskefu', NULL, '297e1e874f83129d014f8334e6e0025c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:05', '2015-08-31 18:05:05', 0, 387, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a0fe0520', '赛罕区', 'pub', '150105', 'cskefu', NULL, '297e1e874f83129d014f8334e6e0025c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:05', '2015-08-31 18:05:05', 0, 388, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a10d0521', '土默特左旗', 'pub', '150121', 'cskefu', NULL, '297e1e874f83129d014f8334e6e0025c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:05', '2015-08-31 18:05:05', 0, 389, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a1200522', '托克托县', 'pub', '150122', 'cskefu', NULL, '297e1e874f83129d014f8334e6e0025c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:05', '2015-08-31 18:05:05', 0, 390, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a12d0523', '和林格尔县', 'pub', '150123', 'cskefu', NULL, '297e1e874f83129d014f8334e6e0025c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:05', '2015-08-31 18:05:05', 0, 391, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a13b0524', '清水河县', 'pub', '150124', 'cskefu', NULL, '297e1e874f83129d014f8334e6e0025c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:05', '2015-08-31 18:05:05', 0, 392, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a14d0525', '武川县', 'pub', '150125', 'cskefu', NULL, '297e1e874f83129d014f8334e6e0025c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:05', '2015-08-31 18:05:05', 0, 393, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a2a30526', '市辖区', 'pub', '150201', 'cskefu', NULL, '297e1e874f83129d014f8334e6f5025d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:05', '2015-08-31 18:05:05', 0, 394, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a2b10527', '东河区', 'pub', '150202', 'cskefu', NULL, '297e1e874f83129d014f8334e6f5025d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:05', '2015-08-31 18:05:05', 0, 395, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a2be0528', '昆都仑区', 'pub', '150203', 'cskefu', NULL, '297e1e874f83129d014f8334e6f5025d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:05', '2015-08-31 18:05:05', 0, 396, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a2cc0529', '青山区', 'pub', '150204', 'cskefu', NULL, '297e1e874f83129d014f8334e6f5025d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:05', '2015-08-31 18:05:05', 0, 397, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a2da052a', '石拐区', 'pub', '150205', 'cskefu', NULL, '297e1e874f83129d014f8334e6f5025d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:05', '2015-08-31 18:05:05', 0, 398, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a2ea052b', '白云矿区', 'pub', '150206', 'cskefu', NULL, '297e1e874f83129d014f8334e6f5025d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:05', '2015-08-31 18:05:05', 0, 399, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a2fa052c', '九原区', 'pub', '150207', 'cskefu', NULL, '297e1e874f83129d014f8334e6f5025d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:05', '2015-08-31 18:05:05', 0, 400, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a308052d', '土默特右旗', 'pub', '150221', 'cskefu', NULL, '297e1e874f83129d014f8334e6f5025d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:05', '2015-08-31 18:05:05', 0, 401, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a315052e', '固阳县', 'pub', '150222', 'cskefu', NULL, '297e1e874f83129d014f8334e6f5025d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:05', '2015-08-31 18:05:05', 0, 402, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a324052f', '达尔罕茂明安联合旗', 'pub', '150223', 'cskefu', NULL, '297e1e874f83129d014f8334e6f5025d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:05', '2015-08-31 18:05:05', 0, 403, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a34e0530', '市辖区', 'pub', '150301', 'cskefu', NULL, '297e1e874f83129d014f8334e702025e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:05', '2015-08-31 18:05:05', 0, 404, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a35c0531', '海勃湾区', 'pub', '150302', 'cskefu', NULL, '297e1e874f83129d014f8334e702025e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:05', '2015-08-31 18:05:05', 0, 405, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a49a0532', '海南区', 'pub', '150303', 'cskefu', NULL, '297e1e874f83129d014f8334e702025e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:06', '2015-08-31 18:05:06', 0, 406, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a4a80533', '乌达区', 'pub', '150304', 'cskefu', NULL, '297e1e874f83129d014f8334e702025e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:06', '2015-08-31 18:05:06', 0, 407, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a4d20534', '市辖区', 'pub', '150401', 'cskefu', NULL, '297e1e874f83129d014f8334e70e025f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:06', '2015-08-31 18:05:06', 0, 408, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a4e20535', '红山区', 'pub', '150402', 'cskefu', NULL, '297e1e874f83129d014f8334e70e025f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:06', '2015-08-31 18:05:06', 0, 409, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a4f20536', '元宝山区', 'pub', '150403', 'cskefu', NULL, '297e1e874f83129d014f8334e70e025f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:06', '2015-08-31 18:05:06', 0, 410, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a5020537', '松山区', 'pub', '150404', 'cskefu', NULL, '297e1e874f83129d014f8334e70e025f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:06', '2015-08-31 18:05:06', 0, 411, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a5110538', '阿鲁科尔沁旗', 'pub', '150421', 'cskefu', NULL, '297e1e874f83129d014f8334e70e025f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:06', '2015-08-31 18:05:06', 0, 412, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a5200539', '巴林左旗', 'pub', '150422', 'cskefu', NULL, '297e1e874f83129d014f8334e70e025f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:06', '2015-08-31 18:05:06', 0, 413, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a530053a', '巴林右旗', 'pub', '150423', 'cskefu', NULL, '297e1e874f83129d014f8334e70e025f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:06', '2015-08-31 18:05:06', 0, 414, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a53e053b', '林西县', 'pub', '150424', 'cskefu', NULL, '297e1e874f83129d014f8334e70e025f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:06', '2015-08-31 18:05:06', 0, 415, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a54d053c', '克什克腾旗', 'pub', '150425', 'cskefu', NULL, '297e1e874f83129d014f8334e70e025f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:06', '2015-08-31 18:05:06', 0, 416, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a55c053d', '翁牛特旗', 'pub', '150426', 'cskefu', NULL, '297e1e874f83129d014f8334e70e025f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:06', '2015-08-31 18:05:06', 0, 417, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a56a053e', '喀喇沁旗', 'pub', '150428', 'cskefu', NULL, '297e1e874f83129d014f8334e70e025f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:06', '2015-08-31 18:05:06', 0, 418, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a57e053f', '宁城县', 'pub', '150429', 'cskefu', NULL, '297e1e874f83129d014f8334e70e025f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:06', '2015-08-31 18:05:06', 0, 419, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a58e0540', '敖汉旗', 'pub', '150430', 'cskefu', NULL, '297e1e874f83129d014f8334e70e025f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:06', '2015-08-31 18:05:06', 0, 420, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a6ed0541', '市辖区', 'pub', '150501', 'cskefu', NULL, '297e1e874f83129d014f8334e71a0260', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:06', '2015-08-31 18:05:06', 0, 421, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a7080542', '科尔沁区', 'pub', '150502', 'cskefu', NULL, '297e1e874f83129d014f8334e71a0260', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:06', '2015-08-31 18:05:06', 0, 422, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a71b0543', '科尔沁左翼中旗', 'pub', '150521', 'cskefu', NULL, '297e1e874f83129d014f8334e71a0260', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:06', '2015-08-31 18:05:06', 0, 423, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a72e0545', '科尔沁左翼后旗', 'pub', '150522', 'cskefu', NULL, '297e1e874f83129d014f8334e71a0260', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:06', '2015-08-31 18:05:06', 0, 424, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a7440546', '开鲁县', 'pub', '150523', 'cskefu', NULL, '297e1e874f83129d014f8334e71a0260', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:06', '2015-08-31 18:05:06', 0, 425, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a7530547', '库伦旗', 'pub', '150524', 'cskefu', NULL, '297e1e874f83129d014f8334e71a0260', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:06', '2015-08-31 18:05:06', 0, 426, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a7650548', '奈曼旗', 'pub', '150525', 'cskefu', NULL, '297e1e874f83129d014f8334e71a0260', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:06', '2015-08-31 18:05:06', 0, 427, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a7740549', '扎鲁特旗', 'pub', '150526', 'cskefu', NULL, '297e1e874f83129d014f8334e71a0260', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:06', '2015-08-31 18:05:06', 0, 428, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a784054a', '霍林郭勒市', 'pub', '150581', 'cskefu', NULL, '297e1e874f83129d014f8334e71a0260', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:06', '2015-08-31 18:05:06', 0, 429, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a7ad054b', '东胜区', 'pub', '150602', 'cskefu', NULL, '297e1e874f83129d014f8334e7270261', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:06', '2015-08-31 18:05:06', 0, 430, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a8e9054c', '达拉特旗', 'pub', '150621', 'cskefu', NULL, '297e1e874f83129d014f8334e7270261', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:07', '2015-08-31 18:05:07', 0, 431, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a8f9054d', '准格尔旗', 'pub', '150622', 'cskefu', NULL, '297e1e874f83129d014f8334e7270261', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:07', '2015-08-31 18:05:07', 0, 432, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a90a054e', '鄂托克前旗', 'pub', '150623', 'cskefu', NULL, '297e1e874f83129d014f8334e7270261', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:07', '2015-08-31 18:05:07', 0, 433, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a91a054f', '鄂托克旗', 'pub', '150624', 'cskefu', NULL, '297e1e874f83129d014f8334e7270261', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:07', '2015-08-31 18:05:07', 0, 434, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a92a0550', '杭锦旗', 'pub', '150625', 'cskefu', NULL, '297e1e874f83129d014f8334e7270261', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:07', '2015-08-31 18:05:07', 0, 435, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a93d0551', '乌审旗', 'pub', '150626', 'cskefu', NULL, '297e1e874f83129d014f8334e7270261', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:07', '2015-08-31 18:05:07', 0, 436, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a94e0552', '伊金霍洛旗', 'pub', '150627', 'cskefu', NULL, '297e1e874f83129d014f8334e7270261', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:07', '2015-08-31 18:05:07', 0, 437, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a9770553', '市辖区', 'pub', '150701', 'cskefu', NULL, '297e1e874f83129d014f8334e7360262', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:07', '2015-08-31 18:05:07', 0, 438, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a9860554', '海拉尔区', 'pub', '150702', 'cskefu', NULL, '297e1e874f83129d014f8334e7360262', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:07', '2015-08-31 18:05:07', 0, 439, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a99a0555', '阿荣旗', 'pub', '150721', 'cskefu', NULL, '297e1e874f83129d014f8334e7360262', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:07', '2015-08-31 18:05:07', 0, 440, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a9ad0556', '莫力达瓦达斡尔族自治旗', 'pub', '150722', 'cskefu', NULL, '297e1e874f83129d014f8334e7360262', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:07', '2015-08-31 18:05:07', 0, 441, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a9bc0557', '鄂伦春自治旗', 'pub', '150723', 'cskefu', NULL, '297e1e874f83129d014f8334e7360262', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:07', '2015-08-31 18:05:07', 0, 442, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a9c90558', '鄂温克族自治旗', 'pub', '150724', 'cskefu', NULL, '297e1e874f83129d014f8334e7360262', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:07', '2015-08-31 18:05:07', 0, 443, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a9da0559', '陈巴尔虎旗', 'pub', '150725', 'cskefu', NULL, '297e1e874f83129d014f8334e7360262', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:07', '2015-08-31 18:05:07', 0, 444, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337a9f8055a', '新巴尔虎左旗', 'pub', '150726', 'cskefu', NULL, '297e1e874f83129d014f8334e7360262', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:07', '2015-08-31 18:05:07', 0, 445, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337aa06055b', '新巴尔虎右旗', 'pub', '150727', 'cskefu', NULL, '297e1e874f83129d014f8334e7360262', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:07', '2015-08-31 18:05:07', 0, 446, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337ab42055c', '满洲里市', 'pub', '150781', 'cskefu', NULL, '297e1e874f83129d014f8334e7360262', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:07', '2015-08-31 18:05:07', 0, 447, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337ab52055d', '牙克石市', 'pub', '150782', 'cskefu', NULL, '297e1e874f83129d014f8334e7360262', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:07', '2015-08-31 18:05:07', 0, 448, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337ab61055e', '扎兰屯市', 'pub', '150783', 'cskefu', NULL, '297e1e874f83129d014f8334e7360262', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:07', '2015-08-31 18:05:07', 0, 449, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337ab72055f', '额尔古纳市', 'pub', '150784', 'cskefu', NULL, '297e1e874f83129d014f8334e7360262', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:07', '2015-08-31 18:05:07', 0, 450, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337ab820560', '根河市', 'pub', '150785', 'cskefu', NULL, '297e1e874f83129d014f8334e7360262', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:07', '2015-08-31 18:05:07', 0, 451, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337abab0561', '市辖区', 'pub', '150801', 'cskefu', NULL, '297e1e874f83129d014f8334e7430263', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:07', '2015-08-31 18:05:07', 0, 452, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337abba0562', '临河区', 'pub', '150802', 'cskefu', NULL, '297e1e874f83129d014f8334e7430263', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:07', '2015-08-31 18:05:07', 0, 453, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337abca0563', '五原县', 'pub', '150821', 'cskefu', NULL, '297e1e874f83129d014f8334e7430263', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:07', '2015-08-31 18:05:07', 0, 454, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337abdd0564', '磴口县', 'pub', '150822', 'cskefu', NULL, '297e1e874f83129d014f8334e7430263', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:07', '2015-08-31 18:05:07', 0, 455, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337abed0565', '乌拉特前旗', 'pub', '150823', 'cskefu', NULL, '297e1e874f83129d014f8334e7430263', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:07', '2015-08-31 18:05:07', 0, 456, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337abff0566', '乌拉特中旗', 'pub', '150824', 'cskefu', NULL, '297e1e874f83129d014f8334e7430263', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:07', '2015-08-31 18:05:07', 0, 457, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337ac110567', '乌拉特后旗', 'pub', '150825', 'cskefu', NULL, '297e1e874f83129d014f8334e7430263', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:07', '2015-08-31 18:05:07', 0, 458, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337ac1e0568', '杭锦后旗', 'pub', '150826', 'cskefu', NULL, '297e1e874f83129d014f8334e7430263', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:07', '2015-08-31 18:05:07', 0, 459, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337ac4e0569', '市辖区', 'pub', '150901', 'cskefu', NULL, '297e1e874f83129d014f8334e74e0264', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:08', '2015-08-31 18:05:08', 0, 460, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337ad8a056a', '集宁区', 'pub', '150902', 'cskefu', NULL, '297e1e874f83129d014f8334e74e0264', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:08', '2015-08-31 18:05:08', 0, 461, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337ada2056b', '卓资县', 'pub', '150921', 'cskefu', NULL, '297e1e874f83129d014f8334e74e0264', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:08', '2015-08-31 18:05:08', 0, 462, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337add5056c', '化德县', 'pub', '150922', 'cskefu', NULL, '297e1e874f83129d014f8334e74e0264', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:08', '2015-08-31 18:05:08', 0, 463, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337ade9056d', '商都县', 'pub', '150923', 'cskefu', NULL, '297e1e874f83129d014f8334e74e0264', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:08', '2015-08-31 18:05:08', 0, 464, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337adfe056e', '兴和县', 'pub', '150924', 'cskefu', NULL, '297e1e874f83129d014f8334e74e0264', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:08', '2015-08-31 18:05:08', 0, 465, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337ae0d056f', '凉城县', 'pub', '150925', 'cskefu', NULL, '297e1e874f83129d014f8334e74e0264', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:08', '2015-08-31 18:05:08', 0, 466, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337ae1d0570', '察哈尔右翼前旗', 'pub', '150926', 'cskefu', NULL, '297e1e874f83129d014f8334e74e0264', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:08', '2015-08-31 18:05:08', 0, 467, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337ae2e0571', '察哈尔右翼中旗', 'pub', '150927', 'cskefu', NULL, '297e1e874f83129d014f8334e74e0264', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:08', '2015-08-31 18:05:08', 0, 468, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337ae3e0572', '察哈尔右翼后旗', 'pub', '150928', 'cskefu', NULL, '297e1e874f83129d014f8334e74e0264', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:08', '2015-08-31 18:05:08', 0, 469, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337ae4d0573', '四子王旗', 'pub', '150929', 'cskefu', NULL, '297e1e874f83129d014f8334e74e0264', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:08', '2015-08-31 18:05:08', 0, 470, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337ae5e0574', '丰镇市', 'pub', '150981', 'cskefu', NULL, '297e1e874f83129d014f8334e74e0264', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:08', '2015-08-31 18:05:08', 0, 471, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337ae8e0575', '乌兰浩特市', 'pub', '152201', 'cskefu', NULL, '297e1e874f83129d014f8334e75b0265', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:08', '2015-08-31 18:05:08', 0, 472, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337ae9e0576', '阿尔山市', 'pub', '152202', 'cskefu', NULL, '297e1e874f83129d014f8334e75b0265', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:08', '2015-08-31 18:05:08', 0, 473, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337aeb10577', '科尔沁右翼前旗', 'pub', '152221', 'cskefu', NULL, '297e1e874f83129d014f8334e75b0265', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:08', '2015-08-31 18:05:08', 0, 474, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337aec10578', '科尔沁右翼中旗', 'pub', '152222', 'cskefu', NULL, '297e1e874f83129d014f8334e75b0265', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:08', '2015-08-31 18:05:08', 0, 475, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337aecf0579', '扎赉特旗', 'pub', '152223', 'cskefu', NULL, '297e1e874f83129d014f8334e75b0265', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:08', '2015-08-31 18:05:08', 0, 476, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337aedf057a', '突泉县', 'pub', '152224', 'cskefu', NULL, '297e1e874f83129d014f8334e75b0265', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:08', '2015-08-31 18:05:08', 0, 477, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b03c057b', '二连浩特市', 'pub', '152501', 'cskefu', NULL, '297e1e874f83129d014f8334e7680266', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', 0, 478, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b04e057c', '锡林浩特市', 'pub', '152502', 'cskefu', NULL, '297e1e874f83129d014f8334e7680266', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', 0, 479, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b062057d', '阿巴嘎旗', 'pub', '152522', 'cskefu', NULL, '297e1e874f83129d014f8334e7680266', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', 0, 480, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b077057e', '苏尼特左旗', 'pub', '152523', 'cskefu', NULL, '297e1e874f83129d014f8334e7680266', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', 0, 481, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b08b057f', '苏尼特右旗', 'pub', '152524', 'cskefu', NULL, '297e1e874f83129d014f8334e7680266', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', 0, 482, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b09f0580', '东乌珠穆沁旗', 'pub', '152525', 'cskefu', NULL, '297e1e874f83129d014f8334e7680266', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', 0, 483, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b0b80581', '西乌珠穆沁旗', 'pub', '152526', 'cskefu', NULL, '297e1e874f83129d014f8334e7680266', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', 0, 484, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b0ca0582', '太仆寺旗', 'pub', '152527', 'cskefu', NULL, '297e1e874f83129d014f8334e7680266', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', 0, 485, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b0dd0583', '镶黄旗', 'pub', '152528', 'cskefu', NULL, '297e1e874f83129d014f8334e7680266', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', 0, 486, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b0ed0584', '正镶白旗', 'pub', '152529', 'cskefu', NULL, '297e1e874f83129d014f8334e7680266', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', 0, 487, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b1020585', '正蓝旗', 'pub', '152530', 'cskefu', NULL, '297e1e874f83129d014f8334e7680266', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', 0, 488, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b1130586', '多伦县', 'pub', '152531', 'cskefu', NULL, '297e1e874f83129d014f8334e7680266', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', 0, 489, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b13e0587', '阿拉善左旗', 'pub', '152921', 'cskefu', NULL, '297e1e874f83129d014f8334e7740267', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', 0, 490, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b1530588', '阿拉善右旗', 'pub', '152922', 'cskefu', NULL, '297e1e874f83129d014f8334e7740267', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', 0, 491, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b1670589', '额济纳旗', 'pub', '152923', 'cskefu', NULL, '297e1e874f83129d014f8334e7740267', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', 0, 492, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b2c8058a', '市辖区', 'pub', '210101', 'cskefu', NULL, '297e1e874f83129d014f8334e7960268', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', 0, 493, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b2d8058b', '和平区', 'pub', '210102', 'cskefu', NULL, '297e1e874f83129d014f8334e7960268', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', 0, 494, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b2e8058c', '沈河区', 'pub', '210103', 'cskefu', NULL, '297e1e874f83129d014f8334e7960268', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', 0, 495, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b2fa058d', '大东区', 'pub', '210104', 'cskefu', NULL, '297e1e874f83129d014f8334e7960268', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', 0, 496, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b310058e', '皇姑区', 'pub', '210105', 'cskefu', NULL, '297e1e874f83129d014f8334e7960268', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', 0, 497, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b321058f', '铁西区', 'pub', '210106', 'cskefu', NULL, '297e1e874f83129d014f8334e7960268', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', 0, 498, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b3320590', '苏家屯区', 'pub', '210111', 'cskefu', NULL, '297e1e874f83129d014f8334e7960268', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', 0, 499, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b3420591', '东陵区', 'pub', '210112', 'cskefu', NULL, '297e1e874f83129d014f8334e7960268', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', 0, 500, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b3530592', '新城子区', 'pub', '210113', 'cskefu', NULL, '297e1e874f83129d014f8334e7960268', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', 0, 501, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b3630593', '于洪区', 'pub', '210114', 'cskefu', NULL, '297e1e874f83129d014f8334e7960268', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', 0, 502, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b3740594', '辽中县', 'pub', '210122', 'cskefu', NULL, '297e1e874f83129d014f8334e7960268', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', 0, 503, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b3820595', '康平县', 'pub', '210123', 'cskefu', NULL, '297e1e874f83129d014f8334e7960268', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', 0, 504, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b3980596', '法库县', 'pub', '210124', 'cskefu', NULL, '297e1e874f83129d014f8334e7960268', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', 0, 505, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b3ac0597', '新民市', 'pub', '210181', 'cskefu', NULL, '297e1e874f83129d014f8334e7960268', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', 0, 506, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b3da0598', '市辖区', 'pub', '210201', 'cskefu', NULL, '297e1e874f83129d014f8334e7a40269', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', 0, 507, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b3ea0599', '中山区', 'pub', '210202', 'cskefu', NULL, '297e1e874f83129d014f8334e7a40269', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:09', '2015-08-31 18:05:09', 0, 508, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b400059a', '西岗区', 'pub', '210203', 'cskefu', NULL, '297e1e874f83129d014f8334e7a40269', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:10', '2015-08-31 18:05:10', 0, 509, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b412059b', '沙河口区', 'pub', '210204', 'cskefu', NULL, '297e1e874f83129d014f8334e7a40269', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:10', '2015-08-31 18:05:10', 0, 510, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b550059c', '甘井子区', 'pub', '210211', 'cskefu', NULL, '297e1e874f83129d014f8334e7a40269', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:10', '2015-08-31 18:05:10', 0, 511, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b560059d', '旅顺口区', 'pub', '210212', 'cskefu', NULL, '297e1e874f83129d014f8334e7a40269', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:10', '2015-08-31 18:05:10', 0, 512, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b56f059e', '金州区', 'pub', '210213', 'cskefu', NULL, '297e1e874f83129d014f8334e7a40269', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:10', '2015-08-31 18:05:10', 0, 513, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b58b059f', '长海县', 'pub', '210224', 'cskefu', NULL, '297e1e874f83129d014f8334e7a40269', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:10', '2015-08-31 18:05:10', 0, 514, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b59b05a0', '瓦房店市', 'pub', '210281', 'cskefu', NULL, '297e1e874f83129d014f8334e7a40269', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:10', '2015-08-31 18:05:10', 0, 515, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b5af05a1', '普兰店市', 'pub', '210282', 'cskefu', NULL, '297e1e874f83129d014f8334e7a40269', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:10', '2015-08-31 18:05:10', 0, 516, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b5c105a2', '庄河市', 'pub', '210283', 'cskefu', NULL, '297e1e874f83129d014f8334e7a40269', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:10', '2015-08-31 18:05:10', 0, 517, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b5ec05a3', '市辖区', 'pub', '210301', 'cskefu', NULL, '297e1e874f83129d014f8334e7b2026a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:10', '2015-08-31 18:05:10', 0, 518, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b5fa05a4', '铁东区', 'pub', '210302', 'cskefu', NULL, '297e1e874f83129d014f8334e7b2026a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:10', '2015-08-31 18:05:10', 0, 519, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b60a05a5', '铁西区', 'pub', '210303', 'cskefu', NULL, '297e1e874f83129d014f8334e7b2026a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:10', '2015-08-31 18:05:10', 0, 520, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b61905a6', '立山区', 'pub', '210304', 'cskefu', NULL, '297e1e874f83129d014f8334e7b2026a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:10', '2015-08-31 18:05:10', 0, 521, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b62905a7', '千山区', 'pub', '210311', 'cskefu', NULL, '297e1e874f83129d014f8334e7b2026a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:10', '2015-08-31 18:05:10', 0, 522, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b63c05a8', '台安县', 'pub', '210321', 'cskefu', NULL, '297e1e874f83129d014f8334e7b2026a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:10', '2015-08-31 18:05:10', 0, 523, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b64b05a9', '岫岩满族自治县', 'pub', '210323', 'cskefu', NULL, '297e1e874f83129d014f8334e7b2026a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:10', '2015-08-31 18:05:10', 0, 524, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b65c05aa', '海城市', 'pub', '210381', 'cskefu', NULL, '297e1e874f83129d014f8334e7b2026a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:10', '2015-08-31 18:05:10', 0, 525, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b7ae05ab', '市辖区', 'pub', '210401', 'cskefu', NULL, '297e1e874f83129d014f8334e7c2026b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:10', '2015-08-31 18:05:10', 0, 526, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b7bc05ac', '新抚区', 'pub', '210402', 'cskefu', NULL, '297e1e874f83129d014f8334e7c2026b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:10', '2015-08-31 18:05:10', 0, 527, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b7ca05ad', '东洲区', 'pub', '210403', 'cskefu', NULL, '297e1e874f83129d014f8334e7c2026b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:10', '2015-08-31 18:05:10', 0, 528, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b7da05ae', '望花区', 'pub', '210404', 'cskefu', NULL, '297e1e874f83129d014f8334e7c2026b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:11', '2015-08-31 18:05:11', 0, 529, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b7e805af', '顺城区', 'pub', '210411', 'cskefu', NULL, '297e1e874f83129d014f8334e7c2026b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:11', '2015-08-31 18:05:11', 0, 530, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b7f905b0', '抚顺县', 'pub', '210421', 'cskefu', NULL, '297e1e874f83129d014f8334e7c2026b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:11', '2015-08-31 18:05:11', 0, 531, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b80b05b1', '新宾满族自治县', 'pub', '210422', 'cskefu', NULL, '297e1e874f83129d014f8334e7c2026b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:11', '2015-08-31 18:05:11', 0, 532, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b81a05b2', '清原满族自治县', 'pub', '210423', 'cskefu', NULL, '297e1e874f83129d014f8334e7c2026b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:11', '2015-08-31 18:05:11', 0, 533, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b84605b3', '市辖区', 'pub', '210501', 'cskefu', NULL, '297e1e874f83129d014f8334e7ce026c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:11', '2015-08-31 18:05:11', 0, 534, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b85805b4', '平山区', 'pub', '210502', 'cskefu', NULL, '297e1e874f83129d014f8334e7ce026c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:11', '2015-08-31 18:05:11', 0, 535, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b86905b5', '溪湖区', 'pub', '210503', 'cskefu', NULL, '297e1e874f83129d014f8334e7ce026c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:11', '2015-08-31 18:05:11', 0, 536, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b9a605b6', '明山区', 'pub', '210504', 'cskefu', NULL, '297e1e874f83129d014f8334e7ce026c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:11', '2015-08-31 18:05:11', 0, 537, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b9b505b7', '南芬区', 'pub', '210505', 'cskefu', NULL, '297e1e874f83129d014f8334e7ce026c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:11', '2015-08-31 18:05:11', 0, 538, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b9c305b8', '本溪满族自治县', 'pub', '210521', 'cskefu', NULL, '297e1e874f83129d014f8334e7ce026c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:11', '2015-08-31 18:05:11', 0, 539, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337b9d405b9', '桓仁满族自治县', 'pub', '210522', 'cskefu', NULL, '297e1e874f83129d014f8334e7ce026c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:11', '2015-08-31 18:05:11', 0, 540, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337ba1105ba', '市辖区', 'pub', '210601', 'cskefu', NULL, '297e1e874f83129d014f8334e7da026d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:11', '2015-08-31 18:05:11', 0, 541, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337ba1f05bb', '元宝区', 'pub', '210602', 'cskefu', NULL, '297e1e874f83129d014f8334e7da026d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:11', '2015-08-31 18:05:11', 0, 542, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337ba3005bc', '振兴区', 'pub', '210603', 'cskefu', NULL, '297e1e874f83129d014f8334e7da026d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:11', '2015-08-31 18:05:11', 0, 543, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337ba3e05bd', '振安区', 'pub', '210604', 'cskefu', NULL, '297e1e874f83129d014f8334e7da026d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:11', '2015-08-31 18:05:11', 0, 544, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337ba4b05be', '宽甸满族自治县', 'pub', '210624', 'cskefu', NULL, '297e1e874f83129d014f8334e7da026d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:11', '2015-08-31 18:05:11', 0, 545, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337ba5c05bf', '东港市', 'pub', '210681', 'cskefu', NULL, '297e1e874f83129d014f8334e7da026d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:11', '2015-08-31 18:05:11', 0, 546, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337ba6b05c0', '凤城市', 'pub', '210682', 'cskefu', NULL, '297e1e874f83129d014f8334e7da026d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:11', '2015-08-31 18:05:11', 0, 547, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337ba9605c1', '市辖区', 'pub', '210701', 'cskefu', NULL, '297e1e874f83129d014f8334e7e6026e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:11', '2015-08-31 18:05:11', 0, 548, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337baa405c2', '古塔区', 'pub', '210702', 'cskefu', NULL, '297e1e874f83129d014f8334e7e6026e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:11', '2015-08-31 18:05:11', 0, 549, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337bab405c4', '凌河区', 'pub', '210703', 'cskefu', NULL, '297e1e874f83129d014f8334e7e6026e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:11', '2015-08-31 18:05:11', 0, 550, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337bbfc05c5', '太和区', 'pub', '210711', 'cskefu', NULL, '297e1e874f83129d014f8334e7e6026e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:12', '2015-08-31 18:05:12', 0, 551, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337bc0905c6', '黑山县', 'pub', '210726', 'cskefu', NULL, '297e1e874f83129d014f8334e7e6026e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:12', '2015-08-31 18:05:12', 0, 552, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337bc1a05c7', '义　县', 'pub', '210727', 'cskefu', NULL, '297e1e874f83129d014f8334e7e6026e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:12', '2015-08-31 18:05:12', 0, 553, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337bc2705c8', '凌海市', 'pub', '210781', 'cskefu', NULL, '297e1e874f83129d014f8334e7e6026e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:12', '2015-08-31 18:05:12', 0, 554, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337bc3505c9', '北宁市', 'pub', '210782', 'cskefu', NULL, '297e1e874f83129d014f8334e7e6026e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:12', '2015-08-31 18:05:12', 0, 555, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337bc6205ca', '市辖区', 'pub', '210801', 'cskefu', NULL, '297e1e874f83129d014f8334e7f3026f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:12', '2015-08-31 18:05:12', 0, 556, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337bc7005cb', '站前区', 'pub', '210802', 'cskefu', NULL, '297e1e874f83129d014f8334e7f3026f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:12', '2015-08-31 18:05:12', 0, 557, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337bc8105cc', '西市区', 'pub', '210803', 'cskefu', NULL, '297e1e874f83129d014f8334e7f3026f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:12', '2015-08-31 18:05:12', 0, 558, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337bc9505cd', '鲅鱼圈区', 'pub', '210804', 'cskefu', NULL, '297e1e874f83129d014f8334e7f3026f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:12', '2015-08-31 18:05:12', 0, 559, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337bca605ce', '老边区', 'pub', '210811', 'cskefu', NULL, '297e1e874f83129d014f8334e7f3026f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:12', '2015-08-31 18:05:12', 0, 560, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337bcbe05cf', '盖州市', 'pub', '210881', 'cskefu', NULL, '297e1e874f83129d014f8334e7f3026f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:12', '2015-08-31 18:05:12', 0, 561, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337bdf805d0', '大石桥市', 'pub', '210882', 'cskefu', NULL, '297e1e874f83129d014f8334e7f3026f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:12', '2015-08-31 18:05:12', 0, 562, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337be2805d1', '市辖区', 'pub', '210901', 'cskefu', NULL, '297e1e874f83129d014f8334e8010270', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:12', '2015-08-31 18:05:12', 0, 563, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337be3d05d2', '海州区', 'pub', '210902', 'cskefu', NULL, '297e1e874f83129d014f8334e8010270', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:12', '2015-08-31 18:05:12', 0, 564, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337be4c05d3', '新邱区', 'pub', '210903', 'cskefu', NULL, '297e1e874f83129d014f8334e8010270', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:12', '2015-08-31 18:05:12', 0, 565, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337be5a05d4', '太平区', 'pub', '210904', 'cskefu', NULL, '297e1e874f83129d014f8334e8010270', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:12', '2015-08-31 18:05:12', 0, 566, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337be6705d5', '清河门区', 'pub', '210905', 'cskefu', NULL, '297e1e874f83129d014f8334e8010270', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:12', '2015-08-31 18:05:12', 0, 567, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337be7505d6', '细河区', 'pub', '210911', 'cskefu', NULL, '297e1e874f83129d014f8334e8010270', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:12', '2015-08-31 18:05:12', 0, 568, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337be8b05d7', '阜新蒙古族自治县', 'pub', '210921', 'cskefu', NULL, '297e1e874f83129d014f8334e8010270', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:12', '2015-08-31 18:05:12', 0, 569, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337bea305d8', '彰武县', 'pub', '210922', 'cskefu', NULL, '297e1e874f83129d014f8334e8010270', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:12', '2015-08-31 18:05:12', 0, 570, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337bede05d9', '市辖区', 'pub', '211001', 'cskefu', NULL, '297e1e874f83129d014f8334e80f0272', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:12', '2015-08-31 18:05:12', 0, 571, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337beec05da', '白塔区', 'pub', '211002', 'cskefu', NULL, '297e1e874f83129d014f8334e80f0272', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:12', '2015-08-31 18:05:12', 0, 572, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337bf0005db', '文圣区', 'pub', '211003', 'cskefu', NULL, '297e1e874f83129d014f8334e80f0272', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:12', '2015-08-31 18:05:12', 0, 573, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337bf0e05dc', '宏伟区', 'pub', '211004', 'cskefu', NULL, '297e1e874f83129d014f8334e80f0272', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:12', '2015-08-31 18:05:12', 0, 574, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337bf2405dd', '弓长岭区', 'pub', '211005', 'cskefu', NULL, '297e1e874f83129d014f8334e80f0272', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:12', '2015-08-31 18:05:12', 0, 575, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337bf3205de', '太子河区', 'pub', '211011', 'cskefu', NULL, '297e1e874f83129d014f8334e80f0272', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:12', '2015-08-31 18:05:12', 0, 576, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337bf4b05df', '辽阳县', 'pub', '211021', 'cskefu', NULL, '297e1e874f83129d014f8334e80f0272', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:12', '2015-08-31 18:05:12', 0, 577, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337bf6105e0', '灯塔市', 'pub', '211081', 'cskefu', NULL, '297e1e874f83129d014f8334e80f0272', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:12', '2015-08-31 18:05:12', 0, 578, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337c0ba05e1', '市辖区', 'pub', '211101', 'cskefu', NULL, '297e1e874f83129d014f8334e81e0273', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:13', '2015-08-31 18:05:13', 0, 579, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337c0c805e2', '双台子区', 'pub', '211102', 'cskefu', NULL, '297e1e874f83129d014f8334e81e0273', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:13', '2015-08-31 18:05:13', 0, 580, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337c0d605e3', '兴隆台区', 'pub', '211103', 'cskefu', NULL, '297e1e874f83129d014f8334e81e0273', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:13', '2015-08-31 18:05:13', 0, 581, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337c0e705e4', '大洼县', 'pub', '211121', 'cskefu', NULL, '297e1e874f83129d014f8334e81e0273', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:13', '2015-08-31 18:05:13', 0, 582, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337c0f405e5', '盘山县', 'pub', '211122', 'cskefu', NULL, '297e1e874f83129d014f8334e81e0273', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:13', '2015-08-31 18:05:13', 0, 583, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337c12105e6', '市辖区', 'pub', '211201', 'cskefu', NULL, '297e1e874f83129d014f8334e82c0274', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:13', '2015-08-31 18:05:13', 0, 584, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337c12e05e7', '银州区', 'pub', '211202', 'cskefu', NULL, '297e1e874f83129d014f8334e82c0274', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:13', '2015-08-31 18:05:13', 0, 585, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337c13d05e8', '清河区', 'pub', '211204', 'cskefu', NULL, '297e1e874f83129d014f8334e82c0274', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:13', '2015-08-31 18:05:13', 0, 586, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337c15005e9', '铁岭县', 'pub', '211221', 'cskefu', NULL, '297e1e874f83129d014f8334e82c0274', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:13', '2015-08-31 18:05:13', 0, 587, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337c16705ea', '西丰县', 'pub', '211223', 'cskefu', NULL, '297e1e874f83129d014f8334e82c0274', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:13', '2015-08-31 18:05:13', 0, 588, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337c17905eb', '昌图县', 'pub', '211224', 'cskefu', NULL, '297e1e874f83129d014f8334e82c0274', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:13', '2015-08-31 18:05:13', 0, 589, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337c2b805ec', '调兵山市', 'pub', '211281', 'cskefu', NULL, '297e1e874f83129d014f8334e82c0274', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:13', '2015-08-31 18:05:13', 0, 590, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337c2cc05ed', '开原市', 'pub', '211282', 'cskefu', NULL, '297e1e874f83129d014f8334e82c0274', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:13', '2015-08-31 18:05:13', 0, 591, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337c2fa05ee', '市辖区', 'pub', '211301', 'cskefu', NULL, '297e1e874f83129d014f8334e8410275', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:13', '2015-08-31 18:05:13', 0, 592, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337c31005ef', '双塔区', 'pub', '211302', 'cskefu', NULL, '297e1e874f83129d014f8334e8410275', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:13', '2015-08-31 18:05:13', 0, 593, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337c32605f0', '龙城区', 'pub', '211303', 'cskefu', NULL, '297e1e874f83129d014f8334e8410275', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:13', '2015-08-31 18:05:13', 0, 594, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337c33c05f1', '朝阳县', 'pub', '211321', 'cskefu', NULL, '297e1e874f83129d014f8334e8410275', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:13', '2015-08-31 18:05:13', 0, 595, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337c34f05f2', '建平县', 'pub', '211322', 'cskefu', NULL, '297e1e874f83129d014f8334e8410275', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:13', '2015-08-31 18:05:13', 0, 596, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337c36405f3', '喀喇沁左翼蒙古族自治县', 'pub', '211324', 'cskefu', NULL, '297e1e874f83129d014f8334e8410275', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:13', '2015-08-31 18:05:13', 0, 597, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337c37c05f4', '北票市', 'pub', '211381', 'cskefu', NULL, '297e1e874f83129d014f8334e8410275', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:13', '2015-08-31 18:05:13', 0, 598, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337c38d05f5', '凌源市', 'pub', '211382', 'cskefu', NULL, '297e1e874f83129d014f8334e8410275', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:13', '2015-08-31 18:05:13', 0, 599, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337c3b805f6', '市辖区', 'pub', '211401', 'cskefu', NULL, '297e1e874f83129d014f8334e84e0276', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:14', '2015-08-31 18:05:14', 0, 600, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337c3cc05f7', '连山区', 'pub', '211402', 'cskefu', NULL, '297e1e874f83129d014f8334e84e0276', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:14', '2015-08-31 18:05:14', 0, 601, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337c3df05f8', '龙港区', 'pub', '211403', 'cskefu', NULL, '297e1e874f83129d014f8334e84e0276', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:14', '2015-08-31 18:05:14', 0, 602, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337c3ef05f9', '南票区', 'pub', '211404', 'cskefu', NULL, '297e1e874f83129d014f8334e84e0276', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:14', '2015-08-31 18:05:14', 0, 603, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337c40005fa', '绥中县', 'pub', '211421', 'cskefu', NULL, '297e1e874f83129d014f8334e84e0276', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:14', '2015-08-31 18:05:14', 0, 604, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337c41605fb', '建昌县', 'pub', '211422', 'cskefu', NULL, '297e1e874f83129d014f8334e84e0276', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:14', '2015-08-31 18:05:14', 0, 605, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337c42c05fc', '兴城市', 'pub', '211481', 'cskefu', NULL, '297e1e874f83129d014f8334e84e0276', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:14', '2015-08-31 18:05:14', 0, 606, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337c58b05fd', '市辖区', 'pub', '220101', 'cskefu', NULL, '297e1e874f83129d014f8334e8730277', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:14', '2015-08-31 18:05:14', 0, 607, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337c59f05fe', '南关区', 'pub', '220102', 'cskefu', NULL, '297e1e874f83129d014f8334e8730277', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:14', '2015-08-31 18:05:14', 0, 608, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337c5b705ff', '宽城区', 'pub', '220103', 'cskefu', NULL, '297e1e874f83129d014f8334e8730277', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:14', '2015-08-31 18:05:14', 0, 609, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337c5c80600', '朝阳区', 'pub', '220104', 'cskefu', NULL, '297e1e874f83129d014f8334e8730277', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:14', '2015-08-31 18:05:14', 0, 610, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337c5db0601', '二道区', 'pub', '220105', 'cskefu', NULL, '297e1e874f83129d014f8334e8730277', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:14', '2015-08-31 18:05:14', 0, 611, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337c5f00602', '绿园区', 'pub', '220106', 'cskefu', NULL, '297e1e874f83129d014f8334e8730277', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:14', '2015-08-31 18:05:14', 0, 612, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337c6040603', '双阳区', 'pub', '220112', 'cskefu', NULL, '297e1e874f83129d014f8334e8730277', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:14', '2015-08-31 18:05:14', 0, 613, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337c6130604', '农安县', 'pub', '220122', 'cskefu', NULL, '297e1e874f83129d014f8334e8730277', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:14', '2015-08-31 18:05:14', 0, 614, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337c6270605', '九台市', 'pub', '220181', 'cskefu', NULL, '297e1e874f83129d014f8334e8730277', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:14', '2015-08-31 18:05:14', 0, 615, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337c63b0606', '榆树市', 'pub', '220182', 'cskefu', NULL, '297e1e874f83129d014f8334e8730277', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:14', '2015-08-31 18:05:14', 0, 616, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337c64f0607', '德惠市', 'pub', '220183', 'cskefu', NULL, '297e1e874f83129d014f8334e8730277', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:14', '2015-08-31 18:05:14', 0, 617, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337c67f0608', '市辖区', 'pub', '220201', 'cskefu', NULL, '297e1e874f83129d014f8334e8800278', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:14', '2015-08-31 18:05:14', 0, 618, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337c68f0609', '昌邑区', 'pub', '220202', 'cskefu', NULL, '297e1e874f83129d014f8334e8800278', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:14', '2015-08-31 18:05:14', 0, 619, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337c6a3060a', '龙潭区', 'pub', '220203', 'cskefu', NULL, '297e1e874f83129d014f8334e8800278', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:14', '2015-08-31 18:05:14', 0, 620, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337c6b9060b', '船营区', 'pub', '220204', 'cskefu', NULL, '297e1e874f83129d014f8334e8800278', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:14', '2015-08-31 18:05:14', 0, 621, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337c6c8060c', '丰满区', 'pub', '220211', 'cskefu', NULL, '297e1e874f83129d014f8334e8800278', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:14', '2015-08-31 18:05:14', 0, 622, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337c6d8060d', '永吉县', 'pub', '220221', 'cskefu', NULL, '297e1e874f83129d014f8334e8800278', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:14', '2015-08-31 18:05:14', 0, 623, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337c813060e', '蛟河市', 'pub', '220281', 'cskefu', NULL, '297e1e874f83129d014f8334e8800278', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:15', '2015-08-31 18:05:15', 0, 624, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337c822060f', '桦甸市', 'pub', '220282', 'cskefu', NULL, '297e1e874f83129d014f8334e8800278', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:15', '2015-08-31 18:05:15', 0, 625, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337c8360610', '舒兰市', 'pub', '220283', 'cskefu', NULL, '297e1e874f83129d014f8334e8800278', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:15', '2015-08-31 18:05:15', 0, 626, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337c8440611', '磐石市', 'pub', '220284', 'cskefu', NULL, '297e1e874f83129d014f8334e8800278', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:15', '2015-08-31 18:05:15', 0, 627, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337c86d0612', '市辖区', 'pub', '220301', 'cskefu', NULL, '297e1e874f83129d014f8334e88f0279', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:15', '2015-08-31 18:05:15', 0, 628, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337c87b0613', '铁西区', 'pub', '220302', 'cskefu', NULL, '297e1e874f83129d014f8334e88f0279', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:15', '2015-08-31 18:05:15', 0, 629, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337c8880614', '铁东区', 'pub', '220303', 'cskefu', NULL, '297e1e874f83129d014f8334e88f0279', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:15', '2015-08-31 18:05:15', 0, 630, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337c8950615', '梨树县', 'pub', '220322', 'cskefu', NULL, '297e1e874f83129d014f8334e88f0279', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:15', '2015-08-31 18:05:15', 0, 631, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337c8a50616', '伊通满族自治县', 'pub', '220323', 'cskefu', NULL, '297e1e874f83129d014f8334e88f0279', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:15', '2015-08-31 18:05:15', 0, 632, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337c8b30617', '公主岭市', 'pub', '220381', 'cskefu', NULL, '297e1e874f83129d014f8334e88f0279', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:15', '2015-08-31 18:05:15', 0, 633, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337c8c40618', '双辽市', 'pub', '220382', 'cskefu', NULL, '297e1e874f83129d014f8334e88f0279', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:15', '2015-08-31 18:05:15', 0, 634, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337c8ea0619', '市辖区', 'pub', '220401', 'cskefu', NULL, '297e1e874f83129d014f8334e89c027a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:15', '2015-08-31 18:05:15', 0, 635, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337ca40061a', '龙山区', 'pub', '220402', 'cskefu', NULL, '297e1e874f83129d014f8334e89c027a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:15', '2015-08-31 18:05:15', 0, 636, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337ca4d061b', '西安区', 'pub', '220403', 'cskefu', NULL, '297e1e874f83129d014f8334e89c027a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:15', '2015-08-31 18:05:15', 0, 637, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337ca5d061c', '东丰县', 'pub', '220421', 'cskefu', NULL, '297e1e874f83129d014f8334e89c027a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:15', '2015-08-31 18:05:15', 0, 638, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337ca6a061d', '东辽县', 'pub', '220422', 'cskefu', NULL, '297e1e874f83129d014f8334e89c027a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:15', '2015-08-31 18:05:15', 0, 639, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337ca91061e', '市辖区', 'pub', '220501', 'cskefu', NULL, '297e1e874f83129d014f8334e8a8027b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:15', '2015-08-31 18:05:15', 0, 640, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337ca9e061f', '东昌区', 'pub', '220502', 'cskefu', NULL, '297e1e874f83129d014f8334e8a8027b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:15', '2015-08-31 18:05:15', 0, 641, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337caad0620', '二道江区', 'pub', '220503', 'cskefu', NULL, '297e1e874f83129d014f8334e8a8027b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:15', '2015-08-31 18:05:15', 0, 642, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337caba0621', '通化县', 'pub', '220521', 'cskefu', NULL, '297e1e874f83129d014f8334e8a8027b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:15', '2015-08-31 18:05:15', 0, 643, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337cac70622', '辉南县', 'pub', '220523', 'cskefu', NULL, '297e1e874f83129d014f8334e8a8027b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:15', '2015-08-31 18:05:15', 0, 644, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337cad50623', '柳河县', 'pub', '220524', 'cskefu', NULL, '297e1e874f83129d014f8334e8a8027b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:15', '2015-08-31 18:05:15', 0, 645, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337cae20624', '梅河口市', 'pub', '220581', 'cskefu', NULL, '297e1e874f83129d014f8334e8a8027b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:15', '2015-08-31 18:05:15', 0, 646, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337caf20625', '集安市', 'pub', '220582', 'cskefu', NULL, '297e1e874f83129d014f8334e8a8027b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:15', '2015-08-31 18:05:15', 0, 647, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337cb1b0626', '市辖区', 'pub', '220601', 'cskefu', NULL, '297e1e874f83129d014f8334e8b9027c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:15', '2015-08-31 18:05:15', 0, 648, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337cc580627', '八道江区', 'pub', '220602', 'cskefu', NULL, '297e1e874f83129d014f8334e8b9027c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:16', '2015-08-31 18:05:16', 0, 649, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337cc650628', '抚松县', 'pub', '220621', 'cskefu', NULL, '297e1e874f83129d014f8334e8b9027c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:16', '2015-08-31 18:05:16', 0, 650, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337cc750629', '靖宇县', 'pub', '220622', 'cskefu', NULL, '297e1e874f83129d014f8334e8b9027c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:16', '2015-08-31 18:05:16', 0, 651, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337cc87062a', '长白朝鲜族自治县', 'pub', '220623', 'cskefu', NULL, '297e1e874f83129d014f8334e8b9027c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:16', '2015-08-31 18:05:16', 0, 652, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337cc96062b', '江源县', 'pub', '220625', 'cskefu', NULL, '297e1e874f83129d014f8334e8b9027c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:16', '2015-08-31 18:05:16', 0, 653, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337cca6062c', '临江市', 'pub', '220681', 'cskefu', NULL, '297e1e874f83129d014f8334e8b9027c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:16', '2015-08-31 18:05:16', 0, 654, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337ccd3062d', '市辖区', 'pub', '220701', 'cskefu', NULL, '297e1e874f83129d014f8334e8c6027d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:16', '2015-08-31 18:05:16', 0, 655, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337cce0062e', '宁江区', 'pub', '220702', 'cskefu', NULL, '297e1e874f83129d014f8334e8c6027d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:16', '2015-08-31 18:05:16', 0, 656, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337ccef062f', '前郭尔罗斯蒙古族自治县', 'pub', '220721', 'cskefu', NULL, '297e1e874f83129d014f8334e8c6027d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:16', '2015-08-31 18:05:16', 0, 657, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337ccfd0630', '长岭县', 'pub', '220722', 'cskefu', NULL, '297e1e874f83129d014f8334e8c6027d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:16', '2015-08-31 18:05:16', 0, 658, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337cd0a0631', '乾安县', 'pub', '220723', 'cskefu', NULL, '297e1e874f83129d014f8334e8c6027d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:16', '2015-08-31 18:05:16', 0, 659, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337cd190632', '扶余县', 'pub', '220724', 'cskefu', NULL, '297e1e874f83129d014f8334e8c6027d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:16', '2015-08-31 18:05:16', 0, 660, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337cf2f0634', '市辖区', 'pub', '220801', 'cskefu', NULL, '297e1e874f83129d014f8334e8d4027e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:16', '2015-08-31 18:05:16', 0, 661, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337cf400635', '洮北区', 'pub', '220802', 'cskefu', NULL, '297e1e874f83129d014f8334e8d4027e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:16', '2015-08-31 18:05:16', 0, 662, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337cf4d0636', '镇赉县', 'pub', '220821', 'cskefu', NULL, '297e1e874f83129d014f8334e8d4027e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', 0, 663, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337cf5d0637', '通榆县', 'pub', '220822', 'cskefu', NULL, '297e1e874f83129d014f8334e8d4027e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', 0, 664, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337cf6c0638', '洮南市', 'pub', '220881', 'cskefu', NULL, '297e1e874f83129d014f8334e8d4027e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', 0, 665, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337cf7c0639', '大安市', 'pub', '220882', 'cskefu', NULL, '297e1e874f83129d014f8334e8d4027e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', 0, 666, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337cfa6063a', '延吉市', 'pub', '222401', 'cskefu', NULL, '297e1e874f83129d014f8334e8e1027f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', 0, 667, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337cfb4063b', '图们市', 'pub', '222402', 'cskefu', NULL, '297e1e874f83129d014f8334e8e1027f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', 0, 668, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337cfc1063c', '敦化市', 'pub', '222403', 'cskefu', NULL, '297e1e874f83129d014f8334e8e1027f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', 0, 669, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337cfcf063d', '珲春市', 'pub', '222404', 'cskefu', NULL, '297e1e874f83129d014f8334e8e1027f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', 0, 670, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337cfdd063e', '龙井市', 'pub', '222405', 'cskefu', NULL, '297e1e874f83129d014f8334e8e1027f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', 0, 671, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337cfea063f', '和龙市', 'pub', '222406', 'cskefu', NULL, '297e1e874f83129d014f8334e8e1027f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', 0, 672, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337cffc0640', '汪清县', 'pub', '222424', 'cskefu', NULL, '297e1e874f83129d014f8334e8e1027f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', 0, 673, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d0090641', '安图县', 'pub', '222426', 'cskefu', NULL, '297e1e874f83129d014f8334e8e1027f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', 0, 674, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d0340642', '市辖区', 'pub', '230101', 'cskefu', NULL, '297e1e874f83129d014f8334e91d0280', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', 0, 675, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d0410643', '道里区', 'pub', '230102', 'cskefu', NULL, '297e1e874f83129d014f8334e91d0280', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', 0, 676, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d17c0644', '南岗区', 'pub', '230103', 'cskefu', NULL, '297e1e874f83129d014f8334e91d0280', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', 0, 677, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d18f0645', '道外区', 'pub', '230104', 'cskefu', NULL, '297e1e874f83129d014f8334e91d0280', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', 0, 678, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d19f0646', '香坊区', 'pub', '230106', 'cskefu', NULL, '297e1e874f83129d014f8334e91d0280', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', 0, 679, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d1af0647', '动力区', 'pub', '230107', 'cskefu', NULL, '297e1e874f83129d014f8334e91d0280', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', 0, 680, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d1c30648', '平房区', 'pub', '230108', 'cskefu', NULL, '297e1e874f83129d014f8334e91d0280', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', 0, 681, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d1d10649', '松北区', 'pub', '230109', 'cskefu', NULL, '297e1e874f83129d014f8334e91d0280', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', 0, 682, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d1e1064a', '呼兰区', 'pub', '230111', 'cskefu', NULL, '297e1e874f83129d014f8334e91d0280', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', 0, 683, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d1ee064b', '依兰县', 'pub', '230123', 'cskefu', NULL, '297e1e874f83129d014f8334e91d0280', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', 0, 684, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d1fb064c', '方正县', 'pub', '230124', 'cskefu', NULL, '297e1e874f83129d014f8334e91d0280', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', 0, 685, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d209064d', '宾　县', 'pub', '230125', 'cskefu', NULL, '297e1e874f83129d014f8334e91d0280', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', 0, 686, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d219064e', '巴彦县', 'pub', '230126', 'cskefu', NULL, '297e1e874f83129d014f8334e91d0280', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', 0, 687, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d228064f', '木兰县', 'pub', '230127', 'cskefu', NULL, '297e1e874f83129d014f8334e91d0280', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', 0, 688, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d2370650', '通河县', 'pub', '230128', 'cskefu', NULL, '297e1e874f83129d014f8334e91d0280', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', 0, 689, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d2490651', '延寿县', 'pub', '230129', 'cskefu', NULL, '297e1e874f83129d014f8334e91d0280', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', 0, 690, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d2580652', '阿城市', 'pub', '230181', 'cskefu', NULL, '297e1e874f83129d014f8334e91d0280', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', 0, 691, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d2660653', '双城市', 'pub', '230182', 'cskefu', NULL, '297e1e874f83129d014f8334e91d0280', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', 0, 692, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d2730654', '尚志市', 'pub', '230183', 'cskefu', NULL, '297e1e874f83129d014f8334e91d0280', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:17', '2015-08-31 18:05:17', 0, 693, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d3ad0655', '五常市', 'pub', '230184', 'cskefu', NULL, '297e1e874f83129d014f8334e91d0280', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:18', '2015-08-31 18:05:18', 0, 694, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d3d80656', '市辖区', 'pub', '230201', 'cskefu', NULL, '297e1e874f83129d014f8334e9290281', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:18', '2015-08-31 18:05:18', 0, 695, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d3e70657', '龙沙区', 'pub', '230202', 'cskefu', NULL, '297e1e874f83129d014f8334e9290281', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:18', '2015-08-31 18:05:18', 0, 696, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d3f40658', '建华区', 'pub', '230203', 'cskefu', NULL, '297e1e874f83129d014f8334e9290281', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:18', '2015-08-31 18:05:18', 0, 697, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d4010659', '铁锋区', 'pub', '230204', 'cskefu', NULL, '297e1e874f83129d014f8334e9290281', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:18', '2015-08-31 18:05:18', 0, 698, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d410065a', '昂昂溪区', 'pub', '230205', 'cskefu', NULL, '297e1e874f83129d014f8334e9290281', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:18', '2015-08-31 18:05:18', 0, 699, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d41d065b', '富拉尔基区', 'pub', '230206', 'cskefu', NULL, '297e1e874f83129d014f8334e9290281', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:18', '2015-08-31 18:05:18', 0, 700, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d42c065c', '碾子山区', 'pub', '230207', 'cskefu', NULL, '297e1e874f83129d014f8334e9290281', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:18', '2015-08-31 18:05:18', 0, 701, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d43d065d', '梅里斯达斡尔族区', 'pub', '230208', 'cskefu', NULL, '297e1e874f83129d014f8334e9290281', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:18', '2015-08-31 18:05:18', 0, 702, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d44a065e', '龙江县', 'pub', '230221', 'cskefu', NULL, '297e1e874f83129d014f8334e9290281', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:18', '2015-08-31 18:05:18', 0, 703, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d457065f', '依安县', 'pub', '230223', 'cskefu', NULL, '297e1e874f83129d014f8334e9290281', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:18', '2015-08-31 18:05:18', 0, 704, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d4640660', '泰来县', 'pub', '230224', 'cskefu', NULL, '297e1e874f83129d014f8334e9290281', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:18', '2015-08-31 18:05:18', 0, 705, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d4760661', '甘南县', 'pub', '230225', 'cskefu', NULL, '297e1e874f83129d014f8334e9290281', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:18', '2015-08-31 18:05:18', 0, 706, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d5b30662', '富裕县', 'pub', '230227', 'cskefu', NULL, '297e1e874f83129d014f8334e9290281', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:18', '2015-08-31 18:05:18', 0, 707, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d5c30663', '克山县', 'pub', '230229', 'cskefu', NULL, '297e1e874f83129d014f8334e9290281', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:18', '2015-08-31 18:05:18', 0, 708, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d5d10664', '克东县', 'pub', '230230', 'cskefu', NULL, '297e1e874f83129d014f8334e9290281', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:18', '2015-08-31 18:05:18', 0, 709, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d5df0665', '拜泉县', 'pub', '230231', 'cskefu', NULL, '297e1e874f83129d014f8334e9290281', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:18', '2015-08-31 18:05:18', 0, 710, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d5ee0666', '讷河市', 'pub', '230281', 'cskefu', NULL, '297e1e874f83129d014f8334e9290281', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:18', '2015-08-31 18:05:18', 0, 711, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d61f0667', '市辖区', 'pub', '230301', 'cskefu', NULL, '297e1e874f83129d014f8334e9390282', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:18', '2015-08-31 18:05:18', 0, 712, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d62f0668', '鸡冠区', 'pub', '230302', 'cskefu', NULL, '297e1e874f83129d014f8334e9390282', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:18', '2015-08-31 18:05:18', 0, 713, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d63f0669', '恒山区', 'pub', '230303', 'cskefu', NULL, '297e1e874f83129d014f8334e9390282', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:18', '2015-08-31 18:05:18', 0, 714, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d650066a', '滴道区', 'pub', '230304', 'cskefu', NULL, '297e1e874f83129d014f8334e9390282', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:18', '2015-08-31 18:05:18', 0, 715, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d65f066b', '梨树区', 'pub', '230305', 'cskefu', NULL, '297e1e874f83129d014f8334e9390282', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:18', '2015-08-31 18:05:18', 0, 716, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d670066c', '城子河区', 'pub', '230306', 'cskefu', NULL, '297e1e874f83129d014f8334e9390282', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:18', '2015-08-31 18:05:18', 0, 717, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d688066d', '麻山区', 'pub', '230307', 'cskefu', NULL, '297e1e874f83129d014f8334e9390282', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:18', '2015-08-31 18:05:18', 0, 718, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d69c066e', '鸡东县', 'pub', '230321', 'cskefu', NULL, '297e1e874f83129d014f8334e9390282', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:18', '2015-08-31 18:05:18', 0, 719, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d6ab066f', '虎林市', 'pub', '230381', 'cskefu', NULL, '297e1e874f83129d014f8334e9390282', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:18', '2015-08-31 18:05:18', 0, 720, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d6bd0670', '密山市', 'pub', '230382', 'cskefu', NULL, '297e1e874f83129d014f8334e9390282', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:18', '2015-08-31 18:05:18', 0, 721, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d81b0671', '市辖区', 'pub', '230401', 'cskefu', NULL, '297e1e874f83129d014f8334e9470283', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:19', '2015-08-31 18:05:19', 0, 722, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d82f0672', '向阳区', 'pub', '230402', 'cskefu', NULL, '297e1e874f83129d014f8334e9470283', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:19', '2015-08-31 18:05:19', 0, 723, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d8420673', '工农区', 'pub', '230403', 'cskefu', NULL, '297e1e874f83129d014f8334e9470283', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:19', '2015-08-31 18:05:19', 0, 724, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d8580674', '南山区', 'pub', '230404', 'cskefu', NULL, '297e1e874f83129d014f8334e9470283', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:19', '2015-08-31 18:05:19', 0, 725, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d86c0675', '兴安区', 'pub', '230405', 'cskefu', NULL, '297e1e874f83129d014f8334e9470283', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:19', '2015-08-31 18:05:19', 0, 726, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d8800676', '东山区', 'pub', '230406', 'cskefu', NULL, '297e1e874f83129d014f8334e9470283', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:19', '2015-08-31 18:05:19', 0, 727, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d8910677', '兴山区', 'pub', '230407', 'cskefu', NULL, '297e1e874f83129d014f8334e9470283', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:19', '2015-08-31 18:05:19', 0, 728, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d89f0678', '萝北县', 'pub', '230421', 'cskefu', NULL, '297e1e874f83129d014f8334e9470283', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:19', '2015-08-31 18:05:19', 0, 729, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d8ab0679', '绥滨县', 'pub', '230422', 'cskefu', NULL, '297e1e874f83129d014f8334e9470283', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:19', '2015-08-31 18:05:19', 0, 730, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d8db067a', '市辖区', 'pub', '230501', 'cskefu', NULL, '297e1e874f83129d014f8334e9570284', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:19', '2015-08-31 18:05:19', 0, 731, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d8eb067b', '尖山区', 'pub', '230502', 'cskefu', NULL, '297e1e874f83129d014f8334e9570284', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:19', '2015-08-31 18:05:19', 0, 732, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d8fc067c', '岭东区', 'pub', '230503', 'cskefu', NULL, '297e1e874f83129d014f8334e9570284', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:19', '2015-08-31 18:05:19', 0, 733, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d90d067d', '四方台区', 'pub', '230505', 'cskefu', NULL, '297e1e874f83129d014f8334e9570284', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:19', '2015-08-31 18:05:19', 0, 734, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d91b067e', '宝山区', 'pub', '230506', 'cskefu', NULL, '297e1e874f83129d014f8334e9570284', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:19', '2015-08-31 18:05:19', 0, 735, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337d92b067f', '集贤县', 'pub', '230521', 'cskefu', NULL, '297e1e874f83129d014f8334e9570284', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:19', '2015-08-31 18:05:19', 0, 736, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337da6e0680', '友谊县', 'pub', '230522', 'cskefu', NULL, '297e1e874f83129d014f8334e9570284', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:19', '2015-08-31 18:05:19', 0, 737, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337da810681', '宝清县', 'pub', '230523', 'cskefu', NULL, '297e1e874f83129d014f8334e9570284', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:19', '2015-08-31 18:05:19', 0, 738, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337da8e0682', '饶河县', 'pub', '230524', 'cskefu', NULL, '297e1e874f83129d014f8334e9570284', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:19', '2015-08-31 18:05:19', 0, 739, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337dabe0683', '市辖区', 'pub', '230601', 'cskefu', NULL, '297e1e874f83129d014f8334e9630285', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:19', '2015-08-31 18:05:19', 0, 740, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337dacd0684', '萨尔图区', 'pub', '230602', 'cskefu', NULL, '297e1e874f83129d014f8334e9630285', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:19', '2015-08-31 18:05:19', 0, 741, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337dadf0685', '龙凤区', 'pub', '230603', 'cskefu', NULL, '297e1e874f83129d014f8334e9630285', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:19', '2015-08-31 18:05:19', 0, 742, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337daed0686', '让胡路区', 'pub', '230604', 'cskefu', NULL, '297e1e874f83129d014f8334e9630285', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:19', '2015-08-31 18:05:19', 0, 743, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337dafb0687', '红岗区', 'pub', '230605', 'cskefu', NULL, '297e1e874f83129d014f8334e9630285', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:19', '2015-08-31 18:05:19', 0, 744, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337db090688', '大同区', 'pub', '230606', 'cskefu', NULL, '297e1e874f83129d014f8334e9630285', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:20', '2015-08-31 18:05:20', 0, 745, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337db1a0689', '肇州县', 'pub', '230621', 'cskefu', NULL, '297e1e874f83129d014f8334e9630285', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:20', '2015-08-31 18:05:20', 0, 746, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337db2a068a', '肇源县', 'pub', '230622', 'cskefu', NULL, '297e1e874f83129d014f8334e9630285', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:20', '2015-08-31 18:05:20', 0, 747, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337db40068b', '林甸县', 'pub', '230623', 'cskefu', NULL, '297e1e874f83129d014f8334e9630285', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:20', '2015-08-31 18:05:20', 0, 748, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337db4f068c', '杜尔伯特蒙古族自治县', 'pub', '230624', 'cskefu', NULL, '297e1e874f83129d014f8334e9630285', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:20', '2015-08-31 18:05:20', 0, 749, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337db7a068d', '市辖区', 'pub', '230701', 'cskefu', NULL, '297e1e874f83129d014f8334e9710286', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:20', '2015-08-31 18:05:20', 0, 750, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337dcb4068e', '伊春区', 'pub', '230702', 'cskefu', NULL, '297e1e874f83129d014f8334e9710286', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:20', '2015-08-31 18:05:20', 0, 751, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337dcc4068f', '南岔区', 'pub', '230703', 'cskefu', NULL, '297e1e874f83129d014f8334e9710286', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:20', '2015-08-31 18:05:20', 0, 752, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337dcd20690', '友好区', 'pub', '230704', 'cskefu', NULL, '297e1e874f83129d014f8334e9710286', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:20', '2015-08-31 18:05:20', 0, 753, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337dce30691', '西林区', 'pub', '230705', 'cskefu', NULL, '297e1e874f83129d014f8334e9710286', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:20', '2015-08-31 18:05:20', 0, 754, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337dcf20692', '翠峦区', 'pub', '230706', 'cskefu', NULL, '297e1e874f83129d014f8334e9710286', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:20', '2015-08-31 18:05:20', 0, 755, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337dd010693', '新青区', 'pub', '230707', 'cskefu', NULL, '297e1e874f83129d014f8334e9710286', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:20', '2015-08-31 18:05:20', 0, 756, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337dd0f0694', '美溪区', 'pub', '230708', 'cskefu', NULL, '297e1e874f83129d014f8334e9710286', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:20', '2015-08-31 18:05:20', 0, 757, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337dd1f0695', '金山屯区', 'pub', '230709', 'cskefu', NULL, '297e1e874f83129d014f8334e9710286', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:20', '2015-08-31 18:05:20', 0, 758, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337dd2c0696', '五营区', 'pub', '230710', 'cskefu', NULL, '297e1e874f83129d014f8334e9710286', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:20', '2015-08-31 18:05:20', 0, 759, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337dd3d0697', '乌马河区', 'pub', '230711', 'cskefu', NULL, '297e1e874f83129d014f8334e9710286', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:20', '2015-08-31 18:05:20', 0, 760, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337dd4d0698', '汤旺河区', 'pub', '230712', 'cskefu', NULL, '297e1e874f83129d014f8334e9710286', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:20', '2015-08-31 18:05:20', 0, 761, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337dd5c0699', '带岭区', 'pub', '230713', 'cskefu', NULL, '297e1e874f83129d014f8334e9710286', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:20', '2015-08-31 18:05:20', 0, 762, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337dd69069a', '乌伊岭区', 'pub', '230714', 'cskefu', NULL, '297e1e874f83129d014f8334e9710286', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:20', '2015-08-31 18:05:20', 0, 763, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337dd7b069b', '红星区', 'pub', '230715', 'cskefu', NULL, '297e1e874f83129d014f8334e9710286', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:20', '2015-08-31 18:05:20', 0, 764, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337dd89069c', '上甘岭区', 'pub', '230716', 'cskefu', NULL, '297e1e874f83129d014f8334e9710286', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:20', '2015-08-31 18:05:20', 0, 765, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337deca069d', '嘉荫县', 'pub', '230722', 'cskefu', NULL, '297e1e874f83129d014f8334e9710286', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:20', '2015-08-31 18:05:20', 0, 766, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337ded8069e', '铁力市', 'pub', '230781', 'cskefu', NULL, '297e1e874f83129d014f8334e9710286', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:20', '2015-08-31 18:05:20', 0, 767, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337df02069f', '市辖区', 'pub', '230801', 'cskefu', NULL, '297e1e874f83129d014f8334e97d0287', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:21', '2015-08-31 18:05:21', 0, 768, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337df1306a0', '永红区', 'pub', '230802', 'cskefu', NULL, '297e1e874f83129d014f8334e97d0287', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:21', '2015-08-31 18:05:21', 0, 769, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337df2106a1', '向阳区', 'pub', '230803', 'cskefu', NULL, '297e1e874f83129d014f8334e97d0287', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:21', '2015-08-31 18:05:21', 0, 770, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337df3006a2', '前进区', 'pub', '230804', 'cskefu', NULL, '297e1e874f83129d014f8334e97d0287', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:21', '2015-08-31 18:05:21', 0, 771, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337df4106a3', '东风区', 'pub', '230805', 'cskefu', NULL, '297e1e874f83129d014f8334e97d0287', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:21', '2015-08-31 18:05:21', 0, 772, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337df5106a4', '郊　区', 'pub', '230811', 'cskefu', NULL, '297e1e874f83129d014f8334e97d0287', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:21', '2015-08-31 18:05:21', 0, 773, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337df5e06a5', '桦南县', 'pub', '230822', 'cskefu', NULL, '297e1e874f83129d014f8334e97d0287', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:21', '2015-08-31 18:05:21', 0, 774, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337df6c06a6', '桦川县', 'pub', '230826', 'cskefu', NULL, '297e1e874f83129d014f8334e97d0287', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:21', '2015-08-31 18:05:21', 0, 775, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337df7a06a7', '汤原县', 'pub', '230828', 'cskefu', NULL, '297e1e874f83129d014f8334e97d0287', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:21', '2015-08-31 18:05:21', 0, 776, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337df8a06a8', '抚远县', 'pub', '230833', 'cskefu', NULL, '297e1e874f83129d014f8334e97d0287', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:21', '2015-08-31 18:05:21', 0, 777, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337df9806a9', '同江市', 'pub', '230881', 'cskefu', NULL, '297e1e874f83129d014f8334e97d0287', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:21', '2015-08-31 18:05:21', 0, 778, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337dfa706aa', '富锦市', 'pub', '230882', 'cskefu', NULL, '297e1e874f83129d014f8334e97d0287', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:21', '2015-08-31 18:05:21', 0, 779, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337dfd206ab', '市辖区', 'pub', '230901', 'cskefu', NULL, '297e1e874f83129d014f8334e98e0288', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:21', '2015-08-31 18:05:21', 0, 780, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e10b06ac', '新兴区', 'pub', '230902', 'cskefu', NULL, '297e1e874f83129d014f8334e98e0288', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:21', '2015-08-31 18:05:21', 0, 781, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e11906ad', '桃山区', 'pub', '230903', 'cskefu', NULL, '297e1e874f83129d014f8334e98e0288', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:21', '2015-08-31 18:05:21', 0, 782, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e12806ae', '茄子河区', 'pub', '230904', 'cskefu', NULL, '297e1e874f83129d014f8334e98e0288', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:21', '2015-08-31 18:05:21', 0, 783, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e13a06af', '勃利县', 'pub', '230921', 'cskefu', NULL, '297e1e874f83129d014f8334e98e0288', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:21', '2015-08-31 18:05:21', 0, 784, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e16606b0', '市辖区', 'pub', '231001', 'cskefu', NULL, '297e1e874f83129d014f8334e99a0289', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:21', '2015-08-31 18:05:21', 0, 785, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e17306b1', '东安区', 'pub', '231002', 'cskefu', NULL, '297e1e874f83129d014f8334e99a0289', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:21', '2015-08-31 18:05:21', 0, 786, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e18306b2', '阳明区', 'pub', '231003', 'cskefu', NULL, '297e1e874f83129d014f8334e99a0289', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:21', '2015-08-31 18:05:21', 0, 787, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e19206b3', '爱民区', 'pub', '231004', 'cskefu', NULL, '297e1e874f83129d014f8334e99a0289', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:21', '2015-08-31 18:05:21', 0, 788, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e1a306b4', '西安区', 'pub', '231005', 'cskefu', NULL, '297e1e874f83129d014f8334e99a0289', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:21', '2015-08-31 18:05:21', 0, 789, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e1b406b5', '东宁县', 'pub', '231024', 'cskefu', NULL, '297e1e874f83129d014f8334e99a0289', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:21', '2015-08-31 18:05:21', 0, 790, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e1c106b6', '林口县', 'pub', '231025', 'cskefu', NULL, '297e1e874f83129d014f8334e99a0289', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:21', '2015-08-31 18:05:21', 0, 791, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e1d606b8', '绥芬河市', 'pub', '231081', 'cskefu', NULL, '297e1e874f83129d014f8334e99a0289', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:21', '2015-08-31 18:05:21', 0, 792, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e30f06b9', '海林市', 'pub', '231083', 'cskefu', NULL, '297e1e874f83129d014f8334e99a0289', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:22', '2015-08-31 18:05:22', 0, 793, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e31d06ba', '宁安市', 'pub', '231084', 'cskefu', NULL, '297e1e874f83129d014f8334e99a0289', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:22', '2015-08-31 18:05:22', 0, 794, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e33406bb', '穆棱市', 'pub', '231085', 'cskefu', NULL, '297e1e874f83129d014f8334e99a0289', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:22', '2015-08-31 18:05:22', 0, 795, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e36006bc', '市辖区', 'pub', '231101', 'cskefu', NULL, '297e1e874f83129d014f8334e9a8028a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:22', '2015-08-31 18:05:22', 0, 796, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e36e06bd', '爱辉区', 'pub', '231102', 'cskefu', NULL, '297e1e874f83129d014f8334e9a8028a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:22', '2015-08-31 18:05:22', 0, 797, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e37b06be', '嫩江县', 'pub', '231121', 'cskefu', NULL, '297e1e874f83129d014f8334e9a8028a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:22', '2015-08-31 18:05:22', 0, 798, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e38906bf', '逊克县', 'pub', '231123', 'cskefu', NULL, '297e1e874f83129d014f8334e9a8028a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:22', '2015-08-31 18:05:22', 0, 799, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e39906c0', '孙吴县', 'pub', '231124', 'cskefu', NULL, '297e1e874f83129d014f8334e9a8028a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:22', '2015-08-31 18:05:22', 0, 800, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e3a806c1', '北安市', 'pub', '231181', 'cskefu', NULL, '297e1e874f83129d014f8334e9a8028a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:22', '2015-08-31 18:05:22', 0, 801, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e3b706c2', '五大连池市', 'pub', '231182', 'cskefu', NULL, '297e1e874f83129d014f8334e9a8028a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:22', '2015-08-31 18:05:22', 0, 802, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e50a06c3', '市辖区', 'pub', '231201', 'cskefu', NULL, '297e1e874f83129d014f8334e9b5028b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:22', '2015-08-31 18:05:22', 0, 803, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e51806c4', '北林区', 'pub', '231202', 'cskefu', NULL, '297e1e874f83129d014f8334e9b5028b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:22', '2015-08-31 18:05:22', 0, 804, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e52606c5', '望奎县', 'pub', '231221', 'cskefu', NULL, '297e1e874f83129d014f8334e9b5028b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:22', '2015-08-31 18:05:22', 0, 805, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e53806c6', '兰西县', 'pub', '231222', 'cskefu', NULL, '297e1e874f83129d014f8334e9b5028b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:22', '2015-08-31 18:05:22', 0, 806, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e54706c7', '青冈县', 'pub', '231223', 'cskefu', NULL, '297e1e874f83129d014f8334e9b5028b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:22', '2015-08-31 18:05:22', 0, 807, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e55406c8', '庆安县', 'pub', '231224', 'cskefu', NULL, '297e1e874f83129d014f8334e9b5028b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:22', '2015-08-31 18:05:22', 0, 808, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e56306c9', '明水县', 'pub', '231225', 'cskefu', NULL, '297e1e874f83129d014f8334e9b5028b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:22', '2015-08-31 18:05:22', 0, 809, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e57306ca', '绥棱县', 'pub', '231226', 'cskefu', NULL, '297e1e874f83129d014f8334e9b5028b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:22', '2015-08-31 18:05:22', 0, 810, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e58006cb', '安达市', 'pub', '231281', 'cskefu', NULL, '297e1e874f83129d014f8334e9b5028b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:22', '2015-08-31 18:05:22', 0, 811, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e58d06cc', '肇东市', 'pub', '231282', 'cskefu', NULL, '297e1e874f83129d014f8334e9b5028b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:22', '2015-08-31 18:05:22', 0, 812, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e59b06cd', '海伦市', 'pub', '231283', 'cskefu', NULL, '297e1e874f83129d014f8334e9b5028b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:22', '2015-08-31 18:05:22', 0, 813, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e5c306ce', '呼玛县', 'pub', '232721', 'cskefu', NULL, '297e1e874f83129d014f8334e9c4028c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:22', '2015-08-31 18:05:22', 0, 814, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e70106cf', '塔河县', 'pub', '232722', 'cskefu', NULL, '297e1e874f83129d014f8334e9c4028c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:23', '2015-08-31 18:05:23', 0, 815, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e70f06d0', '漠河县', 'pub', '232723', 'cskefu', NULL, '297e1e874f83129d014f8334e9c4028c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:23', '2015-08-31 18:05:23', 0, 816, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e73c06d1', '黄浦区', 'pub', '310101', 'cskefu', NULL, '297e1e874f83129d014f8334e9e5028d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:23', '2015-08-31 18:05:23', 0, 817, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e74d06d2', '卢湾区', 'pub', '310103', 'cskefu', NULL, '297e1e874f83129d014f8334e9e5028d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:23', '2015-08-31 18:05:23', 0, 818, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e75b06d3', '徐汇区', 'pub', '310104', 'cskefu', NULL, '297e1e874f83129d014f8334e9e5028d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:23', '2015-08-31 18:05:23', 0, 819, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e76906d4', '长宁区', 'pub', '310105', 'cskefu', NULL, '297e1e874f83129d014f8334e9e5028d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:23', '2015-08-31 18:05:23', 0, 820, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e77806d5', '静安区', 'pub', '310106', 'cskefu', NULL, '297e1e874f83129d014f8334e9e5028d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:23', '2015-08-31 18:05:23', 0, 821, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e78606d6', '普陀区', 'pub', '310107', 'cskefu', NULL, '297e1e874f83129d014f8334e9e5028d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:23', '2015-08-31 18:05:23', 0, 822, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e79506d7', '闸北区', 'pub', '310108', 'cskefu', NULL, '297e1e874f83129d014f8334e9e5028d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:23', '2015-08-31 18:05:23', 0, 823, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e7a506d8', '虹口区', 'pub', '310109', 'cskefu', NULL, '297e1e874f83129d014f8334e9e5028d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:23', '2015-08-31 18:05:23', 0, 824, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e7b306d9', '杨浦区', 'pub', '310110', 'cskefu', NULL, '297e1e874f83129d014f8334e9e5028d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:23', '2015-08-31 18:05:23', 0, 825, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e7c106da', '闵行区', 'pub', '310112', 'cskefu', NULL, '297e1e874f83129d014f8334e9e5028d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:23', '2015-08-31 18:05:23', 0, 826, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e7cf06db', '宝山区', 'pub', '310113', 'cskefu', NULL, '297e1e874f83129d014f8334e9e5028d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:23', '2015-08-31 18:05:23', 0, 827, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e7df06dc', '嘉定区', 'pub', '310114', 'cskefu', NULL, '297e1e874f83129d014f8334e9e5028d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:23', '2015-08-31 18:05:23', 0, 828, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e7ed06dd', '浦东新区', 'pub', '310115', 'cskefu', NULL, '297e1e874f83129d014f8334e9e5028d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:23', '2015-08-31 18:05:23', 0, 829, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e7fe06de', '金山区', 'pub', '310116', 'cskefu', NULL, '297e1e874f83129d014f8334e9e5028d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:23', '2015-08-31 18:05:23', 0, 830, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e93a06df', '松江区', 'pub', '310117', 'cskefu', NULL, '297e1e874f83129d014f8334e9e5028d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:23', '2015-08-31 18:05:23', 0, 831, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e94d06e0', '青浦区', 'pub', '310118', 'cskefu', NULL, '297e1e874f83129d014f8334e9e5028d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:23', '2015-08-31 18:05:23', 0, 832, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e95b06e1', '南汇区', 'pub', '310119', 'cskefu', NULL, '297e1e874f83129d014f8334e9e5028d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:23', '2015-08-31 18:05:23', 0, 833, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e96b06e2', '奉贤区', 'pub', '310120', 'cskefu', NULL, '297e1e874f83129d014f8334e9e5028d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:23', '2015-08-31 18:05:23', 0, 834, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e99506e3', '崇明县', 'pub', '310230', 'cskefu', NULL, '297e1e874f83129d014f8334e9f3028e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:23', '2015-08-31 18:05:23', 0, 835, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e9c206e4', '市辖区', 'pub', '320101', 'cskefu', NULL, '297e1e874f83129d014f8334ea23028f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:23', '2015-08-31 18:05:23', 0, 836, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e9d106e5', '玄武区', 'pub', '320102', 'cskefu', NULL, '297e1e874f83129d014f8334ea23028f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:23', '2015-08-31 18:05:23', 0, 837, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e9de06e6', '白下区', 'pub', '320103', 'cskefu', NULL, '297e1e874f83129d014f8334ea23028f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:23', '2015-08-31 18:05:23', 0, 838, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e9eb06e7', '秦淮区', 'pub', '320104', 'cskefu', NULL, '297e1e874f83129d014f8334ea23028f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:23', '2015-08-31 18:05:23', 0, 839, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337e9f706e8', '建邺区', 'pub', '320105', 'cskefu', NULL, '297e1e874f83129d014f8334ea23028f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:23', '2015-08-31 18:05:23', 0, 840, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337ea0506e9', '鼓楼区', 'pub', '320106', 'cskefu', NULL, '297e1e874f83129d014f8334ea23028f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:23', '2015-08-31 18:05:23', 0, 841, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337eb3f06ea', '下关区', 'pub', '320107', 'cskefu', NULL, '297e1e874f83129d014f8334ea23028f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:24', '2015-08-31 18:05:24', 0, 842, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337eb4d06eb', '浦口区', 'pub', '320111', 'cskefu', NULL, '297e1e874f83129d014f8334ea23028f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:24', '2015-08-31 18:05:24', 0, 843, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337eb5906ec', '栖霞区', 'pub', '320113', 'cskefu', NULL, '297e1e874f83129d014f8334ea23028f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:24', '2015-08-31 18:05:24', 0, 844, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337eb6506ed', '雨花台区', 'pub', '320114', 'cskefu', NULL, '297e1e874f83129d014f8334ea23028f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:24', '2015-08-31 18:05:24', 0, 845, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337eb7206ee', '江宁区', 'pub', '320115', 'cskefu', NULL, '297e1e874f83129d014f8334ea23028f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:24', '2015-08-31 18:05:24', 0, 846, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337eb8006ef', '六合区', 'pub', '320116', 'cskefu', NULL, '297e1e874f83129d014f8334ea23028f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:24', '2015-08-31 18:05:24', 0, 847, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337eb8f06f0', '溧水县', 'pub', '320124', 'cskefu', NULL, '297e1e874f83129d014f8334ea23028f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:24', '2015-08-31 18:05:24', 0, 848, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337eb9b06f1', '高淳县', 'pub', '320125', 'cskefu', NULL, '297e1e874f83129d014f8334ea23028f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:24', '2015-08-31 18:05:24', 0, 849, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337ebc406f2', '市辖区', 'pub', '320201', 'cskefu', NULL, '297e1e874f83129d014f8334ea320290', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:24', '2015-08-31 18:05:24', 0, 850, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337ebd206f3', '崇安区', 'pub', '320202', 'cskefu', NULL, '297e1e874f83129d014f8334ea320290', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:24', '2015-08-31 18:05:24', 0, 851, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337ebdf06f4', '南长区', 'pub', '320203', 'cskefu', NULL, '297e1e874f83129d014f8334ea320290', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:24', '2015-08-31 18:05:24', 0, 852, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337ebeb06f5', '北塘区', 'pub', '320204', 'cskefu', NULL, '297e1e874f83129d014f8334ea320290', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:24', '2015-08-31 18:05:24', 0, 853, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337ebf906f6', '锡山区', 'pub', '320205', 'cskefu', NULL, '297e1e874f83129d014f8334ea320290', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:24', '2015-08-31 18:05:24', 0, 854, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337ed3106f7', '惠山区', 'pub', '320206', 'cskefu', NULL, '297e1e874f83129d014f8334ea320290', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:24', '2015-08-31 18:05:24', 0, 855, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337ed4306f8', '滨湖区', 'pub', '320211', 'cskefu', NULL, '297e1e874f83129d014f8334ea320290', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:24', '2015-08-31 18:05:24', 0, 856, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337ed5806f9', '江阴市', 'pub', '320281', 'cskefu', NULL, '297e1e874f83129d014f8334ea320290', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:24', '2015-08-31 18:05:24', 0, 857, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337ed6606fa', '宜兴市', 'pub', '320282', 'cskefu', NULL, '297e1e874f83129d014f8334ea320290', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:24', '2015-08-31 18:05:24', 0, 858, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337ed8f06fb', '市辖区', 'pub', '320301', 'cskefu', NULL, '297e1e874f83129d014f8334ea430291', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:24', '2015-08-31 18:05:24', 0, 859, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337ed9c06fc', '鼓楼区', 'pub', '320302', 'cskefu', NULL, '297e1e874f83129d014f8334ea430291', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:24', '2015-08-31 18:05:24', 0, 860, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337eda906fd', '云龙区', 'pub', '320303', 'cskefu', NULL, '297e1e874f83129d014f8334ea430291', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:24', '2015-08-31 18:05:24', 0, 861, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337edb506fe', '九里区', 'pub', '320304', 'cskefu', NULL, '297e1e874f83129d014f8334ea430291', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:24', '2015-08-31 18:05:24', 0, 862, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337edc506ff', '贾汪区', 'pub', '320305', 'cskefu', NULL, '297e1e874f83129d014f8334ea430291', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:24', '2015-08-31 18:05:24', 0, 863, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337edd30700', '泉山区', 'pub', '320311', 'cskefu', NULL, '297e1e874f83129d014f8334ea430291', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:24', '2015-08-31 18:05:24', 0, 864, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337ede10701', '丰　县', 'pub', '320321', 'cskefu', NULL, '297e1e874f83129d014f8334ea430291', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:24', '2015-08-31 18:05:24', 0, 865, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337edee0702', '沛　县', 'pub', '320322', 'cskefu', NULL, '297e1e874f83129d014f8334ea430291', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:24', '2015-08-31 18:05:24', 0, 866, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337edfb0703', '铜山县', 'pub', '320323', 'cskefu', NULL, '297e1e874f83129d014f8334ea430291', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:24', '2015-08-31 18:05:24', 0, 867, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337ef3d0704', '睢宁县', 'pub', '320324', 'cskefu', NULL, '297e1e874f83129d014f8334ea430291', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:25', '2015-08-31 18:05:25', 0, 868, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337ef4d0705', '新沂市', 'pub', '320381', 'cskefu', NULL, '297e1e874f83129d014f8334ea430291', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:25', '2015-08-31 18:05:25', 0, 869, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337ef5a0706', '邳州市', 'pub', '320382', 'cskefu', NULL, '297e1e874f83129d014f8334ea430291', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:25', '2015-08-31 18:05:25', 0, 870, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337ef840707', '市辖区', 'pub', '320401', 'cskefu', NULL, '297e1e874f83129d014f8334ea510292', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:25', '2015-08-31 18:05:25', 0, 871, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337ef910708', '天宁区', 'pub', '320402', 'cskefu', NULL, '297e1e874f83129d014f8334ea510292', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:25', '2015-08-31 18:05:25', 0, 872, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337efa10709', '钟楼区', 'pub', '320404', 'cskefu', NULL, '297e1e874f83129d014f8334ea510292', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:25', '2015-08-31 18:05:25', 0, 873, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337efaf070a', '戚墅堰区', 'pub', '320405', 'cskefu', NULL, '297e1e874f83129d014f8334ea510292', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:25', '2015-08-31 18:05:25', 0, 874, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337efc3070b', '新北区', 'pub', '320411', 'cskefu', NULL, '297e1e874f83129d014f8334ea510292', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:25', '2015-08-31 18:05:25', 0, 875, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337efd3070c', '武进区', 'pub', '320412', 'cskefu', NULL, '297e1e874f83129d014f8334ea510292', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:25', '2015-08-31 18:05:25', 0, 876, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337efe1070d', '溧阳市', 'pub', '320481', 'cskefu', NULL, '297e1e874f83129d014f8334ea510292', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:25', '2015-08-31 18:05:25', 0, 877, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337eff1070e', '金坛市', 'pub', '320482', 'cskefu', NULL, '297e1e874f83129d014f8334ea510292', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:25', '2015-08-31 18:05:25', 0, 878, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337f01c070f', '市辖区', 'pub', '320501', 'cskefu', NULL, '297e1e874f83129d014f8334ea5e0293', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:25', '2015-08-31 18:05:25', 0, 879, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337f0280710', '沧浪区', 'pub', '320502', 'cskefu', NULL, '297e1e874f83129d014f8334ea5e0293', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:25', '2015-08-31 18:05:25', 0, 880, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337f03e0711', '平江区', 'pub', '320503', 'cskefu', NULL, '297e1e874f83129d014f8334ea5e0293', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:25', '2015-08-31 18:05:25', 0, 881, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337f17a0712', '金阊区', 'pub', '320504', 'cskefu', NULL, '297e1e874f83129d014f8334ea5e0293', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:25', '2015-08-31 18:05:25', 0, 882, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337f1890713', '虎丘区', 'pub', '320505', 'cskefu', NULL, '297e1e874f83129d014f8334ea5e0293', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:25', '2015-08-31 18:05:25', 0, 883, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337f1960714', '吴中区', 'pub', '320506', 'cskefu', NULL, '297e1e874f83129d014f8334ea5e0293', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:25', '2015-08-31 18:05:25', 0, 884, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337f1a50715', '相城区', 'pub', '320507', 'cskefu', NULL, '297e1e874f83129d014f8334ea5e0293', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:25', '2015-08-31 18:05:25', 0, 885, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337f1b40716', '常熟市', 'pub', '320581', 'cskefu', NULL, '297e1e874f83129d014f8334ea5e0293', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:25', '2015-08-31 18:05:25', 0, 886, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337f1c20717', '张家港市', 'pub', '320582', 'cskefu', NULL, '297e1e874f83129d014f8334ea5e0293', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:25', '2015-08-31 18:05:25', 0, 887, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337f1d20718', '昆山市', 'pub', '320583', 'cskefu', NULL, '297e1e874f83129d014f8334ea5e0293', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:25', '2015-08-31 18:05:25', 0, 888, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337f1df0719', '吴江市', 'pub', '320584', 'cskefu', NULL, '297e1e874f83129d014f8334ea5e0293', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:25', '2015-08-31 18:05:25', 0, 889, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337f1ee071a', '太仓市', 'pub', '320585', 'cskefu', NULL, '297e1e874f83129d014f8334ea5e0293', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:25', '2015-08-31 18:05:25', 0, 890, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337f21a071b', '市辖区', 'pub', '320601', 'cskefu', NULL, '297e1e874f83129d014f8334ea6d0294', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:25', '2015-08-31 18:05:25', 0, 891, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337f227071c', '崇川区', 'pub', '320602', 'cskefu', NULL, '297e1e874f83129d014f8334ea6d0294', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:25', '2015-08-31 18:05:25', 0, 892, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337f236071d', '港闸区', 'pub', '320611', 'cskefu', NULL, '297e1e874f83129d014f8334ea6d0294', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:25', '2015-08-31 18:05:25', 0, 893, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337f24b071e', '海安县', 'pub', '320621', 'cskefu', NULL, '297e1e874f83129d014f8334ea6d0294', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:25', '2015-08-31 18:05:25', 0, 894, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337f385071f', '如东县', 'pub', '320623', 'cskefu', NULL, '297e1e874f83129d014f8334ea6d0294', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:26', '2015-08-31 18:05:26', 0, 895, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337f3920720', '启东市', 'pub', '320681', 'cskefu', NULL, '297e1e874f83129d014f8334ea6d0294', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:26', '2015-08-31 18:05:26', 0, 896, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337f3a00721', '如皋市', 'pub', '320682', 'cskefu', NULL, '297e1e874f83129d014f8334ea6d0294', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:26', '2015-08-31 18:05:26', 0, 897, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337f3b40722', '通州市', 'pub', '320683', 'cskefu', NULL, '297e1e874f83129d014f8334ea6d0294', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:26', '2015-08-31 18:05:26', 0, 898, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337f3c20723', '海门市', 'pub', '320684', 'cskefu', NULL, '297e1e874f83129d014f8334ea6d0294', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:26', '2015-08-31 18:05:26', 0, 899, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337f3ec0724', '市辖区', 'pub', '320701', 'cskefu', NULL, '297e1e874f83129d014f8334ea790295', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:26', '2015-08-31 18:05:26', 0, 900, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337f3fa0725', '连云区', 'pub', '320703', 'cskefu', NULL, '297e1e874f83129d014f8334ea790295', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:26', '2015-08-31 18:05:26', 0, 901, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337f4070726', '新浦区', 'pub', '320705', 'cskefu', NULL, '297e1e874f83129d014f8334ea790295', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:26', '2015-08-31 18:05:26', 0, 902, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337f4150727', '海州区', 'pub', '320706', 'cskefu', NULL, '297e1e874f83129d014f8334ea790295', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:26', '2015-08-31 18:05:26', 0, 903, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337f4260728', '赣榆县', 'pub', '320721', 'cskefu', NULL, '297e1e874f83129d014f8334ea790295', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:26', '2015-08-31 18:05:26', 0, 904, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337f4340729', '东海县', 'pub', '320722', 'cskefu', NULL, '297e1e874f83129d014f8334ea790295', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:26', '2015-08-31 18:05:26', 0, 905, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337f445072a', '灌云县', 'pub', '320723', 'cskefu', NULL, '297e1e874f83129d014f8334ea790295', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:26', '2015-08-31 18:05:26', 0, 906, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337f453072b', '灌南县', 'pub', '320724', 'cskefu', NULL, '297e1e874f83129d014f8334ea790295', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:26', '2015-08-31 18:05:26', 0, 907, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337f483072c', '市辖区', 'pub', '320801', 'cskefu', NULL, '297e1e874f83129d014f8334ea850296', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:26', '2015-08-31 18:05:26', 0, 908, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337f5bf072e', '清河区', 'pub', '320802', 'cskefu', NULL, '297e1e874f83129d014f8334ea850296', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:26', '2015-08-31 18:05:26', 0, 909, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337f5d4072f', '楚州区', 'pub', '320803', 'cskefu', NULL, '297e1e874f83129d014f8334ea850296', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:26', '2015-08-31 18:05:26', 0, 910, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337f5e30730', '淮阴区', 'pub', '320804', 'cskefu', NULL, '297e1e874f83129d014f8334ea850296', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:26', '2015-08-31 18:05:26', 0, 911, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337f5ef0731', '清浦区', 'pub', '320811', 'cskefu', NULL, '297e1e874f83129d014f8334ea850296', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:26', '2015-08-31 18:05:26', 0, 912, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337f5fe0732', '涟水县', 'pub', '320826', 'cskefu', NULL, '297e1e874f83129d014f8334ea850296', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:26', '2015-08-31 18:05:26', 0, 913, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337f60d0733', '洪泽县', 'pub', '320829', 'cskefu', NULL, '297e1e874f83129d014f8334ea850296', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:26', '2015-08-31 18:05:26', 0, 914, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337f61b0734', '盱眙县', 'pub', '320830', 'cskefu', NULL, '297e1e874f83129d014f8334ea850296', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:26', '2015-08-31 18:05:26', 0, 915, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337f6290735', '金湖县', 'pub', '320831', 'cskefu', NULL, '297e1e874f83129d014f8334ea850296', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:26', '2015-08-31 18:05:26', 0, 916, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337f6520736', '市辖区', 'pub', '320901', 'cskefu', NULL, '297e1e874f83129d014f8334ea940297', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:26', '2015-08-31 18:05:26', 0, 917, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337f65f0737', '亭湖区', 'pub', '320902', 'cskefu', NULL, '297e1e874f83129d014f8334ea940297', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:27', '2015-08-31 18:05:27', 0, 918, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337f66d0738', '盐都区', 'pub', '320903', 'cskefu', NULL, '297e1e874f83129d014f8334ea940297', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:27', '2015-08-31 18:05:27', 0, 919, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337f7a70739', '响水县', 'pub', '320921', 'cskefu', NULL, '297e1e874f83129d014f8334ea940297', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:27', '2015-08-31 18:05:27', 0, 920, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337f7b6073a', '滨海县', 'pub', '320922', 'cskefu', NULL, '297e1e874f83129d014f8334ea940297', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:27', '2015-08-31 18:05:27', 0, 921, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337f7c7073b', '阜宁县', 'pub', '320923', 'cskefu', NULL, '297e1e874f83129d014f8334ea940297', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:27', '2015-08-31 18:05:27', 0, 922, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337f7d7073c', '射阳县', 'pub', '320924', 'cskefu', NULL, '297e1e874f83129d014f8334ea940297', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:27', '2015-08-31 18:05:27', 0, 923, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337f7e4073d', '建湖县', 'pub', '320925', 'cskefu', NULL, '297e1e874f83129d014f8334ea940297', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:27', '2015-08-31 18:05:27', 0, 924, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337f7fe073e', '东台市', 'pub', '320981', 'cskefu', NULL, '297e1e874f83129d014f8334ea940297', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:27', '2015-08-31 18:05:27', 0, 925, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337f80c073f', '大丰市', 'pub', '320982', 'cskefu', NULL, '297e1e874f83129d014f8334ea940297', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:27', '2015-08-31 18:05:27', 0, 926, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337f8380740', '市辖区', 'pub', '321001', 'cskefu', NULL, '297e1e874f83129d014f8334eab00298', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:27', '2015-08-31 18:05:27', 0, 927, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337f8460741', '广陵区', 'pub', '321002', 'cskefu', NULL, '297e1e874f83129d014f8334eab00298', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:27', '2015-08-31 18:05:27', 0, 928, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337f8550742', '邗江区', 'pub', '321003', 'cskefu', NULL, '297e1e874f83129d014f8334eab00298', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:27', '2015-08-31 18:05:27', 0, 929, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337f8610743', '郊　区', 'pub', '321011', 'cskefu', NULL, '297e1e874f83129d014f8334eab00298', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:27', '2015-08-31 18:05:27', 0, 930, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337f86f0744', '宝应县', 'pub', '321023', 'cskefu', NULL, '297e1e874f83129d014f8334eab00298', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:27', '2015-08-31 18:05:27', 0, 931, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337f8800745', '仪征市', 'pub', '321081', 'cskefu', NULL, '297e1e874f83129d014f8334eab00298', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:27', '2015-08-31 18:05:27', 0, 932, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337f9bb0746', '高邮市', 'pub', '321084', 'cskefu', NULL, '297e1e874f83129d014f8334eab00298', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:27', '2015-08-31 18:05:27', 0, 933, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337f9ca0747', '江都市', 'pub', '321088', 'cskefu', NULL, '297e1e874f83129d014f8334eab00298', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:27', '2015-08-31 18:05:27', 0, 934, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337f9f70748', '市辖区', 'pub', '321101', 'cskefu', NULL, '297e1e874f83129d014f8334eaca0299', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:27', '2015-08-31 18:05:27', 0, 935, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337fa090749', '京口区', 'pub', '321102', 'cskefu', NULL, '297e1e874f83129d014f8334eaca0299', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:27', '2015-08-31 18:05:27', 0, 936, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337fa1d074a', '润州区', 'pub', '321111', 'cskefu', NULL, '297e1e874f83129d014f8334eaca0299', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:27', '2015-08-31 18:05:27', 0, 937, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337fa2b074b', '丹徒区', 'pub', '321112', 'cskefu', NULL, '297e1e874f83129d014f8334eaca0299', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:27', '2015-08-31 18:05:27', 0, 938, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337fa39074c', '丹阳市', 'pub', '321181', 'cskefu', NULL, '297e1e874f83129d014f8334eaca0299', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:27', '2015-08-31 18:05:27', 0, 939, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337fa46074d', '扬中市', 'pub', '321182', 'cskefu', NULL, '297e1e874f83129d014f8334eaca0299', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:28', '2015-08-31 18:05:28', 0, 940, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337fa54074e', '句容市', 'pub', '321183', 'cskefu', NULL, '297e1e874f83129d014f8334eaca0299', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:28', '2015-08-31 18:05:28', 0, 941, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337fa82074f', '市辖区', 'pub', '321201', 'cskefu', NULL, '297e1e874f83129d014f8334eaed029a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:28', '2015-08-31 18:05:28', 0, 942, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337fa940750', '海陵区', 'pub', '321202', 'cskefu', NULL, '297e1e874f83129d014f8334eaed029a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:28', '2015-08-31 18:05:28', 0, 943, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337faa10751', '高港区', 'pub', '321203', 'cskefu', NULL, '297e1e874f83129d014f8334eaed029a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:28', '2015-08-31 18:05:28', 0, 944, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337fab00752', '兴化市', 'pub', '321281', 'cskefu', NULL, '297e1e874f83129d014f8334eaed029a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:28', '2015-08-31 18:05:28', 0, 945, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337fabe0753', '靖江市', 'pub', '321282', 'cskefu', NULL, '297e1e874f83129d014f8334eaed029a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:28', '2015-08-31 18:05:28', 0, 946, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337fbfb0754', '泰兴市', 'pub', '321283', 'cskefu', NULL, '297e1e874f83129d014f8334eaed029a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:28', '2015-08-31 18:05:28', 0, 947, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337fc080755', '姜堰市', 'pub', '321284', 'cskefu', NULL, '297e1e874f83129d014f8334eaed029a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:28', '2015-08-31 18:05:28', 0, 948, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337fc370756', '市辖区', 'pub', '321301', 'cskefu', NULL, '297e1e874f83129d014f8334eb01029b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:28', '2015-08-31 18:05:28', 0, 949, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337fc450757', '宿城区', 'pub', '321302', 'cskefu', NULL, '297e1e874f83129d014f8334eb01029b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:28', '2015-08-31 18:05:28', 0, 950, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337fc550758', '宿豫区', 'pub', '321311', 'cskefu', NULL, '297e1e874f83129d014f8334eb01029b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:28', '2015-08-31 18:05:28', 0, 951, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337fc640759', '沭阳县', 'pub', '321322', 'cskefu', NULL, '297e1e874f83129d014f8334eb01029b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:28', '2015-08-31 18:05:28', 0, 952, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337fc73075a', '泗阳县', 'pub', '321323', 'cskefu', NULL, '297e1e874f83129d014f8334eb01029b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:28', '2015-08-31 18:05:28', 0, 953, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337fc80075b', '泗洪县', 'pub', '321324', 'cskefu', NULL, '297e1e874f83129d014f8334eb01029b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:28', '2015-08-31 18:05:28', 0, 954, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337fcb3075c', '市辖区', 'pub', '330101', 'cskefu', NULL, '297e1e874f83129d014f8334eb38029c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:28', '2015-08-31 18:05:28', 0, 955, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337fcc4075d', '上城区', 'pub', '330102', 'cskefu', NULL, '297e1e874f83129d014f8334eb38029c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:28', '2015-08-31 18:05:28', 0, 956, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337fcd1075e', '下城区', 'pub', '330103', 'cskefu', NULL, '297e1e874f83129d014f8334eb38029c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:28', '2015-08-31 18:05:28', 0, 957, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337fe0e075f', '江干区', 'pub', '330104', 'cskefu', NULL, '297e1e874f83129d014f8334eb38029c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:28', '2015-08-31 18:05:28', 0, 958, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337fe1c0760', '拱墅区', 'pub', '330105', 'cskefu', NULL, '297e1e874f83129d014f8334eb38029c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:28', '2015-08-31 18:05:28', 0, 959, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337fe330761', '西湖区', 'pub', '330106', 'cskefu', NULL, '297e1e874f83129d014f8334eb38029c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', 0, 960, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337fe480762', '滨江区', 'pub', '330108', 'cskefu', NULL, '297e1e874f83129d014f8334eb38029c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', 0, 961, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337fe580763', '萧山区', 'pub', '330109', 'cskefu', NULL, '297e1e874f83129d014f8334eb38029c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', 0, 962, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337fe660764', '余杭区', 'pub', '330110', 'cskefu', NULL, '297e1e874f83129d014f8334eb38029c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', 0, 963, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337fe760765', '桐庐县', 'pub', '330122', 'cskefu', NULL, '297e1e874f83129d014f8334eb38029c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', 0, 964, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337fe860766', '淳安县', 'pub', '330127', 'cskefu', NULL, '297e1e874f83129d014f8334eb38029c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', 0, 965, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337fe990767', '建德市', 'pub', '330182', 'cskefu', NULL, '297e1e874f83129d014f8334eb38029c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', 0, 966, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337fead0768', '富阳市', 'pub', '330183', 'cskefu', NULL, '297e1e874f83129d014f8334eb38029c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', 0, 967, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337febc0769', '临安市', 'pub', '330185', 'cskefu', NULL, '297e1e874f83129d014f8334eb38029c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', 0, 968, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337fee3076a', '市辖区', 'pub', '330201', 'cskefu', NULL, '297e1e874f83129d014f8334eb45029d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', 0, 969, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337fef4076b', '海曙区', 'pub', '330203', 'cskefu', NULL, '297e1e874f83129d014f8334eb45029d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', 0, 970, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337ff0c076c', '江东区', 'pub', '330204', 'cskefu', NULL, '297e1e874f83129d014f8334eb45029d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', 0, 971, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337ff1a076d', '江北区', 'pub', '330205', 'cskefu', NULL, '297e1e874f83129d014f8334eb45029d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', 0, 972, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8337ff2e076e', '北仑区', 'pub', '330206', 'cskefu', NULL, '297e1e874f83129d014f8334eb45029d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', 0, 973, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83380078076f', '镇海区', 'pub', '330211', 'cskefu', NULL, '297e1e874f83129d014f8334eb45029d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', 0, 974, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833800860770', '鄞州区', 'pub', '330212', 'cskefu', NULL, '297e1e874f83129d014f8334eb45029d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', 0, 975, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338009b0771', '象山县', 'pub', '330225', 'cskefu', NULL, '297e1e874f83129d014f8334eb45029d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', 0, 976, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833800a90772', '宁海县', 'pub', '330226', 'cskefu', NULL, '297e1e874f83129d014f8334eb45029d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', 0, 977, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833800ba0773', '余姚市', 'pub', '330281', 'cskefu', NULL, '297e1e874f83129d014f8334eb45029d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', 0, 978, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833800c90774', '慈溪市', 'pub', '330282', 'cskefu', NULL, '297e1e874f83129d014f8334eb45029d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', 0, 979, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833800de0775', '奉化市', 'pub', '330283', 'cskefu', NULL, '297e1e874f83129d014f8334eb45029d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', 0, 980, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338010d0776', '市辖区', 'pub', '330301', 'cskefu', NULL, '297e1e874f83129d014f8334eb53029e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', 0, 981, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338011d0777', '鹿城区', 'pub', '330302', 'cskefu', NULL, '297e1e874f83129d014f8334eb53029e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', 0, 982, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338012c0778', '龙湾区', 'pub', '330303', 'cskefu', NULL, '297e1e874f83129d014f8334eb53029e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', 0, 983, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833801390779', '瓯海区', 'pub', '330304', 'cskefu', NULL, '297e1e874f83129d014f8334eb53029e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', 0, 984, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83380149077a', '洞头县', 'pub', '330322', 'cskefu', NULL, '297e1e874f83129d014f8334eb53029e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', 0, 985, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338015e077b', '永嘉县', 'pub', '330324', 'cskefu', NULL, '297e1e874f83129d014f8334eb53029e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', 0, 986, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338016e077c', '平阳县', 'pub', '330326', 'cskefu', NULL, '297e1e874f83129d014f8334eb53029e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', 0, 987, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83380186077d', '苍南县', 'pub', '330327', 'cskefu', NULL, '297e1e874f83129d014f8334eb53029e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', 0, 988, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833801a1077e', '文成县', 'pub', '330328', 'cskefu', NULL, '297e1e874f83129d014f8334eb53029e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', 0, 989, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833801ce077f', '泰顺县', 'pub', '330329', 'cskefu', NULL, '297e1e874f83129d014f8334eb53029e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', 0, 990, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833802050780', '瑞安市', 'pub', '330381', 'cskefu', NULL, '297e1e874f83129d014f8334eb53029e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:29', '2015-08-31 18:05:29', 0, 991, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833802260781', '乐清市', 'pub', '330382', 'cskefu', NULL, '297e1e874f83129d014f8334eb53029e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:30', '2015-08-31 18:05:30', 0, 992, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338026f0782', '市辖区', 'pub', '330401', 'cskefu', NULL, '297e1e874f83129d014f8334eb60029f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:30', '2015-08-31 18:05:30', 0, 993, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833802950783', '秀城区', 'pub', '330402', 'cskefu', NULL, '297e1e874f83129d014f8334eb60029f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:30', '2015-08-31 18:05:30', 0, 994, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833802a70784', '秀洲区', 'pub', '330411', 'cskefu', NULL, '297e1e874f83129d014f8334eb60029f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:30', '2015-08-31 18:05:30', 0, 995, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833802b90785', '嘉善县', 'pub', '330421', 'cskefu', NULL, '297e1e874f83129d014f8334eb60029f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:30', '2015-08-31 18:05:30', 0, 996, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833802ce0786', '海盐县', 'pub', '330424', 'cskefu', NULL, '297e1e874f83129d014f8334eb60029f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:30', '2015-08-31 18:05:30', 0, 997, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833802df0787', '海宁市', 'pub', '330481', 'cskefu', NULL, '297e1e874f83129d014f8334eb60029f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:30', '2015-08-31 18:05:30', 0, 998, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833802ef0788', '平湖市', 'pub', '330482', 'cskefu', NULL, '297e1e874f83129d014f8334eb60029f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:30', '2015-08-31 18:05:30', 0, 999, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338042d0789', '桐乡市', 'pub', '330483', 'cskefu', NULL, '297e1e874f83129d014f8334eb60029f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:30', '2015-08-31 18:05:30', 0, 1000, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83380475078a', '市辖区', 'pub', '330501', 'cskefu', NULL, '297e1e874f83129d014f8334eb6e02a0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:30', '2015-08-31 18:05:30', 0, 1001, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83380484078b', '吴兴区', 'pub', '330502', 'cskefu', NULL, '297e1e874f83129d014f8334eb6e02a0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:30', '2015-08-31 18:05:30', 0, 1002, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83380495078c', '南浔区', 'pub', '330503', 'cskefu', NULL, '297e1e874f83129d014f8334eb6e02a0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:30', '2015-08-31 18:05:30', 0, 1003, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833804a8078d', '德清县', 'pub', '330521', 'cskefu', NULL, '297e1e874f83129d014f8334eb6e02a0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:30', '2015-08-31 18:05:30', 0, 1004, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833804b9078e', '长兴县', 'pub', '330522', 'cskefu', NULL, '297e1e874f83129d014f8334eb6e02a0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:30', '2015-08-31 18:05:30', 0, 1005, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833804c7078f', '安吉县', 'pub', '330523', 'cskefu', NULL, '297e1e874f83129d014f8334eb6e02a0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:30', '2015-08-31 18:05:30', 0, 1006, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833805080790', '市辖区', 'pub', '330601', 'cskefu', NULL, '297e1e874f83129d014f8334eb7d02a1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:30', '2015-08-31 18:05:30', 0, 1007, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833805170791', '越城区', 'pub', '330602', 'cskefu', NULL, '297e1e874f83129d014f8334eb7d02a1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:30', '2015-08-31 18:05:30', 0, 1008, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833805260792', '绍兴县', 'pub', '330621', 'cskefu', NULL, '297e1e874f83129d014f8334eb7d02a1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:30', '2015-08-31 18:05:30', 0, 1009, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833805350793', '新昌县', 'pub', '330624', 'cskefu', NULL, '297e1e874f83129d014f8334eb7d02a1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:30', '2015-08-31 18:05:30', 0, 1010, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833805430794', '诸暨市', 'pub', '330681', 'cskefu', NULL, '297e1e874f83129d014f8334eb7d02a1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:30', '2015-08-31 18:05:30', 0, 1011, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833805510795', '上虞市', 'pub', '330682', 'cskefu', NULL, '297e1e874f83129d014f8334eb7d02a1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:30', '2015-08-31 18:05:30', 0, 1012, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833805600796', '嵊州市', 'pub', '330683', 'cskefu', NULL, '297e1e874f83129d014f8334eb7d02a1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:30', '2015-08-31 18:05:30', 0, 1013, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833806c00797', '市辖区', 'pub', '330701', 'cskefu', NULL, '297e1e874f83129d014f8334eb8902a2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:31', '2015-08-31 18:05:31', 0, 1014, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833806d30798', '婺城区', 'pub', '330702', 'cskefu', NULL, '297e1e874f83129d014f8334eb8902a2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:31', '2015-08-31 18:05:31', 0, 1015, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833806eb0799', '金东区', 'pub', '330703', 'cskefu', NULL, '297e1e874f83129d014f8334eb8902a2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:31', '2015-08-31 18:05:31', 0, 1016, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833806f8079a', '武义县', 'pub', '330723', 'cskefu', NULL, '297e1e874f83129d014f8334eb8902a2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:31', '2015-08-31 18:05:31', 0, 1017, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83380706079b', '浦江县', 'pub', '330726', 'cskefu', NULL, '297e1e874f83129d014f8334eb8902a2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:31', '2015-08-31 18:05:31', 0, 1018, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83380715079c', '磐安县', 'pub', '330727', 'cskefu', NULL, '297e1e874f83129d014f8334eb8902a2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:31', '2015-08-31 18:05:31', 0, 1019, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83380723079d', '兰溪市', 'pub', '330781', 'cskefu', NULL, '297e1e874f83129d014f8334eb8902a2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:31', '2015-08-31 18:05:31', 0, 1020, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83380733079e', '义乌市', 'pub', '330782', 'cskefu', NULL, '297e1e874f83129d014f8334eb8902a2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:31', '2015-08-31 18:05:31', 0, 1021, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338074a079f', '东阳市', 'pub', '330783', 'cskefu', NULL, '297e1e874f83129d014f8334eb8902a2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:31', '2015-08-31 18:05:31', 0, 1022, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338075b07a0', '永康市', 'pub', '330784', 'cskefu', NULL, '297e1e874f83129d014f8334eb8902a2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:31', '2015-08-31 18:05:31', 0, 1023, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338078b07a1', '市辖区', 'pub', '330801', 'cskefu', NULL, '297e1e874f83129d014f8334eb9902a3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:31', '2015-08-31 18:05:31', 0, 1024, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338079a07a2', '柯城区', 'pub', '330802', 'cskefu', NULL, '297e1e874f83129d014f8334eb9902a3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:31', '2015-08-31 18:05:31', 0, 1025, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833807ac07a3', '衢江区', 'pub', '330803', 'cskefu', NULL, '297e1e874f83129d014f8334eb9902a3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:31', '2015-08-31 18:05:31', 0, 1026, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833808ec07a5', '常山县', 'pub', '330822', 'cskefu', NULL, '297e1e874f83129d014f8334eb9902a3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:31', '2015-08-31 18:05:31', 0, 1027, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833808fd07a6', '开化县', 'pub', '330824', 'cskefu', NULL, '297e1e874f83129d014f8334eb9902a3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:31', '2015-08-31 18:05:31', 0, 1028, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338090b07a7', '龙游县', 'pub', '330825', 'cskefu', NULL, '297e1e874f83129d014f8334eb9902a3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:31', '2015-08-31 18:05:31', 0, 1029, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338091a07a8', '江山市', 'pub', '330881', 'cskefu', NULL, '297e1e874f83129d014f8334eb9902a3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:31', '2015-08-31 18:05:31', 0, 1030, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338094907a9', '市辖区', 'pub', '330901', 'cskefu', NULL, '297e1e874f83129d014f8334eba502a4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:31', '2015-08-31 18:05:31', 0, 1031, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338095d07aa', '定海区', 'pub', '330902', 'cskefu', NULL, '297e1e874f83129d014f8334eba502a4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:31', '2015-08-31 18:05:31', 0, 1032, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338096b07ab', '普陀区', 'pub', '330903', 'cskefu', NULL, '297e1e874f83129d014f8334eba502a4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:31', '2015-08-31 18:05:31', 0, 1033, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338097807ac', '岱山县', 'pub', '330921', 'cskefu', NULL, '297e1e874f83129d014f8334eba502a4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:31', '2015-08-31 18:05:31', 0, 1034, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338098707ad', '嵊泗县', 'pub', '330922', 'cskefu', NULL, '297e1e874f83129d014f8334eba502a4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:31', '2015-08-31 18:05:31', 0, 1035, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833809b507ae', '市辖区', 'pub', '331001', 'cskefu', NULL, '297e1e874f83129d014f8334ebb202a5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:31', '2015-08-31 18:05:31', 0, 1036, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83380af407af', '椒江区', 'pub', '331002', 'cskefu', NULL, '297e1e874f83129d014f8334ebb202a5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:32', '2015-08-31 18:05:32', 0, 1037, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83380b0207b0', '黄岩区', 'pub', '331003', 'cskefu', NULL, '297e1e874f83129d014f8334ebb202a5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:32', '2015-08-31 18:05:32', 0, 1038, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83380b1207b1', '路桥区', 'pub', '331004', 'cskefu', NULL, '297e1e874f83129d014f8334ebb202a5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:32', '2015-08-31 18:05:32', 0, 1039, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83380b2107b2', '玉环县', 'pub', '331021', 'cskefu', NULL, '297e1e874f83129d014f8334ebb202a5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:32', '2015-08-31 18:05:32', 0, 1040, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83380b3607b3', '三门县', 'pub', '331022', 'cskefu', NULL, '297e1e874f83129d014f8334ebb202a5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:32', '2015-08-31 18:05:32', 0, 1041, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83380b4507b4', '天台县', 'pub', '331023', 'cskefu', NULL, '297e1e874f83129d014f8334ebb202a5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:32', '2015-08-31 18:05:32', 0, 1042, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83380b5307b5', '仙居县', 'pub', '331024', 'cskefu', NULL, '297e1e874f83129d014f8334ebb202a5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:32', '2015-08-31 18:05:32', 0, 1043, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83380b6307b6', '温岭市', 'pub', '331081', 'cskefu', NULL, '297e1e874f83129d014f8334ebb202a5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:32', '2015-08-31 18:05:32', 0, 1044, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83380b7107b7', '临海市', 'pub', '331082', 'cskefu', NULL, '297e1e874f83129d014f8334ebb202a5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:32', '2015-08-31 18:05:32', 0, 1045, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83380ba807b8', '市辖区', 'pub', '331101', 'cskefu', NULL, '297e1e874f83129d014f8334ebbe02a6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:32', '2015-08-31 18:05:32', 0, 1046, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83380bb607b9', '莲都区', 'pub', '331102', 'cskefu', NULL, '297e1e874f83129d014f8334ebbe02a6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:32', '2015-08-31 18:05:32', 0, 1047, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83380bcb07ba', '青田县', 'pub', '331121', 'cskefu', NULL, '297e1e874f83129d014f8334ebbe02a6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:32', '2015-08-31 18:05:32', 0, 1048, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83380bdc07bb', '缙云县', 'pub', '331122', 'cskefu', NULL, '297e1e874f83129d014f8334ebbe02a6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:32', '2015-08-31 18:05:32', 0, 1049, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83380beb07bc', '遂昌县', 'pub', '331123', 'cskefu', NULL, '297e1e874f83129d014f8334ebbe02a6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:32', '2015-08-31 18:05:32', 0, 1050, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83380bfa07bd', '松阳县', 'pub', '331124', 'cskefu', NULL, '297e1e874f83129d014f8334ebbe02a6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:32', '2015-08-31 18:05:32', 0, 1051, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83380d3607be', '云和县', 'pub', '331125', 'cskefu', NULL, '297e1e874f83129d014f8334ebbe02a6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:32', '2015-08-31 18:05:32', 0, 1052, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83380d5507bf', '庆元县', 'pub', '331126', 'cskefu', NULL, '297e1e874f83129d014f8334ebbe02a6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:32', '2015-08-31 18:05:32', 0, 1053, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83380d6707c0', '景宁畲族自治县', 'pub', '331127', 'cskefu', NULL, '297e1e874f83129d014f8334ebbe02a6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:32', '2015-08-31 18:05:32', 0, 1054, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83380d7707c1', '龙泉市', 'pub', '331181', 'cskefu', NULL, '297e1e874f83129d014f8334ebbe02a6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:32', '2015-08-31 18:05:32', 0, 1055, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83380dbe07c2', '市辖区', 'pub', '340101', 'cskefu', NULL, '297e1e874f83129d014f8334ebe802a7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:32', '2015-08-31 18:05:32', 0, 1056, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83380dd207c3', '瑶海区', 'pub', '340102', 'cskefu', NULL, '297e1e874f83129d014f8334ebe802a7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:33', '2015-08-31 18:05:33', 0, 1057, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83380de107c4', '庐阳区', 'pub', '340103', 'cskefu', NULL, '297e1e874f83129d014f8334ebe802a7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:33', '2015-08-31 18:05:33', 0, 1058, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83380df307c5', '蜀山区', 'pub', '340104', 'cskefu', NULL, '297e1e874f83129d014f8334ebe802a7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:33', '2015-08-31 18:05:33', 0, 1059, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83380e0307c6', '包河区', 'pub', '340111', 'cskefu', NULL, '297e1e874f83129d014f8334ebe802a7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:33', '2015-08-31 18:05:33', 0, 1060, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83380e1307c7', '长丰县', 'pub', '340121', 'cskefu', NULL, '297e1e874f83129d014f8334ebe802a7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:33', '2015-08-31 18:05:33', 0, 1061, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83380e2207c8', '肥东县', 'pub', '340122', 'cskefu', NULL, '297e1e874f83129d014f8334ebe802a7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:33', '2015-08-31 18:05:33', 0, 1062, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83380e3207c9', '肥西县', 'pub', '340123', 'cskefu', NULL, '297e1e874f83129d014f8334ebe802a7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:33', '2015-08-31 18:05:33', 0, 1063, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83380e6507ca', '市辖区', 'pub', '340201', 'cskefu', NULL, '297e1e874f83129d014f8334ebf602a8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:33', '2015-08-31 18:05:33', 0, 1064, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83380e7607cb', '镜湖区', 'pub', '340202', 'cskefu', NULL, '297e1e874f83129d014f8334ebf602a8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:33', '2015-08-31 18:05:33', 0, 1065, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83380e8407cc', '马塘区', 'pub', '340203', 'cskefu', NULL, '297e1e874f83129d014f8334ebf602a8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:33', '2015-08-31 18:05:33', 0, 1066, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83380e9307cd', '新芜区', 'pub', '340204', 'cskefu', NULL, '297e1e874f83129d014f8334ebf602a8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:33', '2015-08-31 18:05:33', 0, 1067, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83380ea207ce', '鸠江区', 'pub', '340207', 'cskefu', NULL, '297e1e874f83129d014f8334ebf602a8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:33', '2015-08-31 18:05:33', 0, 1068, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83380fdd07cf', '芜湖县', 'pub', '340221', 'cskefu', NULL, '297e1e874f83129d014f8334ebf602a8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:33', '2015-08-31 18:05:33', 0, 1069, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83380fea07d0', '繁昌县', 'pub', '340222', 'cskefu', NULL, '297e1e874f83129d014f8334ebf602a8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:33', '2015-08-31 18:05:33', 0, 1070, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83380ff807d1', '南陵县', 'pub', '340223', 'cskefu', NULL, '297e1e874f83129d014f8334ebf602a8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:33', '2015-08-31 18:05:33', 0, 1071, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338102007d2', '市辖区', 'pub', '340301', 'cskefu', NULL, '297e1e874f83129d014f8334ed2f02a9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:33', '2015-08-31 18:05:33', 0, 1072, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338102d07d3', '龙子湖区', 'pub', '340302', 'cskefu', NULL, '297e1e874f83129d014f8334ed2f02a9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:33', '2015-08-31 18:05:33', 0, 1073, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338103b07d4', '蚌山区', 'pub', '340303', 'cskefu', NULL, '297e1e874f83129d014f8334ed2f02a9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:33', '2015-08-31 18:05:33', 0, 1074, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338105507d5', '禹会区', 'pub', '340304', 'cskefu', NULL, '297e1e874f83129d014f8334ed2f02a9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:33', '2015-08-31 18:05:33', 0, 1075, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338106a07d6', '淮上区', 'pub', '340311', 'cskefu', NULL, '297e1e874f83129d014f8334ed2f02a9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:33', '2015-08-31 18:05:33', 0, 1076, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338107907d7', '怀远县', 'pub', '340321', 'cskefu', NULL, '297e1e874f83129d014f8334ed2f02a9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:33', '2015-08-31 18:05:33', 0, 1077, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338108607d8', '五河县', 'pub', '340322', 'cskefu', NULL, '297e1e874f83129d014f8334ed2f02a9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:33', '2015-08-31 18:05:33', 0, 1078, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338109507d9', '固镇县', 'pub', '340323', 'cskefu', NULL, '297e1e874f83129d014f8334ed2f02a9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:33', '2015-08-31 18:05:33', 0, 1079, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833811ec07da', '市辖区', 'pub', '340401', 'cskefu', NULL, '297e1e874f83129d014f8334ed4302aa', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:34', '2015-08-31 18:05:34', 0, 1080, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833811f907db', '大通区', 'pub', '340402', 'cskefu', NULL, '297e1e874f83129d014f8334ed4302aa', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:34', '2015-08-31 18:05:34', 0, 1081, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338120707dc', '田家庵区', 'pub', '340403', 'cskefu', NULL, '297e1e874f83129d014f8334ed4302aa', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:34', '2015-08-31 18:05:34', 0, 1082, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338121507dd', '谢家集区', 'pub', '340404', 'cskefu', NULL, '297e1e874f83129d014f8334ed4302aa', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:34', '2015-08-31 18:05:34', 0, 1083, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338122907de', '八公山区', 'pub', '340405', 'cskefu', NULL, '297e1e874f83129d014f8334ed4302aa', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:34', '2015-08-31 18:05:34', 0, 1084, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338123807df', '潘集区', 'pub', '340406', 'cskefu', NULL, '297e1e874f83129d014f8334ed4302aa', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:34', '2015-08-31 18:05:34', 0, 1085, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338124607e0', '凤台县', 'pub', '340421', 'cskefu', NULL, '297e1e874f83129d014f8334ed4302aa', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:34', '2015-08-31 18:05:34', 0, 1086, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338127407e1', '市辖区', 'pub', '340501', 'cskefu', NULL, '297e1e874f83129d014f8334ed5202ab', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:34', '2015-08-31 18:05:34', 0, 1087, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338128207e2', '金家庄区', 'pub', '340502', 'cskefu', NULL, '297e1e874f83129d014f8334ed5202ab', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:34', '2015-08-31 18:05:34', 0, 1088, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338129107e3', '花山区', 'pub', '340503', 'cskefu', NULL, '297e1e874f83129d014f8334ed5202ab', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:34', '2015-08-31 18:05:34', 0, 1089, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833812a307e4', '雨山区', 'pub', '340504', 'cskefu', NULL, '297e1e874f83129d014f8334ed5202ab', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:34', '2015-08-31 18:05:34', 0, 1090, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833812b007e5', '当涂县', 'pub', '340521', 'cskefu', NULL, '297e1e874f83129d014f8334ed5202ab', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:34', '2015-08-31 18:05:34', 0, 1091, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833812d807e6', '市辖区', 'pub', '340601', 'cskefu', NULL, '297e1e874f83129d014f8334ed6202ac', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:34', '2015-08-31 18:05:34', 0, 1092, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833812e707e7', '杜集区', 'pub', '340602', 'cskefu', NULL, '297e1e874f83129d014f8334ed6202ac', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:34', '2015-08-31 18:05:34', 0, 1093, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338142407e8', '相山区', 'pub', '340603', 'cskefu', NULL, '297e1e874f83129d014f8334ed6202ac', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:34', '2015-08-31 18:05:34', 0, 1094, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338143307e9', '烈山区', 'pub', '340604', 'cskefu', NULL, '297e1e874f83129d014f8334ed6202ac', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:34', '2015-08-31 18:05:34', 0, 1095, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338144107ea', '濉溪县', 'pub', '340621', 'cskefu', NULL, '297e1e874f83129d014f8334ed6202ac', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:34', '2015-08-31 18:05:34', 0, 1096, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338146a07eb', '市辖区', 'pub', '340701', 'cskefu', NULL, '297e1e874f83129d014f8334ed6e02ad', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:34', '2015-08-31 18:05:34', 0, 1097, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338147807ec', '铜官山区', 'pub', '340702', 'cskefu', NULL, '297e1e874f83129d014f8334ed6e02ad', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:34', '2015-08-31 18:05:34', 0, 1098, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338148607ed', '狮子山区', 'pub', '340703', 'cskefu', NULL, '297e1e874f83129d014f8334ed6e02ad', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:34', '2015-08-31 18:05:34', 0, 1099, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338149707ee', '郊　区', 'pub', '340711', 'cskefu', NULL, '297e1e874f83129d014f8334ed6e02ad', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:34', '2015-08-31 18:05:34', 0, 1100, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833814a707ef', '铜陵县', 'pub', '340721', 'cskefu', NULL, '297e1e874f83129d014f8334ed6e02ad', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:34', '2015-08-31 18:05:34', 0, 1101, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833814d607f0', '市辖区', 'pub', '340801', 'cskefu', NULL, '297e1e874f83129d014f8334ed7b02ae', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:34', '2015-08-31 18:05:34', 0, 1102, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833814e907f1', '迎江区', 'pub', '340802', 'cskefu', NULL, '297e1e874f83129d014f8334ed7b02ae', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:34', '2015-08-31 18:05:34', 0, 1103, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833814f507f2', '大观区', 'pub', '340803', 'cskefu', NULL, '297e1e874f83129d014f8334ed7b02ae', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:34', '2015-08-31 18:05:34', 0, 1104, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338163007f3', '郊　区', 'pub', '340811', 'cskefu', NULL, '297e1e874f83129d014f8334ed7b02ae', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:35', '2015-08-31 18:05:35', 0, 1105, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338164007f4', '怀宁县', 'pub', '340822', 'cskefu', NULL, '297e1e874f83129d014f8334ed7b02ae', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:35', '2015-08-31 18:05:35', 0, 1106, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338164e07f5', '枞阳县', 'pub', '340823', 'cskefu', NULL, '297e1e874f83129d014f8334ed7b02ae', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:35', '2015-08-31 18:05:35', 0, 1107, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338165d07f6', '潜山县', 'pub', '340824', 'cskefu', NULL, '297e1e874f83129d014f8334ed7b02ae', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:35', '2015-08-31 18:05:35', 0, 1108, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338166c07f7', '太湖县', 'pub', '340825', 'cskefu', NULL, '297e1e874f83129d014f8334ed7b02ae', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:35', '2015-08-31 18:05:35', 0, 1109, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338167a07f8', '宿松县', 'pub', '340826', 'cskefu', NULL, '297e1e874f83129d014f8334ed7b02ae', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:35', '2015-08-31 18:05:35', 0, 1110, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338168c07f9', '望江县', 'pub', '340827', 'cskefu', NULL, '297e1e874f83129d014f8334ed7b02ae', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:35', '2015-08-31 18:05:35', 0, 1111, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338169c07fa', '岳西县', 'pub', '340828', 'cskefu', NULL, '297e1e874f83129d014f8334ed7b02ae', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:35', '2015-08-31 18:05:35', 0, 1112, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833816ab07fb', '桐城市', 'pub', '340881', 'cskefu', NULL, '297e1e874f83129d014f8334ed7b02ae', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:35', '2015-08-31 18:05:35', 0, 1113, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833816db07fc', '市辖区', 'pub', '341001', 'cskefu', NULL, '297e1e874f83129d014f8334ed8802af', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:35', '2015-08-31 18:05:35', 0, 1114, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833816eb07fd', '屯溪区', 'pub', '341002', 'cskefu', NULL, '297e1e874f83129d014f8334ed8802af', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:35', '2015-08-31 18:05:35', 0, 1115, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833816f907fe', '黄山区', 'pub', '341003', 'cskefu', NULL, '297e1e874f83129d014f8334ed8802af', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:35', '2015-08-31 18:05:35', 0, 1116, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338170607ff', '徽州区', 'pub', '341004', 'cskefu', NULL, '297e1e874f83129d014f8334ed8802af', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:35', '2015-08-31 18:05:35', 0, 1117, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833817160800', '歙　县', 'pub', '341021', 'cskefu', NULL, '297e1e874f83129d014f8334ed8802af', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:35', '2015-08-31 18:05:35', 0, 1118, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833817240801', '休宁县', 'pub', '341022', 'cskefu', NULL, '297e1e874f83129d014f8334ed8802af', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:35', '2015-08-31 18:05:35', 0, 1119, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833817320802', '黟　县', 'pub', '341023', 'cskefu', NULL, '297e1e874f83129d014f8334ed8802af', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:35', '2015-08-31 18:05:35', 0, 1120, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833818740803', '祁门县', 'pub', '341024', 'cskefu', NULL, '297e1e874f83129d014f8334ed8802af', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:35', '2015-08-31 18:05:35', 0, 1121, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833818b50804', '市辖区', 'pub', '341101', 'cskefu', NULL, '297e1e874f83129d014f8334ed9602b0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:35', '2015-08-31 18:05:35', 0, 1122, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833818c30805', '琅琊区', 'pub', '341102', 'cskefu', NULL, '297e1e874f83129d014f8334ed9602b0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:35', '2015-08-31 18:05:35', 0, 1123, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833818d10806', '南谯区', 'pub', '341103', 'cskefu', NULL, '297e1e874f83129d014f8334ed9602b0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:35', '2015-08-31 18:05:35', 0, 1124, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833818e10807', '来安县', 'pub', '341122', 'cskefu', NULL, '297e1e874f83129d014f8334ed9602b0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:35', '2015-08-31 18:05:35', 0, 1125, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833818ee0808', '全椒县', 'pub', '341124', 'cskefu', NULL, '297e1e874f83129d014f8334ed9602b0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:35', '2015-08-31 18:05:35', 0, 1126, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833818fe0809', '定远县', 'pub', '341125', 'cskefu', NULL, '297e1e874f83129d014f8334ed9602b0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:35', '2015-08-31 18:05:35', 0, 1127, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338190b080a', '凤阳县', 'pub', '341126', 'cskefu', NULL, '297e1e874f83129d014f8334ed9602b0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:35', '2015-08-31 18:05:35', 0, 1128, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83381919080b', '天长市', 'pub', '341181', 'cskefu', NULL, '297e1e874f83129d014f8334ed9602b0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:35', '2015-08-31 18:05:35', 0, 1129, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83381928080c', '明光市', 'pub', '341182', 'cskefu', NULL, '297e1e874f83129d014f8334ed9602b0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:35', '2015-08-31 18:05:35', 0, 1130, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83381a82080d', '市辖区', 'pub', '341201', 'cskefu', NULL, '297e1e874f83129d014f8334eda302b1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:36', '2015-08-31 18:05:36', 0, 1131, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83381a91080e', '颍州区', 'pub', '341202', 'cskefu', NULL, '297e1e874f83129d014f8334eda302b1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:36', '2015-08-31 18:05:36', 0, 1132, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83381a9f080f', '颍东区', 'pub', '341203', 'cskefu', NULL, '297e1e874f83129d014f8334eda302b1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:36', '2015-08-31 18:05:36', 0, 1133, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83381aad0810', '颍泉区', 'pub', '341204', 'cskefu', NULL, '297e1e874f83129d014f8334eda302b1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:36', '2015-08-31 18:05:36', 0, 1134, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83381abd0811', '临泉县', 'pub', '341221', 'cskefu', NULL, '297e1e874f83129d014f8334eda302b1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:36', '2015-08-31 18:05:36', 0, 1135, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83381ace0812', '太和县', 'pub', '341222', 'cskefu', NULL, '297e1e874f83129d014f8334eda302b1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:36', '2015-08-31 18:05:36', 0, 1136, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83381adb0813', '阜南县', 'pub', '341225', 'cskefu', NULL, '297e1e874f83129d014f8334eda302b1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:36', '2015-08-31 18:05:36', 0, 1137, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83381aeb0814', '颍上县', 'pub', '341226', 'cskefu', NULL, '297e1e874f83129d014f8334eda302b1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:36', '2015-08-31 18:05:36', 0, 1138, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83381af80815', '界首市', 'pub', '341282', 'cskefu', NULL, '297e1e874f83129d014f8334eda302b1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:36', '2015-08-31 18:05:36', 0, 1139, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83381b280816', '市辖区', 'pub', '341301', 'cskefu', NULL, '297e1e874f83129d014f8334edb402b2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:36', '2015-08-31 18:05:36', 0, 1140, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83381b3c0817', '墉桥区', 'pub', '341302', 'cskefu', NULL, '297e1e874f83129d014f8334edb402b2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:36', '2015-08-31 18:05:36', 0, 1141, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83381b490818', '砀山县', 'pub', '341321', 'cskefu', NULL, '297e1e874f83129d014f8334edb402b2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:36', '2015-08-31 18:05:36', 0, 1142, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83381c83081a', '萧　县', 'pub', '341322', 'cskefu', NULL, '297e1e874f83129d014f8334edb402b2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:36', '2015-08-31 18:05:36', 0, 1143, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83381c92081b', '灵璧县', 'pub', '341323', 'cskefu', NULL, '297e1e874f83129d014f8334edb402b2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:36', '2015-08-31 18:05:36', 0, 1144, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83381ca8081c', '泗　县', 'pub', '341324', 'cskefu', NULL, '297e1e874f83129d014f8334edb402b2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:36', '2015-08-31 18:05:36', 0, 1145, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83381cd2081d', '市辖区', 'pub', '341401', 'cskefu', NULL, '297e1e874f83129d014f8334edc002b3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:36', '2015-08-31 18:05:36', 0, 1146, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83381ce6081e', '居巢区', 'pub', '341402', 'cskefu', NULL, '297e1e874f83129d014f8334edc002b3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:36', '2015-08-31 18:05:36', 0, 1147, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83381cf8081f', '庐江县', 'pub', '341421', 'cskefu', NULL, '297e1e874f83129d014f8334edc002b3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:36', '2015-08-31 18:05:36', 0, 1148, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83381d0d0820', '无为县', 'pub', '341422', 'cskefu', NULL, '297e1e874f83129d014f8334edc002b3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:36', '2015-08-31 18:05:36', 0, 1149, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83381d1f0821', '含山县', 'pub', '341423', 'cskefu', NULL, '297e1e874f83129d014f8334edc002b3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:36', '2015-08-31 18:05:36', 0, 1150, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83381d310822', '和　县', 'pub', '341424', 'cskefu', NULL, '297e1e874f83129d014f8334edc002b3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:36', '2015-08-31 18:05:36', 0, 1151, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83381e870823', '市辖区', 'pub', '341501', 'cskefu', NULL, '297e1e874f83129d014f8334edcf02b4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:37', '2015-08-31 18:05:37', 0, 1152, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83381e950824', '金安区', 'pub', '341502', 'cskefu', NULL, '297e1e874f83129d014f8334edcf02b4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:37', '2015-08-31 18:05:37', 0, 1153, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83381ea20825', '裕安区', 'pub', '341503', 'cskefu', NULL, '297e1e874f83129d014f8334edcf02b4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:37', '2015-08-31 18:05:37', 0, 1154, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83381eb00826', '寿　县', 'pub', '341521', 'cskefu', NULL, '297e1e874f83129d014f8334edcf02b4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:37', '2015-08-31 18:05:37', 0, 1155, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83381ec00827', '霍邱县', 'pub', '341522', 'cskefu', NULL, '297e1e874f83129d014f8334edcf02b4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:37', '2015-08-31 18:05:37', 0, 1156, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83381ecd0828', '舒城县', 'pub', '341523', 'cskefu', NULL, '297e1e874f83129d014f8334edcf02b4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:37', '2015-08-31 18:05:37', 0, 1157, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83381edc0829', '金寨县', 'pub', '341524', 'cskefu', NULL, '297e1e874f83129d014f8334edcf02b4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:37', '2015-08-31 18:05:37', 0, 1158, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83381eea082a', '霍山县', 'pub', '341525', 'cskefu', NULL, '297e1e874f83129d014f8334edcf02b4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:37', '2015-08-31 18:05:37', 0, 1159, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83381f1d082b', '市辖区', 'pub', '341601', 'cskefu', NULL, '297e1e874f83129d014f8334eddb02b5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:37', '2015-08-31 18:05:37', 0, 1160, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83381f2a082c', '谯城区', 'pub', '341602', 'cskefu', NULL, '297e1e874f83129d014f8334eddb02b5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:37', '2015-08-31 18:05:37', 0, 1161, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83381f38082d', '涡阳县', 'pub', '341621', 'cskefu', NULL, '297e1e874f83129d014f8334eddb02b5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:37', '2015-08-31 18:05:37', 0, 1162, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83381f47082e', '蒙城县', 'pub', '341622', 'cskefu', NULL, '297e1e874f83129d014f8334eddb02b5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:37', '2015-08-31 18:05:37', 0, 1163, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83381f57082f', '利辛县', 'pub', '341623', 'cskefu', NULL, '297e1e874f83129d014f8334eddb02b5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:37', '2015-08-31 18:05:37', 0, 1164, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83381f840830', '市辖区', 'pub', '341701', 'cskefu', NULL, '297e1e874f83129d014f8334edee02b6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:37', '2015-08-31 18:05:37', 0, 1165, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833820c70831', '贵池区', 'pub', '341702', 'cskefu', NULL, '297e1e874f83129d014f8334edee02b6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:37', '2015-08-31 18:05:37', 0, 1166, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833820e30832', '东至县', 'pub', '341721', 'cskefu', NULL, '297e1e874f83129d014f8334edee02b6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:37', '2015-08-31 18:05:37', 0, 1167, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833820fd0833', '石台县', 'pub', '341722', 'cskefu', NULL, '297e1e874f83129d014f8334edee02b6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:37', '2015-08-31 18:05:37', 0, 1168, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833821170834', '青阳县', 'pub', '341723', 'cskefu', NULL, '297e1e874f83129d014f8334edee02b6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:37', '2015-08-31 18:05:37', 0, 1169, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833821590835', '市辖区', 'pub', '341801', 'cskefu', NULL, '297e1e874f83129d014f8334edfb02b7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', 0, 1170, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833821700836', '宣州区', 'pub', '341802', 'cskefu', NULL, '297e1e874f83129d014f8334edfb02b7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', 0, 1171, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833821840837', '郎溪县', 'pub', '341821', 'cskefu', NULL, '297e1e874f83129d014f8334edfb02b7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', 0, 1172, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833821a20838', '广德县', 'pub', '341822', 'cskefu', NULL, '297e1e874f83129d014f8334edfb02b7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', 0, 1173, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833821bb0839', '泾　县', 'pub', '341823', 'cskefu', NULL, '297e1e874f83129d014f8334edfb02b7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', 0, 1174, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833821d4083a', '绩溪县', 'pub', '341824', 'cskefu', NULL, '297e1e874f83129d014f8334edfb02b7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', 0, 1175, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833821ec083b', '旌德县', 'pub', '341825', 'cskefu', NULL, '297e1e874f83129d014f8334edfb02b7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', 0, 1176, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833821fb083c', '宁国市', 'pub', '341881', 'cskefu', NULL, '297e1e874f83129d014f8334edfb02b7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', 0, 1177, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83382238083d', '市辖区', 'pub', '350101', 'cskefu', NULL, '297e1e874f83129d014f8334ef4d02b8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', 0, 1178, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83382245083e', '鼓楼区', 'pub', '350102', 'cskefu', NULL, '297e1e874f83129d014f8334ef4d02b8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', 0, 1179, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83382253083f', '台江区', 'pub', '350103', 'cskefu', NULL, '297e1e874f83129d014f8334ef4d02b8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', 0, 1180, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833822640840', '仓山区', 'pub', '350104', 'cskefu', NULL, '297e1e874f83129d014f8334ef4d02b8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', 0, 1181, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833822710841', '马尾区', 'pub', '350105', 'cskefu', NULL, '297e1e874f83129d014f8334ef4d02b8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', 0, 1182, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833822800842', '晋安区', 'pub', '350111', 'cskefu', NULL, '297e1e874f83129d014f8334ef4d02b8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', 0, 1183, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833822930843', '闽侯县', 'pub', '350121', 'cskefu', NULL, '297e1e874f83129d014f8334ef4d02b8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', 0, 1184, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833822a10844', '连江县', 'pub', '350122', 'cskefu', NULL, '297e1e874f83129d014f8334ef4d02b8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', 0, 1185, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833823dd0845', '罗源县', 'pub', '350123', 'cskefu', NULL, '297e1e874f83129d014f8334ef4d02b8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', 0, 1186, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833823ec0846', '闽清县', 'pub', '350124', 'cskefu', NULL, '297e1e874f83129d014f8334ef4d02b8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', 0, 1187, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833823fb0847', '永泰县', 'pub', '350125', 'cskefu', NULL, '297e1e874f83129d014f8334ef4d02b8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', 0, 1188, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833824080848', '平潭县', 'pub', '350128', 'cskefu', NULL, '297e1e874f83129d014f8334ef4d02b8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', 0, 1189, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338241a0849', '福清市', 'pub', '350181', 'cskefu', NULL, '297e1e874f83129d014f8334ef4d02b8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', 0, 1190, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83382428084a', '长乐市', 'pub', '350182', 'cskefu', NULL, '297e1e874f83129d014f8334ef4d02b8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', 0, 1191, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338245d084b', '市辖区', 'pub', '350201', 'cskefu', NULL, '297e1e874f83129d014f8334ef5e02b9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', 0, 1192, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338246d084c', '思明区', 'pub', '350203', 'cskefu', NULL, '297e1e874f83129d014f8334ef5e02b9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', 0, 1193, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83382482084d', '海沧区', 'pub', '350205', 'cskefu', NULL, '297e1e874f83129d014f8334ef5e02b9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', 0, 1194, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83382492084e', '湖里区', 'pub', '350206', 'cskefu', NULL, '297e1e874f83129d014f8334ef5e02b9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', 0, 1195, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833824a5084f', '集美区', 'pub', '350211', 'cskefu', NULL, '297e1e874f83129d014f8334ef5e02b9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', 0, 1196, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833824b40850', '同安区', 'pub', '350212', 'cskefu', NULL, '297e1e874f83129d014f8334ef5e02b9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', 0, 1197, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833824c30851', '翔安区', 'pub', '350213', 'cskefu', NULL, '297e1e874f83129d014f8334ef5e02b9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', 0, 1198, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833824f80852', '市辖区', 'pub', '350301', 'cskefu', NULL, '297e1e874f83129d014f8334ef6902ba', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:38', '2015-08-31 18:05:38', 0, 1199, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833826410853', '城厢区', 'pub', '350302', 'cskefu', NULL, '297e1e874f83129d014f8334ef6902ba', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:39', '2015-08-31 18:05:39', 0, 1200, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833826530854', '涵江区', 'pub', '350303', 'cskefu', NULL, '297e1e874f83129d014f8334ef6902ba', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:39', '2015-08-31 18:05:39', 0, 1201, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833826620855', '荔城区', 'pub', '350304', 'cskefu', NULL, '297e1e874f83129d014f8334ef6902ba', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:39', '2015-08-31 18:05:39', 0, 1202, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833826710856', '秀屿区', 'pub', '350305', 'cskefu', NULL, '297e1e874f83129d014f8334ef6902ba', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:39', '2015-08-31 18:05:39', 0, 1203, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833826870857', '仙游县', 'pub', '350322', 'cskefu', NULL, '297e1e874f83129d014f8334ef6902ba', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:39', '2015-08-31 18:05:39', 0, 1204, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833826b80858', '市辖区', 'pub', '350401', 'cskefu', NULL, '297e1e874f83129d014f8334ef7602bb', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:39', '2015-08-31 18:05:39', 0, 1205, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833826c50859', '梅列区', 'pub', '350402', 'cskefu', NULL, '297e1e874f83129d014f8334ef7602bb', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:39', '2015-08-31 18:05:39', 0, 1206, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833826e5085a', '三元区', 'pub', '350403', 'cskefu', NULL, '297e1e874f83129d014f8334ef7602bb', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:39', '2015-08-31 18:05:39', 0, 1207, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833826f9085b', '明溪县', 'pub', '350421', 'cskefu', NULL, '297e1e874f83129d014f8334ef7602bb', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:39', '2015-08-31 18:05:39', 0, 1208, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338272c085c', '清流县', 'pub', '350423', 'cskefu', NULL, '297e1e874f83129d014f8334ef7602bb', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:39', '2015-08-31 18:05:39', 0, 1209, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338273c085d', '宁化县', 'pub', '350424', 'cskefu', NULL, '297e1e874f83129d014f8334ef7602bb', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:39', '2015-08-31 18:05:39', 0, 1210, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338274d085e', '大田县', 'pub', '350425', 'cskefu', NULL, '297e1e874f83129d014f8334ef7602bb', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:39', '2015-08-31 18:05:39', 0, 1211, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338275d085f', '尤溪县', 'pub', '350426', 'cskefu', NULL, '297e1e874f83129d014f8334ef7602bb', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:39', '2015-08-31 18:05:39', 0, 1212, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833827760860', '沙　县', 'pub', '350427', 'cskefu', NULL, '297e1e874f83129d014f8334ef7602bb', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:39', '2015-08-31 18:05:39', 0, 1213, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338278c0861', '将乐县', 'pub', '350428', 'cskefu', NULL, '297e1e874f83129d014f8334ef7602bb', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:39', '2015-08-31 18:05:39', 0, 1214, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833827a30862', '泰宁县', 'pub', '350429', 'cskefu', NULL, '297e1e874f83129d014f8334ef7602bb', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:39', '2015-08-31 18:05:39', 0, 1215, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833827be0863', '建宁县', 'pub', '350430', 'cskefu', NULL, '297e1e874f83129d014f8334ef7602bb', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:39', '2015-08-31 18:05:39', 0, 1216, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833827d70864', '永安市', 'pub', '350481', 'cskefu', NULL, '297e1e874f83129d014f8334ef7602bb', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:39', '2015-08-31 18:05:39', 0, 1217, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833828270865', '市辖区', 'pub', '350501', 'cskefu', NULL, '297e1e874f83129d014f8334ef8202bc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:39', '2015-08-31 18:05:39', 0, 1218, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833828460866', '鲤城区', 'pub', '350502', 'cskefu', NULL, '297e1e874f83129d014f8334ef8202bc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:39', '2015-08-31 18:05:39', 0, 1219, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833828780867', '丰泽区', 'pub', '350503', 'cskefu', NULL, '297e1e874f83129d014f8334ef8202bc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:39', '2015-08-31 18:05:39', 0, 1220, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338289c0868', '洛江区', 'pub', '350504', 'cskefu', NULL, '297e1e874f83129d014f8334ef8202bc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:39', '2015-08-31 18:05:39', 0, 1221, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833828c80869', '泉港区', 'pub', '350505', 'cskefu', NULL, '297e1e874f83129d014f8334ef8202bc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:39', '2015-08-31 18:05:39', 0, 1222, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833828ec086a', '惠安县', 'pub', '350521', 'cskefu', NULL, '297e1e874f83129d014f8334ef8202bc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:39', '2015-08-31 18:05:39', 0, 1223, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83382911086b', '安溪县', 'pub', '350524', 'cskefu', NULL, '297e1e874f83129d014f8334ef8202bc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:39', '2015-08-31 18:05:39', 0, 1224, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338292b086c', '永春县', 'pub', '350525', 'cskefu', NULL, '297e1e874f83129d014f8334ef8202bc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:40', '2015-08-31 18:05:40', 0, 1225, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338293c086d', '德化县', 'pub', '350526', 'cskefu', NULL, '297e1e874f83129d014f8334ef8202bc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:40', '2015-08-31 18:05:40', 0, 1226, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338294e086e', '金门县', 'pub', '350527', 'cskefu', NULL, '297e1e874f83129d014f8334ef8202bc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:40', '2015-08-31 18:05:40', 0, 1227, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83382962086f', '石狮市', 'pub', '350581', 'cskefu', NULL, '297e1e874f83129d014f8334ef8202bc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:40', '2015-08-31 18:05:40', 0, 1228, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833829730870', '晋江市', 'pub', '350582', 'cskefu', NULL, '297e1e874f83129d014f8334ef8202bc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:40', '2015-08-31 18:05:40', 0, 1229, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833829840871', '南安市', 'pub', '350583', 'cskefu', NULL, '297e1e874f83129d014f8334ef8202bc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:40', '2015-08-31 18:05:40', 0, 1230, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83382ae90872', '市辖区', 'pub', '350601', 'cskefu', NULL, '297e1e874f83129d014f8334ef9002bd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:40', '2015-08-31 18:05:40', 0, 1231, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83382afe0873', '芗城区', 'pub', '350602', 'cskefu', NULL, '297e1e874f83129d014f8334ef9002bd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:40', '2015-08-31 18:05:40', 0, 1232, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83382b0e0874', '龙文区', 'pub', '350603', 'cskefu', NULL, '297e1e874f83129d014f8334ef9002bd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:40', '2015-08-31 18:05:40', 0, 1233, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83382b260875', '云霄县', 'pub', '350622', 'cskefu', NULL, '297e1e874f83129d014f8334ef9002bd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:40', '2015-08-31 18:05:40', 0, 1234, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83382b3a0876', '漳浦县', 'pub', '350623', 'cskefu', NULL, '297e1e874f83129d014f8334ef9002bd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:40', '2015-08-31 18:05:40', 0, 1235, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83382b490877', '诏安县', 'pub', '350624', 'cskefu', NULL, '297e1e874f83129d014f8334ef9002bd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:40', '2015-08-31 18:05:40', 0, 1236, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83382b590878', '长泰县', 'pub', '350625', 'cskefu', NULL, '297e1e874f83129d014f8334ef9002bd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:40', '2015-08-31 18:05:40', 0, 1237, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83382b680879', '东山县', 'pub', '350626', 'cskefu', NULL, '297e1e874f83129d014f8334ef9002bd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:40', '2015-08-31 18:05:40', 0, 1238, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83382b76087a', '南靖县', 'pub', '350627', 'cskefu', NULL, '297e1e874f83129d014f8334ef9002bd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:40', '2015-08-31 18:05:40', 0, 1239, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83382b85087b', '平和县', 'pub', '350628', 'cskefu', NULL, '297e1e874f83129d014f8334ef9002bd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:40', '2015-08-31 18:05:40', 0, 1240, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83382b95087c', '华安县', 'pub', '350629', 'cskefu', NULL, '297e1e874f83129d014f8334ef9002bd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:40', '2015-08-31 18:05:40', 0, 1241, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83382ba6087d', '龙海市', 'pub', '350681', 'cskefu', NULL, '297e1e874f83129d014f8334ef9002bd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:40', '2015-08-31 18:05:40', 0, 1242, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83382bd5087e', '市辖区', 'pub', '350701', 'cskefu', NULL, '297e1e874f83129d014f8334ef9d02be', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:40', '2015-08-31 18:05:40', 0, 1243, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83382be6087f', '延平区', 'pub', '350702', 'cskefu', NULL, '297e1e874f83129d014f8334ef9d02be', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:40', '2015-08-31 18:05:40', 0, 1244, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83382bf50880', '顺昌县', 'pub', '350721', 'cskefu', NULL, '297e1e874f83129d014f8334ef9d02be', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:40', '2015-08-31 18:05:40', 0, 1245, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83382d330881', '浦城县', 'pub', '350722', 'cskefu', NULL, '297e1e874f83129d014f8334ef9d02be', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:41', '2015-08-31 18:05:41', 0, 1246, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83382d470882', '光泽县', 'pub', '350723', 'cskefu', NULL, '297e1e874f83129d014f8334ef9d02be', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:41', '2015-08-31 18:05:41', 0, 1247, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83382d590883', '松溪县', 'pub', '350724', 'cskefu', NULL, '297e1e874f83129d014f8334ef9d02be', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:41', '2015-08-31 18:05:41', 0, 1248, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83382d660884', '政和县', 'pub', '350725', 'cskefu', NULL, '297e1e874f83129d014f8334ef9d02be', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:41', '2015-08-31 18:05:41', 0, 1249, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83382d760885', '邵武市', 'pub', '350781', 'cskefu', NULL, '297e1e874f83129d014f8334ef9d02be', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:41', '2015-08-31 18:05:41', 0, 1250, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83382d850886', '武夷山市', 'pub', '350782', 'cskefu', NULL, '297e1e874f83129d014f8334ef9d02be', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:41', '2015-08-31 18:05:41', 0, 1251, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83382d960887', '建瓯市', 'pub', '350783', 'cskefu', NULL, '297e1e874f83129d014f8334ef9d02be', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:41', '2015-08-31 18:05:41', 0, 1252, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83382da40888', '建阳市', 'pub', '350784', 'cskefu', NULL, '297e1e874f83129d014f8334ef9d02be', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:41', '2015-08-31 18:05:41', 0, 1253, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83382dcf0889', '市辖区', 'pub', '350801', 'cskefu', NULL, '297e1e874f83129d014f8334efa902bf', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:41', '2015-08-31 18:05:41', 0, 1254, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83382de0088a', '新罗区', 'pub', '350802', 'cskefu', NULL, '297e1e874f83129d014f8334efa902bf', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:41', '2015-08-31 18:05:41', 0, 1255, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83382df7088b', '长汀县', 'pub', '350821', 'cskefu', NULL, '297e1e874f83129d014f8334efa902bf', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:41', '2015-08-31 18:05:41', 0, 1256, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83382e06088c', '永定县', 'pub', '350822', 'cskefu', NULL, '297e1e874f83129d014f8334efa902bf', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:41', '2015-08-31 18:05:41', 0, 1257, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83382e14088d', '上杭县', 'pub', '350823', 'cskefu', NULL, '297e1e874f83129d014f8334efa902bf', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:41', '2015-08-31 18:05:41', 0, 1258, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83382e22088e', '武平县', 'pub', '350824', 'cskefu', NULL, '297e1e874f83129d014f8334efa902bf', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:41', '2015-08-31 18:05:41', 0, 1259, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83382e30088f', '连城县', 'pub', '350825', 'cskefu', NULL, '297e1e874f83129d014f8334efa902bf', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:41', '2015-08-31 18:05:41', 0, 1260, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83382e3e0890', '漳平市', 'pub', '350881', 'cskefu', NULL, '297e1e874f83129d014f8334efa902bf', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:41', '2015-08-31 18:05:41', 0, 1261, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83382f950891', '市辖区', 'pub', '350901', 'cskefu', NULL, '297e1e874f83129d014f8334efb702c0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:41', '2015-08-31 18:05:41', 0, 1262, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83382fa70892', '蕉城区', 'pub', '350902', 'cskefu', NULL, '297e1e874f83129d014f8334efb702c0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:41', '2015-08-31 18:05:41', 0, 1263, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83382fb60893', '霞浦县', 'pub', '350921', 'cskefu', NULL, '297e1e874f83129d014f8334efb702c0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:41', '2015-08-31 18:05:41', 0, 1264, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83382fc30894', '古田县', 'pub', '350922', 'cskefu', NULL, '297e1e874f83129d014f8334efb702c0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:41', '2015-08-31 18:05:41', 0, 1265, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83382fd50895', '屏南县', 'pub', '350923', 'cskefu', NULL, '297e1e874f83129d014f8334efb702c0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:41', '2015-08-31 18:05:41', 0, 1266, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83382fe50896', '寿宁县', 'pub', '350924', 'cskefu', NULL, '297e1e874f83129d014f8334efb702c0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:41', '2015-08-31 18:05:41', 0, 1267, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833830000898', '周宁县', 'pub', '350925', 'cskefu', NULL, '297e1e874f83129d014f8334efb702c0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:41', '2015-08-31 18:05:41', 0, 1268, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338313b0899', '柘荣县', 'pub', '350926', 'cskefu', NULL, '297e1e874f83129d014f8334efb702c0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:42', '2015-08-31 18:05:42', 0, 1269, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338314b089a', '福安市', 'pub', '350981', 'cskefu', NULL, '297e1e874f83129d014f8334efb702c0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:42', '2015-08-31 18:05:42', 0, 1270, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338315c089b', '福鼎市', 'pub', '350982', 'cskefu', NULL, '297e1e874f83129d014f8334efb702c0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:42', '2015-08-31 18:05:42', 0, 1271, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83383190089c', '市辖区', 'pub', '360101', 'cskefu', NULL, '297e1e874f83129d014f8334efde02c1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:42', '2015-08-31 18:05:42', 0, 1272, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338319f089d', '东湖区', 'pub', '360102', 'cskefu', NULL, '297e1e874f83129d014f8334efde02c1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:42', '2015-08-31 18:05:42', 0, 1273, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833831b3089e', '西湖区', 'pub', '360103', 'cskefu', NULL, '297e1e874f83129d014f8334efde02c1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:42', '2015-08-31 18:05:42', 0, 1274, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833831c1089f', '青云谱区', 'pub', '360104', 'cskefu', NULL, '297e1e874f83129d014f8334efde02c1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:42', '2015-08-31 18:05:42', 0, 1275, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833831d008a0', '湾里区', 'pub', '360105', 'cskefu', NULL, '297e1e874f83129d014f8334efde02c1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:42', '2015-08-31 18:05:42', 0, 1276, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833831e308a1', '青山湖区', 'pub', '360111', 'cskefu', NULL, '297e1e874f83129d014f8334efde02c1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:42', '2015-08-31 18:05:42', 0, 1277, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833831f208a2', '南昌县', 'pub', '360121', 'cskefu', NULL, '297e1e874f83129d014f8334efde02c1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:42', '2015-08-31 18:05:42', 0, 1278, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338320408a3', '新建县', 'pub', '360122', 'cskefu', NULL, '297e1e874f83129d014f8334efde02c1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:42', '2015-08-31 18:05:42', 0, 1279, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338321208a4', '安义县', 'pub', '360123', 'cskefu', NULL, '297e1e874f83129d014f8334efde02c1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:42', '2015-08-31 18:05:42', 0, 1280, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338322008a5', '进贤县', 'pub', '360124', 'cskefu', NULL, '297e1e874f83129d014f8334efde02c1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:42', '2015-08-31 18:05:42', 0, 1281, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338324908a6', '市辖区', 'pub', '360201', 'cskefu', NULL, '297e1e874f83129d014f8334f11902c2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:42', '2015-08-31 18:05:42', 0, 1282, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338338608a7', '昌江区', 'pub', '360202', 'cskefu', NULL, '297e1e874f83129d014f8334f11902c2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:42', '2015-08-31 18:05:42', 0, 1283, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338339608a8', '珠山区', 'pub', '360203', 'cskefu', NULL, '297e1e874f83129d014f8334f11902c2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:42', '2015-08-31 18:05:42', 0, 1284, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833833a708a9', '浮梁县', 'pub', '360222', 'cskefu', NULL, '297e1e874f83129d014f8334f11902c2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:42', '2015-08-31 18:05:42', 0, 1285, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833833b708aa', '乐平市', 'pub', '360281', 'cskefu', NULL, '297e1e874f83129d014f8334f11902c2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:42', '2015-08-31 18:05:42', 0, 1286, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833833e208ab', '市辖区', 'pub', '360301', 'cskefu', NULL, '297e1e874f83129d014f8334f12702c3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:42', '2015-08-31 18:05:42', 0, 1287, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833833f008ac', '安源区', 'pub', '360302', 'cskefu', NULL, '297e1e874f83129d014f8334f12702c3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:42', '2015-08-31 18:05:42', 0, 1288, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833833fc08ad', '湘东区', 'pub', '360313', 'cskefu', NULL, '297e1e874f83129d014f8334f12702c3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:42', '2015-08-31 18:05:42', 0, 1289, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338340a08ae', '莲花县', 'pub', '360321', 'cskefu', NULL, '297e1e874f83129d014f8334f12702c3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:42', '2015-08-31 18:05:42', 0, 1290, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338341a08af', '上栗县', 'pub', '360322', 'cskefu', NULL, '297e1e874f83129d014f8334f12702c3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:42', '2015-08-31 18:05:42', 0, 1291, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338342a08b0', '芦溪县', 'pub', '360323', 'cskefu', NULL, '297e1e874f83129d014f8334f12702c3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:42', '2015-08-31 18:05:42', 0, 1292, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833834a408b1', '市辖区', 'pub', '360401', 'cskefu', NULL, '297e1e874f83129d014f8334f13602c4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:42', '2015-08-31 18:05:42', 0, 1293, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833834b308b2', '庐山区', 'pub', '360402', 'cskefu', NULL, '297e1e874f83129d014f8334f13602c4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:42', '2015-08-31 18:05:42', 0, 1294, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833834c308b3', '浔阳区', 'pub', '360403', 'cskefu', NULL, '297e1e874f83129d014f8334f13602c4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:42', '2015-08-31 18:05:42', 0, 1295, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833834d508b4', '九江县', 'pub', '360421', 'cskefu', NULL, '297e1e874f83129d014f8334f13602c4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:42', '2015-08-31 18:05:42', 0, 1296, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833834ee08b5', '武宁县', 'pub', '360423', 'cskefu', NULL, '297e1e874f83129d014f8334f13602c4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:43', '2015-08-31 18:05:43', 0, 1297, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338350108b6', '修水县', 'pub', '360424', 'cskefu', NULL, '297e1e874f83129d014f8334f13602c4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:43', '2015-08-31 18:05:43', 0, 1298, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338350e08b7', '永修县', 'pub', '360425', 'cskefu', NULL, '297e1e874f83129d014f8334f13602c4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:43', '2015-08-31 18:05:43', 0, 1299, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338364a08b8', '德安县', 'pub', '360426', 'cskefu', NULL, '297e1e874f83129d014f8334f13602c4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:43', '2015-08-31 18:05:43', 0, 1300, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338365c08b9', '星子县', 'pub', '360427', 'cskefu', NULL, '297e1e874f83129d014f8334f13602c4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:43', '2015-08-31 18:05:43', 0, 1301, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338366d08ba', '都昌县', 'pub', '360428', 'cskefu', NULL, '297e1e874f83129d014f8334f13602c4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:43', '2015-08-31 18:05:43', 0, 1302, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338367b08bb', '湖口县', 'pub', '360429', 'cskefu', NULL, '297e1e874f83129d014f8334f13602c4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:43', '2015-08-31 18:05:43', 0, 1303, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338368c08bc', '彭泽县', 'pub', '360430', 'cskefu', NULL, '297e1e874f83129d014f8334f13602c4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:43', '2015-08-31 18:05:43', 0, 1304, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338369c08bd', '瑞昌市', 'pub', '360481', 'cskefu', NULL, '297e1e874f83129d014f8334f13602c4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:43', '2015-08-31 18:05:43', 0, 1305, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833836cb08be', '市辖区', 'pub', '360501', 'cskefu', NULL, '297e1e874f83129d014f8334f14c02c5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:43', '2015-08-31 18:05:43', 0, 1306, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833836da08bf', '渝水区', 'pub', '360502', 'cskefu', NULL, '297e1e874f83129d014f8334f14c02c5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:43', '2015-08-31 18:05:43', 0, 1307, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833836e708c0', '分宜县', 'pub', '360521', 'cskefu', NULL, '297e1e874f83129d014f8334f14c02c5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:43', '2015-08-31 18:05:43', 0, 1308, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338376e08c1', '市辖区', 'pub', '360601', 'cskefu', NULL, '297e1e874f83129d014f8334f15b02c6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:43', '2015-08-31 18:05:43', 0, 1309, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338379608c2', '月湖区', 'pub', '360602', 'cskefu', NULL, '297e1e874f83129d014f8334f15b02c6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:43', '2015-08-31 18:05:43', 0, 1310, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833837a208c3', '余江县', 'pub', '360622', 'cskefu', NULL, '297e1e874f83129d014f8334f15b02c6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:43', '2015-08-31 18:05:43', 0, 1311, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833837b608c4', '贵溪市', 'pub', '360681', 'cskefu', NULL, '297e1e874f83129d014f8334f15b02c6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:43', '2015-08-31 18:05:43', 0, 1312, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833837dd08c5', '市辖区', 'pub', '360701', 'cskefu', NULL, '297e1e874f83129d014f8334f16c02c7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:43', '2015-08-31 18:05:43', 0, 1313, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833837ea08c6', '章贡区', 'pub', '360702', 'cskefu', NULL, '297e1e874f83129d014f8334f16c02c7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:43', '2015-08-31 18:05:43', 0, 1314, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338380308c7', '赣　县', 'pub', '360721', 'cskefu', NULL, '297e1e874f83129d014f8334f16c02c7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:43', '2015-08-31 18:05:43', 0, 1315, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338381208c8', '信丰县', 'pub', '360722', 'cskefu', NULL, '297e1e874f83129d014f8334f16c02c7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:43', '2015-08-31 18:05:43', 0, 1316, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338382008c9', '大余县', 'pub', '360723', 'cskefu', NULL, '297e1e874f83129d014f8334f16c02c7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:43', '2015-08-31 18:05:43', 0, 1317, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338395d08ca', '上犹县', 'pub', '360724', 'cskefu', NULL, '297e1e874f83129d014f8334f16c02c7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', 0, 1318, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338396c08cb', '崇义县', 'pub', '360725', 'cskefu', NULL, '297e1e874f83129d014f8334f16c02c7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', 0, 1319, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338397f08cc', '安远县', 'pub', '360726', 'cskefu', NULL, '297e1e874f83129d014f8334f16c02c7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', 0, 1320, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338398f08cd', '龙南县', 'pub', '360727', 'cskefu', NULL, '297e1e874f83129d014f8334f16c02c7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', 0, 1321, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338399e08ce', '定南县', 'pub', '360728', 'cskefu', NULL, '297e1e874f83129d014f8334f16c02c7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', 0, 1322, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833839ab08cf', '全南县', 'pub', '360729', 'cskefu', NULL, '297e1e874f83129d014f8334f16c02c7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', 0, 1323, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833839b808d0', '宁都县', 'pub', '360730', 'cskefu', NULL, '297e1e874f83129d014f8334f16c02c7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', 0, 1324, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833839c608d1', '于都县', 'pub', '360731', 'cskefu', NULL, '297e1e874f83129d014f8334f16c02c7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', 0, 1325, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833839d308d2', '兴国县', 'pub', '360732', 'cskefu', NULL, '297e1e874f83129d014f8334f16c02c7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', 0, 1326, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833839e108d3', '会昌县', 'pub', '360733', 'cskefu', NULL, '297e1e874f83129d014f8334f16c02c7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', 0, 1327, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833839ef08d4', '寻乌县', 'pub', '360734', 'cskefu', NULL, '297e1e874f83129d014f8334f16c02c7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', 0, 1328, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833839fe08d5', '石城县', 'pub', '360735', 'cskefu', NULL, '297e1e874f83129d014f8334f16c02c7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', 0, 1329, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83383a0b08d6', '瑞金市', 'pub', '360781', 'cskefu', NULL, '297e1e874f83129d014f8334f16c02c7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', 0, 1330, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83383a1a08d7', '南康市', 'pub', '360782', 'cskefu', NULL, '297e1e874f83129d014f8334f16c02c7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', 0, 1331, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83383b7308d8', '市辖区', 'pub', '360801', 'cskefu', NULL, '297e1e874f83129d014f8334f18502c8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', 0, 1332, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83383b8608d9', '吉州区', 'pub', '360802', 'cskefu', NULL, '297e1e874f83129d014f8334f18502c8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', 0, 1333, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83383b9608da', '青原区', 'pub', '360803', 'cskefu', NULL, '297e1e874f83129d014f8334f18502c8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', 0, 1334, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83383bc008db', '吉安县', 'pub', '360821', 'cskefu', NULL, '297e1e874f83129d014f8334f18502c8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', 0, 1335, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83383bcf08dc', '吉水县', 'pub', '360822', 'cskefu', NULL, '297e1e874f83129d014f8334f18502c8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', 0, 1336, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83383bdb08dd', '峡江县', 'pub', '360823', 'cskefu', NULL, '297e1e874f83129d014f8334f18502c8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', 0, 1337, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83383be808de', '新干县', 'pub', '360824', 'cskefu', NULL, '297e1e874f83129d014f8334f18502c8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', 0, 1338, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83383bf508df', '永丰县', 'pub', '360825', 'cskefu', NULL, '297e1e874f83129d014f8334f18502c8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', 0, 1339, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83383c0508e0', '泰和县', 'pub', '360826', 'cskefu', NULL, '297e1e874f83129d014f8334f18502c8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', 0, 1340, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83383c1308e1', '遂川县', 'pub', '360827', 'cskefu', NULL, '297e1e874f83129d014f8334f18502c8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', 0, 1341, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83383c2608e2', '万安县', 'pub', '360828', 'cskefu', NULL, '297e1e874f83129d014f8334f18502c8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', 0, 1342, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83383c3608e3', '安福县', 'pub', '360829', 'cskefu', NULL, '297e1e874f83129d014f8334f18502c8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', 0, 1343, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83383c4608e4', '永新县', 'pub', '360830', 'cskefu', NULL, '297e1e874f83129d014f8334f18502c8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', 0, 1344, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83383c5708e5', '井冈山市', 'pub', '360881', 'cskefu', NULL, '297e1e874f83129d014f8334f18502c8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', 0, 1345, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83383c8608e6', '市辖区', 'pub', '360901', 'cskefu', NULL, '297e1e874f83129d014f8334f19402c9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', 0, 1346, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83383c9708e7', '袁州区', 'pub', '360902', 'cskefu', NULL, '297e1e874f83129d014f8334f19402c9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', 0, 1347, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83383ca408e8', '奉新县', 'pub', '360921', 'cskefu', NULL, '297e1e874f83129d014f8334f19402c9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:44', '2015-08-31 18:05:44', 0, 1348, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83383cb208e9', '万载县', 'pub', '360922', 'cskefu', NULL, '297e1e874f83129d014f8334f19402c9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:45', '2015-08-31 18:05:45', 0, 1349, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83383de908ea', '上高县', 'pub', '360923', 'cskefu', NULL, '297e1e874f83129d014f8334f19402c9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:45', '2015-08-31 18:05:45', 0, 1350, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83383df508eb', '宜丰县', 'pub', '360924', 'cskefu', NULL, '297e1e874f83129d014f8334f19402c9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:45', '2015-08-31 18:05:45', 0, 1351, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83383e0708ec', '靖安县', 'pub', '360925', 'cskefu', NULL, '297e1e874f83129d014f8334f19402c9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:45', '2015-08-31 18:05:45', 0, 1352, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83383e2108ed', '铜鼓县', 'pub', '360926', 'cskefu', NULL, '297e1e874f83129d014f8334f19402c9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:45', '2015-08-31 18:05:45', 0, 1353, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83383e2f08ee', '丰城市', 'pub', '360981', 'cskefu', NULL, '297e1e874f83129d014f8334f19402c9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:45', '2015-08-31 18:05:45', 0, 1354, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83383e3c08ef', '樟树市', 'pub', '360982', 'cskefu', NULL, '297e1e874f83129d014f8334f19402c9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:45', '2015-08-31 18:05:45', 0, 1355, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83383e4808f0', '高安市', 'pub', '360983', 'cskefu', NULL, '297e1e874f83129d014f8334f19402c9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:45', '2015-08-31 18:05:45', 0, 1356, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83383e7208f1', '市辖区', 'pub', '361001', 'cskefu', NULL, '297e1e874f83129d014f8334f1a302ca', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:45', '2015-08-31 18:05:45', 0, 1357, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83383e8108f2', '临川区', 'pub', '361002', 'cskefu', NULL, '297e1e874f83129d014f8334f1a302ca', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:45', '2015-08-31 18:05:45', 0, 1358, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83383e8d08f3', '南城县', 'pub', '361021', 'cskefu', NULL, '297e1e874f83129d014f8334f1a302ca', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:45', '2015-08-31 18:05:45', 0, 1359, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83383ea608f4', '黎川县', 'pub', '361022', 'cskefu', NULL, '297e1e874f83129d014f8334f1a302ca', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:45', '2015-08-31 18:05:45', 0, 1360, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83383eef08f5', '南丰县', 'pub', '361023', 'cskefu', NULL, '297e1e874f83129d014f8334f1a302ca', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:45', '2015-08-31 18:05:45', 0, 1361, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83383f0308f6', '崇仁县', 'pub', '361024', 'cskefu', NULL, '297e1e874f83129d014f8334f1a302ca', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:45', '2015-08-31 18:05:45', 0, 1362, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83383f0f08f7', '乐安县', 'pub', '361025', 'cskefu', NULL, '297e1e874f83129d014f8334f1a302ca', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:45', '2015-08-31 18:05:45', 0, 1363, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83383f1b08f8', '宜黄县', 'pub', '361026', 'cskefu', NULL, '297e1e874f83129d014f8334f1a302ca', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:45', '2015-08-31 18:05:45', 0, 1364, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83383f3208f9', '金溪县', 'pub', '361027', 'cskefu', NULL, '297e1e874f83129d014f8334f1a302ca', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:45', '2015-08-31 18:05:45', 0, 1365, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338406c08fa', '资溪县', 'pub', '361028', 'cskefu', NULL, '297e1e874f83129d014f8334f1a302ca', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:45', '2015-08-31 18:05:45', 0, 1366, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338407808fb', '东乡县', 'pub', '361029', 'cskefu', NULL, '297e1e874f83129d014f8334f1a302ca', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:45', '2015-08-31 18:05:45', 0, 1367, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338408408fc', '广昌县', 'pub', '361030', 'cskefu', NULL, '297e1e874f83129d014f8334f1a302ca', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:45', '2015-08-31 18:05:45', 0, 1368, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833840aa08fd', '市辖区', 'pub', '361101', 'cskefu', NULL, '297e1e874f83129d014f8334f1b202cb', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:46', '2015-08-31 18:05:46', 0, 1369, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833840ba08fe', '信州区', 'pub', '361102', 'cskefu', NULL, '297e1e874f83129d014f8334f1b202cb', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:46', '2015-08-31 18:05:46', 0, 1370, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833840c608ff', '上饶县', 'pub', '361121', 'cskefu', NULL, '297e1e874f83129d014f8334f1b202cb', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:46', '2015-08-31 18:05:46', 0, 1371, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833840d10900', '广丰县', 'pub', '361122', 'cskefu', NULL, '297e1e874f83129d014f8334f1b202cb', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:46', '2015-08-31 18:05:46', 0, 1372, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833840de0901', '玉山县', 'pub', '361123', 'cskefu', NULL, '297e1e874f83129d014f8334f1b202cb', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:46', '2015-08-31 18:05:46', 0, 1373, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833840eb0902', '铅山县', 'pub', '361124', 'cskefu', NULL, '297e1e874f83129d014f8334f1b202cb', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:46', '2015-08-31 18:05:46', 0, 1374, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833840f70903', '横峰县', 'pub', '361125', 'cskefu', NULL, '297e1e874f83129d014f8334f1b202cb', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:46', '2015-08-31 18:05:46', 0, 1375, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833841030904', '弋阳县', 'pub', '361126', 'cskefu', NULL, '297e1e874f83129d014f8334f1b202cb', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:46', '2015-08-31 18:05:46', 0, 1376, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338410f0905', '余干县', 'pub', '361127', 'cskefu', NULL, '297e1e874f83129d014f8334f1b202cb', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:46', '2015-08-31 18:05:46', 0, 1377, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338411c0906', '鄱阳县', 'pub', '361128', 'cskefu', NULL, '297e1e874f83129d014f8334f1b202cb', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:46', '2015-08-31 18:05:46', 0, 1378, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833842550907', '万年县', 'pub', '361129', 'cskefu', NULL, '297e1e874f83129d014f8334f1b202cb', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:46', '2015-08-31 18:05:46', 0, 1379, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833842610908', '婺源县', 'pub', '361130', 'cskefu', NULL, '297e1e874f83129d014f8334f1b202cb', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:46', '2015-08-31 18:05:46', 0, 1380, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833842710909', '德兴市', 'pub', '361181', 'cskefu', NULL, '297e1e874f83129d014f8334f1b202cb', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:46', '2015-08-31 18:05:46', 0, 1381, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83384299090a', '市辖区', 'pub', '370101', 'cskefu', NULL, '297e1e874f83129d014f8334f1da02cc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:46', '2015-08-31 18:05:46', 0, 1382, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833842a7090b', '历下区', 'pub', '370102', 'cskefu', NULL, '297e1e874f83129d014f8334f1da02cc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:46', '2015-08-31 18:05:46', 0, 1383, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833842b5090c', '市中区', 'pub', '370103', 'cskefu', NULL, '297e1e874f83129d014f8334f1da02cc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:46', '2015-08-31 18:05:46', 0, 1384, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833842c8090d', '槐荫区', 'pub', '370104', 'cskefu', NULL, '297e1e874f83129d014f8334f1da02cc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:46', '2015-08-31 18:05:46', 0, 1385, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833842d6090e', '天桥区', 'pub', '370105', 'cskefu', NULL, '297e1e874f83129d014f8334f1da02cc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:46', '2015-08-31 18:05:46', 0, 1386, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833842e5090f', '历城区', 'pub', '370112', 'cskefu', NULL, '297e1e874f83129d014f8334f1da02cc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:46', '2015-08-31 18:05:46', 0, 1387, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833842f30910', '长清区', 'pub', '370113', 'cskefu', NULL, '297e1e874f83129d014f8334f1da02cc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:46', '2015-08-31 18:05:46', 0, 1388, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833842ff0911', '平阴县', 'pub', '370124', 'cskefu', NULL, '297e1e874f83129d014f8334f1da02cc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:46', '2015-08-31 18:05:46', 0, 1389, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338430d0912', '济阳县', 'pub', '370125', 'cskefu', NULL, '297e1e874f83129d014f8334f1da02cc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:46', '2015-08-31 18:05:46', 0, 1390, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338431b0913', '商河县', 'pub', '370126', 'cskefu', NULL, '297e1e874f83129d014f8334f1da02cc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:46', '2015-08-31 18:05:46', 0, 1391, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833844580915', '章丘市', 'pub', '370181', 'cskefu', NULL, '297e1e874f83129d014f8334f1da02cc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:46', '2015-08-31 18:05:46', 0, 1392, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833844820916', '市辖区', 'pub', '370201', 'cskefu', NULL, '297e1e874f83129d014f8334f1e902cd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:47', '2015-08-31 18:05:47', 0, 1393, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833844910917', '市南区', 'pub', '370202', 'cskefu', NULL, '297e1e874f83129d014f8334f1e902cd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:47', '2015-08-31 18:05:47', 0, 1394, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833844ac0918', '市北区', 'pub', '370203', 'cskefu', NULL, '297e1e874f83129d014f8334f1e902cd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:47', '2015-08-31 18:05:47', 0, 1395, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833844bc0919', '四方区', 'pub', '370205', 'cskefu', NULL, '297e1e874f83129d014f8334f1e902cd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:47', '2015-08-31 18:05:47', 0, 1396, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833844c8091a', '黄岛区', 'pub', '370211', 'cskefu', NULL, '297e1e874f83129d014f8334f1e902cd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:47', '2015-08-31 18:05:47', 0, 1397, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833844d8091b', '崂山区', 'pub', '370212', 'cskefu', NULL, '297e1e874f83129d014f8334f1e902cd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:47', '2015-08-31 18:05:47', 0, 1398, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83384533091c', '李沧区', 'pub', '370213', 'cskefu', NULL, '297e1e874f83129d014f8334f1e902cd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:47', '2015-08-31 18:05:47', 0, 1399, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83384542091d', '城阳区', 'pub', '370214', 'cskefu', NULL, '297e1e874f83129d014f8334f1e902cd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:47', '2015-08-31 18:05:47', 0, 1400, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83384554091e', '胶州市', 'pub', '370281', 'cskefu', NULL, '297e1e874f83129d014f8334f1e902cd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:47', '2015-08-31 18:05:47', 0, 1401, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83384564091f', '即墨市', 'pub', '370282', 'cskefu', NULL, '297e1e874f83129d014f8334f1e902cd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:47', '2015-08-31 18:05:47', 0, 1402, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833845780920', '平度市', 'pub', '370283', 'cskefu', NULL, '297e1e874f83129d014f8334f1e902cd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:47', '2015-08-31 18:05:47', 0, 1403, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833845880921', '胶南市', 'pub', '370284', 'cskefu', NULL, '297e1e874f83129d014f8334f1e902cd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:47', '2015-08-31 18:05:47', 0, 1404, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833845a40922', '莱西市', 'pub', '370285', 'cskefu', NULL, '297e1e874f83129d014f8334f1e902cd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:47', '2015-08-31 18:05:47', 0, 1405, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833845da0923', '市辖区', 'pub', '370301', 'cskefu', NULL, '297e1e874f83129d014f8334f20c02ce', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:47', '2015-08-31 18:05:47', 0, 1406, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833847130924', '淄川区', 'pub', '370302', 'cskefu', NULL, '297e1e874f83129d014f8334f20c02ce', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:47', '2015-08-31 18:05:47', 0, 1407, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338471f0925', '张店区', 'pub', '370303', 'cskefu', NULL, '297e1e874f83129d014f8334f20c02ce', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:47', '2015-08-31 18:05:47', 0, 1408, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338472d0926', '博山区', 'pub', '370304', 'cskefu', NULL, '297e1e874f83129d014f8334f20c02ce', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:47', '2015-08-31 18:05:47', 0, 1409, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833847390927', '临淄区', 'pub', '370305', 'cskefu', NULL, '297e1e874f83129d014f8334f20c02ce', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:47', '2015-08-31 18:05:47', 0, 1410, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833847450928', '周村区', 'pub', '370306', 'cskefu', NULL, '297e1e874f83129d014f8334f20c02ce', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:47', '2015-08-31 18:05:47', 0, 1411, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833847530929', '桓台县', 'pub', '370321', 'cskefu', NULL, '297e1e874f83129d014f8334f20c02ce', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:47', '2015-08-31 18:05:47', 0, 1412, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83384761092a', '高青县', 'pub', '370322', 'cskefu', NULL, '297e1e874f83129d014f8334f20c02ce', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:47', '2015-08-31 18:05:47', 0, 1413, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83384773092b', '沂源县', 'pub', '370323', 'cskefu', NULL, '297e1e874f83129d014f8334f20c02ce', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:47', '2015-08-31 18:05:47', 0, 1414, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338479e092c', '市辖区', 'pub', '370401', 'cskefu', NULL, '297e1e874f83129d014f8334f21e02cf', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:47', '2015-08-31 18:05:47', 0, 1415, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833847ae092d', '市中区', 'pub', '370402', 'cskefu', NULL, '297e1e874f83129d014f8334f21e02cf', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:47', '2015-08-31 18:05:47', 0, 1416, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833847be092e', '薛城区', 'pub', '370403', 'cskefu', NULL, '297e1e874f83129d014f8334f21e02cf', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:47', '2015-08-31 18:05:47', 0, 1417, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833847cc092f', '峄城区', 'pub', '370404', 'cskefu', NULL, '297e1e874f83129d014f8334f21e02cf', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:47', '2015-08-31 18:05:47', 0, 1418, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338495c0930', '台儿庄区', 'pub', '370405', 'cskefu', NULL, '297e1e874f83129d014f8334f21e02cf', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:48', '2015-08-31 18:05:48', 0, 1419, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833849920931', '山亭区', 'pub', '370406', 'cskefu', NULL, '297e1e874f83129d014f8334f21e02cf', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:48', '2015-08-31 18:05:48', 0, 1420, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833849a60932', '滕州市', 'pub', '370481', 'cskefu', NULL, '297e1e874f83129d014f8334f21e02cf', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:48', '2015-08-31 18:05:48', 0, 1421, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833849d30933', '市辖区', 'pub', '370501', 'cskefu', NULL, '297e1e874f83129d014f8334f22d02d0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:48', '2015-08-31 18:05:48', 0, 1422, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833849df0934', '东营区', 'pub', '370502', 'cskefu', NULL, '297e1e874f83129d014f8334f22d02d0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:48', '2015-08-31 18:05:48', 0, 1423, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833849f10935', '河口区', 'pub', '370503', 'cskefu', NULL, '297e1e874f83129d014f8334f22d02d0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:48', '2015-08-31 18:05:48', 0, 1424, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83384a020936', '垦利县', 'pub', '370521', 'cskefu', NULL, '297e1e874f83129d014f8334f22d02d0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:48', '2015-08-31 18:05:48', 0, 1425, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83384a110937', '利津县', 'pub', '370522', 'cskefu', NULL, '297e1e874f83129d014f8334f22d02d0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:48', '2015-08-31 18:05:48', 0, 1426, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83384a210938', '广饶县', 'pub', '370523', 'cskefu', NULL, '297e1e874f83129d014f8334f22d02d0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:48', '2015-08-31 18:05:48', 0, 1427, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83384a530939', '市辖区', 'pub', '370601', 'cskefu', NULL, '297e1e874f83129d014f8334f23d02d1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:48', '2015-08-31 18:05:48', 0, 1428, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83384a63093a', '芝罘区', 'pub', '370602', 'cskefu', NULL, '297e1e874f83129d014f8334f23d02d1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:48', '2015-08-31 18:05:48', 0, 1429, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83384a73093b', '福山区', 'pub', '370611', 'cskefu', NULL, '297e1e874f83129d014f8334f23d02d1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:48', '2015-08-31 18:05:48', 0, 1430, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83384a80093c', '牟平区', 'pub', '370612', 'cskefu', NULL, '297e1e874f83129d014f8334f23d02d1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:48', '2015-08-31 18:05:48', 0, 1431, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83384a8c093d', '莱山区', 'pub', '370613', 'cskefu', NULL, '297e1e874f83129d014f8334f23d02d1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:48', '2015-08-31 18:05:48', 0, 1432, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83384a9b093e', '长岛县', 'pub', '370634', 'cskefu', NULL, '297e1e874f83129d014f8334f23d02d1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:48', '2015-08-31 18:05:48', 0, 1433, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83384aa9093f', '龙口市', 'pub', '370681', 'cskefu', NULL, '297e1e874f83129d014f8334f23d02d1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:48', '2015-08-31 18:05:48', 0, 1434, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83384ab80940', '莱阳市', 'pub', '370682', 'cskefu', NULL, '297e1e874f83129d014f8334f23d02d1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:48', '2015-08-31 18:05:48', 0, 1435, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83384ac40941', '莱州市', 'pub', '370683', 'cskefu', NULL, '297e1e874f83129d014f8334f23d02d1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:48', '2015-08-31 18:05:48', 0, 1436, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83384acf0942', '蓬莱市', 'pub', '370684', 'cskefu', NULL, '297e1e874f83129d014f8334f23d02d1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:48', '2015-08-31 18:05:48', 0, 1437, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83384ada0943', '招远市', 'pub', '370685', 'cskefu', NULL, '297e1e874f83129d014f8334f23d02d1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:48', '2015-08-31 18:05:48', 0, 1438, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83384c150944', '栖霞市', 'pub', '370686', 'cskefu', NULL, '297e1e874f83129d014f8334f23d02d1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:48', '2015-08-31 18:05:48', 0, 1439, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83384c260945', '海阳市', 'pub', '370687', 'cskefu', NULL, '297e1e874f83129d014f8334f23d02d1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:48', '2015-08-31 18:05:48', 0, 1440, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83384c640946', '市辖区', 'pub', '370701', 'cskefu', NULL, '297e1e874f83129d014f8334f37702d2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:49', '2015-08-31 18:05:49', 0, 1441, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83384c740947', '潍城区', 'pub', '370702', 'cskefu', NULL, '297e1e874f83129d014f8334f37702d2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:49', '2015-08-31 18:05:49', 0, 1442, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83384c8c0948', '寒亭区', 'pub', '370703', 'cskefu', NULL, '297e1e874f83129d014f8334f37702d2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:49', '2015-08-31 18:05:49', 0, 1443, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83384c9e0949', '坊子区', 'pub', '370704', 'cskefu', NULL, '297e1e874f83129d014f8334f37702d2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:49', '2015-08-31 18:05:49', 0, 1444, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83384cad094a', '奎文区', 'pub', '370705', 'cskefu', NULL, '297e1e874f83129d014f8334f37702d2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:49', '2015-08-31 18:05:49', 0, 1445, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83384cc4094b', '临朐县', 'pub', '370724', 'cskefu', NULL, '297e1e874f83129d014f8334f37702d2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:49', '2015-08-31 18:05:49', 0, 1446, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83384ce7094c', '昌乐县', 'pub', '370725', 'cskefu', NULL, '297e1e874f83129d014f8334f37702d2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:49', '2015-08-31 18:05:49', 0, 1447, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83384cf5094d', '青州市', 'pub', '370781', 'cskefu', NULL, '297e1e874f83129d014f8334f37702d2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:49', '2015-08-31 18:05:49', 0, 1448, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83384d1d094e', '诸城市', 'pub', '370782', 'cskefu', NULL, '297e1e874f83129d014f8334f37702d2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:49', '2015-08-31 18:05:49', 0, 1449, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83384d2c094f', '寿光市', 'pub', '370783', 'cskefu', NULL, '297e1e874f83129d014f8334f37702d2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:49', '2015-08-31 18:05:49', 0, 1450, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83384d3d0950', '安丘市', 'pub', '370784', 'cskefu', NULL, '297e1e874f83129d014f8334f37702d2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:49', '2015-08-31 18:05:49', 0, 1451, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83384d4e0951', '高密市', 'pub', '370785', 'cskefu', NULL, '297e1e874f83129d014f8334f37702d2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:49', '2015-08-31 18:05:49', 0, 1452, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83384d630952', '昌邑市', 'pub', '370786', 'cskefu', NULL, '297e1e874f83129d014f8334f37702d2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:49', '2015-08-31 18:05:49', 0, 1453, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83384da30953', '市辖区', 'pub', '370801', 'cskefu', NULL, '297e1e874f83129d014f8334f38a02d3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:49', '2015-08-31 18:05:49', 0, 1454, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83384dc10954', '市中区', 'pub', '370802', 'cskefu', NULL, '297e1e874f83129d014f8334f38a02d3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:49', '2015-08-31 18:05:49', 0, 1455, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83384ddc0955', '任城区', 'pub', '370811', 'cskefu', NULL, '297e1e874f83129d014f8334f38a02d3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:49', '2015-08-31 18:05:49', 0, 1456, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83384df90956', '微山县', 'pub', '370826', 'cskefu', NULL, '297e1e874f83129d014f8334f38a02d3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:49', '2015-08-31 18:05:49', 0, 1457, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83384e1a0957', '鱼台县', 'pub', '370827', 'cskefu', NULL, '297e1e874f83129d014f8334f38a02d3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:49', '2015-08-31 18:05:49', 0, 1458, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83384e4d0958', '金乡县', 'pub', '370828', 'cskefu', NULL, '297e1e874f83129d014f8334f38a02d3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:49', '2015-08-31 18:05:49', 0, 1459, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83384e5c0959', '嘉祥县', 'pub', '370829', 'cskefu', NULL, '297e1e874f83129d014f8334f38a02d3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:49', '2015-08-31 18:05:49', 0, 1460, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83384e6c095a', '汶上县', 'pub', '370830', 'cskefu', NULL, '297e1e874f83129d014f8334f38a02d3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:49', '2015-08-31 18:05:49', 0, 1461, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83384fa4095b', '泗水县', 'pub', '370831', 'cskefu', NULL, '297e1e874f83129d014f8334f38a02d3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:49', '2015-08-31 18:05:49', 0, 1462, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83384fb5095c', '梁山县', 'pub', '370832', 'cskefu', NULL, '297e1e874f83129d014f8334f38a02d3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:49', '2015-08-31 18:05:49', 0, 1463, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83384fc2095d', '曲阜市', 'pub', '370881', 'cskefu', NULL, '297e1e874f83129d014f8334f38a02d3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:49', '2015-08-31 18:05:49', 0, 1464, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83384fd3095e', '兖州市', 'pub', '370882', 'cskefu', NULL, '297e1e874f83129d014f8334f38a02d3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:49', '2015-08-31 18:05:49', 0, 1465, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83384fe5095f', '邹城市', 'pub', '370883', 'cskefu', NULL, '297e1e874f83129d014f8334f38a02d3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:49', '2015-08-31 18:05:49', 0, 1466, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338500f0960', '市辖区', 'pub', '370901', 'cskefu', NULL, '297e1e874f83129d014f8334f39602d4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:49', '2015-08-31 18:05:49', 0, 1467, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338501c0961', '泰山区', 'pub', '370902', 'cskefu', NULL, '297e1e874f83129d014f8334f39602d4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:49', '2015-08-31 18:05:49', 0, 1468, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833850280962', '岱岳区', 'pub', '370903', 'cskefu', NULL, '297e1e874f83129d014f8334f39602d4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:49', '2015-08-31 18:05:49', 0, 1469, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833850340963', '宁阳县', 'pub', '370921', 'cskefu', NULL, '297e1e874f83129d014f8334f39602d4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:50', '2015-08-31 18:05:50', 0, 1470, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833850400964', '东平县', 'pub', '370923', 'cskefu', NULL, '297e1e874f83129d014f8334f39602d4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:50', '2015-08-31 18:05:50', 0, 1471, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833850510965', '新泰市', 'pub', '370982', 'cskefu', NULL, '297e1e874f83129d014f8334f39602d4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:50', '2015-08-31 18:05:50', 0, 1472, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833850600966', '肥城市', 'pub', '370983', 'cskefu', NULL, '297e1e874f83129d014f8334f39602d4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:50', '2015-08-31 18:05:50', 0, 1473, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833850910967', '市辖区', 'pub', '371001', 'cskefu', NULL, '297e1e874f83129d014f8334f3a202d5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:50', '2015-08-31 18:05:50', 0, 1474, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338509e0968', '环翠区', 'pub', '371002', 'cskefu', NULL, '297e1e874f83129d014f8334f3a202d5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:50', '2015-08-31 18:05:50', 0, 1475, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833851d70969', '文登市', 'pub', '371081', 'cskefu', NULL, '297e1e874f83129d014f8334f3a202d5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:50', '2015-08-31 18:05:50', 0, 1476, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833851e2096a', '荣成市', 'pub', '371082', 'cskefu', NULL, '297e1e874f83129d014f8334f3a202d5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:50', '2015-08-31 18:05:50', 0, 1477, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833851ee096b', '乳山市', 'pub', '371083', 'cskefu', NULL, '297e1e874f83129d014f8334f3a202d5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:50', '2015-08-31 18:05:50', 0, 1478, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83385214096c', '市辖区', 'pub', '371101', 'cskefu', NULL, '297e1e874f83129d014f8334f3b002d6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:50', '2015-08-31 18:05:50', 0, 1479, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338522c096d', '东港区', 'pub', '371102', 'cskefu', NULL, '297e1e874f83129d014f8334f3b002d6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:50', '2015-08-31 18:05:50', 0, 1480, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338523b096e', '岚山区', 'pub', '371103', 'cskefu', NULL, '297e1e874f83129d014f8334f3b002d6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:50', '2015-08-31 18:05:50', 0, 1481, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83385249096f', '五莲县', 'pub', '371121', 'cskefu', NULL, '297e1e874f83129d014f8334f3b002d6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:50', '2015-08-31 18:05:50', 0, 1482, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833852570970', '莒　县', 'pub', '371122', 'cskefu', NULL, '297e1e874f83129d014f8334f3b002d6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:50', '2015-08-31 18:05:50', 0, 1483, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833852830971', '市辖区', 'pub', '371201', 'cskefu', NULL, '297e1e874f83129d014f8334f3c302d7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:50', '2015-08-31 18:05:50', 0, 1484, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833852940972', '莱城区', 'pub', '371202', 'cskefu', NULL, '297e1e874f83129d014f8334f3c302d7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:50', '2015-08-31 18:05:50', 0, 1485, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833852ae0973', '钢城区', 'pub', '371203', 'cskefu', NULL, '297e1e874f83129d014f8334f3c302d7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:50', '2015-08-31 18:05:50', 0, 1486, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338540b0974', '市辖区', 'pub', '371301', 'cskefu', NULL, '297e1e874f83129d014f8334f3d202d8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:50', '2015-08-31 18:05:50', 0, 1487, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338541a0975', '兰山区', 'pub', '371302', 'cskefu', NULL, '297e1e874f83129d014f8334f3d202d8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:51', '2015-08-31 18:05:51', 0, 1488, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338542a0976', '罗庄区', 'pub', '371311', 'cskefu', NULL, '297e1e874f83129d014f8334f3d202d8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:51', '2015-08-31 18:05:51', 0, 1489, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833854380977', '河东区', 'pub', '371312', 'cskefu', NULL, '297e1e874f83129d014f8334f3d202d8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:51', '2015-08-31 18:05:51', 0, 1490, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833854470978', '沂南县', 'pub', '371321', 'cskefu', NULL, '297e1e874f83129d014f8334f3d202d8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:51', '2015-08-31 18:05:51', 0, 1491, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833854550979', '郯城县', 'pub', '371322', 'cskefu', NULL, '297e1e874f83129d014f8334f3d202d8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:51', '2015-08-31 18:05:51', 0, 1492, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83385462097a', '沂水县', 'pub', '371323', 'cskefu', NULL, '297e1e874f83129d014f8334f3d202d8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:51', '2015-08-31 18:05:51', 0, 1493, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83385473097b', '苍山县', 'pub', '371324', 'cskefu', NULL, '297e1e874f83129d014f8334f3d202d8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:51', '2015-08-31 18:05:51', 0, 1494, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83385481097c', '费　县', 'pub', '371325', 'cskefu', NULL, '297e1e874f83129d014f8334f3d202d8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:51', '2015-08-31 18:05:51', 0, 1495, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83385490097d', '平邑县', 'pub', '371326', 'cskefu', NULL, '297e1e874f83129d014f8334f3d202d8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:51', '2015-08-31 18:05:51', 0, 1496, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833854a1097e', '莒南县', 'pub', '371327', 'cskefu', NULL, '297e1e874f83129d014f8334f3d202d8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:51', '2015-08-31 18:05:51', 0, 1497, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833854b0097f', '蒙阴县', 'pub', '371328', 'cskefu', NULL, '297e1e874f83129d014f8334f3d202d8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:51', '2015-08-31 18:05:51', 0, 1498, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833854be0980', '临沭县', 'pub', '371329', 'cskefu', NULL, '297e1e874f83129d014f8334f3d202d8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:51', '2015-08-31 18:05:51', 0, 1499, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833854eb0981', '市辖区', 'pub', '371401', 'cskefu', NULL, '297e1e874f83129d014f8334f3dd02d9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:51', '2015-08-31 18:05:51', 0, 1500, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833856400982', '德城区', 'pub', '371402', 'cskefu', NULL, '297e1e874f83129d014f8334f3dd02d9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:51', '2015-08-31 18:05:51', 0, 1501, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833856510983', '陵　县', 'pub', '371421', 'cskefu', NULL, '297e1e874f83129d014f8334f3dd02d9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:51', '2015-08-31 18:05:51', 0, 1502, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338565d0984', '宁津县', 'pub', '371422', 'cskefu', NULL, '297e1e874f83129d014f8334f3dd02d9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:51', '2015-08-31 18:05:51', 0, 1503, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833856850985', '庆云县', 'pub', '371423', 'cskefu', NULL, '297e1e874f83129d014f8334f3dd02d9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:51', '2015-08-31 18:05:51', 0, 1504, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833856be0986', '临邑县', 'pub', '371424', 'cskefu', NULL, '297e1e874f83129d014f8334f3dd02d9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:51', '2015-08-31 18:05:51', 0, 1505, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833856cc0987', '齐河县', 'pub', '371425', 'cskefu', NULL, '297e1e874f83129d014f8334f3dd02d9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:51', '2015-08-31 18:05:51', 0, 1506, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833856db0988', '平原县', 'pub', '371426', 'cskefu', NULL, '297e1e874f83129d014f8334f3dd02d9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:51', '2015-08-31 18:05:51', 0, 1507, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833856e80989', '夏津县', 'pub', '371427', 'cskefu', NULL, '297e1e874f83129d014f8334f3dd02d9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:51', '2015-08-31 18:05:51', 0, 1508, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833856fa098a', '武城县', 'pub', '371428', 'cskefu', NULL, '297e1e874f83129d014f8334f3dd02d9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:51', '2015-08-31 18:05:51', 0, 1509, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83385708098c', '乐陵市', 'pub', '371481', 'cskefu', NULL, '297e1e874f83129d014f8334f3dd02d9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:51', '2015-08-31 18:05:51', 0, 1510, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83385714098d', '禹城市', 'pub', '371482', 'cskefu', NULL, '297e1e874f83129d014f8334f3dd02d9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:51', '2015-08-31 18:05:51', 0, 1511, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338573f098e', '市辖区', 'pub', '371501', 'cskefu', NULL, '297e1e874f83129d014f8334f3ec02da', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:51', '2015-08-31 18:05:51', 0, 1512, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83385750098f', '东昌府区', 'pub', '371502', 'cskefu', NULL, '297e1e874f83129d014f8334f3ec02da', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:51', '2015-08-31 18:05:51', 0, 1513, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338575d0990', '阳谷县', 'pub', '371521', 'cskefu', NULL, '297e1e874f83129d014f8334f3ec02da', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:51', '2015-08-31 18:05:51', 0, 1514, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338589c0991', '莘　县', 'pub', '371522', 'cskefu', NULL, '297e1e874f83129d014f8334f3ec02da', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:52', '2015-08-31 18:05:52', 0, 1515, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833858aa0992', '茌平县', 'pub', '371523', 'cskefu', NULL, '297e1e874f83129d014f8334f3ec02da', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:52', '2015-08-31 18:05:52', 0, 1516, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833858b90993', '东阿县', 'pub', '371524', 'cskefu', NULL, '297e1e874f83129d014f8334f3ec02da', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:52', '2015-08-31 18:05:52', 0, 1517, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833858c80994', '冠　县', 'pub', '371525', 'cskefu', NULL, '297e1e874f83129d014f8334f3ec02da', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:52', '2015-08-31 18:05:52', 0, 1518, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833858d70995', '高唐县', 'pub', '371526', 'cskefu', NULL, '297e1e874f83129d014f8334f3ec02da', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:52', '2015-08-31 18:05:52', 0, 1519, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833858ec0996', '临清市', 'pub', '371581', 'cskefu', NULL, '297e1e874f83129d014f8334f3ec02da', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:52', '2015-08-31 18:05:52', 0, 1520, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833859230997', '市辖区', 'pub', '371601', 'cskefu', NULL, '297e1e874f83129d014f8334f3fb02db', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:52', '2015-08-31 18:05:52', 0, 1521, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833859410998', '滨城区', 'pub', '371602', 'cskefu', NULL, '297e1e874f83129d014f8334f3fb02db', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:52', '2015-08-31 18:05:52', 0, 1522, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833859600999', '惠民县', 'pub', '371621', 'cskefu', NULL, '297e1e874f83129d014f8334f3fb02db', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:52', '2015-08-31 18:05:52', 0, 1523, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83385993099a', '阳信县', 'pub', '371622', 'cskefu', NULL, '297e1e874f83129d014f8334f3fb02db', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:52', '2015-08-31 18:05:52', 0, 1524, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833859b3099b', '无棣县', 'pub', '371623', 'cskefu', NULL, '297e1e874f83129d014f8334f3fb02db', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:52', '2015-08-31 18:05:52', 0, 1525, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833859cd099c', '沾化县', 'pub', '371624', 'cskefu', NULL, '297e1e874f83129d014f8334f3fb02db', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:52', '2015-08-31 18:05:52', 0, 1526, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833859e8099d', '博兴县', 'pub', '371625', 'cskefu', NULL, '297e1e874f83129d014f8334f3fb02db', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:52', '2015-08-31 18:05:52', 0, 1527, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833859fa099e', '邹平县', 'pub', '371626', 'cskefu', NULL, '297e1e874f83129d014f8334f3fb02db', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:52', '2015-08-31 18:05:52', 0, 1528, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83385a2f099f', '市辖区', 'pub', '371701', 'cskefu', NULL, '297e1e874f83129d014f8334f40802dc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:52', '2015-08-31 18:05:52', 0, 1529, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83385a3c09a0', '牡丹区', 'pub', '371702', 'cskefu', NULL, '297e1e874f83129d014f8334f40802dc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:52', '2015-08-31 18:05:52', 0, 1530, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83385a4a09a1', '曹　县', 'pub', '371721', 'cskefu', NULL, '297e1e874f83129d014f8334f40802dc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:52', '2015-08-31 18:05:52', 0, 1531, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83385a5609a2', '单　县', 'pub', '371722', 'cskefu', NULL, '297e1e874f83129d014f8334f40802dc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:52', '2015-08-31 18:05:52', 0, 1532, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83385a6609a3', '成武县', 'pub', '371723', 'cskefu', NULL, '297e1e874f83129d014f8334f40802dc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:52', '2015-08-31 18:05:52', 0, 1533, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83385a7409a4', '巨野县', 'pub', '371724', 'cskefu', NULL, '297e1e874f83129d014f8334f40802dc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:52', '2015-08-31 18:05:52', 0, 1534, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83385bb309a5', '郓城县', 'pub', '371725', 'cskefu', NULL, '297e1e874f83129d014f8334f40802dc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:52', '2015-08-31 18:05:52', 0, 1535, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83385bc109a6', '鄄城县', 'pub', '371726', 'cskefu', NULL, '297e1e874f83129d014f8334f40802dc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:52', '2015-08-31 18:05:52', 0, 1536, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83385bd209a7', '定陶县', 'pub', '371727', 'cskefu', NULL, '297e1e874f83129d014f8334f40802dc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:52', '2015-08-31 18:05:52', 0, 1537, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83385be709a8', '东明县', 'pub', '371728', 'cskefu', NULL, '297e1e874f83129d014f8334f40802dc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:52', '2015-08-31 18:05:52', 0, 1538, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83385c1209a9', '市辖区', 'pub', '410101', 'cskefu', NULL, '297e1e874f83129d014f8334f43002dd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:53', '2015-08-31 18:05:53', 0, 1539, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83385c1f09aa', '中原区', 'pub', '410102', 'cskefu', NULL, '297e1e874f83129d014f8334f43002dd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:53', '2015-08-31 18:05:53', 0, 1540, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83385c2e09ab', '二七区', 'pub', '410103', 'cskefu', NULL, '297e1e874f83129d014f8334f43002dd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:53', '2015-08-31 18:05:53', 0, 1541, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83385c3b09ac', '管城回族区', 'pub', '410104', 'cskefu', NULL, '297e1e874f83129d014f8334f43002dd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:53', '2015-08-31 18:05:53', 0, 1542, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83385c4c09ad', '金水区', 'pub', '410105', 'cskefu', NULL, '297e1e874f83129d014f8334f43002dd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:53', '2015-08-31 18:05:53', 0, 1543, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83385cb009ae', '上街区', 'pub', '410106', 'cskefu', NULL, '297e1e874f83129d014f8334f43002dd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:53', '2015-08-31 18:05:53', 0, 1544, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83385cd909af', '邙山区', 'pub', '410108', 'cskefu', NULL, '297e1e874f83129d014f8334f43002dd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:53', '2015-08-31 18:05:53', 0, 1545, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83385cf909b0', '中牟县', 'pub', '410122', 'cskefu', NULL, '297e1e874f83129d014f8334f43002dd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:53', '2015-08-31 18:05:53', 0, 1546, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83385d0709b1', '巩义市', 'pub', '410181', 'cskefu', NULL, '297e1e874f83129d014f8334f43002dd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:53', '2015-08-31 18:05:53', 0, 1547, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83385d1409b2', '荥阳市', 'pub', '410182', 'cskefu', NULL, '297e1e874f83129d014f8334f43002dd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:53', '2015-08-31 18:05:53', 0, 1548, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83385d2109b3', '新密市', 'pub', '410183', 'cskefu', NULL, '297e1e874f83129d014f8334f43002dd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:53', '2015-08-31 18:05:53', 0, 1549, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83385d2e09b4', '新郑市', 'pub', '410184', 'cskefu', NULL, '297e1e874f83129d014f8334f43002dd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:53', '2015-08-31 18:05:53', 0, 1550, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83385d4309b5', '登封市', 'pub', '410185', 'cskefu', NULL, '297e1e874f83129d014f8334f43002dd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:53', '2015-08-31 18:05:53', 0, 1551, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83385d6909b6', '市辖区', 'pub', '410201', 'cskefu', NULL, '297e1e874f83129d014f8334f56b02de', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:53', '2015-08-31 18:05:53', 0, 1552, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83385d7709b7', '龙亭区', 'pub', '410202', 'cskefu', NULL, '297e1e874f83129d014f8334f56b02de', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:53', '2015-08-31 18:05:53', 0, 1553, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83385d8309b8', '顺河回族区', 'pub', '410203', 'cskefu', NULL, '297e1e874f83129d014f8334f56b02de', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:53', '2015-08-31 18:05:53', 0, 1554, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83385ebb09b9', '鼓楼区', 'pub', '410204', 'cskefu', NULL, '297e1e874f83129d014f8334f56b02de', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:53', '2015-08-31 18:05:53', 0, 1555, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83385ec709ba', '南关区', 'pub', '410205', 'cskefu', NULL, '297e1e874f83129d014f8334f56b02de', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:53', '2015-08-31 18:05:53', 0, 1556, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83385ed409bb', '郊　区', 'pub', '410211', 'cskefu', NULL, '297e1e874f83129d014f8334f56b02de', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:53', '2015-08-31 18:05:53', 0, 1557, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83385ee409bc', '杞　县', 'pub', '410221', 'cskefu', NULL, '297e1e874f83129d014f8334f56b02de', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:53', '2015-08-31 18:05:53', 0, 1558, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83385f1009bd', '通许县', 'pub', '410222', 'cskefu', NULL, '297e1e874f83129d014f8334f56b02de', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:53', '2015-08-31 18:05:53', 0, 1559, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83385f1f09be', '尉氏县', 'pub', '410223', 'cskefu', NULL, '297e1e874f83129d014f8334f56b02de', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:53', '2015-08-31 18:05:53', 0, 1560, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83385f2d09bf', '开封县', 'pub', '410224', 'cskefu', NULL, '297e1e874f83129d014f8334f56b02de', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:53', '2015-08-31 18:05:53', 0, 1561, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83385f3a09c0', '兰考县', 'pub', '410225', 'cskefu', NULL, '297e1e874f83129d014f8334f56b02de', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:53', '2015-08-31 18:05:53', 0, 1562, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83385f6c09c1', '市辖区', 'pub', '410301', 'cskefu', NULL, '297e1e874f83129d014f8334f57a02df', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:53', '2015-08-31 18:05:53', 0, 1563, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83385fcc09c2', '老城区', 'pub', '410302', 'cskefu', NULL, '297e1e874f83129d014f8334f57a02df', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:53', '2015-08-31 18:05:53', 0, 1564, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83385fda09c3', '西工区', 'pub', '410303', 'cskefu', NULL, '297e1e874f83129d014f8334f57a02df', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:54', '2015-08-31 18:05:54', 0, 1565, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83385fe709c4', '廛河回族区', 'pub', '410304', 'cskefu', NULL, '297e1e874f83129d014f8334f57a02df', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:54', '2015-08-31 18:05:54', 0, 1566, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83385ffa09c5', '涧西区', 'pub', '410305', 'cskefu', NULL, '297e1e874f83129d014f8334f57a02df', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:54', '2015-08-31 18:05:54', 0, 1567, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338600b09c6', '吉利区', 'pub', '410306', 'cskefu', NULL, '297e1e874f83129d014f8334f57a02df', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:54', '2015-08-31 18:05:54', 0, 1568, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338601b09c7', '洛龙区', 'pub', '410307', 'cskefu', NULL, '297e1e874f83129d014f8334f57a02df', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:54', '2015-08-31 18:05:54', 0, 1569, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338602a09c8', '孟津县', 'pub', '410322', 'cskefu', NULL, '297e1e874f83129d014f8334f57a02df', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:54', '2015-08-31 18:05:54', 0, 1570, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338603809c9', '新安县', 'pub', '410323', 'cskefu', NULL, '297e1e874f83129d014f8334f57a02df', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:54', '2015-08-31 18:05:54', 0, 1571, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338604809ca', '栾川县', 'pub', '410324', 'cskefu', NULL, '297e1e874f83129d014f8334f57a02df', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:54', '2015-08-31 18:05:54', 0, 1572, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338605609cb', '嵩　县', 'pub', '410325', 'cskefu', NULL, '297e1e874f83129d014f8334f57a02df', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:54', '2015-08-31 18:05:54', 0, 1573, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338619009cc', '汝阳县', 'pub', '410326', 'cskefu', NULL, '297e1e874f83129d014f8334f57a02df', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:54', '2015-08-31 18:05:54', 0, 1574, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338619d09cd', '宜阳县', 'pub', '410327', 'cskefu', NULL, '297e1e874f83129d014f8334f57a02df', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:54', '2015-08-31 18:05:54', 0, 1575, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833861a909ce', '洛宁县', 'pub', '410328', 'cskefu', NULL, '297e1e874f83129d014f8334f57a02df', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:54', '2015-08-31 18:05:54', 0, 1576, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833861b509cf', '伊川县', 'pub', '410329', 'cskefu', NULL, '297e1e874f83129d014f8334f57a02df', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:54', '2015-08-31 18:05:54', 0, 1577, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833861c209d0', '偃师市', 'pub', '410381', 'cskefu', NULL, '297e1e874f83129d014f8334f57a02df', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:54', '2015-08-31 18:05:54', 0, 1578, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833861e809d1', '市辖区', 'pub', '410401', 'cskefu', NULL, '297e1e874f83129d014f8334f59902e0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:54', '2015-08-31 18:05:54', 0, 1579, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833861f609d2', '新华区', 'pub', '410402', 'cskefu', NULL, '297e1e874f83129d014f8334f59902e0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:54', '2015-08-31 18:05:54', 0, 1580, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338620209d3', '卫东区', 'pub', '410403', 'cskefu', NULL, '297e1e874f83129d014f8334f59902e0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:54', '2015-08-31 18:05:54', 0, 1581, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338620f09d4', '石龙区', 'pub', '410404', 'cskefu', NULL, '297e1e874f83129d014f8334f59902e0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:54', '2015-08-31 18:05:54', 0, 1582, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338621d09d5', '湛河区', 'pub', '410411', 'cskefu', NULL, '297e1e874f83129d014f8334f59902e0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:54', '2015-08-31 18:05:54', 0, 1583, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338622e09d6', '宝丰县', 'pub', '410421', 'cskefu', NULL, '297e1e874f83129d014f8334f59902e0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:54', '2015-08-31 18:05:54', 0, 1584, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338624009d7', '叶　县', 'pub', '410422', 'cskefu', NULL, '297e1e874f83129d014f8334f59902e0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:54', '2015-08-31 18:05:54', 0, 1585, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338626509d8', '鲁山县', 'pub', '410423', 'cskefu', NULL, '297e1e874f83129d014f8334f59902e0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:54', '2015-08-31 18:05:54', 0, 1586, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833863a209d9', '郏　县', 'pub', '410425', 'cskefu', NULL, '297e1e874f83129d014f8334f59902e0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:54', '2015-08-31 18:05:54', 0, 1587, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833863af09da', '舞钢市', 'pub', '410481', 'cskefu', NULL, '297e1e874f83129d014f8334f59902e0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:54', '2015-08-31 18:05:54', 0, 1588, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833863c009db', '汝州市', 'pub', '410482', 'cskefu', NULL, '297e1e874f83129d014f8334f59902e0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:55', '2015-08-31 18:05:55', 0, 1589, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833863e909dc', '市辖区', 'pub', '410501', 'cskefu', NULL, '297e1e874f83129d014f8334f5a902e1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:55', '2015-08-31 18:05:55', 0, 1590, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833863f509dd', '文峰区', 'pub', '410502', 'cskefu', NULL, '297e1e874f83129d014f8334f5a902e1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:55', '2015-08-31 18:05:55', 0, 1591, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338640209de', '北关区', 'pub', '410503', 'cskefu', NULL, '297e1e874f83129d014f8334f5a902e1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:55', '2015-08-31 18:05:55', 0, 1592, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338640f09df', '殷都区', 'pub', '410505', 'cskefu', NULL, '297e1e874f83129d014f8334f5a902e1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:55', '2015-08-31 18:05:55', 0, 1593, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338641d09e0', '龙安区', 'pub', '410506', 'cskefu', NULL, '297e1e874f83129d014f8334f5a902e1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:55', '2015-08-31 18:05:55', 0, 1594, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338642c09e1', '安阳县', 'pub', '410522', 'cskefu', NULL, '297e1e874f83129d014f8334f5a902e1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:55', '2015-08-31 18:05:55', 0, 1595, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338643e09e2', '汤阴县', 'pub', '410523', 'cskefu', NULL, '297e1e874f83129d014f8334f5a902e1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:55', '2015-08-31 18:05:55', 0, 1596, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338645009e3', '滑　县', 'pub', '410526', 'cskefu', NULL, '297e1e874f83129d014f8334f5a902e1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:55', '2015-08-31 18:05:55', 0, 1597, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338645c09e4', '内黄县', 'pub', '410527', 'cskefu', NULL, '297e1e874f83129d014f8334f5a902e1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:55', '2015-08-31 18:05:55', 0, 1598, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338646809e5', '林州市', 'pub', '410581', 'cskefu', NULL, '297e1e874f83129d014f8334f5a902e1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:55', '2015-08-31 18:05:55', 0, 1599, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338649b09e6', '市辖区', 'pub', '410601', 'cskefu', NULL, '297e1e874f83129d014f8334f5b602e2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:55', '2015-08-31 18:05:55', 0, 1600, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833865d609e7', '鹤山区', 'pub', '410602', 'cskefu', NULL, '297e1e874f83129d014f8334f5b602e2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:55', '2015-08-31 18:05:55', 0, 1601, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338661109e8', '山城区', 'pub', '410603', 'cskefu', NULL, '297e1e874f83129d014f8334f5b602e2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:55', '2015-08-31 18:05:55', 0, 1602, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338663d09e9', '淇滨区', 'pub', '410611', 'cskefu', NULL, '297e1e874f83129d014f8334f5b602e2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:55', '2015-08-31 18:05:55', 0, 1603, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338664b09ea', '浚　县', 'pub', '410621', 'cskefu', NULL, '297e1e874f83129d014f8334f5b602e2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:55', '2015-08-31 18:05:55', 0, 1604, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338665a09eb', '淇　县', 'pub', '410622', 'cskefu', NULL, '297e1e874f83129d014f8334f5b602e2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:55', '2015-08-31 18:05:55', 0, 1605, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338668309ec', '市辖区', 'pub', '410701', 'cskefu', NULL, '297e1e874f83129d014f8334f5c602e3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:55', '2015-08-31 18:05:55', 0, 1606, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338668f09ed', '红旗区', 'pub', '410702', 'cskefu', NULL, '297e1e874f83129d014f8334f5c602e3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:55', '2015-08-31 18:05:55', 0, 1607, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338669c09ee', '卫滨区', 'pub', '410703', 'cskefu', NULL, '297e1e874f83129d014f8334f5c602e3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:55', '2015-08-31 18:05:55', 0, 1608, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833866a809ef', '凤泉区', 'pub', '410704', 'cskefu', NULL, '297e1e874f83129d014f8334f5c602e3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:55', '2015-08-31 18:05:55', 0, 1609, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833866b409f0', '牧野区', 'pub', '410711', 'cskefu', NULL, '297e1e874f83129d014f8334f5c602e3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:55', '2015-08-31 18:05:55', 0, 1610, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833866c109f1', '新乡县', 'pub', '410721', 'cskefu', NULL, '297e1e874f83129d014f8334f5c602e3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:55', '2015-08-31 18:05:55', 0, 1611, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833866d109f2', '获嘉县', 'pub', '410724', 'cskefu', NULL, '297e1e874f83129d014f8334f5c602e3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:55', '2015-08-31 18:05:55', 0, 1612, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833866de09f3', '原阳县', 'pub', '410725', 'cskefu', NULL, '297e1e874f83129d014f8334f5c602e3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:55', '2015-08-31 18:05:55', 0, 1613, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833866e909f4', '延津县', 'pub', '410726', 'cskefu', NULL, '297e1e874f83129d014f8334f5c602e3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:55', '2015-08-31 18:05:55', 0, 1614, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833866f709f5', '封丘县', 'pub', '410727', 'cskefu', NULL, '297e1e874f83129d014f8334f5c602e3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:55', '2015-08-31 18:05:55', 0, 1615, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338670209f6', '长垣县', 'pub', '410728', 'cskefu', NULL, '297e1e874f83129d014f8334f5c602e3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:55', '2015-08-31 18:05:55', 0, 1616, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338683b09f7', '卫辉市', 'pub', '410781', 'cskefu', NULL, '297e1e874f83129d014f8334f5c602e3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:56', '2015-08-31 18:05:56', 0, 1617, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338684709f8', '辉县市', 'pub', '410782', 'cskefu', NULL, '297e1e874f83129d014f8334f5c602e3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:56', '2015-08-31 18:05:56', 0, 1618, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338686c09f9', '市辖区', 'pub', '410801', 'cskefu', NULL, '297e1e874f83129d014f8334f5d202e4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:56', '2015-08-31 18:05:56', 0, 1619, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338687809fa', '解放区', 'pub', '410802', 'cskefu', NULL, '297e1e874f83129d014f8334f5d202e4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:56', '2015-08-31 18:05:56', 0, 1620, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338688509fb', '中站区', 'pub', '410803', 'cskefu', NULL, '297e1e874f83129d014f8334f5d202e4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:56', '2015-08-31 18:05:56', 0, 1621, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338689609fc', '马村区', 'pub', '410804', 'cskefu', NULL, '297e1e874f83129d014f8334f5d202e4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:56', '2015-08-31 18:05:56', 0, 1622, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833869d209fd', '山阳区', 'pub', '410811', 'cskefu', NULL, '297e1e874f83129d014f8334f5d202e4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:56', '2015-08-31 18:05:56', 0, 1623, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833869df09fe', '修武县', 'pub', '410821', 'cskefu', NULL, '297e1e874f83129d014f8334f5d202e4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:56', '2015-08-31 18:05:56', 0, 1624, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833869ee09ff', '博爱县', 'pub', '410822', 'cskefu', NULL, '297e1e874f83129d014f8334f5d202e4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:56', '2015-08-31 18:05:56', 0, 1625, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833869fb0a00', '武陟县', 'pub', '410823', 'cskefu', NULL, '297e1e874f83129d014f8334f5d202e4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:56', '2015-08-31 18:05:56', 0, 1626, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83386a070a01', '温　县', 'pub', '410825', 'cskefu', NULL, '297e1e874f83129d014f8334f5d202e4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:56', '2015-08-31 18:05:56', 0, 1627, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83386a150a02', '济源市', 'pub', '410881', 'cskefu', NULL, '297e1e874f83129d014f8334f5d202e4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:56', '2015-08-31 18:05:56', 0, 1628, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83386a270a03', '沁阳市', 'pub', '410882', 'cskefu', NULL, '297e1e874f83129d014f8334f5d202e4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:56', '2015-08-31 18:05:56', 0, 1629, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83386a3a0a04', '孟州市', 'pub', '410883', 'cskefu', NULL, '297e1e874f83129d014f8334f5d202e4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:56', '2015-08-31 18:05:56', 0, 1630, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83386a620a05', '市辖区', 'pub', '410901', 'cskefu', NULL, '297e1e874f83129d014f8334f5e202e5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:56', '2015-08-31 18:05:56', 0, 1631, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83386a730a06', '华龙区', 'pub', '410902', 'cskefu', NULL, '297e1e874f83129d014f8334f5e202e5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:56', '2015-08-31 18:05:56', 0, 1632, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83386a820a08', '清丰县', 'pub', '410922', 'cskefu', NULL, '297e1e874f83129d014f8334f5e202e5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:56', '2015-08-31 18:05:56', 0, 1633, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83386bc60a09', '南乐县', 'pub', '410923', 'cskefu', NULL, '297e1e874f83129d014f8334f5e202e5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:57', '2015-08-31 18:05:57', 0, 1634, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83386bd60a0a', '范　县', 'pub', '410926', 'cskefu', NULL, '297e1e874f83129d014f8334f5e202e5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:57', '2015-08-31 18:05:57', 0, 1635, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83386be60a0b', '台前县', 'pub', '410927', 'cskefu', NULL, '297e1e874f83129d014f8334f5e202e5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:57', '2015-08-31 18:05:57', 0, 1636, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83386bf50a0c', '濮阳县', 'pub', '410928', 'cskefu', NULL, '297e1e874f83129d014f8334f5e202e5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:57', '2015-08-31 18:05:57', 0, 1637, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83386c350a0d', '市辖区', 'pub', '411001', 'cskefu', NULL, '297e1e874f83129d014f8334f5ef02e6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:57', '2015-08-31 18:05:57', 0, 1638, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83386c680a0e', '魏都区', 'pub', '411002', 'cskefu', NULL, '297e1e874f83129d014f8334f5ef02e6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:57', '2015-08-31 18:05:57', 0, 1639, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83386c810a0f', '许昌县', 'pub', '411023', 'cskefu', NULL, '297e1e874f83129d014f8334f5ef02e6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:57', '2015-08-31 18:05:57', 0, 1640, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83386c9c0a10', '鄢陵县', 'pub', '411024', 'cskefu', NULL, '297e1e874f83129d014f8334f5ef02e6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:57', '2015-08-31 18:05:57', 0, 1641, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83386cac0a11', '襄城县', 'pub', '411025', 'cskefu', NULL, '297e1e874f83129d014f8334f5ef02e6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:57', '2015-08-31 18:05:57', 0, 1642, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83386cc40a12', '禹州市', 'pub', '411081', 'cskefu', NULL, '297e1e874f83129d014f8334f5ef02e6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:57', '2015-08-31 18:05:57', 0, 1643, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83386cd90a13', '长葛市', 'pub', '411082', 'cskefu', NULL, '297e1e874f83129d014f8334f5ef02e6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:57', '2015-08-31 18:05:57', 0, 1644, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83386d040a14', '市辖区', 'pub', '411101', 'cskefu', NULL, '297e1e874f83129d014f8334f5fb02e7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:57', '2015-08-31 18:05:57', 0, 1645, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83386d130a15', '源汇区', 'pub', '411102', 'cskefu', NULL, '297e1e874f83129d014f8334f5fb02e7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:57', '2015-08-31 18:05:57', 0, 1646, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83386d1f0a16', '郾城区', 'pub', '411103', 'cskefu', NULL, '297e1e874f83129d014f8334f5fb02e7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:57', '2015-08-31 18:05:57', 0, 1647, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83386d310a17', '召陵区', 'pub', '411104', 'cskefu', NULL, '297e1e874f83129d014f8334f5fb02e7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:57', '2015-08-31 18:05:57', 0, 1648, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83386d400a18', '舞阳县', 'pub', '411121', 'cskefu', NULL, '297e1e874f83129d014f8334f5fb02e7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:57', '2015-08-31 18:05:57', 0, 1649, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83386d510a19', '临颍县', 'pub', '411122', 'cskefu', NULL, '297e1e874f83129d014f8334f5fb02e7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:57', '2015-08-31 18:05:57', 0, 1650, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83386ea70a1a', '市辖区', 'pub', '411201', 'cskefu', NULL, '297e1e874f83129d014f8334f60902e8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:57', '2015-08-31 18:05:57', 0, 1651, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83386ebc0a1b', '湖滨区', 'pub', '411202', 'cskefu', NULL, '297e1e874f83129d014f8334f60902e8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:57', '2015-08-31 18:05:57', 0, 1652, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83386ec80a1c', '渑池县', 'pub', '411221', 'cskefu', NULL, '297e1e874f83129d014f8334f60902e8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:57', '2015-08-31 18:05:57', 0, 1653, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83386edb0a1d', '陕　县', 'pub', '411222', 'cskefu', NULL, '297e1e874f83129d014f8334f60902e8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:57', '2015-08-31 18:05:57', 0, 1654, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83386eeb0a1e', '卢氏县', 'pub', '411224', 'cskefu', NULL, '297e1e874f83129d014f8334f60902e8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:57', '2015-08-31 18:05:57', 0, 1655, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83386ef80a1f', '义马市', 'pub', '411281', 'cskefu', NULL, '297e1e874f83129d014f8334f60902e8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:57', '2015-08-31 18:05:57', 0, 1656, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83386f100a20', '灵宝市', 'pub', '411282', 'cskefu', NULL, '297e1e874f83129d014f8334f60902e8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:57', '2015-08-31 18:05:57', 0, 1657, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83386f390a21', '市辖区', 'pub', '411301', 'cskefu', NULL, '297e1e874f83129d014f8334f61802e9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:57', '2015-08-31 18:05:57', 0, 1658, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83386f5a0a22', '宛城区', 'pub', '411302', 'cskefu', NULL, '297e1e874f83129d014f8334f61802e9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:57', '2015-08-31 18:05:57', 0, 1659, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83386f690a23', '卧龙区', 'pub', '411303', 'cskefu', NULL, '297e1e874f83129d014f8334f61802e9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:57', '2015-08-31 18:05:57', 0, 1660, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83386f770a24', '南召县', 'pub', '411321', 'cskefu', NULL, '297e1e874f83129d014f8334f61802e9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:58', '2015-08-31 18:05:58', 0, 1661, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83386f870a25', '方城县', 'pub', '411322', 'cskefu', NULL, '297e1e874f83129d014f8334f61802e9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:58', '2015-08-31 18:05:58', 0, 1662, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83386f950a26', '西峡县', 'pub', '411323', 'cskefu', NULL, '297e1e874f83129d014f8334f61802e9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:58', '2015-08-31 18:05:58', 0, 1663, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83386fc10a27', '镇平县', 'pub', '411324', 'cskefu', NULL, '297e1e874f83129d014f8334f61802e9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:58', '2015-08-31 18:05:58', 0, 1664, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833870150a28', '内乡县', 'pub', '411325', 'cskefu', NULL, '297e1e874f83129d014f8334f61802e9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:58', '2015-08-31 18:05:58', 0, 1665, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833870310a29', '淅川县', 'pub', '411326', 'cskefu', NULL, '297e1e874f83129d014f8334f61802e9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:58', '2015-08-31 18:05:58', 0, 1666, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833870430a2a', '社旗县', 'pub', '411327', 'cskefu', NULL, '297e1e874f83129d014f8334f61802e9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:58', '2015-08-31 18:05:58', 0, 1667, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833870520a2b', '唐河县', 'pub', '411328', 'cskefu', NULL, '297e1e874f83129d014f8334f61802e9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:58', '2015-08-31 18:05:58', 0, 1668, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833870630a2c', '新野县', 'pub', '411329', 'cskefu', NULL, '297e1e874f83129d014f8334f61802e9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:58', '2015-08-31 18:05:58', 0, 1669, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833870720a2d', '桐柏县', 'pub', '411330', 'cskefu', NULL, '297e1e874f83129d014f8334f61802e9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:58', '2015-08-31 18:05:58', 0, 1670, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833871ab0a2e', '邓州市', 'pub', '411381', 'cskefu', NULL, '297e1e874f83129d014f8334f61802e9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:58', '2015-08-31 18:05:58', 0, 1671, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833871d70a2f', '市辖区', 'pub', '411401', 'cskefu', NULL, '297e1e874f83129d014f8334f62802ea', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:58', '2015-08-31 18:05:58', 0, 1672, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833871e80a30', '梁园区', 'pub', '411402', 'cskefu', NULL, '297e1e874f83129d014f8334f62802ea', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:58', '2015-08-31 18:05:58', 0, 1673, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833871f60a31', '睢阳区', 'pub', '411403', 'cskefu', NULL, '297e1e874f83129d014f8334f62802ea', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:58', '2015-08-31 18:05:58', 0, 1674, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833872090a32', '民权县', 'pub', '411421', 'cskefu', NULL, '297e1e874f83129d014f8334f62802ea', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:58', '2015-08-31 18:05:58', 0, 1675, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833872290a33', '睢　县', 'pub', '411422', 'cskefu', NULL, '297e1e874f83129d014f8334f62802ea', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:58', '2015-08-31 18:05:58', 0, 1676, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833872390a34', '宁陵县', 'pub', '411423', 'cskefu', NULL, '297e1e874f83129d014f8334f62802ea', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:58', '2015-08-31 18:05:58', 0, 1677, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338724b0a35', '柘城县', 'pub', '411424', 'cskefu', NULL, '297e1e874f83129d014f8334f62802ea', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:58', '2015-08-31 18:05:58', 0, 1678, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338725b0a36', '虞城县', 'pub', '411425', 'cskefu', NULL, '297e1e874f83129d014f8334f62802ea', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:58', '2015-08-31 18:05:58', 0, 1679, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833872690a37', '夏邑县', 'pub', '411426', 'cskefu', NULL, '297e1e874f83129d014f8334f62802ea', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:58', '2015-08-31 18:05:58', 0, 1680, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338727b0a38', '永城市', 'pub', '411481', 'cskefu', NULL, '297e1e874f83129d014f8334f62802ea', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:58', '2015-08-31 18:05:58', 0, 1681, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833872a80a39', '市辖区', 'pub', '411501', 'cskefu', NULL, '297e1e874f83129d014f8334f63402eb', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:58', '2015-08-31 18:05:58', 0, 1682, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833872bd0a3a', '师河区', 'pub', '411502', 'cskefu', NULL, '297e1e874f83129d014f8334f63402eb', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:58', '2015-08-31 18:05:58', 0, 1683, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833872cb0a3b', '平桥区', 'pub', '411503', 'cskefu', NULL, '297e1e874f83129d014f8334f63402eb', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:58', '2015-08-31 18:05:58', 0, 1684, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833874100a3c', '罗山县', 'pub', '411521', 'cskefu', NULL, '297e1e874f83129d014f8334f63402eb', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:59', '2015-08-31 18:05:59', 0, 1685, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833874200a3d', '光山县', 'pub', '411522', 'cskefu', NULL, '297e1e874f83129d014f8334f63402eb', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:59', '2015-08-31 18:05:59', 0, 1686, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833874410a3e', '新　县', 'pub', '411523', 'cskefu', NULL, '297e1e874f83129d014f8334f63402eb', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:59', '2015-08-31 18:05:59', 0, 1687, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833874520a3f', '商城县', 'pub', '411524', 'cskefu', NULL, '297e1e874f83129d014f8334f63402eb', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:59', '2015-08-31 18:05:59', 0, 1688, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338746a0a40', '固始县', 'pub', '411525', 'cskefu', NULL, '297e1e874f83129d014f8334f63402eb', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:59', '2015-08-31 18:05:59', 0, 1689, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833874830a41', '潢川县', 'pub', '411526', 'cskefu', NULL, '297e1e874f83129d014f8334f63402eb', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:59', '2015-08-31 18:05:59', 0, 1690, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833874930a42', '淮滨县', 'pub', '411527', 'cskefu', NULL, '297e1e874f83129d014f8334f63402eb', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:59', '2015-08-31 18:05:59', 0, 1691, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338749f0a43', '息　县', 'pub', '411528', 'cskefu', NULL, '297e1e874f83129d014f8334f63402eb', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:59', '2015-08-31 18:05:59', 0, 1692, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833874c60a44', '市辖区', 'pub', '411601', 'cskefu', NULL, '297e1e874f83129d014f8334f64202ec', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:59', '2015-08-31 18:05:59', 0, 1693, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833874dd0a45', '川汇区', 'pub', '411602', 'cskefu', NULL, '297e1e874f83129d014f8334f64202ec', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:59', '2015-08-31 18:05:59', 0, 1694, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833874ee0a46', '扶沟县', 'pub', '411621', 'cskefu', NULL, '297e1e874f83129d014f8334f64202ec', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:59', '2015-08-31 18:05:59', 0, 1695, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833874fb0a47', '西华县', 'pub', '411622', 'cskefu', NULL, '297e1e874f83129d014f8334f64202ec', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:59', '2015-08-31 18:05:59', 0, 1696, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833875120a48', '商水县', 'pub', '411623', 'cskefu', NULL, '297e1e874f83129d014f8334f64202ec', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:59', '2015-08-31 18:05:59', 0, 1697, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833875210a49', '沈丘县', 'pub', '411624', 'cskefu', NULL, '297e1e874f83129d014f8334f64202ec', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:59', '2015-08-31 18:05:59', 0, 1698, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338752e0a4a', '郸城县', 'pub', '411625', 'cskefu', NULL, '297e1e874f83129d014f8334f64202ec', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:59', '2015-08-31 18:05:59', 0, 1699, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833875400a4b', '淮阳县', 'pub', '411626', 'cskefu', NULL, '297e1e874f83129d014f8334f64202ec', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:59', '2015-08-31 18:05:59', 0, 1700, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833875570a4c', '太康县', 'pub', '411627', 'cskefu', NULL, '297e1e874f83129d014f8334f64202ec', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:59', '2015-08-31 18:05:59', 0, 1701, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338756c0a4d', '鹿邑县', 'pub', '411628', 'cskefu', NULL, '297e1e874f83129d014f8334f64202ec', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:59', '2015-08-31 18:05:59', 0, 1702, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833875800a4e', '项城市', 'pub', '411681', 'cskefu', NULL, '297e1e874f83129d014f8334f64202ec', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:59', '2015-08-31 18:05:59', 0, 1703, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833876d70a4f', '市辖区', 'pub', '411701', 'cskefu', NULL, '297e1e874f83129d014f8334f65102ed', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:59', '2015-08-31 18:05:59', 0, 1704, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833876e80a50', '驿城区', 'pub', '411702', 'cskefu', NULL, '297e1e874f83129d014f8334f65102ed', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:59', '2015-08-31 18:05:59', 0, 1705, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833876f50a51', '西平县', 'pub', '411721', 'cskefu', NULL, '297e1e874f83129d014f8334f65102ed', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:59', '2015-08-31 18:05:59', 0, 1706, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833877010a52', '上蔡县', 'pub', '411722', 'cskefu', NULL, '297e1e874f83129d014f8334f65102ed', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:59', '2015-08-31 18:05:59', 0, 1707, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833877120a53', '平舆县', 'pub', '411723', 'cskefu', NULL, '297e1e874f83129d014f8334f65102ed', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:59', '2015-08-31 18:05:59', 0, 1708, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833877240a54', '正阳县', 'pub', '411724', 'cskefu', NULL, '297e1e874f83129d014f8334f65102ed', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:59', '2015-08-31 18:05:59', 0, 1709, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833877330a55', '确山县', 'pub', '411725', 'cskefu', NULL, '297e1e874f83129d014f8334f65102ed', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:05:59', '2015-08-31 18:05:59', 0, 1710, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833877410a56', '泌阳县', 'pub', '411726', 'cskefu', NULL, '297e1e874f83129d014f8334f65102ed', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:00', '2015-08-31 18:06:00', 0, 1711, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338774f0a57', '汝南县', 'pub', '411727', 'cskefu', NULL, '297e1e874f83129d014f8334f65102ed', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:00', '2015-08-31 18:06:00', 0, 1712, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338775c0a58', '遂平县', 'pub', '411728', 'cskefu', NULL, '297e1e874f83129d014f8334f65102ed', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:00', '2015-08-31 18:06:00', 0, 1713, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338776a0a59', '新蔡县', 'pub', '411729', 'cskefu', NULL, '297e1e874f83129d014f8334f65102ed', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:00', '2015-08-31 18:06:00', 0, 1714, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833877920a5a', '市辖区', 'pub', '420101', 'cskefu', NULL, '297e1e874f83129d014f8334f7a802ee', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:00', '2015-08-31 18:06:00', 0, 1715, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338779d0a5b', '江岸区', 'pub', '420102', 'cskefu', NULL, '297e1e874f83129d014f8334f7a802ee', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:00', '2015-08-31 18:06:00', 0, 1716, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833877a90a5c', '江汉区', 'pub', '420103', 'cskefu', NULL, '297e1e874f83129d014f8334f7a802ee', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:00', '2015-08-31 18:06:00', 0, 1717, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833878e90a5d', '乔口区', 'pub', '420104', 'cskefu', NULL, '297e1e874f83129d014f8334f7a802ee', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:00', '2015-08-31 18:06:00', 0, 1718, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833878f70a5e', '汉阳区', 'pub', '420105', 'cskefu', NULL, '297e1e874f83129d014f8334f7a802ee', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:00', '2015-08-31 18:06:00', 0, 1719, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833879080a5f', '武昌区', 'pub', '420106', 'cskefu', NULL, '297e1e874f83129d014f8334f7a802ee', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:00', '2015-08-31 18:06:00', 0, 1720, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833879130a60', '青山区', 'pub', '420107', 'cskefu', NULL, '297e1e874f83129d014f8334f7a802ee', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:00', '2015-08-31 18:06:00', 0, 1721, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338791f0a61', '洪山区', 'pub', '420111', 'cskefu', NULL, '297e1e874f83129d014f8334f7a802ee', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:00', '2015-08-31 18:06:00', 0, 1722, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338792b0a62', '东西湖区', 'pub', '420112', 'cskefu', NULL, '297e1e874f83129d014f8334f7a802ee', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:00', '2015-08-31 18:06:00', 0, 1723, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833879390a63', '汉南区', 'pub', '420113', 'cskefu', NULL, '297e1e874f83129d014f8334f7a802ee', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:00', '2015-08-31 18:06:00', 0, 1724, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833879490a64', '蔡甸区', 'pub', '420114', 'cskefu', NULL, '297e1e874f83129d014f8334f7a802ee', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:00', '2015-08-31 18:06:00', 0, 1725, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833879590a65', '江夏区', 'pub', '420115', 'cskefu', NULL, '297e1e874f83129d014f8334f7a802ee', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:00', '2015-08-31 18:06:00', 0, 1726, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833879670a66', '黄陂区', 'pub', '420116', 'cskefu', NULL, '297e1e874f83129d014f8334f7a802ee', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:00', '2015-08-31 18:06:00', 0, 1727, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833879740a67', '新洲区', 'pub', '420117', 'cskefu', NULL, '297e1e874f83129d014f8334f7a802ee', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:00', '2015-08-31 18:06:00', 0, 1728, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338799a0a68', '市辖区', 'pub', '420201', 'cskefu', NULL, '297e1e874f83129d014f8334f7c902ef', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:00', '2015-08-31 18:06:00', 0, 1729, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833879a70a69', '黄石港区', 'pub', '420202', 'cskefu', NULL, '297e1e874f83129d014f8334f7c902ef', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:00', '2015-08-31 18:06:00', 0, 1730, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83387ae70a6a', '西塞山区', 'pub', '420203', 'cskefu', NULL, '297e1e874f83129d014f8334f7c902ef', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:00', '2015-08-31 18:06:00', 0, 1731, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83387af30a6b', '下陆区', 'pub', '420204', 'cskefu', NULL, '297e1e874f83129d014f8334f7c902ef', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:00', '2015-08-31 18:06:00', 0, 1732, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83387afe0a6c', '铁山区', 'pub', '420205', 'cskefu', NULL, '297e1e874f83129d014f8334f7c902ef', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:00', '2015-08-31 18:06:00', 0, 1733, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83387b0e0a6d', '阳新县', 'pub', '420222', 'cskefu', NULL, '297e1e874f83129d014f8334f7c902ef', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:00', '2015-08-31 18:06:00', 0, 1734, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83387b1a0a6e', '大冶市', 'pub', '420281', 'cskefu', NULL, '297e1e874f83129d014f8334f7c902ef', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:00', '2015-08-31 18:06:00', 0, 1735, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83387b4e0a6f', '市辖区', 'pub', '420301', 'cskefu', NULL, '297e1e874f83129d014f8334f7ee02f0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:01', '2015-08-31 18:06:01', 0, 1736, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83387b5d0a70', '茅箭区', 'pub', '420302', 'cskefu', NULL, '297e1e874f83129d014f8334f7ee02f0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:01', '2015-08-31 18:06:01', 0, 1737, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83387b6a0a71', '张湾区', 'pub', '420303', 'cskefu', NULL, '297e1e874f83129d014f8334f7ee02f0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:01', '2015-08-31 18:06:01', 0, 1738, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83387b760a72', '郧　县', 'pub', '420321', 'cskefu', NULL, '297e1e874f83129d014f8334f7ee02f0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:01', '2015-08-31 18:06:01', 0, 1739, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83387b840a73', '郧西县', 'pub', '420322', 'cskefu', NULL, '297e1e874f83129d014f8334f7ee02f0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:01', '2015-08-31 18:06:01', 0, 1740, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83387b920a74', '竹山县', 'pub', '420323', 'cskefu', NULL, '297e1e874f83129d014f8334f7ee02f0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:01', '2015-08-31 18:06:01', 0, 1741, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83387b9e0a75', '竹溪县', 'pub', '420324', 'cskefu', NULL, '297e1e874f83129d014f8334f7ee02f0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:01', '2015-08-31 18:06:01', 0, 1742, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83387baf0a76', '房　县', 'pub', '420325', 'cskefu', NULL, '297e1e874f83129d014f8334f7ee02f0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:01', '2015-08-31 18:06:01', 0, 1743, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83387ce70a77', '丹江口市', 'pub', '420381', 'cskefu', NULL, '297e1e874f83129d014f8334f7ee02f0', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:01', '2015-08-31 18:06:01', 0, 1744, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83387d0d0a78', '市辖区', 'pub', '420501', 'cskefu', NULL, '297e1e874f83129d014f8334f7fd02f1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:01', '2015-08-31 18:06:01', 0, 1745, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83387d190a79', '西陵区', 'pub', '420502', 'cskefu', NULL, '297e1e874f83129d014f8334f7fd02f1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:01', '2015-08-31 18:06:01', 0, 1746, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83387d250a7a', '伍家岗区', 'pub', '420503', 'cskefu', NULL, '297e1e874f83129d014f8334f7fd02f1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:01', '2015-08-31 18:06:01', 0, 1747, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83387d330a7b', '点军区', 'pub', '420504', 'cskefu', NULL, '297e1e874f83129d014f8334f7fd02f1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:01', '2015-08-31 18:06:01', 0, 1748, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83387d3f0a7c', '猇亭区', 'pub', '420505', 'cskefu', NULL, '297e1e874f83129d014f8334f7fd02f1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:01', '2015-08-31 18:06:01', 0, 1749, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83387d4e0a7d', '夷陵区', 'pub', '420506', 'cskefu', NULL, '297e1e874f83129d014f8334f7fd02f1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:01', '2015-08-31 18:06:01', 0, 1750, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83387d5c0a7e', '远安县', 'pub', '420525', 'cskefu', NULL, '297e1e874f83129d014f8334f7fd02f1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:01', '2015-08-31 18:06:01', 0, 1751, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83387d6c0a7f', '兴山县', 'pub', '420526', 'cskefu', NULL, '297e1e874f83129d014f8334f7fd02f1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:01', '2015-08-31 18:06:01', 0, 1752, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83387d780a80', '秭归县', 'pub', '420527', 'cskefu', NULL, '297e1e874f83129d014f8334f7fd02f1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:01', '2015-08-31 18:06:01', 0, 1753, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83387d830a81', '长阳土家族自治县', 'pub', '420528', 'cskefu', NULL, '297e1e874f83129d014f8334f7fd02f1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:01', '2015-08-31 18:06:01', 0, 1754, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83387d8f0a82', '五峰土家族自治县', 'pub', '420529', 'cskefu', NULL, '297e1e874f83129d014f8334f7fd02f1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:01', '2015-08-31 18:06:01', 0, 1755, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83387da00a83', '宜都市', 'pub', '420581', 'cskefu', NULL, '297e1e874f83129d014f8334f7fd02f1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:01', '2015-08-31 18:06:01', 0, 1756, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83387eda0a85', '当阳市', 'pub', '420582', 'cskefu', NULL, '297e1e874f83129d014f8334f7fd02f1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:01', '2015-08-31 18:06:01', 0, 1757, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83387eeb0a86', '枝江市', 'pub', '420583', 'cskefu', NULL, '297e1e874f83129d014f8334f7fd02f1', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:01', '2015-08-31 18:06:01', 0, 1758, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83387f110a87', '市辖区', 'pub', '420601', 'cskefu', NULL, '297e1e874f83129d014f8334f80b02f2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:02', '2015-08-31 18:06:02', 0, 1759, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83387f1d0a88', '襄城区', 'pub', '420602', 'cskefu', NULL, '297e1e874f83129d014f8334f80b02f2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:02', '2015-08-31 18:06:02', 0, 1760, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83387f2a0a89', '樊城区', 'pub', '420606', 'cskefu', NULL, '297e1e874f83129d014f8334f80b02f2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:02', '2015-08-31 18:06:02', 0, 1761, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83387f380a8a', '襄阳区', 'pub', '420607', 'cskefu', NULL, '297e1e874f83129d014f8334f80b02f2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:02', '2015-08-31 18:06:02', 0, 1762, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83387f440a8b', '南漳县', 'pub', '420624', 'cskefu', NULL, '297e1e874f83129d014f8334f80b02f2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:02', '2015-08-31 18:06:02', 0, 1763, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833880820a8c', '谷城县', 'pub', '420625', 'cskefu', NULL, '297e1e874f83129d014f8334f80b02f2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:02', '2015-08-31 18:06:02', 0, 1764, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338808f0a8d', '保康县', 'pub', '420626', 'cskefu', NULL, '297e1e874f83129d014f8334f80b02f2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:02', '2015-08-31 18:06:02', 0, 1765, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338809b0a8e', '老河口市', 'pub', '420682', 'cskefu', NULL, '297e1e874f83129d014f8334f80b02f2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:02', '2015-08-31 18:06:02', 0, 1766, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833880a80a8f', '枣阳市', 'pub', '420683', 'cskefu', NULL, '297e1e874f83129d014f8334f80b02f2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:02', '2015-08-31 18:06:02', 0, 1767, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833880b30a90', '宜城市', 'pub', '420684', 'cskefu', NULL, '297e1e874f83129d014f8334f80b02f2', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:02', '2015-08-31 18:06:02', 0, 1768, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833880dc0a91', '市辖区', 'pub', '420701', 'cskefu', NULL, '297e1e874f83129d014f8334f81a02f3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:02', '2015-08-31 18:06:02', 0, 1769, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833880ec0a92', '梁子湖区', 'pub', '420702', 'cskefu', NULL, '297e1e874f83129d014f8334f81a02f3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:02', '2015-08-31 18:06:02', 0, 1770, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833880f90a93', '华容区', 'pub', '420703', 'cskefu', NULL, '297e1e874f83129d014f8334f81a02f3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:02', '2015-08-31 18:06:02', 0, 1771, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833881060a94', '鄂城区', 'pub', '420704', 'cskefu', NULL, '297e1e874f83129d014f8334f81a02f3', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:02', '2015-08-31 18:06:02', 0, 1772, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833881320a95', '市辖区', 'pub', '420801', 'cskefu', NULL, '297e1e874f83129d014f8334f82702f4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:02', '2015-08-31 18:06:02', 0, 1773, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338813f0a96', '东宝区', 'pub', '420802', 'cskefu', NULL, '297e1e874f83129d014f8334f82702f4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:02', '2015-08-31 18:06:02', 0, 1774, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833882780a97', '掇刀区', 'pub', '420804', 'cskefu', NULL, '297e1e874f83129d014f8334f82702f4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:02', '2015-08-31 18:06:02', 0, 1775, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833882840a98', '京山县', 'pub', '420821', 'cskefu', NULL, '297e1e874f83129d014f8334f82702f4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:02', '2015-08-31 18:06:02', 0, 1776, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833882910a99', '沙洋县', 'pub', '420822', 'cskefu', NULL, '297e1e874f83129d014f8334f82702f4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:02', '2015-08-31 18:06:02', 0, 1777, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338829c0a9a', '钟祥市', 'pub', '420881', 'cskefu', NULL, '297e1e874f83129d014f8334f82702f4', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:02', '2015-08-31 18:06:02', 0, 1778, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833882cb0a9b', '市辖区', 'pub', '420901', 'cskefu', NULL, '297e1e874f83129d014f8334f83502f5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:02', '2015-08-31 18:06:02', 0, 1779, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833882db0a9c', '孝南区', 'pub', '420902', 'cskefu', NULL, '297e1e874f83129d014f8334f83502f5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:02', '2015-08-31 18:06:02', 0, 1780, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833882eb0a9d', '孝昌县', 'pub', '420921', 'cskefu', NULL, '297e1e874f83129d014f8334f83502f5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:02', '2015-08-31 18:06:02', 0, 1781, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833882f70a9e', '大悟县', 'pub', '420922', 'cskefu', NULL, '297e1e874f83129d014f8334f83502f5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:02', '2015-08-31 18:06:02', 0, 1782, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833883050a9f', '云梦县', 'pub', '420923', 'cskefu', NULL, '297e1e874f83129d014f8334f83502f5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:03', '2015-08-31 18:06:03', 0, 1783, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833883130aa0', '应城市', 'pub', '420981', 'cskefu', NULL, '297e1e874f83129d014f8334f83502f5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:03', '2015-08-31 18:06:03', 0, 1784, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833883260aa1', '安陆市', 'pub', '420982', 'cskefu', NULL, '297e1e874f83129d014f8334f83502f5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:03', '2015-08-31 18:06:03', 0, 1785, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833883360aa2', '汉川市', 'pub', '420984', 'cskefu', NULL, '297e1e874f83129d014f8334f83502f5', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:03', '2015-08-31 18:06:03', 0, 1786, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338835d0aa3', '市辖区', 'pub', '421001', 'cskefu', NULL, '297e1e874f83129d014f8334f84302f6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:03', '2015-08-31 18:06:03', 0, 1787, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338836b0aa4', '沙市区', 'pub', '421002', 'cskefu', NULL, '297e1e874f83129d014f8334f84302f6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:03', '2015-08-31 18:06:03', 0, 1788, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833884a30aa5', '荆州区', 'pub', '421003', 'cskefu', NULL, '297e1e874f83129d014f8334f84302f6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:03', '2015-08-31 18:06:03', 0, 1789, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833884b00aa6', '公安县', 'pub', '421022', 'cskefu', NULL, '297e1e874f83129d014f8334f84302f6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:03', '2015-08-31 18:06:03', 0, 1790, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833884bb0aa7', '监利县', 'pub', '421023', 'cskefu', NULL, '297e1e874f83129d014f8334f84302f6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:03', '2015-08-31 18:06:03', 0, 1791, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833884c60aa8', '江陵县', 'pub', '421024', 'cskefu', NULL, '297e1e874f83129d014f8334f84302f6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:03', '2015-08-31 18:06:03', 0, 1792, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833884d10aa9', '石首市', 'pub', '421081', 'cskefu', NULL, '297e1e874f83129d014f8334f84302f6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:03', '2015-08-31 18:06:03', 0, 1793, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833884dd0aaa', '洪湖市', 'pub', '421083', 'cskefu', NULL, '297e1e874f83129d014f8334f84302f6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:03', '2015-08-31 18:06:03', 0, 1794, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833884eb0aab', '松滋市', 'pub', '421087', 'cskefu', NULL, '297e1e874f83129d014f8334f84302f6', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:03', '2015-08-31 18:06:03', 0, 1795, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833885110aac', '市辖区', 'pub', '421101', 'cskefu', NULL, '297e1e874f83129d014f8334f85b02f7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:03', '2015-08-31 18:06:03', 0, 1796, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338851c0aad', '黄州区', 'pub', '421102', 'cskefu', NULL, '297e1e874f83129d014f8334f85b02f7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:03', '2015-08-31 18:06:03', 0, 1797, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833885280aae', '团风县', 'pub', '421121', 'cskefu', NULL, '297e1e874f83129d014f8334f85b02f7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:03', '2015-08-31 18:06:03', 0, 1798, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833886600aaf', '红安县', 'pub', '421122', 'cskefu', NULL, '297e1e874f83129d014f8334f85b02f7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:03', '2015-08-31 18:06:03', 0, 1799, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338866c0ab0', '罗田县', 'pub', '421123', 'cskefu', NULL, '297e1e874f83129d014f8334f85b02f7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:03', '2015-08-31 18:06:03', 0, 1800, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833886790ab1', '英山县', 'pub', '421124', 'cskefu', NULL, '297e1e874f83129d014f8334f85b02f7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:03', '2015-08-31 18:06:03', 0, 1801, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833886850ab2', '浠水县', 'pub', '421125', 'cskefu', NULL, '297e1e874f83129d014f8334f85b02f7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:03', '2015-08-31 18:06:03', 0, 1802, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833886920ab3', '蕲春县', 'pub', '421126', 'cskefu', NULL, '297e1e874f83129d014f8334f85b02f7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:03', '2015-08-31 18:06:03', 0, 1803, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338869e0ab4', '黄梅县', 'pub', '421127', 'cskefu', NULL, '297e1e874f83129d014f8334f85b02f7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:03', '2015-08-31 18:06:03', 0, 1804, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833886a90ab5', '麻城市', 'pub', '421181', 'cskefu', NULL, '297e1e874f83129d014f8334f85b02f7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:03', '2015-08-31 18:06:03', 0, 1805, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833886b40ab6', '武穴市', 'pub', '421182', 'cskefu', NULL, '297e1e874f83129d014f8334f85b02f7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:03', '2015-08-31 18:06:03', 0, 1806, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833886dc0ab7', '市辖区', 'pub', '421201', 'cskefu', NULL, '297e1e874f83129d014f8334f87102f8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:03', '2015-08-31 18:06:03', 0, 1807, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833886e60ab8', '咸安区', 'pub', '421202', 'cskefu', NULL, '297e1e874f83129d014f8334f87102f8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:04', '2015-08-31 18:06:04', 0, 1808, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833886f20ab9', '嘉鱼县', 'pub', '421221', 'cskefu', NULL, '297e1e874f83129d014f8334f87102f8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:04', '2015-08-31 18:06:04', 0, 1809, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833887000aba', '通城县', 'pub', '421222', 'cskefu', NULL, '297e1e874f83129d014f8334f87102f8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:04', '2015-08-31 18:06:04', 0, 1810, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338870f0abb', '崇阳县', 'pub', '421223', 'cskefu', NULL, '297e1e874f83129d014f8334f87102f8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:04', '2015-08-31 18:06:04', 0, 1811, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833888480abc', '通山县', 'pub', '421224', 'cskefu', NULL, '297e1e874f83129d014f8334f87102f8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:04', '2015-08-31 18:06:04', 0, 1812, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833888530abd', '赤壁市', 'pub', '421281', 'cskefu', NULL, '297e1e874f83129d014f8334f87102f8', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:04', '2015-08-31 18:06:04', 0, 1813, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833888790abe', '市辖区', 'pub', '421301', 'cskefu', NULL, '297e1e874f83129d014f8334f88002f9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:04', '2015-08-31 18:06:04', 0, 1814, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833888850abf', '曾都区', 'pub', '421302', 'cskefu', NULL, '297e1e874f83129d014f8334f88002f9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:04', '2015-08-31 18:06:04', 0, 1815, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833888920ac0', '广水市', 'pub', '421381', 'cskefu', NULL, '297e1e874f83129d014f8334f88002f9', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:04', '2015-08-31 18:06:04', 0, 1816, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833888b90ac1', '恩施市', 'pub', '422801', 'cskefu', NULL, '297e1e874f83129d014f8334f89202fa', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:04', '2015-08-31 18:06:04', 0, 1817, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833888c40ac2', '利川市', 'pub', '422802', 'cskefu', NULL, '297e1e874f83129d014f8334f89202fa', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:04', '2015-08-31 18:06:04', 0, 1818, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833888cf0ac3', '建始县', 'pub', '422822', 'cskefu', NULL, '297e1e874f83129d014f8334f89202fa', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:04', '2015-08-31 18:06:04', 0, 1819, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833888da0ac4', '巴东县', 'pub', '422823', 'cskefu', NULL, '297e1e874f83129d014f8334f89202fa', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:04', '2015-08-31 18:06:04', 0, 1820, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833888e60ac5', '宣恩县', 'pub', '422825', 'cskefu', NULL, '297e1e874f83129d014f8334f89202fa', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:04', '2015-08-31 18:06:04', 0, 1821, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833888f30ac6', '咸丰县', 'pub', '422826', 'cskefu', NULL, '297e1e874f83129d014f8334f89202fa', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:04', '2015-08-31 18:06:04', 0, 1822, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83388a2e0ac7', '来凤县', 'pub', '422827', 'cskefu', NULL, '297e1e874f83129d014f8334f89202fa', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:04', '2015-08-31 18:06:04', 0, 1823, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83388a3a0ac8', '鹤峰县', 'pub', '422828', 'cskefu', NULL, '297e1e874f83129d014f8334f89202fa', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:04', '2015-08-31 18:06:04', 0, 1824, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83388a5f0ac9', '仙桃市', 'pub', '429004', 'cskefu', NULL, '297e1e874f83129d014f8334f89f02fb', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:04', '2015-08-31 18:06:04', 0, 1825, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83388a6a0aca', '潜江市', 'pub', '429005', 'cskefu', NULL, '297e1e874f83129d014f8334f89f02fb', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:04', '2015-08-31 18:06:04', 0, 1826, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83388a760acb', '天门市', 'pub', '429006', 'cskefu', NULL, '297e1e874f83129d014f8334f89f02fb', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:04', '2015-08-31 18:06:04', 0, 1827, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83388a830acc', '神农架林区', 'pub', '429021', 'cskefu', NULL, '297e1e874f83129d014f8334f89f02fb', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:04', '2015-08-31 18:06:04', 0, 1828, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83388aa70acd', '市辖区', 'pub', '430101', 'cskefu', NULL, '297e1e874f83129d014f8334f8d802fc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:04', '2015-08-31 18:06:04', 0, 1829, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83388ab20ace', '芙蓉区', 'pub', '430102', 'cskefu', NULL, '297e1e874f83129d014f8334f8d802fc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:04', '2015-08-31 18:06:04', 0, 1830, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83388abd0acf', '天心区', 'pub', '430103', 'cskefu', NULL, '297e1e874f83129d014f8334f8d802fc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:04', '2015-08-31 18:06:04', 0, 1831, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83388ac70ad0', '岳麓区', 'pub', '430104', 'cskefu', NULL, '297e1e874f83129d014f8334f8d802fc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:04', '2015-08-31 18:06:04', 0, 1832, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83388ad20ad1', '开福区', 'pub', '430105', 'cskefu', NULL, '297e1e874f83129d014f8334f8d802fc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:05', '2015-08-31 18:06:05', 0, 1833, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83388c0b0ad2', '雨花区', 'pub', '430111', 'cskefu', NULL, '297e1e874f83129d014f8334f8d802fc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:05', '2015-08-31 18:06:05', 0, 1834, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83388c160ad3', '长沙县', 'pub', '430121', 'cskefu', NULL, '297e1e874f83129d014f8334f8d802fc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:05', '2015-08-31 18:06:05', 0, 1835, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83388c250ad4', '望城县', 'pub', '430122', 'cskefu', NULL, '297e1e874f83129d014f8334f8d802fc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:05', '2015-08-31 18:06:05', 0, 1836, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83388c320ad5', '宁乡县', 'pub', '430124', 'cskefu', NULL, '297e1e874f83129d014f8334f8d802fc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:05', '2015-08-31 18:06:05', 0, 1837, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83388c3e0ad6', '浏阳市', 'pub', '430181', 'cskefu', NULL, '297e1e874f83129d014f8334f8d802fc', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:05', '2015-08-31 18:06:05', 0, 1838, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83388c660ad7', '市辖区', 'pub', '430201', 'cskefu', NULL, '297e1e874f83129d014f8334f8f902fd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:05', '2015-08-31 18:06:05', 0, 1839, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83388c740ad8', '荷塘区', 'pub', '430202', 'cskefu', NULL, '297e1e874f83129d014f8334f8f902fd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:05', '2015-08-31 18:06:05', 0, 1840, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83388c830ad9', '芦淞区', 'pub', '430203', 'cskefu', NULL, '297e1e874f83129d014f8334f8f902fd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:05', '2015-08-31 18:06:05', 0, 1841, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83388c900ada', '石峰区', 'pub', '430204', 'cskefu', NULL, '297e1e874f83129d014f8334f8f902fd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:05', '2015-08-31 18:06:05', 0, 1842, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83388c9c0adb', '天元区', 'pub', '430211', 'cskefu', NULL, '297e1e874f83129d014f8334f8f902fd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:05', '2015-08-31 18:06:05', 0, 1843, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83388caa0adc', '株洲县', 'pub', '430221', 'cskefu', NULL, '297e1e874f83129d014f8334f8f902fd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:05', '2015-08-31 18:06:05', 0, 1844, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83388cb50add', '攸　县', 'pub', '430223', 'cskefu', NULL, '297e1e874f83129d014f8334f8f902fd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:05', '2015-08-31 18:06:05', 0, 1845, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83388cc20ade', '茶陵县', 'pub', '430224', 'cskefu', NULL, '297e1e874f83129d014f8334f8f902fd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:05', '2015-08-31 18:06:05', 0, 1846, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83388dfa0adf', '炎陵县', 'pub', '430225', 'cskefu', NULL, '297e1e874f83129d014f8334f8f902fd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:05', '2015-08-31 18:06:05', 0, 1847, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83388e090ae0', '醴陵市', 'pub', '430281', 'cskefu', NULL, '297e1e874f83129d014f8334f8f902fd', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:05', '2015-08-31 18:06:05', 0, 1848, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83388e2b0ae1', '市辖区', 'pub', '430301', 'cskefu', NULL, '297e1e874f83129d014f8334fa3e02fe', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:05', '2015-08-31 18:06:05', 0, 1849, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83388e360ae2', '雨湖区', 'pub', '430302', 'cskefu', NULL, '297e1e874f83129d014f8334fa3e02fe', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:05', '2015-08-31 18:06:05', 0, 1850, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83388e410ae3', '岳塘区', 'pub', '430304', 'cskefu', NULL, '297e1e874f83129d014f8334fa3e02fe', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:05', '2015-08-31 18:06:05', 0, 1851, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83388e4d0ae4', '湘潭县', 'pub', '430321', 'cskefu', NULL, '297e1e874f83129d014f8334fa3e02fe', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:05', '2015-08-31 18:06:05', 0, 1852, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83388e570ae5', '湘乡市', 'pub', '430381', 'cskefu', NULL, '297e1e874f83129d014f8334fa3e02fe', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:05', '2015-08-31 18:06:05', 0, 1853, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83388e640ae6', '韶山市', 'pub', '430382', 'cskefu', NULL, '297e1e874f83129d014f8334fa3e02fe', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:05', '2015-08-31 18:06:05', 0, 1854, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83388fb50ae7', '市辖区', 'pub', '430401', 'cskefu', NULL, '297e1e874f83129d014f8334fa5b02ff', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:06', '2015-08-31 18:06:06', 0, 1855, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83388fc00ae8', '珠晖区', 'pub', '430405', 'cskefu', NULL, '297e1e874f83129d014f8334fa5b02ff', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:06', '2015-08-31 18:06:06', 0, 1856, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83388fcd0ae9', '雁峰区', 'pub', '430406', 'cskefu', NULL, '297e1e874f83129d014f8334fa5b02ff', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:06', '2015-08-31 18:06:06', 0, 1857, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83388fda0aea', '石鼓区', 'pub', '430407', 'cskefu', NULL, '297e1e874f83129d014f8334fa5b02ff', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:06', '2015-08-31 18:06:06', 0, 1858, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83388fe60aeb', '蒸湘区', 'pub', '430408', 'cskefu', NULL, '297e1e874f83129d014f8334fa5b02ff', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:06', '2015-08-31 18:06:06', 0, 1859, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83388ff30aec', '南岳区', 'pub', '430412', 'cskefu', NULL, '297e1e874f83129d014f8334fa5b02ff', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:06', '2015-08-31 18:06:06', 0, 1860, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83388fff0aed', '衡阳县', 'pub', '430421', 'cskefu', NULL, '297e1e874f83129d014f8334fa5b02ff', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:06', '2015-08-31 18:06:06', 0, 1861, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338900d0aee', '衡南县', 'pub', '430422', 'cskefu', NULL, '297e1e874f83129d014f8334fa5b02ff', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:06', '2015-08-31 18:06:06', 0, 1862, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338901a0aef', '衡山县', 'pub', '430423', 'cskefu', NULL, '297e1e874f83129d014f8334fa5b02ff', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:06', '2015-08-31 18:06:06', 0, 1863, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833890260af0', '衡东县', 'pub', '430424', 'cskefu', NULL, '297e1e874f83129d014f8334fa5b02ff', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:06', '2015-08-31 18:06:06', 0, 1864, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833890370af1', '祁东县', 'pub', '430426', 'cskefu', NULL, '297e1e874f83129d014f8334fa5b02ff', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:06', '2015-08-31 18:06:06', 0, 1865, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833890430af2', '耒阳市', 'pub', '430481', 'cskefu', NULL, '297e1e874f83129d014f8334fa5b02ff', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:06', '2015-08-31 18:06:06', 0, 1866, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338904e0af3', '常宁市', 'pub', '430482', 'cskefu', NULL, '297e1e874f83129d014f8334fa5b02ff', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:06', '2015-08-31 18:06:06', 0, 1867, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833891a20af5', '市辖区', 'pub', '430501', 'cskefu', NULL, '297e1e874f83129d014f8334fa6c0300', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:06', '2015-08-31 18:06:06', 0, 1868, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833891ae0af6', '双清区', 'pub', '430502', 'cskefu', NULL, '297e1e874f83129d014f8334fa6c0300', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:06', '2015-08-31 18:06:06', 0, 1869, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833891c30af7', '大祥区', 'pub', '430503', 'cskefu', NULL, '297e1e874f83129d014f8334fa6c0300', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:06', '2015-08-31 18:06:06', 0, 1870, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833891d10af8', '北塔区', 'pub', '430511', 'cskefu', NULL, '297e1e874f83129d014f8334fa6c0300', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:06', '2015-08-31 18:06:06', 0, 1871, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833891e10af9', '邵东县', 'pub', '430521', 'cskefu', NULL, '297e1e874f83129d014f8334fa6c0300', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:06', '2015-08-31 18:06:06', 0, 1872, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833891f00afa', '新邵县', 'pub', '430522', 'cskefu', NULL, '297e1e874f83129d014f8334fa6c0300', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:06', '2015-08-31 18:06:06', 0, 1873, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833891fb0afb', '邵阳县', 'pub', '430523', 'cskefu', NULL, '297e1e874f83129d014f8334fa6c0300', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:06', '2015-08-31 18:06:06', 0, 1874, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833892070afc', '隆回县', 'pub', '430524', 'cskefu', NULL, '297e1e874f83129d014f8334fa6c0300', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:06', '2015-08-31 18:06:06', 0, 1875, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833892130afd', '洞口县', 'pub', '430525', 'cskefu', NULL, '297e1e874f83129d014f8334fa6c0300', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:06', '2015-08-31 18:06:06', 0, 1876, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833892200afe', '绥宁县', 'pub', '430527', 'cskefu', NULL, '297e1e874f83129d014f8334fa6c0300', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:06', '2015-08-31 18:06:06', 0, 1877, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833892310aff', '新宁县', 'pub', '430528', 'cskefu', NULL, '297e1e874f83129d014f8334fa6c0300', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:06', '2015-08-31 18:06:06', 0, 1878, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338923d0b00', '城步苗族自治县', 'pub', '430529', 'cskefu', NULL, '297e1e874f83129d014f8334fa6c0300', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:06', '2015-08-31 18:06:06', 0, 1879, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833893760b01', '武冈市', 'pub', '430581', 'cskefu', NULL, '297e1e874f83129d014f8334fa6c0300', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:07', '2015-08-31 18:06:07', 0, 1880, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338939e0b02', '市辖区', 'pub', '430601', 'cskefu', NULL, '297e1e874f83129d014f8334fa840301', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:07', '2015-08-31 18:06:07', 0, 1881, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833893aa0b03', '岳阳楼区', 'pub', '430602', 'cskefu', NULL, '297e1e874f83129d014f8334fa840301', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:07', '2015-08-31 18:06:07', 0, 1882, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833893ba0b04', '云溪区', 'pub', '430603', 'cskefu', NULL, '297e1e874f83129d014f8334fa840301', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:07', '2015-08-31 18:06:07', 0, 1883, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833893c70b05', '君山区', 'pub', '430611', 'cskefu', NULL, '297e1e874f83129d014f8334fa840301', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:07', '2015-08-31 18:06:07', 0, 1884, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833893d80b06', '岳阳县', 'pub', '430621', 'cskefu', NULL, '297e1e874f83129d014f8334fa840301', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:07', '2015-08-31 18:06:07', 0, 1885, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833893e40b07', '华容县', 'pub', '430623', 'cskefu', NULL, '297e1e874f83129d014f8334fa840301', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:07', '2015-08-31 18:06:07', 0, 1886, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833893ef0b08', '湘阴县', 'pub', '430624', 'cskefu', NULL, '297e1e874f83129d014f8334fa840301', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:07', '2015-08-31 18:06:07', 0, 1887, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833893fb0b09', '平江县', 'pub', '430626', 'cskefu', NULL, '297e1e874f83129d014f8334fa840301', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:07', '2015-08-31 18:06:07', 0, 1888, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833894080b0a', '汨罗市', 'pub', '430681', 'cskefu', NULL, '297e1e874f83129d014f8334fa840301', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:07', '2015-08-31 18:06:07', 0, 1889, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833894150b0b', '临湘市', 'pub', '430682', 'cskefu', NULL, '297e1e874f83129d014f8334fa840301', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:07', '2015-08-31 18:06:07', 0, 1890, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338956d0b0c', '市辖区', 'pub', '430701', 'cskefu', NULL, '297e1e874f83129d014f8334fa950302', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:07', '2015-08-31 18:06:07', 0, 1891, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833895780b0d', '武陵区', 'pub', '430702', 'cskefu', NULL, '297e1e874f83129d014f8334fa950302', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:07', '2015-08-31 18:06:07', 0, 1892, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833895860b0e', '鼎城区', 'pub', '430703', 'cskefu', NULL, '297e1e874f83129d014f8334fa950302', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:07', '2015-08-31 18:06:07', 0, 1893, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833895930b0f', '安乡县', 'pub', '430721', 'cskefu', NULL, '297e1e874f83129d014f8334fa950302', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:07', '2015-08-31 18:06:07', 0, 1894, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833895a10b10', '汉寿县', 'pub', '430722', 'cskefu', NULL, '297e1e874f83129d014f8334fa950302', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:07', '2015-08-31 18:06:07', 0, 1895, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833895ae0b11', '澧　县', 'pub', '430723', 'cskefu', NULL, '297e1e874f83129d014f8334fa950302', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:07', '2015-08-31 18:06:07', 0, 1896, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833895b90b12', '临澧县', 'pub', '430724', 'cskefu', NULL, '297e1e874f83129d014f8334fa950302', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:07', '2015-08-31 18:06:07', 0, 1897, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833895c70b13', '桃源县', 'pub', '430725', 'cskefu', NULL, '297e1e874f83129d014f8334fa950302', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:07', '2015-08-31 18:06:07', 0, 1898, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833895d70b14', '石门县', 'pub', '430726', 'cskefu', NULL, '297e1e874f83129d014f8334fa950302', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:07', '2015-08-31 18:06:07', 0, 1899, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833895e20b15', '津市市', 'pub', '430781', 'cskefu', NULL, '297e1e874f83129d014f8334fa950302', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:07', '2015-08-31 18:06:07', 0, 1900, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833896090b16', '市辖区', 'pub', '430801', 'cskefu', NULL, '297e1e874f83129d014f8334fac00303', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:07', '2015-08-31 18:06:07', 0, 1901, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833896160b17', '永定区', 'pub', '430802', 'cskefu', NULL, '297e1e874f83129d014f8334fac00303', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:07', '2015-08-31 18:06:07', 0, 1902, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833896250b18', '武陵源区', 'pub', '430811', 'cskefu', NULL, '297e1e874f83129d014f8334fac00303', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:07', '2015-08-31 18:06:07', 0, 1903, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338975e0b19', '慈利县', 'pub', '430821', 'cskefu', NULL, '297e1e874f83129d014f8334fac00303', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:08', '2015-08-31 18:06:08', 0, 1904, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833897690b1a', '桑植县', 'pub', '430822', 'cskefu', NULL, '297e1e874f83129d014f8334fac00303', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:08', '2015-08-31 18:06:08', 0, 1905, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338978f0b1b', '市辖区', 'pub', '430901', 'cskefu', NULL, '297e1e874f83129d014f8334fafb0304', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:08', '2015-08-31 18:06:08', 0, 1906, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338979b0b1c', '资阳区', 'pub', '430902', 'cskefu', NULL, '297e1e874f83129d014f8334fafb0304', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:08', '2015-08-31 18:06:08', 0, 1907, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833897a60b1d', '赫山区', 'pub', '430903', 'cskefu', NULL, '297e1e874f83129d014f8334fafb0304', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:08', '2015-08-31 18:06:08', 0, 1908, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833897b40b1e', '南　县', 'pub', '430921', 'cskefu', NULL, '297e1e874f83129d014f8334fafb0304', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:08', '2015-08-31 18:06:08', 0, 1909, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833897bf0b1f', '桃江县', 'pub', '430922', 'cskefu', NULL, '297e1e874f83129d014f8334fafb0304', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:08', '2015-08-31 18:06:08', 0, 1910, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833897cb0b20', '安化县', 'pub', '430923', 'cskefu', NULL, '297e1e874f83129d014f8334fafb0304', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:08', '2015-08-31 18:06:08', 0, 1911, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833897d60b21', '沅江市', 'pub', '430981', 'cskefu', NULL, '297e1e874f83129d014f8334fafb0304', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:08', '2015-08-31 18:06:08', 0, 1912, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833899280b22', '市辖区', 'pub', '431001', 'cskefu', NULL, '297e1e874f83129d014f8334fb1b0305', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:08', '2015-08-31 18:06:08', 0, 1913, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833899370b23', '北湖区', 'pub', '431002', 'cskefu', NULL, '297e1e874f83129d014f8334fb1b0305', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:08', '2015-08-31 18:06:08', 0, 1914, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833899430b24', '苏仙区', 'pub', '431003', 'cskefu', NULL, '297e1e874f83129d014f8334fb1b0305', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:08', '2015-08-31 18:06:08', 0, 1915, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833899530b25', '桂阳县', 'pub', '431021', 'cskefu', NULL, '297e1e874f83129d014f8334fb1b0305', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:08', '2015-08-31 18:06:08', 0, 1916, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833899600b26', '宜章县', 'pub', '431022', 'cskefu', NULL, '297e1e874f83129d014f8334fb1b0305', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:08', '2015-08-31 18:06:08', 0, 1917, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338996e0b27', '永兴县', 'pub', '431023', 'cskefu', NULL, '297e1e874f83129d014f8334fb1b0305', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:08', '2015-08-31 18:06:08', 0, 1918, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338997c0b28', '嘉禾县', 'pub', '431024', 'cskefu', NULL, '297e1e874f83129d014f8334fb1b0305', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:08', '2015-08-31 18:06:08', 0, 1919, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833899870b29', '临武县', 'pub', '431025', 'cskefu', NULL, '297e1e874f83129d014f8334fb1b0305', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:08', '2015-08-31 18:06:08', 0, 1920, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833899950b2a', '汝城县', 'pub', '431026', 'cskefu', NULL, '297e1e874f83129d014f8334fb1b0305', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:08', '2015-08-31 18:06:08', 0, 1921, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833899a10b2b', '桂东县', 'pub', '431027', 'cskefu', NULL, '297e1e874f83129d014f8334fb1b0305', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:08', '2015-08-31 18:06:08', 0, 1922, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833899ae0b2c', '安仁县', 'pub', '431028', 'cskefu', NULL, '297e1e874f83129d014f8334fb1b0305', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:08', '2015-08-31 18:06:08', 0, 1923, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833899bf0b2d', '资兴市', 'pub', '431081', 'cskefu', NULL, '297e1e874f83129d014f8334fb1b0305', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:08', '2015-08-31 18:06:08', 0, 1924, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83389b1b0b2e', '市辖区', 'pub', '431101', 'cskefu', NULL, '297e1e874f83129d014f8334fb3d0306', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:09', '2015-08-31 18:06:09', 0, 1925, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83389b280b2f', '芝山区', 'pub', '431102', 'cskefu', NULL, '297e1e874f83129d014f8334fb3d0306', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:09', '2015-08-31 18:06:09', 0, 1926, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83389b390b30', '冷水滩区', 'pub', '431103', 'cskefu', NULL, '297e1e874f83129d014f8334fb3d0306', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:09', '2015-08-31 18:06:09', 0, 1927, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83389b450b31', '祁阳县', 'pub', '431121', 'cskefu', NULL, '297e1e874f83129d014f8334fb3d0306', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:09', '2015-08-31 18:06:09', 0, 1928, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83389b530b32', '东安县', 'pub', '431122', 'cskefu', NULL, '297e1e874f83129d014f8334fb3d0306', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:09', '2015-08-31 18:06:09', 0, 1929, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83389b670b33', '双牌县', 'pub', '431123', 'cskefu', NULL, '297e1e874f83129d014f8334fb3d0306', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:09', '2015-08-31 18:06:09', 0, 1930, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83389b800b34', '道　县', 'pub', '431124', 'cskefu', NULL, '297e1e874f83129d014f8334fb3d0306', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:09', '2015-08-31 18:06:09', 0, 1931, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83389b8f0b35', '江永县', 'pub', '431125', 'cskefu', NULL, '297e1e874f83129d014f8334fb3d0306', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:09', '2015-08-31 18:06:09', 0, 1932, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83389ba40b36', '宁远县', 'pub', '431126', 'cskefu', NULL, '297e1e874f83129d014f8334fb3d0306', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:09', '2015-08-31 18:06:09', 0, 1933, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83389bb90b37', '蓝山县', 'pub', '431127', 'cskefu', NULL, '297e1e874f83129d014f8334fb3d0306', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:09', '2015-08-31 18:06:09', 0, 1934, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83389bc80b38', '新田县', 'pub', '431128', 'cskefu', NULL, '297e1e874f83129d014f8334fb3d0306', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:09', '2015-08-31 18:06:09', 0, 1935, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83389bd70b39', '江华瑶族自治县', 'pub', '431129', 'cskefu', NULL, '297e1e874f83129d014f8334fb3d0306', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:09', '2015-08-31 18:06:09', 0, 1936, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83389bff0b3a', '市辖区', 'pub', '431201', 'cskefu', NULL, '297e1e874f83129d014f8334fb5d0307', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:09', '2015-08-31 18:06:09', 0, 1937, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83389c0e0b3b', '鹤城区', 'pub', '431202', 'cskefu', NULL, '297e1e874f83129d014f8334fb5d0307', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:09', '2015-08-31 18:06:09', 0, 1938, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83389c1d0b3c', '中方县', 'pub', '431221', 'cskefu', NULL, '297e1e874f83129d014f8334fb5d0307', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:09', '2015-08-31 18:06:09', 0, 1939, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83389c2c0b3d', '沅陵县', 'pub', '431222', 'cskefu', NULL, '297e1e874f83129d014f8334fb5d0307', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:09', '2015-08-31 18:06:09', 0, 1940, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83389d640b3e', '辰溪县', 'pub', '431223', 'cskefu', NULL, '297e1e874f83129d014f8334fb5d0307', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:09', '2015-08-31 18:06:09', 0, 1941, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83389d710b3f', '溆浦县', 'pub', '431224', 'cskefu', NULL, '297e1e874f83129d014f8334fb5d0307', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:09', '2015-08-31 18:06:09', 0, 1942, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83389d7d0b40', '会同县', 'pub', '431225', 'cskefu', NULL, '297e1e874f83129d014f8334fb5d0307', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:09', '2015-08-31 18:06:09', 0, 1943, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83389d890b41', '麻阳苗族自治县', 'pub', '431226', 'cskefu', NULL, '297e1e874f83129d014f8334fb5d0307', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:09', '2015-08-31 18:06:09', 0, 1944, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83389d9c0b42', '新晃侗族自治县', 'pub', '431227', 'cskefu', NULL, '297e1e874f83129d014f8334fb5d0307', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:09', '2015-08-31 18:06:09', 0, 1945, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83389daa0b43', '芷江侗族自治县', 'pub', '431228', 'cskefu', NULL, '297e1e874f83129d014f8334fb5d0307', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:09', '2015-08-31 18:06:09', 0, 1946, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83389db90b44', '靖州苗族侗族自治县', 'pub', '431229', 'cskefu', NULL, '297e1e874f83129d014f8334fb5d0307', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:09', '2015-08-31 18:06:09', 0, 1947, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83389dc60b45', '通道侗族自治县', 'pub', '431230', 'cskefu', NULL, '297e1e874f83129d014f8334fb5d0307', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:09', '2015-08-31 18:06:09', 0, 1948, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83389dd20b46', '洪江市', 'pub', '431281', 'cskefu', NULL, '297e1e874f83129d014f8334fb5d0307', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:09', '2015-08-31 18:06:09', 0, 1949, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83389dfc0b47', '市辖区', 'pub', '431301', 'cskefu', NULL, '297e1e874f83129d014f8334fb800308', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:09', '2015-08-31 18:06:09', 0, 1950, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83389e0d0b48', '娄星区', 'pub', '431302', 'cskefu', NULL, '297e1e874f83129d014f8334fb800308', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:09', '2015-08-31 18:06:09', 0, 1951, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83389e1a0b49', '双峰县', 'pub', '431321', 'cskefu', NULL, '297e1e874f83129d014f8334fb800308', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:09', '2015-08-31 18:06:09', 0, 1952, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83389e260b4a', '新化县', 'pub', '431322', 'cskefu', NULL, '297e1e874f83129d014f8334fb800308', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:09', '2015-08-31 18:06:09', 0, 1953, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83389f7a0b4b', '冷水江市', 'pub', '431381', 'cskefu', NULL, '297e1e874f83129d014f8334fb800308', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:10', '2015-08-31 18:06:10', 0, 1954, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83389f880b4c', '涟源市', 'pub', '431382', 'cskefu', NULL, '297e1e874f83129d014f8334fb800308', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:10', '2015-08-31 18:06:10', 0, 1955, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83389fb40b4d', '吉首市', 'pub', '433101', 'cskefu', NULL, '297e1e874f83129d014f8334fb9f030a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:10', '2015-08-31 18:06:10', 0, 1956, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83389fc10b4e', '泸溪县', 'pub', '433122', 'cskefu', NULL, '297e1e874f83129d014f8334fb9f030a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:10', '2015-08-31 18:06:10', 0, 1957, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83389fcd0b4f', '凤凰县', 'pub', '433123', 'cskefu', NULL, '297e1e874f83129d014f8334fb9f030a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:10', '2015-08-31 18:06:10', 0, 1958, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83389fdb0b50', '花垣县', 'pub', '433124', 'cskefu', NULL, '297e1e874f83129d014f8334fb9f030a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:10', '2015-08-31 18:06:10', 0, 1959, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83389fe80b51', '保靖县', 'pub', '433125', 'cskefu', NULL, '297e1e874f83129d014f8334fb9f030a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:10', '2015-08-31 18:06:10', 0, 1960, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83389ff50b52', '古丈县', 'pub', '433126', 'cskefu', NULL, '297e1e874f83129d014f8334fb9f030a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:10', '2015-08-31 18:06:10', 0, 1961, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a0020b53', '永顺县', 'pub', '433127', 'cskefu', NULL, '297e1e874f83129d014f8334fb9f030a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:10', '2015-08-31 18:06:10', 0, 1962, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a00e0b54', '龙山县', 'pub', '433130', 'cskefu', NULL, '297e1e874f83129d014f8334fb9f030a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:10', '2015-08-31 18:06:10', 0, 1963, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a0380b55', '市辖区', 'pub', '440101', 'cskefu', NULL, '297e1e874f83129d014f8334fbf4030b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:10', '2015-08-31 18:06:10', 0, 1964, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a0440b56', '东山区', 'pub', '440102', 'cskefu', NULL, '297e1e874f83129d014f8334fbf4030b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:10', '2015-08-31 18:06:10', 0, 1965, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a0500b57', '荔湾区', 'pub', '440103', 'cskefu', NULL, '297e1e874f83129d014f8334fbf4030b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:10', '2015-08-31 18:06:10', 0, 1966, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a05c0b58', '越秀区', 'pub', '440104', 'cskefu', NULL, '297e1e874f83129d014f8334fbf4030b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:10', '2015-08-31 18:06:10', 0, 1967, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a1980b59', '海珠区', 'pub', '440105', 'cskefu', NULL, '297e1e874f83129d014f8334fbf4030b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:10', '2015-08-31 18:06:10', 0, 1968, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a1a40b5a', '天河区', 'pub', '440106', 'cskefu', NULL, '297e1e874f83129d014f8334fbf4030b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:10', '2015-08-31 18:06:10', 0, 1969, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a1b30b5b', '芳村区', 'pub', '440107', 'cskefu', NULL, '297e1e874f83129d014f8334fbf4030b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:10', '2015-08-31 18:06:10', 0, 1970, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a1c30b5c', '白云区', 'pub', '440111', 'cskefu', NULL, '297e1e874f83129d014f8334fbf4030b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:10', '2015-08-31 18:06:10', 0, 1971, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a1cf0b5d', '黄埔区', 'pub', '440112', 'cskefu', NULL, '297e1e874f83129d014f8334fbf4030b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:10', '2015-08-31 18:06:10', 0, 1972, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a1da0b5e', '番禺区', 'pub', '440113', 'cskefu', NULL, '297e1e874f83129d014f8334fbf4030b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:10', '2015-08-31 18:06:10', 0, 1973, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a1e60b5f', '花都区', 'pub', '440114', 'cskefu', NULL, '297e1e874f83129d014f8334fbf4030b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:10', '2015-08-31 18:06:10', 0, 1974, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a1f40b60', '增城市', 'pub', '440183', 'cskefu', NULL, '297e1e874f83129d014f8334fbf4030b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:10', '2015-08-31 18:06:10', 0, 1975, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a2050b61', '从化市', 'pub', '440184', 'cskefu', NULL, '297e1e874f83129d014f8334fbf4030b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:10', '2015-08-31 18:06:10', 0, 1976, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a2380b62', '市辖区', 'pub', '440201', 'cskefu', NULL, '297e1e874f83129d014f8334fc0d030c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:11', '2015-08-31 18:06:11', 0, 1977, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a24c0b63', '武江区', 'pub', '440203', 'cskefu', NULL, '297e1e874f83129d014f8334fc0d030c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:11', '2015-08-31 18:06:11', 0, 1978, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a25a0b64', '浈江区', 'pub', '440204', 'cskefu', NULL, '297e1e874f83129d014f8334fc0d030c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:11', '2015-08-31 18:06:11', 0, 1979, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a2670b65', '曲江区', 'pub', '440205', 'cskefu', NULL, '297e1e874f83129d014f8334fc0d030c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:11', '2015-08-31 18:06:11', 0, 1980, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a39f0b66', '始兴县', 'pub', '440222', 'cskefu', NULL, '297e1e874f83129d014f8334fc0d030c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:11', '2015-08-31 18:06:11', 0, 1981, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a3ab0b67', '仁化县', 'pub', '440224', 'cskefu', NULL, '297e1e874f83129d014f8334fc0d030c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:11', '2015-08-31 18:06:11', 0, 1982, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a3ba0b68', '翁源县', 'pub', '440229', 'cskefu', NULL, '297e1e874f83129d014f8334fc0d030c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:11', '2015-08-31 18:06:11', 0, 1983, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a3c80b69', '乳源瑶族自治县', 'pub', '440232', 'cskefu', NULL, '297e1e874f83129d014f8334fc0d030c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:11', '2015-08-31 18:06:11', 0, 1984, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a3d50b6a', '新丰县', 'pub', '440233', 'cskefu', NULL, '297e1e874f83129d014f8334fc0d030c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:11', '2015-08-31 18:06:11', 0, 1985, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a3e30b6b', '乐昌市', 'pub', '440281', 'cskefu', NULL, '297e1e874f83129d014f8334fc0d030c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:11', '2015-08-31 18:06:11', 0, 1986, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a3f20b6c', '南雄市', 'pub', '440282', 'cskefu', NULL, '297e1e874f83129d014f8334fc0d030c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:11', '2015-08-31 18:06:11', 0, 1987, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a41f0b6d', '市辖区', 'pub', '440301', 'cskefu', NULL, '297e1e874f83129d014f8334fc35030d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:11', '2015-08-31 18:06:11', 0, 1988, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a42d0b6e', '罗湖区', 'pub', '440303', 'cskefu', NULL, '297e1e874f83129d014f8334fc35030d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:11', '2015-08-31 18:06:11', 0, 1989, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a43e0b6f', '福田区', 'pub', '440304', 'cskefu', NULL, '297e1e874f83129d014f8334fc35030d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:11', '2015-08-31 18:06:11', 0, 1990, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a44d0b70', '南山区', 'pub', '440305', 'cskefu', NULL, '297e1e874f83129d014f8334fc35030d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:11', '2015-08-31 18:06:11', 0, 1991, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a45c0b71', '宝安区', 'pub', '440306', 'cskefu', NULL, '297e1e874f83129d014f8334fc35030d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:11', '2015-08-31 18:06:11', 0, 1992, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a5960b73', '龙岗区', 'pub', '440307', 'cskefu', NULL, '297e1e874f83129d014f8334fc35030d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:11', '2015-08-31 18:06:11', 0, 1993, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a5a60b74', '盐田区', 'pub', '440308', 'cskefu', NULL, '297e1e874f83129d014f8334fc35030d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:11', '2015-08-31 18:06:11', 0, 1994, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a5d50b75', '市辖区', 'pub', '440401', 'cskefu', NULL, '297e1e874f83129d014f8334fc4d030e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:11', '2015-08-31 18:06:11', 0, 1995, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a5e80b76', '香洲区', 'pub', '440402', 'cskefu', NULL, '297e1e874f83129d014f8334fc4d030e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:11', '2015-08-31 18:06:11', 0, 1996, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a5f50b77', '斗门区', 'pub', '440403', 'cskefu', NULL, '297e1e874f83129d014f8334fc4d030e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:11', '2015-08-31 18:06:11', 0, 1997, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a6090b78', '金湾区', 'pub', '440404', 'cskefu', NULL, '297e1e874f83129d014f8334fc4d030e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:11', '2015-08-31 18:06:11', 0, 1998, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a6360b79', '市辖区', 'pub', '440501', 'cskefu', NULL, '297e1e874f83129d014f8334fc64030f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:12', '2015-08-31 18:06:12', 0, 1999, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a6430b7a', '龙湖区', 'pub', '440507', 'cskefu', NULL, '297e1e874f83129d014f8334fc64030f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:12', '2015-08-31 18:06:12', 0, 2000, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a6550b7b', '金平区', 'pub', '440511', 'cskefu', NULL, '297e1e874f83129d014f8334fc64030f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:12', '2015-08-31 18:06:12', 0, 2001, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a7910b7c', '濠江区', 'pub', '440512', 'cskefu', NULL, '297e1e874f83129d014f8334fc64030f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:12', '2015-08-31 18:06:12', 0, 2002, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a79f0b7d', '潮阳区', 'pub', '440513', 'cskefu', NULL, '297e1e874f83129d014f8334fc64030f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:12', '2015-08-31 18:06:12', 0, 2003, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a7ad0b7e', '潮南区', 'pub', '440514', 'cskefu', NULL, '297e1e874f83129d014f8334fc64030f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:12', '2015-08-31 18:06:12', 0, 2004, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a7be0b7f', '澄海区', 'pub', '440515', 'cskefu', NULL, '297e1e874f83129d014f8334fc64030f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:12', '2015-08-31 18:06:12', 0, 2005, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a7cc0b80', '南澳县', 'pub', '440523', 'cskefu', NULL, '297e1e874f83129d014f8334fc64030f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:12', '2015-08-31 18:06:12', 0, 2006, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a7f50b81', '市辖区', 'pub', '440601', 'cskefu', NULL, '297e1e874f83129d014f8334fc830310', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:12', '2015-08-31 18:06:12', 0, 2007, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a8060b82', '禅城区', 'pub', '440604', 'cskefu', NULL, '297e1e874f83129d014f8334fc830310', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:12', '2015-08-31 18:06:12', 0, 2008, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a8140b83', '南海区', 'pub', '440605', 'cskefu', NULL, '297e1e874f83129d014f8334fc830310', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:12', '2015-08-31 18:06:12', 0, 2009, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a8230b84', '顺德区', 'pub', '440606', 'cskefu', NULL, '297e1e874f83129d014f8334fc830310', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:12', '2015-08-31 18:06:12', 0, 2010, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a8300b85', '三水区', 'pub', '440607', 'cskefu', NULL, '297e1e874f83129d014f8334fc830310', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:12', '2015-08-31 18:06:12', 0, 2011, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a8420b86', '高明区', 'pub', '440608', 'cskefu', NULL, '297e1e874f83129d014f8334fc830310', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:12', '2015-08-31 18:06:12', 0, 2012, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a86e0b87', '市辖区', 'pub', '440701', 'cskefu', NULL, '297e1e874f83129d014f8334fca40311', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:12', '2015-08-31 18:06:12', 0, 2013, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a87e0b88', '蓬江区', 'pub', '440703', 'cskefu', NULL, '297e1e874f83129d014f8334fca40311', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:12', '2015-08-31 18:06:12', 0, 2014, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a88b0b89', '江海区', 'pub', '440704', 'cskefu', NULL, '297e1e874f83129d014f8334fca40311', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:12', '2015-08-31 18:06:12', 0, 2015, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a9c40b8a', '新会区', 'pub', '440705', 'cskefu', NULL, '297e1e874f83129d014f8334fca40311', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:12', '2015-08-31 18:06:12', 0, 2016, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a9d20b8b', '台山市', 'pub', '440781', 'cskefu', NULL, '297e1e874f83129d014f8334fca40311', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:12', '2015-08-31 18:06:12', 0, 2017, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a9df0b8c', '开平市', 'pub', '440783', 'cskefu', NULL, '297e1e874f83129d014f8334fca40311', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:12', '2015-08-31 18:06:12', 0, 2018, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a9ec0b8d', '鹤山市', 'pub', '440784', 'cskefu', NULL, '297e1e874f83129d014f8334fca40311', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:12', '2015-08-31 18:06:12', 0, 2019, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338a9f90b8e', '恩平市', 'pub', '440785', 'cskefu', NULL, '297e1e874f83129d014f8334fca40311', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:12', '2015-08-31 18:06:12', 0, 2020, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338aa1c0b8f', '市辖区', 'pub', '440801', 'cskefu', NULL, '297e1e874f83129d014f8334fcc10312', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:13', '2015-08-31 18:06:13', 0, 2021, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338aa290b90', '赤坎区', 'pub', '440802', 'cskefu', NULL, '297e1e874f83129d014f8334fcc10312', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:13', '2015-08-31 18:06:13', 0, 2022, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338aa350b91', '霞山区', 'pub', '440803', 'cskefu', NULL, '297e1e874f83129d014f8334fcc10312', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:13', '2015-08-31 18:06:13', 0, 2023, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338aa470b92', '坡头区', 'pub', '440804', 'cskefu', NULL, '297e1e874f83129d014f8334fcc10312', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:13', '2015-08-31 18:06:13', 0, 2024, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338aa540b93', '麻章区', 'pub', '440811', 'cskefu', NULL, '297e1e874f83129d014f8334fcc10312', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:13', '2015-08-31 18:06:13', 0, 2025, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338aa650b94', '遂溪县', 'pub', '440823', 'cskefu', NULL, '297e1e874f83129d014f8334fcc10312', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:13', '2015-08-31 18:06:13', 0, 2026, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338aa740b95', '徐闻县', 'pub', '440825', 'cskefu', NULL, '297e1e874f83129d014f8334fcc10312', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:13', '2015-08-31 18:06:13', 0, 2027, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338aa840b96', '廉江市', 'pub', '440881', 'cskefu', NULL, '297e1e874f83129d014f8334fcc10312', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:13', '2015-08-31 18:06:13', 0, 2028, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338abc10b97', '雷州市', 'pub', '440882', 'cskefu', NULL, '297e1e874f83129d014f8334fcc10312', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:13', '2015-08-31 18:06:13', 0, 2029, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338abcd0b98', '吴川市', 'pub', '440883', 'cskefu', NULL, '297e1e874f83129d014f8334fcc10312', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:13', '2015-08-31 18:06:13', 0, 2030, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ac400b99', '市辖区', 'pub', '440901', 'cskefu', NULL, '297e1e874f83129d014f8334fcdb0313', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:13', '2015-08-31 18:06:13', 0, 2031, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ac4f0b9a', '茂南区', 'pub', '440902', 'cskefu', NULL, '297e1e874f83129d014f8334fcdb0313', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:13', '2015-08-31 18:06:13', 0, 2032, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ac5e0b9b', '茂港区', 'pub', '440903', 'cskefu', NULL, '297e1e874f83129d014f8334fcdb0313', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:13', '2015-08-31 18:06:13', 0, 2033, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ac6b0b9c', '电白县', 'pub', '440923', 'cskefu', NULL, '297e1e874f83129d014f8334fcdb0313', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:13', '2015-08-31 18:06:13', 0, 2034, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ac7a0b9d', '高州市', 'pub', '440981', 'cskefu', NULL, '297e1e874f83129d014f8334fcdb0313', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:13', '2015-08-31 18:06:13', 0, 2035, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ac8c0b9e', '化州市', 'pub', '440982', 'cskefu', NULL, '297e1e874f83129d014f8334fcdb0313', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:13', '2015-08-31 18:06:13', 0, 2036, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ac980b9f', '信宜市', 'pub', '440983', 'cskefu', NULL, '297e1e874f83129d014f8334fcdb0313', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:13', '2015-08-31 18:06:13', 0, 2037, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338acbd0ba0', '市辖区', 'pub', '441201', 'cskefu', NULL, '297e1e874f83129d014f8334fceb0314', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:13', '2015-08-31 18:06:13', 0, 2038, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338acc90ba1', '端州区', 'pub', '441202', 'cskefu', NULL, '297e1e874f83129d014f8334fceb0314', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:13', '2015-08-31 18:06:13', 0, 2039, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338acd50ba2', '鼎湖区', 'pub', '441203', 'cskefu', NULL, '297e1e874f83129d014f8334fceb0314', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:13', '2015-08-31 18:06:13', 0, 2040, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ace10ba3', '广宁县', 'pub', '441223', 'cskefu', NULL, '297e1e874f83129d014f8334fceb0314', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:13', '2015-08-31 18:06:13', 0, 2041, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338acf00ba4', '怀集县', 'pub', '441224', 'cskefu', NULL, '297e1e874f83129d014f8334fceb0314', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:13', '2015-08-31 18:06:13', 0, 2042, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ae290ba5', '封开县', 'pub', '441225', 'cskefu', NULL, '297e1e874f83129d014f8334fceb0314', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:14', '2015-08-31 18:06:14', 0, 2043, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ae350ba6', '德庆县', 'pub', '441226', 'cskefu', NULL, '297e1e874f83129d014f8334fceb0314', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:14', '2015-08-31 18:06:14', 0, 2044, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ae410ba7', '高要市', 'pub', '441283', 'cskefu', NULL, '297e1e874f83129d014f8334fceb0314', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:14', '2015-08-31 18:06:14', 0, 2045, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ae4e0ba8', '四会市', 'pub', '441284', 'cskefu', NULL, '297e1e874f83129d014f8334fceb0314', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:14', '2015-08-31 18:06:14', 0, 2046, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ae760ba9', '市辖区', 'pub', '441301', 'cskefu', NULL, '297e1e874f83129d014f8334fd140315', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:14', '2015-08-31 18:06:14', 0, 2047, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ae830baa', '惠城区', 'pub', '441302', 'cskefu', NULL, '297e1e874f83129d014f8334fd140315', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:14', '2015-08-31 18:06:14', 0, 2048, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ae900bab', '惠阳区', 'pub', '441303', 'cskefu', NULL, '297e1e874f83129d014f8334fd140315', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:14', '2015-08-31 18:06:14', 0, 2049, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ae9b0bac', '博罗县', 'pub', '441322', 'cskefu', NULL, '297e1e874f83129d014f8334fd140315', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:14', '2015-08-31 18:06:14', 0, 2050, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338aeaa0bad', '惠东县', 'pub', '441323', 'cskefu', NULL, '297e1e874f83129d014f8334fd140315', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:14', '2015-08-31 18:06:14', 0, 2051, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338aeb90bae', '龙门县', 'pub', '441324', 'cskefu', NULL, '297e1e874f83129d014f8334fd140315', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:14', '2015-08-31 18:06:14', 0, 2052, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338aee00baf', '市辖区', 'pub', '441401', 'cskefu', NULL, '297e1e874f83129d014f8334fd2f0316', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:14', '2015-08-31 18:06:14', 0, 2053, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b01a0bb0', '梅江区', 'pub', '441402', 'cskefu', NULL, '297e1e874f83129d014f8334fd2f0316', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:14', '2015-08-31 18:06:14', 0, 2054, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b0270bb1', '梅　县', 'pub', '441421', 'cskefu', NULL, '297e1e874f83129d014f8334fd2f0316', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:14', '2015-08-31 18:06:14', 0, 2055, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b0340bb2', '大埔县', 'pub', '441422', 'cskefu', NULL, '297e1e874f83129d014f8334fd2f0316', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:14', '2015-08-31 18:06:14', 0, 2056, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b0440bb3', '丰顺县', 'pub', '441423', 'cskefu', NULL, '297e1e874f83129d014f8334fd2f0316', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:14', '2015-08-31 18:06:14', 0, 2057, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b0510bb4', '五华县', 'pub', '441424', 'cskefu', NULL, '297e1e874f83129d014f8334fd2f0316', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:14', '2015-08-31 18:06:14', 0, 2058, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b05f0bb5', '平远县', 'pub', '441426', 'cskefu', NULL, '297e1e874f83129d014f8334fd2f0316', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:14', '2015-08-31 18:06:14', 0, 2059, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b06c0bb6', '蕉岭县', 'pub', '441427', 'cskefu', NULL, '297e1e874f83129d014f8334fd2f0316', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:14', '2015-08-31 18:06:14', 0, 2060, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b0780bb7', '兴宁市', 'pub', '441481', 'cskefu', NULL, '297e1e874f83129d014f8334fd2f0316', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:14', '2015-08-31 18:06:14', 0, 2061, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b09f0bb8', '市辖区', 'pub', '441501', 'cskefu', NULL, '297e1e874f83129d014f8334fd4d0317', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:14', '2015-08-31 18:06:14', 0, 2062, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b0af0bb9', '城　区', 'pub', '441502', 'cskefu', NULL, '297e1e874f83129d014f8334fd4d0317', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:14', '2015-08-31 18:06:14', 0, 2063, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b0bc0bba', '海丰县', 'pub', '441521', 'cskefu', NULL, '297e1e874f83129d014f8334fd4d0317', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:14', '2015-08-31 18:06:14', 0, 2064, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b0ce0bbb', '陆河县', 'pub', '441523', 'cskefu', NULL, '297e1e874f83129d014f8334fd4d0317', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:14', '2015-08-31 18:06:14', 0, 2065, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b0dc0bbc', '陆丰市', 'pub', '441581', 'cskefu', NULL, '297e1e874f83129d014f8334fd4d0317', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:14', '2015-08-31 18:06:14', 0, 2066, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b22e0bbd', '市辖区', 'pub', '441601', 'cskefu', NULL, '297e1e874f83129d014f8334fd650318', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:15', '2015-08-31 18:06:15', 0, 2067, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b23c0bbe', '源城区', 'pub', '441602', 'cskefu', NULL, '297e1e874f83129d014f8334fd650318', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:15', '2015-08-31 18:06:15', 0, 2068, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b2490bbf', '紫金县', 'pub', '441621', 'cskefu', NULL, '297e1e874f83129d014f8334fd650318', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:15', '2015-08-31 18:06:15', 0, 2069, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b2560bc0', '龙川县', 'pub', '441622', 'cskefu', NULL, '297e1e874f83129d014f8334fd650318', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:15', '2015-08-31 18:06:15', 0, 2070, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b2620bc1', '连平县', 'pub', '441623', 'cskefu', NULL, '297e1e874f83129d014f8334fd650318', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:15', '2015-08-31 18:06:15', 0, 2071, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b2700bc2', '和平县', 'pub', '441624', 'cskefu', NULL, '297e1e874f83129d014f8334fd650318', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:15', '2015-08-31 18:06:15', 0, 2072, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b27c0bc3', '东源县', 'pub', '441625', 'cskefu', NULL, '297e1e874f83129d014f8334fd650318', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:15', '2015-08-31 18:06:15', 0, 2073, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b2a90bc4', '市辖区', 'pub', '441701', 'cskefu', NULL, '297e1e874f83129d014f8334fd7b0319', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:15', '2015-08-31 18:06:15', 0, 2074, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b2b50bc5', '江城区', 'pub', '441702', 'cskefu', NULL, '297e1e874f83129d014f8334fd7b0319', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:15', '2015-08-31 18:06:15', 0, 2075, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b2c20bc6', '阳西县', 'pub', '441721', 'cskefu', NULL, '297e1e874f83129d014f8334fd7b0319', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:15', '2015-08-31 18:06:15', 0, 2076, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b2ce0bc7', '阳东县', 'pub', '441723', 'cskefu', NULL, '297e1e874f83129d014f8334fd7b0319', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:15', '2015-08-31 18:06:15', 0, 2077, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b4070bc8', '阳春市', 'pub', '441781', 'cskefu', NULL, '297e1e874f83129d014f8334fd7b0319', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:15', '2015-08-31 18:06:15', 0, 2078, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b4320bc9', '市辖区', 'pub', '441801', 'cskefu', NULL, '297e1e874f83129d014f8334fda2031a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:15', '2015-08-31 18:06:15', 0, 2079, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b43e0bca', '清城区', 'pub', '441802', 'cskefu', NULL, '297e1e874f83129d014f8334fda2031a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:15', '2015-08-31 18:06:15', 0, 2080, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b44f0bcb', '佛冈县', 'pub', '441821', 'cskefu', NULL, '297e1e874f83129d014f8334fda2031a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:15', '2015-08-31 18:06:15', 0, 2081, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b45b0bcc', '阳山县', 'pub', '441823', 'cskefu', NULL, '297e1e874f83129d014f8334fda2031a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:15', '2015-08-31 18:06:15', 0, 2082, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b4690bcd', '连山壮族瑶族自治县', 'pub', '441825', 'cskefu', NULL, '297e1e874f83129d014f8334fda2031a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:15', '2015-08-31 18:06:15', 0, 2083, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b4750bce', '连南瑶族自治县', 'pub', '441826', 'cskefu', NULL, '297e1e874f83129d014f8334fda2031a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:15', '2015-08-31 18:06:15', 0, 2084, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b4810bcf', '清新县', 'pub', '441827', 'cskefu', NULL, '297e1e874f83129d014f8334fda2031a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:15', '2015-08-31 18:06:15', 0, 2085, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b48d0bd0', '英德市', 'pub', '441881', 'cskefu', NULL, '297e1e874f83129d014f8334fda2031a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:15', '2015-08-31 18:06:15', 0, 2086, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b49a0bd1', '连州市', 'pub', '441882', 'cskefu', NULL, '297e1e874f83129d014f8334fda2031a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:15', '2015-08-31 18:06:15', 0, 2087, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b4c00bd2', '市辖区', 'pub', '445101', 'cskefu', NULL, '297e1e874f83129d014f8334fde1031d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:15', '2015-08-31 18:06:15', 0, 2088, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b5f90bd3', '湘桥区', 'pub', '445102', 'cskefu', NULL, '297e1e874f83129d014f8334fde1031d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:16', '2015-08-31 18:06:16', 0, 2089, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b6050bd4', '潮安县', 'pub', '445121', 'cskefu', NULL, '297e1e874f83129d014f8334fde1031d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:16', '2015-08-31 18:06:16', 0, 2090, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b6130bd5', '饶平县', 'pub', '445122', 'cskefu', NULL, '297e1e874f83129d014f8334fde1031d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:16', '2015-08-31 18:06:16', 0, 2091, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b63b0bd6', '市辖区', 'pub', '445201', 'cskefu', NULL, '297e1e874f83129d014f8334fdf3031e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:16', '2015-08-31 18:06:16', 0, 2092, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b6470bd7', '榕城区', 'pub', '445202', 'cskefu', NULL, '297e1e874f83129d014f8334fdf3031e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:16', '2015-08-31 18:06:16', 0, 2093, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b6540bd8', '揭东县', 'pub', '445221', 'cskefu', NULL, '297e1e874f83129d014f8334fdf3031e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:16', '2015-08-31 18:06:16', 0, 2094, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b6600bd9', '揭西县', 'pub', '445222', 'cskefu', NULL, '297e1e874f83129d014f8334fdf3031e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:16', '2015-08-31 18:06:16', 0, 2095, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b66e0bda', '惠来县', 'pub', '445224', 'cskefu', NULL, '297e1e874f83129d014f8334fdf3031e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:16', '2015-08-31 18:06:16', 0, 2096, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b6790bdb', '普宁市', 'pub', '445281', 'cskefu', NULL, '297e1e874f83129d014f8334fdf3031e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:16', '2015-08-31 18:06:16', 0, 2097, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b69d0bdc', '市辖区', 'pub', '445301', 'cskefu', NULL, '297e1e874f83129d014f8334fe01031f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:16', '2015-08-31 18:06:16', 0, 2098, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b6aa0bdd', '云城区', 'pub', '445302', 'cskefu', NULL, '297e1e874f83129d014f8334fe01031f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:16', '2015-08-31 18:06:16', 0, 2099, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b7e60bde', '新兴县', 'pub', '445321', 'cskefu', NULL, '297e1e874f83129d014f8334fe01031f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:16', '2015-08-31 18:06:16', 0, 2100, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b7f30bdf', '郁南县', 'pub', '445322', 'cskefu', NULL, '297e1e874f83129d014f8334fe01031f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:16', '2015-08-31 18:06:16', 0, 2101, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b8010be0', '云安县', 'pub', '445323', 'cskefu', NULL, '297e1e874f83129d014f8334fe01031f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:16', '2015-08-31 18:06:16', 0, 2102, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b80f0be1', '罗定市', 'pub', '445381', 'cskefu', NULL, '297e1e874f83129d014f8334fe01031f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:16', '2015-08-31 18:06:16', 0, 2103, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b8370be2', '市辖区', 'pub', '450101', 'cskefu', NULL, '297e1e874f83129d014f8334ff530320', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:16', '2015-08-31 18:06:16', 0, 2104, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b84d0be3', '兴宁区', 'pub', '450102', 'cskefu', NULL, '297e1e874f83129d014f8334ff530320', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:16', '2015-08-31 18:06:16', 0, 2105, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b85b0be4', '青秀区', 'pub', '450103', 'cskefu', NULL, '297e1e874f83129d014f8334ff530320', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:16', '2015-08-31 18:06:16', 0, 2106, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b8700be5', '江南区', 'pub', '450105', 'cskefu', NULL, '297e1e874f83129d014f8334ff530320', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:16', '2015-08-31 18:06:16', 0, 2107, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b8800be6', '西乡塘区', 'pub', '450107', 'cskefu', NULL, '297e1e874f83129d014f8334ff530320', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:16', '2015-08-31 18:06:16', 0, 2108, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b8910be7', '良庆区', 'pub', '450108', 'cskefu', NULL, '297e1e874f83129d014f8334ff530320', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:16', '2015-08-31 18:06:16', 0, 2109, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b8a00be9', '邕宁区', 'pub', '450109', 'cskefu', NULL, '297e1e874f83129d014f8334ff530320', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:16', '2015-08-31 18:06:16', 0, 2110, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b9de0bea', '武鸣县', 'pub', '450122', 'cskefu', NULL, '297e1e874f83129d014f8334ff530320', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:17', '2015-08-31 18:06:17', 0, 2111, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b9eb0beb', '隆安县', 'pub', '450123', 'cskefu', NULL, '297e1e874f83129d014f8334ff530320', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:17', '2015-08-31 18:06:17', 0, 2112, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338b9fb0bec', '马山县', 'pub', '450124', 'cskefu', NULL, '297e1e874f83129d014f8334ff530320', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:17', '2015-08-31 18:06:17', 0, 2113, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ba080bed', '上林县', 'pub', '450125', 'cskefu', NULL, '297e1e874f83129d014f8334ff530320', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:17', '2015-08-31 18:06:17', 0, 2114, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ba160bee', '宾阳县', 'pub', '450126', 'cskefu', NULL, '297e1e874f83129d014f8334ff530320', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:17', '2015-08-31 18:06:17', 0, 2115, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ba240bef', '横　县', 'pub', '450127', 'cskefu', NULL, '297e1e874f83129d014f8334ff530320', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:17', '2015-08-31 18:06:17', 0, 2116, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ba4d0bf0', '市辖区', 'pub', '450201', 'cskefu', NULL, '297e1e874f83129d014f8334ff630321', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:17', '2015-08-31 18:06:17', 0, 2117, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ba5b0bf1', '城中区', 'pub', '450202', 'cskefu', NULL, '297e1e874f83129d014f8334ff630321', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:17', '2015-08-31 18:06:17', 0, 2118, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ba6d0bf2', '鱼峰区', 'pub', '450203', 'cskefu', NULL, '297e1e874f83129d014f8334ff630321', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:17', '2015-08-31 18:06:17', 0, 2119, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ba790bf3', '柳南区', 'pub', '450204', 'cskefu', NULL, '297e1e874f83129d014f8334ff630321', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:17', '2015-08-31 18:06:17', 0, 2120, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ba860bf4', '柳北区', 'pub', '450205', 'cskefu', NULL, '297e1e874f83129d014f8334ff630321', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:17', '2015-08-31 18:06:17', 0, 2121, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ba960bf5', '柳江县', 'pub', '450221', 'cskefu', NULL, '297e1e874f83129d014f8334ff630321', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:17', '2015-08-31 18:06:17', 0, 2122, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338baa40bf6', '柳城县', 'pub', '450222', 'cskefu', NULL, '297e1e874f83129d014f8334ff630321', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:17', '2015-08-31 18:06:17', 0, 2123, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338bbe70bf7', '鹿寨县', 'pub', '450223', 'cskefu', NULL, '297e1e874f83129d014f8334ff630321', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:17', '2015-08-31 18:06:17', 0, 2124, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338bbf40bf8', '融安县', 'pub', '450224', 'cskefu', NULL, '297e1e874f83129d014f8334ff630321', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:17', '2015-08-31 18:06:17', 0, 2125, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338bc010bf9', '融水苗族自治县', 'pub', '450225', 'cskefu', NULL, '297e1e874f83129d014f8334ff630321', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:17', '2015-08-31 18:06:17', 0, 2126, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338bc0d0bfa', '三江侗族自治县', 'pub', '450226', 'cskefu', NULL, '297e1e874f83129d014f8334ff630321', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:17', '2015-08-31 18:06:17', 0, 2127, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338bc320bfb', '市辖区', 'pub', '450301', 'cskefu', NULL, '297e1e874f83129d014f8334ff6f0322', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:17', '2015-08-31 18:06:17', 0, 2128, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338bc3f0bfc', '秀峰区', 'pub', '450302', 'cskefu', NULL, '297e1e874f83129d014f8334ff6f0322', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:17', '2015-08-31 18:06:17', 0, 2129, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338bc500bfd', '叠彩区', 'pub', '450303', 'cskefu', NULL, '297e1e874f83129d014f8334ff6f0322', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:17', '2015-08-31 18:06:17', 0, 2130, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338bc5c0bfe', '象山区', 'pub', '450304', 'cskefu', NULL, '297e1e874f83129d014f8334ff6f0322', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:17', '2015-08-31 18:06:17', 0, 2131, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338bc690bff', '七星区', 'pub', '450305', 'cskefu', NULL, '297e1e874f83129d014f8334ff6f0322', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:17', '2015-08-31 18:06:17', 0, 2132, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338bc780c00', '雁山区', 'pub', '450311', 'cskefu', NULL, '297e1e874f83129d014f8334ff6f0322', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:17', '2015-08-31 18:06:17', 0, 2133, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338bc840c01', '阳朔县', 'pub', '450321', 'cskefu', NULL, '297e1e874f83129d014f8334ff6f0322', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:17', '2015-08-31 18:06:17', 0, 2134, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338bc920c02', '临桂县', 'pub', '450322', 'cskefu', NULL, '297e1e874f83129d014f8334ff6f0322', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:17', '2015-08-31 18:06:17', 0, 2135, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338bca00c03', '灵川县', 'pub', '450323', 'cskefu', NULL, '297e1e874f83129d014f8334ff6f0322', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:17', '2015-08-31 18:06:17', 0, 2136, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338bdda0c04', '全州县', 'pub', '450324', 'cskefu', NULL, '297e1e874f83129d014f8334ff6f0322', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:18', '2015-08-31 18:06:18', 0, 2137, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338bdec0c05', '兴安县', 'pub', '450325', 'cskefu', NULL, '297e1e874f83129d014f8334ff6f0322', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:18', '2015-08-31 18:06:18', 0, 2138, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338bdf80c06', '永福县', 'pub', '450326', 'cskefu', NULL, '297e1e874f83129d014f8334ff6f0322', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:18', '2015-08-31 18:06:18', 0, 2139, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338be040c07', '灌阳县', 'pub', '450327', 'cskefu', NULL, '297e1e874f83129d014f8334ff6f0322', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:18', '2015-08-31 18:06:18', 0, 2140, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338be140c08', '龙胜各族自治县', 'pub', '450328', 'cskefu', NULL, '297e1e874f83129d014f8334ff6f0322', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:18', '2015-08-31 18:06:18', 0, 2141, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338be210c09', '资源县', 'pub', '450329', 'cskefu', NULL, '297e1e874f83129d014f8334ff6f0322', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:18', '2015-08-31 18:06:18', 0, 2142, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338be310c0a', '平乐县', 'pub', '450330', 'cskefu', NULL, '297e1e874f83129d014f8334ff6f0322', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:18', '2015-08-31 18:06:18', 0, 2143, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338be3d0c0b', '荔蒲县', 'pub', '450331', 'cskefu', NULL, '297e1e874f83129d014f8334ff6f0322', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:18', '2015-08-31 18:06:18', 0, 2144, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338be530c0c', '恭城瑶族自治县', 'pub', '450332', 'cskefu', NULL, '297e1e874f83129d014f8334ff6f0322', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:18', '2015-08-31 18:06:18', 0, 2145, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338be7a0c0d', '市辖区', 'pub', '450401', 'cskefu', NULL, '297e1e874f83129d014f8334ff7c0323', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:18', '2015-08-31 18:06:18', 0, 2146, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338be8a0c0e', '万秀区', 'pub', '450403', 'cskefu', NULL, '297e1e874f83129d014f8334ff7c0323', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:18', '2015-08-31 18:06:18', 0, 2147, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338be980c0f', '蝶山区', 'pub', '450404', 'cskefu', NULL, '297e1e874f83129d014f8334ff7c0323', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:18', '2015-08-31 18:06:18', 0, 2148, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338bea40c10', '长洲区', 'pub', '450405', 'cskefu', NULL, '297e1e874f83129d014f8334ff7c0323', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:18', '2015-08-31 18:06:18', 0, 2149, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338beb00c11', '苍梧县', 'pub', '450421', 'cskefu', NULL, '297e1e874f83129d014f8334ff7c0323', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:18', '2015-08-31 18:06:18', 0, 2150, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338bebf0c12', '藤　县', 'pub', '450422', 'cskefu', NULL, '297e1e874f83129d014f8334ff7c0323', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:18', '2015-08-31 18:06:18', 0, 2151, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338bece0c13', '蒙山县', 'pub', '450423', 'cskefu', NULL, '297e1e874f83129d014f8334ff7c0323', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:18', '2015-08-31 18:06:18', 0, 2152, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c0080c14', '岑溪市', 'pub', '450481', 'cskefu', NULL, '297e1e874f83129d014f8334ff7c0323', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:18', '2015-08-31 18:06:18', 0, 2153, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c0300c15', '市辖区', 'pub', '450501', 'cskefu', NULL, '297e1e874f83129d014f8334ff890324', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:18', '2015-08-31 18:06:18', 0, 2154, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c03c0c16', '海城区', 'pub', '450502', 'cskefu', NULL, '297e1e874f83129d014f8334ff890324', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:18', '2015-08-31 18:06:18', 0, 2155, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c0490c17', '银海区', 'pub', '450503', 'cskefu', NULL, '297e1e874f83129d014f8334ff890324', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:18', '2015-08-31 18:06:18', 0, 2156, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c0550c18', '铁山港区', 'pub', '450512', 'cskefu', NULL, '297e1e874f83129d014f8334ff890324', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:18', '2015-08-31 18:06:18', 0, 2157, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c0650c19', '合浦县', 'pub', '450521', 'cskefu', NULL, '297e1e874f83129d014f8334ff890324', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:18', '2015-08-31 18:06:18', 0, 2158, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c0920c1a', '市辖区', 'pub', '450601', 'cskefu', NULL, '297e1e874f83129d014f8334ff970325', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:18', '2015-08-31 18:06:18', 0, 2159, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c09f0c1b', '港口区', 'pub', '450602', 'cskefu', NULL, '297e1e874f83129d014f8334ff970325', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:18', '2015-08-31 18:06:18', 0, 2160, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c0ac0c1c', '防城区', 'pub', '450603', 'cskefu', NULL, '297e1e874f83129d014f8334ff970325', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:18', '2015-08-31 18:06:18', 0, 2161, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c0bd0c1d', '上思县', 'pub', '450621', 'cskefu', NULL, '297e1e874f83129d014f8334ff970325', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:18', '2015-08-31 18:06:18', 0, 2162, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c0cf0c1e', '东兴市', 'pub', '450681', 'cskefu', NULL, '297e1e874f83129d014f8334ff970325', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:18', '2015-08-31 18:06:18', 0, 2163, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c2290c1f', '市辖区', 'pub', '450701', 'cskefu', NULL, '297e1e874f83129d014f8334ffa50326', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:19', '2015-08-31 18:06:19', 0, 2164, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c23e0c20', '钦南区', 'pub', '450702', 'cskefu', NULL, '297e1e874f83129d014f8334ffa50326', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:19', '2015-08-31 18:06:19', 0, 2165, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c24b0c21', '钦北区', 'pub', '450703', 'cskefu', NULL, '297e1e874f83129d014f8334ffa50326', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:19', '2015-08-31 18:06:19', 0, 2166, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c25b0c22', '灵山县', 'pub', '450721', 'cskefu', NULL, '297e1e874f83129d014f8334ffa50326', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:19', '2015-08-31 18:06:19', 0, 2167, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c26c0c23', '浦北县', 'pub', '450722', 'cskefu', NULL, '297e1e874f83129d014f8334ffa50326', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:19', '2015-08-31 18:06:19', 0, 2168, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c2950c24', '市辖区', 'pub', '450801', 'cskefu', NULL, '297e1e874f83129d014f8334ffb30327', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:19', '2015-08-31 18:06:19', 0, 2169, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c2a30c25', '港北区', 'pub', '450802', 'cskefu', NULL, '297e1e874f83129d014f8334ffb30327', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:19', '2015-08-31 18:06:19', 0, 2170, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c2b10c26', '港南区', 'pub', '450803', 'cskefu', NULL, '297e1e874f83129d014f8334ffb30327', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:19', '2015-08-31 18:06:19', 0, 2171, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c2c50c27', '覃塘区', 'pub', '450804', 'cskefu', NULL, '297e1e874f83129d014f8334ffb30327', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:19', '2015-08-31 18:06:19', 0, 2172, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c2d70c28', '平南县', 'pub', '450821', 'cskefu', NULL, '297e1e874f83129d014f8334ffb30327', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:19', '2015-08-31 18:06:19', 0, 2173, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c2e80c29', '桂平市', 'pub', '450881', 'cskefu', NULL, '297e1e874f83129d014f8334ffb30327', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:19', '2015-08-31 18:06:19', 0, 2174, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c31b0c2a', '市辖区', 'pub', '450901', 'cskefu', NULL, '297e1e874f83129d014f8334ffbf0328', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:19', '2015-08-31 18:06:19', 0, 2175, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c45c0c2b', '玉州区', 'pub', '450902', 'cskefu', NULL, '297e1e874f83129d014f8334ffbf0328', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:19', '2015-08-31 18:06:19', 0, 2176, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c46b0c2c', '容　县', 'pub', '450921', 'cskefu', NULL, '297e1e874f83129d014f8334ffbf0328', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:19', '2015-08-31 18:06:19', 0, 2177, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c4880c2d', '陆川县', 'pub', '450922', 'cskefu', NULL, '297e1e874f83129d014f8334ffbf0328', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:19', '2015-08-31 18:06:19', 0, 2178, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c4980c2e', '博白县', 'pub', '450923', 'cskefu', NULL, '297e1e874f83129d014f8334ffbf0328', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:19', '2015-08-31 18:06:19', 0, 2179, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c4ab0c2f', '兴业县', 'pub', '450924', 'cskefu', NULL, '297e1e874f83129d014f8334ffbf0328', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:19', '2015-08-31 18:06:19', 0, 2180, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c4b90c30', '北流市', 'pub', '450981', 'cskefu', NULL, '297e1e874f83129d014f8334ffbf0328', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:19', '2015-08-31 18:06:19', 0, 2181, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c4ea0c31', '市辖区', 'pub', '451001', 'cskefu', NULL, '297e1e874f83129d014f8334ffce0329', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:19', '2015-08-31 18:06:19', 0, 2182, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c4fe0c32', '右江区', 'pub', '451002', 'cskefu', NULL, '297e1e874f83129d014f8334ffce0329', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:19', '2015-08-31 18:06:19', 0, 2183, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c5100c33', '田阳县', 'pub', '451021', 'cskefu', NULL, '297e1e874f83129d014f8334ffce0329', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:19', '2015-08-31 18:06:19', 0, 2184, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c51f0c34', '田东县', 'pub', '451022', 'cskefu', NULL, '297e1e874f83129d014f8334ffce0329', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:19', '2015-08-31 18:06:19', 0, 2185, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c52e0c35', '平果县', 'pub', '451023', 'cskefu', NULL, '297e1e874f83129d014f8334ffce0329', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:19', '2015-08-31 18:06:19', 0, 2186, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c53e0c36', '德保县', 'pub', '451024', 'cskefu', NULL, '297e1e874f83129d014f8334ffce0329', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:19', '2015-08-31 18:06:19', 0, 2187, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c54e0c37', '靖西县', 'pub', '451025', 'cskefu', NULL, '297e1e874f83129d014f8334ffce0329', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:19', '2015-08-31 18:06:19', 0, 2188, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c55e0c38', '那坡县', 'pub', '451026', 'cskefu', NULL, '297e1e874f83129d014f8334ffce0329', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:19', '2015-08-31 18:06:19', 0, 2189, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c56f0c39', '凌云县', 'pub', '451027', 'cskefu', NULL, '297e1e874f83129d014f8334ffce0329', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:20', '2015-08-31 18:06:20', 0, 2190, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c57b0c3a', '乐业县', 'pub', '451028', 'cskefu', NULL, '297e1e874f83129d014f8334ffce0329', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:20', '2015-08-31 18:06:20', 0, 2191, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c6b50c3b', '田林县', 'pub', '451029', 'cskefu', NULL, '297e1e874f83129d014f8334ffce0329', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:20', '2015-08-31 18:06:20', 0, 2192, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c6c60c3c', '西林县', 'pub', '451030', 'cskefu', NULL, '297e1e874f83129d014f8334ffce0329', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:20', '2015-08-31 18:06:20', 0, 2193, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c6d70c3d', '隆林各族自治县', 'pub', '451031', 'cskefu', NULL, '297e1e874f83129d014f8334ffce0329', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:20', '2015-08-31 18:06:20', 0, 2194, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c7050c3e', '市辖区', 'pub', '451101', 'cskefu', NULL, '297e1e874f83129d014f8334ffda032a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:20', '2015-08-31 18:06:20', 0, 2195, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c7160c3f', '八步区', 'pub', '451102', 'cskefu', NULL, '297e1e874f83129d014f8334ffda032a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:20', '2015-08-31 18:06:20', 0, 2196, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c7280c40', '昭平县', 'pub', '451121', 'cskefu', NULL, '297e1e874f83129d014f8334ffda032a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:20', '2015-08-31 18:06:20', 0, 2197, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c7340c41', '钟山县', 'pub', '451122', 'cskefu', NULL, '297e1e874f83129d014f8334ffda032a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:20', '2015-08-31 18:06:20', 0, 2198, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c7470c42', '富川瑶族自治县', 'pub', '451123', 'cskefu', NULL, '297e1e874f83129d014f8334ffda032a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:20', '2015-08-31 18:06:20', 0, 2199, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c76e0c43', '市辖区', 'pub', '451201', 'cskefu', NULL, '297e1e874f83129d014f8334ffe8032b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:20', '2015-08-31 18:06:20', 0, 2200, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c7800c44', '金城江区', 'pub', '451202', 'cskefu', NULL, '297e1e874f83129d014f8334ffe8032b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:20', '2015-08-31 18:06:20', 0, 2201, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c7950c45', '南丹县', 'pub', '451221', 'cskefu', NULL, '297e1e874f83129d014f8334ffe8032b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:20', '2015-08-31 18:06:20', 0, 2202, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c8d40c46', '天峨县', 'pub', '451222', 'cskefu', NULL, '297e1e874f83129d014f8334ffe8032b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:20', '2015-08-31 18:06:20', 0, 2203, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c8e70c47', '凤山县', 'pub', '451223', 'cskefu', NULL, '297e1e874f83129d014f8334ffe8032b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:20', '2015-08-31 18:06:20', 0, 2204, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c8f40c48', '东兰县', 'pub', '451224', 'cskefu', NULL, '297e1e874f83129d014f8334ffe8032b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:20', '2015-08-31 18:06:20', 0, 2205, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c9060c49', '罗城仫佬族自治县', 'pub', '451225', 'cskefu', NULL, '297e1e874f83129d014f8334ffe8032b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:20', '2015-08-31 18:06:20', 0, 2206, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c91e0c4a', '环江毛南族自治县', 'pub', '451226', 'cskefu', NULL, '297e1e874f83129d014f8334ffe8032b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:20', '2015-08-31 18:06:20', 0, 2207, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c92e0c4b', '巴马瑶族自治县', 'pub', '451227', 'cskefu', NULL, '297e1e874f83129d014f8334ffe8032b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:20', '2015-08-31 18:06:20', 0, 2208, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c93d0c4c', '都安瑶族自治县', 'pub', '451228', 'cskefu', NULL, '297e1e874f83129d014f8334ffe8032b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:20', '2015-08-31 18:06:20', 0, 2209, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c9520c4d', '大化瑶族自治县', 'pub', '451229', 'cskefu', NULL, '297e1e874f83129d014f8334ffe8032b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:21', '2015-08-31 18:06:21', 0, 2210, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c9670c4e', '宜州市', 'pub', '451281', 'cskefu', NULL, '297e1e874f83129d014f8334ffe8032b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:21', '2015-08-31 18:06:21', 0, 2211, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c9910c4f', '市辖区', 'pub', '451301', 'cskefu', NULL, '297e1e874f83129d014f8334fff6032c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:21', '2015-08-31 18:06:21', 0, 2212, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c99d0c50', '兴宾区', 'pub', '451302', 'cskefu', NULL, '297e1e874f83129d014f8334fff6032c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:21', '2015-08-31 18:06:21', 0, 2213, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c9aa0c51', '忻城县', 'pub', '451321', 'cskefu', NULL, '297e1e874f83129d014f8334fff6032c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:21', '2015-08-31 18:06:21', 0, 2214, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c9bb0c52', '象州县', 'pub', '451322', 'cskefu', NULL, '297e1e874f83129d014f8334fff6032c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:21', '2015-08-31 18:06:21', 0, 2215, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c9ce0c53', '武宣县', 'pub', '451323', 'cskefu', NULL, '297e1e874f83129d014f8334fff6032c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:21', '2015-08-31 18:06:21', 0, 2216, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338c9db0c54', '金秀瑶族自治县', 'pub', '451324', 'cskefu', NULL, '297e1e874f83129d014f8334fff6032c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:21', '2015-08-31 18:06:21', 0, 2217, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338cb190c55', '合山市', 'pub', '451381', 'cskefu', NULL, '297e1e874f83129d014f8334fff6032c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:21', '2015-08-31 18:06:21', 0, 2218, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338cb480c56', '市辖区', 'pub', '451401', 'cskefu', NULL, '297e1e874f83129d014f83350136032d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:21', '2015-08-31 18:06:21', 0, 2219, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338cb5f0c57', '江洲区', 'pub', '451402', 'cskefu', NULL, '297e1e874f83129d014f83350136032d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:21', '2015-08-31 18:06:21', 0, 2220, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338cb6d0c58', '扶绥县', 'pub', '451421', 'cskefu', NULL, '297e1e874f83129d014f83350136032d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:21', '2015-08-31 18:06:21', 0, 2221, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338cb7b0c59', '宁明县', 'pub', '451422', 'cskefu', NULL, '297e1e874f83129d014f83350136032d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:21', '2015-08-31 18:06:21', 0, 2222, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338cb920c5a', '龙州县', 'pub', '451423', 'cskefu', NULL, '297e1e874f83129d014f83350136032d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:21', '2015-08-31 18:06:21', 0, 2223, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338cba10c5b', '大新县', 'pub', '451424', 'cskefu', NULL, '297e1e874f83129d014f83350136032d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:21', '2015-08-31 18:06:21', 0, 2224, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338cbb00c5c', '天等县', 'pub', '451425', 'cskefu', NULL, '297e1e874f83129d014f83350136032d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:21', '2015-08-31 18:06:21', 0, 2225, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338cbc70c5d', '凭祥市', 'pub', '451481', 'cskefu', NULL, '297e1e874f83129d014f83350136032d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:21', '2015-08-31 18:06:21', 0, 2226, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338cbf40c5e', '市辖区', 'pub', '460101', 'cskefu', NULL, '297e1e874f83129d014f8335015b032e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:21', '2015-08-31 18:06:21', 0, 2227, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338cc040c5f', '秀英区', 'pub', '460105', 'cskefu', NULL, '297e1e874f83129d014f8335015b032e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:21', '2015-08-31 18:06:21', 0, 2228, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338cc140c60', '龙华区', 'pub', '460106', 'cskefu', NULL, '297e1e874f83129d014f8335015b032e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:21', '2015-08-31 18:06:21', 0, 2229, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338cc260c61', '琼山区', 'pub', '460107', 'cskefu', NULL, '297e1e874f83129d014f8335015b032e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:21', '2015-08-31 18:06:21', 0, 2230, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338cc370c63', '美兰区', 'pub', '460108', 'cskefu', NULL, '297e1e874f83129d014f8335015b032e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:21', '2015-08-31 18:06:21', 0, 2231, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338cd950c64', '市辖区', 'pub', '460201', 'cskefu', NULL, '297e1e874f83129d014f83350167032f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:22', '2015-08-31 18:06:22', 0, 2232, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338cdc70c65', '五指山市', 'pub', '469001', 'cskefu', NULL, '297e1e874f83129d014f833501740330', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:22', '2015-08-31 18:06:22', 0, 2233, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338cdd70c66', '琼海市', 'pub', '469002', 'cskefu', NULL, '297e1e874f83129d014f833501740330', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:22', '2015-08-31 18:06:22', 0, 2234, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338cdef0c67', '儋州市', 'pub', '469003', 'cskefu', NULL, '297e1e874f83129d014f833501740330', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:22', '2015-08-31 18:06:22', 0, 2235, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ce000c68', '文昌市', 'pub', '469005', 'cskefu', NULL, '297e1e874f83129d014f833501740330', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:22', '2015-08-31 18:06:22', 0, 2236, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ce0e0c69', '万宁市', 'pub', '469006', 'cskefu', NULL, '297e1e874f83129d014f833501740330', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:22', '2015-08-31 18:06:22', 0, 2237, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ce230c6a', '东方市', 'pub', '469007', 'cskefu', NULL, '297e1e874f83129d014f833501740330', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:22', '2015-08-31 18:06:22', 0, 2238, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ce3c0c6b', '定安县', 'pub', '469025', 'cskefu', NULL, '297e1e874f83129d014f833501740330', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:22', '2015-08-31 18:06:22', 0, 2239, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ce4b0c6c', '屯昌县', 'pub', '469026', 'cskefu', NULL, '297e1e874f83129d014f833501740330', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:22', '2015-08-31 18:06:22', 0, 2240, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ce5b0c6d', '澄迈县', 'pub', '469027', 'cskefu', NULL, '297e1e874f83129d014f833501740330', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:22', '2015-08-31 18:06:22', 0, 2241, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ce6e0c6e', '临高县', 'pub', '469028', 'cskefu', NULL, '297e1e874f83129d014f833501740330', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:22', '2015-08-31 18:06:22', 0, 2242, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ce7c0c6f', '白沙黎族自治县', 'pub', '469030', 'cskefu', NULL, '297e1e874f83129d014f833501740330', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:22', '2015-08-31 18:06:22', 0, 2243, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338cfbb0c70', '昌江黎族自治县', 'pub', '469031', 'cskefu', NULL, '297e1e874f83129d014f833501740330', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:22', '2015-08-31 18:06:22', 0, 2244, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338cfcc0c71', '乐东黎族自治县', 'pub', '469033', 'cskefu', NULL, '297e1e874f83129d014f833501740330', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:22', '2015-08-31 18:06:22', 0, 2245, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338cfdb0c72', '陵水黎族自治县', 'pub', '469034', 'cskefu', NULL, '297e1e874f83129d014f833501740330', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:22', '2015-08-31 18:06:22', 0, 2246, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338cfeb0c73', '保亭黎族苗族自治县', 'pub', '469035', 'cskefu', NULL, '297e1e874f83129d014f833501740330', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:22', '2015-08-31 18:06:22', 0, 2247, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338cffe0c74', '琼中黎族苗族自治县', 'pub', '469036', 'cskefu', NULL, '297e1e874f83129d014f833501740330', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:22', '2015-08-31 18:06:22', 0, 2248, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d0160c75', '西沙群岛', 'pub', '469037', 'cskefu', NULL, '297e1e874f83129d014f833501740330', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:22', '2015-08-31 18:06:22', 0, 2249, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d0250c76', '南沙群岛', 'pub', '469038', 'cskefu', NULL, '297e1e874f83129d014f833501740330', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:22', '2015-08-31 18:06:22', 0, 2250, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d0360c77', '中沙群岛的岛礁及其海域', 'pub', '469039', 'cskefu', NULL, '297e1e874f83129d014f833501740330', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:22', '2015-08-31 18:06:22', 0, 2251, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d0640c78', '万州区', 'pub', '500101', 'cskefu', NULL, '297e1e874f83129d014f833501a30331', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:22', '2015-08-31 18:06:22', 0, 2252, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d0710c79', '涪陵区', 'pub', '500102', 'cskefu', NULL, '297e1e874f83129d014f833501a30331', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:22', '2015-08-31 18:06:22', 0, 2253, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d0800c7a', '渝中区', 'pub', '500103', 'cskefu', NULL, '297e1e874f83129d014f833501a30331', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:22', '2015-08-31 18:06:22', 0, 2254, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d08f0c7b', '大渡口区', 'pub', '500104', 'cskefu', NULL, '297e1e874f83129d014f833501a30331', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:22', '2015-08-31 18:06:22', 0, 2255, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d09d0c7c', '江北区', 'pub', '500105', 'cskefu', NULL, '297e1e874f83129d014f833501a30331', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:22', '2015-08-31 18:06:22', 0, 2256, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d0ac0c7d', '沙坪坝区', 'pub', '500106', 'cskefu', NULL, '297e1e874f83129d014f833501a30331', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:22', '2015-08-31 18:06:22', 0, 2257, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d0be0c7e', '九龙坡区', 'pub', '500107', 'cskefu', NULL, '297e1e874f83129d014f833501a30331', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:22', '2015-08-31 18:06:22', 0, 2258, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d0cd0c7f', '南岸区', 'pub', '500108', 'cskefu', NULL, '297e1e874f83129d014f833501a30331', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:22', '2015-08-31 18:06:22', 0, 2259, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d20a0c80', '北碚区', 'pub', '500109', 'cskefu', NULL, '297e1e874f83129d014f833501a30331', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:23', '2015-08-31 18:06:23', 0, 2260, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d21c0c81', '万盛区', 'pub', '500110', 'cskefu', NULL, '297e1e874f83129d014f833501a30331', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:23', '2015-08-31 18:06:23', 0, 2261, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d2330c82', '双桥区', 'pub', '500111', 'cskefu', NULL, '297e1e874f83129d014f833501a30331', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:23', '2015-08-31 18:06:23', 0, 2262, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d2400c83', '渝北区', 'pub', '500112', 'cskefu', NULL, '297e1e874f83129d014f833501a30331', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:23', '2015-08-31 18:06:23', 0, 2263, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d24d0c84', '巴南区', 'pub', '500113', 'cskefu', NULL, '297e1e874f83129d014f833501a30331', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:23', '2015-08-31 18:06:23', 0, 2264, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d25c0c85', '黔江区', 'pub', '500114', 'cskefu', NULL, '297e1e874f83129d014f833501a30331', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:23', '2015-08-31 18:06:23', 0, 2265, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d2710c86', '长寿区', 'pub', '500115', 'cskefu', NULL, '297e1e874f83129d014f833501a30331', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:23', '2015-08-31 18:06:23', 0, 2266, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d2a70c87', '綦江县', 'pub', '500222', 'cskefu', NULL, '297e1e874f83129d014f833501b20332', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:23', '2015-08-31 18:06:23', 0, 2267, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d2b80c88', '潼南县', 'pub', '500223', 'cskefu', NULL, '297e1e874f83129d014f833501b20332', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:23', '2015-08-31 18:06:23', 0, 2268, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d2c80c89', '铜梁县', 'pub', '500224', 'cskefu', NULL, '297e1e874f83129d014f833501b20332', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:23', '2015-08-31 18:06:23', 0, 2269, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d2d60c8a', '大足县', 'pub', '500225', 'cskefu', NULL, '297e1e874f83129d014f833501b20332', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:23', '2015-08-31 18:06:23', 0, 2270, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d2e80c8b', '荣昌县', 'pub', '500226', 'cskefu', NULL, '297e1e874f83129d014f833501b20332', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:23', '2015-08-31 18:06:23', 0, 2271, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d2fa0c8c', '璧山县', 'pub', '500227', 'cskefu', NULL, '297e1e874f83129d014f833501b20332', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:23', '2015-08-31 18:06:23', 0, 2272, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d3080c8d', '梁平县', 'pub', '500228', 'cskefu', NULL, '297e1e874f83129d014f833501b20332', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:23', '2015-08-31 18:06:23', 0, 2273, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d3140c8e', '城口县', 'pub', '500229', 'cskefu', NULL, '297e1e874f83129d014f833501b20332', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:23', '2015-08-31 18:06:23', 0, 2274, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d3200c8f', '丰都县', 'pub', '500230', 'cskefu', NULL, '297e1e874f83129d014f833501b20332', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:23', '2015-08-31 18:06:23', 0, 2275, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d4580c90', '垫江县', 'pub', '500231', 'cskefu', NULL, '297e1e874f83129d014f833501b20332', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:23', '2015-08-31 18:06:23', 0, 2276, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d4640c91', '武隆县', 'pub', '500232', 'cskefu', NULL, '297e1e874f83129d014f833501b20332', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:23', '2015-08-31 18:06:23', 0, 2277, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d4700c92', '忠　县', 'pub', '500233', 'cskefu', NULL, '297e1e874f83129d014f833501b20332', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:23', '2015-08-31 18:06:23', 0, 2278, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d47e0c93', '开　县', 'pub', '500234', 'cskefu', NULL, '297e1e874f83129d014f833501b20332', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:23', '2015-08-31 18:06:23', 0, 2279, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d48d0c94', '云阳县', 'pub', '500235', 'cskefu', NULL, '297e1e874f83129d014f833501b20332', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:23', '2015-08-31 18:06:23', 0, 2280, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d49b0c95', '奉节县', 'pub', '500236', 'cskefu', NULL, '297e1e874f83129d014f833501b20332', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:23', '2015-08-31 18:06:23', 0, 2281, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d4b90c96', '巫山县', 'pub', '500237', 'cskefu', NULL, '297e1e874f83129d014f833501b20332', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:23', '2015-08-31 18:06:23', 0, 2282, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d4ca0c97', '巫溪县', 'pub', '500238', 'cskefu', NULL, '297e1e874f83129d014f833501b20332', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:23', '2015-08-31 18:06:23', 0, 2283, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d4db0c98', '石柱土家族自治县', 'pub', '500240', 'cskefu', NULL, '297e1e874f83129d014f833501b20332', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:23', '2015-08-31 18:06:23', 0, 2284, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d4e80c99', '秀山土家族苗族自治县', 'pub', '500241', 'cskefu', NULL, '297e1e874f83129d014f833501b20332', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:23', '2015-08-31 18:06:23', 0, 2285, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d4f60c9a', '酉阳土家族苗族自治县', 'pub', '500242', 'cskefu', NULL, '297e1e874f83129d014f833501b20332', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:23', '2015-08-31 18:06:23', 0, 2286, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d5030c9b', '彭水苗族土家族自治县', 'pub', '500243', 'cskefu', NULL, '297e1e874f83129d014f833501b20332', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:24', '2015-08-31 18:06:24', 0, 2287, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d52b0c9c', '江津市', 'pub', '500381', 'cskefu', NULL, '297e1e874f83129d014f833501c00333', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:24', '2015-08-31 18:06:24', 0, 2288, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d6690c9d', '合川市', 'pub', '500382', 'cskefu', NULL, '297e1e874f83129d014f833501c00333', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:24', '2015-08-31 18:06:24', 0, 2289, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d6770c9e', '永川市', 'pub', '500383', 'cskefu', NULL, '297e1e874f83129d014f833501c00333', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:24', '2015-08-31 18:06:24', 0, 2290, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d6850c9f', '南川市', 'pub', '500384', 'cskefu', NULL, '297e1e874f83129d014f833501c00333', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:24', '2015-08-31 18:06:24', 0, 2291, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d6b20ca0', '市辖区', 'pub', '510101', 'cskefu', NULL, '297e1e874f83129d014f833503160334', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:24', '2015-08-31 18:06:24', 0, 2292, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d6c20ca1', '锦江区', 'pub', '510104', 'cskefu', NULL, '297e1e874f83129d014f833503160334', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:24', '2015-08-31 18:06:24', 0, 2293, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d6d00ca2', '青羊区', 'pub', '510105', 'cskefu', NULL, '297e1e874f83129d014f833503160334', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:24', '2015-08-31 18:06:24', 0, 2294, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d6dd0ca3', '金牛区', 'pub', '510106', 'cskefu', NULL, '297e1e874f83129d014f833503160334', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:24', '2015-08-31 18:06:24', 0, 2295, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d6ec0ca4', '武侯区', 'pub', '510107', 'cskefu', NULL, '297e1e874f83129d014f833503160334', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:24', '2015-08-31 18:06:24', 0, 2296, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d6f80ca5', '成华区', 'pub', '510108', 'cskefu', NULL, '297e1e874f83129d014f833503160334', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:24', '2015-08-31 18:06:24', 0, 2297, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d7060ca6', '龙泉驿区', 'pub', '510112', 'cskefu', NULL, '297e1e874f83129d014f833503160334', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:24', '2015-08-31 18:06:24', 0, 2298, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d7140ca7', '青白江区', 'pub', '510113', 'cskefu', NULL, '297e1e874f83129d014f833503160334', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:24', '2015-08-31 18:06:24', 0, 2299, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d7210ca8', '新都区', 'pub', '510114', 'cskefu', NULL, '297e1e874f83129d014f833503160334', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:24', '2015-08-31 18:06:24', 0, 2300, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d7340ca9', '温江县', 'pub', '510115', 'cskefu', NULL, '297e1e874f83129d014f833503160334', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:24', '2015-08-31 18:06:24', 0, 2301, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d86e0caa', '金堂县', 'pub', '510121', 'cskefu', NULL, '297e1e874f83129d014f833503160334', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:24', '2015-08-31 18:06:24', 0, 2302, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d87c0cab', '双流县', 'pub', '510122', 'cskefu', NULL, '297e1e874f83129d014f833503160334', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:24', '2015-08-31 18:06:24', 0, 2303, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d88e0cac', '郫　县', 'pub', '510124', 'cskefu', NULL, '297e1e874f83129d014f833503160334', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:24', '2015-08-31 18:06:24', 0, 2304, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d89b0cad', '大邑县', 'pub', '510129', 'cskefu', NULL, '297e1e874f83129d014f833503160334', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:24', '2015-08-31 18:06:24', 0, 2305, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d8a70cae', '蒲江县', 'pub', '510131', 'cskefu', NULL, '297e1e874f83129d014f833503160334', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:24', '2015-08-31 18:06:24', 0, 2306, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d8b40caf', '新津县', 'pub', '510132', 'cskefu', NULL, '297e1e874f83129d014f833503160334', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:24', '2015-08-31 18:06:24', 0, 2307, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d8bf0cb0', '都江堰市', 'pub', '510181', 'cskefu', NULL, '297e1e874f83129d014f833503160334', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:24', '2015-08-31 18:06:24', 0, 2308, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d8cc0cb1', '彭州市', 'pub', '510182', 'cskefu', NULL, '297e1e874f83129d014f833503160334', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:24', '2015-08-31 18:06:24', 0, 2309, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d8db0cb2', '邛崃市', 'pub', '510183', 'cskefu', NULL, '297e1e874f83129d014f833503160334', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:24', '2015-08-31 18:06:24', 0, 2310, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d8ea0cb3', '崇州市', 'pub', '510184', 'cskefu', NULL, '297e1e874f83129d014f833503160334', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:25', '2015-08-31 18:06:25', 0, 2311, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d9120cb4', '市辖区', 'pub', '510301', 'cskefu', NULL, '297e1e874f83129d014f8335032b0335', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:25', '2015-08-31 18:06:25', 0, 2312, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338d9200cb5', '自流井区', 'pub', '510302', 'cskefu', NULL, '297e1e874f83129d014f8335032b0335', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:25', '2015-08-31 18:06:25', 0, 2313, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338da5b0cb6', '贡井区', 'pub', '510303', 'cskefu', NULL, '297e1e874f83129d014f8335032b0335', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:25', '2015-08-31 18:06:25', 0, 2314, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338da670cb7', '大安区', 'pub', '510304', 'cskefu', NULL, '297e1e874f83129d014f8335032b0335', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:25', '2015-08-31 18:06:25', 0, 2315, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338da740cb8', '沿滩区', 'pub', '510311', 'cskefu', NULL, '297e1e874f83129d014f8335032b0335', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:25', '2015-08-31 18:06:25', 0, 2316, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338da840cb9', '荣　县', 'pub', '510321', 'cskefu', NULL, '297e1e874f83129d014f8335032b0335', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:25', '2015-08-31 18:06:25', 0, 2317, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338da920cba', '富顺县', 'pub', '510322', 'cskefu', NULL, '297e1e874f83129d014f8335032b0335', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:25', '2015-08-31 18:06:25', 0, 2318, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338dab90cbb', '市辖区', 'pub', '510401', 'cskefu', NULL, '297e1e874f83129d014f8335033a0336', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:25', '2015-08-31 18:06:25', 0, 2319, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338dac50cbc', '东　区', 'pub', '510402', 'cskefu', NULL, '297e1e874f83129d014f8335033a0336', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:25', '2015-08-31 18:06:25', 0, 2320, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338dad10cbd', '西　区', 'pub', '510403', 'cskefu', NULL, '297e1e874f83129d014f8335033a0336', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:25', '2015-08-31 18:06:25', 0, 2321, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338dadd0cbe', '仁和区', 'pub', '510411', 'cskefu', NULL, '297e1e874f83129d014f8335033a0336', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:25', '2015-08-31 18:06:25', 0, 2322, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338dae80cbf', '米易县', 'pub', '510421', 'cskefu', NULL, '297e1e874f83129d014f8335033a0336', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:25', '2015-08-31 18:06:25', 0, 2323, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338daf50cc0', '盐边县', 'pub', '510422', 'cskefu', NULL, '297e1e874f83129d014f8335033a0336', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:25', '2015-08-31 18:06:25', 0, 2324, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338db1b0cc1', '市辖区', 'pub', '510501', 'cskefu', NULL, '297e1e874f83129d014f833503490337', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:25', '2015-08-31 18:06:25', 0, 2325, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338dc560cc2', '江阳区', 'pub', '510502', 'cskefu', NULL, '297e1e874f83129d014f833503490337', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:25', '2015-08-31 18:06:25', 0, 2326, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338dc660cc3', '纳溪区', 'pub', '510503', 'cskefu', NULL, '297e1e874f83129d014f833503490337', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:25', '2015-08-31 18:06:25', 0, 2327, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338dc750cc4', '龙马潭区', 'pub', '510504', 'cskefu', NULL, '297e1e874f83129d014f833503490337', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:25', '2015-08-31 18:06:25', 0, 2328, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338dc870cc5', '泸　县', 'pub', '510521', 'cskefu', NULL, '297e1e874f83129d014f833503490337', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:25', '2015-08-31 18:06:25', 0, 2329, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338dc950cc6', '合江县', 'pub', '510522', 'cskefu', NULL, '297e1e874f83129d014f833503490337', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:25', '2015-08-31 18:06:25', 0, 2330, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338dca30cc7', '叙永县', 'pub', '510524', 'cskefu', NULL, '297e1e874f83129d014f833503490337', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:25', '2015-08-31 18:06:25', 0, 2331, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338dcb10cc8', '古蔺县', 'pub', '510525', 'cskefu', NULL, '297e1e874f83129d014f833503490337', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:25', '2015-08-31 18:06:25', 0, 2332, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338dcdc0cc9', '市辖区', 'pub', '510601', 'cskefu', NULL, '297e1e874f83129d014f833503570338', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:26', '2015-08-31 18:06:26', 0, 2333, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338dcf80cca', '旌阳区', 'pub', '510603', 'cskefu', NULL, '297e1e874f83129d014f833503570338', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:26', '2015-08-31 18:06:26', 0, 2334, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338dd070ccb', '中江县', 'pub', '510623', 'cskefu', NULL, '297e1e874f83129d014f833503570338', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:26', '2015-08-31 18:06:26', 0, 2335, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338dd140ccc', '罗江县', 'pub', '510626', 'cskefu', NULL, '297e1e874f83129d014f833503570338', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:26', '2015-08-31 18:06:26', 0, 2336, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338dd210ccd', '广汉市', 'pub', '510681', 'cskefu', NULL, '297e1e874f83129d014f833503570338', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:26', '2015-08-31 18:06:26', 0, 2337, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338dd2f0cce', '什邡市', 'pub', '510682', 'cskefu', NULL, '297e1e874f83129d014f833503570338', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:26', '2015-08-31 18:06:26', 0, 2338, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338dd3e0ccf', '绵竹市', 'pub', '510683', 'cskefu', NULL, '297e1e874f83129d014f833503570338', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:26', '2015-08-31 18:06:26', 0, 2339, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338de9c0cd0', '市辖区', 'pub', '510701', 'cskefu', NULL, '297e1e874f83129d014f833503650339', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:26', '2015-08-31 18:06:26', 0, 2340, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338deaa0cd1', '涪城区', 'pub', '510703', 'cskefu', NULL, '297e1e874f83129d014f833503650339', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:26', '2015-08-31 18:06:26', 0, 2341, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338deb80cd2', '游仙区', 'pub', '510704', 'cskefu', NULL, '297e1e874f83129d014f833503650339', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:26', '2015-08-31 18:06:26', 0, 2342, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338dec60cd3', '三台县', 'pub', '510722', 'cskefu', NULL, '297e1e874f83129d014f833503650339', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:26', '2015-08-31 18:06:26', 0, 2343, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ded30cd4', '盐亭县', 'pub', '510723', 'cskefu', NULL, '297e1e874f83129d014f833503650339', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:26', '2015-08-31 18:06:26', 0, 2344, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338dee40cd5', '安　县', 'pub', '510724', 'cskefu', NULL, '297e1e874f83129d014f833503650339', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:26', '2015-08-31 18:06:26', 0, 2345, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338def20cd6', '梓潼县', 'pub', '510725', 'cskefu', NULL, '297e1e874f83129d014f833503650339', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:26', '2015-08-31 18:06:26', 0, 2346, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338df020cd7', '北川羌族自治县', 'pub', '510726', 'cskefu', NULL, '297e1e874f83129d014f833503650339', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:26', '2015-08-31 18:06:26', 0, 2347, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338df0f0cd8', '平武县', 'pub', '510727', 'cskefu', NULL, '297e1e874f83129d014f833503650339', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:26', '2015-08-31 18:06:26', 0, 2348, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338df1c0cd9', '江油市', 'pub', '510781', 'cskefu', NULL, '297e1e874f83129d014f833503650339', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:26', '2015-08-31 18:06:26', 0, 2349, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338df460cda', '市辖区', 'pub', '510801', 'cskefu', NULL, '297e1e874f83129d014f83350373033a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:26', '2015-08-31 18:06:26', 0, 2350, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338df530cdb', '市中区', 'pub', '510802', 'cskefu', NULL, '297e1e874f83129d014f83350373033a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:26', '2015-08-31 18:06:26', 0, 2351, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338df6f0cdc', '元坝区', 'pub', '510811', 'cskefu', NULL, '297e1e874f83129d014f83350373033a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:26', '2015-08-31 18:06:26', 0, 2352, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338df7e0cdd', '朝天区', 'pub', '510812', 'cskefu', NULL, '297e1e874f83129d014f83350373033a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:26', '2015-08-31 18:06:26', 0, 2353, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338df930cde', '旺苍县', 'pub', '510821', 'cskefu', NULL, '297e1e874f83129d014f83350373033a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:26', '2015-08-31 18:06:26', 0, 2354, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338dfb50ce0', '青川县', 'pub', '510822', 'cskefu', NULL, '297e1e874f83129d014f83350373033a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:26', '2015-08-31 18:06:26', 0, 2355, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338e0f50ce1', '剑阁县', 'pub', '510823', 'cskefu', NULL, '297e1e874f83129d014f83350373033a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:27', '2015-08-31 18:06:27', 0, 2356, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338e1030ce2', '苍溪县', 'pub', '510824', 'cskefu', NULL, '297e1e874f83129d014f83350373033a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:27', '2015-08-31 18:06:27', 0, 2357, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338e1320ce3', '市辖区', 'pub', '510901', 'cskefu', NULL, '297e1e874f83129d014f8335037f033b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:27', '2015-08-31 18:06:27', 0, 2358, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338e1430ce4', '船山区', 'pub', '510903', 'cskefu', NULL, '297e1e874f83129d014f8335037f033b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:27', '2015-08-31 18:06:27', 0, 2359, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338e1520ce5', '安居区', 'pub', '510904', 'cskefu', NULL, '297e1e874f83129d014f8335037f033b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:27', '2015-08-31 18:06:27', 0, 2360, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338e1600ce6', '蓬溪县', 'pub', '510921', 'cskefu', NULL, '297e1e874f83129d014f8335037f033b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:27', '2015-08-31 18:06:27', 0, 2361, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338e16e0ce7', '射洪县', 'pub', '510922', 'cskefu', NULL, '297e1e874f83129d014f8335037f033b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:27', '2015-08-31 18:06:27', 0, 2362, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338e17c0ce8', '大英县', 'pub', '510923', 'cskefu', NULL, '297e1e874f83129d014f8335037f033b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:27', '2015-08-31 18:06:27', 0, 2363, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338e1a50ce9', '市辖区', 'pub', '511001', 'cskefu', NULL, '297e1e874f83129d014f83350393033c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:27', '2015-08-31 18:06:27', 0, 2364, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338e1b40cea', '市中区', 'pub', '511002', 'cskefu', NULL, '297e1e874f83129d014f83350393033c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:27', '2015-08-31 18:06:27', 0, 2365, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338e1c00ceb', '东兴区', 'pub', '511011', 'cskefu', NULL, '297e1e874f83129d014f83350393033c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:27', '2015-08-31 18:06:27', 0, 2366, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338e2fb0cec', '威远县', 'pub', '511024', 'cskefu', NULL, '297e1e874f83129d014f83350393033c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:27', '2015-08-31 18:06:27', 0, 2367, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338e3080ced', '资中县', 'pub', '511025', 'cskefu', NULL, '297e1e874f83129d014f83350393033c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:27', '2015-08-31 18:06:27', 0, 2368, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338e3150cee', '隆昌县', 'pub', '511028', 'cskefu', NULL, '297e1e874f83129d014f83350393033c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:27', '2015-08-31 18:06:27', 0, 2369, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338e3400cef', '市辖区', 'pub', '511101', 'cskefu', NULL, '297e1e874f83129d014f833503b0033d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:27', '2015-08-31 18:06:27', 0, 2370, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338e34f0cf0', '市中区', 'pub', '511102', 'cskefu', NULL, '297e1e874f83129d014f833503b0033d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:27', '2015-08-31 18:06:27', 0, 2371, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338e35c0cf1', '沙湾区', 'pub', '511111', 'cskefu', NULL, '297e1e874f83129d014f833503b0033d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:27', '2015-08-31 18:06:27', 0, 2372, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338e36a0cf2', '五通桥区', 'pub', '511112', 'cskefu', NULL, '297e1e874f83129d014f833503b0033d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:27', '2015-08-31 18:06:27', 0, 2373, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338e3790cf3', '金口河区', 'pub', '511113', 'cskefu', NULL, '297e1e874f83129d014f833503b0033d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:27', '2015-08-31 18:06:27', 0, 2374, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338e3850cf4', '犍为县', 'pub', '511123', 'cskefu', NULL, '297e1e874f83129d014f833503b0033d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:27', '2015-08-31 18:06:27', 0, 2375, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338e3930cf5', '井研县', 'pub', '511124', 'cskefu', NULL, '297e1e874f83129d014f833503b0033d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:27', '2015-08-31 18:06:27', 0, 2376, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338e4cd0cf6', '夹江县', 'pub', '511126', 'cskefu', NULL, '297e1e874f83129d014f833503b0033d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:28', '2015-08-31 18:06:28', 0, 2377, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338e4db0cf7', '沐川县', 'pub', '511129', 'cskefu', NULL, '297e1e874f83129d014f833503b0033d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:28', '2015-08-31 18:06:28', 0, 2378, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338e4ee0cf8', '峨边彝族自治县', 'pub', '511132', 'cskefu', NULL, '297e1e874f83129d014f833503b0033d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:28', '2015-08-31 18:06:28', 0, 2379, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338e4fb0cf9', '马边彝族自治县', 'pub', '511133', 'cskefu', NULL, '297e1e874f83129d014f833503b0033d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:28', '2015-08-31 18:06:28', 0, 2380, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338e5090cfa', '峨眉山市', 'pub', '511181', 'cskefu', NULL, '297e1e874f83129d014f833503b0033d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:28', '2015-08-31 18:06:28', 0, 2381, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338e53e0cfb', '市辖区', 'pub', '511301', 'cskefu', NULL, '297e1e874f83129d014f833503bf033e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:28', '2015-08-31 18:06:28', 0, 2382, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338e5510cfc', '顺庆区', 'pub', '511302', 'cskefu', NULL, '297e1e874f83129d014f833503bf033e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:28', '2015-08-31 18:06:28', 0, 2383, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338e55f0cfd', '高坪区', 'pub', '511303', 'cskefu', NULL, '297e1e874f83129d014f833503bf033e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:28', '2015-08-31 18:06:28', 0, 2384, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338e5700cfe', '嘉陵区', 'pub', '511304', 'cskefu', NULL, '297e1e874f83129d014f833503bf033e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:28', '2015-08-31 18:06:28', 0, 2385, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338e57e0cff', '南部县', 'pub', '511321', 'cskefu', NULL, '297e1e874f83129d014f833503bf033e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:28', '2015-08-31 18:06:28', 0, 2386, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338e58d0d00', '营山县', 'pub', '511322', 'cskefu', NULL, '297e1e874f83129d014f833503bf033e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:28', '2015-08-31 18:06:28', 0, 2387, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338e59b0d01', '蓬安县', 'pub', '511323', 'cskefu', NULL, '297e1e874f83129d014f833503bf033e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:28', '2015-08-31 18:06:28', 0, 2388, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338e5aa0d02', '仪陇县', 'pub', '511324', 'cskefu', NULL, '297e1e874f83129d014f833503bf033e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:28', '2015-08-31 18:06:28', 0, 2389, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338e5bd0d03', '西充县', 'pub', '511325', 'cskefu', NULL, '297e1e874f83129d014f833503bf033e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:28', '2015-08-31 18:06:28', 0, 2390, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338e5d10d04', '阆中市', 'pub', '511381', 'cskefu', NULL, '297e1e874f83129d014f833503bf033e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:28', '2015-08-31 18:06:28', 0, 2391, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338e72f0d05', '市辖区', 'pub', '511401', 'cskefu', NULL, '297e1e874f83129d014f833503cf033f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:28', '2015-08-31 18:06:28', 0, 2392, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338e73f0d06', '东坡区', 'pub', '511402', 'cskefu', NULL, '297e1e874f83129d014f833503cf033f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:28', '2015-08-31 18:06:28', 0, 2393, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338e74f0d07', '仁寿县', 'pub', '511421', 'cskefu', NULL, '297e1e874f83129d014f833503cf033f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:28', '2015-08-31 18:06:28', 0, 2394, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338e7600d08', '彭山县', 'pub', '511422', 'cskefu', NULL, '297e1e874f83129d014f833503cf033f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:28', '2015-08-31 18:06:28', 0, 2395, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338e7700d09', '洪雅县', 'pub', '511423', 'cskefu', NULL, '297e1e874f83129d014f833503cf033f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:28', '2015-08-31 18:06:28', 0, 2396, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338e7800d0a', '丹棱县', 'pub', '511424', 'cskefu', NULL, '297e1e874f83129d014f833503cf033f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:28', '2015-08-31 18:06:28', 0, 2397, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338e7910d0b', '青神县', 'pub', '511425', 'cskefu', NULL, '297e1e874f83129d014f833503cf033f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:28', '2015-08-31 18:06:28', 0, 2398, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338e7bc0d0c', '市辖区', 'pub', '511501', 'cskefu', NULL, '297e1e874f83129d014f833503df0340', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:28', '2015-08-31 18:06:28', 0, 2399, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338e7ca0d0d', '翠屏区', 'pub', '511502', 'cskefu', NULL, '297e1e874f83129d014f833503df0340', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:28', '2015-08-31 18:06:28', 0, 2400, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338e7d80d0e', '宜宾县', 'pub', '511521', 'cskefu', NULL, '297e1e874f83129d014f833503df0340', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:28', '2015-08-31 18:06:28', 0, 2401, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338e7e80d0f', '南溪县', 'pub', '511522', 'cskefu', NULL, '297e1e874f83129d014f833503df0340', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:28', '2015-08-31 18:06:28', 0, 2402, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338e7f80d10', '江安县', 'pub', '511523', 'cskefu', NULL, '297e1e874f83129d014f833503df0340', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:28', '2015-08-31 18:06:28', 0, 2403, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338e9390d11', '长宁县', 'pub', '511524', 'cskefu', NULL, '297e1e874f83129d014f833503df0340', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:29', '2015-08-31 18:06:29', 0, 2404, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338e9490d12', '高　县', 'pub', '511525', 'cskefu', NULL, '297e1e874f83129d014f833503df0340', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:29', '2015-08-31 18:06:29', 0, 2405, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338e9580d13', '珙　县', 'pub', '511526', 'cskefu', NULL, '297e1e874f83129d014f833503df0340', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:29', '2015-08-31 18:06:29', 0, 2406, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338e9660d14', '筠连县', 'pub', '511527', 'cskefu', NULL, '297e1e874f83129d014f833503df0340', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:29', '2015-08-31 18:06:29', 0, 2407, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338e9770d15', '兴文县', 'pub', '511528', 'cskefu', NULL, '297e1e874f83129d014f833503df0340', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:29', '2015-08-31 18:06:29', 0, 2408, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338e9900d16', '屏山县', 'pub', '511529', 'cskefu', NULL, '297e1e874f83129d014f833503df0340', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:29', '2015-08-31 18:06:29', 0, 2409, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338e9c00d17', '市辖区', 'pub', '511601', 'cskefu', NULL, '297e1e874f83129d014f833503f10341', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:29', '2015-08-31 18:06:29', 0, 2410, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338e9d30d18', '广安区', 'pub', '511602', 'cskefu', NULL, '297e1e874f83129d014f833503f10341', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:29', '2015-08-31 18:06:29', 0, 2411, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338e9ed0d19', '岳池县', 'pub', '511621', 'cskefu', NULL, '297e1e874f83129d014f833503f10341', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:29', '2015-08-31 18:06:29', 0, 2412, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338e9fd0d1a', '武胜县', 'pub', '511622', 'cskefu', NULL, '297e1e874f83129d014f833503f10341', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:29', '2015-08-31 18:06:29', 0, 2413, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ea0c0d1b', '邻水县', 'pub', '511623', 'cskefu', NULL, '297e1e874f83129d014f833503f10341', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:29', '2015-08-31 18:06:29', 0, 2414, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ea1b0d1c', '华莹市', 'pub', '511681', 'cskefu', NULL, '297e1e874f83129d014f833503f10341', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:29', '2015-08-31 18:06:29', 0, 2415, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ea4d0d1d', '市辖区', 'pub', '511701', 'cskefu', NULL, '297e1e874f83129d014f833504010342', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:29', '2015-08-31 18:06:29', 0, 2416, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ea600d1e', '通川区', 'pub', '511702', 'cskefu', NULL, '297e1e874f83129d014f833504010342', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:29', '2015-08-31 18:06:29', 0, 2417, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ea6e0d1f', '达　县', 'pub', '511721', 'cskefu', NULL, '297e1e874f83129d014f833504010342', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:29', '2015-08-31 18:06:29', 0, 2418, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ea7f0d20', '宣汉县', 'pub', '511722', 'cskefu', NULL, '297e1e874f83129d014f833504010342', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:29', '2015-08-31 18:06:29', 0, 2419, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ea940d21', '开江县', 'pub', '511723', 'cskefu', NULL, '297e1e874f83129d014f833504010342', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:29', '2015-08-31 18:06:29', 0, 2420, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ebcd0d22', '大竹县', 'pub', '511724', 'cskefu', NULL, '297e1e874f83129d014f833504010342', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:29', '2015-08-31 18:06:29', 0, 2421, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ebda0d23', '渠　县', 'pub', '511725', 'cskefu', NULL, '297e1e874f83129d014f833504010342', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:29', '2015-08-31 18:06:29', 0, 2422, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ebe80d24', '万源市', 'pub', '511781', 'cskefu', NULL, '297e1e874f83129d014f833504010342', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:29', '2015-08-31 18:06:29', 0, 2423, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ec150d25', '市辖区', 'pub', '511801', 'cskefu', NULL, '297e1e874f83129d014f833504100343', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:29', '2015-08-31 18:06:29', 0, 2424, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ec270d26', '雨城区', 'pub', '511802', 'cskefu', NULL, '297e1e874f83129d014f833504100343', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:29', '2015-08-31 18:06:29', 0, 2425, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ec350d27', '名山县', 'pub', '511821', 'cskefu', NULL, '297e1e874f83129d014f833504100343', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:29', '2015-08-31 18:06:29', 0, 2426, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ec420d28', '荥经县', 'pub', '511822', 'cskefu', NULL, '297e1e874f83129d014f833504100343', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:29', '2015-08-31 18:06:29', 0, 2427, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ec510d29', '汉源县', 'pub', '511823', 'cskefu', NULL, '297e1e874f83129d014f833504100343', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:29', '2015-08-31 18:06:29', 0, 2428, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ec5f0d2a', '石棉县', 'pub', '511824', 'cskefu', NULL, '297e1e874f83129d014f833504100343', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:29', '2015-08-31 18:06:29', 0, 2429, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ec6d0d2b', '天全县', 'pub', '511825', 'cskefu', NULL, '297e1e874f83129d014f833504100343', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:29', '2015-08-31 18:06:29', 0, 2430, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ec7a0d2c', '芦山县', 'pub', '511826', 'cskefu', NULL, '297e1e874f83129d014f833504100343', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:30', '2015-08-31 18:06:30', 0, 2431, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ec8b0d2d', '宝兴县', 'pub', '511827', 'cskefu', NULL, '297e1e874f83129d014f833504100343', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:30', '2015-08-31 18:06:30', 0, 2432, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ede50d2e', '市辖区', 'pub', '511901', 'cskefu', NULL, '297e1e874f83129d014f833504230344', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:30', '2015-08-31 18:06:30', 0, 2433, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338edf60d2f', '巴州区', 'pub', '511902', 'cskefu', NULL, '297e1e874f83129d014f833504230344', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:30', '2015-08-31 18:06:30', 0, 2434, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ee020d30', '通江县', 'pub', '511921', 'cskefu', NULL, '297e1e874f83129d014f833504230344', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:30', '2015-08-31 18:06:30', 0, 2435, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ee110d31', '南江县', 'pub', '511922', 'cskefu', NULL, '297e1e874f83129d014f833504230344', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:30', '2015-08-31 18:06:30', 0, 2436, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ee200d32', '平昌县', 'pub', '511923', 'cskefu', NULL, '297e1e874f83129d014f833504230344', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:30', '2015-08-31 18:06:30', 0, 2437, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ee510d33', '市辖区', 'pub', '512001', 'cskefu', NULL, '297e1e874f83129d014f833505600345', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:30', '2015-08-31 18:06:30', 0, 2438, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ee5f0d34', '雁江区', 'pub', '512002', 'cskefu', NULL, '297e1e874f83129d014f833505600345', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:30', '2015-08-31 18:06:30', 0, 2439, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ee700d35', '安岳县', 'pub', '512021', 'cskefu', NULL, '297e1e874f83129d014f833505600345', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:30', '2015-08-31 18:06:30', 0, 2440, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ee810d36', '乐至县', 'pub', '512022', 'cskefu', NULL, '297e1e874f83129d014f833505600345', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:30', '2015-08-31 18:06:30', 0, 2441, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ee8d0d37', '简阳市', 'pub', '512081', 'cskefu', NULL, '297e1e874f83129d014f833505600345', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:30', '2015-08-31 18:06:30', 0, 2442, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338eeba0d38', '汶川县', 'pub', '513221', 'cskefu', NULL, '297e1e874f83129d014f833505730346', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:30', '2015-08-31 18:06:30', 0, 2443, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338eec80d39', '理　县', 'pub', '513222', 'cskefu', NULL, '297e1e874f83129d014f833505730346', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:30', '2015-08-31 18:06:30', 0, 2444, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338eed50d3a', '茂　县', 'pub', '513223', 'cskefu', NULL, '297e1e874f83129d014f833505730346', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:30', '2015-08-31 18:06:30', 0, 2445, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f0100d3b', '松潘县', 'pub', '513224', 'cskefu', NULL, '297e1e874f83129d014f833505730346', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:30', '2015-08-31 18:06:30', 0, 2446, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f01e0d3c', '九寨沟县', 'pub', '513225', 'cskefu', NULL, '297e1e874f83129d014f833505730346', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:30', '2015-08-31 18:06:30', 0, 2447, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f0310d3d', '金川县', 'pub', '513226', 'cskefu', NULL, '297e1e874f83129d014f833505730346', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:30', '2015-08-31 18:06:30', 0, 2448, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f03e0d3e', '小金县', 'pub', '513227', 'cskefu', NULL, '297e1e874f83129d014f833505730346', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:30', '2015-08-31 18:06:30', 0, 2449, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f04d0d3f', '黑水县', 'pub', '513228', 'cskefu', NULL, '297e1e874f83129d014f833505730346', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:30', '2015-08-31 18:06:30', 0, 2450, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f0590d40', '马尔康县', 'pub', '513229', 'cskefu', NULL, '297e1e874f83129d014f833505730346', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:31', '2015-08-31 18:06:31', 0, 2451, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f0690d41', '壤塘县', 'pub', '513230', 'cskefu', NULL, '297e1e874f83129d014f833505730346', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:31', '2015-08-31 18:06:31', 0, 2452, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f0780d42', '阿坝县', 'pub', '513231', 'cskefu', NULL, '297e1e874f83129d014f833505730346', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:31', '2015-08-31 18:06:31', 0, 2453, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f0870d43', '若尔盖县', 'pub', '513232', 'cskefu', NULL, '297e1e874f83129d014f833505730346', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:31', '2015-08-31 18:06:31', 0, 2454, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f0960d44', '红原县', 'pub', '513233', 'cskefu', NULL, '297e1e874f83129d014f833505730346', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:31', '2015-08-31 18:06:31', 0, 2455, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f0c30d45', '康定县', 'pub', '513321', 'cskefu', NULL, '297e1e874f83129d014f833505830347', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:31', '2015-08-31 18:06:31', 0, 2456, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f0d10d46', '泸定县', 'pub', '513322', 'cskefu', NULL, '297e1e874f83129d014f833505830347', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:31', '2015-08-31 18:06:31', 0, 2457, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f0e20d47', '丹巴县', 'pub', '513323', 'cskefu', NULL, '297e1e874f83129d014f833505830347', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:31', '2015-08-31 18:06:31', 0, 2458, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f21c0d48', '九龙县', 'pub', '513324', 'cskefu', NULL, '297e1e874f83129d014f833505830347', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:31', '2015-08-31 18:06:31', 0, 2459, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f2290d49', '雅江县', 'pub', '513325', 'cskefu', NULL, '297e1e874f83129d014f833505830347', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:31', '2015-08-31 18:06:31', 0, 2460, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f2360d4a', '道孚县', 'pub', '513326', 'cskefu', NULL, '297e1e874f83129d014f833505830347', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:31', '2015-08-31 18:06:31', 0, 2461, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f2520d4b', '炉霍县', 'pub', '513327', 'cskefu', NULL, '297e1e874f83129d014f833505830347', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:31', '2015-08-31 18:06:31', 0, 2462, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f25f0d4c', '甘孜县', 'pub', '513328', 'cskefu', NULL, '297e1e874f83129d014f833505830347', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:31', '2015-08-31 18:06:31', 0, 2463, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f26d0d4d', '新龙县', 'pub', '513329', 'cskefu', NULL, '297e1e874f83129d014f833505830347', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:31', '2015-08-31 18:06:31', 0, 2464, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f2790d4e', '德格县', 'pub', '513330', 'cskefu', NULL, '297e1e874f83129d014f833505830347', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:31', '2015-08-31 18:06:31', 0, 2465, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f2890d4f', '白玉县', 'pub', '513331', 'cskefu', NULL, '297e1e874f83129d014f833505830347', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:31', '2015-08-31 18:06:31', 0, 2466, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f2970d50', '石渠县', 'pub', '513332', 'cskefu', NULL, '297e1e874f83129d014f833505830347', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:31', '2015-08-31 18:06:31', 0, 2467, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f2a70d51', '色达县', 'pub', '513333', 'cskefu', NULL, '297e1e874f83129d014f833505830347', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:31', '2015-08-31 18:06:31', 0, 2468, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f2b30d52', '理塘县', 'pub', '513334', 'cskefu', NULL, '297e1e874f83129d014f833505830347', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:31', '2015-08-31 18:06:31', 0, 2469, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f2c50d53', '巴塘县', 'pub', '513335', 'cskefu', NULL, '297e1e874f83129d014f833505830347', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:31', '2015-08-31 18:06:31', 0, 2470, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f2d40d54', '乡城县', 'pub', '513336', 'cskefu', NULL, '297e1e874f83129d014f833505830347', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:31', '2015-08-31 18:06:31', 0, 2471, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f2e40d55', '稻城县', 'pub', '513337', 'cskefu', NULL, '297e1e874f83129d014f833505830347', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:31', '2015-08-31 18:06:31', 0, 2472, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f2f10d56', '得荣县', 'pub', '513338', 'cskefu', NULL, '297e1e874f83129d014f833505830347', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:31', '2015-08-31 18:06:31', 0, 2473, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f4460d58', '西昌市', 'pub', '513401', 'cskefu', NULL, '297e1e874f83129d014f833505940348', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:32', '2015-08-31 18:06:32', 0, 2474, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f4530d59', '木里藏族自治县', 'pub', '513422', 'cskefu', NULL, '297e1e874f83129d014f833505940348', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:32', '2015-08-31 18:06:32', 0, 2475, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f4610d5a', '盐源县', 'pub', '513423', 'cskefu', NULL, '297e1e874f83129d014f833505940348', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:32', '2015-08-31 18:06:32', 0, 2476, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f4740d5b', '德昌县', 'pub', '513424', 'cskefu', NULL, '297e1e874f83129d014f833505940348', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:32', '2015-08-31 18:06:32', 0, 2477, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f4810d5c', '会理县', 'pub', '513425', 'cskefu', NULL, '297e1e874f83129d014f833505940348', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:32', '2015-08-31 18:06:32', 0, 2478, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f4910d5d', '会东县', 'pub', '513426', 'cskefu', NULL, '297e1e874f83129d014f833505940348', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:32', '2015-08-31 18:06:32', 0, 2479, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f4ac0d5e', '宁南县', 'pub', '513427', 'cskefu', NULL, '297e1e874f83129d014f833505940348', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:32', '2015-08-31 18:06:32', 0, 2480, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f4c00d5f', '普格县', 'pub', '513428', 'cskefu', NULL, '297e1e874f83129d014f833505940348', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:32', '2015-08-31 18:06:32', 0, 2481, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f4cf0d60', '布拖县', 'pub', '513429', 'cskefu', NULL, '297e1e874f83129d014f833505940348', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:32', '2015-08-31 18:06:32', 0, 2482, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f4df0d61', '金阳县', 'pub', '513430', 'cskefu', NULL, '297e1e874f83129d014f833505940348', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:32', '2015-08-31 18:06:32', 0, 2483, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f61b0d62', '昭觉县', 'pub', '513431', 'cskefu', NULL, '297e1e874f83129d014f833505940348', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:32', '2015-08-31 18:06:32', 0, 2484, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f6290d63', '喜德县', 'pub', '513432', 'cskefu', NULL, '297e1e874f83129d014f833505940348', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:32', '2015-08-31 18:06:32', 0, 2485, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f6380d64', '冕宁县', 'pub', '513433', 'cskefu', NULL, '297e1e874f83129d014f833505940348', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:32', '2015-08-31 18:06:32', 0, 2486, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f64d0d65', '越西县', 'pub', '513434', 'cskefu', NULL, '297e1e874f83129d014f833505940348', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:32', '2015-08-31 18:06:32', 0, 2487, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f6620d66', '甘洛县', 'pub', '513435', 'cskefu', NULL, '297e1e874f83129d014f833505940348', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:32', '2015-08-31 18:06:32', 0, 2488, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f6760d67', '美姑县', 'pub', '513436', 'cskefu', NULL, '297e1e874f83129d014f833505940348', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:32', '2015-08-31 18:06:32', 0, 2489, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f6860d68', '雷波县', 'pub', '513437', 'cskefu', NULL, '297e1e874f83129d014f833505940348', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:32', '2015-08-31 18:06:32', 0, 2490, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f6b20d69', '市辖区', 'pub', '520101', 'cskefu', NULL, '297e1e874f83129d014f833505ca0349', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:32', '2015-08-31 18:06:32', 0, 2491, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f6c10d6a', '南明区', 'pub', '520102', 'cskefu', NULL, '297e1e874f83129d014f833505ca0349', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:32', '2015-08-31 18:06:32', 0, 2492, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f6d40d6b', '云岩区', 'pub', '520103', 'cskefu', NULL, '297e1e874f83129d014f833505ca0349', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:32', '2015-08-31 18:06:32', 0, 2493, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f6e30d6c', '花溪区', 'pub', '520111', 'cskefu', NULL, '297e1e874f83129d014f833505ca0349', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:32', '2015-08-31 18:06:32', 0, 2494, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f6f40d6d', '乌当区', 'pub', '520112', 'cskefu', NULL, '297e1e874f83129d014f833505ca0349', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:32', '2015-08-31 18:06:32', 0, 2495, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f7080d6e', '白云区', 'pub', '520113', 'cskefu', NULL, '297e1e874f83129d014f833505ca0349', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:32', '2015-08-31 18:06:32', 0, 2496, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f7150d6f', '小河区', 'pub', '520114', 'cskefu', NULL, '297e1e874f83129d014f833505ca0349', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:32', '2015-08-31 18:06:32', 0, 2497, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f7210d70', '开阳县', 'pub', '520121', 'cskefu', NULL, '297e1e874f83129d014f833505ca0349', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:32', '2015-08-31 18:06:32', 0, 2498, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f7300d71', '息烽县', 'pub', '520122', 'cskefu', NULL, '297e1e874f83129d014f833505ca0349', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:32', '2015-08-31 18:06:32', 0, 2499, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f86a0d72', '修文县', 'pub', '520123', 'cskefu', NULL, '297e1e874f83129d014f833505ca0349', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:33', '2015-08-31 18:06:33', 0, 2500, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f8780d73', '清镇市', 'pub', '520181', 'cskefu', NULL, '297e1e874f83129d014f833505ca0349', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:33', '2015-08-31 18:06:33', 0, 2501, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f89f0d74', '钟山区', 'pub', '520201', 'cskefu', NULL, '297e1e874f83129d014f833505d9034a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:33', '2015-08-31 18:06:33', 0, 2502, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f8ac0d75', '六枝特区', 'pub', '520203', 'cskefu', NULL, '297e1e874f83129d014f833505d9034a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:33', '2015-08-31 18:06:33', 0, 2503, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f8b80d76', '水城县', 'pub', '520221', 'cskefu', NULL, '297e1e874f83129d014f833505d9034a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:33', '2015-08-31 18:06:33', 0, 2504, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f8c40d77', '盘　县', 'pub', '520222', 'cskefu', NULL, '297e1e874f83129d014f833505d9034a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:33', '2015-08-31 18:06:33', 0, 2505, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f8ef0d78', '市辖区', 'pub', '520301', 'cskefu', NULL, '297e1e874f83129d014f833505ea034b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:33', '2015-08-31 18:06:33', 0, 2506, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f8fc0d79', '红花岗区', 'pub', '520302', 'cskefu', NULL, '297e1e874f83129d014f833505ea034b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:33', '2015-08-31 18:06:33', 0, 2507, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f9090d7a', '汇川区', 'pub', '520303', 'cskefu', NULL, '297e1e874f83129d014f833505ea034b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:33', '2015-08-31 18:06:33', 0, 2508, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f9160d7b', '遵义县', 'pub', '520321', 'cskefu', NULL, '297e1e874f83129d014f833505ea034b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:33', '2015-08-31 18:06:33', 0, 2509, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338f9220d7c', '桐梓县', 'pub', '520322', 'cskefu', NULL, '297e1e874f83129d014f833505ea034b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:33', '2015-08-31 18:06:33', 0, 2510, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338fa590d7d', '绥阳县', 'pub', '520323', 'cskefu', NULL, '297e1e874f83129d014f833505ea034b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:33', '2015-08-31 18:06:33', 0, 2511, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338fa650d7e', '正安县', 'pub', '520324', 'cskefu', NULL, '297e1e874f83129d014f833505ea034b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:33', '2015-08-31 18:06:33', 0, 2512, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338fa710d7f', '道真仡佬族苗族自治县', 'pub', '520325', 'cskefu', NULL, '297e1e874f83129d014f833505ea034b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:33', '2015-08-31 18:06:33', 0, 2513, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338fa7d0d80', '务川仡佬族苗族自治县', 'pub', '520326', 'cskefu', NULL, '297e1e874f83129d014f833505ea034b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:33', '2015-08-31 18:06:33', 0, 2514, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338fa8b0d81', '凤冈县', 'pub', '520327', 'cskefu', NULL, '297e1e874f83129d014f833505ea034b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:33', '2015-08-31 18:06:33', 0, 2515, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338fa970d82', '湄潭县', 'pub', '520328', 'cskefu', NULL, '297e1e874f83129d014f833505ea034b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:33', '2015-08-31 18:06:33', 0, 2516, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338faa40d83', '余庆县', 'pub', '520329', 'cskefu', NULL, '297e1e874f83129d014f833505ea034b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:33', '2015-08-31 18:06:33', 0, 2517, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338fab10d84', '习水县', 'pub', '520330', 'cskefu', NULL, '297e1e874f83129d014f833505ea034b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:33', '2015-08-31 18:06:33', 0, 2518, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338fac20d85', '赤水市', 'pub', '520381', 'cskefu', NULL, '297e1e874f83129d014f833505ea034b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:33', '2015-08-31 18:06:33', 0, 2519, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338facf0d86', '仁怀市', 'pub', '520382', 'cskefu', NULL, '297e1e874f83129d014f833505ea034b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:33', '2015-08-31 18:06:33', 0, 2520, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338faff0d87', '市辖区', 'pub', '520401', 'cskefu', NULL, '297e1e874f83129d014f833505fb034c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:33', '2015-08-31 18:06:33', 0, 2521, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338fb0d0d88', '西秀区', 'pub', '520402', 'cskefu', NULL, '297e1e874f83129d014f833505fb034c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:33', '2015-08-31 18:06:33', 0, 2522, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338fb190d89', '平坝县', 'pub', '520421', 'cskefu', NULL, '297e1e874f83129d014f833505fb034c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:33', '2015-08-31 18:06:33', 0, 2523, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338fc530d8a', '普定县', 'pub', '520422', 'cskefu', NULL, '297e1e874f83129d014f833505fb034c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:34', '2015-08-31 18:06:34', 0, 2524, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338fc600d8b', '镇宁布依族苗族自治县', 'pub', '520423', 'cskefu', NULL, '297e1e874f83129d014f833505fb034c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:34', '2015-08-31 18:06:34', 0, 2525, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338fc6d0d8c', '关岭布依族苗族自治县', 'pub', '520424', 'cskefu', NULL, '297e1e874f83129d014f833505fb034c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:34', '2015-08-31 18:06:34', 0, 2526, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338fc790d8d', '紫云苗族布依族自治县', 'pub', '520425', 'cskefu', NULL, '297e1e874f83129d014f833505fb034c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:34', '2015-08-31 18:06:34', 0, 2527, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338fca60d8e', '铜仁市', 'pub', '522201', 'cskefu', NULL, '297e1e874f83129d014f8335060c034d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:34', '2015-08-31 18:06:34', 0, 2528, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338fcb30d8f', '江口县', 'pub', '522222', 'cskefu', NULL, '297e1e874f83129d014f8335060c034d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:34', '2015-08-31 18:06:34', 0, 2529, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338fcc00d90', '玉屏侗族自治县', 'pub', '522223', 'cskefu', NULL, '297e1e874f83129d014f8335060c034d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:34', '2015-08-31 18:06:34', 0, 2530, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338fcce0d91', '石阡县', 'pub', '522224', 'cskefu', NULL, '297e1e874f83129d014f8335060c034d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:34', '2015-08-31 18:06:34', 0, 2531, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338fcdd0d92', '思南县', 'pub', '522225', 'cskefu', NULL, '297e1e874f83129d014f8335060c034d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:34', '2015-08-31 18:06:34', 0, 2532, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338fced0d93', '印江土家族苗族自治县', 'pub', '522226', 'cskefu', NULL, '297e1e874f83129d014f8335060c034d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:34', '2015-08-31 18:06:34', 0, 2533, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338fcff0d94', '德江县', 'pub', '522227', 'cskefu', NULL, '297e1e874f83129d014f8335060c034d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:34', '2015-08-31 18:06:34', 0, 2534, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338fd0c0d95', '沿河土家族自治县', 'pub', '522228', 'cskefu', NULL, '297e1e874f83129d014f8335060c034d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:34', '2015-08-31 18:06:34', 0, 2535, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338fd1b0d96', '松桃苗族自治县', 'pub', '522229', 'cskefu', NULL, '297e1e874f83129d014f8335060c034d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:34', '2015-08-31 18:06:34', 0, 2536, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338fd290d97', '万山特区', 'pub', '522230', 'cskefu', NULL, '297e1e874f83129d014f8335060c034d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:34', '2015-08-31 18:06:34', 0, 2537, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338fe820d98', '兴义市', 'pub', '522301', 'cskefu', NULL, '297e1e874f83129d014f8335061f034e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:34', '2015-08-31 18:06:34', 0, 2538, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338fe910d99', '兴仁县', 'pub', '522322', 'cskefu', NULL, '297e1e874f83129d014f8335061f034e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:34', '2015-08-31 18:06:34', 0, 2539, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338fe9d0d9a', '普安县', 'pub', '522323', 'cskefu', NULL, '297e1e874f83129d014f8335061f034e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:34', '2015-08-31 18:06:34', 0, 2540, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338fea80d9b', '晴隆县', 'pub', '522324', 'cskefu', NULL, '297e1e874f83129d014f8335061f034e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:34', '2015-08-31 18:06:34', 0, 2541, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338feb40d9c', '贞丰县', 'pub', '522325', 'cskefu', NULL, '297e1e874f83129d014f8335061f034e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:34', '2015-08-31 18:06:34', 0, 2542, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338febf0d9d', '望谟县', 'pub', '522326', 'cskefu', NULL, '297e1e874f83129d014f8335061f034e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:34', '2015-08-31 18:06:34', 0, 2543, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338fecb0d9e', '册亨县', 'pub', '522327', 'cskefu', NULL, '297e1e874f83129d014f8335061f034e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:34', '2015-08-31 18:06:34', 0, 2544, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338fed70d9f', '安龙县', 'pub', '522328', 'cskefu', NULL, '297e1e874f83129d014f8335061f034e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:34', '2015-08-31 18:06:34', 0, 2545, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ff030da0', '毕节市', 'pub', '522401', 'cskefu', NULL, '297e1e874f83129d014f8335062e034f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:34', '2015-08-31 18:06:34', 0, 2546, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ff100da1', '大方县', 'pub', '522422', 'cskefu', NULL, '297e1e874f83129d014f8335062e034f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:34', '2015-08-31 18:06:34', 0, 2547, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ff1f0da2', '黔西县', 'pub', '522423', 'cskefu', NULL, '297e1e874f83129d014f8335062e034f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:34', '2015-08-31 18:06:34', 0, 2548, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ff2b0da3', '金沙县', 'pub', '522424', 'cskefu', NULL, '297e1e874f83129d014f8335062e034f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:34', '2015-08-31 18:06:34', 0, 2549, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8338ff370da4', '织金县', 'pub', '522425', 'cskefu', NULL, '297e1e874f83129d014f8335062e034f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:34', '2015-08-31 18:06:34', 0, 2550, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833900710da5', '纳雍县', 'pub', '522426', 'cskefu', NULL, '297e1e874f83129d014f8335062e034f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:35', '2015-08-31 18:06:35', 0, 2551, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833900800da6', '威宁彝族回族苗族自治县', 'pub', '522427', 'cskefu', NULL, '297e1e874f83129d014f8335062e034f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:35', '2015-08-31 18:06:35', 0, 2552, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339008c0da7', '赫章县', 'pub', '522428', 'cskefu', NULL, '297e1e874f83129d014f8335062e034f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:35', '2015-08-31 18:06:35', 0, 2553, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833900b30da8', '凯里市', 'pub', '522601', 'cskefu', NULL, '297e1e874f83129d014f833506400350', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:35', '2015-08-31 18:06:35', 0, 2554, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833900c00da9', '黄平县', 'pub', '522622', 'cskefu', NULL, '297e1e874f83129d014f833506400350', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:35', '2015-08-31 18:06:35', 0, 2555, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833900cc0daa', '施秉县', 'pub', '522623', 'cskefu', NULL, '297e1e874f83129d014f833506400350', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:35', '2015-08-31 18:06:35', 0, 2556, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833900da0dab', '三穗县', 'pub', '522624', 'cskefu', NULL, '297e1e874f83129d014f833506400350', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:35', '2015-08-31 18:06:35', 0, 2557, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833900e70dac', '镇远县', 'pub', '522625', 'cskefu', NULL, '297e1e874f83129d014f833506400350', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:35', '2015-08-31 18:06:35', 0, 2558, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833900f30dad', '岑巩县', 'pub', '522626', 'cskefu', NULL, '297e1e874f83129d014f833506400350', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:35', '2015-08-31 18:06:35', 0, 2559, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339022c0dae', '天柱县', 'pub', '522627', 'cskefu', NULL, '297e1e874f83129d014f833506400350', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:35', '2015-08-31 18:06:35', 0, 2560, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833902400daf', '锦屏县', 'pub', '522628', 'cskefu', NULL, '297e1e874f83129d014f833506400350', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:35', '2015-08-31 18:06:35', 0, 2561, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339024f0db0', '剑河县', 'pub', '522629', 'cskefu', NULL, '297e1e874f83129d014f833506400350', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:35', '2015-08-31 18:06:35', 0, 2562, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339025d0db1', '台江县', 'pub', '522630', 'cskefu', NULL, '297e1e874f83129d014f833506400350', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:35', '2015-08-31 18:06:35', 0, 2563, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833902690db2', '黎平县', 'pub', '522631', 'cskefu', NULL, '297e1e874f83129d014f833506400350', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:35', '2015-08-31 18:06:35', 0, 2564, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833902750db3', '榕江县', 'pub', '522632', 'cskefu', NULL, '297e1e874f83129d014f833506400350', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:35', '2015-08-31 18:06:35', 0, 2565, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833902810db4', '从江县', 'pub', '522633', 'cskefu', NULL, '297e1e874f83129d014f833506400350', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:35', '2015-08-31 18:06:35', 0, 2566, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833902900db5', '雷山县', 'pub', '522634', 'cskefu', NULL, '297e1e874f83129d014f833506400350', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:35', '2015-08-31 18:06:35', 0, 2567, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339029c0db6', '麻江县', 'pub', '522635', 'cskefu', NULL, '297e1e874f83129d014f833506400350', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:35', '2015-08-31 18:06:35', 0, 2568, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833902a80db7', '丹寨县', 'pub', '522636', 'cskefu', NULL, '297e1e874f83129d014f833506400350', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:35', '2015-08-31 18:06:35', 0, 2569, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833902ce0db8', '都匀市', 'pub', '522701', 'cskefu', NULL, '297e1e874f83129d014f833506500351', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:35', '2015-08-31 18:06:35', 0, 2570, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833902dd0db9', '福泉市', 'pub', '522702', 'cskefu', NULL, '297e1e874f83129d014f833506500351', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:35', '2015-08-31 18:06:35', 0, 2571, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833902ea0dba', '荔波县', 'pub', '522722', 'cskefu', NULL, '297e1e874f83129d014f833506500351', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:35', '2015-08-31 18:06:35', 0, 2572, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833904260dbb', '贵定县', 'pub', '522723', 'cskefu', NULL, '297e1e874f83129d014f833506500351', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:36', '2015-08-31 18:06:36', 0, 2573, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833904350dbc', '瓮安县', 'pub', '522725', 'cskefu', NULL, '297e1e874f83129d014f833506500351', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:36', '2015-08-31 18:06:36', 0, 2574, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833904420dbd', '独山县', 'pub', '522726', 'cskefu', NULL, '297e1e874f83129d014f833506500351', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:36', '2015-08-31 18:06:36', 0, 2575, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339044e0dbe', '平塘县', 'pub', '522727', 'cskefu', NULL, '297e1e874f83129d014f833506500351', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:36', '2015-08-31 18:06:36', 0, 2576, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339045b0dbf', '罗甸县', 'pub', '522728', 'cskefu', NULL, '297e1e874f83129d014f833506500351', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:36', '2015-08-31 18:06:36', 0, 2577, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833904680dc0', '长顺县', 'pub', '522729', 'cskefu', NULL, '297e1e874f83129d014f833506500351', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:36', '2015-08-31 18:06:36', 0, 2578, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833904750dc1', '龙里县', 'pub', '522730', 'cskefu', NULL, '297e1e874f83129d014f833506500351', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:36', '2015-08-31 18:06:36', 0, 2579, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833904830dc2', '惠水县', 'pub', '522731', 'cskefu', NULL, '297e1e874f83129d014f833506500351', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:36', '2015-08-31 18:06:36', 0, 2580, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833904920dc3', '三都水族自治县', 'pub', '522732', 'cskefu', NULL, '297e1e874f83129d014f833506500351', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:36', '2015-08-31 18:06:36', 0, 2581, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833904be0dc4', '市辖区', 'pub', '530101', 'cskefu', NULL, '297e1e874f83129d014f833506810352', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:36', '2015-08-31 18:06:36', 0, 2582, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833904cd0dc5', '五华区', 'pub', '530102', 'cskefu', NULL, '297e1e874f83129d014f833506810352', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:36', '2015-08-31 18:06:36', 0, 2583, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833904db0dc6', '盘龙区', 'pub', '530103', 'cskefu', NULL, '297e1e874f83129d014f833506810352', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:36', '2015-08-31 18:06:36', 0, 2584, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833904e70dc7', '官渡区', 'pub', '530111', 'cskefu', NULL, '297e1e874f83129d014f833506810352', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:36', '2015-08-31 18:06:36', 0, 2585, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833906210dc8', '西山区', 'pub', '530112', 'cskefu', NULL, '297e1e874f83129d014f833506810352', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:36', '2015-08-31 18:06:36', 0, 2586, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339062e0dc9', '东川区', 'pub', '530113', 'cskefu', NULL, '297e1e874f83129d014f833506810352', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:36', '2015-08-31 18:06:36', 0, 2587, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339063f0dca', '呈贡县', 'pub', '530121', 'cskefu', NULL, '297e1e874f83129d014f833506810352', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:36', '2015-08-31 18:06:36', 0, 2588, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339064c0dcb', '晋宁县', 'pub', '530122', 'cskefu', NULL, '297e1e874f83129d014f833506810352', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:36', '2015-08-31 18:06:36', 0, 2589, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339065a0dcc', '富民县', 'pub', '530124', 'cskefu', NULL, '297e1e874f83129d014f833506810352', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:36', '2015-08-31 18:06:36', 0, 2590, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833906670dcd', '宜良县', 'pub', '530125', 'cskefu', NULL, '297e1e874f83129d014f833506810352', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:36', '2015-08-31 18:06:36', 0, 2591, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833906780dce', '石林彝族自治县', 'pub', '530126', 'cskefu', NULL, '297e1e874f83129d014f833506810352', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:36', '2015-08-31 18:06:36', 0, 2592, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833906850dcf', '嵩明县', 'pub', '530127', 'cskefu', NULL, '297e1e874f83129d014f833506810352', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:36', '2015-08-31 18:06:36', 0, 2593, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833906910dd0', '禄劝彝族苗族自治县', 'pub', '530128', 'cskefu', NULL, '297e1e874f83129d014f833506810352', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:36', '2015-08-31 18:06:36', 0, 2594, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339069d0dd1', '寻甸回族彝族自治县', 'pub', '530129', 'cskefu', NULL, '297e1e874f83129d014f833506810352', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:36', '2015-08-31 18:06:36', 0, 2595, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833906a80dd2', '安宁市', 'pub', '530181', 'cskefu', NULL, '297e1e874f83129d014f833506810352', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:36', '2015-08-31 18:06:36', 0, 2596, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833907fc0dd4', '市辖区', 'pub', '530301', 'cskefu', NULL, '297e1e874f83129d014f833507bf0353', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:37', '2015-08-31 18:06:37', 0, 2597, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339080a0dd5', '麒麟区', 'pub', '530302', 'cskefu', NULL, '297e1e874f83129d014f833507bf0353', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:37', '2015-08-31 18:06:37', 0, 2598, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833908190dd6', '马龙县', 'pub', '530321', 'cskefu', NULL, '297e1e874f83129d014f833507bf0353', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:37', '2015-08-31 18:06:37', 0, 2599, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833908260dd7', '陆良县', 'pub', '530322', 'cskefu', NULL, '297e1e874f83129d014f833507bf0353', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:37', '2015-08-31 18:06:37', 0, 2600, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833908330dd8', '师宗县', 'pub', '530323', 'cskefu', NULL, '297e1e874f83129d014f833507bf0353', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:37', '2015-08-31 18:06:37', 0, 2601, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339083f0dd9', '罗平县', 'pub', '530324', 'cskefu', NULL, '297e1e874f83129d014f833507bf0353', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:37', '2015-08-31 18:06:37', 0, 2602, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339084c0dda', '富源县', 'pub', '530325', 'cskefu', NULL, '297e1e874f83129d014f833507bf0353', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:37', '2015-08-31 18:06:37', 0, 2603, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339085c0ddb', '会泽县', 'pub', '530326', 'cskefu', NULL, '297e1e874f83129d014f833507bf0353', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:37', '2015-08-31 18:06:37', 0, 2604, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833908690ddc', '沾益县', 'pub', '530328', 'cskefu', NULL, '297e1e874f83129d014f833507bf0353', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:37', '2015-08-31 18:06:37', 0, 2605, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833908740ddd', '宣威市', 'pub', '530381', 'cskefu', NULL, '297e1e874f83129d014f833507bf0353', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:37', '2015-08-31 18:06:37', 0, 2606, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339089c0dde', '市辖区', 'pub', '530401', 'cskefu', NULL, '297e1e874f83129d014f833507cd0354', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:37', '2015-08-31 18:06:37', 0, 2607, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833908a80ddf', '红塔区', 'pub', '530402', 'cskefu', NULL, '297e1e874f83129d014f833507cd0354', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:37', '2015-08-31 18:06:37', 0, 2608, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833908b40de0', '江川县', 'pub', '530421', 'cskefu', NULL, '297e1e874f83129d014f833507cd0354', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:37', '2015-08-31 18:06:37', 0, 2609, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833909ef0de1', '澄江县', 'pub', '530422', 'cskefu', NULL, '297e1e874f83129d014f833507cd0354', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:37', '2015-08-31 18:06:37', 0, 2610, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833909fc0de2', '通海县', 'pub', '530423', 'cskefu', NULL, '297e1e874f83129d014f833507cd0354', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:37', '2015-08-31 18:06:37', 0, 2611, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83390a080de3', '华宁县', 'pub', '530424', 'cskefu', NULL, '297e1e874f83129d014f833507cd0354', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:37', '2015-08-31 18:06:37', 0, 2612, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83390a140de4', '易门县', 'pub', '530425', 'cskefu', NULL, '297e1e874f83129d014f833507cd0354', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:37', '2015-08-31 18:06:37', 0, 2613, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83390a210de5', '峨山彝族自治县', 'pub', '530426', 'cskefu', NULL, '297e1e874f83129d014f833507cd0354', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:37', '2015-08-31 18:06:37', 0, 2614, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83390a310de6', '新平彝族傣族自治县', 'pub', '530427', 'cskefu', NULL, '297e1e874f83129d014f833507cd0354', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:37', '2015-08-31 18:06:37', 0, 2615, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83390a3d0de7', '元江哈尼族彝族傣族自治县', 'pub', '530428', 'cskefu', NULL, '297e1e874f83129d014f833507cd0354', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:37', '2015-08-31 18:06:37', 0, 2616, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83390a660de8', '市辖区', 'pub', '530501', 'cskefu', NULL, '297e1e874f83129d014f833507e00355', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:37', '2015-08-31 18:06:37', 0, 2617, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83390a770de9', '隆阳区', 'pub', '530502', 'cskefu', NULL, '297e1e874f83129d014f833507e00355', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:37', '2015-08-31 18:06:37', 0, 2618, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83390a840dea', '施甸县', 'pub', '530521', 'cskefu', NULL, '297e1e874f83129d014f833507e00355', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:37', '2015-08-31 18:06:37', 0, 2619, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83390a970deb', '腾冲县', 'pub', '530522', 'cskefu', NULL, '297e1e874f83129d014f833507e00355', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:37', '2015-08-31 18:06:37', 0, 2620, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83390aa50dec', '龙陵县', 'pub', '530523', 'cskefu', NULL, '297e1e874f83129d014f833507e00355', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:37', '2015-08-31 18:06:37', 0, 2621, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83390bdf0ded', '昌宁县', 'pub', '530524', 'cskefu', NULL, '297e1e874f83129d014f833507e00355', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:38', '2015-08-31 18:06:38', 0, 2622, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83390c090dee', '市辖区', 'pub', '530601', 'cskefu', NULL, '297e1e874f83129d014f833507f60356', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:38', '2015-08-31 18:06:38', 0, 2623, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83390c150def', '昭阳区', 'pub', '530602', 'cskefu', NULL, '297e1e874f83129d014f833507f60356', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:38', '2015-08-31 18:06:38', 0, 2624, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83390c260df0', '鲁甸县', 'pub', '530621', 'cskefu', NULL, '297e1e874f83129d014f833507f60356', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:38', '2015-08-31 18:06:38', 0, 2625, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83390c380df1', '巧家县', 'pub', '530622', 'cskefu', NULL, '297e1e874f83129d014f833507f60356', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:38', '2015-08-31 18:06:38', 0, 2626, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83390c460df2', '盐津县', 'pub', '530623', 'cskefu', NULL, '297e1e874f83129d014f833507f60356', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:38', '2015-08-31 18:06:38', 0, 2627, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83390c540df3', '大关县', 'pub', '530624', 'cskefu', NULL, '297e1e874f83129d014f833507f60356', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:38', '2015-08-31 18:06:38', 0, 2628, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83390c620df4', '永善县', 'pub', '530625', 'cskefu', NULL, '297e1e874f83129d014f833507f60356', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:38', '2015-08-31 18:06:38', 0, 2629, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83390c6e0df5', '绥江县', 'pub', '530626', 'cskefu', NULL, '297e1e874f83129d014f833507f60356', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:38', '2015-08-31 18:06:38', 0, 2630, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83390c7c0df6', '镇雄县', 'pub', '530627', 'cskefu', NULL, '297e1e874f83129d014f833507f60356', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:38', '2015-08-31 18:06:38', 0, 2631, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83390c8a0df7', '彝良县', 'pub', '530628', 'cskefu', NULL, '297e1e874f83129d014f833507f60356', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:38', '2015-08-31 18:06:38', 0, 2632, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83390c9d0df8', '威信县', 'pub', '530629', 'cskefu', NULL, '297e1e874f83129d014f833507f60356', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:38', '2015-08-31 18:06:38', 0, 2633, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83390ca90df9', '水富县', 'pub', '530630', 'cskefu', NULL, '297e1e874f83129d014f833507f60356', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:38', '2015-08-31 18:06:38', 0, 2634, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83390e040dfa', '市辖区', 'pub', '530701', 'cskefu', NULL, '297e1e874f83129d014f833508050357', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:38', '2015-08-31 18:06:38', 0, 2635, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83390e100dfb', '古城区', 'pub', '530702', 'cskefu', NULL, '297e1e874f83129d014f833508050357', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:38', '2015-08-31 18:06:38', 0, 2636, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83390e1d0dfc', '玉龙纳西族自治县', 'pub', '530721', 'cskefu', NULL, '297e1e874f83129d014f833508050357', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:38', '2015-08-31 18:06:38', 0, 2637, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83390e2a0dfd', '永胜县', 'pub', '530722', 'cskefu', NULL, '297e1e874f83129d014f833508050357', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:38', '2015-08-31 18:06:38', 0, 2638, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83390e380dfe', '华坪县', 'pub', '530723', 'cskefu', NULL, '297e1e874f83129d014f833508050357', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:38', '2015-08-31 18:06:38', 0, 2639, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83390e440dff', '宁蒗彝族自治县', 'pub', '530724', 'cskefu', NULL, '297e1e874f83129d014f833508050357', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:38', '2015-08-31 18:06:38', 0, 2640, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83390e6a0e00', '市辖区', 'pub', '530801', 'cskefu', NULL, '297e1e874f83129d014f833508180358', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:38', '2015-08-31 18:06:38', 0, 2641, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83390e780e01', '翠云区', 'pub', '530802', 'cskefu', NULL, '297e1e874f83129d014f833508180358', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:38', '2015-08-31 18:06:38', 0, 2642, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83390e8c0e02', '普洱哈尼族彝族自治县', 'pub', '530821', 'cskefu', NULL, '297e1e874f83129d014f833508180358', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:38', '2015-08-31 18:06:38', 0, 2643, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83390e990e03', '墨江哈尼族自治县', 'pub', '530822', 'cskefu', NULL, '297e1e874f83129d014f833508180358', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:38', '2015-08-31 18:06:38', 0, 2644, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83390fdd0e04', '景东彝族自治县', 'pub', '530823', 'cskefu', NULL, '297e1e874f83129d014f833508180358', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:39', '2015-08-31 18:06:39', 0, 2645, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83390fec0e05', '景谷傣族彝族自治县', 'pub', '530824', 'cskefu', NULL, '297e1e874f83129d014f833508180358', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:39', '2015-08-31 18:06:39', 0, 2646, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83390ffc0e06', '镇沅彝族哈尼族拉祜族自治县', 'pub', '530825', 'cskefu', NULL, '297e1e874f83129d014f833508180358', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:39', '2015-08-31 18:06:39', 0, 2647, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339100e0e07', '江城哈尼族彝族自治县', 'pub', '530826', 'cskefu', NULL, '297e1e874f83129d014f833508180358', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:39', '2015-08-31 18:06:39', 0, 2648, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339101c0e08', '孟连傣族拉祜族佤族自治县', 'pub', '530827', 'cskefu', NULL, '297e1e874f83129d014f833508180358', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:39', '2015-08-31 18:06:39', 0, 2649, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339102b0e09', '澜沧拉祜族自治县', 'pub', '530828', 'cskefu', NULL, '297e1e874f83129d014f833508180358', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:39', '2015-08-31 18:06:39', 0, 2650, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339103d0e0a', '西盟佤族自治县', 'pub', '530829', 'cskefu', NULL, '297e1e874f83129d014f833508180358', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:39', '2015-08-31 18:06:39', 0, 2651, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339106d0e0b', '市辖区', 'pub', '530901', 'cskefu', NULL, '297e1e874f83129d014f833508270359', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:39', '2015-08-31 18:06:39', 0, 2652, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339107d0e0c', '临翔区', 'pub', '530902', 'cskefu', NULL, '297e1e874f83129d014f833508270359', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:39', '2015-08-31 18:06:39', 0, 2653, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339108f0e0d', '凤庆县', 'pub', '530921', 'cskefu', NULL, '297e1e874f83129d014f833508270359', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:39', '2015-08-31 18:06:39', 0, 2654, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339109e0e0e', '云　县', 'pub', '530922', 'cskefu', NULL, '297e1e874f83129d014f833508270359', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:39', '2015-08-31 18:06:39', 0, 2655, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833910ac0e0f', '永德县', 'pub', '530923', 'cskefu', NULL, '297e1e874f83129d014f833508270359', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:39', '2015-08-31 18:06:39', 0, 2656, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833910bf0e10', '镇康县', 'pub', '530924', 'cskefu', NULL, '297e1e874f83129d014f833508270359', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:39', '2015-08-31 18:06:39', 0, 2657, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833910d00e11', '双江拉祜族佤族布朗族傣族自治县', 'pub', '530925', 'cskefu', NULL, '297e1e874f83129d014f833508270359', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:39', '2015-08-31 18:06:39', 0, 2658, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833910dc0e12', '耿马傣族佤族自治县', 'pub', '530926', 'cskefu', NULL, '297e1e874f83129d014f833508270359', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:39', '2015-08-31 18:06:39', 0, 2659, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339121e0e13', '沧源佤族自治县', 'pub', '530927', 'cskefu', NULL, '297e1e874f83129d014f833508270359', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:39', '2015-08-31 18:06:39', 0, 2660, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833912500e14', '楚雄市', 'pub', '532301', 'cskefu', NULL, '297e1e874f83129d014f8335083b035a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:39', '2015-08-31 18:06:39', 0, 2661, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833912600e15', '双柏县', 'pub', '532322', 'cskefu', NULL, '297e1e874f83129d014f8335083b035a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:39', '2015-08-31 18:06:39', 0, 2662, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339126e0e16', '牟定县', 'pub', '532323', 'cskefu', NULL, '297e1e874f83129d014f8335083b035a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:39', '2015-08-31 18:06:39', 0, 2663, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833912800e17', '南华县', 'pub', '532324', 'cskefu', NULL, '297e1e874f83129d014f8335083b035a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:39', '2015-08-31 18:06:39', 0, 2664, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833912910e18', '姚安县', 'pub', '532325', 'cskefu', NULL, '297e1e874f83129d014f8335083b035a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:39', '2015-08-31 18:06:39', 0, 2665, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339129d0e19', '大姚县', 'pub', '532326', 'cskefu', NULL, '297e1e874f83129d014f8335083b035a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:39', '2015-08-31 18:06:39', 0, 2666, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833912ae0e1a', '永仁县', 'pub', '532327', 'cskefu', NULL, '297e1e874f83129d014f8335083b035a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:39', '2015-08-31 18:06:39', 0, 2667, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833912c20e1b', '元谋县', 'pub', '532328', 'cskefu', NULL, '297e1e874f83129d014f8335083b035a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:39', '2015-08-31 18:06:39', 0, 2668, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833912d40e1c', '武定县', 'pub', '532329', 'cskefu', NULL, '297e1e874f83129d014f8335083b035a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:39', '2015-08-31 18:06:39', 0, 2669, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833912e30e1d', '禄丰县', 'pub', '532331', 'cskefu', NULL, '297e1e874f83129d014f8335083b035a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:39', '2015-08-31 18:06:39', 0, 2670, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833913120e1e', '个旧市', 'pub', '532501', 'cskefu', NULL, '297e1e874f83129d014f8335084a035b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:39', '2015-08-31 18:06:39', 0, 2671, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833913210e1f', '开远市', 'pub', '532502', 'cskefu', NULL, '297e1e874f83129d014f8335084a035b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:39', '2015-08-31 18:06:39', 0, 2672, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339132f0e20', '蒙自县', 'pub', '532522', 'cskefu', NULL, '297e1e874f83129d014f8335084a035b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:39', '2015-08-31 18:06:39', 0, 2673, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339146a0e21', '屏边苗族自治县', 'pub', '532523', 'cskefu', NULL, '297e1e874f83129d014f8335084a035b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:40', '2015-08-31 18:06:40', 0, 2674, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833914770e22', '建水县', 'pub', '532524', 'cskefu', NULL, '297e1e874f83129d014f8335084a035b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:40', '2015-08-31 18:06:40', 0, 2675, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833914840e23', '石屏县', 'pub', '532525', 'cskefu', NULL, '297e1e874f83129d014f8335084a035b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:40', '2015-08-31 18:06:40', 0, 2676, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833914940e24', '弥勒县', 'pub', '532526', 'cskefu', NULL, '297e1e874f83129d014f8335084a035b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:40', '2015-08-31 18:06:40', 0, 2677, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833914a10e25', '泸西县', 'pub', '532527', 'cskefu', NULL, '297e1e874f83129d014f8335084a035b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:40', '2015-08-31 18:06:40', 0, 2678, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833914b10e26', '元阳县', 'pub', '532528', 'cskefu', NULL, '297e1e874f83129d014f8335084a035b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:40', '2015-08-31 18:06:40', 0, 2679, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833914bd0e27', '红河县', 'pub', '532529', 'cskefu', NULL, '297e1e874f83129d014f8335084a035b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:40', '2015-08-31 18:06:40', 0, 2680, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833914d20e28', '金平苗族瑶族傣族自治县', 'pub', '532530', 'cskefu', NULL, '297e1e874f83129d014f8335084a035b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:40', '2015-08-31 18:06:40', 0, 2681, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833914e70e29', '绿春县', 'pub', '532531', 'cskefu', NULL, '297e1e874f83129d014f8335084a035b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:40', '2015-08-31 18:06:40', 0, 2682, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833914f40e2a', '河口瑶族自治县', 'pub', '532532', 'cskefu', NULL, '297e1e874f83129d014f8335084a035b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:40', '2015-08-31 18:06:40', 0, 2683, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339151c0e2b', '文山县', 'pub', '532621', 'cskefu', NULL, '297e1e874f83129d014f8335085b035c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:40', '2015-08-31 18:06:40', 0, 2684, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339152a0e2c', '砚山县', 'pub', '532622', 'cskefu', NULL, '297e1e874f83129d014f8335085b035c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:40', '2015-08-31 18:06:40', 0, 2685, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833915390e2d', '西畴县', 'pub', '532623', 'cskefu', NULL, '297e1e874f83129d014f8335085b035c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:40', '2015-08-31 18:06:40', 0, 2686, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833916750e2e', '麻栗坡县', 'pub', '532624', 'cskefu', NULL, '297e1e874f83129d014f8335085b035c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:40', '2015-08-31 18:06:40', 0, 2687, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833916890e2f', '马关县', 'pub', '532625', 'cskefu', NULL, '297e1e874f83129d014f8335085b035c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:40', '2015-08-31 18:06:40', 0, 2688, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833916970e30', '丘北县', 'pub', '532626', 'cskefu', NULL, '297e1e874f83129d014f8335085b035c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:40', '2015-08-31 18:06:40', 0, 2689, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833916a70e31', '广南县', 'pub', '532627', 'cskefu', NULL, '297e1e874f83129d014f8335085b035c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:40', '2015-08-31 18:06:40', 0, 2690, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833916bb0e32', '富宁县', 'pub', '532628', 'cskefu', NULL, '297e1e874f83129d014f8335085b035c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:40', '2015-08-31 18:06:40', 0, 2691, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833916e80e33', '景洪市', 'pub', '532801', 'cskefu', NULL, '297e1e874f83129d014f8335086c035d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:40', '2015-08-31 18:06:40', 0, 2692, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833916f50e34', '勐海县', 'pub', '532822', 'cskefu', NULL, '297e1e874f83129d014f8335086c035d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:40', '2015-08-31 18:06:40', 0, 2693, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833917040e35', '勐腊县', 'pub', '532823', 'cskefu', NULL, '297e1e874f83129d014f8335086c035d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:40', '2015-08-31 18:06:40', 0, 2694, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833917350e36', '大理市', 'pub', '532901', 'cskefu', NULL, '297e1e874f83129d014f8335087a035e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:40', '2015-08-31 18:06:40', 0, 2695, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833917420e37', '漾濞彝族自治县', 'pub', '532922', 'cskefu', NULL, '297e1e874f83129d014f8335087a035e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:40', '2015-08-31 18:06:40', 0, 2696, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833917520e38', '祥云县', 'pub', '532923', 'cskefu', NULL, '297e1e874f83129d014f8335087a035e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:40', '2015-08-31 18:06:40', 0, 2697, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833917620e39', '宾川县', 'pub', '532924', 'cskefu', NULL, '297e1e874f83129d014f8335087a035e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:40', '2015-08-31 18:06:40', 0, 2698, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833917720e3a', '弥渡县', 'pub', '532925', 'cskefu', NULL, '297e1e874f83129d014f8335087a035e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:41', '2015-08-31 18:06:41', 0, 2699, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339177f0e3b', '南涧彝族自治县', 'pub', '532926', 'cskefu', NULL, '297e1e874f83129d014f8335087a035e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:41', '2015-08-31 18:06:41', 0, 2700, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833918b80e3c', '巍山彝族回族自治县', 'pub', '532927', 'cskefu', NULL, '297e1e874f83129d014f8335087a035e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:41', '2015-08-31 18:06:41', 0, 2701, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833918c30e3d', '永平县', 'pub', '532928', 'cskefu', NULL, '297e1e874f83129d014f8335087a035e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:41', '2015-08-31 18:06:41', 0, 2702, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833918d20e3e', '云龙县', 'pub', '532929', 'cskefu', NULL, '297e1e874f83129d014f8335087a035e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:41', '2015-08-31 18:06:41', 0, 2703, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833918de0e3f', '洱源县', 'pub', '532930', 'cskefu', NULL, '297e1e874f83129d014f8335087a035e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:41', '2015-08-31 18:06:41', 0, 2704, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833918ed0e40', '剑川县', 'pub', '532931', 'cskefu', NULL, '297e1e874f83129d014f8335087a035e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:41', '2015-08-31 18:06:41', 0, 2705, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833918fb0e41', '鹤庆县', 'pub', '532932', 'cskefu', NULL, '297e1e874f83129d014f8335087a035e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:41', '2015-08-31 18:06:41', 0, 2706, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833919270e42', '瑞丽市', 'pub', '533102', 'cskefu', NULL, '297e1e874f83129d014f8335088a035f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:41', '2015-08-31 18:06:41', 0, 2707, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833919360e43', '潞西市', 'pub', '533103', 'cskefu', NULL, '297e1e874f83129d014f8335088a035f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:41', '2015-08-31 18:06:41', 0, 2708, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833919470e44', '梁河县', 'pub', '533122', 'cskefu', NULL, '297e1e874f83129d014f8335088a035f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:41', '2015-08-31 18:06:41', 0, 2709, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833919570e45', '盈江县', 'pub', '533123', 'cskefu', NULL, '297e1e874f83129d014f8335088a035f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:41', '2015-08-31 18:06:41', 0, 2710, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833919650e46', '陇川县', 'pub', '533124', 'cskefu', NULL, '297e1e874f83129d014f8335088a035f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:41', '2015-08-31 18:06:41', 0, 2711, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83391abf0e48', '泸水县', 'pub', '533321', 'cskefu', NULL, '297e1e874f83129d014f8335089b0360', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:41', '2015-08-31 18:06:41', 0, 2712, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83391acc0e49', '福贡县', 'pub', '533323', 'cskefu', NULL, '297e1e874f83129d014f8335089b0360', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:41', '2015-08-31 18:06:41', 0, 2713, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83391ada0e4a', '贡山独龙族怒族自治县', 'pub', '533324', 'cskefu', NULL, '297e1e874f83129d014f8335089b0360', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:41', '2015-08-31 18:06:41', 0, 2714, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83391aea0e4b', '兰坪白族普米族自治县', 'pub', '533325', 'cskefu', NULL, '297e1e874f83129d014f8335089b0360', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:41', '2015-08-31 18:06:41', 0, 2715, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83391b130e4c', '香格里拉县', 'pub', '533421', 'cskefu', NULL, '297e1e874f83129d014f833508b20361', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:41', '2015-08-31 18:06:41', 0, 2716, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83391b1f0e4d', '德钦县', 'pub', '533422', 'cskefu', NULL, '297e1e874f83129d014f833508b20361', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:41', '2015-08-31 18:06:41', 0, 2717, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83391b2b0e4e', '维西傈僳族自治县', 'pub', '533423', 'cskefu', NULL, '297e1e874f83129d014f833508b20361', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:41', '2015-08-31 18:06:41', 0, 2718, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83391c850e4f', '市辖区', 'pub', '540101', 'cskefu', NULL, '297e1e874f83129d014f833508e00362', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:42', '2015-08-31 18:06:42', 0, 2719, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83391c970e50', '城关区', 'pub', '540102', 'cskefu', NULL, '297e1e874f83129d014f833508e00362', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:42', '2015-08-31 18:06:42', 0, 2720, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83391ca50e51', '林周县', 'pub', '540121', 'cskefu', NULL, '297e1e874f83129d014f833508e00362', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:42', '2015-08-31 18:06:42', 0, 2721, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83391cb10e52', '当雄县', 'pub', '540122', 'cskefu', NULL, '297e1e874f83129d014f833508e00362', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:42', '2015-08-31 18:06:42', 0, 2722, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83391cc10e53', '尼木县', 'pub', '540123', 'cskefu', NULL, '297e1e874f83129d014f833508e00362', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:42', '2015-08-31 18:06:42', 0, 2723, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83391cce0e54', '曲水县', 'pub', '540124', 'cskefu', NULL, '297e1e874f83129d014f833508e00362', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:42', '2015-08-31 18:06:42', 0, 2724, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83391cdb0e55', '堆龙德庆县', 'pub', '540125', 'cskefu', NULL, '297e1e874f83129d014f833508e00362', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:42', '2015-08-31 18:06:42', 0, 2725, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83391cf20e56', '达孜县', 'pub', '540126', 'cskefu', NULL, '297e1e874f83129d014f833508e00362', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:42', '2015-08-31 18:06:42', 0, 2726, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83391d000e57', '墨竹工卡县', 'pub', '540127', 'cskefu', NULL, '297e1e874f83129d014f833508e00362', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:42', '2015-08-31 18:06:42', 0, 2727, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83391d2a0e58', '昌都县', 'pub', '542121', 'cskefu', NULL, '297e1e874f83129d014f83350a1c0363', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:42', '2015-08-31 18:06:42', 0, 2728, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83391d370e59', '江达县', 'pub', '542122', 'cskefu', NULL, '297e1e874f83129d014f83350a1c0363', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:42', '2015-08-31 18:06:42', 0, 2729, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83391d440e5a', '贡觉县', 'pub', '542123', 'cskefu', NULL, '297e1e874f83129d014f83350a1c0363', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:42', '2015-08-31 18:06:42', 0, 2730, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83391d500e5b', '类乌齐县', 'pub', '542124', 'cskefu', NULL, '297e1e874f83129d014f83350a1c0363', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:42', '2015-08-31 18:06:42', 0, 2731, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83391d5b0e5c', '丁青县', 'pub', '542125', 'cskefu', NULL, '297e1e874f83129d014f83350a1c0363', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:42', '2015-08-31 18:06:42', 0, 2732, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83391e960e5d', '察雅县', 'pub', '542126', 'cskefu', NULL, '297e1e874f83129d014f83350a1c0363', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:42', '2015-08-31 18:06:42', 0, 2733, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83391ea60e5e', '八宿县', 'pub', '542127', 'cskefu', NULL, '297e1e874f83129d014f83350a1c0363', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:42', '2015-08-31 18:06:42', 0, 2734, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83391eb40e5f', '左贡县', 'pub', '542128', 'cskefu', NULL, '297e1e874f83129d014f83350a1c0363', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:42', '2015-08-31 18:06:42', 0, 2735, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83391ec30e60', '芒康县', 'pub', '542129', 'cskefu', NULL, '297e1e874f83129d014f83350a1c0363', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:42', '2015-08-31 18:06:42', 0, 2736, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83391ed00e61', '洛隆县', 'pub', '542132', 'cskefu', NULL, '297e1e874f83129d014f83350a1c0363', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:42', '2015-08-31 18:06:42', 0, 2737, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83391ee00e62', '边坝县', 'pub', '542133', 'cskefu', NULL, '297e1e874f83129d014f83350a1c0363', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:42', '2015-08-31 18:06:42', 0, 2738, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83391f060e63', '乃东县', 'pub', '542221', 'cskefu', NULL, '297e1e874f83129d014f83350a2b0364', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:42', '2015-08-31 18:06:42', 0, 2739, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83391f130e64', '扎囊县', 'pub', '542222', 'cskefu', NULL, '297e1e874f83129d014f83350a2b0364', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:42', '2015-08-31 18:06:42', 0, 2740, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83391f220e65', '贡嘎县', 'pub', '542223', 'cskefu', NULL, '297e1e874f83129d014f83350a2b0364', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:42', '2015-08-31 18:06:42', 0, 2741, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83391f2e0e66', '桑日县', 'pub', '542224', 'cskefu', NULL, '297e1e874f83129d014f83350a2b0364', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:42', '2015-08-31 18:06:42', 0, 2742, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83391f3c0e67', '琼结县', 'pub', '542225', 'cskefu', NULL, '297e1e874f83129d014f83350a2b0364', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:43', '2015-08-31 18:06:43', 0, 2743, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83391f480e68', '曲松县', 'pub', '542226', 'cskefu', NULL, '297e1e874f83129d014f83350a2b0364', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:43', '2015-08-31 18:06:43', 0, 2744, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83391f590e69', '措美县', 'pub', '542227', 'cskefu', NULL, '297e1e874f83129d014f83350a2b0364', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:43', '2015-08-31 18:06:43', 0, 2745, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833920940e6a', '洛扎县', 'pub', '542228', 'cskefu', NULL, '297e1e874f83129d014f83350a2b0364', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:43', '2015-08-31 18:06:43', 0, 2746, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833920a00e6b', '加查县', 'pub', '542229', 'cskefu', NULL, '297e1e874f83129d014f83350a2b0364', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:43', '2015-08-31 18:06:43', 0, 2747, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833920ac0e6c', '隆子县', 'pub', '542231', 'cskefu', NULL, '297e1e874f83129d014f83350a2b0364', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:43', '2015-08-31 18:06:43', 0, 2748, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833920b70e6d', '错那县', 'pub', '542232', 'cskefu', NULL, '297e1e874f83129d014f83350a2b0364', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:43', '2015-08-31 18:06:43', 0, 2749, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833920c20e6e', '浪卡子县', 'pub', '542233', 'cskefu', NULL, '297e1e874f83129d014f83350a2b0364', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:43', '2015-08-31 18:06:43', 0, 2750, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833920e80e6f', '日喀则市', 'pub', '542301', 'cskefu', NULL, '297e1e874f83129d014f83350a3a0365', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:43', '2015-08-31 18:06:43', 0, 2751, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833920f30e70', '南木林县', 'pub', '542322', 'cskefu', NULL, '297e1e874f83129d014f83350a3a0365', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:43', '2015-08-31 18:06:43', 0, 2752, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833921000e71', '江孜县', 'pub', '542323', 'cskefu', NULL, '297e1e874f83129d014f83350a3a0365', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:43', '2015-08-31 18:06:43', 0, 2753, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339210f0e72', '定日县', 'pub', '542324', 'cskefu', NULL, '297e1e874f83129d014f83350a3a0365', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:43', '2015-08-31 18:06:43', 0, 2754, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339211a0e73', '萨迦县', 'pub', '542325', 'cskefu', NULL, '297e1e874f83129d014f83350a3a0365', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:43', '2015-08-31 18:06:43', 0, 2755, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833921250e74', '拉孜县', 'pub', '542326', 'cskefu', NULL, '297e1e874f83129d014f83350a3a0365', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:43', '2015-08-31 18:06:43', 0, 2756, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833921310e75', '昂仁县', 'pub', '542327', 'cskefu', NULL, '297e1e874f83129d014f83350a3a0365', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:43', '2015-08-31 18:06:43', 0, 2757, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339213c0e76', '谢通门县', 'pub', '542328', 'cskefu', NULL, '297e1e874f83129d014f83350a3a0365', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:43', '2015-08-31 18:06:43', 0, 2758, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833922770e77', '白朗县', 'pub', '542329', 'cskefu', NULL, '297e1e874f83129d014f83350a3a0365', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:43', '2015-08-31 18:06:43', 0, 2759, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833922820e78', '仁布县', 'pub', '542330', 'cskefu', NULL, '297e1e874f83129d014f83350a3a0365', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:43', '2015-08-31 18:06:43', 0, 2760, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833922900e79', '康马县', 'pub', '542331', 'cskefu', NULL, '297e1e874f83129d014f83350a3a0365', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:43', '2015-08-31 18:06:43', 0, 2761, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339229d0e7a', '定结县', 'pub', '542332', 'cskefu', NULL, '297e1e874f83129d014f83350a3a0365', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:43', '2015-08-31 18:06:43', 0, 2762, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833922a90e7b', '仲巴县', 'pub', '542333', 'cskefu', NULL, '297e1e874f83129d014f83350a3a0365', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:43', '2015-08-31 18:06:43', 0, 2763, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833922b40e7c', '亚东县', 'pub', '542334', 'cskefu', NULL, '297e1e874f83129d014f83350a3a0365', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:43', '2015-08-31 18:06:43', 0, 2764, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833922bf0e7d', '吉隆县', 'pub', '542335', 'cskefu', NULL, '297e1e874f83129d014f83350a3a0365', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:43', '2015-08-31 18:06:43', 0, 2765, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833922cc0e7e', '聂拉木县', 'pub', '542336', 'cskefu', NULL, '297e1e874f83129d014f83350a3a0365', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:43', '2015-08-31 18:06:43', 0, 2766, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833922d90e7f', '萨嘎县', 'pub', '542337', 'cskefu', NULL, '297e1e874f83129d014f83350a3a0365', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:43', '2015-08-31 18:06:43', 0, 2767, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833922e80e80', '岗巴县', 'pub', '542338', 'cskefu', NULL, '297e1e874f83129d014f83350a3a0365', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:43', '2015-08-31 18:06:43', 0, 2768, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833923140e81', '那曲县', 'pub', '542421', 'cskefu', NULL, '297e1e874f83129d014f83350a480366', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:43', '2015-08-31 18:06:43', 0, 2769, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833923200e82', '嘉黎县', 'pub', '542422', 'cskefu', NULL, '297e1e874f83129d014f83350a480366', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:43', '2015-08-31 18:06:43', 0, 2770, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339232b0e83', '比如县', 'pub', '542423', 'cskefu', NULL, '297e1e874f83129d014f83350a480366', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:44', '2015-08-31 18:06:44', 0, 2771, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833924630e84', '聂荣县', 'pub', '542424', 'cskefu', NULL, '297e1e874f83129d014f83350a480366', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:44', '2015-08-31 18:06:44', 0, 2772, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339246f0e85', '安多县', 'pub', '542425', 'cskefu', NULL, '297e1e874f83129d014f83350a480366', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:44', '2015-08-31 18:06:44', 0, 2773, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339247b0e86', '申扎县', 'pub', '542426', 'cskefu', NULL, '297e1e874f83129d014f83350a480366', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:44', '2015-08-31 18:06:44', 0, 2774, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833924860e87', '索　县', 'pub', '542427', 'cskefu', NULL, '297e1e874f83129d014f83350a480366', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:44', '2015-08-31 18:06:44', 0, 2775, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833924950e88', '班戈县', 'pub', '542428', 'cskefu', NULL, '297e1e874f83129d014f83350a480366', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:44', '2015-08-31 18:06:44', 0, 2776, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833924a10e89', '巴青县', 'pub', '542429', 'cskefu', NULL, '297e1e874f83129d014f83350a480366', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:44', '2015-08-31 18:06:44', 0, 2777, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833924ad0e8a', '尼玛县', 'pub', '542430', 'cskefu', NULL, '297e1e874f83129d014f83350a480366', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:44', '2015-08-31 18:06:44', 0, 2778, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833924d60e8b', '普兰县', 'pub', '542521', 'cskefu', NULL, '297e1e874f83129d014f83350a560367', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:44', '2015-08-31 18:06:44', 0, 2779, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833924e40e8c', '札达县', 'pub', '542522', 'cskefu', NULL, '297e1e874f83129d014f83350a560367', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:44', '2015-08-31 18:06:44', 0, 2780, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833924f10e8d', '噶尔县', 'pub', '542523', 'cskefu', NULL, '297e1e874f83129d014f83350a560367', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:44', '2015-08-31 18:06:44', 0, 2781, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833926290e8e', '日土县', 'pub', '542524', 'cskefu', NULL, '297e1e874f83129d014f83350a560367', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:44', '2015-08-31 18:06:44', 0, 2782, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833926340e8f', '革吉县', 'pub', '542525', 'cskefu', NULL, '297e1e874f83129d014f83350a560367', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:44', '2015-08-31 18:06:44', 0, 2783, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833926400e90', '改则县', 'pub', '542526', 'cskefu', NULL, '297e1e874f83129d014f83350a560367', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:44', '2015-08-31 18:06:44', 0, 2784, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339264b0e91', '措勤县', 'pub', '542527', 'cskefu', NULL, '297e1e874f83129d014f83350a560367', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:44', '2015-08-31 18:06:44', 0, 2785, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833926790e92', '林芝县', 'pub', '542621', 'cskefu', NULL, '297e1e874f83129d014f83350a650368', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:44', '2015-08-31 18:06:44', 0, 2786, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833926850e93', '工布江达县', 'pub', '542622', 'cskefu', NULL, '297e1e874f83129d014f83350a650368', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:44', '2015-08-31 18:06:44', 0, 2787, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833926910e94', '米林县', 'pub', '542623', 'cskefu', NULL, '297e1e874f83129d014f83350a650368', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:44', '2015-08-31 18:06:44', 0, 2788, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339269e0e95', '墨脱县', 'pub', '542624', 'cskefu', NULL, '297e1e874f83129d014f83350a650368', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:44', '2015-08-31 18:06:44', 0, 2789, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833926aa0e96', '波密县', 'pub', '542625', 'cskefu', NULL, '297e1e874f83129d014f83350a650368', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:44', '2015-08-31 18:06:44', 0, 2790, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833926b60e97', '察隅县', 'pub', '542626', 'cskefu', NULL, '297e1e874f83129d014f83350a650368', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:44', '2015-08-31 18:06:44', 0, 2791, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833926c30e98', '朗　县', 'pub', '542627', 'cskefu', NULL, '297e1e874f83129d014f83350a650368', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:44', '2015-08-31 18:06:44', 0, 2792, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833926e90e99', '市辖区', 'pub', '610101', 'cskefu', NULL, '297e1e874f83129d014f83350a8e0369', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:44', '2015-08-31 18:06:44', 0, 2793, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833926f40e9a', '新城区', 'pub', '610102', 'cskefu', NULL, '297e1e874f83129d014f83350a8e0369', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:44', '2015-08-31 18:06:44', 0, 2794, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833926ff0e9b', '碑林区', 'pub', '610103', 'cskefu', NULL, '297e1e874f83129d014f83350a8e0369', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:44', '2015-08-31 18:06:44', 0, 2795, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833928370e9c', '莲湖区', 'pub', '610104', 'cskefu', NULL, '297e1e874f83129d014f83350a8e0369', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:45', '2015-08-31 18:06:45', 0, 2796, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833928440e9d', '灞桥区', 'pub', '610111', 'cskefu', NULL, '297e1e874f83129d014f83350a8e0369', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:45', '2015-08-31 18:06:45', 0, 2797, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833928500e9e', '未央区', 'pub', '610112', 'cskefu', NULL, '297e1e874f83129d014f83350a8e0369', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:45', '2015-08-31 18:06:45', 0, 2798, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339285f0e9f', '雁塔区', 'pub', '610113', 'cskefu', NULL, '297e1e874f83129d014f83350a8e0369', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:45', '2015-08-31 18:06:45', 0, 2799, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339286a0ea0', '阎良区', 'pub', '610114', 'cskefu', NULL, '297e1e874f83129d014f83350a8e0369', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:45', '2015-08-31 18:06:45', 0, 2800, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833928770ea1', '临潼区', 'pub', '610115', 'cskefu', NULL, '297e1e874f83129d014f83350a8e0369', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:45', '2015-08-31 18:06:45', 0, 2801, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833928820ea2', '长安区', 'pub', '610116', 'cskefu', NULL, '297e1e874f83129d014f83350a8e0369', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:45', '2015-08-31 18:06:45', 0, 2802, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339288e0ea3', '蓝田县', 'pub', '610122', 'cskefu', NULL, '297e1e874f83129d014f83350a8e0369', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:45', '2015-08-31 18:06:45', 0, 2803, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339289b0ea4', '周至县', 'pub', '610124', 'cskefu', NULL, '297e1e874f83129d014f83350a8e0369', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:45', '2015-08-31 18:06:45', 0, 2804, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833928a80ea5', '户　县', 'pub', '610125', 'cskefu', NULL, '297e1e874f83129d014f83350a8e0369', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:45', '2015-08-31 18:06:45', 0, 2805, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833928b40ea6', '高陵县', 'pub', '610126', 'cskefu', NULL, '297e1e874f83129d014f83350a8e0369', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:45', '2015-08-31 18:06:45', 0, 2806, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83392a0c0ea7', '市辖区', 'pub', '610201', 'cskefu', NULL, '297e1e874f83129d014f83350aa1036a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:45', '2015-08-31 18:06:45', 0, 2807, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83392a1a0ea8', '王益区', 'pub', '610202', 'cskefu', NULL, '297e1e874f83129d014f83350aa1036a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:45', '2015-08-31 18:06:45', 0, 2808, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83392a270ea9', '印台区', 'pub', '610203', 'cskefu', NULL, '297e1e874f83129d014f83350aa1036a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:45', '2015-08-31 18:06:45', 0, 2809, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83392a320eaa', '耀州区', 'pub', '610204', 'cskefu', NULL, '297e1e874f83129d014f83350aa1036a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:45', '2015-08-31 18:06:45', 0, 2810, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83392a470eab', '宜君县', 'pub', '610222', 'cskefu', NULL, '297e1e874f83129d014f83350aa1036a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:45', '2015-08-31 18:06:45', 0, 2811, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83392a6e0eac', '市辖区', 'pub', '610301', 'cskefu', NULL, '297e1e874f83129d014f83350ab6036b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:45', '2015-08-31 18:06:45', 0, 2812, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83392a7a0ead', '渭滨区', 'pub', '610302', 'cskefu', NULL, '297e1e874f83129d014f83350ab6036b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:45', '2015-08-31 18:06:45', 0, 2813, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83392a860eae', '金台区', 'pub', '610303', 'cskefu', NULL, '297e1e874f83129d014f83350ab6036b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:45', '2015-08-31 18:06:45', 0, 2814, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83392a940eaf', '陈仓区', 'pub', '610304', 'cskefu', NULL, '297e1e874f83129d014f83350ab6036b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:45', '2015-08-31 18:06:45', 0, 2815, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83392aa10eb0', '凤翔县', 'pub', '610322', 'cskefu', NULL, '297e1e874f83129d014f83350ab6036b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:45', '2015-08-31 18:06:45', 0, 2816, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83392aad0eb1', '岐山县', 'pub', '610323', 'cskefu', NULL, '297e1e874f83129d014f83350ab6036b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:45', '2015-08-31 18:06:45', 0, 2817, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83392aba0eb2', '扶风县', 'pub', '610324', 'cskefu', NULL, '297e1e874f83129d014f83350ab6036b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:45', '2015-08-31 18:06:45', 0, 2818, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83392bf30eb3', '眉　县', 'pub', '610326', 'cskefu', NULL, '297e1e874f83129d014f83350ab6036b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:46', '2015-08-31 18:06:46', 0, 2819, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83392bff0eb4', '陇　县', 'pub', '610327', 'cskefu', NULL, '297e1e874f83129d014f83350ab6036b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:46', '2015-08-31 18:06:46', 0, 2820, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83392c0a0eb5', '千阳县', 'pub', '610328', 'cskefu', NULL, '297e1e874f83129d014f83350ab6036b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:46', '2015-08-31 18:06:46', 0, 2821, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83392c1b0eb6', '麟游县', 'pub', '610329', 'cskefu', NULL, '297e1e874f83129d014f83350ab6036b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:46', '2015-08-31 18:06:46', 0, 2822, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83392c260eb7', '凤　县', 'pub', '610330', 'cskefu', NULL, '297e1e874f83129d014f83350ab6036b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:46', '2015-08-31 18:06:46', 0, 2823, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83392c310eb8', '太白县', 'pub', '610331', 'cskefu', NULL, '297e1e874f83129d014f83350ab6036b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:46', '2015-08-31 18:06:46', 0, 2824, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83392c590eb9', '市辖区', 'pub', '610401', 'cskefu', NULL, '297e1e874f83129d014f83350ad3036c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:46', '2015-08-31 18:06:46', 0, 2825, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83392c640eba', '秦都区', 'pub', '610402', 'cskefu', NULL, '297e1e874f83129d014f83350ad3036c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:46', '2015-08-31 18:06:46', 0, 2826, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83392c700ebb', '杨凌区', 'pub', '610403', 'cskefu', NULL, '297e1e874f83129d014f83350ad3036c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:46', '2015-08-31 18:06:46', 0, 2827, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83392c7c0ebc', '渭城区', 'pub', '610404', 'cskefu', NULL, '297e1e874f83129d014f83350ad3036c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:46', '2015-08-31 18:06:46', 0, 2828, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83392c8b0ebd', '三原县', 'pub', '610422', 'cskefu', NULL, '297e1e874f83129d014f83350ad3036c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:46', '2015-08-31 18:06:46', 0, 2829, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83392c970ebe', '泾阳县', 'pub', '610423', 'cskefu', NULL, '297e1e874f83129d014f83350ad3036c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:46', '2015-08-31 18:06:46', 0, 2830, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83392ca50ebf', '乾　县', 'pub', '610424', 'cskefu', NULL, '297e1e874f83129d014f83350ad3036c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:46', '2015-08-31 18:06:46', 0, 2831, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83392ddd0ec1', '礼泉县', 'pub', '610425', 'cskefu', NULL, '297e1e874f83129d014f83350ad3036c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:46', '2015-08-31 18:06:46', 0, 2832, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83392de80ec2', '永寿县', 'pub', '610426', 'cskefu', NULL, '297e1e874f83129d014f83350ad3036c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:46', '2015-08-31 18:06:46', 0, 2833, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83392df30ec3', '彬　县', 'pub', '610427', 'cskefu', NULL, '297e1e874f83129d014f83350ad3036c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:46', '2015-08-31 18:06:46', 0, 2834, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83392e020ec4', '长武县', 'pub', '610428', 'cskefu', NULL, '297e1e874f83129d014f83350ad3036c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:46', '2015-08-31 18:06:46', 0, 2835, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83392e0f0ec5', '旬邑县', 'pub', '610429', 'cskefu', NULL, '297e1e874f83129d014f83350ad3036c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:46', '2015-08-31 18:06:46', 0, 2836, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83392e1a0ec6', '淳化县', 'pub', '610430', 'cskefu', NULL, '297e1e874f83129d014f83350ad3036c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:46', '2015-08-31 18:06:46', 0, 2837, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83392e260ec7', '武功县', 'pub', '610431', 'cskefu', NULL, '297e1e874f83129d014f83350ad3036c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:46', '2015-08-31 18:06:46', 0, 2838, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83392e320ec8', '兴平市', 'pub', '610481', 'cskefu', NULL, '297e1e874f83129d014f83350ad3036c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:46', '2015-08-31 18:06:46', 0, 2839, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83392f8a0ec9', '市辖区', 'pub', '610501', 'cskefu', NULL, '297e1e874f83129d014f83350ae2036d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:47', '2015-08-31 18:06:47', 0, 2840, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83392f990eca', '临渭区', 'pub', '610502', 'cskefu', NULL, '297e1e874f83129d014f83350ae2036d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:47', '2015-08-31 18:06:47', 0, 2841, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83392fa50ecb', '华　县', 'pub', '610521', 'cskefu', NULL, '297e1e874f83129d014f83350ae2036d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:47', '2015-08-31 18:06:47', 0, 2842, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83392fb40ecc', '潼关县', 'pub', '610522', 'cskefu', NULL, '297e1e874f83129d014f83350ae2036d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:47', '2015-08-31 18:06:47', 0, 2843, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83392fc20ecd', '大荔县', 'pub', '610523', 'cskefu', NULL, '297e1e874f83129d014f83350ae2036d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:47', '2015-08-31 18:06:47', 0, 2844, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83392fcd0ece', '合阳县', 'pub', '610524', 'cskefu', NULL, '297e1e874f83129d014f83350ae2036d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:47', '2015-08-31 18:06:47', 0, 2845, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83392fdf0ecf', '澄城县', 'pub', '610525', 'cskefu', NULL, '297e1e874f83129d014f83350ae2036d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:47', '2015-08-31 18:06:47', 0, 2846, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83392feb0ed0', '蒲城县', 'pub', '610526', 'cskefu', NULL, '297e1e874f83129d014f83350ae2036d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:47', '2015-08-31 18:06:47', 0, 2847, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83392ffa0ed1', '白水县', 'pub', '610527', 'cskefu', NULL, '297e1e874f83129d014f83350ae2036d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:47', '2015-08-31 18:06:47', 0, 2848, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833930060ed2', '富平县', 'pub', '610528', 'cskefu', NULL, '297e1e874f83129d014f83350ae2036d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:47', '2015-08-31 18:06:47', 0, 2849, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833930130ed3', '韩城市', 'pub', '610581', 'cskefu', NULL, '297e1e874f83129d014f83350ae2036d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:47', '2015-08-31 18:06:47', 0, 2850, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339301f0ed4', '华阴市', 'pub', '610582', 'cskefu', NULL, '297e1e874f83129d014f83350ae2036d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:47', '2015-08-31 18:06:47', 0, 2851, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833930490ed5', '市辖区', 'pub', '610601', 'cskefu', NULL, '297e1e874f83129d014f83350af0036e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:47', '2015-08-31 18:06:47', 0, 2852, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833930570ed6', '宝塔区', 'pub', '610602', 'cskefu', NULL, '297e1e874f83129d014f83350af0036e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:47', '2015-08-31 18:06:47', 0, 2853, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833930630ed7', '延长县', 'pub', '610621', 'cskefu', NULL, '297e1e874f83129d014f83350af0036e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:47', '2015-08-31 18:06:47', 0, 2854, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339319f0ed8', '延川县', 'pub', '610622', 'cskefu', NULL, '297e1e874f83129d014f83350af0036e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:47', '2015-08-31 18:06:47', 0, 2855, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833931aa0ed9', '子长县', 'pub', '610623', 'cskefu', NULL, '297e1e874f83129d014f83350af0036e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:47', '2015-08-31 18:06:47', 0, 2856, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833931b70eda', '安塞县', 'pub', '610624', 'cskefu', NULL, '297e1e874f83129d014f83350af0036e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:47', '2015-08-31 18:06:47', 0, 2857, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833931c20edb', '志丹县', 'pub', '610625', 'cskefu', NULL, '297e1e874f83129d014f83350af0036e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:47', '2015-08-31 18:06:47', 0, 2858, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833931cd0edc', '吴旗县', 'pub', '610626', 'cskefu', NULL, '297e1e874f83129d014f83350af0036e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:47', '2015-08-31 18:06:47', 0, 2859, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833931d90edd', '甘泉县', 'pub', '610627', 'cskefu', NULL, '297e1e874f83129d014f83350af0036e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:47', '2015-08-31 18:06:47', 0, 2860, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833931e40ede', '富　县', 'pub', '610628', 'cskefu', NULL, '297e1e874f83129d014f83350af0036e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:47', '2015-08-31 18:06:47', 0, 2861, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833931f20edf', '洛川县', 'pub', '610629', 'cskefu', NULL, '297e1e874f83129d014f83350af0036e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:47', '2015-08-31 18:06:47', 0, 2862, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833931fe0ee0', '宜川县', 'pub', '610630', 'cskefu', NULL, '297e1e874f83129d014f83350af0036e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:47', '2015-08-31 18:06:47', 0, 2863, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833932090ee1', '黄龙县', 'pub', '610631', 'cskefu', NULL, '297e1e874f83129d014f83350af0036e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:47', '2015-08-31 18:06:47', 0, 2864, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833932150ee2', '黄陵县', 'pub', '610632', 'cskefu', NULL, '297e1e874f83129d014f83350af0036e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:47', '2015-08-31 18:06:47', 0, 2865, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833933760ee3', '市辖区', 'pub', '610701', 'cskefu', NULL, '297e1e874f83129d014f83350afe036f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:48', '2015-08-31 18:06:48', 0, 2866, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833933820ee4', '汉台区', 'pub', '610702', 'cskefu', NULL, '297e1e874f83129d014f83350afe036f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:48', '2015-08-31 18:06:48', 0, 2867, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339338e0ee5', '南郑县', 'pub', '610721', 'cskefu', NULL, '297e1e874f83129d014f83350afe036f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:48', '2015-08-31 18:06:48', 0, 2868, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339339f0ee6', '城固县', 'pub', '610722', 'cskefu', NULL, '297e1e874f83129d014f83350afe036f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:48', '2015-08-31 18:06:48', 0, 2869, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833933ae0ee7', '洋　县', 'pub', '610723', 'cskefu', NULL, '297e1e874f83129d014f83350afe036f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:48', '2015-08-31 18:06:48', 0, 2870, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833933bc0ee8', '西乡县', 'pub', '610724', 'cskefu', NULL, '297e1e874f83129d014f83350afe036f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:48', '2015-08-31 18:06:48', 0, 2871, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833933c70ee9', '勉　县', 'pub', '610725', 'cskefu', NULL, '297e1e874f83129d014f83350afe036f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:48', '2015-08-31 18:06:48', 0, 2872, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833933d70eea', '宁强县', 'pub', '610726', 'cskefu', NULL, '297e1e874f83129d014f83350afe036f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:48', '2015-08-31 18:06:48', 0, 2873, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833933e30eeb', '略阳县', 'pub', '610727', 'cskefu', NULL, '297e1e874f83129d014f83350afe036f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:48', '2015-08-31 18:06:48', 0, 2874, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833933ee0eec', '镇巴县', 'pub', '610728', 'cskefu', NULL, '297e1e874f83129d014f83350afe036f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:48', '2015-08-31 18:06:48', 0, 2875, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833933f90eed', '留坝县', 'pub', '610729', 'cskefu', NULL, '297e1e874f83129d014f83350afe036f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:48', '2015-08-31 18:06:48', 0, 2876, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833934040eee', '佛坪县', 'pub', '610730', 'cskefu', NULL, '297e1e874f83129d014f83350afe036f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:48', '2015-08-31 18:06:48', 0, 2877, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833934300eef', '市辖区', 'pub', '610801', 'cskefu', NULL, '297e1e874f83129d014f83350b0b0370', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:48', '2015-08-31 18:06:48', 0, 2878, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339343f0ef0', '榆阳区', 'pub', '610802', 'cskefu', NULL, '297e1e874f83129d014f83350b0b0370', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:48', '2015-08-31 18:06:48', 0, 2879, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339344b0ef1', '神木县', 'pub', '610821', 'cskefu', NULL, '297e1e874f83129d014f83350b0b0370', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:48', '2015-08-31 18:06:48', 0, 2880, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833935830ef2', '府谷县', 'pub', '610822', 'cskefu', NULL, '297e1e874f83129d014f83350b0b0370', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:48', '2015-08-31 18:06:48', 0, 2881, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339358f0ef3', '横山县', 'pub', '610823', 'cskefu', NULL, '297e1e874f83129d014f83350b0b0370', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:48', '2015-08-31 18:06:48', 0, 2882, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339359c0ef4', '靖边县', 'pub', '610824', 'cskefu', NULL, '297e1e874f83129d014f83350b0b0370', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:48', '2015-08-31 18:06:48', 0, 2883, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833935a80ef5', '定边县', 'pub', '610825', 'cskefu', NULL, '297e1e874f83129d014f83350b0b0370', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:48', '2015-08-31 18:06:48', 0, 2884, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833935b40ef6', '绥德县', 'pub', '610826', 'cskefu', NULL, '297e1e874f83129d014f83350b0b0370', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:48', '2015-08-31 18:06:48', 0, 2885, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833935bf0ef7', '米脂县', 'pub', '610827', 'cskefu', NULL, '297e1e874f83129d014f83350b0b0370', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:48', '2015-08-31 18:06:48', 0, 2886, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833935ce0ef8', '佳　县', 'pub', '610828', 'cskefu', NULL, '297e1e874f83129d014f83350b0b0370', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:48', '2015-08-31 18:06:48', 0, 2887, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833935d90ef9', '吴堡县', 'pub', '610829', 'cskefu', NULL, '297e1e874f83129d014f83350b0b0370', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:48', '2015-08-31 18:06:48', 0, 2888, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833935e70efa', '清涧县', 'pub', '610830', 'cskefu', NULL, '297e1e874f83129d014f83350b0b0370', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:48', '2015-08-31 18:06:48', 0, 2889, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833935f20efb', '子洲县', 'pub', '610831', 'cskefu', NULL, '297e1e874f83129d014f83350b0b0370', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:48', '2015-08-31 18:06:48', 0, 2890, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339361c0efc', '市辖区', 'pub', '610901', 'cskefu', NULL, '297e1e874f83129d014f83350b170371', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:48', '2015-08-31 18:06:48', 0, 2891, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833937620efd', '汉滨区', 'pub', '610902', 'cskefu', NULL, '297e1e874f83129d014f83350b170371', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:49', '2015-08-31 18:06:49', 0, 2892, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833937740efe', '汉阴县', 'pub', '610921', 'cskefu', NULL, '297e1e874f83129d014f83350b170371', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:49', '2015-08-31 18:06:49', 0, 2893, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833937820eff', '石泉县', 'pub', '610922', 'cskefu', NULL, '297e1e874f83129d014f83350b170371', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:49', '2015-08-31 18:06:49', 0, 2894, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339378f0f00', '宁陕县', 'pub', '610923', 'cskefu', NULL, '297e1e874f83129d014f83350b170371', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:49', '2015-08-31 18:06:49', 0, 2895, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339379b0f01', '紫阳县', 'pub', '610924', 'cskefu', NULL, '297e1e874f83129d014f83350b170371', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:49', '2015-08-31 18:06:49', 0, 2896, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833937a70f02', '岚皋县', 'pub', '610925', 'cskefu', NULL, '297e1e874f83129d014f83350b170371', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:49', '2015-08-31 18:06:49', 0, 2897, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833937b30f03', '平利县', 'pub', '610926', 'cskefu', NULL, '297e1e874f83129d014f83350b170371', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:49', '2015-08-31 18:06:49', 0, 2898, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833937bf0f04', '镇坪县', 'pub', '610927', 'cskefu', NULL, '297e1e874f83129d014f83350b170371', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:49', '2015-08-31 18:06:49', 0, 2899, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833937cd0f05', '旬阳县', 'pub', '610928', 'cskefu', NULL, '297e1e874f83129d014f83350b170371', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:49', '2015-08-31 18:06:49', 0, 2900, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833937d80f06', '白河县', 'pub', '610929', 'cskefu', NULL, '297e1e874f83129d014f83350b170371', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:49', '2015-08-31 18:06:49', 0, 2901, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833938030f07', '市辖区', 'pub', '611001', 'cskefu', NULL, '297e1e874f83129d014f83350c540372', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:49', '2015-08-31 18:06:49', 0, 2902, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339381a0f08', '商州区', 'pub', '611002', 'cskefu', NULL, '297e1e874f83129d014f83350c540372', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:49', '2015-08-31 18:06:49', 0, 2903, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833938330f09', '洛南县', 'pub', '611021', 'cskefu', NULL, '297e1e874f83129d014f83350c540372', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:49', '2015-08-31 18:06:49', 0, 2904, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833938450f0a', '丹凤县', 'pub', '611022', 'cskefu', NULL, '297e1e874f83129d014f83350c540372', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:49', '2015-08-31 18:06:49', 0, 2905, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833938520f0b', '商南县', 'pub', '611023', 'cskefu', NULL, '297e1e874f83129d014f83350c540372', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:49', '2015-08-31 18:06:49', 0, 2906, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339398e0f0c', '山阳县', 'pub', '611024', 'cskefu', NULL, '297e1e874f83129d014f83350c540372', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:49', '2015-08-31 18:06:49', 0, 2907, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339399c0f0d', '镇安县', 'pub', '611025', 'cskefu', NULL, '297e1e874f83129d014f83350c540372', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:49', '2015-08-31 18:06:49', 0, 2908, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833939a90f0e', '柞水县', 'pub', '611026', 'cskefu', NULL, '297e1e874f83129d014f83350c540372', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:49', '2015-08-31 18:06:49', 0, 2909, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833939d20f0f', '市辖区', 'pub', '620101', 'cskefu', NULL, '297e1e874f83129d014f83350c7b0373', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:49', '2015-08-31 18:06:49', 0, 2910, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833939de0f10', '城关区', 'pub', '620102', 'cskefu', NULL, '297e1e874f83129d014f83350c7b0373', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:49', '2015-08-31 18:06:49', 0, 2911, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833939ee0f11', '七里河区', 'pub', '620103', 'cskefu', NULL, '297e1e874f83129d014f83350c7b0373', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:49', '2015-08-31 18:06:49', 0, 2912, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833939fe0f12', '西固区', 'pub', '620104', 'cskefu', NULL, '297e1e874f83129d014f83350c7b0373', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:49', '2015-08-31 18:06:49', 0, 2913, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83393a090f13', '安宁区', 'pub', '620105', 'cskefu', NULL, '297e1e874f83129d014f83350c7b0373', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:49', '2015-08-31 18:06:49', 0, 2914, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83393a140f14', '红古区', 'pub', '620111', 'cskefu', NULL, '297e1e874f83129d014f83350c7b0373', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:49', '2015-08-31 18:06:49', 0, 2915, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83393a210f15', '永登县', 'pub', '620121', 'cskefu', NULL, '297e1e874f83129d014f83350c7b0373', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:49', '2015-08-31 18:06:49', 0, 2916, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83393a310f16', '皋兰县', 'pub', '620122', 'cskefu', NULL, '297e1e874f83129d014f83350c7b0373', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:49', '2015-08-31 18:06:49', 0, 2917, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83393a3d0f17', '榆中县', 'pub', '620123', 'cskefu', NULL, '297e1e874f83129d014f83350c7b0373', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:49', '2015-08-31 18:06:49', 0, 2918, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83393b930f18', '市辖区', 'pub', '620201', 'cskefu', NULL, '297e1e874f83129d014f83350c890374', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:50', '2015-08-31 18:06:50', 0, 2919, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83393bbf0f19', '市辖区', 'pub', '620301', 'cskefu', NULL, '297e1e874f83129d014f83350c960375', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:50', '2015-08-31 18:06:50', 0, 2920, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83393bcf0f1a', '金川区', 'pub', '620302', 'cskefu', NULL, '297e1e874f83129d014f83350c960375', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:50', '2015-08-31 18:06:50', 0, 2921, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83393bdc0f1b', '永昌县', 'pub', '620321', 'cskefu', NULL, '297e1e874f83129d014f83350c960375', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:50', '2015-08-31 18:06:50', 0, 2922, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83393c030f1c', '市辖区', 'pub', '620401', 'cskefu', NULL, '297e1e874f83129d014f83350ca40376', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:50', '2015-08-31 18:06:50', 0, 2923, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83393c0f0f1d', '白银区', 'pub', '620402', 'cskefu', NULL, '297e1e874f83129d014f83350ca40376', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:50', '2015-08-31 18:06:50', 0, 2924, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83393c610f1e', '平川区', 'pub', '620403', 'cskefu', NULL, '297e1e874f83129d014f83350ca40376', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:50', '2015-08-31 18:06:50', 0, 2925, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83393c710f1f', '靖远县', 'pub', '620421', 'cskefu', NULL, '297e1e874f83129d014f83350ca40376', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:50', '2015-08-31 18:06:50', 0, 2926, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83393c840f20', '会宁县', 'pub', '620422', 'cskefu', NULL, '297e1e874f83129d014f83350ca40376', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:50', '2015-08-31 18:06:50', 0, 2927, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83393c900f21', '景泰县', 'pub', '620423', 'cskefu', NULL, '297e1e874f83129d014f83350ca40376', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:50', '2015-08-31 18:06:50', 0, 2928, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83393cb70f22', '市辖区', 'pub', '620501', 'cskefu', NULL, '297e1e874f83129d014f83350cb10377', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:50', '2015-08-31 18:06:50', 0, 2929, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83393df00f23', '秦城区', 'pub', '620502', 'cskefu', NULL, '297e1e874f83129d014f83350cb10377', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:50', '2015-08-31 18:06:50', 0, 2930, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83393e030f24', '北道区', 'pub', '620503', 'cskefu', NULL, '297e1e874f83129d014f83350cb10377', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:50', '2015-08-31 18:06:50', 0, 2931, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83393e130f25', '清水县', 'pub', '620521', 'cskefu', NULL, '297e1e874f83129d014f83350cb10377', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:50', '2015-08-31 18:06:50', 0, 2932, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83393e1f0f26', '秦安县', 'pub', '620522', 'cskefu', NULL, '297e1e874f83129d014f83350cb10377', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:50', '2015-08-31 18:06:50', 0, 2933, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83393e2c0f27', '甘谷县', 'pub', '620523', 'cskefu', NULL, '297e1e874f83129d014f83350cb10377', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:50', '2015-08-31 18:06:50', 0, 2934, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83393e3c0f28', '武山县', 'pub', '620524', 'cskefu', NULL, '297e1e874f83129d014f83350cb10377', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:50', '2015-08-31 18:06:50', 0, 2935, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83393e4a0f29', '张家川回族自治县', 'pub', '620525', 'cskefu', NULL, '297e1e874f83129d014f83350cb10377', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:50', '2015-08-31 18:06:50', 0, 2936, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83393e720f2a', '市辖区', 'pub', '620601', 'cskefu', NULL, '297e1e874f83129d014f83350cc20378', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:50', '2015-08-31 18:06:50', 0, 2937, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83393e800f2b', '凉州区', 'pub', '620602', 'cskefu', NULL, '297e1e874f83129d014f83350cc20378', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:51', '2015-08-31 18:06:51', 0, 2938, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83393e8c0f2c', '民勤县', 'pub', '620621', 'cskefu', NULL, '297e1e874f83129d014f83350cc20378', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:51', '2015-08-31 18:06:51', 0, 2939, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83393e990f2d', '古浪县', 'pub', '620622', 'cskefu', NULL, '297e1e874f83129d014f83350cc20378', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:51', '2015-08-31 18:06:51', 0, 2940, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83393ea60f2e', '天祝藏族自治县', 'pub', '620623', 'cskefu', NULL, '297e1e874f83129d014f83350cc20378', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:51', '2015-08-31 18:06:51', 0, 2941, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83393ff70f2f', '市辖区', 'pub', '620701', 'cskefu', NULL, '297e1e874f83129d014f83350cd10379', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:51', '2015-08-31 18:06:51', 0, 2942, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833940030f30', '甘州区', 'pub', '620702', 'cskefu', NULL, '297e1e874f83129d014f83350cd10379', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:51', '2015-08-31 18:06:51', 0, 2943, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339400e0f31', '肃南裕固族自治县', 'pub', '620721', 'cskefu', NULL, '297e1e874f83129d014f83350cd10379', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:51', '2015-08-31 18:06:51', 0, 2944, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339401a0f32', '民乐县', 'pub', '620722', 'cskefu', NULL, '297e1e874f83129d014f83350cd10379', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:51', '2015-08-31 18:06:51', 0, 2945, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833940280f33', '临泽县', 'pub', '620723', 'cskefu', NULL, '297e1e874f83129d014f83350cd10379', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:51', '2015-08-31 18:06:51', 0, 2946, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833940330f34', '高台县', 'pub', '620724', 'cskefu', NULL, '297e1e874f83129d014f83350cd10379', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:51', '2015-08-31 18:06:51', 0, 2947, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833940440f35', '山丹县', 'pub', '620725', 'cskefu', NULL, '297e1e874f83129d014f83350cd10379', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:51', '2015-08-31 18:06:51', 0, 2948, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339406b0f36', '市辖区', 'pub', '620801', 'cskefu', NULL, '297e1e874f83129d014f83350cde037a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:51', '2015-08-31 18:06:51', 0, 2949, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833940790f37', '崆峒区', 'pub', '620802', 'cskefu', NULL, '297e1e874f83129d014f83350cde037a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:51', '2015-08-31 18:06:51', 0, 2950, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339408e0f38', '泾川县', 'pub', '620821', 'cskefu', NULL, '297e1e874f83129d014f83350cde037a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:51', '2015-08-31 18:06:51', 0, 2951, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339409a0f39', '灵台县', 'pub', '620822', 'cskefu', NULL, '297e1e874f83129d014f83350cde037a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:51', '2015-08-31 18:06:51', 0, 2952, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833940a70f3a', '崇信县', 'pub', '620823', 'cskefu', NULL, '297e1e874f83129d014f83350cde037a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:51', '2015-08-31 18:06:51', 0, 2953, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833941e00f3c', '华亭县', 'pub', '620824', 'cskefu', NULL, '297e1e874f83129d014f83350cde037a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:51', '2015-08-31 18:06:51', 0, 2954, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833941ec0f3d', '庄浪县', 'pub', '620825', 'cskefu', NULL, '297e1e874f83129d014f83350cde037a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:51', '2015-08-31 18:06:51', 0, 2955, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833941f80f3e', '静宁县', 'pub', '620826', 'cskefu', NULL, '297e1e874f83129d014f83350cde037a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:51', '2015-08-31 18:06:51', 0, 2956, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833942210f3f', '市辖区', 'pub', '620901', 'cskefu', NULL, '297e1e874f83129d014f83350cec037b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:51', '2015-08-31 18:06:51', 0, 2957, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339422e0f40', '肃州区', 'pub', '620902', 'cskefu', NULL, '297e1e874f83129d014f83350cec037b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:51', '2015-08-31 18:06:51', 0, 2958, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339423b0f41', '金塔县', 'pub', '620921', 'cskefu', NULL, '297e1e874f83129d014f83350cec037b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:51', '2015-08-31 18:06:51', 0, 2959, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339424a0f42', '安西县', 'pub', '620922', 'cskefu', NULL, '297e1e874f83129d014f83350cec037b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:51', '2015-08-31 18:06:51', 0, 2960, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833942580f43', '肃北蒙古族自治县', 'pub', '620923', 'cskefu', NULL, '297e1e874f83129d014f83350cec037b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:51', '2015-08-31 18:06:51', 0, 2961, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833942640f44', '阿克塞哈萨克族自治县', 'pub', '620924', 'cskefu', NULL, '297e1e874f83129d014f83350cec037b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:52', '2015-08-31 18:06:52', 0, 2962, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833942700f45', '玉门市', 'pub', '620981', 'cskefu', NULL, '297e1e874f83129d014f83350cec037b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:52', '2015-08-31 18:06:52', 0, 2963, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339427b0f46', '敦煌市', 'pub', '620982', 'cskefu', NULL, '297e1e874f83129d014f83350cec037b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:52', '2015-08-31 18:06:52', 0, 2964, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833943cf0f47', '市辖区', 'pub', '621001', 'cskefu', NULL, '297e1e874f83129d014f83350cf9037c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:52', '2015-08-31 18:06:52', 0, 2965, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833943db0f48', '西峰区', 'pub', '621002', 'cskefu', NULL, '297e1e874f83129d014f83350cf9037c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:52', '2015-08-31 18:06:52', 0, 2966, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833943e70f49', '庆城县', 'pub', '621021', 'cskefu', NULL, '297e1e874f83129d014f83350cf9037c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:52', '2015-08-31 18:06:52', 0, 2967, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833943f30f4a', '环　县', 'pub', '621022', 'cskefu', NULL, '297e1e874f83129d014f83350cf9037c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:52', '2015-08-31 18:06:52', 0, 2968, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833943ff0f4b', '华池县', 'pub', '621023', 'cskefu', NULL, '297e1e874f83129d014f83350cf9037c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:52', '2015-08-31 18:06:52', 0, 2969, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339440a0f4c', '合水县', 'pub', '621024', 'cskefu', NULL, '297e1e874f83129d014f83350cf9037c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:52', '2015-08-31 18:06:52', 0, 2970, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339441c0f4d', '正宁县', 'pub', '621025', 'cskefu', NULL, '297e1e874f83129d014f83350cf9037c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:52', '2015-08-31 18:06:52', 0, 2971, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339442c0f4e', '宁　县', 'pub', '621026', 'cskefu', NULL, '297e1e874f83129d014f83350cf9037c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:52', '2015-08-31 18:06:52', 0, 2972, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833944390f4f', '镇原县', 'pub', '621027', 'cskefu', NULL, '297e1e874f83129d014f83350cf9037c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:52', '2015-08-31 18:06:52', 0, 2973, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833944620f50', '市辖区', 'pub', '621101', 'cskefu', NULL, '297e1e874f83129d014f83350d09037d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:52', '2015-08-31 18:06:52', 0, 2974, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339446e0f51', '安定区', 'pub', '621102', 'cskefu', NULL, '297e1e874f83129d014f83350d09037d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:52', '2015-08-31 18:06:52', 0, 2975, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833945be0f52', '通渭县', 'pub', '621121', 'cskefu', NULL, '297e1e874f83129d014f83350d09037d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:52', '2015-08-31 18:06:52', 0, 2976, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833945e30f53', '陇西县', 'pub', '621122', 'cskefu', NULL, '297e1e874f83129d014f83350d09037d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:52', '2015-08-31 18:06:52', 0, 2977, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339460d0f54', '渭源县', 'pub', '621123', 'cskefu', NULL, '297e1e874f83129d014f83350d09037d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:52', '2015-08-31 18:06:52', 0, 2978, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339461b0f55', '临洮县', 'pub', '621124', 'cskefu', NULL, '297e1e874f83129d014f83350d09037d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:52', '2015-08-31 18:06:52', 0, 2979, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833946270f56', '漳　县', 'pub', '621125', 'cskefu', NULL, '297e1e874f83129d014f83350d09037d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:52', '2015-08-31 18:06:52', 0, 2980, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833946350f57', '岷　县', 'pub', '621126', 'cskefu', NULL, '297e1e874f83129d014f83350d09037d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:52', '2015-08-31 18:06:52', 0, 2981, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339465a0f58', '市辖区', 'pub', '621201', 'cskefu', NULL, '297e1e874f83129d014f83350d19037e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:53', '2015-08-31 18:06:53', 0, 2982, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833946690f59', '武都区', 'pub', '621202', 'cskefu', NULL, '297e1e874f83129d014f83350d19037e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:53', '2015-08-31 18:06:53', 0, 2983, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833946760f5a', '成　县', 'pub', '621221', 'cskefu', NULL, '297e1e874f83129d014f83350d19037e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:53', '2015-08-31 18:06:53', 0, 2984, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833946820f5b', '文　县', 'pub', '621222', 'cskefu', NULL, '297e1e874f83129d014f83350d19037e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:53', '2015-08-31 18:06:53', 0, 2985, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339469a0f5c', '宕昌县', 'pub', '621223', 'cskefu', NULL, '297e1e874f83129d014f83350d19037e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:53', '2015-08-31 18:06:53', 0, 2986, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833946aa0f5d', '康　县', 'pub', '621224', 'cskefu', NULL, '297e1e874f83129d014f83350d19037e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:53', '2015-08-31 18:06:53', 0, 2987, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833946b80f5e', '西和县', 'pub', '621225', 'cskefu', NULL, '297e1e874f83129d014f83350d19037e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:53', '2015-08-31 18:06:53', 0, 2988, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833946c60f5f', '礼　县', 'pub', '621226', 'cskefu', NULL, '297e1e874f83129d014f83350d19037e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:53', '2015-08-31 18:06:53', 0, 2989, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833946d20f60', '徽　县', 'pub', '621227', 'cskefu', NULL, '297e1e874f83129d014f83350d19037e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:53', '2015-08-31 18:06:53', 0, 2990, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833946e00f61', '两当县', 'pub', '621228', 'cskefu', NULL, '297e1e874f83129d014f83350d19037e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:53', '2015-08-31 18:06:53', 0, 2991, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833948360f62', '临夏市', 'pub', '622901', 'cskefu', NULL, '297e1e874f83129d014f83350e53037f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:53', '2015-08-31 18:06:53', 0, 2992, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833948470f63', '临夏县', 'pub', '622921', 'cskefu', NULL, '297e1e874f83129d014f83350e53037f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:53', '2015-08-31 18:06:53', 0, 2993, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833948540f64', '康乐县', 'pub', '622922', 'cskefu', NULL, '297e1e874f83129d014f83350e53037f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:53', '2015-08-31 18:06:53', 0, 2994, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833948600f65', '永靖县', 'pub', '622923', 'cskefu', NULL, '297e1e874f83129d014f83350e53037f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:53', '2015-08-31 18:06:53', 0, 2995, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339486d0f66', '广河县', 'pub', '622924', 'cskefu', NULL, '297e1e874f83129d014f83350e53037f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:53', '2015-08-31 18:06:53', 0, 2996, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339487a0f67', '和政县', 'pub', '622925', 'cskefu', NULL, '297e1e874f83129d014f83350e53037f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:53', '2015-08-31 18:06:53', 0, 2997, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833948860f68', '东乡族自治县', 'pub', '622926', 'cskefu', NULL, '297e1e874f83129d014f83350e53037f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:53', '2015-08-31 18:06:53', 0, 2998, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833948910f69', '积石山保安族东乡族撒拉族自治县', 'pub', '622927', 'cskefu', NULL, '297e1e874f83129d014f83350e53037f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:53', '2015-08-31 18:06:53', 0, 2999, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833948be0f6a', '合作市', 'pub', '623001', 'cskefu', NULL, '297e1e874f83129d014f83350e600380', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:53', '2015-08-31 18:06:53', 0, 3000, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833948ca0f6b', '临潭县', 'pub', '623021', 'cskefu', NULL, '297e1e874f83129d014f83350e600380', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:53', '2015-08-31 18:06:53', 0, 3001, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833948d40f6c', '卓尼县', 'pub', '623022', 'cskefu', NULL, '297e1e874f83129d014f83350e600380', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:53', '2015-08-31 18:06:53', 0, 3002, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83394a0c0f6d', '舟曲县', 'pub', '623023', 'cskefu', NULL, '297e1e874f83129d014f83350e600380', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:53', '2015-08-31 18:06:53', 0, 3003, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83394a1a0f6e', '迭部县', 'pub', '623024', 'cskefu', NULL, '297e1e874f83129d014f83350e600380', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:53', '2015-08-31 18:06:53', 0, 3004, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83394a280f6f', '玛曲县', 'pub', '623025', 'cskefu', NULL, '297e1e874f83129d014f83350e600380', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:53', '2015-08-31 18:06:53', 0, 3005, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83394a330f70', '碌曲县', 'pub', '623026', 'cskefu', NULL, '297e1e874f83129d014f83350e600380', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:54', '2015-08-31 18:06:54', 0, 3006, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83394a400f71', '夏河县', 'pub', '623027', 'cskefu', NULL, '297e1e874f83129d014f83350e600380', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:54', '2015-08-31 18:06:54', 0, 3007, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83394a660f72', '市辖区', 'pub', '630101', 'cskefu', NULL, '297e1e874f83129d014f83350e890381', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:54', '2015-08-31 18:06:54', 0, 3008, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83394a730f73', '城东区', 'pub', '630102', 'cskefu', NULL, '297e1e874f83129d014f83350e890381', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:54', '2015-08-31 18:06:54', 0, 3009, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83394a820f74', '城中区', 'pub', '630103', 'cskefu', NULL, '297e1e874f83129d014f83350e890381', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:54', '2015-08-31 18:06:54', 0, 3010, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83394a8e0f75', '城西区', 'pub', '630104', 'cskefu', NULL, '297e1e874f83129d014f83350e890381', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:54', '2015-08-31 18:06:54', 0, 3011, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83394a9a0f76', '城北区', 'pub', '630105', 'cskefu', NULL, '297e1e874f83129d014f83350e890381', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:54', '2015-08-31 18:06:54', 0, 3012, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83394aa60f77', '大通回族土族自治县', 'pub', '630121', 'cskefu', NULL, '297e1e874f83129d014f83350e890381', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:54', '2015-08-31 18:06:54', 0, 3013, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83394ab50f78', '湟中县', 'pub', '630122', 'cskefu', NULL, '297e1e874f83129d014f83350e890381', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:54', '2015-08-31 18:06:54', 0, 3014, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83394bee0f79', '湟源县', 'pub', '630123', 'cskefu', NULL, '297e1e874f83129d014f83350e890381', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:54', '2015-08-31 18:06:54', 0, 3015, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83394c130f7a', '平安县', 'pub', '632121', 'cskefu', NULL, '297e1e874f83129d014f83350e990382', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:54', '2015-08-31 18:06:54', 0, 3016, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83394c1f0f7b', '民和回族土族自治县', 'pub', '632122', 'cskefu', NULL, '297e1e874f83129d014f83350e990382', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:54', '2015-08-31 18:06:54', 0, 3017, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83394c2b0f7c', '乐都县', 'pub', '632123', 'cskefu', NULL, '297e1e874f83129d014f83350e990382', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:54', '2015-08-31 18:06:54', 0, 3018, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83394c350f7d', '互助土族自治县', 'pub', '632126', 'cskefu', NULL, '297e1e874f83129d014f83350e990382', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:54', '2015-08-31 18:06:54', 0, 3019, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83394c440f7e', '化隆回族自治县', 'pub', '632127', 'cskefu', NULL, '297e1e874f83129d014f83350e990382', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:54', '2015-08-31 18:06:54', 0, 3020, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83394c4f0f7f', '循化撒拉族自治县', 'pub', '632128', 'cskefu', NULL, '297e1e874f83129d014f83350e990382', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:54', '2015-08-31 18:06:54', 0, 3021, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83394c770f80', '门源回族自治县', 'pub', '632221', 'cskefu', NULL, '297e1e874f83129d014f83350ea80383', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:54', '2015-08-31 18:06:54', 0, 3022, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83394c840f81', '祁连县', 'pub', '632222', 'cskefu', NULL, '297e1e874f83129d014f83350ea80383', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:54', '2015-08-31 18:06:54', 0, 3023, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83394c8f0f82', '海晏县', 'pub', '632223', 'cskefu', NULL, '297e1e874f83129d014f83350ea80383', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:54', '2015-08-31 18:06:54', 0, 3024, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83394c9d0f83', '刚察县', 'pub', '632224', 'cskefu', NULL, '297e1e874f83129d014f83350ea80383', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:54', '2015-08-31 18:06:54', 0, 3025, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83394df30f84', '同仁县', 'pub', '632321', 'cskefu', NULL, '297e1e874f83129d014f83350eb90384', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:54', '2015-08-31 18:06:54', 0, 3026, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83394dff0f85', '尖扎县', 'pub', '632322', 'cskefu', NULL, '297e1e874f83129d014f83350eb90384', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:54', '2015-08-31 18:06:54', 0, 3027, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83394e0a0f86', '泽库县', 'pub', '632323', 'cskefu', NULL, '297e1e874f83129d014f83350eb90384', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:54', '2015-08-31 18:06:54', 0, 3028, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83394e160f87', '河南蒙古族自治县', 'pub', '632324', 'cskefu', NULL, '297e1e874f83129d014f83350eb90384', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:54', '2015-08-31 18:06:54', 0, 3029, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83394e410f88', '共和县', 'pub', '632521', 'cskefu', NULL, '297e1e874f83129d014f83350ec60385', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:55', '2015-08-31 18:06:55', 0, 3030, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83394e4e0f89', '同德县', 'pub', '632522', 'cskefu', NULL, '297e1e874f83129d014f83350ec60385', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:55', '2015-08-31 18:06:55', 0, 3031, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83394e5a0f8a', '贵德县', 'pub', '632523', 'cskefu', NULL, '297e1e874f83129d014f83350ec60385', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:55', '2015-08-31 18:06:55', 0, 3032, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83394e660f8b', '兴海县', 'pub', '632524', 'cskefu', NULL, '297e1e874f83129d014f83350ec60385', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:55', '2015-08-31 18:06:55', 0, 3033, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83394e720f8c', '贵南县', 'pub', '632525', 'cskefu', NULL, '297e1e874f83129d014f83350ec60385', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:55', '2015-08-31 18:06:55', 0, 3034, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83394e9d0f8d', '玛沁县', 'pub', '632621', 'cskefu', NULL, '297e1e874f83129d014f83350ed80386', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:55', '2015-08-31 18:06:55', 0, 3035, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83394fd70f8e', '班玛县', 'pub', '632622', 'cskefu', NULL, '297e1e874f83129d014f83350ed80386', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:55', '2015-08-31 18:06:55', 0, 3036, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83394fe10f8f', '甘德县', 'pub', '632623', 'cskefu', NULL, '297e1e874f83129d014f83350ed80386', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:55', '2015-08-31 18:06:55', 0, 3037, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83394fec0f90', '达日县', 'pub', '632624', 'cskefu', NULL, '297e1e874f83129d014f83350ed80386', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:55', '2015-08-31 18:06:55', 0, 3038, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83394ff80f91', '久治县', 'pub', '632625', 'cskefu', NULL, '297e1e874f83129d014f83350ed80386', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:55', '2015-08-31 18:06:55', 0, 3039, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833950030f92', '玛多县', 'pub', '632626', 'cskefu', NULL, '297e1e874f83129d014f83350ed80386', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:55', '2015-08-31 18:06:55', 0, 3040, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339502e0f93', '玉树县', 'pub', '632721', 'cskefu', NULL, '297e1e874f83129d014f83350ee90387', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:55', '2015-08-31 18:06:55', 0, 3041, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339503a0f94', '杂多县', 'pub', '632722', 'cskefu', NULL, '297e1e874f83129d014f83350ee90387', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:55', '2015-08-31 18:06:55', 0, 3042, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833950460f95', '称多县', 'pub', '632723', 'cskefu', NULL, '297e1e874f83129d014f83350ee90387', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:55', '2015-08-31 18:06:55', 0, 3043, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833950520f96', '治多县', 'pub', '632724', 'cskefu', NULL, '297e1e874f83129d014f83350ee90387', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:55', '2015-08-31 18:06:55', 0, 3044, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339505f0f97', '囊谦县', 'pub', '632725', 'cskefu', NULL, '297e1e874f83129d014f83350ee90387', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:55', '2015-08-31 18:06:55', 0, 3045, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339506f0f98', '曲麻莱县', 'pub', '632726', 'cskefu', NULL, '297e1e874f83129d014f83350ee90387', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:55', '2015-08-31 18:06:55', 0, 3046, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833951db0f99', '格尔木市', 'pub', '632801', 'cskefu', NULL, '297e1e874f83129d014f83350efd0388', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:55', '2015-08-31 18:06:55', 0, 3047, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833951e80f9a', '德令哈市', 'pub', '632802', 'cskefu', NULL, '297e1e874f83129d014f83350efd0388', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:55', '2015-08-31 18:06:55', 0, 3048, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833951f50f9b', '乌兰县', 'pub', '632821', 'cskefu', NULL, '297e1e874f83129d014f83350efd0388', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:55', '2015-08-31 18:06:55', 0, 3049, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833952020f9c', '都兰县', 'pub', '632822', 'cskefu', NULL, '297e1e874f83129d014f83350efd0388', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:56', '2015-08-31 18:06:56', 0, 3050, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339520e0f9d', '天峻县', 'pub', '632823', 'cskefu', NULL, '297e1e874f83129d014f83350efd0388', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:56', '2015-08-31 18:06:56', 0, 3051, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833952400f9e', '市辖区', 'pub', '640101', 'cskefu', NULL, '297e1e874f83129d014f83350f24038a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:56', '2015-08-31 18:06:56', 0, 3052, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339524d0f9f', '兴庆区', 'pub', '640104', 'cskefu', NULL, '297e1e874f83129d014f83350f24038a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:56', '2015-08-31 18:06:56', 0, 3053, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339525a0fa0', '西夏区', 'pub', '640105', 'cskefu', NULL, '297e1e874f83129d014f83350f24038a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:56', '2015-08-31 18:06:56', 0, 3054, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833952660fa1', '金凤区', 'pub', '640106', 'cskefu', NULL, '297e1e874f83129d014f83350f24038a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:56', '2015-08-31 18:06:56', 0, 3055, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833952730fa2', '永宁县', 'pub', '640121', 'cskefu', NULL, '297e1e874f83129d014f83350f24038a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:56', '2015-08-31 18:06:56', 0, 3056, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833952820fa3', '贺兰县', 'pub', '640122', 'cskefu', NULL, '297e1e874f83129d014f83350f24038a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:56', '2015-08-31 18:06:56', 0, 3057, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339528f0fa4', '灵武市', 'pub', '640181', 'cskefu', NULL, '297e1e874f83129d014f83350f24038a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:56', '2015-08-31 18:06:56', 0, 3058, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833953e30fa5', '市辖区', 'pub', '640201', 'cskefu', NULL, '297e1e874f83129d014f8335105f038b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:56', '2015-08-31 18:06:56', 0, 3059, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833953f10fa6', '大武口区', 'pub', '640202', 'cskefu', NULL, '297e1e874f83129d014f8335105f038b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:56', '2015-08-31 18:06:56', 0, 3060, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833953ff0fa7', '惠农区', 'pub', '640205', 'cskefu', NULL, '297e1e874f83129d014f8335105f038b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:56', '2015-08-31 18:06:56', 0, 3061, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339540f0fa8', '平罗县', 'pub', '640221', 'cskefu', NULL, '297e1e874f83129d014f8335105f038b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:56', '2015-08-31 18:06:56', 0, 3062, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339543f0fa9', '市辖区', 'pub', '640301', 'cskefu', NULL, '297e1e874f83129d014f8335106f038c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:56', '2015-08-31 18:06:56', 0, 3063, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339544b0faa', '利通区', 'pub', '640302', 'cskefu', NULL, '297e1e874f83129d014f8335106f038c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:56', '2015-08-31 18:06:56', 0, 3064, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833954590fab', '盐池县', 'pub', '640323', 'cskefu', NULL, '297e1e874f83129d014f8335106f038c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:56', '2015-08-31 18:06:56', 0, 3065, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833954670fac', '同心县', 'pub', '640324', 'cskefu', NULL, '297e1e874f83129d014f8335106f038c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:56', '2015-08-31 18:06:56', 0, 3066, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833954740fad', '青铜峡市', 'pub', '640381', 'cskefu', NULL, '297e1e874f83129d014f8335106f038c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:56', '2015-08-31 18:06:56', 0, 3067, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339549d0fae', '市辖区', 'pub', '640401', 'cskefu', NULL, '297e1e874f83129d014f83351081038d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:56', '2015-08-31 18:06:56', 0, 3068, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833954a80faf', '原州区', 'pub', '640402', 'cskefu', NULL, '297e1e874f83129d014f83351081038d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:56', '2015-08-31 18:06:56', 0, 3069, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833954b70fb0', '西吉县', 'pub', '640422', 'cskefu', NULL, '297e1e874f83129d014f83351081038d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:56', '2015-08-31 18:06:56', 0, 3070, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833954c30fb1', '隆德县', 'pub', '640423', 'cskefu', NULL, '297e1e874f83129d014f83351081038d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:56', '2015-08-31 18:06:56', 0, 3071, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833955fc0fb3', '泾源县', 'pub', '640424', 'cskefu', NULL, '297e1e874f83129d014f83351081038d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:57', '2015-08-31 18:06:57', 0, 3072, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833956080fb4', '彭阳县', 'pub', '640425', 'cskefu', NULL, '297e1e874f83129d014f83351081038d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:57', '2015-08-31 18:06:57', 0, 3073, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833956370fb5', '市辖区', 'pub', '640501', 'cskefu', NULL, '297e1e874f83129d014f83351091038e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:57', '2015-08-31 18:06:57', 0, 3074, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833956450fb6', '沙坡头区', 'pub', '640502', 'cskefu', NULL, '297e1e874f83129d014f83351091038e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:57', '2015-08-31 18:06:57', 0, 3075, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833956540fb7', '中宁县', 'pub', '640521', 'cskefu', NULL, '297e1e874f83129d014f83351091038e', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:57', '2015-08-31 18:06:57', 0, 3076, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833956810fb8', '海原县', 'pub', '640522', 'cskefu', NULL, '297e1e874f83129d014f83351081038d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:57', '2015-08-31 18:06:57', 0, 3077, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833957de0fb9', '市辖区', 'pub', '650101', 'cskefu', NULL, '297e1e874f83129d014f833510c5038f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:57', '2015-08-31 18:06:57', 0, 3078, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833957eb0fba', '天山区', 'pub', '650102', 'cskefu', NULL, '297e1e874f83129d014f833510c5038f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:57', '2015-08-31 18:06:57', 0, 3079, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833957fb0fbb', '沙依巴克区', 'pub', '650103', 'cskefu', NULL, '297e1e874f83129d014f833510c5038f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:57', '2015-08-31 18:06:57', 0, 3080, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833958090fbc', '新市区', 'pub', '650104', 'cskefu', NULL, '297e1e874f83129d014f833510c5038f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:57', '2015-08-31 18:06:57', 0, 3081, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833958170fbd', '水磨沟区', 'pub', '650105', 'cskefu', NULL, '297e1e874f83129d014f833510c5038f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:57', '2015-08-31 18:06:57', 0, 3082, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833958260fbe', '头屯河区', 'pub', '650106', 'cskefu', NULL, '297e1e874f83129d014f833510c5038f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:57', '2015-08-31 18:06:57', 0, 3083, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833958360fbf', '达坂城区', 'pub', '650107', 'cskefu', NULL, '297e1e874f83129d014f833510c5038f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:57', '2015-08-31 18:06:57', 0, 3084, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833958440fc0', '东山区', 'pub', '650108', 'cskefu', NULL, '297e1e874f83129d014f833510c5038f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:57', '2015-08-31 18:06:57', 0, 3085, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833958520fc1', '乌鲁木齐县', 'pub', '650121', 'cskefu', NULL, '297e1e874f83129d014f833510c5038f', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:57', '2015-08-31 18:06:57', 0, 3086, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833958830fc2', '市辖区', 'pub', '650201', 'cskefu', NULL, '297e1e874f83129d014f833510d30390', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:57', '2015-08-31 18:06:57', 0, 3087, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833958910fc3', '独山子区', 'pub', '650202', 'cskefu', NULL, '297e1e874f83129d014f833510d30390', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:57', '2015-08-31 18:06:57', 0, 3088, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833958a20fc4', '克拉玛依区', 'pub', '650203', 'cskefu', NULL, '297e1e874f83129d014f833510d30390', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:57', '2015-08-31 18:06:57', 0, 3089, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833958be0fc5', '白碱滩区', 'pub', '650204', 'cskefu', NULL, '297e1e874f83129d014f833510d30390', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:57', '2015-08-31 18:06:57', 0, 3090, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833959f70fc6', '乌尔禾区', 'pub', '650205', 'cskefu', NULL, '297e1e874f83129d014f833510d30390', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:58', '2015-08-31 18:06:58', 0, 3091, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83395a280fc7', '吐鲁番市', 'pub', '652101', 'cskefu', NULL, '297e1e874f83129d014f833510e90391', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:58', '2015-08-31 18:06:58', 0, 3092, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83395a350fc8', '鄯善县', 'pub', '652122', 'cskefu', NULL, '297e1e874f83129d014f833510e90391', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:58', '2015-08-31 18:06:58', 0, 3093, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83395a420fc9', '托克逊县', 'pub', '652123', 'cskefu', NULL, '297e1e874f83129d014f833510e90391', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:58', '2015-08-31 18:06:58', 0, 3094, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83395a6a0fca', '哈密市', 'pub', '652201', 'cskefu', NULL, '297e1e874f83129d014f833510fa0392', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:58', '2015-08-31 18:06:58', 0, 3095, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83395a760fcb', '巴里坤哈萨克自治县', 'pub', '652222', 'cskefu', NULL, '297e1e874f83129d014f833510fa0392', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:58', '2015-08-31 18:06:58', 0, 3096, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83395a840fcc', '伊吾县', 'pub', '652223', 'cskefu', NULL, '297e1e874f83129d014f833510fa0392', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:58', '2015-08-31 18:06:58', 0, 3097, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83395ab30fcd', '昌吉市', 'pub', '652301', 'cskefu', NULL, '297e1e874f83129d014f833511050393', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:58', '2015-08-31 18:06:58', 0, 3098, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83395ac10fce', '阜康市', 'pub', '652302', 'cskefu', NULL, '297e1e874f83129d014f833511050393', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:58', '2015-08-31 18:06:58', 0, 3099, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83395bfa0fcf', '米泉市', 'pub', '652303', 'cskefu', NULL, '297e1e874f83129d014f833511050393', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:58', '2015-08-31 18:06:58', 0, 3100, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83395c070fd0', '呼图壁县', 'pub', '652323', 'cskefu', NULL, '297e1e874f83129d014f833511050393', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:58', '2015-08-31 18:06:58', 0, 3101, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83395c140fd1', '玛纳斯县', 'pub', '652324', 'cskefu', NULL, '297e1e874f83129d014f833511050393', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:58', '2015-08-31 18:06:58', 0, 3102, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83395c230fd2', '奇台县', 'pub', '652325', 'cskefu', NULL, '297e1e874f83129d014f833511050393', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:58', '2015-08-31 18:06:58', 0, 3103, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83395c300fd3', '吉木萨尔县', 'pub', '652327', 'cskefu', NULL, '297e1e874f83129d014f833511050393', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:58', '2015-08-31 18:06:58', 0, 3104, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83395c3f0fd4', '木垒哈萨克自治县', 'pub', '652328', 'cskefu', NULL, '297e1e874f83129d014f833511050393', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:58', '2015-08-31 18:06:58', 0, 3105, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83395d2e0fd5', '博乐市', 'pub', '652701', 'cskefu', NULL, '297e1e874f83129d014f8335111a0394', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:58', '2015-08-31 18:06:58', 0, 3106, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83395d3c0fd6', '精河县', 'pub', '652722', 'cskefu', NULL, '297e1e874f83129d014f8335111a0394', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:58', '2015-08-31 18:06:58', 0, 3107, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83395d4e0fd7', '温泉县', 'pub', '652723', 'cskefu', NULL, '297e1e874f83129d014f8335111a0394', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:58', '2015-08-31 18:06:58', 0, 3108, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83395f570fd8', '库尔勒市', 'pub', '652801', 'cskefu', NULL, '297e1e874f83129d014f833511280395', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:59', '2015-08-31 18:06:59', 0, 3109, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83395f670fd9', '轮台县', 'pub', '652822', 'cskefu', NULL, '297e1e874f83129d014f833511280395', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:59', '2015-08-31 18:06:59', 0, 3110, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83395f7c0fda', '尉犁县', 'pub', '652823', 'cskefu', NULL, '297e1e874f83129d014f833511280395', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:59', '2015-08-31 18:06:59', 0, 3111, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83395f890fdb', '若羌县', 'pub', '652824', 'cskefu', NULL, '297e1e874f83129d014f833511280395', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:59', '2015-08-31 18:06:59', 0, 3112, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83395f990fdc', '且末县', 'pub', '652825', 'cskefu', NULL, '297e1e874f83129d014f833511280395', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:59', '2015-08-31 18:06:59', 0, 3113, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83395faa0fdd', '焉耆回族自治县', 'pub', '652826', 'cskefu', NULL, '297e1e874f83129d014f833511280395', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:59', '2015-08-31 18:06:59', 0, 3114, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83395fb80fde', '和静县', 'pub', '652827', 'cskefu', NULL, '297e1e874f83129d014f833511280395', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:59', '2015-08-31 18:06:59', 0, 3115, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833960d30fdf', '和硕县', 'pub', '652828', 'cskefu', NULL, '297e1e874f83129d014f833511280395', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:59', '2015-08-31 18:06:59', 0, 3116, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833960e30fe0', '博湖县', 'pub', '652829', 'cskefu', NULL, '297e1e874f83129d014f833511280395', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:06:59', '2015-08-31 18:06:59', 0, 3117, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833962dc0fe1', '阿克苏市', 'pub', '652901', 'cskefu', NULL, '297e1e874f83129d014f833512b80396', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:00', '2015-08-31 18:07:00', 0, 3118, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833962eb0fe2', '温宿县', 'pub', '652922', 'cskefu', NULL, '297e1e874f83129d014f833512b80396', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:00', '2015-08-31 18:07:00', 0, 3119, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833962fd0fe3', '库车县', 'pub', '652923', 'cskefu', NULL, '297e1e874f83129d014f833512b80396', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:00', '2015-08-31 18:07:00', 0, 3120, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339630a0fe4', '沙雅县', 'pub', '652924', 'cskefu', NULL, '297e1e874f83129d014f833512b80396', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:00', '2015-08-31 18:07:00', 0, 3121, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833963190fe5', '新和县', 'pub', '652925', 'cskefu', NULL, '297e1e874f83129d014f833512b80396', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:00', '2015-08-31 18:07:00', 0, 3122, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339632b0fe6', '拜城县', 'pub', '652926', 'cskefu', NULL, '297e1e874f83129d014f833512b80396', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:00', '2015-08-31 18:07:00', 0, 3123, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339633d0fe7', '乌什县', 'pub', '652927', 'cskefu', NULL, '297e1e874f83129d014f833512b80396', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:00', '2015-08-31 18:07:00', 0, 3124, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339634f0fe8', '阿瓦提县', 'pub', '652928', 'cskefu', NULL, '297e1e874f83129d014f833512b80396', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:00', '2015-08-31 18:07:00', 0, 3125, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339646a0fe9', '柯坪县', 'pub', '652929', 'cskefu', NULL, '297e1e874f83129d014f833512b80396', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:00', '2015-08-31 18:07:00', 0, 3126, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339659f0fea', '阿图什市', 'pub', '653001', 'cskefu', NULL, '297e1e874f83129d014f833512c90397', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:01', '2015-08-31 18:07:01', 0, 3127, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833965ac0feb', '阿克陶县', 'pub', '653022', 'cskefu', NULL, '297e1e874f83129d014f833512c90397', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:01', '2015-08-31 18:07:01', 0, 3128, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833966d10fec', '阿合奇县', 'pub', '653023', 'cskefu', NULL, '297e1e874f83129d014f833512c90397', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:01', '2015-08-31 18:07:01', 0, 3129, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833966df0fed', '乌恰县', 'pub', '653024', 'cskefu', NULL, '297e1e874f83129d014f833512c90397', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:01', '2015-08-31 18:07:01', 0, 3130, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339681b0fee', '喀什市', 'pub', '653101', 'cskefu', NULL, '297e1e874f83129d014f833512e50398', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:01', '2015-08-31 18:07:01', 0, 3131, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833968dc0ff0', '疏附县', 'pub', '653121', 'cskefu', NULL, '297e1e874f83129d014f833512e50398', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:01', '2015-08-31 18:07:01', 0, 3132, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833968eb0ff1', '疏勒县', 'pub', '653122', 'cskefu', NULL, '297e1e874f83129d014f833512e50398', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:01', '2015-08-31 18:07:01', 0, 3133, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833968f90ff2', '英吉沙县', 'pub', '653123', 'cskefu', NULL, '297e1e874f83129d014f833512e50398', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:01', '2015-08-31 18:07:01', 0, 3134, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833969090ff3', '泽普县', 'pub', '653124', 'cskefu', NULL, '297e1e874f83129d014f833512e50398', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:01', '2015-08-31 18:07:01', 0, 3135, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833969190ff4', '莎车县', 'pub', '653125', 'cskefu', NULL, '297e1e874f83129d014f833512e50398', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:01', '2015-08-31 18:07:01', 0, 3136, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339692e0ff5', '叶城县', 'pub', '653126', 'cskefu', NULL, '297e1e874f83129d014f833512e50398', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:01', '2015-08-31 18:07:01', 0, 3137, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833969400ff6', '麦盖提县', 'pub', '653127', 'cskefu', NULL, '297e1e874f83129d014f833512e50398', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:01', '2015-08-31 18:07:01', 0, 3138, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339694e0ff7', '岳普湖县', 'pub', '653128', 'cskefu', NULL, '297e1e874f83129d014f833512e50398', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:01', '2015-08-31 18:07:01', 0, 3139, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f8339695b0ff8', '伽师县', 'pub', '653129', 'cskefu', NULL, '297e1e874f83129d014f833512e50398', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:01', '2015-08-31 18:07:01', 0, 3140, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833969690ff9', '巴楚县', 'pub', '653130', 'cskefu', NULL, '297e1e874f83129d014f833512e50398', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:01', '2015-08-31 18:07:01', 0, 3141, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833969760ffa', '塔什库尔干塔吉克自治县', 'pub', '653131', 'cskefu', NULL, '297e1e874f83129d014f833512e50398', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', 0, 3142, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833969a80ffb', '和田市', 'pub', '653201', 'cskefu', NULL, '297e1e874f83129d014f833512f60399', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', 0, 3143, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833969b60ffc', '和田县', 'pub', '653221', 'cskefu', NULL, '297e1e874f83129d014f833512f60399', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', 0, 3144, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833969c40ffd', '墨玉县', 'pub', '653222', 'cskefu', NULL, '297e1e874f83129d014f833512f60399', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', 0, 3145, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833969d40ffe', '皮山县', 'pub', '653223', 'cskefu', NULL, '297e1e874f83129d014f833512f60399', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', 0, 3146, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833969e00fff', '洛浦县', 'pub', '653224', 'cskefu', NULL, '297e1e874f83129d014f833512f60399', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', 0, 3147, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833969ee1000', '策勒县', 'pub', '653225', 'cskefu', NULL, '297e1e874f83129d014f833512f60399', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', 0, 3148, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f833969fe1001', '于田县', 'pub', '653226', 'cskefu', NULL, '297e1e874f83129d014f833512f60399', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', 0, 3149, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83396a0b1002', '民丰县', 'pub', '653227', 'cskefu', NULL, '297e1e874f83129d014f833512f60399', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', 0, 3150, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83396a3d1003', '伊宁市', 'pub', '654002', 'cskefu', NULL, '297e1e874f83129d014f8335130a039a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', 0, 3151, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83396a4a1004', '奎屯市', 'pub', '654003', 'cskefu', NULL, '297e1e874f83129d014f8335130a039a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', 0, 3152, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83396a581005', '伊宁县', 'pub', '654021', 'cskefu', NULL, '297e1e874f83129d014f8335130a039a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', 0, 3153, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83396a661006', '察布查尔锡伯自治县', 'pub', '654022', 'cskefu', NULL, '297e1e874f83129d014f8335130a039a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', 0, 3154, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83396a771007', '霍城县', 'pub', '654023', 'cskefu', NULL, '297e1e874f83129d014f8335130a039a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', 0, 3155, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83396a841008', '巩留县', 'pub', '654024', 'cskefu', NULL, '297e1e874f83129d014f8335130a039a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', 0, 3156, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83396a951009', '新源县', 'pub', '654025', 'cskefu', NULL, '297e1e874f83129d014f8335130a039a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', 0, 3157, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83396aa8100a', '昭苏县', 'pub', '654026', 'cskefu', NULL, '297e1e874f83129d014f8335130a039a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', 0, 3158, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83396ab6100b', '特克斯县', 'pub', '654027', 'cskefu', NULL, '297e1e874f83129d014f8335130a039a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', 0, 3159, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83396acc100c', '尼勒克县', 'pub', '654028', 'cskefu', NULL, '297e1e874f83129d014f8335130a039a', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', 0, 3160, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83396afc100d', '塔城市', 'pub', '654201', 'cskefu', NULL, '297e1e874f83129d014f8335131d039b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', 0, 3161, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83396b09100e', '乌苏市', 'pub', '654202', 'cskefu', NULL, '297e1e874f83129d014f8335131d039b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', 0, 3162, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83396b17100f', '额敏县', 'pub', '654221', 'cskefu', NULL, '297e1e874f83129d014f8335131d039b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', 0, 3163, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83396b261010', '沙湾县', 'pub', '654223', 'cskefu', NULL, '297e1e874f83129d014f8335131d039b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', 0, 3164, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83396b341011', '托里县', 'pub', '654224', 'cskefu', NULL, '297e1e874f83129d014f8335131d039b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', 0, 3165, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83396b491012', '裕民县', 'pub', '654225', 'cskefu', NULL, '297e1e874f83129d014f8335131d039b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', 0, 3166, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83396b591013', '和布克赛尔蒙古自治县', 'pub', '654226', 'cskefu', NULL, '297e1e874f83129d014f8335131d039b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', 0, 3167, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83396b851014', '阿勒泰市', 'pub', '654301', 'cskefu', NULL, '297e1e874f83129d014f83351330039c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', 0, 3168, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83396b941015', '布尔津县', 'pub', '654321', 'cskefu', NULL, '297e1e874f83129d014f83351330039c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', 0, 3169, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83396ba31016', '富蕴县', 'pub', '654322', 'cskefu', NULL, '297e1e874f83129d014f83351330039c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', 0, 3170, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83396bb31017', '福海县', 'pub', '654323', 'cskefu', NULL, '297e1e874f83129d014f83351330039c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', 0, 3171, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83396bc61018', '哈巴河县', 'pub', '654324', 'cskefu', NULL, '297e1e874f83129d014f83351330039c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', 0, 3172, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83396bd61019', '青河县', 'pub', '654325', 'cskefu', NULL, '297e1e874f83129d014f83351330039c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', 0, 3173, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83396be4101a', '吉木乃县', 'pub', '654326', 'cskefu', NULL, '297e1e874f83129d014f83351330039c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', 0, 3174, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83396c13101b', '石河子市', 'pub', '659001', 'cskefu', NULL, '297e1e874f83129d014f83351347039d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', 0, 3175, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83396c20101c', '阿拉尔市', 'pub', '659002', 'cskefu', NULL, '297e1e874f83129d014f83351347039d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', 0, 3176, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83396c2e101d', '图木舒克市', 'pub', '659003', 'cskefu', NULL, '297e1e874f83129d014f83351347039d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', 0, 3177, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e1e874f83129d014f83396c3d101e', '五家渠市', 'pub', '659004', 'cskefu', NULL, '297e1e874f83129d014f83351347039d', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2015-08-31 18:07:02', '2015-08-31 18:07:02', 0, 3178, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e63f05d1da6be015d1dae6de20002', '系统模板分类', 'pub', 'com.dic.system.template', NULL, 'resu', '0', '', NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-07-07 23:32:36', NULL, 1, 0, NULL, 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('297e63f05d1da6be015d1daee82c0003', '呼叫中心', 'pub', 'callcenter', 'cskefu', NULL, '297e63f05d1da6be015d1dae6de20002', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-07-07 23:33:08', '2017-07-07 23:33:08', 0, 1, '297e63f05d1da6be015d1dae6de20002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028811b6109050201610928ed6a030d', '工单邮件', 'pub', 'workordermail', 'cskefu', 'layui-icon', '297e63f05d1da6be015d1dae6de20002', '', NULL, '', '', NULL, '297e8c7b455798280145579c73e501c1', '2018-01-18 20:05:32', NULL, 1, 0, '297e63f05d1da6be015d1dae6de20002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028811b61090502016109293494030e', '工单短信', 'pub', 'workordersms', 'cskefu', 'layui-icon', '297e63f05d1da6be015d1dae6de20002', '', NULL, '', '', NULL, '297e8c7b455798280145579c73e501c1', '2018-01-18 20:05:50', NULL, 1, 0, '297e63f05d1da6be015d1dae6de20002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028811b618d0dca01618d5a5fd10349', '布局组件', 'pub', 'layout', 'cskefu', 'layout', '297e63f05d1da6be015d1dae6de20002', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-02-13 12:09:25', '2018-02-13 12:09:25', 0, 1, '297e63f05d1da6be015d1dae6de20002', 0, 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028811b618d0dca01618d5a5fe6034a', '报表组件', 'pub', 'report', 'cskefu', 'report', '297e63f05d1da6be015d1dae6de20002', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-02-13 12:09:25', '2018-02-13 12:09:25', 0, 2, '297e63f05d1da6be015d1dae6de20002', 0, 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028811b618d0dca01618d5a5ff6034b', '过滤器组件', 'pub', 'filter', 'cskefu', 'layui-icon', '297e63f05d1da6be015d1dae6de20002', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-02-13 12:09:25', '2018-02-13 12:09:25', 0, 3, '297e63f05d1da6be015d1dae6de20002', 0, 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028811b621faf9401621fcabd0203c6', '短信网关类型', 'pub', 'com.dic.sms.type', NULL, 'data', '0', '', NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-13 22:36:43', NULL, 1, 0, NULL, 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028811b621faf9401621fcae43003c7', '阿里大鱼', 'pub', 'aliyun', 'cskefu', 'layui-icon', '4028811b621faf9401621fcabd0203c6', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-13 22:36:53', '2018-03-13 22:36:53', 0, 1, '4028811b621faf9401621fcabd0203c6', 0, 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028811b639010de0163904e80d30539', '电话号码类型', 'pub', 'com.dic.phone.type', NULL, 'data', '0', '', NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-05-24 12:00:53', NULL, 1, 0, NULL, 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028811b639010de016390502552053e', '家庭电话', 'pub', '01', 'cskefu', 'layui-icon', '4028811b639010de0163904e80d30539', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-05-24 12:02:41', '2018-05-24 12:02:41', 0, 1, '4028811b639010de0163904e80d30539', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028811b639010de016390502562053f', '工作电话', 'pub', '02', 'cskefu', 'layui-icon', '4028811b639010de0163904e80d30539', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-05-24 12:02:41', '2018-05-24 12:02:41', 0, 2, '4028811b639010de0163904e80d30539', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028811b639010de0163905025700540', '住宅电话', 'pub', '03', 'cskefu', 'layui-icon', '4028811b639010de0163904e80d30539', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-05-24 12:02:41', '2018-05-24 12:02:41', 0, 3, '4028811b639010de0163904e80d30539', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028811b639010de01639050257e0541', '主要电话', 'pub', '04', 'cskefu', 'layui-icon', '4028811b639010de0163904e80d30539', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-05-24 12:02:41', '2018-05-24 12:02:41', 0, 4, '4028811b639010de0163904e80d30539', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028811b639010de01639050258f0542', '无线电话', 'pub', '05', 'cskefu', 'layui-icon', '4028811b639010de0163904e80d30539', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-05-24 12:02:41', '2018-05-24 12:02:41', 0, 5, '4028811b639010de0163904e80d30539', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028811b639010de01639050259b0543', '移动电话', 'pub', '06', 'cskefu', 'layui-icon', '4028811b639010de0163904e80d30539', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-05-24 12:02:41', '2018-05-24 12:02:41', 0, 6, '4028811b639010de0163904e80d30539', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028811b639010de0163905025a50544', '车载电话', 'pub', '07', 'cskefu', 'layui-icon', '4028811b639010de0163904e80d30539', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-05-24 12:02:41', '2018-05-24 12:02:41', 0, 7, '4028811b639010de0163904e80d30539', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028811b639010de0163905025b00545', '助理电话', 'pub', '08', 'cskefu', 'layui-icon', '4028811b639010de0163904e80d30539', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-05-24 12:02:41', '2018-05-24 12:02:41', 0, 8, '4028811b639010de0163904e80d30539', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028811b639010de0163905025bb0546', '回拨电话', 'pub', '09', 'cskefu', 'layui-icon', '4028811b639010de0163904e80d30539', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-05-24 12:02:41', '2018-05-24 12:02:41', 0, 9, '4028811b639010de0163904e80d30539', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028811b63905368016390662e700570', '字段隐藏显示', 'pub', 'com.dic.phone.secdis', NULL, 'data', '0', '', NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-05-24 12:26:45', NULL, 1, 0, NULL, 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028811b63905368016390666f4d0575', '隐藏中间四位', 'pub', '01', 'cskefu', 'layui-icon', '4028811b63905368016390662e700570', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-05-24 12:27:02', '2018-05-24 12:27:02', 0, 1, '4028811b63905368016390662e700570', 0, 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028811b6390536801639066bae2057c', '隐藏后四位', 'pub', '02', 'cskefu', 'layui-icon', '4028811b63905368016390662e700570', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-05-24 12:27:21', '2018-05-24 12:27:21', 0, 1, '4028811b63905368016390662e700570', 0, 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028811b6390536801639066df8e0580', '隐藏前4位', 'pub', '03', 'cskefu', 'layui-icon', '4028811b63905368016390662e700570', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-05-24 12:27:31', '2018-05-24 12:27:31', 0, 1, '4028811b63905368016390662e700570', 0, 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028811b63906a0c01639139c1520562', '外呼业务类型', 'pub', 'com.dic.callout.type', NULL, 'data', '0', '', NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-05-24 16:17:51', NULL, 1, 0, NULL, 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028811b63906a0c0163913a1c790567', '电销', 'pub', '01', 'cskefu', NULL, '4028811b63906a0c01639139c1520562', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-05-24 16:18:14', '2018-05-24 16:18:14', 0, 1, '4028811b63906a0c01639139c1520562', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028811b63906a0c0163913a1c890568', '回访', 'pub', '02', 'cskefu', NULL, '4028811b63906a0c01639139c1520562', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-05-24 16:18:14', '2018-05-24 16:18:14', 0, 2, '4028811b63906a0c01639139c1520562', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028811b63c516b60163c51cc6d0057f', '外呼', 'pub', 'callout', 'cskefu', 'layui-icon', '4028838b5b565caf015b566d11d80010', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-06-03 18:06:27', NULL, 1, 0, '4028838b5b565caf015b566d11d80010', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028811b63c5281b0163c5c6cbf905d4', '全部隐藏', 'pub', '04', 'cskefu', 'layui-icon', '4028811b63905368016390662e700570', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-06-03 21:12:09', NULL, 1, 0, '4028811b63905368016390662e700570', 0, 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028811b63f83f5d0163f84fd56605bb', '未知', 'pub', '-1', 'cskefu', 'layui-icon', '297e1e874f5ae37e014f5af969e30120', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-06-13 16:42:51', NULL, 1, 0, '297e1e874f5ae37e014f5af969e30120', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028811b642af06f01642af9cfa304c6', '输入参数', 'pub', 'inputparam', 'cskefu', NULL, '297e63f05d1da6be015d1dae6de20002', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-06-23 12:49:32', '2018-06-23 12:49:32', 0, 1, '297e63f05d1da6be015d1dae6de20002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028811b642af06f01642af9cfaf04c7', '输出参数', 'pub', 'outputparam', 'cskefu', NULL, '297e63f05d1da6be015d1dae6de20002', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-06-23 12:49:32', '2018-06-23 12:49:32', 0, 2, '297e63f05d1da6be015d1dae6de20002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881e8618cc9ab01618cd99f40035a', '模型类型', 'pub', 'com.dic.cube.modeltype', NULL, 'data', '0', '', NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-02-13 09:48:47', NULL, 1, 0, NULL, 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881e8618cc9ab01618cd9cfae035b', '立方体', 'pub', 'cube', 'cskefu', 'layui-icon', '402881e8618cc9ab01618cd99f40035a', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-02-13 09:49:00', '2018-02-13 09:49:00', 0, 1, '402881e8618cc9ab01618cd99f40035a', 0, 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881e86191fd51016191ff64550355', '维度成员数据类型', 'pub', 'com.dic.cubelevel.type', NULL, 'data', '0', '', NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-02-14 09:48:09', NULL, 1, 0, NULL, 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881e86191fd510161920152c10356', '字符', 'pub', 'String', 'cskefu', 'layui-icon', '402881e86191fd51016191ff64550355', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-02-14 09:50:15', '2018-02-14 09:50:15', 0, 1, '402881e86191fd51016191ff64550355', 0, 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881e86191fd510161920152d00357', '整数', 'pub', 'Integer', 'cskefu', 'layui-icon', '402881e86191fd51016191ff64550355', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-02-14 09:50:15', '2018-02-14 09:50:15', 0, 2, '402881e86191fd51016191ff64550355', 0, 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881e86191fd510161920152df0358', '数字', 'pub', 'Numeric', 'cskefu', 'layui-icon', '402881e86191fd51016191ff64550355', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-02-14 09:50:15', '2018-02-14 09:50:15', 0, 3, '402881e86191fd51016191ff64550355', 0, 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881e86191fd510161920152ec0359', '布尔', 'pub', 'Boolean', 'cskefu', 'layui-icon', '402881e86191fd51016191ff64550355', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-02-14 09:50:15', '2018-02-14 09:50:15', 0, 4, '402881e86191fd51016191ff64550355', 0, 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881e86191fd51016192015306035a', '日期', 'pub', 'Date', 'cskefu', 'layui-icon', '402881e86191fd51016191ff64550355', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-02-14 09:50:15', '2018-02-14 09:50:15', 0, 5, '402881e86191fd51016191ff64550355', 0, 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881e86191fd51016192015315035b', '时间戳', 'pub', 'Timestamp', 'cskefu', 'layui-icon', '402881e86191fd51016191ff64550355', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-02-14 09:50:15', '2018-02-14 09:50:15', 0, 6, '402881e86191fd51016191ff64550355', 0, 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881e86191fd510161920a42ad035c', '数据表', 'pub', 'table', 'cskefu', 'layui-icon', '402881e8618cc9ab01618cd99f40035a', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-02-14 10:00:01', NULL, 1, 0, '402881e8618cc9ab01618cd99f40035a', 0, 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881e861c035950161c039aac3036e', '维度类型', 'pub', 'com.dic.dimension.modeltype', NULL, 'data', '0', '', NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-02-23 09:14:20', NULL, 1, 0, NULL, 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881e861c035950161c03a9110036f', 'TimeDimension', 'pub', 'time', 'cskefu', 'layui-icon', '402881e861c035950161c039aac3036e', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-02-23 09:15:19', NULL, 1, 0, '402881e861c035950161c039aac3036e', 0, 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881e861c041370161c05335070370', '维度成员时间类型', 'pub', 'com.dic.cubelevel.leveltype', NULL, 'data', '0', '', NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-02-23 09:42:13', NULL, 1, 0, NULL, 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881e861c041370161c0563d130371', 'TimeYears', 'pub', 'TimeYears', 'cskefu', 'layui-icon', '402881e861c041370161c05335070370', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-02-23 09:45:32', '2018-02-23 09:45:32', 0, 1, '402881e861c041370161c05335070370', 0, 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881e861c041370161c0563d260372', 'TimeQuarters', 'pub', 'TimeQuarters', 'cskefu', 'layui-icon', '402881e861c041370161c05335070370', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-02-23 09:45:32', '2018-02-23 09:45:32', 0, 2, '402881e861c041370161c05335070370', 0, 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881e861c041370161c0563d360373', 'TimeMonths', 'pub', 'TimeMonths', 'cskefu', 'layui-icon', '402881e861c041370161c05335070370', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-02-23 09:45:32', '2018-02-23 09:45:32', 0, 3, '402881e861c041370161c05335070370', 0, 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881e861c041370161c0563d460374', 'TimeWeeks', 'pub', 'TimeWeeks', 'cskefu', 'layui-icon', '402881e861c041370161c05335070370', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-02-23 09:45:32', '2018-02-23 09:45:32', 0, 4, '402881e861c041370161c05335070370', 0, 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881e861c041370161c0563d660375', 'TimeDays', 'pub', 'TimeDays', 'cskefu', 'layui-icon', '402881e861c041370161c05335070370', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-02-23 09:45:32', '2018-02-23 09:45:32', 0, 5, '402881e861c041370161c05335070370', 0, 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881e861c041370161c0563d7a0376', 'TimeHours', 'pub', 'TimeHours', 'cskefu', 'layui-icon', '402881e861c041370161c05335070370', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-02-23 09:45:32', '2018-02-23 09:45:32', 0, 6, '402881e861c041370161c05335070370', 0, 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881e861c041370161c0563d8c0377', 'TimeMinutes', 'pub', 'TimeMinutes', 'cskefu', 'layui-icon', '402881e861c041370161c05335070370', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-02-23 09:45:32', '2018-02-23 09:45:32', 0, 7, '402881e861c041370161c05335070370', 0, 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881e861c0b7280161c0cbd1450375', '指标聚合方式', 'pub', 'com.dic.cubemeasure.aggregator', NULL, 'data', '0', '', NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-02-23 11:53:58', NULL, 1, 0, NULL, 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881e861c0b7280161c0ceec93037b', '求和（Sum）', 'pub', 'sum', 'cskefu', 'layui-icon', '402881e861c0b7280161c0cbd1450375', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-02-23 11:57:21', '2018-02-23 11:57:21', 0, 1, '402881e861c0b7280161c0cbd1450375', 0, 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881e861c0b7280161c0ceeca1037c', '计数（Count）', 'pub', 'count', 'cskefu', 'layui-icon', '402881e861c0b7280161c0cbd1450375', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-02-23 11:57:21', '2018-02-23 11:57:21', 0, 2, '402881e861c0b7280161c0cbd1450375', 0, 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881e861c0b7280161c0ceecac037d', '最小（Min）', 'pub', 'min', 'cskefu', 'layui-icon', '402881e861c0b7280161c0cbd1450375', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-02-23 11:57:21', '2018-02-23 11:57:21', 0, 3, '402881e861c0b7280161c0cbd1450375', 0, 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881e861c0b7280161c0ceecb8037e', '最大（Max）', 'pub', 'max', 'cskefu', 'layui-icon', '402881e861c0b7280161c0cbd1450375', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-02-23 11:57:21', '2018-02-23 11:57:21', 0, 4, '402881e861c0b7280161c0cbd1450375', 0, 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881e861c0b7280161c0ceecc7037f', '平均值（Avg）', 'pub', 'avg', 'cskefu', 'layui-icon', '402881e861c0b7280161c0cbd1450375', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-02-23 11:57:21', '2018-02-23 11:57:21', 0, 5, '402881e861c0b7280161c0cbd1450375', 0, 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881e861d54f430161d55069db037f', '模板样例数据', 'pub', 'com.dic.template.datatype', NULL, 'data', '0', '', NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-02-27 11:31:12', NULL, 1, 0, NULL, 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881e861d54f430161d5507af50380', '递减', 'pub', 'dec', 'cskefu', 'report', '402881e861d54f430161d55069db037f', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-02-27 11:31:16', '2018-02-27 11:31:16', 0, 1, '402881e861d54f430161d55069db037f', 0, 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881e861d54f430161d5507b020381', '地图', 'pub', 'map', 'cskefu', 'report', '402881e861d54f430161d55069db037f', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-02-27 11:31:16', '2018-02-27 11:31:16', 0, 2, '402881e861d54f430161d55069db037f', 0, 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881e861d54f430161d550a8d60382', '基本', 'pub', 'simple', 'cskefu', 'report', '402881e861d54f430161d55069db037f', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-02-27 11:31:28', '2018-02-27 11:31:28', 0, 1, '402881e861d54f430161d55069db037f', 0, 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881e861d54f430161d550a8ee0383', '序列', 'pub', 'seq', 'cskefu', 'report', '402881e861d54f430161d55069db037f', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-02-27 11:31:28', '2018-02-27 11:31:28', 0, 3, '402881e861d54f430161d55069db037f', 0, 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881e861da4c960161da7040bc0385', '报表查询模板', 'pub', 'reportquery', 'cskefu', 'layui-icon', '297e63f05d1da6be015d1dae6de20002', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-02-28 11:24:05', NULL, 1, 0, '297e63f05d1da6be015d1dae6de20002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612cc4a491053e', '坐席对话', 'pub', 'A01', NULL, 'auth', '402888815d2fe37f015d2fe75cc80002', NULL, NULL, '<i class=\"layui-icon\" style=\"top: 3px;\">&#xe63a;</i>', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:02:20', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/agent/index.html', 'webim', '1', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612cc4ffb1053f', '全部联系人', 'pub', 'A02', NULL, 'auth', '402888815d2fe37f015d2fe75cc80002', NULL, NULL, '<i class=\"layui-icon\" style=\"position: relative;\">&#xe612;</i>', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:02:43', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/apps/contacts/index.html', 'webim', '1', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612cc529b20540', '全部客户', 'pub', 'A03', NULL, 'auth', '402888815d2fe37f015d2fe75cc80002', NULL, NULL, '<i class=\"kfont\" style=\"position: relative;\">&#xe650;</i>', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:02:54', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/apps/customer/index.html', 'webim', '1', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612cc551ac0541', '工单管理', 'pub', 'A04', NULL, 'auth', '402888815d2fe37f015d2fe75cc80002', NULL, NULL, '<i class=\"kfont\" style=\"position: relative;\">&#xe607;</i>', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:03:04', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/apps/workorders/index.html', 'webim', '1', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612cc580cc0542', '业务流程', 'pub', 'A05', NULL, 'auth', '402888815d2fe37f015d2fe75cc80002', NULL, NULL, '<i class=\"kfont\" style=\"position: relative;\">&#xe636;</i>', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:03:16', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/apps/bpm/index.html', 'webim', '1', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612cc5a2040543', '客服设置', 'pub', 'A06', NULL, 'auth', '402888815d2fe37f015d2fe75cc80002', NULL, NULL, '<i class=\"layui-icon\" style=\"position: relative;\">&#xe614;</i>', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:03:25', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/setting/agent/index.html', 'webim', '1', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612cc5d9710545', '会话历史', 'pub', 'A08', NULL, 'auth', '402888815d2fe37f015d2fe75cc80002', NULL, NULL, '<i class=\"kfont\" style=\"position: relative;\">&#xe7eb;</i>', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:03:39', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/service/history/index.html', 'webim', '1', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612cc626f90547', '语音渠道', 'pub', 'A10', NULL, 'auth', '402888815d2fe37f015d2fe75cc80002', NULL, NULL, '<i class=\"kfont\" style=\"position: relative;\">&#xe625;</i>', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:03:59', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/apps/callcenter/service/index.html', 'webim', '1', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612cc78f570548', '联系人', 'pub', 'A02_A01', NULL, 'auth', '402881ef612b1f5b01612cc4ffb1053f', NULL, NULL, '&#x756e646566696e6564;', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:05:31', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, 'javascript:;', 'webim', '2', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612cc817fb0549', '全部联系人', 'pub', 'A02_A01_A01', NULL, 'auth', '402881ef612b1f5b01612cc78f570548', NULL, NULL, '&#x756e646566696e6564;', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:06:06', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/apps/contacts/index.html', 'webim', '3', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612cc87273054a', '客户分类', 'pub', 'A02_A01_A02', NULL, 'auth', '402881ef612b1f5b01612cc78f570548', NULL, NULL, '&#x756e646566696e6564;', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:06:29', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/apps/contacts/index.html?ckind=4028838b5af1047e015af140df150003', 'webim', '3', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612cc94072054b', '全部客户', 'pub', 'A03_A01', NULL, 'auth', '402881ef612b1f5b01612cc529b20540', NULL, NULL, '&#x756e646566696e6564;', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:07:22', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, 'javascript:;', 'webim', '2', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612cc998f7054c', '全部客户', 'pub', 'A03_A01_A01', NULL, 'auth', '402881ef612b1f5b01612cc94072054b', NULL, NULL, '&#x756e646566696e6564;', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:07:44', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/apps/customer/index.html', 'webim', '3', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612cca221d054d', '客户分类', 'pub', 'A03_A01_A02', NULL, 'auth', '402881ef612b1f5b01612cc94072054b', NULL, NULL, '&#x756e646566696e6564;', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:08:19', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/apps/customer/index.html?ekind=4028838b5ae97036015ae972d48d0004', 'webim', '3', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612cca88e2054e', '工单概况', 'pub', 'A04_A01', NULL, 'auth', '402881ef612b1f5b01612cc551ac0541', NULL, NULL, '&#x756e646566696e6564;', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:08:46', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/apps/workorders/index.html', 'webim', '2', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612ccabee3054f', '工单管理', 'pub', 'A04_A02', NULL, 'auth', '402881ef612b1f5b01612cc551ac0541', NULL, NULL, '&#x756e646566696e6564;', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:09:00', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, 'javascript:;', 'webim', '2', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612ccf1f4f0555', '我的工单', 'pub', 'A04_A02_A01', NULL, 'auth', '402881ef612b1f5b01612ccabee3054f', NULL, NULL, '&#x756e646566696e6564;', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:13:46', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/apps/workorders/myorders.html', 'webim', '3', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612ccf7e580556', '待处理工单', 'pub', 'A04_A02_A02', NULL, 'auth', '402881ef612b1f5b01612ccabee3054f', NULL, NULL, '&#x756e646566696e6564;', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:14:11', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/apps/workorders/workitem.html', 'webim', '3', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612ccfce4c0557', '未分配工单', 'pub', 'A04_A02_A03', NULL, 'auth', '402881ef612b1f5b01612ccabee3054f', NULL, NULL, '&#x756e646566696e6564;', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:14:31', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/apps/workorders/notassigned.html', 'webim', '3', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612cd018910558', '关注的工单', 'pub', 'A04_A02_A04', NULL, 'auth', '402881ef612b1f5b01612ccabee3054f', NULL, NULL, '&#x756e646566696e6564;', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:14:50', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/apps/workorders/favorites.html', 'webim', '3', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612cd067780559', '已关闭工单', 'pub', 'A04_A02_A05', NULL, 'auth', '402881ef612b1f5b01612ccabee3054f', NULL, NULL, '&#x756e646566696e6564;', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:15:10', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/apps/workorders/closed.html', 'webim', '3', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612cd1a2ce055a', '业务流程', 'pub', 'A05_A01', NULL, 'auth', '402881ef612b1f5b01612cc580cc0542', NULL, NULL, '&#x756e646566696e6564;', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:16:31', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, 'javascript:;', 'webim', '2', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612cd1fac4055b', '流程管理', 'pub', 'A05_A01_A01', NULL, 'auth', '402881ef612b1f5b01612cd1a2ce055a', NULL, NULL, '&#x756e646566696e6564;', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:16:54', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/apps/bpm/index.html', 'webim', '3', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612cd22c2c055c', '已发布流程', 'pub', 'A05_A01_A02', NULL, 'auth', '402881ef612b1f5b01612cd1a2ce055a', NULL, NULL, '&#x756e646566696e6564;', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:17:06', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/apps/bpm/process.html', 'webim', '3', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612cd267fd055d', '流程实例', 'pub', 'A05_A01_A03', NULL, 'auth', '402881ef612b1f5b01612cd1a2ce055a', NULL, NULL, '&#x756e646566696e6564;', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:17:22', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/apps/bpm/instance.html', 'webim', '3', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612cd2a031055e', '工单分类', 'pub', 'A05_A01_A04', NULL, 'auth', '402881ef612b1f5b01612cd1a2ce055a', NULL, NULL, '&#x756e646566696e6564;', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:17:36', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/apps/workorder/type/index.html', 'webim', '3', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612cd4c271055f', '客服设置', 'pub', 'A06_A01', NULL, 'auth', '402881ef612b1f5b01612cc5a2040543', NULL, NULL, '&#x756e646566696e6564;', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:19:56', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, 'javascript:;', 'webim', '2', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612cd4fd8c0560', '广告位管理', 'pub', 'A06_A02', NULL, 'auth', '402881ef612b1f5b01612cc5a2040543', NULL, NULL, '&#x756e646566696e6564;', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:20:11', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, 'javascript:;', 'webim', '2', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612cd541ff0561', '标签管理', 'pub', 'A06_A03', NULL, 'auth', '402881ef612b1f5b01612cc5a2040543', NULL, NULL, '&#x756e646566696e6564;', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:20:29', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, 'javascript:;', 'webim', '2', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612cd5a74f0562', '对话设置', 'pub', 'A06_A01_A01', NULL, 'auth', '402881ef612b1f5b01612cd4c271055f', NULL, NULL, '&#x756e646566696e6564;', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:20:54', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/setting/agent/index.html', 'webim', '3', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612cd5db850563', '黑名单', 'pub', 'A06_A01_A02', NULL, 'auth', '402881ef612b1f5b01612cd4c271055f', NULL, NULL, '&#x756e646566696e6564;', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:21:08', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/setting/blacklist.html', 'webim', '3', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612cdc778c056d', '会话信息', 'pub', 'A08_A01', NULL, 'auth', '402881ef612b1f5b01612cc5d9710545', NULL, NULL, '&#x756e646566696e6564;', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:28:21', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, 'javascript:;', 'webim', '2', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612cdca922056e', '统计功能', 'pub', 'A08_A02', NULL, 'auth', '402881ef612b1f5b01612cc5d9710545', NULL, NULL, '&#x756e646566696e6564;', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:28:34', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, 'javascript:;', 'webim', '2', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612cdce2a4056f', '服务小结', 'pub', 'A08_A03', NULL, 'auth', '402881ef612b1f5b01612cc5d9710545', NULL, NULL, '&#x756e646566696e6564;', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:28:48', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, 'javascript:;', 'webim', '2', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612cdd1e930570', '坐席信息', 'pub', 'A08_A04', NULL, 'auth', '402881ef612b1f5b01612cc5d9710545', NULL, NULL, '&#x756e646566696e6564;', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:29:04', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, 'javascript:;', 'webim', '2', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612cddc0920571', '历史会话', 'pub', 'A08_A01_A01', NULL, 'auth', '402881ef612b1f5b01612cdc778c056d', NULL, NULL, '&#x756e646566696e6564;', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:29:45', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/service/history/index.html', 'webim', '3', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612cde068c0572', '当前会话', 'pub', 'A08_A01_A02', NULL, 'auth', '402881ef612b1f5b01612cdc778c056d', NULL, NULL, '&#x756e646566696e6564;', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:30:03', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/service/current/index.html', 'webim', '3', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612cde3ca40573', '排队队列', 'pub', 'A08_A01_A03', NULL, 'auth', '402881ef612b1f5b01612cdc778c056d', NULL, NULL, '&#x756e646566696e6564;', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:30:17', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/service/quene/index.html', 'webim', '3', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612cdeb60b0574', '访客留言', 'pub', 'A08_A01_A04', NULL, 'auth', '402881ef612b1f5b01612cdc778c056d', NULL, NULL, '&#x756e646566696e6564;', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:30:48', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/service/leavemsg/index.html', 'webim', '3', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612cdf24e10575', '满意度评价', 'pub', 'A08_A01_A05', NULL, 'auth', '402881ef612b1f5b01612cdc778c056d', NULL, NULL, '&#x756e646566696e6564;', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:31:16', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/service/comment/index.html', 'webim', '3', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612ce748b20577', '满意度统计', 'pub', 'A08_A02_A01', NULL, 'auth', '402881ef612b1f5b01612cdca922056e', NULL, NULL, '&#x756e646566696e6564;', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:40:10', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/service/stats/coment.html', 'webim', '3', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612ce774fe0579', '客服坐席', 'pub', 'A08_A02_A02', NULL, 'auth', '402881ef612b1f5b01612cdca922056e', NULL, NULL, '&#x756e646566696e6564;', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:40:21', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/service/stats/agent.html', 'webim', '3', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612ce7ca6a057a', '多媒体客服', 'pub', 'A08_A03_A01', NULL, 'auth', '402881ef612b1f5b01612cdce2a4056f', NULL, NULL, '&#x756e646566696e6564;', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:40:43', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/apps/agent/summary/index.html', 'webim', '3', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612ce7fb2d057b', '已处理多媒体客服', 'pub', 'A08_A03_A02', NULL, 'auth', '402881ef612b1f5b01612cdce2a4056f', NULL, NULL, '&#x756e646566696e6564;', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:40:56', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/apps/agent/processed/index.html', 'webim', '3', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612ce85460057c', '呼叫中心', 'pub', 'A08_A03_A03', NULL, 'auth', '402881ef612b1f5b01612cdce2a4056f', NULL, NULL, '&#x756e646566696e6564;', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:41:18', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/apps/callcenter/summary/index.html', 'webim', '3', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612ce88154057d', '已处理呼叫中心', 'pub', 'A08_A03_A04', NULL, 'auth', '402881ef612b1f5b01612cdce2a4056f', NULL, NULL, '&#x756e646566696e6564;', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:41:30', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/apps/callcenter/processed/index.html', 'webim', '3', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612ce8b990057e', '在线坐席', 'pub', 'A08_A04_A01', NULL, 'auth', '402881ef612b1f5b01612cdd1e930570', NULL, NULL, '&#x756e646566696e6564;', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:41:44', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/service/agent/index.html', 'webim', '3', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612ce8e6a2057f', '全部坐席', 'pub', 'A08_A04_A02', NULL, 'auth', '402881ef612b1f5b01612cdd1e930570', NULL, NULL, '&#x756e646566696e6564;', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:41:56', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/service/user/index.html', 'webim', '3', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612cee4fbb058a', '通话信息', 'pub', 'A10_A01', NULL, 'auth', '402881ef612b1f5b01612cc626f90547', NULL, NULL, '&#x756e646566696e6564;', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:47:50', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, 'javascript:;', 'webim', '2', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612cee80ed058b', '坐席信息', 'pub', 'A10_A02', NULL, 'auth', '402881ef612b1f5b01612cc626f90547', NULL, NULL, '&#x756e646566696e6564;', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:48:03', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, 'javascript:;', 'webim', '2', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612ceeca0c058c', '历史通话', 'pub', 'A10_A01_A01', NULL, 'auth', '402881ef612b1f5b01612cee4fbb058a', NULL, NULL, '&#x756e646566696e6564;', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:48:22', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/apps/callcenter/service/index.html', 'webim', '3', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612ceef6c4058d', '当前通话', 'pub', 'A10_A01_A02', NULL, 'auth', '402881ef612b1f5b01612cee4fbb058a', NULL, NULL, '&#x756e646566696e6564;', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:48:33', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/apps/callcenter/current/index.html', 'webim', '3', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612cef4503058e', '排队队列', 'pub', 'A10_A01_A03', NULL, 'auth', '402881ef612b1f5b01612cee4fbb058a', NULL, NULL, '&#x756e646566696e6564;', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:48:53', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/apps/callcenter/quene/index.html', 'webim', '3', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612cef8453058f', '录音管理', 'pub', 'A10_A01_A04', NULL, 'auth', '402881ef612b1f5b01612cee4fbb058a', NULL, NULL, '&#x756e646566696e6564;', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:49:09', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/apps/callcenter/record/index.html', 'webim', '3', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612cefb4120590', '语音留言', 'pub', 'A10_A01_A05', NULL, 'auth', '402881ef612b1f5b01612cee4fbb058a', NULL, NULL, '&#x756e646566696e6564;', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:49:22', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/apps/callcenter/voicemail/index.html', 'webim', '3', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612ceffa060591', '漏话列表', 'pub', 'A10_A01_A06', NULL, 'auth', '402881ef612b1f5b01612cee4fbb058a', NULL, NULL, '&#x756e646566696e6564;', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:49:40', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/apps/callcenter/misscall/index.html', 'webim', '3', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612cf03d740592', '在线坐席', 'pub', 'A10_A02_A01', NULL, 'auth', '402881ef612b1f5b01612cee80ed058b', NULL, NULL, '&#x756e646566696e6564;', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:49:57', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/apps/callcenter/online/index.html', 'webim', '3', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612cf065f40593', '全部坐席', 'pub', 'A10_A02_A02', NULL, 'auth', '402881ef612b1f5b01612cee80ed058b', NULL, NULL, '&#x756e646566696e6564;', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:50:07', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/apps/callcenter/agents/index.html', 'webim', '3', NULL, 'left');

INSERT INTO `uk_sysdic` VALUES ('402881ef612b1f5b01612cf147810595', '系统管理', 'pub', 'B02', NULL, 'auth', '402888815d2fe37f015d2fe75cc80002', NULL, NULL, '<i class=\"layui-icon\" style=\"position: relative;\">&#xe631;</i>', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-25 18:51:05', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/admin/content.html', 'webim', '1', NULL, 'left');

INSERT INTO `uk_sysdic` VALUES ('2c9580866e7993b3016e832ce1e71309', '用户账号', 'pub', 'B02_B01', 'cskefu', 'layui-icon', '402881ef612b1f5b01612cf147810595', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2019-11-19 18:19:47', NULL, 1, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('2c9580866e7993b3016e832d13f6130f', '系统角色', 'pub', 'B02_B02', 'cskefu', 'layui-icon', '402881ef612b1f5b01612cf147810595', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2019-11-19 18:19:59', NULL, 1, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('2c9580866e7993b3016e832d8bc61315', '组织机构', 'pub', 'B02_B03', 'cskefu', 'layui-icon', '402881ef612b1f5b01612cf147810595', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2019-11-19 18:20:30', NULL, 1, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('2c9580866e7993b3016e832de05c131c', '网站列表', 'pub', 'B02_B04', 'cskefu', 'layui-icon', '402881ef612b1f5b01612cf147810595', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2019-11-19 18:20:52', NULL, 1, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, NULL, NULL, NULL, NULL, NULL);

INSERT INTO `uk_sysdic` VALUES ('402881fb61e49a9a0161e4a8a1260392', '过滤器类型', 'pub', 'com.dic.filter.modeltype', NULL, 'data', '0', '', NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-02 11:01:52', NULL, 1, 0, NULL, 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb61e49a9a0161e4a925a20393', '过滤器取值方式', 'pub', 'com.dic.filter.convalue', NULL, 'data', '0', '', NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-02 11:02:25', NULL, 1, 0, NULL, 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb61e49a9a0161e4a96f900394', '过滤器条件类型', 'pub', 'com.dic.filter.valuefiltertype', NULL, 'data', '0', '', NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-02 11:02:44', NULL, 1, 0, NULL, 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb61e49a9a0161e4a9b6f80395', '过滤器比较放松', 'pub', 'com.dic.filter.comparetype', NULL, 'data', '0', '', NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-02 11:03:03', NULL, 1, 0, NULL, 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb61e49a9a0161e4abe5630396', '文本框', 'pub', 'text', 'cskefu', 'layui-icon', '402881fb61e49a9a0161e4a8a1260392', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-02 11:05:26', '2018-03-02 11:05:26', 0, 1, '402881fb61e49a9a0161e4a8a1260392', 0, 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb61e49a9a0161e4abe56f0397', '日历', 'pub', 'date', 'cskefu', 'layui-icon', '402881fb61e49a9a0161e4a8a1260392', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-02 11:05:26', '2018-03-02 11:05:26', 0, 2, '402881fb61e49a9a0161e4a8a1260392', 0, 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb61e49a9a0161e4abe57c0398', '单选下拉列表', 'pub', 'sigsel', 'cskefu', 'layui-icon', '402881fb61e49a9a0161e4a8a1260392', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-02 11:05:26', '2018-03-02 11:05:26', 0, 3, '402881fb61e49a9a0161e4a8a1260392', 0, 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb61e49a9a0161e4ac69b10399', '用户输入', 'pub', 'input', 'cskefu', 'layui-icon', '402881fb61e49a9a0161e4a925a20393', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-02 11:05:59', '2018-03-02 11:05:59', 0, 1, '402881fb61e49a9a0161e4a925a20393', 0, 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb61e49a9a0161e4ac69be039a', '自动获取', 'pub', 'auto', 'cskefu', 'layui-icon', '402881fb61e49a9a0161e4a925a20393', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-02 11:05:59', '2018-03-02 11:05:59', 0, 2, '402881fb61e49a9a0161e4a925a20393', 0, 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb61e49a9a0161e4ace76a039b', '比较', 'pub', 'compare', 'cskefu', 'layui-icon', '402881fb61e49a9a0161e4a96f900394', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-02 11:06:32', '2018-03-02 11:06:32', 0, 1, '402881fb61e49a9a0161e4a96f900394', 0, 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb61e49a9a0161e4ace777039c', '范围', 'pub', 'range', 'cskefu', 'layui-icon', '402881fb61e49a9a0161e4a96f900394', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-02 11:06:32', '2018-03-02 11:06:32', 0, 2, '402881fb61e49a9a0161e4a96f900394', 0, 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb61e49a9a0161e4ad727d039d', '相等（IN）', 'pub', 'equal', 'cskefu', 'layui-icon', '402881fb61e49a9a0161e4a9b6f80395', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-02 11:07:07', '2018-03-02 11:07:07', 0, 1, '402881fb61e49a9a0161e4a9b6f80395', 0, 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb61e49a9a0161e4ade5d6039e', '不等（NOT IN）', 'pub', 'not', 'cskefu', 'layui-icon', '402881fb61e49a9a0161e4a9b6f80395', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-02 11:07:37', NULL, 1, 0, '402881fb61e49a9a0161e4a9b6f80395', 0, 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb621cfbce01621d1b9eb003cf', '单位性质', 'pub', 'com.dic.customer.etype', 'cskefu', 'data', '0', '', NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-13 10:06:12', NULL, 1, 0, NULL, 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb621cfbce01621d1c25c703d0', '企业客户', 'pub', 'enterprise', 'cskefu', 'layui-icon', '402881fb621cfbce01621d1b9eb003cf', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-13 10:06:46', '2018-03-13 10:06:46', 0, 1, '402881fb621cfbce01621d1b9eb003cf', 0, 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb621cfbce01621d1c25d603d1', '个人客户', 'pub', 'personal', 'cskefu', 'layui-icon', '402881fb621cfbce01621d1b9eb003cf', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-13 10:06:46', '2018-03-13 10:06:46', 0, 2, '402881fb621cfbce01621d1b9eb003cf', 0, 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb621d3ffc01621d6755fd03d5', '是否', 'pub', 'com.dic.yesorno', NULL, 'data', '0', '', NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-13 11:28:54', NULL, 1, 0, NULL, 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb621d3ffc01621d6793b203d6', '是', 'pub', '1', 'cskefu', 'layui-icon', '402881fb621d3ffc01621d6755fd03d5', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-13 11:29:10', NULL, 1, 0, '402881fb621d3ffc01621d6755fd03d5', 0, 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb621d3ffc01621d67ab3903d7', '否', 'pub', '0', 'cskefu', 'layui-icon', '402881fb621d3ffc01621d6755fd03d5', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-13 11:29:16', NULL, 1, 0, '402881fb621d3ffc01621d6755fd03d5', 0, 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb624b78cd01624b7bd7fe0380', '订单状态', 'pub', 'com.dic.ticket.orderstatus', NULL, 'data', '0', '', NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-22 10:13:50', NULL, 1, 0, NULL, 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb624b78cd01624b7d4b600381', '预约未付费', 'pub', 'U', 'cskefu', NULL, '402881fb624b78cd01624b7bd7fe0380', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-22 10:15:25', '2018-03-22 10:15:25', 0, 1, '402881fb624b78cd01624b7bd7fe0380', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb624b78cd01624b7d4b6f0382', '预约已取消', 'pub', 'R', 'cskefu', NULL, '402881fb624b78cd01624b7bd7fe0380', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-22 10:15:25', '2018-03-22 10:15:25', 0, 2, '402881fb624b78cd01624b7bd7fe0380', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb624b78cd01624b7d4b7a0383', '已付费处理中', 'pub', 'P', 'cskefu', NULL, '402881fb624b78cd01624b7bd7fe0380', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-22 10:15:25', '2018-03-22 10:15:25', 0, 3, '402881fb624b78cd01624b7bd7fe0380', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb624b78cd01624b7d4b890384', '退费成功（含撤消成功）', 'pub', 'T', 'cskefu', NULL, '402881fb624b78cd01624b7bd7fe0380', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-22 10:15:25', '2018-03-22 10:15:25', 0, 4, '402881fb624b78cd01624b7bd7fe0380', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb624b78cd01624b7d4b9b0385', '申请退费（含撤消申请）', 'pub', 'W', 'cskefu', NULL, '402881fb624b78cd01624b7bd7fe0380', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-22 10:15:25', '2018-03-22 10:15:25', 0, 5, '402881fb624b78cd01624b7bd7fe0380', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb624b78cd01624b7d4bad0386', '成功处理', 'pub', 'S', 'cskefu', NULL, '402881fb624b78cd01624b7bd7fe0380', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-22 10:15:25', '2018-03-22 10:15:25', 0, 6, '402881fb624b78cd01624b7bd7fe0380', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb624b78cd01624b7d4bbc0387', '挂号已取号（线下状态）', 'pub', 'G', 'cskefu', NULL, '402881fb624b78cd01624b7bd7fe0380', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-22 10:15:25', '2018-03-22 10:15:25', 0, 7, '402881fb624b78cd01624b7bd7fe0380', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb624c612401624c6fb495043d', '工单问题类别', 'pub', 'com.dic.workorders.category', NULL, 'data', '0', '', NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-22 14:40:11', NULL, 1, 0, NULL, 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb624c612401624c70fdea043e', '畜牧类', 'pub', 'a', 'cskefu', 'layui-icon', '402881fb624c612401624c6fb495043d', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-22 14:41:36', NULL, 1, 0, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb624c612401624c7125d0043f', '猪', 'pub', 'a1', 'cskefu', 'layui-icon', '402881fb624c612401624c70fdea043e', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-22 14:41:46', NULL, 1, 0, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251a290016251a53aa1051a', '蔬菜类', 'pub', 'b', 'cskefu', NULL, '402881fb624c612401624c6fb495043d', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 14:56:45', '2018-03-23 14:56:45', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251a290016251a53ac0051b', '大田类', 'pub', 'c', 'cskefu', NULL, '402881fb624c612401624c6fb495043d', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 14:56:45', '2018-03-23 14:56:45', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251a290016251a53ad9051c', '生产类', 'pub', 'd', 'cskefu', NULL, '402881fb624c612401624c6fb495043d', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 14:56:45', '2018-03-23 14:56:45', 0, 4, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251a290016251a53af4051d', '政策类', 'pub', 'e', 'cskefu', NULL, '402881fb624c612401624c6fb495043d', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 14:56:45', '2018-03-23 14:56:45', 0, 5, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251a290016251a53b0f051e', '气象类', 'pub', 'f', 'cskefu', NULL, '402881fb624c612401624c6fb495043d', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 14:56:45', '2018-03-23 14:56:45', 0, 6, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251a290016251a53b2b051f', '采集员', 'pub', 'g', 'cskefu', NULL, '402881fb624c612401624c6fb495043d', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 14:56:45', '2018-03-23 14:56:45', 0, 7, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251a290016251a53b440520', '其他类', 'pub', 'h', 'cskefu', NULL, '402881fb624c612401624c6fb495043d', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 14:56:45', '2018-03-23 14:56:45', 0, 8, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251a290016251a63bfd0521', '牛', 'pub', 'a2', 'cskefu', NULL, '402881fb624c612401624c70fdea043e', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 14:57:51', '2018-03-23 14:57:51', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251a290016251a63c0b0522', '羊', 'pub', 'a3', 'cskefu', NULL, '402881fb624c612401624c70fdea043e', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 14:57:51', '2018-03-23 14:57:51', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251a290016251a63c190523', '鹅', 'pub', 'a4', 'cskefu', NULL, '402881fb624c612401624c70fdea043e', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 14:57:51', '2018-03-23 14:57:51', 0, 4, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251a290016251a63c2e0524', '兔', 'pub', 'a5', 'cskefu', NULL, '402881fb624c612401624c70fdea043e', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 14:57:51', '2018-03-23 14:57:51', 0, 5, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251a290016251a63c3b0525', '鸭', 'pub', 'a6', 'cskefu', NULL, '402881fb624c612401624c70fdea043e', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 14:57:51', '2018-03-23 14:57:51', 0, 6, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251a290016251a63c470526', '鸽子', 'pub', 'a7', 'cskefu', NULL, '402881fb624c612401624c70fdea043e', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 14:57:51', '2018-03-23 14:57:51', 0, 7, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251a290016251a63c550527', '毛皮动物', 'pub', 'a8', 'cskefu', NULL, '402881fb624c612401624c70fdea043e', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 14:57:51', '2018-03-23 14:57:51', 0, 8, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251a290016251a63c620528', '狗', 'pub', 'a9', 'cskefu', NULL, '402881fb624c612401624c70fdea043e', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 14:57:51', '2018-03-23 14:57:51', 0, 9, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251a290016251a63c6d0529', '鹿', 'pub', 'a10', 'cskefu', NULL, '402881fb624c612401624c70fdea043e', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 14:57:51', '2018-03-23 14:57:51', 0, 10, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251a290016251a63c79052a', '水产', 'pub', 'a11', 'cskefu', NULL, '402881fb624c612401624c70fdea043e', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 14:57:51', '2018-03-23 14:57:51', 0, 11, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251a290016251a63c87052b', '饲料', 'pub', 'a12', 'cskefu', NULL, '402881fb624c612401624c70fdea043e', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 14:57:51', '2018-03-23 14:57:51', 0, 12, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251a290016251a63c93052c', '马', 'pub', 'a13', 'cskefu', NULL, '402881fb624c612401624c70fdea043e', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 14:57:51', '2018-03-23 14:57:51', 0, 13, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251a290016251a63c9f052d', '蛋鸡', 'pub', 'a14', 'cskefu', NULL, '402881fb624c612401624c70fdea043e', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 14:57:51', '2018-03-23 14:57:51', 0, 14, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251a290016251a63caa052e', '淘汰鸡', 'pub', 'a15', 'cskefu', NULL, '402881fb624c612401624c70fdea043e', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 14:57:51', '2018-03-23 14:57:51', 0, 15, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251a290016251a63cb6052f', '肉鸡', 'pub', 'a16', 'cskefu', NULL, '402881fb624c612401624c70fdea043e', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 14:57:51', '2018-03-23 14:57:51', 0, 16, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251a290016251a63cc30530', '其他', 'pub', 'a17', 'cskefu', NULL, '402881fb624c612401624c70fdea043e', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 14:57:51', '2018-03-23 14:57:51', 0, 17, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251a290016251a63cd00531', '鸡蛋', 'pub', 'a18', 'cskefu', NULL, '402881fb624c612401624c70fdea043e', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 14:57:51', '2018-03-23 14:57:51', 0, 18, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251f8f96e0351', '市场行情', 'pub', 'a11', 'cskefu', NULL, '402881fb624c612401624c7125d0043f', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:28:14', '2018-03-23 16:28:14', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251f8f9860352', '疾病疫情', 'pub', 'a12', 'cskefu', NULL, '402881fb624c612401624c7125d0043f', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:28:14', '2018-03-23 16:28:14', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251f8f9a00353', '饲养技术', 'pub', 'a13', 'cskefu', NULL, '402881fb624c612401624c7125d0043f', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:28:14', '2018-03-23 16:28:14', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251f8f9b80354', '其他', 'pub', 'a14', 'cskefu', NULL, '402881fb624c612401624c7125d0043f', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:28:14', '2018-03-23 16:28:14', 0, 4, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251f92ed30355', '市场行情', 'pub', 'a21', 'cskefu', NULL, '402881fb6251a290016251a63bfd0521', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:28:27', '2018-03-23 16:28:27', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251f92ef00356', '疾病疫情', 'pub', 'a22', 'cskefu', NULL, '402881fb6251a290016251a63bfd0521', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:28:27', '2018-03-23 16:28:27', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251f92f080357', '饲养技术', 'pub', 'a23', 'cskefu', NULL, '402881fb6251a290016251a63bfd0521', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:28:27', '2018-03-23 16:28:27', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251f92f210358', '其他', 'pub', 'a24', 'cskefu', NULL, '402881fb6251a290016251a63bfd0521', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:28:27', '2018-03-23 16:28:27', 0, 4, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251f9b2000359', '市场行情', 'pub', 'a31', 'cskefu', NULL, '402881fb6251a290016251a63c0b0522', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:29:01', '2018-03-23 16:29:01', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251f9b219035a', '疾病疫情', 'pub', 'a32', 'cskefu', NULL, '402881fb6251a290016251a63c0b0522', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:29:01', '2018-03-23 16:29:01', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251f9b237035b', '饲养技术', 'pub', 'a33', 'cskefu', NULL, '402881fb6251a290016251a63c0b0522', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:29:01', '2018-03-23 16:29:01', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251f9b253035c', '其他', 'pub', 'a34', 'cskefu', NULL, '402881fb6251a290016251a63c0b0522', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:29:01', '2018-03-23 16:29:01', 0, 4, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fa367c035d', '市场行情', 'pub', 'a41', 'cskefu', 'layui-icon', '402881fb6251a290016251a63c190523', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:29:35', '2018-03-23 16:29:35', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fa3698035e', '疾病疫情', 'pub', 'a42', 'cskefu', 'layui-icon', '402881fb6251a290016251a63c190523', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:29:35', '2018-03-23 16:29:35', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fa36af035f', '饲养技术', 'pub', 'a43', 'cskefu', 'layui-icon', '402881fb6251a290016251a63c190523', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:29:35', '2018-03-23 16:29:35', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fa36c80360', '其他', 'pub', 'a44', 'cskefu', 'layui-icon', '402881fb6251a290016251a63c190523', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:29:35', '2018-03-23 16:29:35', 0, 4, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fae0a10361', '市场行情', 'pub', 'a51', 'cskefu', NULL, '402881fb6251a290016251a63c2e0524', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:30:18', '2018-03-23 16:30:18', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fae0bc0362', '疾病疫情', 'pub', 'a52', 'cskefu', NULL, '402881fb6251a290016251a63c2e0524', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:30:18', '2018-03-23 16:30:18', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fae0d50363', '饲养技术', 'pub', 'a53', 'cskefu', NULL, '402881fb6251a290016251a63c2e0524', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:30:18', '2018-03-23 16:30:18', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fae0ec0364', '其他', 'pub', 'a54', 'cskefu', NULL, '402881fb6251a290016251a63c2e0524', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:30:18', '2018-03-23 16:30:18', 0, 4, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fb24be0367', '市场行情', 'pub', 'a61', 'cskefu', NULL, '402881fb6251a290016251a63c3b0525', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:30:36', '2018-03-23 16:30:36', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fb24db0368', '疾病疫情', 'pub', 'a62', 'cskefu', NULL, '402881fb6251a290016251a63c3b0525', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:30:36', '2018-03-23 16:30:36', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fb24f80369', '饲养技术', 'pub', 'a63', 'cskefu', NULL, '402881fb6251a290016251a63c3b0525', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:30:36', '2018-03-23 16:30:36', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fb2516036a', '其他', 'pub', 'a64', 'cskefu', NULL, '402881fb6251a290016251a63c3b0525', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:30:36', '2018-03-23 16:30:36', 0, 4, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fb49c0036b', '市场行情', 'pub', 'a71', 'cskefu', NULL, '402881fb6251a290016251a63c470526', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:30:45', '2018-03-23 16:30:45', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fb49db036c', '疾病疫情', 'pub', 'a72', 'cskefu', NULL, '402881fb6251a290016251a63c470526', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:30:45', '2018-03-23 16:30:45', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fb49f3036d', '饲养技术', 'pub', 'a73', 'cskefu', NULL, '402881fb6251a290016251a63c470526', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:30:45', '2018-03-23 16:30:45', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fb4a0d036e', '其他', 'pub', 'a74', 'cskefu', NULL, '402881fb6251a290016251a63c470526', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:30:45', '2018-03-23 16:30:45', 0, 4, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fb7acd036f', '市场行情', 'pub', 'a81', 'cskefu', NULL, '402881fb6251a290016251a63c550527', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:30:58', '2018-03-23 16:30:58', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fb7aea0370', '疾病疫情', 'pub', 'a82', 'cskefu', NULL, '402881fb6251a290016251a63c550527', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:30:58', '2018-03-23 16:30:58', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fb7b030371', '饲养技术', 'pub', 'a83', 'cskefu', NULL, '402881fb6251a290016251a63c550527', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:30:58', '2018-03-23 16:30:58', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fb7b190372', '其他', 'pub', 'a84', 'cskefu', NULL, '402881fb6251a290016251a63c550527', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:30:58', '2018-03-23 16:30:58', 0, 4, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fb9fe20373', '市场行情', 'pub', 'a91', 'cskefu', NULL, '402881fb6251a290016251a63c620528', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:31:07', '2018-03-23 16:31:07', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fb9fff0374', '疾病疫情', 'pub', 'a92', 'cskefu', NULL, '402881fb6251a290016251a63c620528', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:31:07', '2018-03-23 16:31:07', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fba01a0375', '饲养技术', 'pub', 'a93', 'cskefu', NULL, '402881fb6251a290016251a63c620528', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:31:07', '2018-03-23 16:31:07', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fba0350376', '其他', 'pub', 'a94', 'cskefu', NULL, '402881fb6251a290016251a63c620528', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:31:07', '2018-03-23 16:31:07', 0, 4, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fbd1c60377', '市场行情', 'pub', 'a101', 'cskefu', NULL, '402881fb6251a290016251a63c6d0529', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:31:20', '2018-03-23 16:31:20', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fbd1df0378', '疾病疫情', 'pub', 'a102', 'cskefu', NULL, '402881fb6251a290016251a63c6d0529', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:31:20', '2018-03-23 16:31:20', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fbd1f80379', '饲养技术', 'pub', 'a103', 'cskefu', NULL, '402881fb6251a290016251a63c6d0529', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:31:20', '2018-03-23 16:31:20', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fbd211037a', '其他', 'pub', 'a104', 'cskefu', NULL, '402881fb6251a290016251a63c6d0529', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:31:20', '2018-03-23 16:31:20', 0, 4, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fc256f037b', '市场行情', 'pub', 'a111', 'cskefu', NULL, '402881fb6251a290016251a63c79052a', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:31:41', '2018-03-23 16:31:41', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fc2589037c', '疾病疫情', 'pub', 'a112', 'cskefu', NULL, '402881fb6251a290016251a63c79052a', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:31:41', '2018-03-23 16:31:41', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fc25a2037d', '饲养技术', 'pub', 'a113', 'cskefu', NULL, '402881fb6251a290016251a63c79052a', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:31:41', '2018-03-23 16:31:41', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fc25ba037e', '其他', 'pub', 'a114', 'cskefu', NULL, '402881fb6251a290016251a63c79052a', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:31:42', '2018-03-23 16:31:42', 0, 4, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fc4168037f', '市场行情', 'pub', 'a121', 'cskefu', NULL, '402881fb6251a290016251a63c87052b', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:31:49', '2018-03-23 16:31:49', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fc41830380', '疾病疫情', 'pub', 'a122', 'cskefu', NULL, '402881fb6251a290016251a63c87052b', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:31:49', '2018-03-23 16:31:49', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fc419f0381', '饲养技术', 'pub', 'a123', 'cskefu', NULL, '402881fb6251a290016251a63c87052b', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:31:49', '2018-03-23 16:31:49', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fc41b90382', '其他', 'pub', 'a124', 'cskefu', NULL, '402881fb6251a290016251a63c87052b', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:31:49', '2018-03-23 16:31:49', 0, 4, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fc683e0383', '市场行情', 'pub', 'a131', 'cskefu', NULL, '402881fb6251a290016251a63c93052c', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:31:59', '2018-03-23 16:31:59', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fc68570384', '疾病疫情', 'pub', 'a132', 'cskefu', NULL, '402881fb6251a290016251a63c93052c', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:31:59', '2018-03-23 16:31:59', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fc686f0385', '饲养技术', 'pub', 'a133', 'cskefu', NULL, '402881fb6251a290016251a63c93052c', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:31:59', '2018-03-23 16:31:59', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fc68810386', '其他', 'pub', 'a134', 'cskefu', NULL, '402881fb6251a290016251a63c93052c', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:31:59', '2018-03-23 16:31:59', 0, 4, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fc95d20387', '市场行情', 'pub', 'a141', 'cskefu', NULL, '402881fb6251a290016251a63c9f052d', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:32:10', '2018-03-23 16:32:10', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fc95ee0388', '疾病疫情', 'pub', 'a142', 'cskefu', NULL, '402881fb6251a290016251a63c9f052d', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:32:10', '2018-03-23 16:32:10', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fc96080389', '饲养技术', 'pub', 'a143', 'cskefu', NULL, '402881fb6251a290016251a63c9f052d', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:32:10', '2018-03-23 16:32:10', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fc9621038a', '其他', 'pub', 'a144', 'cskefu', NULL, '402881fb6251a290016251a63c9f052d', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:32:10', '2018-03-23 16:32:10', 0, 4, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fcbddb038b', '市场行情', 'pub', 'a151', 'cskefu', NULL, '402881fb6251a290016251a63caa052e', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:32:20', '2018-03-23 16:32:20', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fcbdf4038c', '疾病疫情', 'pub', 'a152', 'cskefu', NULL, '402881fb6251a290016251a63caa052e', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:32:20', '2018-03-23 16:32:20', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fcbe0e038d', '饲养技术', 'pub', 'a153', 'cskefu', NULL, '402881fb6251a290016251a63caa052e', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:32:20', '2018-03-23 16:32:20', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fcbe26038e', '其他', 'pub', 'a154', 'cskefu', NULL, '402881fb6251a290016251a63caa052e', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:32:21', '2018-03-23 16:32:21', 0, 4, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fcf7d2038f', '市场行情', 'pub', 'a161', 'cskefu', NULL, '402881fb6251a290016251a63cb6052f', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:32:35', '2018-03-23 16:32:35', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fcf7ec0390', '疾病疫情', 'pub', 'a162', 'cskefu', NULL, '402881fb6251a290016251a63cb6052f', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:32:35', '2018-03-23 16:32:35', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fcf8060391', '饲养技术', 'pub', 'a163', 'cskefu', NULL, '402881fb6251a290016251a63cb6052f', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:32:35', '2018-03-23 16:32:35', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fcf81f0392', '其他', 'pub', 'a164', 'cskefu', NULL, '402881fb6251a290016251a63cb6052f', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:32:35', '2018-03-23 16:32:35', 0, 4, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fd1fcc0393', '市场行情', 'pub', 'a171', 'cskefu', NULL, '402881fb6251a290016251a63cc30530', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:32:46', '2018-03-23 16:32:46', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fd1ff90394', '疾病疫情', 'pub', 'a172', 'cskefu', NULL, '402881fb6251a290016251a63cc30530', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:32:46', '2018-03-23 16:32:46', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fd20150395', '饲养技术', 'pub', 'a173', 'cskefu', NULL, '402881fb6251a290016251a63cc30530', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:32:46', '2018-03-23 16:32:46', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fd203a0396', '其他', 'pub', 'a174', 'cskefu', NULL, '402881fb6251a290016251a63cc30530', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:32:46', '2018-03-23 16:32:46', 0, 4, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fd505f0397', '市场行情', 'pub', 'a181', 'cskefu', NULL, '402881fb6251a290016251a63cd00531', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:32:58', '2018-03-23 16:32:58', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fd507c0398', '疾病疫情', 'pub', 'a182', 'cskefu', NULL, '402881fb6251a290016251a63cd00531', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:32:58', '2018-03-23 16:32:58', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fd50920399', '饲养技术', 'pub', 'a183', 'cskefu', NULL, '402881fb6251a290016251a63cd00531', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:32:58', '2018-03-23 16:32:58', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fd50aa039a', '其他', 'pub', 'a184', 'cskefu', NULL, '402881fb6251a290016251a63cd00531', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:32:58', '2018-03-23 16:32:58', 0, 4, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fe9bf6039b', '蔬菜', 'pub', 'b1', 'cskefu', NULL, '402881fb6251a290016251a53aa1051a', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:34:23', '2018-03-23 16:34:23', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fe9c15039c', '果树', 'pub', 'b2', 'cskefu', NULL, '402881fb6251a290016251a53aa1051a', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:34:23', '2018-03-23 16:34:23', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fe9c2e039d', '园林花卉', 'pub', 'b3', 'cskefu', NULL, '402881fb6251a290016251a53aa1051a', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:34:23', '2018-03-23 16:34:23', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fe9c46039e', '食用菌', 'pub', 'b4', 'cskefu', NULL, '402881fb6251a290016251a53aa1051a', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:34:23', '2018-03-23 16:34:23', 0, 4, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fe9c5d039f', '中药材', 'pub', 'b5', 'cskefu', NULL, '402881fb6251a290016251a53aa1051a', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:34:23', '2018-03-23 16:34:23', 0, 5, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fe9c7503a0', '山野菜', 'pub', 'b6', 'cskefu', NULL, '402881fb6251a290016251a53aa1051a', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:34:23', '2018-03-23 16:34:23', 0, 6, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fe9c9003a1', '黄瓜', 'pub', 'b7', 'cskefu', NULL, '402881fb6251a290016251a53aa1051a', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:34:23', '2018-03-23 16:34:23', 0, 7, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fe9caa03a2', '番茄', 'pub', 'b8', 'cskefu', NULL, '402881fb6251a290016251a53aa1051a', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:34:23', '2018-03-23 16:34:23', 0, 8, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fe9cc203a3', '西甜瓜', 'pub', 'b9', 'cskefu', NULL, '402881fb6251a290016251a53aa1051a', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:34:23', '2018-03-23 16:34:23', 0, 9, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fe9cd803a4', '茄子', 'pub', 'b10', 'cskefu', NULL, '402881fb6251a290016251a53aa1051a', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:34:23', '2018-03-23 16:34:23', 0, 10, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fe9cef03a5', '三辣', 'pub', 'b11', 'cskefu', NULL, '402881fb6251a290016251a53aa1051a', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:34:23', '2018-03-23 16:34:23', 0, 11, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fe9d0603a6', '马铃薯', 'pub', 'b12', 'cskefu', NULL, '402881fb6251a290016251a53aa1051a', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:34:23', '2018-03-23 16:34:23', 0, 12, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fe9d1b03a7', '白菜', 'pub', 'b13', 'cskefu', NULL, '402881fb6251a290016251a53aa1051a', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:34:23', '2018-03-23 16:34:23', 0, 13, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fe9d3103a8', '豆角', 'pub', 'b14', 'cskefu', NULL, '402881fb6251a290016251a53aa1051a', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:34:23', '2018-03-23 16:34:23', 0, 14, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fe9d4a03a9', '毛葱', 'pub', 'b15', 'cskefu', NULL, '402881fb6251a290016251a53aa1051a', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:34:23', '2018-03-23 16:34:23', 0, 15, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fe9d6203aa', '大葱', 'pub', 'b16', 'cskefu', NULL, '402881fb6251a290016251a53aa1051a', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:34:23', '2018-03-23 16:34:23', 0, 16, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fe9d7903ab', '芹菜', 'pub', 'b17', 'cskefu', NULL, '402881fb6251a290016251a53aa1051a', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:34:23', '2018-03-23 16:34:23', 0, 17, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fe9d8f03ac', '萝卜', 'pub', 'b18', 'cskefu', NULL, '402881fb6251a290016251a53aa1051a', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:34:23', '2018-03-23 16:34:23', 0, 18, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fe9da503ad', '胡萝卜', 'pub', 'b19', 'cskefu', NULL, '402881fb6251a290016251a53aa1051a', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:34:23', '2018-03-23 16:34:23', 0, 19, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fe9dbc03ae', '甘蓝', 'pub', 'b20', 'cskefu', NULL, '402881fb6251a290016251a53aa1051a', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:34:23', '2018-03-23 16:34:23', 0, 20, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fe9dd503af', '花卉', 'pub', 'b21', 'cskefu', NULL, '402881fb6251a290016251a53aa1051a', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:34:23', '2018-03-23 16:34:23', 0, 21, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fe9dec03b0', '葡萄', 'pub', 'b22', 'cskefu', NULL, '402881fb6251a290016251a53aa1051a', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:34:23', '2018-03-23 16:34:23', 0, 22, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fe9e0303b1', '苹果', 'pub', 'b23', 'cskefu', NULL, '402881fb6251a290016251a53aa1051a', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:34:23', '2018-03-23 16:34:23', 0, 23, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fe9e1a03b2', '草莓', 'pub', 'b24', 'cskefu', NULL, '402881fb6251a290016251a53aa1051a', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:34:23', '2018-03-23 16:34:23', 0, 24, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fe9e3103b3', '苹果梨', 'pub', 'b25', 'cskefu', NULL, '402881fb6251a290016251a53aa1051a', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:34:23', '2018-03-23 16:34:23', 0, 25, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fe9e4703b4', '蓝莓', 'pub', 'b26', 'cskefu', NULL, '402881fb6251a290016251a53aa1051a', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:34:23', '2018-03-23 16:34:23', 0, 26, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fe9e5e03b5', '樱桃', 'pub', 'b27', 'cskefu', NULL, '402881fb6251a290016251a53aa1051a', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:34:23', '2018-03-23 16:34:23', 0, 27, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fe9e7503b6', '板栗', 'pub', 'b28', 'cskefu', NULL, '402881fb6251a290016251a53aa1051a', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:34:23', '2018-03-23 16:34:23', 0, 28, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fe9e8c03b7', '桃', 'pub', 'b29', 'cskefu', NULL, '402881fb6251a290016251a53aa1051a', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:34:24', '2018-03-23 16:34:24', 0, 29, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fe9ea303b8', '钙果', 'pub', 'b30', 'cskefu', NULL, '402881fb6251a290016251a53aa1051a', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:34:24', '2018-03-23 16:34:24', 0, 30, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fe9eba03b9', '其他', 'pub', 'b31', 'cskefu', NULL, '402881fb6251a290016251a53aa1051a', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:34:24', '2018-03-23 16:34:24', 0, 31, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fe9ed103ba', '桃李杏', 'pub', 'b32', 'cskefu', NULL, '402881fb6251a290016251a53aa1051a', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:34:24', '2018-03-23 16:34:24', 0, 32, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016251fe9ee903bb', '叶菜', 'pub', 'b33', 'cskefu', NULL, '402881fb6251a290016251a53aa1051a', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 16:34:24', '2018-03-23 16:34:24', 0, 33, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625219783f03c6', '市场行情', 'pub', 'b31_1', 'cskefu', NULL, '402881fb6251f622016251fe9eba03b9', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:43', '2018-03-23 17:03:43', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625219784103c7', '市场行情', 'pub', 'b30_1', 'cskefu', NULL, '402881fb6251f622016251fe9ea303b8', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:43', '2018-03-23 17:03:43', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625219787003c8', '栽培技术', 'pub', 'b30_2', 'cskefu', NULL, '402881fb6251f622016251fe9ea303b8', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:43', '2018-03-23 17:03:43', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625219787303c9', '市场行情', 'pub', 'b33_1', 'cskefu', NULL, '402881fb6251f622016251fe9ee903bb', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:43', '2018-03-23 17:03:43', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625219787303ca', '市场行情', 'pub', 'b29_1', 'cskefu', NULL, '402881fb6251f622016251fe9e8c03b7', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:43', '2018-03-23 17:03:43', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625219787403cb', '市场行情', 'pub', 'b32_1', 'cskefu', NULL, '402881fb6251f622016251fe9ed103ba', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:43', '2018-03-23 17:03:43', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625219787f03cc', '栽培技术', 'pub', 'b31_2', 'cskefu', NULL, '402881fb6251f622016251fe9eba03b9', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:43', '2018-03-23 17:03:43', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625219788c03cd', '栽培技术', 'pub', 'b33_2', 'cskefu', NULL, '402881fb6251f622016251fe9ee903bb', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:43', '2018-03-23 17:03:43', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625219788d03ce', '病虫草害', 'pub', 'b30_3', 'cskefu', NULL, '402881fb6251f622016251fe9ea303b8', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:43', '2018-03-23 17:03:43', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625219789903cf', '栽培技术', 'pub', 'b29_2', 'cskefu', NULL, '402881fb6251f622016251fe9e8c03b7', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:43', '2018-03-23 17:03:43', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625219789b03d0', '栽培技术', 'pub', 'b32_2', 'cskefu', NULL, '402881fb6251f622016251fe9ed103ba', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:43', '2018-03-23 17:03:43', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625219789b03d1', '病虫草害', 'pub', 'b33_3', 'cskefu', NULL, '402881fb6251f622016251fe9ee903bb', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:43', '2018-03-23 17:03:43', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162521978b203d2', '病虫草害', 'pub', 'b29_3', 'cskefu', NULL, '402881fb6251f622016251fe9e8c03b7', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:43', '2018-03-23 17:03:43', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162521978b203d3', '病虫草害', 'pub', 'b31_3', 'cskefu', NULL, '402881fb6251f622016251fe9eba03b9', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:43', '2018-03-23 17:03:43', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162521978b203d4', '病虫草害', 'pub', 'b32_3', 'cskefu', NULL, '402881fb6251f622016251fe9ed103ba', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:43', '2018-03-23 17:03:43', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162521979ca03d5', '市场行情', 'pub', 'b1_1', 'cskefu', NULL, '402881fb6251f622016251fe9bf6039b', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:43', '2018-03-23 17:03:43', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162521979e003d6', '栽培技术', 'pub', 'b1_2', 'cskefu', NULL, '402881fb6251f622016251fe9bf6039b', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:44', '2018-03-23 17:03:44', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162521979f103d7', '病虫草害', 'pub', 'b1_3', 'cskefu', NULL, '402881fb6251f622016251fe9bf6039b', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:44', '2018-03-23 17:03:44', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252197d0d03d8', '市场行情', 'pub', 'b5_1', 'cskefu', NULL, '402881fb6251f622016251fe9c5d039f', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:44', '2018-03-23 17:03:44', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252197d0d03d9', '市场行情', 'pub', 'b6_1', 'cskefu', NULL, '402881fb6251f622016251fe9c7503a0', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:44', '2018-03-23 17:03:44', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252197d1d03da', '市场行情', 'pub', 'b7_1', 'cskefu', NULL, '402881fb6251f622016251fe9c9003a1', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:44', '2018-03-23 17:03:44', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252197d2c03db', '栽培技术', 'pub', 'b5_2', 'cskefu', NULL, '402881fb6251f622016251fe9c5d039f', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:44', '2018-03-23 17:03:44', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252197d2c03dc', '栽培技术', 'pub', 'b6_2', 'cskefu', NULL, '402881fb6251f622016251fe9c7503a0', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:44', '2018-03-23 17:03:44', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252197d3803dd', '市场行情', 'pub', 'b2_1', 'cskefu', NULL, '402881fb6251f622016251fe9c15039c', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:44', '2018-03-23 17:03:44', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252197d5903de', '市场行情', 'pub', 'b4_1', 'cskefu', NULL, '402881fb6251f622016251fe9c46039e', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:44', '2018-03-23 17:03:44', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252197d6003df', '病虫草害', 'pub', 'b6_3', 'cskefu', NULL, '402881fb6251f622016251fe9c7503a0', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:44', '2018-03-23 17:03:44', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252197d7103e0', '栽培技术', 'pub', 'b4_2', 'cskefu', NULL, '402881fb6251f622016251fe9c46039e', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:44', '2018-03-23 17:03:44', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252197d7403e1', '市场行情', 'pub', 'b3_1', 'cskefu', NULL, '402881fb6251f622016251fe9c2e039d', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:44', '2018-03-23 17:03:44', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252197d7a03e2', '栽培技术', 'pub', 'b2_2', 'cskefu', NULL, '402881fb6251f622016251fe9c15039c', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:44', '2018-03-23 17:03:44', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252197d7b03e3', '病虫草害', 'pub', 'b5_3', 'cskefu', NULL, '402881fb6251f622016251fe9c5d039f', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:44', '2018-03-23 17:03:44', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252197d8c03e4', '病虫草害', 'pub', 'b4_3', 'cskefu', NULL, '402881fb6251f622016251fe9c46039e', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:45', '2018-03-23 17:03:45', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252197d9003e5', '栽培技术', 'pub', 'b7_2', 'cskefu', NULL, '402881fb6251f622016251fe9c9003a1', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:45', '2018-03-23 17:03:45', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252197d9a03e6', '栽培技术', 'pub', 'b3_2', 'cskefu', NULL, '402881fb6251f622016251fe9c2e039d', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:45', '2018-03-23 17:03:45', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252197d9e03e7', '病虫草害', 'pub', 'b2_3', 'cskefu', NULL, '402881fb6251f622016251fe9c15039c', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:45', '2018-03-23 17:03:45', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252197db703e8', '病虫草害', 'pub', 'b3_3', 'cskefu', NULL, '402881fb6251f622016251fe9c2e039d', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:45', '2018-03-23 17:03:45', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252197db803e9', '病虫草害', 'pub', 'b7_3', 'cskefu', NULL, '402881fb6251f622016251fe9c9003a1', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:45', '2018-03-23 17:03:45', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252197f8603ea', '市场行情', 'pub', 'b12_1', 'cskefu', NULL, '402881fb6251f622016251fe9d0603a6', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:45', '2018-03-23 17:03:45', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252197f8903eb', '市场行情', 'pub', 'b10_1', 'cskefu', NULL, '402881fb6251f622016251fe9cd803a4', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:45', '2018-03-23 17:03:45', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252197f8b03ec', '市场行情', 'pub', 'b9_1', 'cskefu', NULL, '402881fb6251f622016251fe9cc203a3', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:45', '2018-03-23 17:03:45', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252197f9c03ed', '栽培技术', 'pub', 'b10_2', 'cskefu', NULL, '402881fb6251f622016251fe9cd803a4', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:45', '2018-03-23 17:03:45', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252197f9c03ee', '栽培技术', 'pub', 'b12_2', 'cskefu', NULL, '402881fb6251f622016251fe9d0603a6', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:45', '2018-03-23 17:03:45', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252197fa303ef', '栽培技术', 'pub', 'b9_2', 'cskefu', NULL, '402881fb6251f622016251fe9cc203a3', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:45', '2018-03-23 17:03:45', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252197faa03f0', '市场行情', 'pub', 'b11_1', 'cskefu', NULL, '402881fb6251f622016251fe9cef03a5', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:45', '2018-03-23 17:03:45', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252197fb903f1', '病虫草害', 'pub', 'b10_3', 'cskefu', NULL, '402881fb6251f622016251fe9cd803a4', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:45', '2018-03-23 17:03:45', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252197fbc03f2', '病虫草害', 'pub', 'b9_3', 'cskefu', NULL, '402881fb6251f622016251fe9cc203a3', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:45', '2018-03-23 17:03:45', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252197fc803f3', '病虫草害', 'pub', 'b12_3', 'cskefu', NULL, '402881fb6251f622016251fe9d0603a6', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:45', '2018-03-23 17:03:45', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252197fcc03f4', '市场行情', 'pub', 'b8_1', 'cskefu', NULL, '402881fb6251f622016251fe9caa03a2', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:45', '2018-03-23 17:03:45', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252197fe603f5', '栽培技术', 'pub', 'b8_2', 'cskefu', NULL, '402881fb6251f622016251fe9caa03a2', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:45', '2018-03-23 17:03:45', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625219800403f6', '病虫草害', 'pub', 'b8_3', 'cskefu', NULL, '402881fb6251f622016251fe9caa03a2', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:45', '2018-03-23 17:03:45', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625219800a03f7', '栽培技术', 'pub', 'b11_2', 'cskefu', NULL, '402881fb6251f622016251fe9cef03a5', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:45', '2018-03-23 17:03:45', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625219801003f8', '市场行情', 'pub', 'b13_1', 'cskefu', NULL, '402881fb6251f622016251fe9d1b03a7', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:45', '2018-03-23 17:03:45', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625219803103f9', '病虫草害', 'pub', 'b11_3', 'cskefu', NULL, '402881fb6251f622016251fe9cef03a5', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:45', '2018-03-23 17:03:45', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625219803103fa', '栽培技术', 'pub', 'b13_2', 'cskefu', NULL, '402881fb6251f622016251fe9d1b03a7', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:45', '2018-03-23 17:03:45', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625219806603fb', '市场行情', 'pub', 'b14_1', 'cskefu', NULL, '402881fb6251f622016251fe9d3103a8', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:45', '2018-03-23 17:03:45', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162521980d503fc', '病虫草害', 'pub', 'b13_3', 'cskefu', NULL, '402881fb6251f622016251fe9d1b03a7', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:45', '2018-03-23 17:03:45', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625219816403fd', '栽培技术', 'pub', 'b14_2', 'cskefu', NULL, '402881fb6251f622016251fe9d3103a8', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:45', '2018-03-23 17:03:45', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625219816603fe', '市场行情', 'pub', 'b15_1', 'cskefu', NULL, '402881fb6251f622016251fe9d4a03a9', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:46', '2018-03-23 17:03:46', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625219816d03ff', '市场行情', 'pub', 'b17_1', 'cskefu', NULL, '402881fb6251f622016251fe9d7903ab', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:46', '2018-03-23 17:03:46', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625219816f0400', '市场行情', 'pub', 'b18_1', 'cskefu', NULL, '402881fb6251f622016251fe9d8f03ac', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:46', '2018-03-23 17:03:46', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162521981760401', '市场行情', 'pub', 'b16_1', 'cskefu', NULL, '402881fb6251f622016251fe9d6203aa', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:46', '2018-03-23 17:03:46', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162521981860402', '病虫草害', 'pub', 'b14_3', 'cskefu', NULL, '402881fb6251f622016251fe9d3103a8', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:46', '2018-03-23 17:03:46', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625219818f0403', '栽培技术', 'pub', 'b15_2', 'cskefu', NULL, '402881fb6251f622016251fe9d4a03a9', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:46', '2018-03-23 17:03:46', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162521981920404', '栽培技术', 'pub', 'b17_2', 'cskefu', NULL, '402881fb6251f622016251fe9d7903ab', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:46', '2018-03-23 17:03:46', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162521981ac0405', '栽培技术', 'pub', 'b18_2', 'cskefu', NULL, '402881fb6251f622016251fe9d8f03ac', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:46', '2018-03-23 17:03:46', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162521981b50406', '栽培技术', 'pub', 'b16_2', 'cskefu', NULL, '402881fb6251f622016251fe9d6203aa', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:46', '2018-03-23 17:03:46', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162521981bb0407', '病虫草害', 'pub', 'b18_3', 'cskefu', NULL, '402881fb6251f622016251fe9d8f03ac', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:46', '2018-03-23 17:03:46', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162521981c60408', '病虫草害', 'pub', 'b16_3', 'cskefu', NULL, '402881fb6251f622016251fe9d6203aa', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:46', '2018-03-23 17:03:46', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162521981cc0409', '病虫草害', 'pub', 'b17_3', 'cskefu', NULL, '402881fb6251f622016251fe9d7903ab', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:46', '2018-03-23 17:03:46', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625219821f040a', '市场行情', 'pub', 'b19_1', 'cskefu', NULL, '402881fb6251f622016251fe9da503ad', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:46', '2018-03-23 17:03:46', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625219822e040b', '栽培技术', 'pub', 'b19_2', 'cskefu', NULL, '402881fb6251f622016251fe9da503ad', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:46', '2018-03-23 17:03:46', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625219823d040c', '市场行情', 'pub', 'b20_1', 'cskefu', NULL, '402881fb6251f622016251fe9dbc03ae', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:46', '2018-03-23 17:03:46', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625219823e040d', '病虫草害', 'pub', 'b19_3', 'cskefu', NULL, '402881fb6251f622016251fe9da503ad', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:46', '2018-03-23 17:03:46', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625219823e040e', '市场行情', 'pub', 'b21_1', 'cskefu', NULL, '402881fb6251f622016251fe9dd503af', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:46', '2018-03-23 17:03:46', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252198256040f', '市场行情', 'pub', 'b22_1', 'cskefu', NULL, '402881fb6251f622016251fe9dec03b0', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:46', '2018-03-23 17:03:46', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625219825b0410', '栽培技术', 'pub', 'b21_2', 'cskefu', NULL, '402881fb6251f622016251fe9dd503af', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:46', '2018-03-23 17:03:46', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625219826e0411', '栽培技术', 'pub', 'b22_2', 'cskefu', NULL, '402881fb6251f622016251fe9dec03b0', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:46', '2018-03-23 17:03:46', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162521982f90412', '病虫草害', 'pub', 'b21_3', 'cskefu', NULL, '402881fb6251f622016251fe9dd503af', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:46', '2018-03-23 17:03:46', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162521982fa0413', '栽培技术', 'pub', 'b20_2', 'cskefu', NULL, '402881fb6251f622016251fe9dbc03ae', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:46', '2018-03-23 17:03:46', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162521982fe0414', '病虫草害', 'pub', 'b15_3', 'cskefu', NULL, '402881fb6251f622016251fe9d4a03a9', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:46', '2018-03-23 17:03:46', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625219830e0415', '病虫草害', 'pub', 'b22_3', 'cskefu', NULL, '402881fb6251f622016251fe9dec03b0', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:46', '2018-03-23 17:03:46', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625219832a0416', '市场行情', 'pub', 'b23_1', 'cskefu', NULL, '402881fb6251f622016251fe9e0303b1', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:46', '2018-03-23 17:03:46', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162521983470417', '栽培技术', 'pub', 'b23_2', 'cskefu', NULL, '402881fb6251f622016251fe9e0303b1', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:46', '2018-03-23 17:03:46', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625219834f0418', '病虫草害', 'pub', 'b20_3', 'cskefu', NULL, '402881fb6251f622016251fe9dbc03ae', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:46', '2018-03-23 17:03:46', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162521983550419', '病虫草害', 'pub', 'b23_3', 'cskefu', NULL, '402881fb6251f622016251fe9e0303b1', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:46', '2018-03-23 17:03:46', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252198545041a', '市场行情', 'pub', 'b25_1', 'cskefu', NULL, '402881fb6251f622016251fe9e3103b3', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:47', '2018-03-23 17:03:47', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252198548041b', '市场行情', 'pub', 'b27_1', 'cskefu', NULL, '402881fb6251f622016251fe9e5e03b5', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:47', '2018-03-23 17:03:47', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252198550041c', '市场行情', 'pub', 'b24_1', 'cskefu', NULL, '402881fb6251f622016251fe9e1a03b2', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:47', '2018-03-23 17:03:47', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162521985b1041d', '栽培技术', 'pub', 'b24_2', 'cskefu', NULL, '402881fb6251f622016251fe9e1a03b2', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:47', '2018-03-23 17:03:47', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162521985b4041e', '市场行情', 'pub', 'b28_1', 'cskefu', NULL, '402881fb6251f622016251fe9e7503b6', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:47', '2018-03-23 17:03:47', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162521985c2041f', '栽培技术', 'pub', 'b27_2', 'cskefu', NULL, '402881fb6251f622016251fe9e5e03b5', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:47', '2018-03-23 17:03:47', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162521985c30420', '市场行情', 'pub', 'b26_1', 'cskefu', NULL, '402881fb6251f622016251fe9e4703b4', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:47', '2018-03-23 17:03:47', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162521985d20421', '栽培技术', 'pub', 'b28_2', 'cskefu', NULL, '402881fb6251f622016251fe9e7503b6', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:47', '2018-03-23 17:03:47', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162521985d20422', '病虫草害', 'pub', 'b24_3', 'cskefu', NULL, '402881fb6251f622016251fe9e1a03b2', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:47', '2018-03-23 17:03:47', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162521985dc0423', '病虫草害', 'pub', 'b27_3', 'cskefu', NULL, '402881fb6251f622016251fe9e5e03b5', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:47', '2018-03-23 17:03:47', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162521985e30424', '病虫草害', 'pub', 'b28_3', 'cskefu', NULL, '402881fb6251f622016251fe9e7503b6', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:47', '2018-03-23 17:03:47', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162521985ed0425', '栽培技术', 'pub', 'b26_2', 'cskefu', NULL, '402881fb6251f622016251fe9e4703b4', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:47', '2018-03-23 17:03:47', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162521985fd0426', '病虫草害', 'pub', 'b26_3', 'cskefu', NULL, '402881fb6251f622016251fe9e4703b4', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:47', '2018-03-23 17:03:47', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625219867d0427', '栽培技术', 'pub', 'b25_2', 'cskefu', NULL, '402881fb6251f622016251fe9e3103b3', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:47', '2018-03-23 17:03:47', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162521986ce0428', '病虫草害', 'pub', 'b25_3', 'cskefu', NULL, '402881fb6251f622016251fe9e3103b3', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:03:47', '2018-03-23 17:03:47', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162521a4ccd0429', '种子', 'pub', 'c1', 'cskefu', NULL, '402881fb6251a290016251a53ac0051b', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:04:38', '2018-03-23 17:04:38', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162521a4cdd042a', '农药', 'pub', 'c2', 'cskefu', NULL, '402881fb6251a290016251a53ac0051b', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:04:38', '2018-03-23 17:04:38', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162521a4ce9042b', '农膜', 'pub', 'c3', 'cskefu', NULL, '402881fb6251a290016251a53ac0051b', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:04:38', '2018-03-23 17:04:38', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162521a4cf5042c', '土肥', 'pub', 'c4', 'cskefu', NULL, '402881fb6251a290016251a53ac0051b', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:04:38', '2018-03-23 17:04:38', 0, 4, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162521a4d01042d', '沼气', 'pub', 'c5', 'cskefu', NULL, '402881fb6251a290016251a53ac0051b', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:04:38', '2018-03-23 17:04:38', 0, 5, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162521a4d0e042e', '绿色食品', 'pub', 'c6', 'cskefu', NULL, '402881fb6251a290016251a53ac0051b', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:04:38', '2018-03-23 17:04:38', 0, 6, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162521a4d1f042f', '农机', 'pub', 'c7', 'cskefu', NULL, '402881fb6251a290016251a53ac0051b', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:04:38', '2018-03-23 17:04:38', 0, 7, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162521a4d2b0430', '其他', 'pub', 'c8', 'cskefu', NULL, '402881fb6251a290016251a53ac0051b', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:04:38', '2018-03-23 17:04:38', 0, 8, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162521bac110434', '市场行情', 'pub', 'c1_1', 'cskefu', NULL, '402881fb6251f6220162521a4ccd0429', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:06:08', '2018-03-23 17:06:08', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162521bac200435', '栽培技术', 'pub', 'c1_2', 'cskefu', NULL, '402881fb6251f6220162521a4ccd0429', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:06:08', '2018-03-23 17:06:08', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162521bac310436', '病虫草害', 'pub', 'c1_3', 'cskefu', NULL, '402881fb6251f6220162521a4ccd0429', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:06:08', '2018-03-23 17:06:08', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625221e2800437', '市场行情', 'pub', 'c5_1', 'cskefu', NULL, '402881fb6251f6220162521a4d01042d', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:12:55', '2018-03-23 17:12:55', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625221e2800438', '市场行情', 'pub', 'c3_1', 'cskefu', NULL, '402881fb6251f6220162521a4ce9042b', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:12:55', '2018-03-23 17:12:55', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625221e2c80439', '市场行情', 'pub', 'c6_1', 'cskefu', NULL, '402881fb6251f6220162521a4d0e042e', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:12:55', '2018-03-23 17:12:55', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625221e2c8043a', '市场行情', 'pub', 'c4_1', 'cskefu', NULL, '402881fb6251f6220162521a4cf5042c', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:12:55', '2018-03-23 17:12:55', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625221e2cb043b', '市场行情', 'pub', 'c2_1', 'cskefu', NULL, '402881fb6251f6220162521a4cdd042a', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:12:55', '2018-03-23 17:12:55', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625221e2dc043c', '栽培技术', 'pub', 'c5_2', 'cskefu', NULL, '402881fb6251f6220162521a4d01042d', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:12:55', '2018-03-23 17:12:55', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625221e2dc043d', '栽培技术', 'pub', 'c2_2', 'cskefu', NULL, '402881fb6251f6220162521a4cdd042a', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:12:55', '2018-03-23 17:12:55', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625221e2de043e', '栽培技术', 'pub', 'c4_2', 'cskefu', NULL, '402881fb6251f6220162521a4cf5042c', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:12:55', '2018-03-23 17:12:55', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625221e2e9043f', '栽培技术', 'pub', 'c6_2', 'cskefu', NULL, '402881fb6251f6220162521a4d0e042e', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:12:55', '2018-03-23 17:12:55', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625221e2eb0440', '病虫草害', 'pub', 'c5_3', 'cskefu', NULL, '402881fb6251f6220162521a4d01042d', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:12:55', '2018-03-23 17:12:55', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625221e2f20441', '栽培技术', 'pub', 'c3_2', 'cskefu', NULL, '402881fb6251f6220162521a4ce9042b', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:12:55', '2018-03-23 17:12:55', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625221e2f20442', '病虫草害', 'pub', 'c2_3', 'cskefu', NULL, '402881fb6251f6220162521a4cdd042a', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:12:55', '2018-03-23 17:12:55', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625221e2f90443', '病虫草害', 'pub', 'c6_3', 'cskefu', NULL, '402881fb6251f6220162521a4d0e042e', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:12:55', '2018-03-23 17:12:55', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625221e3010444', '病虫草害', 'pub', 'c3_3', 'cskefu', NULL, '402881fb6251f6220162521a4ce9042b', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:12:55', '2018-03-23 17:12:55', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625221e3050445', '病虫草害', 'pub', 'c4_3', 'cskefu', NULL, '402881fb6251f6220162521a4cf5042c', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:12:55', '2018-03-23 17:12:55', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625221e3650446', '市场行情', 'pub', 'c7_1', 'cskefu', NULL, '402881fb6251f6220162521a4d1f042f', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:12:55', '2018-03-23 17:12:55', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625221e37c0447', '栽培技术', 'pub', 'c7_2', 'cskefu', NULL, '402881fb6251f6220162521a4d1f042f', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:12:55', '2018-03-23 17:12:55', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625221e38b0448', '病虫草害', 'pub', 'c7_3', 'cskefu', NULL, '402881fb6251f6220162521a4d1f042f', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:12:55', '2018-03-23 17:12:55', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625221e5fa0449', '市场行情', 'pub', 'c8_1', 'cskefu', NULL, '402881fb6251f6220162521a4d2b0430', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:12:56', '2018-03-23 17:12:56', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625221e60b044a', '栽培技术', 'pub', 'c8_2', 'cskefu', NULL, '402881fb6251f6220162521a4d2b0430', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:12:56', '2018-03-23 17:12:56', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625221e623044b', '病虫草害', 'pub', 'c8_3', 'cskefu', NULL, '402881fb6251f6220162521a4d2b0430', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:12:56', '2018-03-23 17:12:56', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252229af9044c', '土地', 'pub', 'd1', 'cskefu', NULL, '402881fb6251a290016251a53ad9051c', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:13:42', '2018-03-23 17:13:42', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252229b0d044d', '养殖', 'pub', 'd2', 'cskefu', NULL, '402881fb6251a290016251a53ad9051c', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:13:42', '2018-03-23 17:13:42', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252229b19044e', '法律政策', 'pub', 'd3', 'cskefu', NULL, '402881fb6251a290016251a53ad9051c', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:13:42', '2018-03-23 17:13:42', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252229b28044f', '农村政策法规', 'pub', 'd4', 'cskefu', NULL, '402881fb6251a290016251a53ad9051c', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:13:42', '2018-03-23 17:13:42', 0, 4, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252229b3c0450', '涉农政策', 'pub', 'd5', 'cskefu', NULL, '402881fb6251a290016251a53ad9051c', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:13:42', '2018-03-23 17:13:42', 0, 5, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252229b4c0451', '农机', 'pub', 'd6', 'cskefu', NULL, '402881fb6251a290016251a53ad9051c', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:13:42', '2018-03-23 17:13:42', 0, 6, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252229b5a0452', '保险', 'pub', 'd7', 'cskefu', NULL, '402881fb6251a290016251a53ad9051c', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:13:42', '2018-03-23 17:13:42', 0, 7, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252229b660453', '合作社', 'pub', 'd8', 'cskefu', NULL, '402881fb6251a290016251a53ad9051c', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:13:42', '2018-03-23 17:13:42', 0, 8, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252229b720454', '其他', 'pub', 'd9', 'cskefu', NULL, '402881fb6251a290016251a53ad9051c', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:13:42', '2018-03-23 17:13:42', 0, 9, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252229b7f0455', '法律', 'pub', 'd10', 'cskefu', NULL, '402881fb6251a290016251a53ad9051c', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:13:42', '2018-03-23 17:13:42', 0, 10, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252229b8c0456', '粮食', 'pub', 'd11', 'cskefu', NULL, '402881fb6251a290016251a53ad9051c', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:13:42', '2018-03-23 17:13:42', 0, 11, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252229ba20457', '农民负担', 'pub', 'd12', 'cskefu', NULL, '402881fb6251a290016251a53ad9051c', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:13:42', '2018-03-23 17:13:42', 0, 12, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162522309a10458', '技术解答', 'pub', 'd1_1', 'cskefu', NULL, '402881fb6251f622016252229af9044c', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:14:10', '2018-03-23 17:14:10', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162522309b00459', '市场行情', 'pub', 'd1_2', 'cskefu', NULL, '402881fb6251f622016252229af9044c', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:14:10', '2018-03-23 17:14:10', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162522590f3045a', '技术解答', 'pub', 'd9_1', 'cskefu', NULL, '402881fb6251f622016252229b720454', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:16:56', '2018-03-23 17:16:56', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162522590f9045b', '技术解答', 'pub', 'd7_1', 'cskefu', NULL, '402881fb6251f622016252229b5a0452', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:16:56', '2018-03-23 17:16:56', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252259105045c', '市场行情', 'pub', 'd9_2', 'cskefu', NULL, '402881fb6251f622016252229b720454', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:16:56', '2018-03-23 17:16:56', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252259108045d', '市场行情', 'pub', 'd7_2', 'cskefu', NULL, '402881fb6251f622016252229b5a0452', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:16:56', '2018-03-23 17:16:56', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252259137045e', '技术解答', 'pub', 'd11_1', 'cskefu', NULL, '402881fb6251f622016252229b8c0456', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:16:56', '2018-03-23 17:16:56', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252259137045f', '技术解答', 'pub', 'd10_1', 'cskefu', NULL, '402881fb6251f622016252229b7f0455', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:16:56', '2018-03-23 17:16:56', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162522592020460', '市场行情', 'pub', 'd11_2', 'cskefu', NULL, '402881fb6251f622016252229b8c0456', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:16:56', '2018-03-23 17:16:56', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625225920c0461', '市场行情', 'pub', 'd10_2', 'cskefu', NULL, '402881fb6251f622016252229b7f0455', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:16:56', '2018-03-23 17:16:56', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162522592190462', '技术解答', 'pub', 'd8_1', 'cskefu', NULL, '402881fb6251f622016252229b660453', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:16:56', '2018-03-23 17:16:56', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625225922a0463', '市场行情', 'pub', 'd8_2', 'cskefu', NULL, '402881fb6251f622016252229b660453', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:16:56', '2018-03-23 17:16:56', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162522592410464', '技术解答', 'pub', 'd6_1', 'cskefu', NULL, '402881fb6251f622016252229b4c0451', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:16:56', '2018-03-23 17:16:56', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162522592500465', '市场行情', 'pub', 'd6_2', 'cskefu', NULL, '402881fb6251f622016252229b4c0451', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:16:56', '2018-03-23 17:16:56', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162522592670466', '技术解答', 'pub', 'd5_1', 'cskefu', NULL, '402881fb6251f622016252229b3c0450', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:16:56', '2018-03-23 17:16:56', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162522592770467', '市场行情', 'pub', 'd5_2', 'cskefu', NULL, '402881fb6251f622016252229b3c0450', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:16:56', '2018-03-23 17:16:56', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625225929e0468', '技术解答', 'pub', 'd4_1', 'cskefu', NULL, '402881fb6251f622016252229b28044f', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:16:56', '2018-03-23 17:16:56', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162522592bb0469', '市场行情', 'pub', 'd4_2', 'cskefu', NULL, '402881fb6251f622016252229b28044f', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:16:56', '2018-03-23 17:16:56', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252259367046a', '技术解答', 'pub', 'd2_1', 'cskefu', NULL, '402881fb6251f622016252229b0d044d', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:16:57', '2018-03-23 17:16:57', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252259376046b', '技术解答', 'pub', 'd12_1', 'cskefu', NULL, '402881fb6251f622016252229ba20457', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:16:57', '2018-03-23 17:16:57', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625225937f046c', '市场行情', 'pub', 'd2_2', 'cskefu', NULL, '402881fb6251f622016252229b0d044d', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:16:57', '2018-03-23 17:16:57', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252259382046d', '技术解答', 'pub', 'd3_1', 'cskefu', NULL, '402881fb6251f622016252229b19044e', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:16:57', '2018-03-23 17:16:57', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252259386046e', '市场行情', 'pub', 'd12_2', 'cskefu', NULL, '402881fb6251f622016252229ba20457', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:16:57', '2018-03-23 17:16:57', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252259390046f', '市场行情', 'pub', 'd3_2', 'cskefu', NULL, '402881fb6251f622016252229b19044e', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:16:57', '2018-03-23 17:16:57', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625226e23e0470', '本周气象', 'pub', 'e1', 'cskefu', NULL, '402881fb6251a290016251a53af4051d', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:18:22', '2018-03-23 17:18:22', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625226e24d0471', '每日气象', 'pub', 'e2', 'cskefu', NULL, '402881fb6251a290016251a53af4051d', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:18:22', '2018-03-23 17:18:22', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625226e25b0472', '长期气象', 'pub', 'e3', 'cskefu', NULL, '402881fb6251a290016251a53af4051d', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:18:22', '2018-03-23 17:18:22', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625226e26b0473', '未来一周气象', 'pub', 'e4', 'cskefu', NULL, '402881fb6251a290016251a53af4051d', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:18:22', '2018-03-23 17:18:22', 0, 4, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162522723bb0474', '技术解答', 'pub', 'e1_1', 'cskefu', NULL, '402881fb6251f62201625226e23e0470', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:18:39', '2018-03-23 17:18:39', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162522723cf0475', '市场行情', 'pub', 'e1_2', 'cskefu', NULL, '402881fb6251f62201625226e23e0470', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:18:39', '2018-03-23 17:18:39', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252278f2f0476', '技术解答', 'pub', 'e2_1', 'cskefu', NULL, '402881fb6251f62201625226e24d0471', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:19:07', '2018-03-23 17:19:07', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252278f420477', '市场行情', 'pub', 'e2_2', 'cskefu', NULL, '402881fb6251f62201625226e24d0471', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:19:07', '2018-03-23 17:19:07', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625227ad460478', '技术解答', 'pub', 'e3_1', 'cskefu', NULL, '402881fb6251f62201625226e25b0472', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:19:14', '2018-03-23 17:19:14', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625227ad550479', '市场行情', 'pub', 'e3_2', 'cskefu', NULL, '402881fb6251f62201625226e25b0472', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:19:14', '2018-03-23 17:19:14', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625227ca6f047a', '技术解答', 'pub', 'e4_1', 'cskefu', NULL, '402881fb6251f62201625226e26b0473', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:19:22', '2018-03-23 17:19:22', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625227ca7f047b', '市场行情', 'pub', 'e4_2', 'cskefu', NULL, '402881fb6251f62201625226e26b0473', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:19:22', '2018-03-23 17:19:22', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162522800d5047c', '大田', 'pub', 'f1', 'cskefu', NULL, '402881fb6251a290016251a53b0f051e', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:19:36', '2018-03-23 17:19:36', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162522800e3047d', '畜牧', 'pub', 'f2', 'cskefu', NULL, '402881fb6251a290016251a53b0f051e', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:19:36', '2018-03-23 17:19:36', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162522800ed047e', '果蔬', 'pub', 'f3', 'cskefu', NULL, '402881fb6251a290016251a53b0f051e', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:19:36', '2018-03-23 17:19:36', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625228381e047f', '温度', 'pub', 'f1_1', 'cskefu', NULL, '402881fb6251f6220162522800d5047c', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:19:50', '2018-03-23 17:19:50', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625228382c0480', '气温雨量', 'pub', 'f1_2', 'cskefu', NULL, '402881fb6251f6220162522800d5047c', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:19:50', '2018-03-23 17:19:50', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162522838390481', '雨水', 'pub', 'f1_3', 'cskefu', NULL, '402881fb6251f6220162522800d5047c', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:19:50', '2018-03-23 17:19:50', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162522860310482', '温度', 'pub', 'f2_1', 'cskefu', NULL, '402881fb6251f6220162522800e3047d', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:20:00', '2018-03-23 17:20:00', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625228603e0483', '气温雨量', 'pub', 'f2_2', 'cskefu', NULL, '402881fb6251f6220162522800e3047d', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:20:00', '2018-03-23 17:20:00', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625228604a0484', '雨水', 'pub', 'f2_3', 'cskefu', NULL, '402881fb6251f6220162522800e3047d', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:20:00', '2018-03-23 17:20:00', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252287adc0485', '温度', 'pub', 'f3_1', 'cskefu', NULL, '402881fb6251f6220162522800ed047e', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:20:07', '2018-03-23 17:20:07', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252287aed0486', '气温雨量', 'pub', 'f3_2', 'cskefu', NULL, '402881fb6251f6220162522800ed047e', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:20:07', '2018-03-23 17:20:07', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252287afb0487', '雨水', 'pub', 'f3_3', 'cskefu', NULL, '402881fb6251f6220162522800ed047e', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:20:07', '2018-03-23 17:20:07', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625228bb030488', '其他', 'pub', 'g1', 'cskefu', NULL, '402881fb6251a290016251a53b2b051f', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:20:23', '2018-03-23 17:20:23', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625228bb0d0489', '错误信息', 'pub', 'g2', 'cskefu', NULL, '402881fb6251a290016251a53b2b051f', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:20:23', '2018-03-23 17:20:23', 0, 2, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625228bb1a048a', '感谢', 'pub', 'g3', 'cskefu', NULL, '402881fb6251a290016251a53b2b051f', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:20:23', '2018-03-23 17:20:23', 0, 3, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625228bb27048b', '业务办理', 'pub', 'g4', 'cskefu', NULL, '402881fb6251a290016251a53b2b051f', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:20:23', '2018-03-23 17:20:23', 0, 4, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625228bb33048c', '医疗', 'pub', 'g5', 'cskefu', NULL, '402881fb6251a290016251a53b2b051f', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:20:23', '2018-03-23 17:20:23', 0, 5, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625228bb3f048d', '生活百科', 'pub', 'g6', 'cskefu', NULL, '402881fb6251a290016251a53b2b051f', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:20:23', '2018-03-23 17:20:23', 0, 6, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625228bb4b048e', '宣传', 'pub', 'g7', 'cskefu', NULL, '402881fb6251a290016251a53b2b051f', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:20:23', '2018-03-23 17:20:23', 0, 7, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625228bb5a048f', '培训', 'pub', 'g8', 'cskefu', NULL, '402881fb6251a290016251a53b2b051f', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:20:23', '2018-03-23 17:20:23', 0, 8, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625228fc8f0490', '价格采集', 'pub', 'g1_1', 'cskefu', NULL, '402881fb6251f62201625228bb030488', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:20:40', '2018-03-23 17:20:40', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252290a270491', '价格采集', 'pub', 'g2_1', 'cskefu', NULL, '402881fb6251f62201625228bb0d0489', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:20:44', '2018-03-23 17:20:44', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f6220162522918ec0492', '价格采集', 'pub', 'g3_1', 'cskefu', NULL, '402881fb6251f62201625228bb1a048a', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:20:47', '2018-03-23 17:20:47', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f622016252292d8e0493', '价格采集', 'pub', 'g5_1', 'cskefu', 'layui-icon', '402881fb6251f62201625228bb33048c', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:20:53', '2018-03-23 17:20:53', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625229ab0c0494', '价格采集', 'pub', 'g4_1', 'cskefu', NULL, '402881fb6251f62201625228bb27048b', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:21:25', '2018-03-23 17:21:25', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625229bd380495', '价格采集', 'pub', 'g6_1', 'cskefu', NULL, '402881fb6251f62201625228bb3f048d', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:21:29', '2018-03-23 17:21:29', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625229ccad0496', '价格采集', 'pub', 'g7_1', 'cskefu', NULL, '402881fb6251f62201625228bb4b048e', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:21:33', '2018-03-23 17:21:33', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6251f62201625229ddcf0497', '价格采集', 'pub', 'g8_1', 'cskefu', NULL, '402881fb6251f62201625228bb5a048f', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-23 17:21:38', '2018-03-23 17:21:38', 0, 1, '402881fb624c612401624c6fb495043d', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6266a6c7016266a9854e0394', '短信网关类型', 'pub', 'com.dic.sms.type', NULL, 'data', '0', '', NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-27 16:53:28', NULL, 1, 0, NULL, 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6266a6c7016266ab17bf0395', '阿里大于', 'pub', 'dysms', 'cskefu', 'layui-icon', '402881fb6266a6c7016266a9854e0394', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-27 16:55:11', NULL, 1, 0, '402881fb6266a6c7016266a9854e0394', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402881fb6266c1bd016266c3d4070394', '其他短信', 'pub', 'othersms', 'cskefu', 'layui-icon', '297e63f05d1da6be015d1dae6de20002', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-27 17:22:12', NULL, 1, 0, '297e63f05d1da6be015d1dae6de20002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5ae97036015ae972b6f10003', '客户类型', 'pub', 'com.dic.contacts.entype', NULL, 'data', '0', '', NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 10:01:33', NULL, 1, 0, NULL, 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5ae97036015ae972d48d0004', '普通客户', 'pub', '01', 'cskefu', NULL, '4028838b5ae97036015ae972b6f10003', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 10:01:41', '2017-03-20 10:01:41', 0, 1, '4028838b5ae97036015ae972b6f10003', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5ae97036015ae972d4970005', 'VIP客户', 'pub', '02', 'cskefu', NULL, '4028838b5ae97036015ae972b6f10003', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 10:01:41', '2017-03-20 10:01:41', 0, 2, '4028838b5ae97036015ae972b6f10003', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5ae97036015ae972d49e0006', '老客户', 'pub', '03', 'cskefu', NULL, '4028838b5ae97036015ae972b6f10003', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 10:01:41', '2017-03-20 10:01:41', 0, 3, '4028838b5ae97036015ae972b6f10003', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5ae97036015ae972d4b50007', '代理商', 'pub', '04', 'cskefu', NULL, '4028838b5ae97036015ae972b6f10003', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 10:01:41', '2017-03-20 10:01:41', 0, 4, '4028838b5ae97036015ae972b6f10003', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5ae97036015ae972d4bf0008', '供货商', 'pub', '05', 'cskefu', NULL, '4028838b5ae97036015ae972b6f10003', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 10:01:41', '2017-03-20 10:01:41', 0, 5, '4028838b5ae97036015ae972b6f10003', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5ae97036015ae972d4c80009', '合作伙伴', 'pub', '06', 'cskefu', NULL, '4028838b5ae97036015ae972b6f10003', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 10:01:41', '2017-03-20 10:01:41', 0, 6, '4028838b5ae97036015ae972b6f10003', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5ae97036015ae972d4d1000a', '其它', 'pub', '07', 'cskefu', NULL, '4028838b5ae97036015ae972b6f10003', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 10:01:41', '2017-03-20 10:01:41', 0, 7, '4028838b5ae97036015ae972b6f10003', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5ae9ea25015ae9eccbfc0002', '客户级别', 'pub', 'com.dic.contacts.elevel', NULL, 'data', '0', '', NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 12:14:54', NULL, 1, 0, NULL, 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5ae9ea25015ae9ee39a20003', '★', 'pub', '01', 'cskefu', NULL, '4028838b5ae9ea25015ae9eccbfc0002', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 12:16:28', '2017-03-20 12:16:28', 0, 1, '4028838b5ae9ea25015ae9eccbfc0002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5ae9ea25015ae9ee39ac0004', '★★', 'pub', '02', 'cskefu', NULL, '4028838b5ae9ea25015ae9eccbfc0002', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 12:16:28', '2017-03-20 12:16:28', 0, 2, '4028838b5ae9ea25015ae9eccbfc0002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5ae9ea25015ae9ee39b10005', '★★★', 'pub', '03', 'cskefu', NULL, '4028838b5ae9ea25015ae9eccbfc0002', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 12:16:28', '2017-03-20 12:16:28', 0, 3, '4028838b5ae9ea25015ae9eccbfc0002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5ae9ea25015ae9ee39c00006', '★★★★', 'pub', '04', 'cskefu', NULL, '4028838b5ae9ea25015ae9eccbfc0002', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 12:16:28', '2017-03-20 12:16:28', 0, 4, '4028838b5ae9ea25015ae9eccbfc0002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5ae9ea25015ae9ee39c70007', '★★★★★', 'pub', '05', 'cskefu', NULL, '4028838b5ae9ea25015ae9eccbfc0002', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 12:16:28', '2017-03-20 12:16:28', 0, 5, '4028838b5ae9ea25015ae9eccbfc0002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5ae9f0a1015ae9fb052b0002', '客户来源', 'pub', 'com.dic.contacts.esource', NULL, 'data', '0', '', NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 12:30:26', NULL, 1, 0, NULL, 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5ae9f0a1015ae9fb20680003', '注册会员', 'pub', '01', 'cskefu', NULL, '4028838b5ae9f0a1015ae9fb052b0002', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 12:30:33', '2017-03-20 12:30:33', 0, 1, '4028838b5ae9f0a1015ae9fb052b0002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5ae9f0a1015ae9fb20730004', '朋友介绍', 'pub', '02', 'cskefu', NULL, '4028838b5ae9f0a1015ae9fb052b0002', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 12:30:33', '2017-03-20 12:30:33', 0, 2, '4028838b5ae9f0a1015ae9fb052b0002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5ae9f0a1015ae9fb20790005', '手工录入', 'pub', '03', 'cskefu', NULL, '4028838b5ae9f0a1015ae9fb052b0002', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 12:30:33', '2017-03-20 12:30:33', 0, 3, '4028838b5ae9f0a1015ae9fb052b0002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5ae9f0a1015ae9fb20870006', '失败客户', 'pub', '04', 'cskefu', NULL, '4028838b5ae9f0a1015ae9fb052b0002', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 12:30:33', '2017-03-20 12:30:33', 0, 4, '4028838b5ae9f0a1015ae9fb052b0002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5ae9f0a1015ae9fb208b0007', '行业展会', 'pub', '05', 'cskefu', NULL, '4028838b5ae9f0a1015ae9fb052b0002', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 12:30:33', '2017-03-20 12:30:33', 0, 5, '4028838b5ae9f0a1015ae9fb052b0002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5ae9f0a1015ae9fb20930008', '客户介绍', 'pub', '06', 'cskefu', NULL, '4028838b5ae9f0a1015ae9fb052b0002', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 12:30:33', '2017-03-20 12:30:33', 0, 6, '4028838b5ae9f0a1015ae9fb052b0002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5ae9f0a1015ae9fb20980009', '电子商务', 'pub', '07', 'cskefu', NULL, '4028838b5ae9f0a1015ae9fb052b0002', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 12:30:33', '2017-03-20 12:30:33', 0, 7, '4028838b5ae9f0a1015ae9fb052b0002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5ae9f0a1015ae9fb209c000a', '合作伙伴', 'pub', '08', 'cskefu', NULL, '4028838b5ae9f0a1015ae9fb052b0002', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 12:30:33', '2017-03-20 12:30:33', 0, 8, '4028838b5ae9f0a1015ae9fb052b0002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5ae9f0a1015ae9fb20a3000b', '广告', 'pub', '09', 'cskefu', NULL, '4028838b5ae9f0a1015ae9fb052b0002', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 12:30:33', '2017-03-20 12:30:33', 0, 9, '4028838b5ae9f0a1015ae9fb052b0002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5ae9f0a1015ae9fb20aa000c', '职员引介', 'pub', '10', 'cskefu', NULL, '4028838b5ae9f0a1015ae9fb052b0002', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 12:30:33', '2017-03-20 12:30:33', 0, 10, '4028838b5ae9f0a1015ae9fb052b0002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5ae9f0a1015ae9fb20ae000d', '市场活动', 'pub', '11', 'cskefu', NULL, '4028838b5ae9f0a1015ae9fb052b0002', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 12:30:33', '2017-03-20 12:30:33', 0, 11, '4028838b5ae9f0a1015ae9fb052b0002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5ae9f0a1015ae9fb20b7000e', '公共关系', 'pub', '12', 'cskefu', NULL, '4028838b5ae9f0a1015ae9fb052b0002', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 12:30:33', '2017-03-20 12:30:33', 0, 12, '4028838b5ae9f0a1015ae9fb052b0002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5ae9f0a1015ae9fb20bb000f', '口头传达', 'pub', '13', 'cskefu', NULL, '4028838b5ae9f0a1015ae9fb052b0002', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 12:30:33', '2017-03-20 12:30:33', 0, 13, '4028838b5ae9f0a1015ae9fb052b0002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5ae9f0a1015ae9fb20be0010', '研讨会', 'pub', '14', 'cskefu', NULL, '4028838b5ae9f0a1015ae9fb052b0002', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 12:30:33', '2017-03-20 12:30:33', 0, 14, '4028838b5ae9f0a1015ae9fb052b0002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5ae9f0a1015ae9fb20c60011', '其它', 'pub', '15', 'cskefu', NULL, '4028838b5ae9f0a1015ae9fb052b0002', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 12:30:33', '2017-03-20 12:30:33', 0, 15, '4028838b5ae9f0a1015ae9fb052b0002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5aea0e3f015aea127f8d0002', '客户成熟度', 'pub', 'com.dic.contacts.maturity', NULL, 'data', '0', '', NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 12:56:05', NULL, 1, 0, NULL, 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5aea0e3f015aea12a3da0003', 'A+：明确成交意向', 'pub', '01', 'cskefu', NULL, '4028838b5aea0e3f015aea127f8d0002', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 12:56:14', '2017-03-20 12:56:14', 0, 1, '4028838b5aea0e3f015aea127f8d0002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5aea0e3f015aea12a3e10004', 'A-：有初步成交意向', 'pub', '02', 'cskefu', NULL, '4028838b5aea0e3f015aea127f8d0002', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 12:56:14', '2017-03-20 12:56:14', 0, 2, '4028838b5aea0e3f015aea127f8d0002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5aea0e3f015aea12a3e90005', 'B+：关键人有成交意向', 'pub', '03', 'cskefu', NULL, '4028838b5aea0e3f015aea127f8d0002', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 12:56:14', '2017-03-20 12:56:14', 0, 3, '4028838b5aea0e3f015aea127f8d0002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5aea0e3f015aea12a3f40006', 'B-：关键人成交意向不确定', 'pub', '04', 'cskefu', NULL, '4028838b5aea0e3f015aea127f8d0002', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 12:56:14', '2017-03-20 12:56:14', 0, 4, '4028838b5aea0e3f015aea127f8d0002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5aea0e3f015aea12a3fa0007', 'C+：初步联系，有意向', 'pub', '05', 'cskefu', NULL, '4028838b5aea0e3f015aea127f8d0002', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 12:56:14', '2017-03-20 12:56:14', 0, 5, '4028838b5aea0e3f015aea127f8d0002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5aea0e3f015aea12a4070008', 'C-：初步联系，意向不确定', 'pub', '06', 'cskefu', NULL, '4028838b5aea0e3f015aea127f8d0002', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 12:56:14', '2017-03-20 12:56:14', 0, 6, '4028838b5aea0e3f015aea127f8d0002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5aea0e3f015aea12a40f0009', 'D：新建客户', 'pub', '07', 'cskefu', NULL, '4028838b5aea0e3f015aea127f8d0002', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 12:56:14', '2017-03-20 12:56:14', 0, 7, '4028838b5aea0e3f015aea127f8d0002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5aea0e3f015aea12a415000a', 'E：明显拒绝', 'pub', '08', 'cskefu', NULL, '4028838b5aea0e3f015aea127f8d0002', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 12:56:14', '2017-03-20 12:56:14', 0, 8, '4028838b5aea0e3f015aea127f8d0002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5aea0e3f015aea12a41d000b', 'F：无效客户', 'pub', '09', 'cskefu', NULL, '4028838b5aea0e3f015aea127f8d0002', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 12:56:14', '2017-03-20 12:56:14', 0, 9, '4028838b5aea0e3f015aea127f8d0002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5aea0e3f015aea30c4ae0015', '客户行业', 'pub', 'com.dic.contacts.industry', NULL, 'data', '0', '', NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 13:29:09', NULL, 1, 0, NULL, 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5aea0e3f015aea30de4a0016', '机械及行业设备', 'pub', '01', 'cskefu', NULL, '4028838b5aea0e3f015aea30c4ae0015', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 13:29:15', '2017-03-20 13:29:15', 0, 1, '4028838b5aea0e3f015aea30c4ae0015', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5aea0e3f015aea30de5b0017', '电子元器件', 'pub', '02', 'cskefu', NULL, '4028838b5aea0e3f015aea30c4ae0015', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 13:29:15', '2017-03-20 13:29:15', 0, 2, '4028838b5aea0e3f015aea30c4ae0015', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5aea0e3f015aea30de6c0018', '礼品、工艺品、饰品', 'pub', '03', 'cskefu', NULL, '4028838b5aea0e3f015aea30c4ae0015', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 13:29:15', '2017-03-20 13:29:15', 0, 3, '4028838b5aea0e3f015aea30c4ae0015', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5aea0e3f015aea30de7a0019', '家居用品', 'pub', '04', 'cskefu', NULL, '4028838b5aea0e3f015aea30c4ae0015', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 13:29:15', '2017-03-20 13:29:15', 0, 4, '4028838b5aea0e3f015aea30c4ae0015', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5aea0e3f015aea30de85001a', '电工电气', 'pub', '05', 'cskefu', NULL, '4028838b5aea0e3f015aea30c4ae0015', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 13:29:15', '2017-03-20 13:29:15', 0, 5, '4028838b5aea0e3f015aea30c4ae0015', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5aea0e3f015aea30de94001b', '建筑、建材', 'pub', '06', 'cskefu', NULL, '4028838b5aea0e3f015aea30c4ae0015', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 13:29:15', '2017-03-20 13:29:15', 0, 6, '4028838b5aea0e3f015aea30c4ae0015', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5aea0e3f015aea30dea4001c', '五金、工具', 'pub', '07', 'cskefu', NULL, '4028838b5aea0e3f015aea30c4ae0015', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 13:29:15', '2017-03-20 13:29:15', 0, 7, '4028838b5aea0e3f015aea30c4ae0015', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5aea0e3f015aea30deb3001d', '纺织、皮革', 'pub', '08', 'cskefu', NULL, '4028838b5aea0e3f015aea30c4ae0015', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 13:29:15', '2017-03-20 13:29:15', 0, 8, '4028838b5aea0e3f015aea30c4ae0015', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5aea0e3f015aea30dec0001e', '包装', 'pub', '09', 'cskefu', NULL, '4028838b5aea0e3f015aea30c4ae0015', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 13:29:15', '2017-03-20 13:29:15', 0, 9, '4028838b5aea0e3f015aea30c4ae0015', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5aea0e3f015aea30decd001f', '橡塑', 'pub', '10', 'cskefu', NULL, '4028838b5aea0e3f015aea30c4ae0015', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 13:29:15', '2017-03-20 13:29:15', 0, 10, '4028838b5aea0e3f015aea30c4ae0015', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5aea0e3f015aea30dedb0020', '化工', 'pub', '11', 'cskefu', NULL, '4028838b5aea0e3f015aea30c4ae0015', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 13:29:15', '2017-03-20 13:29:15', 0, 11, '4028838b5aea0e3f015aea30c4ae0015', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5aea0e3f015aea30dee90021', '服装', 'pub', '12', 'cskefu', NULL, '4028838b5aea0e3f015aea30c4ae0015', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 13:29:15', '2017-03-20 13:29:15', 0, 12, '4028838b5aea0e3f015aea30c4ae0015', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5aea0e3f015aea30defd0022', '办公、文教', 'pub', '13', 'cskefu', NULL, '4028838b5aea0e3f015aea30c4ae0015', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 13:29:15', '2017-03-20 13:29:15', 0, 13, '4028838b5aea0e3f015aea30c4ae0015', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5aea0e3f015aea30df100023', '冶金矿产', 'pub', '14', 'cskefu', NULL, '4028838b5aea0e3f015aea30c4ae0015', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 13:29:15', '2017-03-20 13:29:15', 0, 14, '4028838b5aea0e3f015aea30c4ae0015', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5aea0e3f015aea30df1e0024', '数码、电脑', 'pub', '15', 'cskefu', NULL, '4028838b5aea0e3f015aea30c4ae0015', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 13:29:15', '2017-03-20 13:29:15', 0, 15, '4028838b5aea0e3f015aea30c4ae0015', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5aea0e3f015aea30df280025', '服饰', 'pub', '16', 'cskefu', NULL, '4028838b5aea0e3f015aea30c4ae0015', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 13:29:15', '2017-03-20 13:29:15', 0, 16, '4028838b5aea0e3f015aea30c4ae0015', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5aea0e3f015aea30df340026', '运动、休闲', 'pub', '17', 'cskefu', NULL, '4028838b5aea0e3f015aea30c4ae0015', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 13:29:15', '2017-03-20 13:29:15', 0, 17, '4028838b5aea0e3f015aea30c4ae0015', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5aea0e3f015aea30df3e0027', '传媒、广电', 'pub', '18', 'cskefu', NULL, '4028838b5aea0e3f015aea30c4ae0015', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 13:29:15', '2017-03-20 13:29:15', 0, 18, '4028838b5aea0e3f015aea30c4ae0015', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5aea0e3f015aea30df480028', '精细化学品', 'pub', '19', 'cskefu', NULL, '4028838b5aea0e3f015aea30c4ae0015', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 13:29:15', '2017-03-20 13:29:15', 0, 19, '4028838b5aea0e3f015aea30c4ae0015', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5aea0e3f015aea30df530029', '安全、防护', 'pub', '20', 'cskefu', NULL, '4028838b5aea0e3f015aea30c4ae0015', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 13:29:15', '2017-03-20 13:29:15', 0, 20, '4028838b5aea0e3f015aea30c4ae0015', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5aea0e3f015aea30df5d002a', '照明工业', 'pub', '21', 'cskefu', NULL, '4028838b5aea0e3f015aea30c4ae0015', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 13:29:15', '2017-03-20 13:29:15', 0, 21, '4028838b5aea0e3f015aea30c4ae0015', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5aea0e3f015aea30df69002b', '仪器仪表', 'pub', '22', 'cskefu', NULL, '4028838b5aea0e3f015aea30c4ae0015', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 13:29:15', '2017-03-20 13:29:15', 0, 22, '4028838b5aea0e3f015aea30c4ae0015', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5aea0e3f015aea30df74002c', '农业', 'pub', '23', 'cskefu', NULL, '4028838b5aea0e3f015aea30c4ae0015', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 13:29:15', '2017-03-20 13:29:15', 0, 23, '4028838b5aea0e3f015aea30c4ae0015', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5aea0e3f015aea30df7e002d', '汽摩及配件', 'pub', '24', 'cskefu', NULL, '4028838b5aea0e3f015aea30c4ae0015', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 13:29:15', '2017-03-20 13:29:15', 0, 24, '4028838b5aea0e3f015aea30c4ae0015', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5aea0e3f015aea30df88002e', '通信产品', 'pub', '25', 'cskefu', NULL, '4028838b5aea0e3f015aea30c4ae0015', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 13:29:15', '2017-03-20 13:29:15', 0, 25, '4028838b5aea0e3f015aea30c4ae0015', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5aea0e3f015aea30df92002f', '环保', 'pub', '26', 'cskefu', NULL, '4028838b5aea0e3f015aea30c4ae0015', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 13:29:15', '2017-03-20 13:29:15', 0, 26, '4028838b5aea0e3f015aea30c4ae0015', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5aea0e3f015aea30df9d0030', '食品、饮料', 'pub', '27', 'cskefu', NULL, '4028838b5aea0e3f015aea30c4ae0015', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 13:29:15', '2017-03-20 13:29:15', 0, 27, '4028838b5aea0e3f015aea30c4ae0015', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5aea0e3f015aea30dfa70031', '加工', 'pub', '28', 'cskefu', NULL, '4028838b5aea0e3f015aea30c4ae0015', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 13:29:15', '2017-03-20 13:29:15', 0, 28, '4028838b5aea0e3f015aea30c4ae0015', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5aea0e3f015aea30dfb20032', '玩具', 'pub', '29', 'cskefu', NULL, '4028838b5aea0e3f015aea30c4ae0015', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 13:29:15', '2017-03-20 13:29:15', 0, 29, '4028838b5aea0e3f015aea30c4ae0015', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5aea0e3f015aea30dfc30033', '家用电器', 'pub', '30', 'cskefu', NULL, '4028838b5aea0e3f015aea30c4ae0015', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 13:29:15', '2017-03-20 13:29:15', 0, 30, '4028838b5aea0e3f015aea30c4ae0015', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5aea0e3f015aea30dfcf0034', '交通运输', 'pub', '31', 'cskefu', NULL, '4028838b5aea0e3f015aea30c4ae0015', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 13:29:15', '2017-03-20 13:29:15', 0, 31, '4028838b5aea0e3f015aea30c4ae0015', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5aea0e3f015aea30dfda0035', '医药、保养', 'pub', '32', 'cskefu', NULL, '4028838b5aea0e3f015aea30c4ae0015', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 13:29:15', '2017-03-20 13:29:15', 0, 32, '4028838b5aea0e3f015aea30c4ae0015', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5aea0e3f015aea30dfe60036', '商务服务', 'pub', '33', 'cskefu', NULL, '4028838b5aea0e3f015aea30c4ae0015', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 13:29:15', '2017-03-20 13:29:15', 0, 33, '4028838b5aea0e3f015aea30c4ae0015', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5aea0e3f015aea30dff10037', '印刷', 'pub', '34', 'cskefu', NULL, '4028838b5aea0e3f015aea30c4ae0015', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 13:29:16', '2017-03-20 13:29:16', 0, 34, '4028838b5aea0e3f015aea30c4ae0015', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5aea0e3f015aea30dffb0038', '能源', 'pub', '35', 'cskefu', NULL, '4028838b5aea0e3f015aea30c4ae0015', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 13:29:16', '2017-03-20 13:29:16', 0, 35, '4028838b5aea0e3f015aea30c4ae0015', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5aea0e3f015aea30e0050039', '代理', 'pub', '36', 'cskefu', NULL, '4028838b5aea0e3f015aea30c4ae0015', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 13:29:16', '2017-03-20 13:29:16', 0, 36, '4028838b5aea0e3f015aea30c4ae0015', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5aea0e3f015aea30e00f003a', '纸业', 'pub', '37', 'cskefu', NULL, '4028838b5aea0e3f015aea30c4ae0015', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 13:29:16', '2017-03-20 13:29:16', 0, 37, '4028838b5aea0e3f015aea30c4ae0015', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5aea0e3f015aea30e019003b', '其它行业', 'pub', '38', 'cskefu', NULL, '4028838b5aea0e3f015aea30c4ae0015', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 13:29:16', '2017-03-20 13:29:16', 0, 38, '4028838b5aea0e3f015aea30c4ae0015', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5aea0e3f015aea31cd51003c', '客户状态', 'pub', 'com.dic.contacts.validstatus', NULL, 'data', '0', '', NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 13:30:16', NULL, 1, 0, NULL, 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5aea0e3f015aea324228003d', '潜在客户', 'pub', '01', 'cskefu', NULL, '4028838b5aea0e3f015aea31cd51003c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 13:30:46', '2017-03-20 13:30:46', 0, 1, '4028838b5aea0e3f015aea31cd51003c', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5aea0e3f015aea324239003e', '意向客户', 'pub', '02', 'cskefu', NULL, '4028838b5aea0e3f015aea31cd51003c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 13:30:46', '2017-03-20 13:30:46', 0, 2, '4028838b5aea0e3f015aea31cd51003c', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5aea0e3f015aea324245003f', '成交客户', 'pub', '03', 'cskefu', NULL, '4028838b5aea0e3f015aea31cd51003c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 13:30:46', '2017-03-20 13:30:46', 0, 3, '4028838b5aea0e3f015aea31cd51003c', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5aea0e3f015aea3242520040', '失败客户', 'pub', '04', 'cskefu', NULL, '4028838b5aea0e3f015aea31cd51003c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 13:30:46', '2017-03-20 13:30:46', 0, 4, '4028838b5aea0e3f015aea31cd51003c', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5aea0e3f015aea3242600041', '已流失客户', 'pub', '05', 'cskefu', NULL, '4028838b5aea0e3f015aea31cd51003c', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 13:30:46', '2017-03-20 13:30:46', 0, 5, '4028838b5aea0e3f015aea31cd51003c', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5aeba14b015aebbbceea0008', '三沙市', 'pub', '460300', 'cskefu', NULL, '297e1e874f83129d014f832155f300d7', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-20 20:40:38', '2017-03-20 20:40:38', 0, 1, '297e1e874f83129d014f832090e200b8', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5af1047e015af13e30a70002', '联系人类型', 'pub', 'com.dic.contacts.ckind', NULL, 'data', '0', '', NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-21 22:21:09', NULL, 1, 0, NULL, 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5af1047e015af140df150003', '客户', 'pub', '01', 'cskefu', NULL, '4028838b5af1047e015af13e30a70002', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-21 22:24:04', '2017-03-21 22:24:04', 0, 1, '4028838b5af1047e015af13e30a70002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5af1047e015af140df2e0004', '合作伙伴', 'pub', '02', 'cskefu', NULL, '4028838b5af1047e015af13e30a70002', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-21 22:24:04', '2017-03-21 22:24:04', 0, 2, '4028838b5af1047e015af13e30a70002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5af1047e015af140df3e0005', '集成商', 'pub', '03', 'cskefu', NULL, '4028838b5af1047e015af13e30a70002', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-21 22:24:04', '2017-03-21 22:24:04', 0, 3, '4028838b5af1047e015af13e30a70002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5af1047e015af140df600006', '渠道', 'pub', '04', 'cskefu', NULL, '4028838b5af1047e015af13e30a70002', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-21 22:24:04', '2017-03-21 22:24:04', 0, 4, '4028838b5af1047e015af13e30a70002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5af1047e015af140df710007', '供应商', 'pub', '05', 'cskefu', NULL, '4028838b5af1047e015af13e30a70002', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-21 22:24:04', '2017-03-21 22:24:04', 0, 5, '4028838b5af1047e015af13e30a70002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5af1047e015af140df800008', '分销商', 'pub', '06', 'cskefu', NULL, '4028838b5af1047e015af13e30a70002', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-21 22:24:04', '2017-03-21 22:24:04', 0, 6, '4028838b5af1047e015af13e30a70002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5af1047e015af140df900009', '其他', 'pub', '07', 'cskefu', NULL, '4028838b5af1047e015af13e30a70002', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-03-21 22:24:04', '2017-03-21 22:24:04', 0, 7, '4028838b5af1047e015af13e30a70002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5b55e572015b56513ef90002', '工单状态', 'pub', 'com.dic.workorders.status', NULL, 'data', '0', '', NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-04-10 13:23:36', NULL, 1, 0, NULL, 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5b55e572015b565262200003', '未受理', 'pub', '01', 'cskefu', 'layui-icon', '4028838b5b55e572015b56513ef90002', '', NULL, '', '#32c24d', NULL, '297e8c7b455798280145579c73e501c1', '2017-04-10 13:24:51', '2017-04-10 13:24:51', 0, 1, '4028838b5b55e572015b56513ef90002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5b55e572015b5652626e0006', '已回复', 'pub', '04', 'cskefu', 'layui-icon', '4028838b5b55e572015b56513ef90002', '', NULL, '', '#1E9FFF', NULL, '297e8c7b455798280145579c73e501c1', '2017-04-10 13:24:51', '2017-04-10 13:24:51', 0, 4, '4028838b5b55e572015b56513ef90002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5b55e572015b5652628e0008', '已关闭', 'pub', 'uckefu_workorders_closed', 'cskefu', 'layui-icon', '4028838b5b55e572015b56513ef90002', '', NULL, '', '#FF5722', NULL, '297e8c7b455798280145579c73e501c1', '2017-04-10 13:24:51', '2017-04-10 13:24:51', 0, 6, '4028838b5b55e572015b56513ef90002', 0, 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5b565caf015b56645f320003', '再追问', 'pub', '07', 'cskefu', 'layui-icon', '4028838b5b55e572015b56513ef90002', '', NULL, '', '#F7B824', NULL, '297e8c7b455798280145579c73e501c1', '2017-04-10 13:44:30', NULL, 1, 0, '4028838b5b55e572015b56513ef90002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5b565caf015b566536480004', '工单类型', 'pub', 'com.dic.workorders.type', NULL, 'data', '0', '', NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-04-10 13:45:25', NULL, 1, 0, NULL, 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5b565caf015b5665e5a30005', '投诉', 'pub', '01', 'cskefu', NULL, '4028838b5b565caf015b566536480004', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-04-10 13:46:10', '2017-04-10 13:46:10', 0, 1, '4028838b5b565caf015b566536480004', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5b565caf015b5665e5b90006', '问题', 'pub', '02', 'cskefu', NULL, '4028838b5b565caf015b566536480004', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-04-10 13:46:10', '2017-04-10 13:46:10', 0, 2, '4028838b5b565caf015b566536480004', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5b565caf015b5665e5df0007', '咨询', 'pub', '03', 'cskefu', NULL, '4028838b5b565caf015b566536480004', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-04-10 13:46:10', '2017-04-10 13:46:10', 0, 3, '4028838b5b565caf015b566536480004', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5b565caf015b5665e5ec0008', '故障', 'pub', '04', 'cskefu', NULL, '4028838b5b565caf015b566536480004', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-04-10 13:46:10', '2017-04-10 13:46:10', 0, 4, '4028838b5b565caf015b566536480004', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5b565caf015b5665e5fa0009', '任务', 'pub', '05', 'cskefu', NULL, '4028838b5b565caf015b566536480004', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-04-10 13:46:10', '2017-04-10 13:46:10', 0, 5, '4028838b5b565caf015b566536480004', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5b565caf015b5665e608000a', '回访', 'pub', '06', 'cskefu', NULL, '4028838b5b565caf015b566536480004', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-04-10 13:46:10', '2017-04-10 13:46:10', 0, 6, '4028838b5b565caf015b566536480004', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5b565caf015b56683247000b', '工单优先级', 'pub', 'com.dic.workorders.priority', NULL, 'data', '0', '', NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-04-10 13:48:40', NULL, 1, 0, NULL, 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5b565caf015b56688fe3000c', '低', 'pub', '01', 'cskefu', 'layui-icon', '4028838b5b565caf015b56683247000b', '', NULL, '', '#5FB878', NULL, '297e8c7b455798280145579c73e501c1', '2017-04-10 13:49:04', '2017-04-10 13:49:04', 0, 1, '4028838b5b565caf015b56683247000b', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5b565caf015b56688ff5000d', '中', 'pub', '02', 'cskefu', 'layui-icon', '4028838b5b565caf015b56683247000b', '', NULL, '', '#1E9FFF', NULL, '297e8c7b455798280145579c73e501c1', '2017-04-10 13:49:04', '2017-04-10 13:49:04', 0, 2, '4028838b5b565caf015b56683247000b', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5b565caf015b56689005000e', '高', 'pub', '03', 'cskefu', 'layui-icon', '4028838b5b565caf015b56683247000b', '', NULL, '', '#F7B824', NULL, '297e8c7b455798280145579c73e501c1', '2017-04-10 13:49:04', '2017-04-10 13:49:04', 0, 3, '4028838b5b565caf015b56683247000b', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5b565caf015b56689012000f', '紧急', 'pub', '04', 'cskefu', 'layui-icon', '4028838b5b565caf015b56683247000b', '', NULL, '', '#FF5722', NULL, '297e8c7b455798280145579c73e501c1', '2017-04-10 13:49:04', '2017-04-10 13:49:04', 0, 4, '4028838b5b565caf015b56683247000b', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5b565caf015b566d11d80010', '标签类型', 'pub', 'com.dic.tag.type', NULL, 'data', '0', '', NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-04-10 13:54:00', NULL, 1, 0, NULL, 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5b565caf015b566de3180011', '联系人', 'pub', 'user', 'cskefu', 'layui-icon', '4028838b5b565caf015b566d11d80010', '', NULL, '', '', NULL, '297e8c7b455798280145579c73e501c1', '2017-04-10 13:54:53', '2017-04-10 13:54:53', 0, 1, '4028838b5b565caf015b566d11d80010', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028838b5b565caf015b566de32a0012', '工单', 'pub', 'workorders', 'cskefu', 'layui-icon', '4028838b5b565caf015b566d11d80010', '', NULL, '', '', NULL, '297e8c7b455798280145579c73e501c1', '2017-04-10 13:54:53', '2017-04-10 13:54:53', 0, 2, '4028838b5b565caf015b566d11d80010', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402888815c2e2f66015c2f083d010004', '姓名', 'pub', '01', 'cskefu', NULL, '402888815c2e2f66015c2f07827e0002', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-05-22 15:21:28', '2017-05-22 15:21:28', 0, 1, '402888815c2e2f66015c2f07827e0002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402888815c2e2f66015c2f083d180005', '性别', 'pub', '02', 'cskefu', NULL, '402888815c2e2f66015c2f07827e0002', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-05-22 15:21:28', '2017-05-22 15:21:28', 0, 2, '402888815c2e2f66015c2f07827e0002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402888815c2e2f66015c2f083d250006', '年龄', 'pub', '03', 'cskefu', NULL, '402888815c2e2f66015c2f07827e0002', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-05-22 15:21:28', '2017-05-22 15:21:28', 0, 3, '402888815c2e2f66015c2f07827e0002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402888815c2e2f66015c2f087e510007', '姓名', 'pub', '01', 'cskefu', NULL, '402888815c2e2f66015c2f07c6190003', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-05-22 15:21:44', '2017-05-22 15:21:44', 0, 1, '402888815c2e2f66015c2f07c6190003', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402888815c2e2f66015c2f087e660008', '年龄', 'pub', '02', 'cskefu', NULL, '402888815c2e2f66015c2f07c6190003', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-05-22 15:21:44', '2017-05-22 15:21:44', 0, 2, '402888815c2e2f66015c2f07c6190003', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402888815cb3fa3b015cb3fe31410001', '呼叫中心分机类型', 'pub', 'com.dic.callcenter.extype', NULL, 'data', '0', '', NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-06-17 10:59:59', NULL, 1, 0, NULL, 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402888815cb3fa3b015cb3ff6f810002', '直线', 'pub', '01', 'cskefu', NULL, '402888815cb3fa3b015cb3fe31410001', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-06-17 11:01:20', '2017-06-17 11:01:20', 0, 1, '402888815cb3fa3b015cb3fe31410001', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402888815cb3fa3b015cb3ff6f8e0003', 'IVR', 'pub', '02', 'cskefu', NULL, '402888815cb3fa3b015cb3fe31410001', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-06-17 11:01:20', '2017-06-17 11:01:20', 0, 2, '402888815cb3fa3b015cb3fe31410001', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402888815cb3fa3b015cb3ff6f9a0004', '技能组', 'pub', '03', 'cskefu', NULL, '402888815cb3fa3b015cb3fe31410001', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-06-17 11:01:20', '2017-06-17 11:01:20', 0, 3, '402888815cb3fa3b015cb3fe31410001', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402888815cb3fa3b015cb3ff6fa90005', '会议', 'pub', '04', 'cskefu', NULL, '402888815cb3fa3b015cb3fe31410001', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-06-17 11:01:20', '2017-06-17 11:01:20', 0, 4, '402888815cb3fa3b015cb3fe31410001', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402888815cb3fa3b015cb3ff6fb30006', '队列', 'pub', '05', 'cskefu', NULL, '402888815cb3fa3b015cb3fe31410001', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-06-17 11:01:20', '2017-06-17 11:01:20', 0, 5, '402888815cb3fa3b015cb3fe31410001', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402888815cf217cd015cf219f9f80002', '呼叫中心服务类型', 'pub', 'ccsummary', 'cskefu', 'layui-icon', '4028838b5b565caf015b566d11d80010', '', NULL, '', '', NULL, '297e8c7b455798280145579c73e501c1', '2017-06-29 12:26:47', NULL, 1, 0, '4028838b5b565caf015b566d11d80010', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402888815d2fe37f015d2fe75cc80002', '系统权限资源数据', 'pub', 'com.dic.auth.resource', NULL, 'auth', '0', '系统权限资源数据', NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-07-11 12:27:58', NULL, 1, 0, NULL, 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402888815d89b1aa015d89b318ab0002', '知识库知识', 'pub', 'kbs', 'cskefu', 'layui-icon', '4028838b5b565caf015b566d11d80010', '', NULL, '', '', NULL, '297e8c7b455798280145579c73e501c1', '2017-07-28 22:56:42', '2017-07-28 22:56:42', 0, 1, '4028838b5b565caf015b566d11d80010', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402888815dfd1c35015dfd2645510006', '广告位', 'pub', 'com.dic.adv.type', NULL, 'data', '0', '', NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-08-20 08:58:50', NULL, 1, 0, NULL, 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402888815dfd1c35015dfd2690740007', '访客入口（技能组窗口）', 'pub', 'point', 'cskefu', 'layui-icon', '402888815dfd1c35015dfd2645510006', '图片尺寸：140x90', NULL, '', '', NULL, '297e8c7b455798280145579c73e501c1', '2017-08-20 08:59:09', '2017-08-20 08:59:09', 0, 1, '402888815dfd1c35015dfd2645510006', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402888815dfd1c35015dfd2690870008', '邀请框（询问窗口）', 'pub', 'invite', 'cskefu', 'layui-icon', '402888815dfd1c35015dfd2645510006', '图片尺寸：420x178', NULL, '', '', NULL, '297e8c7b455798280145579c73e501c1', '2017-08-20 08:59:09', '2017-08-20 08:59:09', 0, 2, '402888815dfd1c35015dfd2645510006', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402888815dfd2cf1015dfd3029110002', '欢迎提示（对话窗口）', 'pub', 'welcome', 'cskefu', 'layui-icon', '402888815dfd1c35015dfd2645510006', '图片尺寸：520x50', NULL, '', '', NULL, '297e8c7b455798280145579c73e501c1', '2017-08-20 09:09:38', NULL, 1, 0, '402888815dfd1c35015dfd2645510006', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402888815dfd2cf1015dfd312f870003', '形象展示（对话窗口）', 'pub', 'image', 'cskefu', 'layui-icon', '402888815dfd1c35015dfd2645510006', '图片尺寸：280x190', NULL, '', '', NULL, '297e8c7b455798280145579c73e501c1', '2017-08-20 09:10:45', NULL, 1, 0, '402888815dfd1c35015dfd2645510006', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402888815e097729015e0999f26e0002', '数据接口', 'pub', 'com.dic.data.impl', NULL, 'data', '0', '', NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-08-22 19:00:37', NULL, 1, 0, NULL, 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402888815e097729015e099ac71b0003', '知识库分类', 'pub', 'topictype', 'cskefu', NULL, '402888815e097729015e0999f26e0002', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-08-22 19:01:32', '2017-08-22 19:01:32', 0, 1, '402888815e097729015e0999f26e0002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402888815e6061e7015e6069187f000b', '在线客服满意度意见', 'pub', 'com.dic.webim.comment.item', NULL, 'data', '0', '', NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-09-08 15:34:13', NULL, 1, 0, NULL, 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402888815e6061e7015e6069c226000c', '管理人员的业务能力不够', 'pub', '01', 'cskefu', NULL, '402888815e6061e7015e6069187f000b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-09-08 15:34:57', '2017-09-08 15:34:57', 0, 1, '402888815e6061e7015e6069187f000b', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402888815e6061e7015e6069c23a000d', '客服人员的服务态度不好', 'pub', '02', 'cskefu', NULL, '402888815e6061e7015e6069187f000b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-09-08 15:34:57', '2017-09-08 15:34:57', 0, 2, '402888815e6061e7015e6069187f000b', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402888815e6061e7015e6069c248000e', '不能得到及时服务', 'pub', '03', 'cskefu', NULL, '402888815e6061e7015e6069187f000b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-09-08 15:34:57', '2017-09-08 15:34:57', 0, 3, '402888815e6061e7015e6069187f000b', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402888815e6061e7015e6069c258000f', '其他', 'pub', '04', 'cskefu', NULL, '402888815e6061e7015e6069187f000b', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-09-08 15:34:57', '2017-09-08 15:34:57', 0, 4, '402888815e6061e7015e6069187f000b', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028888163ffe467016400f640f30646', '外呼系统', 'pub', 'A11', NULL, 'auth', '402888815d2fe37f015d2fe75cc80002', NULL, NULL, '', NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-06-15 09:01:35', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/apps/callout/index.html', 'webim', '1', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402888816400f911016401056d340533', '资源管理', 'pub', 'A11_A01', NULL, 'auth', '4028888163ffe467016400f640f30646', NULL, NULL, '', NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-06-15 09:18:10', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/apps/callout/index.html', 'webim', '2', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402888816400f911016401185cbb057d', '拨号计划', 'pub', 'A11_A02', NULL, 'auth', '4028888163ffe467016400f640f30646', NULL, NULL, ' ', NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-06-15 09:38:51', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, 'javascript:;', 'webim', '2', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402888816400f91101640118c86d0581', '数据查询', 'pub', 'A11_A03', NULL, 'auth', '4028888163ffe467016400f640f30646', NULL, NULL, ' ', NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-06-15 09:39:18', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, 'javascript:;', 'webim', '2', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('40288273656b534a01656b6de4bb056b', '坐席监控', 'pub', 'A11_A01_A03', 'cskefu', 'auth', '402888816400f911016401056d340533', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-08-24 18:14:48', NULL, 1, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/apps/callout/monitor.html', 'webim', NULL, NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402888816400f9110164013ab7170601', '已删除任务', 'pub', 'A11_A02_A02', NULL, 'auth', '402888816400f911016401185cbb057d', NULL, NULL, ' ', NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-06-15 10:16:22', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/apps/callout/report/index.html', 'webim', '3', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402888816400f9110164013ab717060e', '任务列表', 'pub', 'A11_A02_A01', NULL, 'auth', '402888816400f911016401185cbb057d', NULL, NULL, ' ', NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-06-15 10:16:22', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/apps/callout/report/index.html', 'webim', '3', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402888816400f9110164013c5a060615', '坐席报表', 'pub', 'A11_A03_A01', NULL, 'auth', '402888816400f91101640118c86d0581', NULL, NULL, ' ', NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-06-15 10:18:09', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/apps/callout/activity.html', 'webim', '3', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402888816400f9110164013ca2e8061a', '外呼日报', 'pub', 'A11_A03_A02', NULL, 'auth', '402888816400f91101640118c86d0581', NULL, NULL, ' ', NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-06-15 10:18:28', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/apps/callout/task.html', 'webim', '3', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402888816400f9110164013e9b4e062a', '录音记录', 'pub', 'A11_A03_A04', NULL, 'auth', '402888816400f91101640118c86d0581', NULL, NULL, ' ', NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-06-15 10:20:37', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/apps/callout/names/myorganapstatus.html', 'webim', '3', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('402888816400f9110164013efaca062f', '通话记录', 'pub', 'A11_A03_A05', NULL, 'auth', '402888816400f91101640118c86d0581', NULL, NULL, ' ', NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-06-15 10:21:02', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/apps/callout/names/myorganuser.html', 'webim', '3', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('40288881640eba2a01640f8599db07ec', '全部坐席', 'pub', 'A12_A01_A01', NULL, 'auth', '40288881640eba2a01640f85359107e6', NULL, NULL, ' ', NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-06-18 04:52:51', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/apps/callcenter/service/monitor/allcall.html', 'webim', '1', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('40288881640eba2a01640f85f8af07f0', '坐席状态', 'pub', 'A12_A02', NULL, 'auth', '4028888163ffe467016400f692c7064b', NULL, NULL, ' ', NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-06-18 04:53:15', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, 'javascript:;', 'webim', '2', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('4028b46f62d295d90162d297a7d7035d', '质检', 'pub', 'quality', 'cskefu', 'layui-icon', '4028838b5b565caf015b566d11d80010', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-04-17 15:52:57', NULL, 1, 0, '4028838b5b565caf015b566d11d80010', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402882516dce9b82016dcedd5abc009c', '会话监控 ', 'pub', 'A13_A01', 'cskefu', 'layui-icon', '402888815d2fe37f015d2fe75cc80002', '坐席对话实时监控', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2019-10-15 18:01:16', NULL, 1, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402882516dce9b82016dcede487700a3', '浏览会话', 'pub', 'A13_A01_A01', 'cskefu', 'layui-icon', '402882516dce9b82016dcedd5abc009c', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2019-10-15 18:02:17', NULL, 1, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402882516dce9b82016dcedea4b900a7', '转接会话', 'pub', 'A13_A01_A02', 'cskefu', 'layui-icon', '402882516dce9b82016dcedd5abc009c', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2019-10-15 18:02:40', NULL, 1, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('402882516dce9b82016dcedf1cbd00ab', '发送消息', 'pub', 'A13_A01_A03', 'cskefu', 'layui-icon', '402882516dce9b82016dcedd5abc009c', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2019-10-15 18:03:11', NULL, 1, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('ff8080816de316aa016de31d0e130016', '企业聊天', 'pub', 'A14', 'cskefu', 'layui-icon', '402888815d2fe37f015d2fe75cc80002', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2019-10-19 16:23:15', NULL, 1, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('ff8080816de316aa016de3201ffb001c', '创建群组', 'pub', 'A14_A01', 'cskefu', 'layui-icon', 'ff8080816de316aa016de31d0e130016', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2019-10-19 16:26:36', NULL, 1, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028c1236170e237016170e4d95a03c6', '类似问题', 'pub', 'topicmore', 'cskefu', 'layui-icon', '402888815e097729015e0999f26e0002', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-02-07 23:31:41', NULL, 1, 0, '402888815e097729015e0999f26e0002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028c1236173b85b016173bde0fd0333', '用户接口', 'pub', 'userdata', 'cskefu', 'layui-icon', '402888815e097729015e0999f26e0002', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-02-08 12:47:59', NULL, 1, 0, '402888815e097729015e0999f26e0002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028826a6eeed0f3016eeed9eee7001c', '标签接口', 'pub', 'tagdata', 'cskefu', 'layui-icon', '402888815e097729015e0999f26e0002', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2019-12-10 16:08:10', NULL, 1, 0, '402888815e097729015e0999f26e0002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028c1236173b85b016173be114e0335', '部门接口', 'pub', 'organdata', 'cskefu', 'layui-icon', '402888815e097729015e0999f26e0002', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-02-08 12:48:11', NULL, 1, 0, '402888815e097729015e0999f26e0002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028cba3613c9d2d01613cb0dbf8062d', '全部联系人', 'pub', 'A02_A01_A02_B01', NULL, 'auth', '402881ef612b1f5b01612cc87273054a', NULL, NULL, '', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-28 20:14:39', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, 'javascript:;', 'webim', '4', NULL, 'top');
INSERT INTO `uk_sysdic` VALUES ('4028cba3613c9d2d01613cb15cce062e', '今日新增', 'pub', 'A02_A01_A02_B02', NULL, 'auth', '402881ef612b1f5b01612cc87273054a', NULL, NULL, '', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-28 20:15:12', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, 'javascript:;', 'webim', '4', NULL, 'top');
INSERT INTO `uk_sysdic` VALUES ('4028cba3613c9d2d01613cb204df062f', '本周新增', 'pub', 'A02_A01_A02_B03', NULL, 'auth', '402881ef612b1f5b01612cc87273054a', NULL, NULL, '', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-28 20:15:55', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, 'javascript:;', 'webim', '4', NULL, 'top');
INSERT INTO `uk_sysdic` VALUES ('4028cba3613c9d2d01613cb2b5f70630', '我的联系人', 'pub', 'A02_A01_A02_B04', NULL, 'auth', '402881ef612b1f5b01612cc87273054a', NULL, NULL, '', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-28 20:16:40', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, 'javascript:;', 'webim', '4', NULL, 'top');
INSERT INTO `uk_sysdic` VALUES ('4028cba3613c9d2d01613cb33d5b0631', '新建联系人', 'pub', 'A02_A01_A02_B05', NULL, 'auth', '402881ef612b1f5b01612cc87273054a', NULL, NULL, '', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-28 20:17:15', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, 'javascript:;', 'webim', '4', NULL, 'top');
INSERT INTO `uk_sysdic` VALUES ('4028cba3613c9d2d01613cc2909b0665', '编辑联系人信息', 'pub', 'A02_A01_A02_B06', NULL, 'auth', '402881ef612b1f5b01612cc87273054a', NULL, NULL, '<i class=\"layui-icon\">&#xe642;</i>', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-28 20:33:59', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/apps/contacts/edit.html?id=cf249b0039eb44f5aa6df663b156faae', 'webim', '4', NULL, 'top');
INSERT INTO `uk_sysdic` VALUES ('4028cba3613c9d2d01613cc36c5b0666', '删除联系人', 'pub', 'A02_A01_A02_B07', NULL, 'auth', '402881ef612b1f5b01612cc87273054a', NULL, NULL, '<i class=\"layui-icon\" style=\"color:red;\">&#x1006;</i>', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-28 20:34:55', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/apps/contacts/delete.html?id=cf249b0039eb44f5aa6df663b156faae', 'webim', '4', NULL, 'top');
INSERT INTO `uk_sysdic` VALUES ('4028cba3613c9d2d01613cc3ffd00667', '导入', 'pub', 'A02_A01_A02_B08', NULL, 'auth', '402881ef612b1f5b01612cc87273054a', NULL, NULL, '<i class=\"layui-icon\">&#xe642;</i>', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-28 20:35:33', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/apps/contacts/edit.html?id=cf249b0039eb44f5aa6df663b156faae', 'webim', '4', NULL, 'top');
INSERT INTO `uk_sysdic` VALUES ('4028cba3613c9d2d01613cc443a70668', '导出', 'pub', 'A02_A01_A02_B09', NULL, 'auth', '402881ef612b1f5b01612cc87273054a', NULL, NULL, '<i class=\"layui-icon\">&#xe642;</i>', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-28 20:35:50', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/apps/contacts/edit.html?id=cf249b0039eb44f5aa6df663b156faae', 'webim', '4', NULL, 'top');
INSERT INTO `uk_sysdic` VALUES ('4028cba3613c9d2d01613ccdc17f067c', '全部客户', 'pub', 'A03_A01_A02_B01', NULL, 'auth', '402881ef612b1f5b01612cca221d054d', NULL, NULL, '<i class=\"kfont\" style=\"position: relative;\">&#xe636;</i>', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-28 20:46:12', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/apps/bpm/index.html', 'webim', '4', NULL, 'top');
INSERT INTO `uk_sysdic` VALUES ('4028cba3613c9d2d01613cce1c4e067d', '今日新增', 'pub', 'A03_A01_A02_B02', NULL, 'auth', '402881ef612b1f5b01612cca221d054d', NULL, NULL, '<i class=\"kfont\" style=\"position: relative;\">&#xe636;</i>', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-28 20:46:36', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/apps/bpm/index.html', 'webim', '4', NULL, 'top');
INSERT INTO `uk_sysdic` VALUES ('4028cba3613c9d2d01613cce686b067e', '本周新增', 'pub', 'A03_A01_A02_B03', NULL, 'auth', '402881ef612b1f5b01612cca221d054d', NULL, NULL, '<i class=\"kfont\" style=\"position: relative;\">&#xe636;</i>', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-28 20:46:55', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/apps/bpm/index.html', 'webim', '4', NULL, 'top');
INSERT INTO `uk_sysdic` VALUES ('4028cba3613c9d2d01613ccec9a6067f', '企业客户', 'pub', 'A03_A01_A02_B04', NULL, 'auth', '402881ef612b1f5b01612cca221d054d', NULL, NULL, '<i class=\"layui-icon\" style=\"position: relative;\">&#xe614;</i>', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-28 20:47:20', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/setting/agent/index.html', 'webim', '4', NULL, 'top');
INSERT INTO `uk_sysdic` VALUES ('4028cba3613c9d2d01613ccf1eb00680', '个人客户', 'pub', 'A03_A01_A02_B05', NULL, 'auth', '402881ef612b1f5b01612cca221d054d', NULL, NULL, '<i class=\"layui-icon\" style=\"position: relative;\">&#xe614;</i>', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-28 20:47:42', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/setting/agent/index.html', 'webim', '4', NULL, 'top');
INSERT INTO `uk_sysdic` VALUES ('4028cba3613c9d2d01613ccf70960681', '新建客户', 'pub', 'A03_A01_A02_B06', NULL, 'auth', '402881ef612b1f5b01612cca221d054d', NULL, NULL, '<i class=\"layui-icon\" style=\"position: relative;\">&#xe614;</i>', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-28 20:48:03', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/setting/agent/index.html', 'webim', '4', NULL, 'top');
INSERT INTO `uk_sysdic` VALUES ('4028cba3613c9d2d01613ccfca880682', '编辑', 'pub', 'A03_A01_A02_B07', NULL, 'auth', '402881ef612b1f5b01612cca221d054d', NULL, NULL, '<i class=\"layui-icon\" style=\"position: relative;\">&#xe614;</i>', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-28 20:48:26', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/setting/agent/index.html', 'webim', '4', NULL, 'top');
INSERT INTO `uk_sysdic` VALUES ('4028cba3613c9d2d01613cd01d250683', '删除', 'pub', 'A03_A01_A02_B08', NULL, 'auth', '402881ef612b1f5b01612cca221d054d', NULL, NULL, '<i class=\"layui-icon\" style=\"position: relative;\">&#xe614;</i>', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-28 20:48:47', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/setting/agent/index.html', 'webim', '4', NULL, 'top');
INSERT INTO `uk_sysdic` VALUES ('4028cba3613c9d2d01613cd06df20684', '导入', 'pub', 'A03_A01_A02_B09', NULL, 'auth', '402881ef612b1f5b01612cca221d054d', NULL, NULL, '<i class=\"layui-icon\" style=\"position: relative;\">&#xe614;</i>', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-28 20:49:08', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/setting/agent/index.html', 'webim', '4', NULL, 'top');
INSERT INTO `uk_sysdic` VALUES ('4028cba3613c9d2d01613cd0b9780685', '导出', 'pub', 'A03_A01_A02_B010', NULL, 'auth', '402881ef612b1f5b01612cca221d054d', NULL, NULL, '<i class=\"layui-icon\" style=\"position: relative;\">&#xe614;</i>', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-28 20:49:27', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, '/setting/agent/index.html', 'webim', '4', NULL, 'top');
INSERT INTO `uk_sysdic` VALUES ('4028e3815bafaa94015bafb14edf0002', '服务类型', 'pub', 'summary', 'cskefu', 'layui-icon', '4028838b5b565caf015b566d11d80010', '', NULL, '', '', NULL, '297e8c7b455798280145579c73e501c1', '2017-04-27 21:54:44', NULL, 1, 0, '4028838b5b565caf015b566d11d80010', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028e3815bafb323015bafe5c8180009', '服务小结预约方式', 'pub', 'com.dic.summary.reservtype', NULL, 'data', '0', '', NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-04-27 22:52:03', NULL, 1, 0, NULL, 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028e3815bafb323015bafe64be2000a', '电话', 'pub', 'phone', 'cskefu', NULL, '4028e3815bafb323015bafe5c8180009', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-04-27 22:52:37', '2017-04-27 22:52:37', 0, 1, '4028e3815bafb323015bafe5c8180009', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028e3815bafb323015bafe64bf1000b', '邮件', 'pub', 'email', 'cskefu', NULL, '4028e3815bafb323015bafe5c8180009', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-04-27 22:52:37', '2017-04-27 22:52:37', 0, 2, '4028e3815bafb323015bafe5c8180009', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028e3815bafb323015bafe64c02000c', '短信', 'pub', 'sms', 'cskefu', NULL, '4028e3815bafb323015bafe5c8180009', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-04-27 22:52:37', '2017-04-27 22:52:37', 0, 3, '4028e3815bafb323015bafe5c8180009', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('4028e3815bafb323015bafe64c1e000d', '微信', 'pub', 'wechat', 'cskefu', NULL, '4028e3815bafb323015bafe5c8180009', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-04-27 22:52:37', '2017-04-27 22:52:37', 0, 4, '4028e3815bafb323015bafe5c8180009', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('8a2a71896150d606016150f9ff0c053e', '创建新工单', 'pub', 'A04_A01_B01', NULL, 'auth', '402881ef612b1f5b01612cca88e2054e', NULL, NULL, '', NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-02-01 18:46:56', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, ' ', 'webim', '3', NULL, 'top');
INSERT INTO `uk_sysdic` VALUES ('8a2a71896168dbb40161690ff8520563', '工单分类', 'pub', 'A04_A02_A06', NULL, 'auth', '402881ef612b1f5b01612ccabee3054f', NULL, NULL, '', NULL, NULL, '8a2a71896160d682016163b5ee06059d', '2018-02-06 11:01:49', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, ' ', 'webim', '3', NULL, 'left');
INSERT INTO `uk_sysdic` VALUES ('8a2a718961697de101616a5b5ad106f2', '我的工单总数', 'pub', 'A04_A01_B04', NULL, 'auth', '402881ef612b1f5b01612cca88e2054e', NULL, NULL, '', NULL, NULL, '8a2a71896160d682016163cffbf40a00', '2018-02-06 17:03:47', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, ' ', 'webim', '3', NULL, 'top');
INSERT INTO `uk_sysdic` VALUES ('8a2a718961697de101616a5bb80906f6', '我的待办工单总数', 'pub', 'A04_A01_B05', NULL, 'auth', '402881ef612b1f5b01612cca88e2054e', NULL, NULL, '', NULL, NULL, '8a2a71896160d682016163cffbf40a00', '2018-02-06 17:04:11', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, ' ', 'webim', '3', NULL, 'top');
INSERT INTO `uk_sysdic` VALUES ('8a7f5f826222b5c5016222bdb0dc0352', 'ES数据资源', 'pub', 'com.dic.es.type', NULL, 'data', '0', '', NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-14 12:21:19', NULL, 1, 0, NULL, 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('8a7f5f826222b5c5016222be3e110354', '联系人对象', 'pub', 'com.ukefu.webim.service.es.ContactsRepository', 'cskefu', 'layui-icon', '8a7f5f826222b5c5016222bdb0dc0352', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-14 12:21:55', '2018-03-14 12:21:55', 0, 1, '8a7f5f826222b5c5016222bdb0dc0352', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('8a7f5f826222d164016222d97921035a', 'DB数据资源', 'pub', 'com.dic.db.type', NULL, 'data', '0', '', NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-14 12:51:40', NULL, 1, 0, NULL, 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('8a7f5f826222d164016222e64a000377', '联系人', 'pub', 'com.ukefu.webim.web.model.Contacts', 'cskefu', NULL, '8a7f5f826222d164016222d97921035a', NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-03-14 13:05:40', '2018-03-14 13:05:40', 0, 1, '8a7f5f826222d164016222d97921035a', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('8a7f5f83632021be016320246f5d0407', '知识库', 'pub', 'com.ukefu.webim.web.model.Topic', 'cskefu', 'layui-icon', '8a7f5f826222d164016222d97921035a', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-05-02 17:17:28', NULL, 1, 0, '8a7f5f826222d164016222d97921035a', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('8a7f5f83632021be01632025644a040f', '知识库对象', 'pub', 'com.ukefu.webim.service.es.TopicRepository', 'cskefu', 'layui-icon', '8a7f5f826222b5c5016222bdb0dc0352', '', NULL, '', '', NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-05-02 17:18:31', NULL, 1, 0, '8a7f5f826222b5c5016222bdb0dc0352', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('8a7f82825e241666015e241d2b3b0002', '在线客服满意度', 'pub', 'com.dic.webim.comment', NULL, 'data', '0', '', NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-08-27 22:34:04', NULL, 1, 0, NULL, 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('8a7f82825e241666015e241da9660003', '非常满意', 'pub', '1', 'cskefu', NULL, '8a7f82825e241666015e241d2b3b0002', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-08-27 22:34:37', '2017-08-27 22:34:37', 0, 1, '8a7f82825e241666015e241d2b3b0002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('8a7f82825e241666015e241da97b0004', '满意', 'pub', '2', 'cskefu', NULL, '8a7f82825e241666015e241d2b3b0002', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-08-27 22:34:37', '2017-08-27 22:34:37', 0, 2, '8a7f82825e241666015e241d2b3b0002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('8a7f82825e241666015e241da9860005', '一般', 'pub', '3', 'cskefu', NULL, '8a7f82825e241666015e241d2b3b0002', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-08-27 22:34:37', '2017-08-27 22:34:37', 0, 3, '8a7f82825e241666015e241d2b3b0002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('8a7f82825e241666015e241da9970006', '不满意', 'pub', '4', 'cskefu', NULL, '8a7f82825e241666015e241d2b3b0002', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-08-27 22:34:37', '2017-08-27 22:34:37', 0, 4, '8a7f82825e241666015e241d2b3b0002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('8a7f82825e241666015e241da9a20007', '非常不满意', 'pub', '5', 'cskefu', NULL, '8a7f82825e241666015e241d2b3b0002', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2017-08-27 22:34:37', '2017-08-27 22:34:37', 0, 5, '8a7f82825e241666015e241d2b3b0002', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('8a838ae561465f4b01614667863c0324', '机构类型', 'pub', 'com.dic.organization.type', NULL, 'data', '0', '', NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-30 17:30:45', NULL, 1, 0, NULL, 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('8a838ae561465f4b0161466886170326', '金融', 'pub', '01', 'cskefu', NULL, '8a838ae561465f4b01614667863c0324', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-30 17:31:50', '2018-01-30 17:31:50', 0, 1, '8a838ae561465f4b01614667863c0324', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('8a838ae561465f4b0161466886280327', '电信', 'pub', '02', 'cskefu', NULL, '8a838ae561465f4b01614667863c0324', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-30 17:31:50', '2018-01-30 17:31:50', 0, 2, '8a838ae561465f4b01614667863c0324', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('8a838ae561465f4b01614668863c0328', '政府', 'pub', '03', 'cskefu', NULL, '8a838ae561465f4b01614667863c0324', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-30 17:31:50', '2018-01-30 17:31:50', 0, 3, '8a838ae561465f4b01614667863c0324', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('8a838ae561465f4b01614668864c0329', '制造', 'pub', '04', 'cskefu', NULL, '8a838ae561465f4b01614667863c0324', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-30 17:31:50', '2018-01-30 17:31:50', 0, 4, '8a838ae561465f4b01614667863c0324', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('8a838ae561465f4b01614668866a032a', 'IT/互联网', 'pub', '05', 'cskefu', NULL, '8a838ae561465f4b01614667863c0324', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-30 17:31:50', '2018-01-30 17:31:50', 0, 5, '8a838ae561465f4b01614667863c0324', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('8a838ae561465f4b01614668867d032b', '医药医疗', 'pub', '06', 'cskefu', NULL, '8a838ae561465f4b01614667863c0324', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-30 17:31:50', '2018-01-30 17:31:50', 0, 6, '8a838ae561465f4b01614667863c0324', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('8a838ae561465f4b01614668868c032c', '零售物流', 'pub', '07', 'cskefu', NULL, '8a838ae561465f4b01614667863c0324', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-30 17:31:50', '2018-01-30 17:31:50', 0, 7, '8a838ae561465f4b01614667863c0324', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('8a838ae561465f4b01614668869b032d', '工程建筑', 'pub', '08', 'cskefu', NULL, '8a838ae561465f4b01614667863c0324', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-30 17:31:50', '2018-01-30 17:31:50', 0, 8, '8a838ae561465f4b01614667863c0324', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('8a838ae561465f4b0161466886b4032e', '能源', 'pub', '09', 'cskefu', NULL, '8a838ae561465f4b01614667863c0324', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-30 17:31:50', '2018-01-30 17:31:50', 0, 9, '8a838ae561465f4b01614667863c0324', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('8a838ae561465f4b0161466886c8032f', '其他', 'pub', '10', 'cskefu', NULL, '8a838ae561465f4b01614667863c0324', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-30 17:31:50', '2018-01-30 17:31:50', 0, 10, '8a838ae561465f4b01614667863c0324', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('8a838ae561465f4b0161466932100330', '机构规模', 'pub', 'com.dic.organization.scale', NULL, 'data', '0', '', NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-30 17:32:34', NULL, 1, 0, NULL, 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('8a838ae561465f4b01614669c00a0331', '0-30人', 'pub', '01', 'cskefu', NULL, '8a838ae561465f4b0161466932100330', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-30 17:33:11', '2018-01-30 17:33:11', 0, 1, '8a838ae561465f4b0161466932100330', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('8a838ae561465f4b01614669c0160332', '30-300人', 'pub', '02', 'cskefu', NULL, '8a838ae561465f4b0161466932100330', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-30 17:33:11', '2018-01-30 17:33:11', 0, 2, '8a838ae561465f4b0161466932100330', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('8a838ae561465f4b01614669c0200333', '300-1000人', 'pub', '03', 'cskefu', NULL, '8a838ae561465f4b0161466932100330', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-30 17:33:11', '2018-01-30 17:33:11', 0, 3, '8a838ae561465f4b0161466932100330', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('8a838ae561465f4b01614669c0300334', '1000人以上', 'pub', '04', 'cskefu', NULL, '8a838ae561465f4b0161466932100330', NULL, NULL, NULL, NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-30 17:33:11', '2018-01-30 17:33:11', 0, 4, '8a838ae561465f4b0161466932100330', 0, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `uk_sysdic` VALUES ('ff808081613ba48901613bb32ac404e6', '工单总数', 'pub', 'A04_A01_B02', NULL, 'auth', '402881ef612b1f5b01612cca88e2054e', NULL, NULL, '<i class=\"kfont ukewo-btn ukefu-measure-btn\">&#xe606;</i>', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-28 15:37:33', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, 'javascript:void(0)', 'webim', '3', NULL, 'top');
INSERT INTO `uk_sysdic` VALUES ('ff808081613ba48901613bb42bbf04e7', '未关闭工单总数', 'pub', 'A04_A01_B03', NULL, 'auth', '402881ef612b1f5b01612cca88e2054e', NULL, NULL, '<i class=\"kfont ukewo-btn ukefu-measure-btn ukefu-bg-color-yellow\">&#xe606;</i>', NULL, NULL, '297e8c7b455798280145579c73e501c1', '2018-01-28 15:38:38', NULL, 0, 0, '402888815d2fe37f015d2fe75cc80002', 0, 0, 'javascript:void(0)', 'webim', '3', NULL, 'top');
COMMIT;

-- ----------------------------
-- Table structure for uk_system_message
-- ----------------------------
DROP TABLE IF EXISTS `uk_system_message`;
CREATE TABLE `uk_system_message` (
  `ID` varchar(32) NOT NULL COMMENT '主键ID',
  `MSGTYPE` varchar(20) DEFAULT NULL COMMENT '消息类型',
  `SMTPSERVER` varchar(255) DEFAULT NULL COMMENT 'SMTP服务器',
  `SMTPUSER` varchar(255) DEFAULT NULL COMMENT 'SMTP账号',
  `SMTPPASSWORD` varchar(255) DEFAULT NULL COMMENT 'SMTP密码',
  `MAILFROM` varchar(255) DEFAULT NULL COMMENT '发件人',
  `SECLEV` varchar(50) DEFAULT NULL COMMENT '启用SSL',
  `SSLPORT` varchar(50) DEFAULT NULL COMMENT 'SSL端口',
  `ORGI` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `ORGAN` varchar(32) DEFAULT NULL COMMENT '组织ID',
  `URL` text DEFAULT NULL COMMENT 'URL',
  `smstype` varchar(32) DEFAULT NULL COMMENT '短信类型',
  `APPKEY` varchar(200) DEFAULT NULL COMMENT 'APPKEY',
  `APPSEC` varchar(200) DEFAULT NULL COMMENT 'APPSEC',
  `SIGN` varchar(50) DEFAULT NULL COMMENT '签名',
  `TPCODE` varchar(50) DEFAULT NULL COMMENT 'TP代码',
  `CREATETIME` datetime DEFAULT NULL COMMENT '创建时间',
  `NAME` varchar(50) DEFAULT NULL COMMENT '邮件或短信网关名称',
  `moreparam` text COMMENT '更多参数',
  PRIMARY KEY (`ID`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='公告信息表';

-- ----------------------------
-- Table structure for uk_systemconfig
-- ----------------------------
DROP TABLE IF EXISTS `uk_systemconfig`;
CREATE TABLE `uk_systemconfig` (
  `ID` varchar(32) NOT NULL COMMENT '主键ID',
  `NAME` varchar(100) DEFAULT NULL COMMENT '名称',
  `TITLE` varchar(100) DEFAULT NULL COMMENT '标题',
  `CODE` varchar(100) DEFAULT NULL COMMENT '编码',
  `ORGI` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `CTYPE` varchar(32) DEFAULT NULL COMMENT '类型',
  `PARENTID` varchar(32) DEFAULT NULL COMMENT '父级ID',
  `DESCRIPTION` varchar(255) DEFAULT NULL COMMENT '描述',
  `MEMO` varchar(32) DEFAULT NULL COMMENT '备注',
  `ICONSTR` varchar(255) DEFAULT NULL COMMENT '自定义样式',
  `ICONSKIN` varchar(255) DEFAULT NULL COMMENT '自定义样式',
  `CATETYPE` varchar(32) DEFAULT NULL COMMENT '分类',
  `CREATER` varchar(32) DEFAULT NULL COMMENT '创建人',
  `CREATETIME` datetime DEFAULT NULL COMMENT '创建时间',
  `UPDATETIME` datetime DEFAULT NULL COMMENT '更新时间',
  `HASCHILD` tinyint(4) DEFAULT NULL COMMENT '是否有下级',
  `SORTINDEX` int(11) DEFAULT NULL COMMENT '排序',
  `DICID` varchar(32) DEFAULT NULL COMMENT '目录ID',
  `DEFAULTVALUE` tinyint(4) DEFAULT NULL COMMENT '默认值',
  `THEME` varchar(50) DEFAULT NULL COMMENT '皮肤',
  `LOGLEVEL` varchar(32) DEFAULT NULL COMMENT '日志级别',
  `ENABLESSL` tinyint(4) DEFAULT NULL COMMENT '启用SSL',
  `JKSFILE` varchar(255) DEFAULT NULL COMMENT 'JKS文件路径',
  `JKSPASSWORD` varchar(255) DEFAULT NULL COMMENT 'JKS密码',
  `MAPKEY` varchar(255) DEFAULT NULL COMMENT '百度地图授权编码',
  `workorders` tinyint(4) DEFAULT NULL COMMENT '启用工单三栏布局',
  `callcenter` tinyint(4) DEFAULT NULL COMMENT '启用呼叫中心',
  `cc_extention` varchar(32) DEFAULT NULL COMMENT '分机',
  `cc_quene` varchar(32) DEFAULT NULL COMMENT '技能组队列',
  `cc_router` varchar(32) DEFAULT NULL COMMENT '路由策略',
  `cc_ivr` varchar(32) DEFAULT NULL COMMENT 'IVR模板',
  `cc_acl` varchar(32) DEFAULT NULL COMMENT '访问列表模板',
  `cc_siptrunk` varchar(32) DEFAULT NULL COMMENT 'SIP配置模板',
  `cc_callcenter` varchar(32) DEFAULT NULL COMMENT '呼叫中心配置',
  `CALLOUT` tinyint(4) DEFAULT NULL COMMENT '是否允许点击号码外呼',
  `AUTH` tinyint(4) DEFAULT NULL COMMENT '启用权限控制',
  `enablemail` tinyint(4) DEFAULT '0' COMMENT '启用发送邮件',
  `enablesms` tinyint(4) DEFAULT '0' COMMENT '启用发送短信',
  `emailid` varchar(32) DEFAULT NULL COMMENT '启用AI',
  `emailworkordertp` varchar(32) DEFAULT NULL COMMENT '启用工单邮件发送',
  `smsid` varchar(32) DEFAULT NULL COMMENT '短信网关ID',
  `smsworkordertp` varchar(32) DEFAULT NULL COMMENT '启用工单发送短信',
  `mailcreatetp` varchar(32) DEFAULT NULL COMMENT '创建发送邮件模板',
  `mailupdatetp` varchar(32) DEFAULT NULL COMMENT '更新发送邮件模板',
  `mailprocesstp` varchar(32) DEFAULT NULL COMMENT '处理发送邮件模板',
  `emailtocreater` tinyint(4) DEFAULT '0' COMMENT '更新发送创建人邮件模板',
  `emailshowrecipient` tinyint(4) DEFAULT '0' COMMENT '发送邮件给创建人',
  `smscreatetp` varchar(32) DEFAULT NULL COMMENT '创建发送短信',
  `smsupdatetp` varchar(32) DEFAULT NULL,
  `smsprocesstp` varchar(32) DEFAULT NULL COMMENT '处理发送短信',
  `smstocreater` tinyint(4) DEFAULT '0' COMMENT '创建发送短信',
  `emailtocreatertp` varchar(32) DEFAULT NULL COMMENT '创建发送短信模板',
  `smstocreatertp` varchar(32) DEFAULT NULL COMMENT '更新发送短信模板',
  `enabletneant` tinyint(4) DEFAULT '0' COMMENT '启用多租户',
  `tenantshare` tinyint(4) DEFAULT '0' COMMENT '租户共享数据',
  `namealias` varchar(100) DEFAULT NULL COMMENT '别称',
  `enableregorgi` tinyint(4) DEFAULT '0' COMMENT '启用注册租户',
  `tenantconsole` tinyint(4) DEFAULT '0' COMMENT '登录跳转到租户切换页面',
  `loginlogo` varchar(255) DEFAULT NULL COMMENT '登陆页面Logo',
  `consolelogo` varchar(255) DEFAULT NULL COMMENT '后台页面Logo',
  `favlogo` varchar(255) DEFAULT NULL COMMENT '系统Fav图标Logo',
  UNIQUE KEY `SQL121227155532210` (`ID`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='系统设置表';

-- ----------------------------
-- Records of uk_systemconfig
-- ----------------------------
BEGIN;
INSERT INTO `uk_systemconfig` VALUES ('2c93809364e0a6d00164ef6722270582', NULL, '春松客服-多渠道智能客服', NULL, 'cskefu', NULL, NULL, NULL, NULL, NULL, NULL, NULL, '4028cac3614cd2f901614cf8be1f0324', '2018-07-31 08:14:30', NULL, NULL, NULL, NULL, NULL, '01', 'info', 0, NULL, NULL, '', 0, 0, '', '', '', '', '', '', NULL, 0, 0, 0, 0, '', '', NULL, NULL, '', '', NULL, 0, 0, NULL, NULL, NULL, 0, '', NULL, 0, 0, '租户', 0, 0, NULL, NULL, NULL);
COMMIT;

-- ----------------------------
-- Table structure for uk_tableproperties
-- ----------------------------
DROP TABLE IF EXISTS `uk_tableproperties`;
CREATE TABLE `uk_tableproperties` (
  `ID` varchar(32) NOT NULL DEFAULT '' COMMENT '主键ID',
  `NAME` varchar(255) DEFAULT NULL COMMENT '字段名称',
  `CODE` varchar(255) DEFAULT NULL COMMENT '代码',
  `GROUPID` varchar(255) DEFAULT NULL COMMENT '组ID',
  `USERID` varchar(255) DEFAULT NULL COMMENT '创建人ID',
  `FIELDNAME` varchar(255) DEFAULT NULL COMMENT '字段名称',
  `DATATYPECODE` int(11) NOT NULL COMMENT '数据类型代码',
  `DATATYPENAME` varchar(255) DEFAULT NULL COMMENT '字段类型名称',
  `DBTABLEID` varchar(191) DEFAULT NULL COMMENT '数据表ID',
  `INDEXDATATYPE` varchar(255) DEFAULT NULL COMMENT '字段类型',
  `PK` smallint(6) DEFAULT NULL COMMENT '是否外键',
  `MODITS` smallint(6) DEFAULT NULL COMMENT '是否启用多值',
  `INDEXFIELD` varchar(32) DEFAULT NULL COMMENT '是否索引',
  `PLUGIN` varchar(32) DEFAULT NULL COMMENT '处理插件',
  `ORGI` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `FKTABLE` varchar(32) DEFAULT NULL COMMENT '外键表',
  `FKPROPERTY` varchar(32) DEFAULT NULL COMMENT '外键字段',
  `TABLENAME` varchar(255) DEFAULT NULL COMMENT '数据表名称',
  `viewtype` varchar(255) DEFAULT NULL COMMENT '视图类型',
  `SORTINDEX` int(11) DEFAULT NULL COMMENT '排序位置',
  `SYSTEMFIELD` tinyint(4) DEFAULT NULL COMMENT '系统字段',
  `INX` tinyint(4) DEFAULT NULL COMMENT '索引',
  `TOKEN` tinyint(4) DEFAULT NULL COMMENT '分词',
  `LENGTH` int(11) DEFAULT NULL COMMENT '长度',
  `FIELDSTATUS` tinyint(4) DEFAULT NULL COMMENT '字段状态',
  `SELDATA` tinyint(4) DEFAULT NULL COMMENT '关联字段数据',
  `SELDATACODE` varchar(32) DEFAULT NULL COMMENT '关联字段代码',
  `SELDATAKEY` varchar(32) DEFAULT NULL COMMENT '关联key',
  `SELDATAVALUE` varchar(32) DEFAULT NULL COMMENT '关联字段值',
  `SELDATATYPE` varchar(32) DEFAULT NULL COMMENT '关联类型',
  `REFTBID` varchar(32) DEFAULT NULL COMMENT '引用表ID',
  `REFTPID` varchar(32) DEFAULT NULL COMMENT '引用字段ID',
  `REFTYPE` varchar(32) DEFAULT NULL COMMENT '引用类型',
  `REFTBNAME` varchar(60) DEFAULT NULL COMMENT '引用表名称',
  `REFTPNAME` varchar(60) DEFAULT NULL COMMENT '引用字段名称',
  `REFTPTITLEFIELD` varchar(60) DEFAULT NULL COMMENT '引用字段ID',
  `REFFK` tinyint(4) DEFAULT NULL COMMENT '外键',
  `DEFAULTSORT` tinyint(4) DEFAULT NULL COMMENT '默认排序',
  `DEFAULTVALUE` varchar(255) DEFAULT NULL COMMENT '默认值',
  `DEFAULTVALUETITLE` varchar(255) DEFAULT NULL COMMENT '默认标题',
  `DEFAULTFIELDVALUE` varchar(255) DEFAULT NULL COMMENT '默认标题内容',
  `MULTPARTFILE` tinyint(4) DEFAULT NULL COMMENT '多值',
  `UPLOADTYPE` varchar(255) DEFAULT NULL COMMENT '文件上传类型',
  `cascadetype` varchar(255) DEFAULT NULL COMMENT '引用',
  `title` tinyint(4) DEFAULT NULL COMMENT '标题',
  `DESCORDER` tinyint(4) DEFAULT NULL COMMENT '排序方式',
  `impfield` tinyint(4) DEFAULT '0' COMMENT '导入字段',
  `tokentype` varchar(32) DEFAULT NULL COMMENT '分词',
  `phonenumber` tinyint(4) DEFAULT NULL COMMENT '是否电话号码',
  `phonetype` varchar(50) DEFAULT NULL COMMENT '电话号码类型',
  `phonememo` varchar(50) DEFAULT NULL COMMENT '电话号码备注',
  `secfield` tinyint(4) DEFAULT '0' COMMENT '隐藏字段',
  `secdistype` varchar(50) DEFAULT NULL COMMENT '字段隐藏方式',
  `styletype` varchar(32) DEFAULT NULL COMMENT '样式',
  `sysfield` tinyint(4) DEFAULT '0' COMMENT '系统字段',
  PRIMARY KEY (`ID`) USING BTREE,
  UNIQUE KEY `SQL130112140848940` (`ID`) USING BTREE,
  KEY `FKF8D74787854BC62` (`DBTABLEID`) USING BTREE,
  KEY `FKF8D747811BE44FF` (`FKPROPERTY`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='元数据字段表';

INSERT INTO `uk_tableproperties` (`ID`, `NAME`, `CODE`, `GROUPID`, `USERID`, `FIELDNAME`, `DATATYPECODE`, `DATATYPENAME`, `DBTABLEID`, `INDEXDATATYPE`, `PK`, `MODITS`, `INDEXFIELD`, `PLUGIN`, `ORGI`, `FKTABLE`, `FKPROPERTY`, `TABLENAME`, `viewtype`, `SORTINDEX`, `SYSTEMFIELD`, `INX`, `TOKEN`, `LENGTH`, `FIELDSTATUS`, `SELDATA`, `SELDATACODE`, `SELDATAKEY`, `SELDATAVALUE`, `SELDATATYPE`, `REFTBID`, `REFTPID`, `REFTYPE`, `REFTBNAME`, `REFTPNAME`, `REFTPTITLEFIELD`, `REFFK`, `DEFAULTSORT`, `DEFAULTVALUE`, `DEFAULTVALUETITLE`, `DEFAULTFIELDVALUE`, `MULTPARTFILE`, `UPLOADTYPE`, `cascadetype`, `title`, `DESCORDER`, `impfield`, `tokentype`, `phonenumber`, `phonetype`, `phonememo`, `secfield`, `secdistype`, `styletype`, `sysfield`)
VALUES
	('2c9480886e91d9e5016e91f528ac018f', '性别', NULL, NULL, NULL, 'gender', 0, 'text', '2c9480886e91d9e5016e91f528ab018d', NULL, 0, 0, NULL, NULL, 'cskefu', NULL, NULL, 'uk_contacts', NULL, 100, 0, 1, 0, 60, 1, 1, 'com.dic.contacts.sex', NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, 1, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, NULL, NULL, 0),
	('2c9480886e91d9e5016e91f528ac0190', '出生日期', NULL, NULL, NULL, 'cusbirthday', 0, 'text', '2c9480886e91d9e5016e91f528ab018d', NULL, 0, 0, NULL, NULL, 'cskefu', NULL, NULL, 'uk_contacts', NULL, 100, 0, 1, 0, 50, 1, 0, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, 1, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, NULL, NULL, 0),
	('2c9480886e91d9e5016e91f528ac0192', '联系人类别', NULL, NULL, NULL, 'ckind', 0, 'text', '2c9480886e91d9e5016e91f528ab018d', NULL, 0, 0, NULL, NULL, 'cskefu', NULL, NULL, 'uk_contacts', NULL, 100, 0, 1, 0, 60, 1, 1, 'com.dic.contacts.ckind', NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, 1, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, NULL, NULL, 0),
	('2c9480886e91d9e5016e91f528af019e', '电子邮件', NULL, NULL, NULL, 'email', 0, 'text', '2c9480886e91d9e5016e91f528ab018d', NULL, 0, 0, NULL, NULL, 'cskefu', NULL, NULL, 'uk_contacts', NULL, 100, 0, 1, 0, 128, 1, 0, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, 1, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, NULL, NULL, 0),
	('2c9480886e91d9e5016e91f528b001a0', '手机号码', NULL, NULL, NULL, 'mobileno', 0, 'text', '2c9480886e91d9e5016e91f528ab018d', NULL, 0, 0, NULL, NULL, 'cskefu', NULL, NULL, 'uk_contacts', NULL, 100, 0, 1, 0, 40, 1, 0, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, 1, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, NULL, NULL, 0),
	('2c9480886e91d9e5016e91f528b101a2', '办公电话', NULL, NULL, NULL, 'phone', 0, 'text', '2c9480886e91d9e5016e91f528ab018d', NULL, 0, 0, NULL, NULL, 'cskefu', NULL, NULL, 'uk_contacts', NULL, 100, 0, 1, 0, 40, 1, 0, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, 1, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, NULL, NULL, 0),
	('2c9480886e91d9e5016e91f528b301ab', '省', NULL, NULL, NULL, 'province', 0, 'text', '2c9480886e91d9e5016e91f528ab018d', NULL, 0, 0, NULL, NULL, 'cskefu', NULL, NULL, 'uk_contacts', NULL, 100, 0, 1, 0, 60, 1, 1, 'com.dic.address.area', NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, 1, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, NULL, NULL, 0),
	('2c9480886e91d9e5016e91f528b401ac', '市(区)县', NULL, NULL, NULL, 'city', 0, 'text', '2c9480886e91d9e5016e91f528ab018d', NULL, 0, 0, NULL, NULL, 'cskefu', NULL, NULL, 'uk_contacts', NULL, 100, 0, 1, 0, 60, 1, 1, 'com.dic.address.area', NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, 1, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, NULL, NULL, 0),
	('2c9480886e91d9e5016e91f528b401ad', '地址', NULL, NULL, NULL, 'address', 0, 'text', '2c9480886e91d9e5016e91f528ab018d', NULL, 0, 0, NULL, NULL, 'cskefu', NULL, NULL, 'uk_contacts', NULL, 100, 0, 1, 0, 65535, 1, 0, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, 1, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, NULL, NULL, 0),
	('2c9480886e91d9e5016e91f528b801bb', '最后联系时间', NULL, NULL, NULL, 'touchtime', 0, 'datetime', '2c9480886e91d9e5016e91f528ab018d', NULL, 0, 0, NULL, NULL, 'cskefu', NULL, NULL, 'uk_contacts', NULL, 100, 0, 1, 0, 19, 1, 0, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, 1, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, NULL, NULL, 0),
	('2c9480886e91d9e5016e91f528b901be', '创建人', NULL, NULL, NULL, 'creater', 0, 'text', '2c9480886e91d9e5016e91f528ab018d', NULL, 0, 0, NULL, NULL, 'cskefu', NULL, NULL, 'uk_contacts', NULL, 100, 0, 1, 0, 60, 1, 0, '', NULL, NULL, '', 'userdata', NULL, NULL, NULL, NULL, NULL, 1, 0, NULL, NULL, NULL, 1, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, NULL, NULL, 0),
	('2c9480886e91d9e5016e91f528b901c1', '联系人备注', NULL, NULL, NULL, 'memo', 0, 'text', '2c9480886e91d9e5016e91f528ab018d', NULL, 0, 0, NULL, NULL, 'cskefu', NULL, NULL, 'uk_contacts', NULL, 100, 0, 1, 0, 255, 1, 0, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, 1, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, NULL, NULL, 0),
	('2c9480886e91d9e5016e91f528b901c3', '修改时间', NULL, NULL, NULL, 'updatetime', 0, 'datetime', '2c9480886e91d9e5016e91f528ab018d', NULL, 0, 0, NULL, NULL, 'cskefu', NULL, NULL, 'uk_contacts', NULL, 100, 0, 1, 0, 19, 1, 0, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, 1, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, NULL, NULL, 0),
	('2c9480886e91d9e5016e91f528ba01c6', '创建时间', NULL, NULL, NULL, 'createtime', 0, 'datetime', '2c9480886e91d9e5016e91f528ab018d', NULL, 0, 0, NULL, NULL, 'cskefu', NULL, NULL, 'uk_contacts', NULL, 100, 0, 1, 0, 19, 1, 0, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, 1, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, NULL, NULL, 0),
	('2c9480886e91d9e5016e91f528ba01c7', '联系人姓名', NULL, NULL, NULL, 'name', 0, 'text', '2c9480886e91d9e5016e91f528ab018d', NULL, 0, 0, NULL, NULL, 'cskefu', NULL, NULL, 'uk_contacts', NULL, 100, 0, 1, 0, 255, 1, 0, '', NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, 'required', NULL, 1, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, NULL, NULL, 0),
	('2c9480886e91d9e5016e91f528ba01ca', '分享给', NULL, NULL, NULL, 'shares', 0, 'text', '2c9480886e91d9e5016e91f528ab018d', NULL, 0, 0, NULL, NULL, 'cskefu', NULL, NULL, 'uk_contacts', NULL, 100, 0, 1, 0, 255, 1, 0, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, 1, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, NULL, NULL, 0),
	('2c9480886e91d9e5016e91f528bb01d0', 'skypeid', NULL, NULL, NULL, 'skypeid', 0, 'text', '2c9480886e91d9e5016e91f528ab018d', NULL, 0, 0, NULL, NULL, 'cskefu', NULL, NULL, 'uk_contacts', NULL, 100, 0, 1, 0, 100, 1, 0, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, 1, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, NULL, NULL, 0),
	('2c9480886e91d9e5016e91f528bb01d1', '人员id', NULL, NULL, NULL, 'wluid', 0, 'text', '2c9480886e91d9e5016e91f528ab018d', NULL, 0, 0, NULL, NULL, 'cskefu', NULL, NULL, 'uk_contacts', NULL, 100, 0, 1, 0, 100, 1, 0, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, 1, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, NULL, NULL, 0),
	('2c9480886e91d9e5016e91f528bc01d2', '人员名称', NULL, NULL, NULL, 'wlusername', 0, 'text', '2c9480886e91d9e5016e91f528ab018d', NULL, 0, 0, NULL, NULL, 'cskefu', NULL, NULL, 'uk_contacts', NULL, 100, 0, 1, 0, 255, 1, 0, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, 1, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, NULL, NULL, 0),
	('2c9480886e91d9e5016e91f528bc01d3', '公司id', NULL, NULL, NULL, 'wlcid', 0, 'text', '2c9480886e91d9e5016e91f528ab018d', NULL, 0, 0, NULL, NULL, 'cskefu', NULL, NULL, 'uk_contacts', NULL, 100, 0, 1, 0, 100, 1, 0, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, 1, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, NULL, NULL, 0),
	('2c9480886e91d9e5016e91f528bc01d4', '公司名称', NULL, NULL, NULL, 'wlcompany_name', 0, 'text', '2c9480886e91d9e5016e91f528ab018d', NULL, 0, 0, NULL, NULL, 'cskefu', NULL, NULL, 'uk_contacts', NULL, 100, 0, 1, 0, 255, 1, 0, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, 1, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, NULL, NULL, 0),
	('2c9480886e91d9e5016e91f528bc01d5', '子系统id', NULL, NULL, NULL, 'wlsid', 0, 'text', '2c9480886e91d9e5016e91f528ab018d', NULL, 0, 0, NULL, NULL, 'cskefu', NULL, NULL, 'uk_contacts', NULL, 100, 0, 1, 0, 100, 1, 0, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, 1, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, NULL, NULL, 0),
	('2c9480886e91d9e5016e91f528bc01d6', '子系统名称', NULL, NULL, NULL, 'wlsystem_name', 0, 'text', '2c9480886e91d9e5016e91f528ab018d', NULL, 0, 0, NULL, NULL, 'cskefu', NULL, NULL, 'uk_contacts', NULL, 100, 0, 1, 0, 255, 1, 0, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, 1, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, NULL, NULL, 0),
	('402870876e5d9773016e5e95575801c2', '企(事)业单位名称', NULL, NULL, NULL, 'name', 0, 'text', '402870876e5d9773016e5e95575601c0', NULL, 0, 0, NULL, NULL, 'cskefu', NULL, NULL, 'uk_entcustomer', NULL, 100, 0, 1, 0, 255, 1, 0, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, 1, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, NULL, NULL, 0),
	('402870876e5d9773016e5e95575801c3', '单位性质', NULL, NULL, NULL, 'etype', 0, 'text', '402870876e5d9773016e5e95575601c0', NULL, 0, 0, NULL, NULL, 'cskefu', NULL, NULL, 'uk_entcustomer', NULL, 100, 0, 1, 0, 60, 1, 1, 'com.dic.customer.etype', NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, 1, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, NULL, NULL, 0),
	('402870876e5d9773016e5e95575b01c4', '客户类别', NULL, NULL, NULL, 'ekind', 0, 'text', '402870876e5d9773016e5e95575601c0', NULL, 0, 0, NULL, NULL, 'cskefu', NULL, NULL, 'uk_entcustomer', NULL, 100, 0, 1, 0, 60, 1, 1, 'com.dic.contacts.entype', NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, 1, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, NULL, NULL, 0),
	('402870876e5d9773016e5e95575c01c5', '客户级别', NULL, NULL, NULL, 'elevel', 0, 'text', '402870876e5d9773016e5e95575601c0', NULL, 0, 0, NULL, NULL, 'cskefu', NULL, NULL, 'uk_entcustomer', NULL, 100, 0, 1, 0, 60, 1, 1, 'com.dic.contacts.elevel', NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, 1, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, NULL, NULL, 0),
	('402870876e5d9773016e5e95575c01c8', '来源', NULL, NULL, NULL, 'esource', 0, 'text', '402870876e5d9773016e5e95575601c0', NULL, 0, 0, NULL, NULL, 'cskefu', NULL, NULL, 'uk_entcustomer', NULL, 100, 0, 1, 0, 64, 1, 1, 'com.dic.contacts.esource', NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, 1, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, NULL, NULL, 0),
	('402870876e5d9773016e5e95576101d1', '电子邮件', NULL, NULL, NULL, 'email', 0, 'text', '402870876e5d9773016e5e95575601c0', NULL, 0, 0, NULL, NULL, 'cskefu', NULL, NULL, 'uk_entcustomer', NULL, 100, 0, 1, 0, 128, 1, 0, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, 1, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, NULL, NULL, 0),
	('402870876e5d9773016e5e95576101d3', '办公电话', NULL, NULL, NULL, 'phone', 0, 'text', '402870876e5d9773016e5e95575601c0', NULL, 0, 0, NULL, NULL, 'cskefu', NULL, NULL, 'uk_entcustomer', NULL, 100, 0, 1, 0, 40, 1, 0, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, 1, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, NULL, NULL, 0),
	('402870876e5d9773016e5e95576201d8', '省', NULL, NULL, NULL, 'province', 0, 'text', '402870876e5d9773016e5e95575601c0', NULL, 0, 0, NULL, NULL, 'cskefu', NULL, NULL, 'uk_entcustomer', NULL, 100, 0, 1, 0, 60, 1, 1, 'com.dic.address.area', NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, 1, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, NULL, NULL, 0),
	('402870876e5d9773016e5e95576201d9', '市区县', NULL, NULL, NULL, 'city', 0, 'text', '402870876e5d9773016e5e95575601c0', NULL, 0, 0, NULL, NULL, 'cskefu', NULL, NULL, 'uk_entcustomer', NULL, 100, 0, 1, 0, 60, 1, 1, 'com.dic.address.area', NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, 1, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, NULL, NULL, 0),
	('402870876e5d9773016e5e95576201db', '地址', NULL, NULL, NULL, 'address', 0, 'text', '402870876e5d9773016e5e95575601c0', NULL, 0, 0, NULL, NULL, 'cskefu', NULL, NULL, 'uk_entcustomer', NULL, 100, 0, 1, 0, 255, 1, 0, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, 1, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, NULL, NULL, 0),
	('402870876e5d9773016e5e95576301e3', '所属行业', NULL, NULL, NULL, 'industry', 0, 'text', '402870876e5d9773016e5e95575601c0', NULL, 0, 0, NULL, NULL, 'cskefu', NULL, NULL, 'uk_entcustomer', NULL, 100, 0, 1, 0, 60, 1, 1, 'com.dic.contacts.industry', NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, 1, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, NULL, NULL, 0),
	('402870876e5d9773016e5e95576301e4', '效力状态', NULL, NULL, NULL, 'validstatus', 0, 'text', '402870876e5d9773016e5e95575601c0', NULL, 0, 0, NULL, NULL, 'cskefu', NULL, NULL, 'uk_entcustomer', NULL, 100, 0, 1, 0, 50, 1, 1, 'com.dic.contacts.validstatus', NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, 1, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, NULL, NULL, 0),
	('402870876e5d9773016e5e95576301ef', '描述', NULL, NULL, NULL, 'description', 0, 'text', '402870876e5d9773016e5e95575601c0', NULL, 0, 0, NULL, NULL, 'cskefu', NULL, NULL, 'uk_entcustomer', NULL, 100, 0, 1, 0, 65535, 1, 0, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, 1, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, NULL, NULL, 0),
	('402870876e5d9773016e5e95576401f0', '创建人', NULL, NULL, NULL, 'creater', 0, 'text', '402870876e5d9773016e5e95575601c0', NULL, 0, 0, NULL, NULL, 'cskefu', NULL, NULL, 'uk_entcustomer', NULL, 100, 0, 1, 0, 60, 1, 0, '', NULL, NULL, '', 'userdata', NULL, NULL, NULL, NULL, NULL, 1, 0, NULL, NULL, NULL, 1, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, NULL, NULL, 0),
	('402870876e5d9773016e5e95576401f4', '修改时间', NULL, NULL, NULL, 'updatetime', 0, 'datetime', '402870876e5d9773016e5e95575601c0', NULL, 0, 0, NULL, NULL, 'cskefu', NULL, NULL, 'uk_entcustomer', NULL, 100, 0, 1, 0, 19, 1, 0, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, 1, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, NULL, NULL, 0),
	('402870876e5d9773016e5e95576401f6', '创建时间', NULL, NULL, NULL, 'createtime', 0, 'datetime', '402870876e5d9773016e5e95575601c0', NULL, 0, 0, NULL, NULL, 'cskefu', NULL, NULL, 'uk_entcustomer', NULL, 100, 0, 1, 0, 19, 1, 0, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, 1, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, NULL, NULL, 0),
	('402870876e5d9773016e5e95576401f9', '分享给', NULL, NULL, NULL, 'shares', 0, 'text', '402870876e5d9773016e5e95575601c0', NULL, 0, 0, NULL, NULL, 'cskefu', NULL, NULL, 'uk_entcustomer', NULL, 100, 0, 1, 0, 255, 1, 0, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, 1, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, NULL, NULL, 0),
	('402870876e5d9773016e5e9cc6380272', '坐席用户名', NULL, NULL, NULL, 'agentusername', 0, 'text', '402870876e5d9773016e5e9cc6370270', NULL, 0, 0, NULL, NULL, 'cskefu', NULL, NULL, 'uk_servicesummary', NULL, 100, 0, 1, 0, 100, 1, 0, '', NULL, NULL, '', 'userdata', NULL, NULL, NULL, NULL, NULL, 1, 0, NULL, NULL, NULL, 1, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, NULL, NULL, 0),
	('402870876e5d9773016e5e9cc6380275', '服务次数', NULL, NULL, NULL, 'times', 0, 'number', '402870876e5d9773016e5e9cc6370270', NULL, 0, 0, NULL, NULL, 'cskefu', NULL, NULL, 'uk_servicesummary', NULL, 100, 0, 1, 0, 10, 1, 0, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, 1, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, NULL, NULL, 0),
	('402870876e5d9773016e5e9cc6390278', '用户名', NULL, NULL, NULL, 'username', 0, 'text', '402870876e5d9773016e5e9cc6370270', NULL, 0, 0, NULL, NULL, 'cskefu', NULL, NULL, 'uk_servicesummary', NULL, 100, 0, 1, 0, 100, 1, 0, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, 1, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, NULL, NULL, 0),
	('402870876e5d9773016e5e9cc63a027a', '渠道', NULL, NULL, NULL, 'channel', 0, 'text', '402870876e5d9773016e5e9cc6370270', NULL, 0, 0, NULL, NULL, 'cskefu', NULL, NULL, 'uk_servicesummary', NULL, 100, 0, 1, 0, 32, 1, 0, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, 1, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, NULL, NULL, 0),
	('402870876e5d9773016e5e9cc63a027b', '登录时间', NULL, NULL, NULL, 'logindate', 0, 'datetime', '402870876e5d9773016e5e9cc6370270', NULL, 0, 0, NULL, NULL, 'cskefu', NULL, NULL, 'uk_servicesummary', NULL, 100, 0, 1, 0, 19, 1, 0, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, 1, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, NULL, NULL, 0),
	('402870876e5d9773016e5e9cc63a027c', '服务类型', NULL, NULL, NULL, 'servicetype', 0, 'text', '402870876e5d9773016e5e9cc6370270', NULL, 0, 0, NULL, NULL, 'cskefu', NULL, NULL, 'uk_servicesummary', NULL, 100, 0, 1, 0, 65535, 1, 0, 'com.dic.db.type', NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, 1, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, NULL, NULL, 0),
	('402870876e5d9773016e5e9cc63a027d', '是否预约', NULL, NULL, NULL, 'reservation', 0, 'text', '402870876e5d9773016e5e9cc6370270', NULL, 0, 0, NULL, NULL, 'cskefu', NULL, NULL, 'uk_servicesummary', NULL, 100, 0, 1, 0, 3, 1, 1, 'com.dic.yesorno', NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, 1, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, NULL, NULL, 0),
	('402870876e5d9773016e5e9cc63b027e', '预约方式', NULL, NULL, NULL, 'reservtype', 0, 'text', '402870876e5d9773016e5e9cc6370270', NULL, 0, 0, NULL, NULL, 'cskefu', NULL, NULL, 'uk_servicesummary', NULL, 100, 0, 1, 0, 32, 1, 1, 'com.dic.summary.reservtype', NULL, NULL, '', '', NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, 1, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, NULL, NULL, 0),
	('402870876e5d9773016e5e9cc63b027f', 'reservtime', NULL, NULL, NULL, 'reservtime', 0, 'datetime', '402870876e5d9773016e5e9cc6370270', NULL, 0, 0, NULL, NULL, 'cskefu', NULL, NULL, 'uk_servicesummary', NULL, 100, 0, 1, 0, 19, 1, 0, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, 1, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, NULL, NULL, 0),
	('402870876e5d9773016e5e9cc63b0280', '电子邮件', NULL, NULL, NULL, 'email', 0, 'text', '402870876e5d9773016e5e9cc6370270', NULL, 0, 0, NULL, NULL, 'cskefu', NULL, NULL, 'uk_servicesummary', NULL, 100, 0, 1, 0, 100, 1, 0, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, 1, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, NULL, NULL, 0),
	('402870876e5d9773016e5e9cc63b0281', '电话号码', NULL, NULL, NULL, 'phonenumber', 0, 'text', '402870876e5d9773016e5e9cc6370270', NULL, 0, 0, NULL, NULL, 'cskefu', NULL, NULL, 'uk_servicesummary', NULL, 100, 0, 1, 0, 32, 1, 0, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, 1, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, NULL, NULL, 0),
	('402870876e5d9773016e5e9cc63b0282', '服务记录', NULL, NULL, NULL, 'summary', 0, 'text', '402870876e5d9773016e5e9cc6370270', NULL, 0, 0, NULL, NULL, 'cskefu', NULL, NULL, 'uk_servicesummary', NULL, 100, 0, 1, 0, 65535, 1, 0, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, 1, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, NULL, NULL, 0),
	('402870876e5d9773016e5e9cc63b0284', '创建人', NULL, NULL, NULL, 'creater', 0, 'text', '402870876e5d9773016e5e9cc6370270', NULL, 0, 0, NULL, NULL, 'cskefu', NULL, NULL, 'uk_servicesummary', NULL, 100, 0, 1, 0, 32, 1, 0, '', NULL, NULL, '', 'userdata', NULL, NULL, NULL, NULL, NULL, 1, 0, NULL, NULL, NULL, 1, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, NULL, NULL, 0),
	('402870876e5d9773016e5e9cc63c0285', '创建时间', NULL, NULL, NULL, 'createtime', 0, 'datetime', '402870876e5d9773016e5e9cc6370270', NULL, 0, 0, NULL, NULL, 'cskefu', NULL, NULL, 'uk_servicesummary', NULL, 100, 0, 1, 0, 19, 1, 0, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, 1, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, NULL, NULL, 0),
	('402870876e5d9773016e5e9cc63d028c', 'process', NULL, NULL, NULL, 'process', 0, 'text', '402870876e5d9773016e5e9cc6370270', NULL, 0, 0, NULL, NULL, 'cskefu', NULL, NULL, 'uk_servicesummary', NULL, 100, 0, 1, 0, 3, 1, 0, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, 1, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, NULL, NULL, 0),
	('402870876e5d9773016e5e9cc63d028d', 'updateuser', NULL, NULL, NULL, 'updateuser', 0, 'text', '402870876e5d9773016e5e9cc6370270', NULL, 0, 0, NULL, NULL, 'cskefu', NULL, NULL, 'uk_servicesummary', NULL, 100, 0, 1, 0, 32, 1, 0, '', NULL, NULL, '', 'userdata', NULL, NULL, NULL, NULL, NULL, 1, 0, NULL, NULL, NULL, 1, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, NULL, NULL, 0),
	('402870876e5d9773016e5e9cc63d028e', 'updatetime', NULL, NULL, NULL, 'updatetime', 0, 'datetime', '402870876e5d9773016e5e9cc6370270', NULL, 0, 0, NULL, NULL, 'cskefu', NULL, NULL, 'uk_servicesummary', NULL, 100, 0, 1, 0, 19, 1, 0, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, 1, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, NULL, NULL, 0),
	('402870876e5d9773016e5e9cc63d028f', 'processmemo', NULL, NULL, NULL, 'processmemo', 0, 'text', '402870876e5d9773016e5e9cc6370270', NULL, 0, 0, NULL, NULL, 'cskefu', NULL, NULL, 'uk_servicesummary', NULL, 100, 0, 1, 0, 65535, 1, 0, NULL, NULL, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, NULL, NULL, 1, NULL, NULL, 0, 0, 0, NULL, 0, NULL, NULL, 0, NULL, NULL, 0);


-- ----------------------------
-- Table structure for uk_tabletask
-- ----------------------------
DROP TABLE IF EXISTS `uk_tabletask`;
CREATE TABLE `uk_tabletask` (
  `ID` varchar(32) NOT NULL DEFAULT '' COMMENT '主键ID',
  `NAME` varchar(255) DEFAULT NULL COMMENT '元数据表名称',
  `SECURE` varchar(255) DEFAULT NULL COMMENT '安全级别',
  `TASKSTATUS` varchar(255) DEFAULT NULL COMMENT '任务状态',
  `TABLEDIRID` varchar(255) DEFAULT NULL COMMENT '数据表目录ID',
  `DBID` varchar(255) DEFAULT NULL COMMENT '数据源ID',
  `CODE` varchar(255) DEFAULT NULL COMMENT '代码',
  `GROUPID` varchar(255) DEFAULT NULL COMMENT '分组ID',
  `CREATER` varchar(32) DEFAULT NULL COMMENT '创建人',
  `CREATERNAME` varchar(255) DEFAULT NULL COMMENT '创建人姓名',
  `TASKTYPE` varchar(255) DEFAULT NULL COMMENT '任务类型',
  `TASKNAME` varchar(255) DEFAULT NULL COMMENT '任务名称',
  `TASKPLAN` varchar(255) DEFAULT NULL COMMENT '任务计划',
  `CONFIGURE` varchar(255) DEFAULT NULL COMMENT '配置',
  `SECURECONF` varchar(255) DEFAULT NULL COMMENT '安全级别',
  `USERID` varchar(255) DEFAULT NULL COMMENT '用户ID',
  `PREVIEWTEMPLET` text COMMENT '预览模板',
  `LISTBLOCKTEMPLET` text COMMENT '详情模板',
  `TABLENAME` varchar(255) DEFAULT NULL COMMENT '数据表名称',
  `TABLETYPE` varchar(255) DEFAULT NULL COMMENT '数据表类型',
  `STARTINDEX` int(11) NOT NULL COMMENT '开始位置',
  `UPDATETIME` datetime DEFAULT NULL COMMENT '更新时间',
  `UPDATETIMENUMBER` int(11) NOT NULL COMMENT '更新时间时间戳',
  `DATASQL` longtext COMMENT 'SQL',
  `DATABASETASK` varchar(32) DEFAULT NULL COMMENT '数据库任务',
  `DRIVERPLUGIN` varchar(32) DEFAULT NULL COMMENT '驱动',
  `ORGI` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `WORKFLOW` tinyint(10) DEFAULT NULL COMMENT '流程',
  `FROMDB` tinyint(4) DEFAULT NULL COMMENT '来源数据库',
  `tabtype` varchar(32) DEFAULT NULL COMMENT '切换类型',
  `pid` varchar(32) DEFAULT NULL COMMENT '外部ID',
  `secmenuid` varchar(32) DEFAULT NULL COMMENT '二级菜单ID',
  `reportid` varchar(32) DEFAULT NULL COMMENT '报表ID',
  `eventname` varchar(32) DEFAULT NULL COMMENT '事件名称',
  `tltemplet` varchar(32) DEFAULT NULL COMMENT '标题模板',
  `timeline` tinyint(4) DEFAULT NULL COMMENT '时间',
  `tbversion` int(11) DEFAULT NULL COMMENT '版本',
  `LASTUPDATE` datetime DEFAULT NULL COMMENT '最近更新时间',
  `CREATETIME` datetime DEFAULT NULL COMMENT '创建时间',
  PRIMARY KEY (`ID`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='元数据信息表';


INSERT INTO `uk_tabletask` (`ID`, `NAME`, `SECURE`, `TASKSTATUS`, `TABLEDIRID`, `DBID`, `CODE`, `GROUPID`, `CREATER`, `CREATERNAME`, `TASKTYPE`, `TASKNAME`, `TASKPLAN`, `CONFIGURE`, `SECURECONF`, `USERID`, `PREVIEWTEMPLET`, `LISTBLOCKTEMPLET`, `TABLENAME`, `TABLETYPE`, `STARTINDEX`, `UPDATETIME`, `UPDATETIMENUMBER`, `DATASQL`, `DATABASETASK`, `DRIVERPLUGIN`, `ORGI`, `WORKFLOW`, `FROMDB`, `tabtype`, `pid`, `secmenuid`, `reportid`, `eventname`, `tltemplet`, `timeline`, `tbversion`, `LASTUPDATE`, `CREATETIME`)
VALUES
	('2c9480886e91d9e5016e91f528ab018d', 'uk_contacts', NULL, NULL, '0', NULL, NULL, NULL, '2c9480886e91d9e5016e91db8df10017', 'xianli', NULL, 'uk_contacts', NULL, NULL, NULL, NULL, NULL, NULL, 'uk_contacts', '1', 0, '2019-11-22 15:13:13', 0, NULL, NULL, NULL, 'cskefu', 0, 0, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, '2019-11-22 15:13:13'),
	('402870876e5d9773016e5e95575601c0', 'uk_entcustomer', NULL, NULL, '0', NULL, NULL, NULL, '402870876e4f5bdd016e4f77eb6f0075', 'xiaoxiao', NULL, 'uk_entcustomer', NULL, NULL, NULL, NULL, NULL, NULL, 'uk_entcustomer', '1', 0, '2019-11-12 15:47:53', 0, NULL, NULL, NULL, 'cskefu', 0, 0, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, '2019-11-12 15:47:53'),
	('402870876e5d9773016e5e9cc6370270', 'uk_servicesummary', NULL, NULL, '0', NULL, NULL, NULL, '402870876e4f5bdd016e4f77eb6f0075', 'xiaoxiao', NULL, 'uk_servicesummary', NULL, NULL, NULL, NULL, NULL, NULL, 'uk_servicesummary', '1', 0, '2019-11-12 15:56:02', 0, NULL, NULL, NULL, 'cskefu', 0, 0, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, '2019-11-12 15:56:02');

-- ----------------------------
-- Table structure for uk_tag
-- ----------------------------
DROP TABLE IF EXISTS `uk_tag`;
CREATE TABLE `uk_tag` (
  `id` varchar(32) NOT NULL COMMENT '主键ID',
  `tag` varchar(100) DEFAULT NULL COMMENT '标签',
  `orgi` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `times` int(11) DEFAULT NULL COMMENT '引用次数',
  `creater` varchar(32) DEFAULT NULL COMMENT '创建人',
  `tagtype` varchar(32) DEFAULT NULL COMMENT '标签类型',
  `icon` varchar(50) DEFAULT NULL COMMENT '图标',
  `color` varchar(10) DEFAULT NULL COMMENT '颜色',
  `skill` varchar(32) DEFAULT NULL COMMENT '组织机构ID',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='标签表';



-- ----------------------------
-- Table structure for uk_tagrelation
-- ----------------------------
DROP TABLE IF EXISTS `uk_tagrelation`;
CREATE TABLE `uk_tagrelation` (
  `id` varchar(32) NOT NULL COMMENT '主键ID',
  `tagid` varchar(32) DEFAULT NULL COMMENT '标签ID',
  `userid` varchar(32) DEFAULT NULL COMMENT '创建人',
  `dataid` varchar(32) DEFAULT NULL COMMENT '数据ID',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='标签映射关系表';


-- ----------------------------
-- Table structure for uk_templet
-- ----------------------------
DROP TABLE IF EXISTS `uk_templet`;
CREATE TABLE `uk_templet` (
  `ID` varchar(32) NOT NULL COMMENT '主键ID',
  `NAME` varchar(255) DEFAULT NULL COMMENT '模板名称',
  `DESCRIPTION` longtext COMMENT '描述',
  `CODE` varchar(255) DEFAULT NULL COMMENT '代码',
  `GROUPID` varchar(255) DEFAULT NULL COMMENT '组ID',
  `CREATETIME` datetime DEFAULT NULL COMMENT '创建时间',
  `USERID` varchar(255) DEFAULT NULL COMMENT '创建人ID',
  `TEMPLETTITLE` varchar(500) DEFAULT NULL COMMENT '模板标题内容',
  `TEMPLETTEXT` longtext COMMENT '模板内容',
  `TEMPLETTYPE` varchar(255) DEFAULT NULL COMMENT '模板类型',
  `ORGI` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `ICONSTR` varchar(255) DEFAULT NULL COMMENT '自定义样式',
  `MEMO` varchar(255) DEFAULT NULL COMMENT '备注',
  `ORDERINDEX` int(11) DEFAULT NULL COMMENT '排序位置',
  `TYPEID` varchar(32) DEFAULT NULL COMMENT '分类ID',
  `SELDATA` tinyint(4) DEFAULT NULL COMMENT '启用外键',
  `layoutcols` int(11) DEFAULT '0' COMMENT '布局列数',
  `datatype` varchar(32) DEFAULT NULL COMMENT '数据类型',
  `charttype` varchar(32) DEFAULT NULL COMMENT '图表类型',
  PRIMARY KEY (`ID`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='模板表';

-- ----------------------------
-- Records of uk_templet
-- ----------------------------
BEGIN;
INSERT INTO `uk_templet` VALUES ('4028811b618d0dca01618f99e056035c', '四列布局', NULL, 'layout', NULL, '2018-02-13 22:38:01', NULL, NULL, '<div class=\"layui-col-md3 ukefu-col\" data-colspan=\"3\" data-index=\"1\" data-mid=\"${model.id}\">\r\n	<#list reportModels as element>\r\n	<#if element.parentid?? && element.parentid == model.id && element.colindex == 1>\r\n	<#assign eltemplet = element.templet()>\r\n	<#include \"/apps/business/report/design/element.html\">\r\n	</#if>\r\n	</#list>\r\n</div>\r\n<div class=\"layui-col-md3 ukefu-col\" data-colspan=\"3\" data-index=\"2\" data-mid=\"${model.id}\">\r\n	<#list reportModels as element>\r\n	<#if element.parentid?? && element.parentid == model.id && element.colindex == 2>\r\n	<#assign eltemplet = element.templet()>\r\n	<#include \"/apps/business/report/design/element.html\">\r\n	</#if>\r\n	</#list>\r\n</div>\r\n<div class=\"layui-col-md3 ukefu-col\" data-colspan=\"3\" data-index=\"3\" data-mid=\"${model.id}\">\r\n	<#list reportModels as element>\r\n	<#if element.parentid?? && element.parentid == model.id && element.colindex == 3>\r\n	<#assign eltemplet = element.templet()>\r\n	<#include \"/apps/business/report/design/element.html\">\r\n	</#if>\r\n	</#list>\r\n</div>\r\n<div class=\"layui-col-md3 ukefu-col\" data-colspan=\"3\" data-index=\"4\" data-mid=\"${model.id}\">\r\n	<#list reportModels as element>\r\n	<#if element.parentid?? && element.parentid == model.id && element.colindex == 4>\r\n	<#assign eltemplet = element.templet()>\r\n	<#include \"/apps/business/report/design/element.html\">\r\n	</#if>\r\n	</#list>\r\n</div>', '4028811b618d0dca01618d5a5fd10349', 'cskefu', '/images/design/four.png', NULL, NULL, NULL, NULL, 4, NULL, NULL);
INSERT INTO `uk_templet` VALUES ('4028811b618d0dca01618f99f175035d', '三列布局', NULL, 'layout', NULL, '2018-02-13 22:38:06', NULL, NULL, '<div class=\"layui-col-md4 ukefu-col\" data-colspan=\"4\" data-index=\"1\" data-mid=\"${model.id}\">\r\n	<#list reportModels as element>\r\n	<#if element.parentid?? && element.parentid == model.id && element.colindex == 1>\r\n	<#assign eltemplet = element.templet()>\r\n	<#include \"/apps/business/report/design/element.html\">\r\n	</#if>\r\n	</#list>\r\n</div>\r\n<div class=\"layui-col-md4 ukefu-col\" data-colspan=\"4\" data-index=\"2\" data-mid=\"${model.id}\">\r\n	<#list reportModels as element>\r\n	<#if element.parentid?? && element.parentid == model.id && element.colindex == 2>\r\n	<#assign eltemplet = element.templet()>\r\n	<#include \"/apps/business/report/design/element.html\">\r\n	</#if>\r\n	</#list>\r\n</div>\r\n<div class=\"layui-col-md4 ukefu-col\" data-colspan=\"4\" data-index=\"3\" data-mid=\"${model.id}\">\r\n	<#list reportModels as element>\r\n	<#if element.parentid?? && element.parentid == model.id && element.colindex == 3>\r\n	<#assign eltemplet = element.templet()>\r\n	<#include \"/apps/business/report/design/element.html\">\r\n	</#if>\r\n	</#list>\r\n</div>', '4028811b618d0dca01618d5a5fd10349', 'cskefu', '/images/design/three.png', NULL, NULL, NULL, NULL, 3, NULL, NULL);
INSERT INTO `uk_templet` VALUES ('4028811b618d0dca01618f9a08c5035e', '两列布局', NULL, 'layout', NULL, '2018-02-13 22:38:12', NULL, NULL, '<div class=\"layui-col-md6 ukefu-col\" data-colspan=\"6\" data-index=\"1\" data-mid=\"${model.id}\">\r\n	<#list reportModels as element>\r\n	<#if element.parentid?? && element.parentid == model.id && element.colindex == 1>\r\n	<#assign eltemplet = element.templet()>\r\n	<#include \"/apps/business/report/design/element.html\">\r\n	</#if>\r\n	</#list>\r\n</div>\r\n<div class=\"layui-col-md6 ukefu-col\" data-colspan=\"6\" data-index=\"2\" data-mid=\"${model.id}\">\r\n	<#list reportModels as element>\r\n	<#if element.parentid?? && element.parentid == model.id && element.colindex == 2>\r\n	<#assign eltemplet = element.templet()>\r\n	<#include \"/apps/business/report/design/element.html\">\r\n	</#if>\r\n	</#list>\r\n</div>', '4028811b618d0dca01618d5a5fd10349', 'cskefu', '/images/design/two.png', NULL, NULL, NULL, NULL, 2, NULL, NULL);
INSERT INTO `uk_templet` VALUES ('4028811b618d0dca01618f9a1aee035f', '一列布局', NULL, 'layout', NULL, '2018-02-13 22:38:16', NULL, NULL, '<div class=\"layui-col-md12 ukefu-col\" data-colspan=\"12\" data-index=\"1\" data-mid=\"${model.id}\">\r\n	<#list reportModels as element>\r\n	<#if element.parentid?? && element.parentid == model.id && element.colindex == 1>\r\n	<#assign eltemplet = element.templet()>\r\n	<#include \"/apps/business/report/design/element.html\">\r\n	</#if>\r\n	</#list>\r\n</div>', '4028811b618d0dca01618d5a5fd10349', 'cskefu', '/images/design/one.png', NULL, NULL, NULL, NULL, 1, NULL, NULL);
INSERT INTO `uk_templet` VALUES ('4028811b6191e289016191e4721c033d', '数据表', NULL, 'report', NULL, '2018-02-14 09:18:43', NULL, NULL, '<#if reportData??>\r\n<table class=\"layui-table ukefu-report\">\r\n  <thead>\r\n	<#if reportData?? && reportData.col?? && reportData.col.title??>\r\n	  <#list reportData.col.title as tlist>\r\n		<tr class=\"sortableTr\">\r\n		  <#if reportData.col.title?size gt 1 && tlist_index==0 && reportData.row.title?size gt 0>\r\n			<td align=\"center\" colspan=\"${reportData.row.title?size}\" rowspan=\"${reportData.col.title?size-1}\" class=\"s_blue\"></td>\r\n		  </#if>\r\n		  <#if (tlist_index+1)==reportData.col.title?size && reportData.row?? && reportData.row.firstTitle??>\r\n			<#list reportData.row.firstTitle as first>\r\n			  <td align=\"center\" data-title=\"${first.name?url}\" data-flag=\"dim\">${first.rename!first.name!\'\'}				\r\n			</#list>\r\n		  </#if>\r\n		  <#if tlist??>\r\n			<#list tlist as tl>\r\n			  <td align=\"center\" <#if tl.leveltype?? && tl.leveltype==\"newcol\">rowspan=\"${reportData.col.title?size}\"</#if>colspan=\"${tl.colspan}\" > ${tl.rename!tl.name!\"\"}\r\n				</td>\r\n			</#list>\r\n			</#if>\r\n	</tr>\r\n	</#list>\r\n	</#if>\r\n  </thead>\r\n  <tbody>\r\n	<#if reportData?? && reportData.data??>\r\n	  <#list reportData.data as values>\r\n		<tr class=\"rowcell\">\r\n		  <#if reportData.row?? && reportData.row.title?? && reportData.row.title?size gt 0>\r\n			<#list reportData.row.title as tl>\r\n			  <#assign rows=0>\r\n				<#list tl as title>\r\n				  <#if title??>\r\n					<#if rows==values_index && title.name !=\"TOTAL_TEMP\">\r\n					  	<#if title.leveltype !=\"newrow_extend_sum\">\r\n						<td nowrap=\"nowrap\" align=\"center\" class=\"blue_k <#if title.total == true>total</#if>\" rowspan=\"${title.rowspan!\'0\'}\" <#if title.colspan gt 1>colspan=\"${title.colspan}\"</#if>>\r\n						  ${title.formatName!\'\'}</td>\r\n						</#if>\r\n						<#if title.valueData??>\r\n						  <#list title.valueData as value>\r\n							<#if value.merge==false>\r\n							  <td rowspan=\"${value.rowspan}\" colspan=\"${value.colspan}\" align=\"center\" class=\"measure ${value.vtclass!\'\'}\" nowrap=\"nowrap\" <#if value.cellmergeid??>data-cellmerge=\"${value.cellmergeid}\"</#if>>\r\n							${value.valueStyle!value.foramatValue!\'\'}</td>\r\n							</#if>\r\n							</#list>\r\n						  </#if>\r\n					  </#if>\r\n					  <#assign rows=rows + title.rowspan>\r\n				  </#if>\r\n			</#list>\r\n	</#list>\r\n	<#else>\r\n	  <#list values as value>\r\n		<td class=\"row \" style=\"text-align: right;<#if value.valueType?? && value.valueType == \'total\'>background-color:#c5daed;</#if>\">\r\n		  ${value.valueStyle!value.foramatValue!\'\'}</td>\r\n	  </#list>\r\n	  </#if>\r\n	  </tr>\r\n	  </#list>\r\n	  </#if>\r\n  </tbody>\r\n</table>\r\n<#if reportModel?? && reportModel.isloadfulldata == \'true\'>\r\n<#if reportData?? && reportData.total gt reportData.pageSize>\r\n<div class=\"row\" style=\"padding:5px;\">\r\n	<div class=\"col-lg-12\" id=\"page_${reportModel.id!\'\'}\" style=\"text-align:center;\"></div>\r\n</div>\r\n</#if>\r\n<script>\r\n	layui.use([\'laypage\', \'layer\',\'form\'], function(){\r\n		  var laypage = layui.laypage\r\n		  ,layer = layui.layer;\r\n		  laypage.render({\r\n			  elem:\'page_${reportModel.id!\'\'}\'\r\n				,count: <#if reportData??>${reportData.total}<#else>0</#if> \r\n				,curr:<#if reportData??>${reportData.page}<#else>0</#if>\r\n				,groups: 5 \r\n				,limit:<#if reportData?? && reportData.pageSize gt 0>${reportData.pageSize}<#else>20</#if>\r\n				,jump:function(data , first){\r\n					if(!first){\r\n						loadURL(\"/apps/report/design/getelement.html?id=<#if reportModel??>${reportModel.id!\'\'}</#if>&p=\"+data.curr,\"#${reportModel.id!\'\'}\");\r\n					}\r\n				}\r\n		   });\r\n		});\r\n</script>\r\n</#if>\r\n<#else>\r\n<div class=\"layui-form\">\r\n  <table class=\"layui-table\">\r\n    <thead>\r\n      <tr><th>人物</th><th>民族</th><th>格言</th></tr> \r\n    </thead>\r\n    <tbody>\r\n      <tr><td>贤心</td><td>汉族</td><td>人生似修行</td>\r\n      </tr>\r\n      <tr><td>张爱玲</td><td>汉族</td><td>时间</td></tr>\r\n      <tr><td>Helen Keller</td><td>拉丁美裔</td><td>nothing</td></tr>\r\n    </tbody>\r\n  </table>\r\n</div>\r\n</#if>', '4028811b618d0dca01618d5a5fe6034a', 'cskefu', '/images/design/table.png', NULL, NULL, NULL, NULL, 0, 'simple', NULL);
INSERT INTO `uk_templet` VALUES ('4028811b6191e289016191e76714033e', '金字塔图', NULL, 'report', NULL, '2018-02-14 09:21:57', NULL, NULL, '	<script>\r\n	<#if reportData??>\r\n	var data_${element.mid!\'\'} = [];\r\n		<#if reportData.row??>\r\n			<#list reportData.row.title as title>\r\n				<#if (title_index+1) == reportData.row.title?size>\r\n					<#list title as rowtl>\r\n						var obj_${element.mid!\'\'} = new Object();\r\n						obj_${element.mid!\'\'}[\"_name\"] = \"${rowtl.rename!rowtl.name!\'\'}\";\r\n						<#if reportData.col??>\r\n						<#list reportData.col.title as coltlist>\r\n							<#list coltlist as coltl>\r\n								<#if reportData?? && reportData.data??>\r\n									<#list reportData.data as values>\r\n										<#if rowtl_index == values_index>\r\n											<#list values as val>	\r\n												<#if coltl_index == val_index && val_index == 0>\r\n													obj_${element.mid!\'\'}[\'key\'] = ${val.valueStyle!val.foramatValue!\'\'}\r\n												</#if>\r\n												<#if coltl_index == val_index && val_index == 1>\r\n													obj_${element.mid!\'\'}[\'value\'] = ${val.valueStyle!val.foramatValue!\'\'}\r\n												</#if>\r\n											</#list>\r\n										</#if>\r\n									</#list>\r\n								</#if>\r\n							</#list>\r\n						</#list>	\r\n						</#if>\r\n						data_${element.mid!\'\'}.push(obj_${element.mid!\'\'})						\r\n					</#list>			\r\n				</#if>\r\n			</#list>\r\n		</#if>\r\n		<#else>\r\n		const data_${element.mid!\'\'} = [\r\n					{ key: \'浏览网站\', value: 50000 },\r\n					{ key: \'放入购物车\', value: 35000 },\r\n					{ key: \'生成订单\', value: 25000 },\r\n					{ key: \'支付订单\', value: 15000 },\r\n					{ key: \'完成交易\', value: 8000 }\r\n				  ];		\r\n		</#if>	\r\n	  const dv_${element.mid!\'\'} = data_${element.mid!\'\'};\r\n	var json_${element.mid!\'\'} =  $.parseJSON( $(\"#json_${element.mid!\'\'}\").text() );\r\n	  $(\"#json_${element.mid!\'\'}\").remove();\r\n	  ChartAction.renderChart(\'${element.mid!\'\'}\',dv_${element.mid!\'\'},json_${element.mid!\'\'})\r\n	</script>\r\n', '4028811b618d0dca01618d5a5fe6034a', 'cskefu', '/images/design/jzt.png', NULL, NULL, NULL, NULL, 0, NULL, 'pyramid');
INSERT INTO `uk_templet` VALUES ('4028811b6191e289016191e7c554033f', '地图', NULL, 'report', NULL, '2018-02-14 09:22:21', NULL, NULL, '	<script>\r\n	<#if reportData??>\r\n	var data_${element.mid!\'\'} = [];\r\n	<#if reportData.row??>\r\n		<#list reportData.row.title as title>\r\n			<#if (title_index+1) == reportData.row.title?size>\r\n				<#list title as rowtl>	\r\n					var obj_${element.mid!\'\'} = new Object();\r\n					obj_${element.mid!\'\'}[\"key\"] = \'${rowtl.rename!rowtl.name!\'\'}\';\r\n					<#if reportData.col??>\r\n						<#list reportData.col.title as coltlist>\r\n							<#list coltlist as coltl>\r\n								<#if coltl_index == 0>	\r\n									<#list reportData.data as values>\r\n										<#if rowtl_index == values_index>\r\n											<#list values as val>	\r\n												<#if coltl_index == 0>\r\n													obj_${element.mid!\'\'}[\"value\"] = ${val.valueStyle!val.foramatValue!\'\'}\r\n												</#if>\r\n											</#list>\r\n										</#if>\r\n									</#list>									\r\n								</#if>																			\r\n							</#list>\r\n						</#list>\r\n					</#if>	\r\n					data_${element.mid!\'\'}.push(obj_${element.mid!\'\'});		\r\n				</#list>										\r\n			</#if>\r\n		</#list>\r\n	</#if>		\r\n	</#if>	\r\n	let func_${element.mid!\'\'} = function(geoJson){\r\n	<#if !reportData??>\r\n		const data1_${element.mid!\'\'} = [];\r\n		  for (let i = 0; i < geoJson.length; i++) {\r\n	  	      let name = geoJson[i].properties.name;\r\n	  	      data1_${element.mid!\'\'}.push({\r\n	  	        key: name,\r\n	  	        value: Math.round(Math.random() * 1000),\r\n	  	      });\r\n	  	    }\r\n	<#else>\r\n		const data1_${element.mid!\'\'} = [];\r\n		for (let i = 0; i < geoJson.length; i++) {\r\n			let name = geoJson[i].properties.name;\r\n			let value = 0;\r\n			for (let j = 0; j < data_${element.mid!\'\'}.length;j++) {				  	      \r\n			  let name2 = data_${element.mid!\'\'}[j][\"key\"];\r\n			  if(name == name2){\r\n				value = data_${element.mid!\'\'}[j].value;\r\n			  }	      \r\n	  	    }\r\n			data1_${element.mid!\'\'}.push({\r\n	  	        key: name,\r\n	  	        value: value,\r\n	  	      });\r\n	  	    }\r\n	</#if>\r\n	\r\n		let mapData_${element.mid!\'\'} = {\r\n	      type: \'FeatureCollection\',\r\n	      features: geoJson\r\n		};\r\n	    let ds_${element.mid!\'\'} = new DataSet();\r\n	    let geoDataView_${element.mid!\'\'} = ds_${element.mid!\'\'}.createView().source(mapData_${element.mid!\'\'}, {\r\n	      type: \'GeoJSON\',\r\n	    });\r\n\r\n	    // 用户数据\r\n	    let dvData_${element.mid!\'\'} = ds_${element.mid!\'\'}.createView().source(data1_${element.mid!\'\'});\r\n	    dvData_${element.mid!\'\'}.transform({\r\n	      type: \'geo.region\',\r\n	      field: \'key\',\r\n	      geoDataView: geoDataView_${element.mid!\'\'},\r\n	      as: [\'longitude\', \'lantitude\'],\r\n	    });\r\n	   var json_${element.mid!\'\'} =  $.parseJSON( $(\"#json_${element.mid!\'\'}\").text() );\r\n	  $(\"#json_${element.mid!\'\'}\").remove();\r\n	  ChartAction.renderChart(\'${element.mid!\'\'}\',dvData_${element.mid!\'\'},json_${element.mid!\'\'})\r\n	}\r\n	    mapLoad(func_${element.mid!\'\'});\r\n	</script>', '4028811b618d0dca01618d5a5fe6034a', 'cskefu', '/images/design/map.png', NULL, NULL, NULL, NULL, 0, NULL, 'map');
INSERT INTO `uk_templet` VALUES ('4028811b6191e289016191ea38620340', '漏斗图', NULL, 'report', NULL, '2018-02-14 09:25:01', NULL, NULL, '	<script>\r\n	<#if reportData??>\r\n	var data_${element.mid!\'\'} = [];\r\n		<#if reportData.row??>\r\n			<#list reportData.row.title as title>\r\n				<#if (title_index+1) == reportData.row.title?size>\r\n					<#list title as rowtl>\r\n						var obj_${element.mid!\'\'} = new Object();\r\n						obj_${element.mid!\'\'}[\"_name\"] = \"${rowtl.rename!rowtl.name!\'\'}\";\r\n						<#if reportData.col??>\r\n						<#list reportData.col.title as coltlist>\r\n							<#list coltlist as coltl>\r\n								<#if reportData?? && reportData.data??>\r\n									<#list reportData.data as values>\r\n										<#if rowtl_index == values_index>\r\n											<#list values as val>	\r\n												<#if coltl_index == val_index && val_index == 0>\r\n													obj_${element.mid!\'\'}[\'key\'] = ${val.valueStyle!val.foramatValue!\'\'}\r\n												</#if>\r\n												<#if coltl_index == val_index && val_index == 1>\r\n													obj_${element.mid!\'\'}[\'value\'] = ${val.valueStyle!val.foramatValue!\'\'}\r\n												</#if>\r\n											</#list>\r\n										</#if>\r\n									</#list>\r\n								</#if>\r\n							</#list>\r\n						</#list>	\r\n						</#if>\r\n						data_${element.mid!\'\'}.push(obj_${element.mid!\'\'})						\r\n					</#list>			\r\n				</#if>\r\n			</#list>\r\n		</#if>\r\n		<#else>\r\n		const data_${element.mid!\'\'} = [\r\n					{ key: \'浏览网站\', value: 50000 },\r\n					{ key: \'放入购物车\', value: 35000 },\r\n					{ key: \'生成订单\', value: 25000 },\r\n					{ key: \'支付订单\', value: 15000 },\r\n					{ key: \'完成交易\', value: 8000 }\r\n				  ];		\r\n		</#if>	\r\n	  const dv_${element.mid!\'\'} = data_${element.mid!\'\'};\r\n	var json_${element.mid!\'\'} =  $.parseJSON( $(\"#json_${element.mid!\'\'}\").text() );\r\n	  $(\"#json_${element.mid!\'\'}\").remove();\r\n	  ChartAction.renderChart(\'${element.mid!\'\'}\',dv_${element.mid!\'\'},json_${element.mid!\'\'})\r\n	</script>\r\n', '4028811b618d0dca01618d5a5fe6034a', 'cskefu', '/images/design/loudou.png', NULL, NULL, NULL, NULL, 0, NULL, 'funnel');
INSERT INTO `uk_templet` VALUES ('4028811b6191e289016191eba2190341', '折线图', NULL, 'report', NULL, '2018-02-14 09:26:34', NULL, NULL, '	<script>\r\n	<#if reportData??>\r\n	var data_${element.mid!\'\'} = [];\r\n	var mea_${element.mid!\'\'} = [];\r\n		<#if reportData.row??>\r\n			<#list reportData.row.title as title>\r\n				<#if (title_index+1) == reportData.row.title?size>\r\n					<#if reportData.col??>\r\n						<#list reportData.col.title as coltlist>\r\n							<#list coltlist as coltl>\r\n									var obj_${element.mid!\'\'} = new Object();\r\n									obj_${element.mid!\'\'}[\"_name\"] = \"${coltl.rename!coltl.name!\'\'}\";\r\n									<#list title as rowtl2>							\r\n									<#if reportData?? && reportData.data??>\r\n										<#list reportData.data as values>\r\n											<#if rowtl2_index == values_index>\r\n												<#list values as val>	\r\n													<#if coltl_index == val_index>\r\n														obj_${element.mid!\'\'}[\"${rowtl2.rename!rowtl2.name!\'\'}\"] = ${val.valueStyle!val.foramatValue!\'\'}\r\n													</#if>\r\n												</#list>\r\n											</#if>\r\n										</#list>\r\n									</#if>\r\n									</#list>\r\n									data_${element.mid!\'\'}.push(obj_${element.mid!\'\'});						\r\n							</#list>\r\n						</#list>\r\n					</#if>\r\n					<#list title as rowtl>						\r\n						mea_${element.mid!\'\'}.push(\'${rowtl.rename!rowtl.name!\'\'}\');						\r\n					</#list>\r\n				</#if>\r\n			</#list>\r\n		</#if>\r\n	<#else>\r\n		const data_${element.mid!\'\'} = [\r\n			{ _name:\'London\', \'Jan.\': 18.9, \'Feb.\': 28.8, \'Mar.\' :39.3, \'Apr.\': 81.4, \'May\': 47, \'Jun.\': 20.3, \'Jul.\': 24, \'Aug.\': 35.6 },\r\n			{ _name:\'Berlin\', \'Jan.\': 12.4, \'Feb.\': 23.2, \'Mar.\' :34.5, \'Apr.\': 99.7, \'May\': 52.6, \'Jun.\': 35.5, \'Jul.\': 37.4, \'Aug.\': 42.4}\r\n		  ];\r\n		const mea_${element.mid!\'\'} =  [ \'Jan.\',\'Feb.\',\'Mar.\',\'Apr.\',\'May\',\'Jun.\',\'Jul.\',\'Aug.\' ];\r\n	</#if>\r\n	const ds_${element.mid!\'\'} = new DataSet();\r\n	  const dv_${element.mid!\'\'} = ds_${element.mid!\'\'}.createView().source(data_${element.mid!\'\'});\r\n	  dv_${element.mid!\'\'}.transform({\r\n		type: \'fold\',\r\n		fields: mea_${element.mid!\'\'}, // 展开字段集\r\n		key: \'key\', // key字段\r\n		value: \'value\', // value字段\r\n	  });\r\n		var json_${element.mid!\'\'} =  $.parseJSON( $(\"#json_${element.mid!\'\'}\").text() );\r\n	  $(\"#json_${element.mid!\'\'}\").remove();\r\n	  ChartAction.renderChart(\'${element.mid!\'\'}\',dv_${element.mid!\'\'},json_${element.mid!\'\'})\r\n	</script>\r\n', '4028811b618d0dca01618d5a5fe6034a', 'cskefu', '/images/design/line.gif', NULL, NULL, NULL, NULL, 0, NULL, 'line');
INSERT INTO `uk_templet` VALUES ('4028811b6191e289016191ebf9ae0342', '柱形图', NULL, 'report', NULL, '2018-02-14 09:26:56', NULL, NULL, '	<script>\r\n	<#if reportData??>\r\n	var data_${element.mid!\'\'} = [];\r\n	var mea_${element.mid!\'\'} = [];\r\n		<#if reportData.row??>\r\n			<#list reportData.row.title as title>\r\n				<#if (title_index+1) == reportData.row.title?size>\r\n					<#if reportData.col??>\r\n						<#list reportData.col.title as coltlist>\r\n							<#list coltlist as coltl>\r\n									var obj_${element.mid!\'\'} = new Object();\r\n									obj_${element.mid!\'\'}[\"_name\"] = \"${coltl.rename!coltl.name!\'\'}\";\r\n									<#list title as rowtl2>							\r\n									<#if reportData?? && reportData.data??>\r\n										<#list reportData.data as values>\r\n											<#if rowtl2_index == values_index>\r\n												<#list values as val>	\r\n													<#if coltl_index == val_index>\r\n														obj_${element.mid!\'\'}[\"${rowtl2.rename!rowtl2.name!\'\'}\"] = ${val.valueStyle!val.foramatValue!\'\'}\r\n													</#if>\r\n												</#list>\r\n											</#if>\r\n										</#list>\r\n									</#if>\r\n									</#list>\r\n									data_${element.mid!\'\'}.push(obj_${element.mid!\'\'});						\r\n							</#list>\r\n						</#list>\r\n					</#if>\r\n					<#list title as rowtl>						\r\n						mea_${element.mid!\'\'}.push(\'${rowtl.rename!rowtl.name!\'\'}\');						\r\n					</#list>\r\n				</#if>\r\n			</#list>\r\n		</#if>\r\n	<#else>\r\n		const data_${element.mid!\'\'} = [\r\n			{ _name:\'London\', \'Jan.\': 18.9, \'Feb.\': 28.8, \'Mar.\' :39.3, \'Apr.\': 81.4, \'May\': 47, \'Jun.\': 20.3, \'Jul.\': 24, \'Aug.\': 35.6 },\r\n			{ _name:\'Berlin\', \'Jan.\': 12.4, \'Feb.\': 23.2, \'Mar.\' :34.5, \'Apr.\': 99.7, \'May\': 52.6, \'Jun.\': 35.5, \'Jul.\': 37.4, \'Aug.\': 42.4}\r\n		  ];\r\n		const mea_${element.mid!\'\'} =  [ \'Jan.\',\'Feb.\',\'Mar.\',\'Apr.\',\'May\',\'Jun.\',\'Jul.\',\'Aug.\' ];\r\n	</#if>\r\n	const ds_${element.mid!\'\'} = new DataSet();\r\n	  const dv_${element.mid!\'\'} = ds_${element.mid!\'\'}.createView().source(data_${element.mid!\'\'});\r\n	  dv_${element.mid!\'\'}.transform({\r\n		type: \'fold\',\r\n		fields: mea_${element.mid!\'\'}, // 展开字段集\r\n		key: \'key\', // key字段	\r\n		value: \'value\', // value字段\r\n	  });\r\n	  var json_${element.mid!\'\'} =  $.parseJSON( $(\"#json_${element.mid!\'\'}\").text() );\r\n	  $(\"#json_${element.mid!\'\'}\").remove();\r\n	  ChartAction.renderChart(\'${element.mid!\'\'}\',dv_${element.mid!\'\'},json_${element.mid!\'\'})\r\n	</script>\r\n\r\n\r\n', '4028811b618d0dca01618d5a5fe6034a', 'cskefu', '/images/design/bar.gif', NULL, NULL, NULL, NULL, 0, NULL, 'histogram');
INSERT INTO `uk_templet` VALUES ('4028811b6191e289016191ec3c900343', '饼形图', NULL, 'report', NULL, '2018-02-14 09:27:13', NULL, NULL, '	<script>\r\n	<#if reportData??>\r\n	var data_${element.mid!\'\'} = [];\r\n	var field_${element.mid!\'\'}  = \"\";\r\n	<#if reportData.row??>\r\n		<#list reportData.row.title as title>\r\n			<#if (title_index+1) == reportData.row.title?size>\r\n				<#list title as rowtl>	\r\n					var obj_${element.mid!\'\'} = new Object();\r\n					obj_${element.mid!\'\'}[\"key\"] = \'${rowtl.rename!rowtl.name!\'\'}\';\r\n					<#if reportData.col??>\r\n						<#list reportData.col.title as coltlist>\r\n							<#list coltlist as coltl>\r\n								<#if coltl_index == 0>	\r\n									<#list reportData.data as values>\r\n										<#if rowtl_index == values_index>\r\n											<#list values as val>	\r\n												<#if coltl_index == 0>\r\n													obj_${element.mid!\'\'}[\"${coltl.rename!coltl.name!\'\'}\"] = ${val.valueStyle!val.foramatValue!\'\'}\r\n													field_${element.mid!\'\'}  = \'${coltl.rename!coltl.name!\'\'}\';\r\n												</#if>\r\n											</#list>\r\n										</#if>\r\n									</#list>									\r\n								</#if>																			\r\n							</#list>\r\n						</#list>\r\n					</#if>	\r\n					data_${element.mid!\'\'}.push(obj_${element.mid!\'\'});		\r\n				</#list>										\r\n			</#if>\r\n		</#list>\r\n	</#if>\r\n	<#else>\r\n		const data_${element.mid!\'\'} = [\r\n			{ key: \'事例一\', count: 40 },\r\n			{ key: \'事例二\', count: 21 },\r\n			{ key: \'事例三\', count: 17 },\r\n			{ key: \'事例四\', count: 13 },\r\n			{ key: \'事例五\', count: 9 }\r\n		  ];\r\n		  var field_${element.mid!\'\'}  = \"count\";\r\n	</#if>\r\n		console.info(data_${element.mid!\'\'})\r\n		console.info(field_${element.mid!\'\'})\r\n		const { DataView } = DataSet;\r\n	  const dv_${element.mid!\'\'} = new DataView();\r\n	  dv_${element.mid!\'\'}.source(data_${element.mid!\'\'}).transform({\r\n		type: \'percent\',\r\n		field: field_${element.mid!\'\'},\r\n		dimension: \'key\',\r\n		as: \'value\'\r\n	  });\r\n	   var json_${element.mid!\'\'} =  $.parseJSON( $(\"#json_${element.mid!\'\'}\").text() );\r\n	  $(\"#json_${element.mid!\'\'}\").remove();\r\n	  ChartAction.renderChart(\'${element.mid!\'\'}\',dv_${element.mid!\'\'},json_${element.mid!\'\'})\r\n	</script>', '4028811b618d0dca01618d5a5fe6034a', 'cskefu', '/images/design/pie.gif', NULL, NULL, NULL, NULL, 0, NULL, 'pie');
INSERT INTO `uk_templet` VALUES ('4028811b6191e289016191ec901f0344', '面积图', NULL, 'report', NULL, '2018-02-14 09:27:35', NULL, NULL, '	<script>\r\n	<#if reportData??>\r\n	var data_${element.mid!\'\'} = [];\r\n	var mea_${element.mid!\'\'} = [];\r\n		<#if reportData.row??>\r\n			<#list reportData.row.title as title>\r\n				<#if (title_index+1) == reportData.row.title?size>\r\n					<#if reportData.col??>\r\n						<#list reportData.col.title as coltlist>\r\n							<#list coltlist as coltl>\r\n									var obj_${element.mid!\'\'} = new Object();\r\n									obj_${element.mid!\'\'}[\"_name\"] = \"${coltl.rename!coltl.name!\'\'}\";\r\n									<#list title as rowtl2>							\r\n									<#if reportData?? && reportData.data??>\r\n										<#list reportData.data as values>\r\n											<#if rowtl2_index == values_index>\r\n												<#list values as val>	\r\n													<#if coltl_index == val_index>\r\n														obj_${element.mid!\'\'}[\"${rowtl2.rename!rowtl2.name!\'\'}\"] = ${val.valueStyle!val.foramatValue!\'\'}\r\n													</#if>\r\n												</#list>\r\n											</#if>\r\n										</#list>\r\n									</#if>\r\n									</#list>\r\n									data_${element.mid!\'\'}.push(obj_${element.mid!\'\'});						\r\n							</#list>\r\n						</#list>\r\n					</#if>\r\n					<#list title as rowtl>						\r\n						mea_${element.mid!\'\'}.push(\'${rowtl.rename!rowtl.name!\'\'}\');						\r\n					</#list>\r\n				</#if>\r\n			</#list>\r\n		</#if>		\r\n	<#else>\r\n		const data_${element.mid!\'\'} = [\r\n			{ _name:\'London\', \'Jan.\': 18.9, \'Feb.\': 28.8, \'Mar.\' :39.3, \'Apr.\': 81.4, \'May\': 47, \'Jun.\': 20.3, \'Jul.\': 24, \'Aug.\': 35.6 },\r\n			{ _name:\'Berlin\', \'Jan.\': 12.4, \'Feb.\': 23.2, \'Mar.\' :34.5, \'Apr.\': 99.7, \'May\': 52.6, \'Jun.\': 35.5, \'Jul.\': 37.4, \'Aug.\': 42.4}\r\n		  ];\r\n		const mea_${element.mid!\'\'} =  [ \'Jan.\',\'Feb.\',\'Mar.\',\'Apr.\',\'May\',\'Jun.\',\'Jul.\',\'Aug.\' ];\r\n	</#if>	\r\n	const { DataView } = DataSet;	\r\n	const ds_${element.mid!\'\'} = new DataSet();\r\n	const dv_${element.mid!\'\'} = new DataView().source(data_${element.mid!\'\'});\r\n	  dv_${element.mid!\'\'}.transform({\r\n		type: \'fold\',\r\n		fields: mea_${element.mid!\'\'}, // 展开字段集\r\n		key: \'key\', // key字段\r\n		value: \'value\', // value字段\r\n	  });  \r\n	   var json_${element.mid!\'\'} =  $.parseJSON( $(\"#json_${element.mid!\'\'}\").text() );\r\n	  $(\"#json_${element.mid!\'\'}\").remove();\r\n	  ChartAction.renderChart(\'${element.mid!\'\'}\',dv_${element.mid!\'\'},json_${element.mid!\'\'})\r\n	</script>', '4028811b618d0dca01618d5a5fe6034a', 'cskefu', '/images/design/area.gif', NULL, NULL, NULL, NULL, 0, NULL, 'area');
INSERT INTO `uk_templet` VALUES ('4028811b6191e289016191ed0e160345', '条形图', NULL, 'report', NULL, '2018-02-14 09:28:07', NULL, NULL, '	<script>\r\n	<#if reportData??>\r\n	var data_${element.mid!\'\'} = [];\r\n	var mea_${element.mid!\'\'} = [];\r\n		<#if reportData.row??>\r\n			<#list reportData.row.title as title>\r\n				<#if (title_index+1) == reportData.row.title?size>\r\n					<#if reportData.col??>\r\n						<#list reportData.col.title as coltlist>\r\n							<#list coltlist as coltl>\r\n									var obj_${element.mid!\'\'} = new Object();\r\n									obj_${element.mid!\'\'}[\"_name\"] = \"${coltl.rename!coltl.name!\'\'}\";\r\n									<#list title as rowtl2>							\r\n									<#if reportData?? && reportData.data??>\r\n										<#list reportData.data as values>\r\n											<#if rowtl2_index == values_index>\r\n												<#list values as val>	\r\n													<#if coltl_index == val_index>\r\n														obj_${element.mid!\'\'}[\"${rowtl2.rename!rowtl2.name!\'\'}\"] = ${val.valueStyle!val.foramatValue!\'\'}\r\n													</#if>\r\n												</#list>\r\n											</#if>\r\n										</#list>\r\n									</#if>\r\n									</#list>\r\n									data_${element.mid!\'\'}.push(obj_${element.mid!\'\'});						\r\n							</#list>\r\n						</#list>\r\n					</#if>\r\n					<#list title as rowtl>						\r\n						mea_${element.mid!\'\'}.push(\'${rowtl.rename!rowtl.name!\'\'}\');						\r\n					</#list>\r\n				</#if>\r\n			</#list>\r\n		</#if>\r\n	<#else>\r\n		const data_${element.mid!\'\'} = [\r\n			{ _name:\'London\', \'Jan.\': 18.9, \'Feb.\': 28.8, \'Mar.\' :39.3, \'Apr.\': 81.4, \'May\': 47, \'Jun.\': 20.3, \'Jul.\': 24, \'Aug.\': 35.6 },\r\n			{ _name:\'Berlin\', \'Jan.\': 12.4, \'Feb.\': 23.2, \'Mar.\' :34.5, \'Apr.\': 99.7, \'May\': 52.6, \'Jun.\': 35.5, \'Jul.\': 37.4, \'Aug.\': 42.4}\r\n		  ];\r\n		const mea_${element.mid!\'\'} =  [ \'Jan.\',\'Feb.\',\'Mar.\',\'Apr.\',\'May\',\'Jun.\',\'Jul.\',\'Aug.\' ];\r\n	</#if>\r\n	const ds_${element.mid!\'\'} = new DataSet();\r\n	  const dv_${element.mid!\'\'} = ds_${element.mid!\'\'}.createView().source(data_${element.mid!\'\'});\r\n	  dv_${element.mid!\'\'}.transform({\r\n		type: \'fold\',\r\n		fields: mea_${element.mid!\'\'}, // 展开字段集\r\n		key: \'key\', // key字段\r\n		value: \'value\', // value字段\r\n	  });\r\n	  \r\n	   var json_${element.mid!\'\'} =  $.parseJSON( $(\"#json_${element.mid!\'\'}\").text() );\r\n	  $(\"#json_${element.mid!\'\'}\").remove();\r\n	  ChartAction.renderChart(\'${element.mid!\'\'}\',dv_${element.mid!\'\'},json_${element.mid!\'\'})\r\n	</script>', '4028811b618d0dca01618d5a5fe6034a', 'cskefu', '/images/design/flat.gif', NULL, NULL, NULL, NULL, 0, NULL, 'bar');
INSERT INTO `uk_templet` VALUES ('4028811b6191e289016191ed46550346', '环形图', NULL, 'report', NULL, '2018-02-14 09:28:21', NULL, NULL, '	<script>\r\n	<#if reportData??>\r\n	var data_${element.mid!\'\'} = [];\r\n	var field_${element.mid!\'\'}  = \"\";\r\n	<#if reportData.row??>\r\n		<#list reportData.row.title as title>\r\n			<#if (title_index+1) == reportData.row.title?size>\r\n				<#list title as rowtl>	\r\n					var obj_${element.mid!\'\'} = new Object();\r\n					obj_${element.mid!\'\'}[\"item\"] = \'${rowtl.rename!rowtl.name!\'\'}\';\r\n					<#if reportData.col??>\r\n						<#list reportData.col.title as coltlist>\r\n							<#list coltlist as coltl>\r\n								<#if coltl_index == 0>	\r\n									<#list reportData.data as values>\r\n										<#if rowtl_index == values_index>\r\n											<#list values as val>	\r\n												<#if coltl_index == 0>\r\n													obj_${element.mid!\'\'}[\"${coltl.rename!coltl.name!\'\'}\"] = ${val.valueStyle!val.foramatValue!\'\'}\r\n													field_${element.mid!\'\'}  = \'${coltl.rename!coltl.name!\'\'}\';\r\n												</#if>\r\n											</#list>\r\n										</#if>\r\n									</#list>									\r\n								</#if>																			\r\n							</#list>\r\n						</#list>\r\n					</#if>	\r\n					data_${element.mid!\'\'}.push(obj_${element.mid!\'\'});		\r\n				</#list>										\r\n			</#if>\r\n		</#list>\r\n	</#if>\r\n	<#else>\r\n		const data_${element.mid!\'\'} = [\r\n			{ key: \'事例一\', count: 40 },\r\n			{ key: \'事例二\', count: 21 },\r\n			{ key: \'事例三\', count: 17 },\r\n			{ key: \'事例四\', count: 13 },\r\n			{ key: \'事例五\', count: 9 }\r\n		  ];\r\n		  var field_${element.mid!\'\'}  = \"count\";\r\n	</#if>\r\n		const { DataView } = DataSet;\r\n	  const dv_${element.mid!\'\'} = new DataView();\r\n	  dv_${element.mid!\'\'}.source(data_${element.mid!\'\'}).transform({\r\n		type: \'percent\',\r\n		field: field_${element.mid!\'\'},\r\n		dimension: \'key\',\r\n		as: \'value\'\r\n	  });\r\n	   var json_${element.mid!\'\'} =  $.parseJSON( $(\"#json_${element.mid!\'\'}\").text() );\r\n	  $(\"#json_${element.mid!\'\'}\").remove();\r\n	  ChartAction.renderChart(\'${element.mid!\'\'}\',dv_${element.mid!\'\'},json_${element.mid!\'\'})\r\n	</script>', '4028811b618d0dca01618d5a5fe6034a', 'cskefu', '/images/design/hole.gif', NULL, NULL, NULL, NULL, 0, NULL, 'ring');
INSERT INTO `uk_templet` VALUES ('4028811b6191e289016191ed97a80347', '点状图', NULL, 'report', NULL, '2018-02-14 09:28:42', NULL, NULL, '	<script>\r\n	<#if reportData??>\r\n	var data_${element.mid!\'\'} = [];\r\n		<#if reportData.row??>\r\n			<#list reportData.row.title as title>\r\n				<#if (title_index+1) == reportData.row.title?size>\r\n					<#list title as rowtl>\r\n						var obj_${element.mid!\'\'} = new Object();\r\n						obj_${element.mid!\'\'}[\"_name\"] = \"${rowtl.rename!rowtl.name!\'\'}\";\r\n						<#if reportData.col??>\r\n						<#list reportData.col.title as coltlist>\r\n							<#list coltlist as coltl>\r\n								<#if reportData?? && reportData.data??>\r\n									<#list reportData.data as values>\r\n										<#if rowtl_index == values_index>\r\n											<#list values as val>	\r\n												<#if coltl_index == val_index && val_index == 0>\r\n													obj_${element.mid!\'\'}[\'key\'] = ${val.valueStyle!val.foramatValue!\'\'}\r\n												</#if>\r\n												<#if coltl_index == val_index && val_index == 1>\r\n													obj_${element.mid!\'\'}[\'value\'] = ${val.valueStyle!val.foramatValue!\'\'}\r\n												</#if>\r\n											</#list>\r\n										</#if>\r\n									</#list>\r\n								</#if>\r\n							</#list>\r\n						</#list>	\r\n						</#if>\r\n						data_${element.mid!\'\'}.push(obj_${element.mid!\'\'})						\r\n					</#list>			\r\n				</#if>\r\n			</#list>\r\n		</#if>\r\n		<#else>\r\n		const data_${element.mid!\'\'} = [{\"_name\":\"female\",\"key\":161.2,\"value\":51.6},{\"_name\":\"female\",\"key\":167.5,\"value\":59},{\"_name\":\"female\",\"key\":159.5,\"value\":49.2},{\"_name\":\"female\",\"key\":157,\"value\":63},{\"_name\":\"female\",\"key\":155.8,\"value\":53.6},{\"_name\":\"female\",\"key\":170,\"value\":59},{\"_name\":\"female\",\"key\":159.1,\"value\":47.6},{\"_name\":\"female\",\"key\":166,\"value\":69.8},{\"_name\":\"female\",\"key\":176.2,\"value\":66.8},{\"_name\":\"female\",\"key\":160.2,\"value\":75.2},{\"_name\":\"female\",\"key\":172.5,\"value\":55.2},{\"_name\":\"female\",\"key\":170.9,\"value\":54.2},{\"_name\":\"female\",\"key\":172.9,\"value\":62.5},{\"_name\":\"female\",\"key\":153.4,\"value\":42},{\"_name\":\"female\",\"key\":160,\"value\":50},{\"_name\":\"female\",\"key\":147.2,\"value\":49.8},{\"_name\":\"female\",\"key\":168.2,\"value\":49.2},{\"_name\":\"female\",\"key\":175,\"value\":73.2},{\"_name\":\"female\",\"key\":157,\"value\":47.8},{\"_name\":\"female\",\"key\":167.6,\"value\":68.8},{\"_name\":\"female\",\"key\":159.5,\"value\":50.6},{\"_name\":\"female\",\"key\":175,\"value\":82.5},{\"_name\":\"female\",\"key\":166.8,\"value\":57.2},{\"_name\":\"female\",\"key\":176.5,\"value\":87.8},{\"_name\":\"female\",\"key\":170.2,\"value\":72.8},{\"_name\":\"female\",\"key\":174,\"value\":54.5},{\"_name\":\"female\",\"key\":173,\"value\":59.8},{\"_name\":\"female\",\"key\":179.9,\"value\":67.3},{\"_name\":\"female\",\"key\":170.5,\"value\":67.8},{\"_name\":\"female\",\"key\":160,\"value\":47},{\"_name\":\"female\",\"key\":154.4,\"value\":46.2},{\"_name\":\"female\",\"key\":162,\"value\":55},{\"_name\":\"female\",\"key\":176.5,\"value\":83},{\"_name\":\"female\",\"key\":160,\"value\":54.4},{\"_name\":\"female\",\"key\":152,\"value\":45.8},{\"_name\":\"female\",\"key\":162.1,\"value\":53.6},{\"_name\":\"female\",\"key\":170,\"value\":73.2},{\"_name\":\"male\",\"key\":160.2,\"value\":52.1},{\"_name\":\"female\",\"key\":161.3,\"value\":67.9}]		\r\n		</#if>	\r\n	  const dv_${element.mid!\'\'} = data_${element.mid!\'\'};\r\n	var json_${element.mid!\'\'} =  $.parseJSON( $(\"#json_${element.mid!\'\'}\").text() );\r\n	  $(\"#json_${element.mid!\'\'}\").remove();\r\n	  ChartAction.renderChart(\'${element.mid!\'\'}\',dv_${element.mid!\'\'},json_${element.mid!\'\'})\r\n	</script>\r\n', '4028811b618d0dca01618d5a5fe6034a', 'cskefu', '/images/design/point.gif', NULL, NULL, NULL, NULL, 0, NULL, 'dotplot');
INSERT INTO `uk_templet` VALUES ('4028811b6191e289016191edc7b50348', '雷达图', NULL, 'report', NULL, '2018-02-14 09:28:54', NULL, NULL, '	<script>\r\n	<#if reportData??>\r\n	var data_${element.mid!\'\'} = [];\r\n	var mea_${element.mid!\'\'} = [];\r\n		<#if reportData.row??>\r\n			<#list reportData.row.title as title>\r\n				<#if (title_index+1) == reportData.row.title?size>\r\n					<#if reportData.col??>\r\n						<#list reportData.col.title as coltlist>\r\n							<#list coltlist as coltl>\r\n									var obj_${element.mid!\'\'} = new Object();\r\n									obj_${element.mid!\'\'}[\"_name\"] = \"${coltl.rename!coltl.name!\'\'}\";\r\n									<#list title as rowtl2>							\r\n									<#if reportData?? && reportData.data??>\r\n										<#list reportData.data as values>\r\n											<#if rowtl2_index == values_index>\r\n												<#list values as val>	\r\n													<#if coltl_index == val_index>\r\n														obj_${element.mid!\'\'}[\"${rowtl2.rename!rowtl2.name!\'\'}\"] = ${val.valueStyle!val.foramatValue!\'\'}\r\n													</#if>\r\n												</#list>\r\n											</#if>\r\n										</#list>\r\n									</#if>\r\n									</#list>\r\n									data_${element.mid!\'\'}.push(obj_${element.mid!\'\'});						\r\n							</#list>\r\n						</#list>\r\n					</#if>\r\n					<#list title as rowtl>						\r\n						mea_${element.mid!\'\'}.push(\'${rowtl.rename!rowtl.name!\'\'}\');						\r\n					</#list>\r\n				</#if>\r\n			</#list>\r\n		</#if>\r\n	<#else>\r\n		const data_${element.mid!\'\'} = [\r\n			{ _name:\'London\', \'Jan.\': 18.9, \'Feb.\': 28.8, \'Mar.\' :39.3, \'Apr.\': 81.4, \'May\': 47, \'Jun.\': 20.3, \'Jul.\': 24, \'Aug.\': 35.6 },\r\n			{ _name:\'Berlin\', \'Jan.\': 12.4, \'Feb.\': 23.2, \'Mar.\' :34.5, \'Apr.\': 99.7, \'May\': 52.6, \'Jun.\': 35.5, \'Jul.\': 37.4, \'Aug.\': 42.4}\r\n		  ];\r\n		const mea_${element.mid!\'\'} =  [ \'Jan.\',\'Feb.\',\'Mar.\',\'Apr.\',\'May\',\'Jun.\',\'Jul.\',\'Aug.\' ];\r\n	</#if>\r\n	const ds_${element.mid!\'\'} = new DataSet();\r\n	const dv_${element.mid!\'\'} = ds_${element.mid!\'\'}.createView().source(data_${element.mid!\'\'});\r\n	  dv_${element.mid!\'\'}.transform({\r\n		type: \'fold\',\r\n		fields: mea_${element.mid!\'\'}, // 展开字段集\r\n		key: \'key\', // key字段\r\n		value: \'value\', // value字段\r\n	  });\r\n	   var json_${element.mid!\'\'} =  $.parseJSON( $(\"#json_${element.mid!\'\'}\").text() );\r\n	  $(\"#json_${element.mid!\'\'}\").remove();\r\n	  ChartAction.renderChart(\'${element.mid!\'\'}\',dv_${element.mid!\'\'},json_${element.mid!\'\'})\r\n	</script>\r\n', '4028811b618d0dca01618d5a5fe6034a', 'cskefu', '/images/design/radar.gif', NULL, NULL, NULL, NULL, 0, NULL, 'radar');
INSERT INTO `uk_templet` VALUES ('4028811b6191e289016191ee589c0349', 'KPI图', NULL, 'report', NULL, '2018-02-14 09:29:32', NULL, NULL, '<div id=\"element_${reportModel.id!\'\'}\" class=\"r3-data-element\" style=\"min-width:100px;min-height:65px;\">\r\n\r\n    <#if reportModel.reportData?? && reportModel.reportData.data??>\r\n    	<#list reportModel.reportData.data as values>\r\n    		<#if values_index == 0>\r\n    			<#list values as value>\r\n    				<#if value_index ==0>\r\n    				<h1 class=\"no-margins\" <#if value.value lt 0>style=\"color:red;\"</#if>>\r\n                		${value.foramatValue!\'\'}\r\n                	</h1>\r\n                	<div class=\"stat-percent font-bold text-success\">\r\n                		<#if value.row?? && value.row.name?? && value.row.name!= \'root\' >${value.row.name!\'\'}</#if>\r\n                	</div>\r\n                	<small>\r\n                		<#if value.name??>${value.name!\'\'}</#if>\r\n                	</small>\r\n    				</#if>\r\n    			</#list>\r\n    		</#if>\r\n    	</#list>\r\n    </#if> 	\r\n</div>', '4028811b618d0dca01618d5a5fe6034a', 'cskefu', '/images/design/kpi.png', NULL, NULL, NULL, NULL, 0, NULL, NULL);
INSERT INTO `uk_templet` VALUES ('4028811b6418c59701641b65e21c075b', 'sff', NULL, 'ffff', NULL, '2018-06-20 12:13:39', NULL, NULL, 'asdfasdf', '4028811b6109050201610928ed6a030d', 'cskefu', NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL);
INSERT INTO `uk_templet` VALUES ('4028811b642af06f01642afa426804cd', '外部机器人输入参数', NULL, 'otheraiinput', NULL, '2018-06-23 12:50:01', NULL, NULL, '{\r\n	\"service_type\": \"query\",\r\n	\"data_type\": \"${chat.msgtype!\'text\'}\",\r\n	\"app_key\": \"gamutsoft\",\r\n	\"user_id\": \"${chat.userid!\'\'}\",\r\n	\"label\": \"\",\r\n	\"data\": \"${chat.message!\'\'}\",\r\n	\"timeout\": 10\r\n}', '4028811b642af06f01642af9cfa304c6', 'cskefu', NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL);
INSERT INTO `uk_templet` VALUES ('4028811b642af06f01642afaae4f04d3', '外部机器人输出参数', NULL, 'otheraioutputparam', NULL, '2018-06-23 12:50:29', NULL, NULL, '{\r\n\"msgtype\":\"${data.data_type!\'text\'}\"\r\n<#if data?? && data.candidates?? && data.candidates?size gt 0>\r\n	<#assign suggest = \"[\">\r\n	<#list data.candidates as item>\r\n		<#if suggest?length gt 1>\r\n			<#assign suggest = suggest + \",\">\r\n		</#if>\r\n		<#if item.question??>\r\n			<#assign suggest = suggest + \'{\"id\":\"\'+item.kbid+\'\",\"title\":\"\'+item.question + \'\"}\'>\r\n		</#if>\r\n	</#list>\r\n	<#assign suggest = suggest + \"]\">\r\n	,\"items\":${suggest}\r\n</#if>\r\n<#if data?? && data.data?? && data.data.answer??>\r\n	,\"message\":\"${data.data.answer!\'\'}\"\r\n<#elseif data?? && data.data?? && data.data.kbid??>\r\n	,\"id\":\"${data.data.kbid!\'\'}\"\r\n	,\"detail\":true\r\n<#else>\r\n	,\"message\":\"${data.message!\'\'}\"\r\n</#if>\r\n}', '4028811b642af06f01642af9cfaf04c7', 'cskefu', NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL);
INSERT INTO `uk_templet` VALUES ('4028811b644983b60164498da54a040f', '搜索输入接口', NULL, 'opsearh', NULL, '2018-06-29 11:19:37', NULL, NULL, '{\r\n	\"keyword\": \"${q!\'\'}\",\r\n	\"label\":\"\"\r\n}\r\n', '4028811b642af06f01642af9cfa304c6', 'cskefu', NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL);
INSERT INTO `uk_templet` VALUES ('4028811b644983b60164498e06570416', '详情输入接口', NULL, 'oqrdetail', NULL, '2018-06-29 11:20:01', NULL, NULL, '{\r\n	\"kbid\": \"${id!\'\'}\",\r\n}', '4028811b642af06f01642af9cfa304c6', 'cskefu', NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL);
INSERT INTO `uk_templet` VALUES ('4028811b644a2d2e01644a2ea6770400', '搜索输出接口', NULL, 'searchoutput', NULL, '2018-06-29 14:15:28', NULL, NULL, '[<#if data?? && data.data??><#list data.data as kb><#if kb_index gt 0>,</#if>\r\n{\r\n	\"id\":\"${kb.kbid!\'\'}\",\r\n	\"title\":\"${(kb.title!\'\')?replace(\'\\n\',\'\')}\"\r\n}</#list></#if>\r\n]', '4028811b642af06f01642af9cfaf04c7', 'cskefu', NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL);
INSERT INTO `uk_templet` VALUES ('4028811b644a2d2e01644a334a650422', '详情输出接口', NULL, 'detailinput', NULL, '2018-06-29 14:20:32', NULL, NULL, '<#if data?? && data.data??>\r\n{\r\n	\"id\":\"${data.data.kbid!\'\'}\",\r\n	\"title\":\"${(data.data.title!\'\')?replace(\'\\n\',\'\')}\",\r\n	\"content\":\"${((data.data.content!\'\')?replace(\'\\n\',\'\'))?replace(\'\"\' , \'\\\\\"\')}\"\r\n}</#if>', '4028811b642af06f01642af9cfaf04c7', 'cskefu', NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL);
INSERT INTO `uk_templet` VALUES ('402881e861da4c960161da74a89e0386', '报表XML模板', NULL, 'reportquery', NULL, '2018-02-28 11:28:53', NULL, NULL, '<?xml version=\'1.0\' ?>\r\n<Schema name=\'ukefu\'>\r\n    <#if !cube.modeltype?? || cube.modeltype!=\"1\">\r\n    <Cube name=\'${cube.name}\'>\r\n		<#if cube.sql?? && cube.sql?length gt 0>\r\n		<View alias=\'${cube.table}\'>\r\n                        <SQL>                              \r\n							${(cube.sql!\'\')?html}\r\n                        </SQL>\r\n                </View>\r\n		<#else>\r\n		<Table name=\'${cube.table}\' />\r\n                </#if>\r\n		\r\n		<#if reportModel.properties?? && reportModel.properties?size gt 0 >\r\n			<Dimension name=\'${reportModel.name}\'>\r\n				<Hierarchy hasAll=\'true\' allMemberName=\'\'>						\r\n					<#list reportModel.properties as property>\r\n						<#list cube.dimension as dimension>\r\n							<#list dimension.cubeLevel as level>\r\n							<#if property.dataid == level.id>\r\n							<Level name=\'${level.name}\'  column=\'${level.nameAlias}\' uniqueMembers=\'${level.uniquemembers?string}\'  <#if level.parameters??>${level.parameters!\"\"}</#if>>\r\n								<#if level.attribue?? && level.attribue?length gt 0>${level.attribue!\"\"}</#if>\r\n								</Level>	\r\n							</#if>						\r\n							</#list>	\r\n						</#list>					\r\n					</#list>			\r\n				</Hierarchy>\r\n			</Dimension>        \r\n		</#if>\r\n		<#if istable?? && istable && reportModel.colproperties?? && reportModel.colproperties?size gt 0>\r\n			<Dimension name=\'${reportModel.name}_col\'>\r\n				<Hierarchy hasAll=\'true\' allMemberName=\'\'>\r\n					<#if reportModel.colproperties??>\r\n					<#list reportModel.colproperties as property>\r\n						<#list cube.dimension as dimension>\r\n							<#list dimension.cubeLevel as level>\r\n							<#if property.dataid == level.id>\r\n							<Level name=\'${level.name}\'  column=\'${level.nameAlias}\' uniqueMembers=\'${level.uniquemembers?string}\'  <#if level.parameters??>${level.parameters!\"\"}</#if>>\r\n								<#if level.attribue?? && level.attribue?length gt 0>${level.attribue!\"\"}</#if>\r\n								</Level>	\r\n							</#if>						\r\n							</#list>	\r\n						</#list>					\r\n					</#list>\r\n					</#if>\r\n				</Hierarchy>\r\n			</Dimension>\r\n		</#if>\r\n\r\n		<#if cube.measure??>\r\n			<#list cube.measure as measure>				\r\n				<#if measure.calculatedmember != true>\r\n				<Measure name=\'${measure.name}\' <#if measure.attribue?? && measure.attribue?length gt 0><#else>column=\'${measure.nameAlias}\'</#if> aggregator=\'${measure.aggregator}\' <#if measure.formatstring != \'\'>formatString=\'${measure.formatstring!\"####\"}\'<#else>formatString=\'####\'</#if>>\r\n						<#if measure.attribue?? && measure.attribue?length gt 0>\r\n						${measure.attribue!\"\"}\r\n						</#if>\r\n				</Measure>\r\n				</#if>\r\n			</#list>\r\n        </#if>\r\n		\r\n\r\n		<#if cube.measure??>\r\n			<#list cube.measure as measure>				\r\n				<#if measure.calculatedmember == true>\r\n					<CalculatedMember name=\'${measure.name}\' dimension=\'Measures\' <#if measure.parameters??>${measure.parameters!\"\"}</#if> <#if measure.formatstring?? && measure.formatstring?length gt 0>formatString=\"${measure.formatstring!\"\"}\"</#if>>\r\n                             <#if measure.attribue?? && measure.attribue?length gt 0>${measure.attribue!\"\"}</#if>\r\n                        </CalculatedMember>\r\n				</#if>\r\n			</#list>\r\n		</#if>\r\n\r\n		</Cube>	\r\n	</#if>\r\n</Schema>\r\n', '402881e861da4c960161da7040bc0385', 'cskefu', NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL);
INSERT INTO `uk_templet` VALUES ('402881e861da4c960161da74a89e0387', '过滤器XML模板', '', 'filterquery', '', '2018-02-28 11:28:53', '', NULL, '<?xml version=\'1.0\' ?>\r\n<Schema name=\'ukefu\'>\r\n    <Cube name=\'filterquery\'>\r\n		<#if sql?? && sql?length gt 0>\r\n		<View alias=\'filter\'>\r\n                        <SQL>                              \r\n							${(sql!\'\')?html}\r\n                        </SQL>\r\n                </View>\r\n		</#if>		\r\n		<Dimension name=\'KEYVAL\'>\r\n			<Hierarchy hasAll=\'true\' allMemberName=\'\'>						\r\n				<Level name=\'KEYVAL\'  column=\'KEYVAL\' uniqueMembers=\'\' />	\r\n				<Level name=\'VAL\'  column=\'VAL\' uniqueMembers=\'\' />						\r\n			</Hierarchy>\r\n		</Dimension>		\r\n		</Cube>	\r\n</Schema>\r\n', '402881e861da4c960161da7040bc0385', 'cskefu', NULL, '', NULL, '', NULL, 0, NULL, NULL);
INSERT INTO `uk_templet` VALUES ('402881fb62084b98016208652dea0393', '文本框', NULL, 'text', NULL, '2018-03-09 09:34:31', NULL, NULL, '<#if filter?? && filter.modeltype == \'text\'>\r\n	<#if filter.valuefiltertype ==\'range\'>\r\n		<div class=\"layui-inline\">\r\n		    <div class=\"layui-input-inline\" style=\"width: 80px;\">\r\n		      <input type=\"text\" name=\"${filter.code!\'\'}_startvalue\" id=\"${filter.code!\'\'}_startvalue\"  class=\"layui-input\" value=\"${filter.requeststartvalue!\'\'}\" <#if filter.mustvalue?? && filter.mustvalue==\'mustvalue\'>lay-verify=required</#if> >\r\n		    </div>\r\n		    <div class=\"layui-form-mid\">-</div>\r\n		    <div class=\"layui-input-inline\" style=\"width: 80px;\">\r\n		      <input type=\"text\" name=\"${filter.code!\'\'}_endvalue\" id=\"${filter.code!\'\'}_endvalue\"  class=\"layui-input\"  value=\"${filter.requestendvalue!\'\'}\" <#if filter.mustvalue?? && filter.mustvalue==\'mustvalue\'>lay-verify=required</#if>>\r\n		    </div>\r\n		  </div>\r\n	<#else>\r\n		<div class=\"layui-input-inline\" >\r\n		      <input type=\"text\" name=\"${filter.code!\'\'}\"  id=\"${filter.code!\'\'}\"  class=\"layui-input\" value=\"${filter.requestvalue!\'\'}\" <#if filter.mustvalue?? && filter.mustvalue==\'mustvalue\'>lay-verify=required</#if>>\r\n		    </div>\r\n	</#if>\r\n</#if>\r\n<#if filter?? && filter.modeltype == \'date\'>\r\n	<#if filter.valuefiltertype ==\'range\'>\r\n		<div class=\"layui-inline\" style=\"margin-right:0px;\">\r\n		    <div class=\"layui-input-inline\" style=\"width: 98px;\">\r\n		      <input type=\"text\" name=\"${filter.code!\'\'}\" class=\"layui-input\" value=\"${filter.requeststartvalue!\'\'}\" id=\"${filter.code!\'\'}_startvalue\" >\r\n		    </div>\r\n		    <div class=\"layui-form-mid\">-</div>\r\n		    <div class=\"layui-input-inline\" style=\"width: 98px;\">\r\n		      <input type=\"text\" name=\"${filter.code!\'\'}_endvalue\"  class=\"layui-input\"  value=\"${filter.requestendvalue!\'\'}\" id=\"${filter.code!\'\'}_endvalue\" >\r\n		    </div>\r\n		  </div>\r\n		  <script>\r\n			   	layui.use(\'laydate\', function(){\r\n			  	  	var laydate = layui.laydate;\r\n			  		laydate.render({ \r\n			   	  		elem: document.getElementById(\'${filter.code!\'\'}_startvalue\'),\r\n			   		  	value: \'${filter.startvalue!\'\'}\',\r\n			   		  	type:UKHelper.getLayDateType(\'${filter.formatstr!\'\'}\'),\r\n			   		 	format: \'${filter.formatstr!\'\'}\'\r\n			   		});\r\n			  		laydate.render({ \r\n			   	  		elem: document.getElementById(\'${filter.code!\'\'}_endvalue\'),\r\n			   		  	value: \'${filter.endvalue!\'\'}\',\r\n			   		  	type:UKHelper.getLayDateType(\'${filter.formatstr!\'\'}\'),\r\n			   		 	format: \'${filter.formatstr!\'\'}\'\r\n			   		});\r\n			  	});\r\n		   	</script>\r\n	<#else>\r\n		<div class=\"layui-input-inline\" >\r\n		      <input type=\"text\" name=\"${filter.code!\'\'}\" id=\"${filter.code!\'\'}\"  class=\"layui-input\" >\r\n		    </div>\r\n		   	<script>\r\n			   	layui.use(\'laydate\', function(){\r\n			  	  	var laydate = layui.laydate;\r\n			  		laydate.render({ \r\n			   	  		elem: document.getElementById(\'${filter.code!\'\'}\'),\r\n			   		  	value: \'${filter.requestvalue!\'\'}\',\r\n			   		  	type:UKHelper.getLayDateType(\'${filter.formatstr!\'\'}\'),\r\n			   		 	format: \'${filter.formatstr!\'\'}\'\r\n			   		});\r\n			  	});\r\n		   	</script>\r\n	</#if>\r\n</#if>\r\n<#if filter?? && filter.modeltype == \'sigsel\'>\r\n	<#if filter.valuefiltertype ==\'range\'>\r\n	<#else>\r\n		<div class=\"layui-input-inline\" >\r\n		 	<select  <#if filter.mustvalue?? && filter.mustvalue==\'mustvalue\'>lay-verify=required</#if>  name=\"${filter.code!\'\'}\" lay-filter=${filter.code!\'\'} id=\"${filter.code!\'\'}\">\r\n				<option value=\"\" <#if !(filter.requestvalue??)>selected=selected</#if> >请选择</option>\r\n				  <#if  filter.reportData.col?? && filter.reportData.col.childeren ??>\r\n					<#list filter.reportData.col.childeren as val>\r\n		  				<option value=\"${val.name!\'\'}\" <#if filter.requestvalue == val.name>selected=selected</#if> ><#list val.childeren as key><#if key_index ==1>${key.name!\'\'}</#if></#list></option>\r\n			  		</#list>\r\n				  </#if>\r\n			</select>\r\n		 </div>\r\n		 <script>\r\n			layui.use(\'form\', function(){\r\n			  var form = layui.form;\r\n			  <#if filter?? && filter.childFilter??>\r\n			  form.on(\'select(${filter.code!\'\'})\', function(data){\r\n				  if($(\'#item_${filter.childFilter.code}\')){\r\n					  loadURL(\'/apps/report/design/filtervalchange.html?id=${filter.modelid}&fid=${filter.childFilter.id!\'\'}&publishedid=<#if publishedReport??>${publishedReport.id!\'\'}<#else></#if>&${filter.code!\'\'}=\'+data.value, \'#item_${filter.childFilter.code}\'); \r\n				  }\r\n			  });\r\n			  </#if>\r\n			  form.render();\r\n			});\r\n			</script>\r\n	</#if>\r\n</#if>\r\n', '4028811b618d0dca01618d5a5ff6034b', 'cskefu', '/images/design/table.png', NULL, NULL, NULL, NULL, 0, NULL, NULL);
INSERT INTO `uk_templet` VALUES ('402881fb6208a81f016208b1f59d038e', '日期选择', NULL, 'date', NULL, '2018-03-09 10:58:23', NULL, NULL, '<#if filter?? && filter.modeltype == \'text\'>\r\n	<#if filter.valuefiltertype ==\'range\'>\r\n		<div class=\"layui-inline\">\r\n		    <div class=\"layui-input-inline\" style=\"width: 80px;\">\r\n		      <input type=\"text\" name=\"${filter.code!\'\'}_startvalue\" id=\"${filter.code!\'\'}_startvalue\"  class=\"layui-input\" value=\"${filter.requeststartvalue!\'\'}\" <#if filter.mustvalue?? && filter.mustvalue==\'mustvalue\'>lay-verify=required</#if> >\r\n		    </div>\r\n		    <div class=\"layui-form-mid\">-</div>\r\n		    <div class=\"layui-input-inline\" style=\"width: 80px;\">\r\n		      <input type=\"text\" name=\"${filter.code!\'\'}_endvalue\" id=\"${filter.code!\'\'}_endvalue\"  class=\"layui-input\"  value=\"${filter.requestendvalue!\'\'}\" <#if filter.mustvalue?? && filter.mustvalue==\'mustvalue\'>lay-verify=required</#if>>\r\n		    </div>\r\n		  </div>\r\n	<#else>\r\n		<div class=\"layui-input-inline\" >\r\n		      <input type=\"text\" name=\"${filter.code!\'\'}\"  id=\"${filter.code!\'\'}\"  class=\"layui-input\" value=\"${filter.requestvalue!\'\'}\" <#if filter.mustvalue?? && filter.mustvalue==\'mustvalue\'>lay-verify=required</#if>>\r\n		    </div>\r\n	</#if>\r\n</#if>\r\n<#if filter?? && filter.modeltype == \'date\'>\r\n	<#if filter.valuefiltertype ==\'range\'>\r\n		<div class=\"layui-inline\" style=\"margin-right:0px;\">\r\n		    <div class=\"layui-input-inline\" style=\"width: 98px;\">\r\n		      <input type=\"text\" name=\"${filter.code!\'\'}\" class=\"layui-input\" value=\"${filter.requeststartvalue!\'\'}\" id=\"${filter.code!\'\'}_startvalue\" >\r\n		    </div>\r\n		    <div class=\"layui-form-mid\">-</div>\r\n		    <div class=\"layui-input-inline\" style=\"width: 98px;\">\r\n		      <input type=\"text\" name=\"${filter.code!\'\'}_endvalue\"  class=\"layui-input\"  value=\"${filter.requestendvalue!\'\'}\" id=\"${filter.code!\'\'}_endvalue\" >\r\n		    </div>\r\n		  </div>\r\n		  <script>\r\n			   	layui.use(\'laydate\', function(){\r\n			  	  	var laydate = layui.laydate;\r\n			  		laydate.render({ \r\n			   	  		elem: document.getElementById(\'${filter.code!\'\'}_startvalue\'),\r\n			   		  	value: \'${filter.startvalue!\'\'}\',\r\n			   		  	type:UKHelper.getLayDateType(\'${filter.formatstr!\'\'}\'),\r\n			   		 	format: \'${filter.formatstr!\'\'}\'\r\n			   		});\r\n			  		laydate.render({ \r\n			   	  		elem: document.getElementById(\'${filter.code!\'\'}_endvalue\'),\r\n			   		  	value: \'${filter.endvalue!\'\'}\',\r\n			   		  	type:UKHelper.getLayDateType(\'${filter.formatstr!\'\'}\'),\r\n			   		 	format: \'${filter.formatstr!\'\'}\'\r\n			   		});\r\n			  	});\r\n		   	</script>\r\n	<#else>\r\n		<div class=\"layui-input-inline\" >\r\n		      <input type=\"text\" name=\"${filter.code!\'\'}\" id=\"${filter.code!\'\'}\"  class=\"layui-input\" >\r\n		    </div>\r\n		   	<script>\r\n			   	layui.use(\'laydate\', function(){\r\n			  	  	var laydate = layui.laydate;\r\n			  		laydate.render({ \r\n			   	  		elem: document.getElementById(\'${filter.code!\'\'}\'),\r\n			   		  	value: \'${filter.requestvalue!\'\'}\',\r\n			   		  	type:UKHelper.getLayDateType(\'${filter.formatstr!\'\'}\'),\r\n			   		 	format: \'${filter.formatstr!\'\'}\'\r\n			   		});\r\n			  	});\r\n		   	</script>\r\n	</#if>\r\n</#if>\r\n<#if filter?? && filter.modeltype == \'sigsel\'>\r\n	<#if filter.valuefiltertype ==\'range\'>\r\n	<#else>\r\n		<div class=\"layui-input-inline\" >\r\n		 	<select  <#if filter.mustvalue?? && filter.mustvalue==\'mustvalue\'>lay-verify=required</#if>  name=\"${filter.code!\'\'}\" lay-filter=${filter.code!\'\'} id=\"${filter.code!\'\'}\">\r\n				<option value=\"\" <#if !(filter.requestvalue??)>selected=selected</#if> >请选择</option>\r\n				  <#if  filter.reportData.col?? && filter.reportData.col.childeren ??>\r\n					<#list filter.reportData.col.childeren as val>\r\n		  				<option value=\"${val.name!\'\'}\" <#if filter.requestvalue == val.name>selected=selected</#if> ><#list val.childeren as key><#if key_index ==1>${key.name!\'\'}</#if></#list></option>\r\n			  		</#list>\r\n				  </#if>\r\n			</select>\r\n		 </div>\r\n		 <script>\r\n			layui.use(\'form\', function(){\r\n			  var form = layui.form;\r\n			  <#if filter?? && filter.childFilter??>\r\n			  form.on(\'select(${filter.code!\'\'})\', function(data){\r\n				  if($(\'#item_${filter.childFilter.code}\')){\r\n					  loadURL(\'/apps/report/design/filtervalchange.html?id=${filter.modelid}&fid=${filter.childFilter.id!\'\'}&publishedid=<#if publishedReport??>${publishedReport.id!\'\'}<#else></#if>&${filter.code!\'\'}=\'+data.value, \'#item_${filter.childFilter.code}\'); \r\n				  }\r\n			  });\r\n			  </#if>\r\n			  form.render();\r\n			});\r\n			</script>\r\n	</#if>\r\n</#if>\r\n', '4028811b618d0dca01618d5a5ff6034b', 'cskefu', '/images/design/calendar.png', NULL, NULL, NULL, NULL, 0, NULL, NULL);
INSERT INTO `uk_templet` VALUES ('402881fb6208a81f016208b2491e038f', '单选下拉', NULL, 'sigsel', NULL, '2018-03-09 10:58:44', NULL, NULL, '<#if filter?? && filter.modeltype == \'text\'>\r\n	<#if filter.valuefiltertype ==\'range\'>\r\n		<div class=\"layui-inline\">\r\n		    <div class=\"layui-input-inline\" style=\"width: 80px;\">\r\n		      <input type=\"text\" name=\"${filter.code!\'\'}_startvalue\" id=\"${filter.code!\'\'}_startvalue\"  class=\"layui-input\" value=\"${filter.requeststartvalue!\'\'}\" <#if filter.mustvalue?? && filter.mustvalue==\'mustvalue\'>lay-verify=required</#if> >\r\n		    </div>\r\n		    <div class=\"layui-form-mid\">-</div>\r\n		    <div class=\"layui-input-inline\" style=\"width: 80px;\">\r\n		      <input type=\"text\" name=\"${filter.code!\'\'}_endvalue\" id=\"${filter.code!\'\'}_endvalue\"  class=\"layui-input\"  value=\"${filter.requestendvalue!\'\'}\" <#if filter.mustvalue?? && filter.mustvalue==\'mustvalue\'>lay-verify=required</#if>>\r\n		    </div>\r\n		  </div>\r\n	<#else>\r\n		<div class=\"layui-input-inline\" >\r\n		      <input type=\"text\" name=\"${filter.code!\'\'}\"  id=\"${filter.code!\'\'}\"  class=\"layui-input\" value=\"${filter.requestvalue!\'\'}\" <#if filter.mustvalue?? && filter.mustvalue==\'mustvalue\'>lay-verify=required</#if>>\r\n		    </div>\r\n	</#if>\r\n</#if>\r\n<#if filter?? && filter.modeltype == \'date\'>\r\n	<#if filter.valuefiltertype ==\'range\'>\r\n		<div class=\"layui-inline\" style=\"margin-right:0px;\">\r\n		    <div class=\"layui-input-inline\" style=\"width: 98px;\">\r\n		      <input type=\"text\" name=\"${filter.code!\'\'}\" class=\"layui-input\" value=\"${filter.requeststartvalue!\'\'}\" id=\"${filter.code!\'\'}_startvalue\" >\r\n		    </div>\r\n		    <div class=\"layui-form-mid\">-</div>\r\n		    <div class=\"layui-input-inline\" style=\"width: 98px;\">\r\n		      <input type=\"text\" name=\"${filter.code!\'\'}_endvalue\"  class=\"layui-input\"  value=\"${filter.requestendvalue!\'\'}\" id=\"${filter.code!\'\'}_endvalue\" >\r\n		    </div>\r\n		  </div>\r\n		  <script>\r\n			   	layui.use(\'laydate\', function(){\r\n			  	  	var laydate = layui.laydate;\r\n			  		laydate.render({ \r\n			   	  		elem: document.getElementById(\'${filter.code!\'\'}_startvalue\'),\r\n			   		  	value: \'${filter.startvalue!\'\'}\',\r\n			   		  	type:UKHelper.getLayDateType(\'${filter.formatstr!\'\'}\'),\r\n			   		 	format: \'${filter.formatstr!\'\'}\'\r\n			   		});\r\n			  		laydate.render({ \r\n			   	  		elem: document.getElementById(\'${filter.code!\'\'}_endvalue\'),\r\n			   		  	value: \'${filter.endvalue!\'\'}\',\r\n			   		  	type:UKHelper.getLayDateType(\'${filter.formatstr!\'\'}\'),\r\n			   		 	format: \'${filter.formatstr!\'\'}\'\r\n			   		});\r\n			  	});\r\n		   	</script>\r\n	<#else>\r\n		<div class=\"layui-input-inline\" >\r\n		      <input type=\"text\" name=\"${filter.code!\'\'}\" id=\"${filter.code!\'\'}\"  class=\"layui-input\" >\r\n		    </div>\r\n		   	<script>\r\n			   	layui.use(\'laydate\', function(){\r\n			  	  	var laydate = layui.laydate;\r\n			  		laydate.render({ \r\n			   	  		elem: document.getElementById(\'${filter.code!\'\'}\'),\r\n			   		  	value: \'${filter.requestvalue!\'\'}\',\r\n			   		  	type:UKHelper.getLayDateType(\'${filter.formatstr!\'\'}\'),\r\n			   		 	format: \'${filter.formatstr!\'\'}\'\r\n			   		});\r\n			  	});\r\n		   	</script>\r\n	</#if>\r\n</#if>\r\n<#if filter?? && filter.modeltype == \'sigsel\'>\r\n	<#if filter.valuefiltertype ==\'range\'>\r\n	<#else>\r\n		<div class=\"layui-input-inline\" >\r\n		 	<select  <#if filter.mustvalue?? && filter.mustvalue==\'mustvalue\'>lay-verify=required</#if>  name=\"${filter.code!\'\'}\" lay-filter=${filter.code!\'\'} id=\"${filter.code!\'\'}\">\r\n				<option value=\"\" <#if !(filter.requestvalue??)>selected=selected</#if> >请选择</option>\r\n				  <#if  filter.reportData.col?? && filter.reportData.col.childeren ??>\r\n					<#list filter.reportData.col.childeren as val>\r\n		  				<option value=\"${val.name!\'\'}\" <#if filter.requestvalue == val.name>selected=selected</#if> ><#list val.childeren as key><#if key_index ==1>${key.name!\'\'}</#if></#list></option>\r\n			  		</#list>\r\n				  </#if>\r\n			</select>\r\n		 </div>\r\n		 <script>\r\n			layui.use(\'form\', function(){\r\n			  var form = layui.form;\r\n			  <#if filter?? && filter.childFilter??>\r\n			  form.on(\'select(${filter.code!\'\'})\', function(data){\r\n				  if($(\'#item_${filter.childFilter.code}\')){\r\n					  loadURL(\'/apps/report/design/filtervalchange.html?id=${filter.modelid}&fid=${filter.childFilter.id!\'\'}&publishedid=<#if publishedReport??>${publishedReport.id!\'\'}<#else></#if>&${filter.code!\'\'}=\'+data.value, \'#item_${filter.childFilter.code}\'); \r\n				  }\r\n			  });\r\n			  </#if>\r\n			  form.render();\r\n			});\r\n			</script>\r\n	</#if>\r\n</#if>\r\n', '4028811b618d0dca01618d5a5ff6034b', 'cskefu', '/images/design/select.png', NULL, NULL, NULL, NULL, 0, NULL, NULL);
COMMIT;

-- ----------------------------
-- Table structure for cs_user
-- ----------------------------
DROP TABLE IF EXISTS `cs_user`;
CREATE TABLE `cs_user` (
  `ID` varchar(32) NOT NULL COMMENT '主键ID',
  `LANGUAGE` varchar(255) DEFAULT NULL COMMENT '语言',
  `USERNAME` varchar(50) DEFAULT NULL COMMENT '用户名',
  `PASSWORD` varchar(255) DEFAULT NULL COMMENT '密码',
  `SECURECONF` varchar(255) DEFAULT NULL COMMENT '安全级别',
  `email` varchar(255) DEFAULT NULL COMMENT '邮件',
  `FIRSTNAME` varchar(255) DEFAULT NULL COMMENT '姓',
  `MIDNAME` varchar(255) DEFAULT NULL COMMENT '名',
  `LASTNAME` varchar(255) DEFAULT NULL COMMENT '名',
  `JOBTITLE` varchar(255) DEFAULT NULL COMMENT '职位',
  `GENDER` varchar(255) DEFAULT NULL COMMENT '性别',
  `BIRTHDAY` varchar(255) DEFAULT NULL COMMENT '生日',
  `nickname` varchar(255) DEFAULT NULL COMMENT '昵称',
  `rulename` varchar(255) DEFAULT NULL COMMENT '角色',
  `SEARCHPROJECTID` varchar(255) DEFAULT NULL COMMENT '备用',
  `orgi` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `creater` varchar(32) DEFAULT NULL COMMENT '创建人',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `memo` varchar(255) DEFAULT NULL COMMENT '备注',
  `updatetime` datetime DEFAULT NULL COMMENT '更新时间',
  `mobile` varchar(32) DEFAULT NULL COMMENT '手机号',
  `passupdatetime` datetime DEFAULT NULL COMMENT '最后 一次密码修改时间',
  `sign` text COMMENT '签名',
  `del` tinyint(4) DEFAULT '0' COMMENT '是否已删除',
  `uname` varchar(100) DEFAULT NULL COMMENT '姓名',
  `musteditpassword` tinyint(4) DEFAULT NULL COMMENT '登录修改密码',
  `agent` tinyint(4) DEFAULT NULL COMMENT '工号',
  `province` varchar(50) DEFAULT NULL COMMENT '省份',
  `city` varchar(50) DEFAULT NULL COMMENT '城市',
  `fans` int(11) DEFAULT NULL COMMENT '关注人数',
  `follows` int(11) DEFAULT NULL COMMENT '被关注次数',
  `integral` int(11) DEFAULT NULL COMMENT '积分',
  `lastlogintime` datetime DEFAULT NULL COMMENT '最后登录时间',
  `status` varchar(10) DEFAULT NULL COMMENT '状态',
  `deactivetime` datetime DEFAULT NULL COMMENT '离线时间',
  `title` varchar(50) DEFAULT NULL COMMENT '标题',
  `datastatus` tinyint(4) DEFAULT NULL COMMENT '数据状态',
  `callcenter` tinyint(4) DEFAULT NULL COMMENT '启用呼叫中心坐席',
  `superadmin` tinyint(4) DEFAULT NULL COMMENT '系统管理员',
  `admin` tinyint(4) DEFAULT NULL COMMENT '管理员',
  `maxuser` int(11) DEFAULT '0' COMMENT '最大接入访客数量',
  `ordertype` varchar(20) DEFAULT NULL COMMENT '默认排序方式',
  PRIMARY KEY (`ID`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='用户表';

-- ----------------------------
-- Records of cs_user
-- ----------------------------
BEGIN;
INSERT INTO `cs_user` VALUES ('4028cac3614cd2f901614cf8be1f0324', NULL, 'admin', '5d80253b1cd5e5d4ca5ed539f4d72052', '5', 'admin@cc.com', NULL, NULL, NULL, NULL, NULL, NULL, '0', NULL, NULL, 'cskefu', NULL, '2017-03-16 13:56:34', '北京', '2018-07-31 08:24:13', '18888888888', NULL, NULL, 0, '系统管理员', 0, 1, '北京', '北京', 2, 1, 0, '2018-08-10 04:38:17', NULL, NULL, NULL, 0, 0, 1, 1, 0, NULL);
COMMIT;

-- ----------------------------
-- Table structure for uk_userevent
-- ----------------------------
DROP TABLE IF EXISTS `uk_userevent`;
CREATE TABLE `uk_userevent` (
  `id` varchar(32) NOT NULL DEFAULT '' COMMENT '主键ID',
  `username` varchar(32) DEFAULT NULL COMMENT '用户名',
  `creater` varchar(32) DEFAULT NULL COMMENT '创建人ID',
  `orgi` varchar(50) DEFAULT NULL COMMENT '租户ID',
  `maintype` varchar(32) DEFAULT NULL COMMENT 'Spring MVC注释分类',
  `subtype` varchar(32) DEFAULT NULL COMMENT '注释二级分类',
  `name` varchar(32) DEFAULT NULL COMMENT '名称',
  `admin` tinyint(32) DEFAULT NULL COMMENT '是否管理员',
  `accessnum` tinyint(32) DEFAULT NULL COMMENT '访问次数',
  `ip` varchar(50) DEFAULT NULL COMMENT 'IP',
  `hostname` varchar(50) DEFAULT NULL COMMENT '主机名',
  `country` varchar(50) DEFAULT NULL COMMENT '国家',
  `region` varchar(50) DEFAULT NULL COMMENT '区域',
  `city` varchar(32) DEFAULT NULL COMMENT '城市',
  `isp` varchar(32) DEFAULT NULL COMMENT '运营商',
  `province` varchar(32) DEFAULT NULL COMMENT '省份',
  `url` text DEFAULT NULL COMMENT '接入URL',
  `sessionid` varchar(32) DEFAULT NULL COMMENT '会话ID',
  `param` text COMMENT '请求参数',
  `times` int(11) DEFAULT NULL COMMENT '访问次数',
  `createtime` datetime DEFAULT NULL COMMENT '访问时间',
  `updatetime` datetime DEFAULT NULL COMMENT '更新时间',
  `title` varchar(255) DEFAULT NULL COMMENT '页面标题',
  `ostype` varchar(100) DEFAULT NULL COMMENT '操作系统',
  `browser` varchar(50) DEFAULT NULL COMMENT '浏览器',
  `mobile` varchar(10) DEFAULT NULL COMMENT '移动端',
  `model` varchar(10) DEFAULT NULL COMMENT '组件',
  `appid` varchar(32) DEFAULT NULL COMMENT 'SNSID',
  `createdate` varchar(32) DEFAULT NULL COMMENT '创建时间',
  `referer` varchar(255) DEFAULT NULL COMMENT '跳转URL',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='访客浏览记录表';

-- ----------------------------
-- Table structure for uk_userrole
-- ----------------------------
DROP TABLE IF EXISTS `uk_userrole`;
CREATE TABLE `uk_userrole` (
  `id` varchar(32) NOT NULL COMMENT '主键ID',
  `user_id` varchar(32) DEFAULT NULL COMMENT '用户ID',
  `role_id` varchar(32) DEFAULT NULL COMMENT '角色ID',
  `creater` varchar(32) DEFAULT NULL COMMENT '创建人',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `orgi` varchar(32) DEFAULT NULL COMMENT '租户ID',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='用户角色';

-- ----------------------------
-- Table structure for uk_webim_monitor
-- ----------------------------
DROP TABLE IF EXISTS `uk_webim_monitor`;
CREATE TABLE `uk_webim_monitor` (
  `ID` varchar(50) NOT NULL COMMENT 'ID',
  `ORGI` varchar(50) DEFAULT NULL COMMENT '租户ID',
  `CREATETIME` datetime DEFAULT NULL COMMENT '记录创建时间',
  `AGENTS` int(11) DEFAULT NULL COMMENT '在线坐席数量',
  `USERS` int(11) DEFAULT NULL COMMENT '咨询中访客数量',
  `INQUENE` int(11) DEFAULT NULL COMMENT '排队访客数量',
  `BUSY` int(11) DEFAULT NULL COMMENT '示忙坐席数量',
  `TYPE` varchar(32) DEFAULT NULL COMMENT '坐席类型',
  `DATESTR` varchar(32) DEFAULT NULL COMMENT '日期字符串',
  `HOURSTR` varchar(32) DEFAULT NULL COMMENT '小时字符串',
  `DATEHOURSTR` varchar(32) DEFAULT NULL COMMENT '日期小时字符串',
  `worktype` varchar(50) DEFAULT NULL COMMENT '操作类型',
  `workresult` varchar(50) DEFAULT NULL COMMENT '操作结果',
  `dataid` varchar(50) DEFAULT NULL COMMENT '数据ID',
  PRIMARY KEY (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='坐席状态表';

-- ----------------------------
-- Records of uk_webim_monitor
-- ----------------------------

-- ----------------------------
-- Table structure for uk_weixinuser
-- ----------------------------
DROP TABLE IF EXISTS `uk_weixinuser`;
CREATE TABLE `uk_weixinuser` (
  `id` varchar(32) NOT NULL COMMENT '主键ID',
  `snsid` varchar(32) DEFAULT NULL COMMENT 'SNSID',
  `subscribe` tinyint(4) DEFAULT NULL COMMENT '是否关注公众号',
  `openid` varchar(100) DEFAULT NULL COMMENT 'OPENID',
  `nickname` varchar(50) DEFAULT NULL COMMENT '昵称',
  `sex` varchar(50) DEFAULT NULL COMMENT '性别',
  `language` varchar(50) DEFAULT NULL COMMENT '语言',
  `city` varchar(50) DEFAULT NULL COMMENT '城市',
  `province` varchar(50) DEFAULT NULL COMMENT '省份',
  `country` varchar(50) DEFAULT NULL COMMENT '国家',
  `headimgurl` varchar(255) DEFAULT NULL COMMENT '头像',
  `subscribetime` varchar(32) DEFAULT NULL COMMENT '关注时间',
  `unionid` varchar(50) DEFAULT NULL COMMENT '唯一ID',
  `sexid` varchar(50) DEFAULT NULL COMMENT '性别编码',
  `remark` varchar(100) DEFAULT NULL COMMENT '签名',
  `groupid` varchar(50) DEFAULT NULL COMMENT '组ID',
  `orgi` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `contactsid` varchar(32) DEFAULT NULL COMMENT '联系人ID',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='微信用户信息';

-- ----------------------------
-- Table structure for uk_work_monitor
-- ----------------------------
DROP TABLE IF EXISTS `uk_work_monitor`;
CREATE TABLE `uk_work_monitor` (
  `ID` varchar(50) NOT NULL COMMENT 'ID',
  `USERID` varchar(50) DEFAULT NULL COMMENT '登录人ID',
  `AGENT` varchar(50) DEFAULT NULL COMMENT '坐席工号',
  `USERNAME` varchar(50) DEFAULT NULL COMMENT '坐席用户名（登录名）',
  `AGENTNO` varchar(50) DEFAULT NULL COMMENT '分机号（坐席登录的分机号码）',
  `NAME` varchar(50) DEFAULT NULL COMMENT '坐席姓名',
  `CODE` varchar(50) DEFAULT NULL COMMENT '坐席状态code（对应字典表里的CODE）',
  `STATUS` varchar(50) DEFAULT NULL COMMENT '坐席当前状',
  `BUSY` tinyint(4) DEFAULT '0' COMMENT '坐席是否忙',
  `WORKSTATUS` varchar(50) DEFAULT NULL COMMENT '坐席工作状态',
  `ORGI` varchar(50) DEFAULT NULL COMMENT '租户ID',
  `AGENTSERVICEID` varchar(50) DEFAULT NULL COMMENT '会话ID',
  `SKILL` varchar(50) DEFAULT NULL COMMENT '接入的技能组ID',
  `SKILLNAME` varchar(50) DEFAULT NULL COMMENT '接入的技能组名称',
  `CREATETIME` datetime DEFAULT NULL COMMENT '记录创建时间',
  `ANI` varchar(50) DEFAULT NULL COMMENT '主叫号码',
  `CALLED` varchar(50) DEFAULT NULL COMMENT '被叫号码',
  `SOURCE` varchar(50) DEFAULT NULL COMMENT '来源',
  `SERVICEID` varchar(32) DEFAULT NULL COMMENT '服务记录ID',
  `SERVICESTATUS` varchar(50) DEFAULT NULL COMMENT '当前呼叫状态',
  `DISCALLER` varchar(50) DEFAULT NULL COMMENT '主叫分机号',
  `DISCALLED` varchar(50) DEFAULT NULL COMMENT '被叫分机号',
  `ORGAN` varchar(50) DEFAULT NULL COMMENT '所属组织机构ID',
  `BEGINTIME` datetime DEFAULT NULL COMMENT '状态开始时间',
  `ENDTIME` datetime DEFAULT NULL COMMENT '状态结束时间',
  `FIRSTSTATUS` tinyint(4) DEFAULT '0' COMMENT '当天首次时间',
  `DATESTR` varchar(20) DEFAULT NULL COMMENT '日期字符串',
  `DURATION` int(11) DEFAULT NULL COMMENT '通话时长',
  `EVENTID` varchar(50) DEFAULT NULL COMMENT '事件ID',
  `WORKTYPE` varchar(32) DEFAULT NULL COMMENT '业务类型',
  `CALLENDTIME` datetime DEFAULT NULL COMMENT '结束呼叫事件',
  `CALLSTARTTIME` datetime DEFAULT NULL COMMENT '开始呼叫事件',
  `DIRECTION` varchar(50) DEFAULT NULL COMMENT '呼叫方向',
  `EXTNO` varchar(32) DEFAULT NULL COMMENT '分机号码',
  `ADMIN` tinyint(4) DEFAULT '0' COMMENT '是否管理员',
  `firsttime` tinyint(4) DEFAULT '0' COMMENT '是否首次就绪',
  `firsttimes` int(11) DEFAULT '0' COMMENT '首次就绪时长',
  PRIMARY KEY (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='坐席状态表';

-- ----------------------------
-- Table structure for uk_work_session
-- ----------------------------
DROP TABLE IF EXISTS `uk_work_session`;
CREATE TABLE `uk_work_session` (
  `ID` varchar(50) NOT NULL COMMENT 'ID',
  `USERID` varchar(50) DEFAULT NULL COMMENT '登录人ID',
  `AGENT` varchar(50) DEFAULT NULL COMMENT '坐席工号',
  `USERNAME` varchar(50) DEFAULT NULL COMMENT '坐席用户名（登录名）',
  `AGENTNO` varchar(50) DEFAULT NULL COMMENT '分机号（坐席登录的分机号码）',
  `NAME` varchar(50) DEFAULT NULL COMMENT '坐席姓名',
  `CODE` varchar(50) DEFAULT NULL COMMENT '坐席状态code（对应字典表里的CODE）',
  `STATUS` varchar(50) DEFAULT NULL COMMENT '坐席当前状',
  `BUSY` tinyint(4) DEFAULT '0' COMMENT '坐席是否忙',
  `WORKSTATUS` varchar(50) DEFAULT NULL COMMENT '坐席工作状态',
  `ORGI` varchar(50) DEFAULT NULL COMMENT '租户ID',
  `AGENTSERVICEID` varchar(50) DEFAULT NULL COMMENT '会话ID',
  `SKILL` varchar(50) DEFAULT NULL COMMENT '接入的技能组ID',
  `SKILLNAME` varchar(50) DEFAULT NULL COMMENT '接入的技能组名称',
  `CREATETIME` datetime DEFAULT NULL COMMENT '记录创建时间',
  `ANI` varchar(50) DEFAULT NULL COMMENT '主叫号码',
  `CALLED` varchar(50) DEFAULT NULL COMMENT '被叫号码',
  `SOURCE` varchar(50) DEFAULT NULL COMMENT '来源',
  `SERVICEID` varchar(32) DEFAULT NULL COMMENT '服务记录ID',
  `SERVICESTATUS` varchar(50) DEFAULT NULL COMMENT '当前呼叫状态',
  `DISCALLER` varchar(50) DEFAULT NULL COMMENT '主叫分机号',
  `DISCALLED` varchar(50) DEFAULT NULL COMMENT '被叫分机号',
  `ORGAN` varchar(50) DEFAULT NULL COMMENT '所属组织机构ID',
  `BEGINTIME` datetime DEFAULT NULL COMMENT '状态开始时间',
  `ENDTIME` datetime DEFAULT NULL COMMENT '状态结束时间',
  `FIRSTSTATUS` tinyint(4) DEFAULT '0' COMMENT '当天首次时间',
  `DATESTR` varchar(20) DEFAULT NULL COMMENT '日期字符串',
  `DURATION` int(11) DEFAULT NULL COMMENT '通话时长',
  `IPADDR` varchar(100) DEFAULT NULL COMMENT '通话时长',
  `HOSTNAME` varchar(100) DEFAULT NULL COMMENT '通话时长',
  `ADMIN` tinyint(4) DEFAULT '0',
  `firsttime` tinyint(4) DEFAULT '0' COMMENT '是否首次就绪',
  `firsttimes` int(11) DEFAULT '0' COMMENT '首次就绪时长',
  `CLIENTID` varchar(100) DEFAULT NULL COMMENT '客户端ID',
  `SESSIONID` varchar(50) DEFAULT NULL COMMENT '会话ID',
  `WORKTYPE` varchar(32) DEFAULT NULL COMMENT '业务类型',
  PRIMARY KEY (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='坐席状态表';


-- ----------------------------
-- Table structure for uk_workorder_type
-- ----------------------------
DROP TABLE IF EXISTS `uk_workorder_type`;
CREATE TABLE `uk_workorder_type` (
  `ID` varchar(32) NOT NULL COMMENT '主键ID',
  `NAME` varchar(50) DEFAULT NULL COMMENT '名称',
  `CODE` varchar(50) DEFAULT NULL COMMENT '代码',
  `CREATETIME` datetime DEFAULT NULL COMMENT '创建时间',
  `CREATER` varchar(32) DEFAULT NULL COMMENT '创建人',
  `UPDATETIME` datetime DEFAULT NULL COMMENT '更新时间',
  `ORGI` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `USERNAME` varchar(50) DEFAULT NULL COMMENT '用户名',
  `BPM` tinyint(4) DEFAULT NULL COMMENT '启用流程',
  `PROCESSID` varchar(32) DEFAULT NULL COMMENT '流程ID',
  `SLA` tinyint(4) DEFAULT NULL COMMENT '请SLA',
  `SLAID` varchar(32) DEFAULT NULL COMMENT 'SLA指标ID',
  `PARENTID` varchar(32) DEFAULT NULL COMMENT '上级分类ID',
  PRIMARY KEY (`ID`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='工单类型表';

-- ----------------------------
-- Table structure for uk_workorders
-- ----------------------------
DROP TABLE IF EXISTS `uk_workorders`;
CREATE TABLE `uk_workorders` (
  `ID` varchar(32) NOT NULL COMMENT 'ID',
  `NAME` varchar(50) DEFAULT NULL COMMENT '名称',
  `CODE` varchar(50) DEFAULT NULL COMMENT '代码',
  `CREATETIME` datetime DEFAULT NULL COMMENT '创建时间',
  `CREATER` varchar(32) DEFAULT NULL COMMENT '创建人',
  `UPDATETIME` datetime DEFAULT NULL COMMENT '更新时间',
  `ORGI` varchar(32) DEFAULT NULL COMMENT 'ORGI',
  `USERNAME` varchar(50) DEFAULT NULL COMMENT '创建人用户名',
  `PARENT` varchar(32) DEFAULT NULL COMMENT 'PARENT',
  `ORDERNO` int(11) DEFAULT NULL COMMENT '工单编号',
  `SESSIONID` varchar(32) DEFAULT NULL COMMENT '会话ID',
  `TITLE` varchar(255) DEFAULT NULL COMMENT '标题',
  `CONTENT` text COMMENT '内容',
  `PRICE` int(11) DEFAULT NULL COMMENT 'PRICE',
  `KEYWORD` varchar(255) DEFAULT NULL COMMENT '关键词',
  `SUMMARY` varchar(255) DEFAULT NULL COMMENT '摘要',
  `ANONYMOUS` tinyint(4) DEFAULT NULL COMMENT '允许匿名访问',
  `TOP` tinyint(4) DEFAULT NULL COMMENT '置顶',
  `ESSENCE` tinyint(4) DEFAULT NULL COMMENT '精华',
  `ACCEPT` tinyint(4) DEFAULT NULL COMMENT '已采纳答案',
  `FINISH` tinyint(4) DEFAULT NULL COMMENT '已结束',
  `ANSWERS` int(11) DEFAULT NULL COMMENT '回复数量',
  `sviews` int(11) DEFAULT NULL COMMENT '查看次数',
  `FOLLOWERS` int(11) DEFAULT NULL COMMENT '关注数',
  `COLLECTIONS` int(11) DEFAULT NULL COMMENT '收藏数',
  `COMMENTS` int(11) DEFAULT NULL COMMENT '评论数',
  `MOBILE` tinyint(4) DEFAULT NULL COMMENT '移动端',
  `STATUS` varchar(32) DEFAULT NULL COMMENT '状态',
  `WOTYPE` varchar(32) DEFAULT NULL COMMENT '工单类型',
  `DATASTATUS` tinyint(4) DEFAULT NULL COMMENT '数据状态',
  `CATE` varchar(32) DEFAULT NULL COMMENT '类型',
  `PRIORITY` varchar(32) DEFAULT NULL COMMENT '优先级',
  `CONTACTS` varchar(32) DEFAULT NULL COMMENT '联系人',
  `CUSID` varchar(32) DEFAULT NULL COMMENT '联系人ID',
  `INITIATOR` text COMMENT '发起人',
  `BPMID` varchar(32) DEFAULT NULL COMMENT '流程ID',
  `TAGS` varchar(255) DEFAULT NULL COMMENT '标签',
  `ACCDEPT` varchar(32) DEFAULT NULL COMMENT '受理部门',
  `ACCUSER` varchar(32) DEFAULT NULL COMMENT '受理人',
  `ASSIGNED` tinyint(4) DEFAULT NULL COMMENT '已受理',
  `ORGAN` varchar(32) DEFAULT NULL COMMENT '部门',
  `AGENT` varchar(32) DEFAULT NULL COMMENT '坐席',
  `SHARES` text COMMENT '共享',
  `SKILL` varchar(32) DEFAULT NULL COMMENT '技能组',
  `ROWCOUNT` int(11) DEFAULT NULL COMMENT '行数',
  `KEY` varchar(32) DEFAULT NULL COMMENT '关键词',
  `MEMO` varchar(100) DEFAULT NULL COMMENT '备注',
  `frommobile` tinyint(4) DEFAULT '0',
  `dataid` varchar(50) DEFAULT NULL COMMENT '业务数据ID',
  `eventid` varchar(50) DEFAULT NULL COMMENT '通话ID',
  `ani` varchar(50) DEFAULT NULL COMMENT '主叫号码',
  PRIMARY KEY (`ID`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='工单表';

-- ----------------------------
-- Table structure for uk_worktime
-- ----------------------------
DROP TABLE IF EXISTS `uk_worktime`;
CREATE TABLE `uk_worktime` (
  `id` varchar(32) NOT NULL COMMENT '主键ID',
  `creater` varchar(32) DEFAULT NULL COMMENT '创建人',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `updatetime` datetime DEFAULT NULL COMMENT '更新时间',
  `name` varchar(100) DEFAULT NULL COMMENT '名称',
  `orgi` varchar(100) DEFAULT NULL COMMENT '租户ID',
  `hostid` varchar(32) DEFAULT NULL COMMENT 'PBX主机ID',
  `type` varchar(32) DEFAULT NULL COMMENT '类型',
  `day` varchar(0) DEFAULT NULL COMMENT '日期',
  `begintime` varchar(20) DEFAULT NULL COMMENT '开始时间',
  `endtime` varchar(20) DEFAULT NULL COMMENT '结束时间',
  `timetype` varchar(10) DEFAULT NULL COMMENT '时间类型',
  `wfrom` int(11) DEFAULT NULL COMMENT '周开始',
  `wto` int(11) DEFAULT NULL COMMENT '周结束',
  `dfrom` int(11) DEFAULT NULL COMMENT '日期开始',
  `dto` int(11) DEFAULT NULL COMMENT '日期结束',
  `wbegintime` varchar(20) DEFAULT NULL COMMENT '周开始时间',
  `wendtime` varchar(20) DEFAULT NULL COMMENT '周结束时间',
  `dbegintime` varchar(20) DEFAULT NULL COMMENT '日期开始时间',
  `dendtime` varchar(20) DEFAULT NULL COMMENT '日期结束时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='工作时间';

-- ----------------------------
-- Table structure for uk_wxmpevent
-- ----------------------------
DROP TABLE IF EXISTS `uk_wxmpevent`;
CREATE TABLE `uk_wxmpevent` (
  `id` varchar(32) NOT NULL DEFAULT '' COMMENT '主键ID',
  `fromuser` varchar(32) DEFAULT NULL COMMENT '来源用户',
  `username` varchar(32) DEFAULT NULL COMMENT '用户名',
  `creater` varchar(32) DEFAULT NULL COMMENT '创建人',
  `orgi` varchar(50) DEFAULT NULL COMMENT '租户ID',
  `country` varchar(50) DEFAULT NULL COMMENT '国家',
  `city` varchar(32) DEFAULT NULL COMMENT '城市',
  `province` varchar(32) DEFAULT NULL COMMENT '省份',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `updatetime` datetime DEFAULT NULL COMMENT '更新时间',
  `event` varchar(255) DEFAULT NULL COMMENT '事件',
  `channel` varchar(255) DEFAULT NULL COMMENT '渠道',
  `model` varchar(10) DEFAULT NULL COMMENT '组件',
  `appid` varchar(32) DEFAULT NULL COMMENT 'SNSID',
  `snsid` varchar(32) DEFAULT NULL COMMENT 'SNSID'
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='微信事件记录';

-- ----------------------------
-- Table structure for cs_chatbot_config
-- ----------------------------
DROP TABLE IF EXISTS `cs_chatbot_config`;
CREATE TABLE `cs_chatbot_config` (
  `id` varchar(32) NOT NULL COMMENT '主键ID',
  `orgi` varchar(32) DEFAULT NULL COMMENT '租户ID',
  `creater` varchar(32) DEFAULT NULL COMMENT '创建人',
  `username` varchar(32) DEFAULT NULL COMMENT '创建人用户名',
  `name` varchar(32) DEFAULT NULL COMMENT '名称',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `enableask` tinyint(4) DEFAULT NULL COMMENT '允许AI主动发起问答',
  `askfirst` tinyint(4) DEFAULT NULL COMMENT 'AI优先',
  `enablescene` tinyint(4) DEFAULT NULL COMMENT '启用场景识别',
  `scenefirst` tinyint(4) DEFAULT NULL COMMENT '优先命中场景',
  `enablekeyword` tinyint(4) DEFAULT NULL COMMENT '启用关键词命中',
  `keywordnum` int(11) DEFAULT NULL COMMENT '关键词数量',
  `noresultmsg` text COMMENT '未命中回复消息',
  `askqs` tinyint(4) DEFAULT NULL COMMENT '询问访客是否解决问题',
  `asktipmsg` varchar(255) DEFAULT NULL COMMENT '询问访客的文本',
  `resolved` varchar(100) DEFAULT NULL COMMENT '已解决的提示文本',
  `unresolved` varchar(100) DEFAULT NULL COMMENT '未解决的提示文本',
  `redirectagent` tinyint(4) DEFAULT NULL COMMENT '跳转到人工坐席',
  `redirecturl` varchar(255) DEFAULT NULL COMMENT '跳转到其他URL',
  `asktimes` int(11) DEFAULT NULL COMMENT '最长多久开始询问',
  `selectskill` int(11) DEFAULT NULL COMMENT '技能组',
  `selectskillmsg` varchar(255) DEFAULT NULL COMMENT '技能组消息',
  `aiid` varchar(32) DEFAULT NULL COMMENT '机器人ID',
  `welcomemsg` text COMMENT '机器人欢迎语',
  `waitmsg` text COMMENT '机器人等待提示语',
  `enableother` tinyint(4) DEFAULT '0' COMMENT '启用外部机器人',
  `otherfirst` tinyint(4) DEFAULT '0' COMMENT '外部机器人优先',
  `otherurl` varchar(255) DEFAULT NULL COMMENT '外部机器人URL',
  `otherlogin` tinyint(4) DEFAULT '0' COMMENT '外部机器人是否需要登录',
  `otherappkey` varchar(255) DEFAULT NULL COMMENT '外部机器人APPKey',
  `otherappsec` varchar(255) DEFAULT NULL COMMENT '外部机器人APPSec',
  `otherparam` text COMMENT '外部机器人参数',
  `othertempletinput` varchar(32) DEFAULT NULL COMMENT '外部机器人提交参数模板',
  `othertempletoutput` varchar(32) DEFAULT NULL COMMENT '外部机器人回复参数解析模板',
  `othermethod` varchar(20) DEFAULT NULL COMMENT '外部机器人提交方式',
  `otherssl` tinyint(4) DEFAULT '0' COMMENT '外部机器人启用SSL',
  `enablesuggest` tinyint(4) DEFAULT '0' COMMENT '启用推荐功能',
  `suggestmsg` text COMMENT '推荐的提示信息',
  `oqrdetailurl` varchar(255) DEFAULT NULL COMMENT '外部机器人内容URL',
  `oqrdetailinput` varchar(32) DEFAULT NULL COMMENT '外部机器人详情输入参数',
  `oqrdetailoutput` varchar(32) DEFAULT NULL COMMENT '外部机器人详情输出参数',
  `othersuggestmsg` text COMMENT '命中结果的推荐的提示信息',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=COMPACT COMMENT='机器人配置';

SET FOREIGN_KEY_CHECKS = 1;
